;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P386
LOCALS
JUMPS

code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gve32.inc
include gomez.inc
include svga.inc
include gdraw.inc
include keys.inc


;
;
;
;   GOMEZ VECTOR ENGINE                                            3D-Viewer
;
;
;

extrn GVE_Cosinus_Table:dword

World_Ptr	dd	?
Camera_Ptr	dd	?
Palette_Ptr	dd	?
Mesh_Ptr	dd	?
Counter		dd	?

STXT		db	"Gomez Vector Engine                                 (C) 1996 by Marc van Shaney",10,13,'$'
ETXT0		db	"Usage: 3DMESH.EXE [/switches]",10,13
		db	"       With the follwing switches:",10,13
		db	"	  /NoVESA       - Lock out VESA Modes",10,13
		db	"	  /NoVGA        - Lock out VGA Modes",10,13
		db	"	  /NoTweak      - Lock out Tweak Modes",10,13
		db	"	  /NoLinBuf     - Don't use linear frame buffer",10,13
		db	"	  /NoVESAPM     - Don't use VESA proteceted mode interface",10,13
		db	"	  /NoVBE2	- Ignore VESA 2.0 extensions",10,13
		db	"	  /NoPages  	- Don't use VESA multipage support",10,13
		db	"	  /BIOSPal	- Use BIOS functions to set palette",10,13
		db	"	  /WaitRetrace  - Wait for vertical retrace before setting palette",10,13
		db	"	  /VMode=xxx	- Force to use this VESA-mode (hex)",10,13
		db	'$'
ETXT2		db	"Error: Could not initialize vector engine . . .",10,13,'$'
FNAM		db	"mesh.gve",0

;
;   GOMEZ VECTOR ENGINE                                         Main routine
;
PUBLIC C main
main PROC NEAR
	mov	es,cs:[DATA32_Selector]
	mov	esi,OFFSET STXT
	call	Print32

	;
	mov	ecx,1024
	call	Malloc
	jc	@@InitError
	mov	ds:[Palette_Ptr],eax
	mov	edi,eax
	xor	eax,eax
	mov	ecx,256
@@L5:	stosd
	add	eax,01010101h
	dec	ecx
	jnz	short @@L5
	;
	mov	eax,SVGA_8bit_Modes+SVGA_15bit_Modes+SVGA_16bit_Modes
	call	SVGA_Scan_Modes
	call	SVGA_Select_Mode
	jc	@@Ende
	mov	edi,eax			;EDI = mode-number
	;
	mov	eax,ds:[ecx]			;EAX = Display-Width
	mov	ebx,ds:[ecx+4]			;EBX = Display-Height
	mov	ecx,ds:[ecx+8]			;ECX = Display-Depth
	call	Init_GVE
	jc	@@InitError

	call	GVE_Alloc_World
	mov	ds:[World_Ptr],eax		;Save returned ptr !
	jc	@@InitError

	mov	eax,ds:[World_Ptr]
	call	GVE_Alloc_Light
	jc	@@InitError

	mov	eax,ds:[World_Ptr]
	call	GVE_Alloc_Camera
	mov	ds:[Camera_Ptr],eax
	jc 	@@InitError

	mov	eax,ds:[World_Ptr]
	mov	ebx,40
	mov	ecx,40
	mov	edx,1 shl GVE_MATH_SHIFT
	call	GVE_Alloc_Mesh
	mov	ds:[Mesh_Ptr],eax
	jc	@@InitError

	mov	edx,eax
	mov	eax,ds:[World_Ptr]
	mov	bl,VOBJ_GOURAUD_POLY
	mov	cl,16
	mov	ch,GVE_CHANGE_SHADING or GVE_CHANGE_COLOUR
	call	GVE_Change_Object
	jc 	@@InitError

	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Mesh_Ptr]
	call	GVE_Init_Mesh
	jc 	@@InitError

	mov	eax,ds:[World_Ptr]
	call	GVE_Init_Shading_LUT
	jc	@@InitError

	mov	eax,ds:[World_Ptr]
	call	GVE_Init_World			;Initialize world
	jc  	@@InitError
	;
	mov	eax,edi
	call	Init_SVGA
	jc	@@NoVESA

	mov	eax,ds:[SVGA_Display_Width]
	mov	ebx,ds:[SVGA_Display_Height]
	mov	ecx,ds:[SVGA_Display_Depth]
	call	Init_GDraw
	jc	@@InitError

	mov	esi,ds:[World_Ptr]              ;ESI = World ptr
	mov	eax,ds:[esi+World_Palette]	;ESI = ptr to palette
	xor	ebx,ebx
	mov	ecx,256
	call	SVGA_Set_Palette

	mov	esi,ds:[World_Ptr]              ;ESI = World ptr
	mov	eax,ds:[esi+World_Palette]	;ESI = ptr to palette
	call	GDraw_Set_Frame_Palette

	mov	eax,ds:[Palette_Ptr]
	call	GDraw_Set_System_Palette
	;
@@L1:	mov	eax,ds:[Mesh_Ptr]
	mov	ebx,ds:[eax+Object_Mesh_Width]
	mov	ecx,ds:[eax+Object_Mesh_Height]
	mov	esi,ds:[eax+Object_Vertex_List]
	add	esi,4

@@L2:	push	ebx
	@@L3:   mov	eax,ecx
		mov	edx,ebx
		sub	eax,20
		sub	edx,20
		imul	eax,eax
		imul	edx,edx
		add	eax,edx			;EAX = x+y
		lea	edx,[eax-800]
		imul	eax,3
		add	eax,ds:[Counter]
		and 	eax,GVE_COSINE_SIZE-1
		mov 	eax,ds:[GVE_Cosinus_Table+4*eax]
		imul	eax,edx
		sar 	eax,GVE_MATRIX_SHIFT-GVE_MATH_SHIFT+6
		mov	ds:[esi+VertexZ],eax
		add	esi,GVE_VERTEX_SIZE
		dec	ebx
		jnz	short @@L3
	pop	ebx
	dec	ecx
	jnz	short @@L2

	add	ds:[Counter],29
	;
	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Mesh_Ptr]
	call	GVE_Init_Mesh

	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Camera_Ptr]
	call	GVE_Move_Camera			;Move camera !
	mov	eax,ds:[World_Ptr]
	mov	ebx,ds:[Camera_Ptr]
	mov	ecx,ds:[SVGA_Old_Frame_Buffer]
	mov	edx,ds:[SVGA_Frame_Buffer]	;EDX = Frame buffer
	call	GVE_Draw_World			;Draw world !

	mov	ebx,ds:[Camera_Ptr]		;EBX = Viewport
	add	dword ptr ds:[ebx+Camera_RotationX],4
	sub	dword ptr ds:[ebx+Camera_RotationY],3
	add	dword ptr ds:[ebx+Camera_RotationZ],5

	call	Profiler
	call	SVGA_Switch_Frame
	;
	GETKEY32
	test	ax,ax				;No key => Loop !
	jz	@@L1
	mov	ebx,ds:[Camera_Ptr]		;EBX = ViewPort
	mov	ecx,ds:[World_Ptr]		;ECX = World_Header
	cmp	ax,'+'
@@K0:	jne	short @@K1
		add 	dword ptr ds:[ebx+Camera_PositionZ],20 shl GVE_MATH_SHIFT
		jmp 	@@L1
@@K1:	cmp	ax,'-'
	jne	short @@K6
		sub 	dword ptr ds:[ebx+Camera_PositionZ],20 shl GVE_MATH_SHIFT
		jmp 	@@L1
@@K6:	cmp	ax,F9_Key
	jne	short @@K7
		xor	ds:[ecx+World_Flags],GVE_FLAG_SOFTEN_HORIZONTAL
		jmp	@@L1
@@K7:	cmp	ax,F10_Key
	jne	short @@K8
		xor	ds:[ecx+World_Flags],GVE_FLAG_SOFTEN_VERTICAL
		jmp	@@L1
@@K8:	cmp	ax,F1_Key
	jne	short @@K9
		xor	ds:[ecx+World_Flags],GVE_FLAG_MOTION_BLURR
		jmp	@@L1
@@K9:	cmp	ax,F2_Key
	jne	short @@KA
		xor	ds:[ecx+World_Flags],GVE_FLAG_MOTION_TRACE
		jmp	@@L1
@@KA:	cmp	ax,F3_Key
	jne	short @@KB
		xor	ds:[ecx+World_Flags],GVE_FLAG_FEED_BACK
		jmp	@@L1
@@KB:	cmp	ax,F4_Key
	jne	short @@KEnd
		xor	ds:[ecx+World_Flags],GVE_FLAG_CLEAR_FRAME
		jmp	@@L1

@@KEnd:	cmp 	ax,Escape
	je	short @@Ende
	jmp	@@L1
	;
@@Ende:	mov	eax,ds:[World_Ptr]
	call	GVE_Free_World                  ;Release memory
	call	Exit_GDraw
	call	Exit_SVGA
	call	Exit_GVE			;Bye-bye !
@@NoVESA:
	jmp	Exit_PMODE32			;Thats all folks !

@@InitError:					;An error occured
	mov	esi,OFFSET ETXT2		;Display error-text
	call	Print32
	jmp	Exit_PMODE32

@@NoFile:
	mov	esi,OFFSET ETXT0		;Display error-text
	call	Print32
	jmp	Exit_PMODE32
main ENDP



;
;   GOMEZ VECTOR ENGINE                                           Profiler
;
Text_Buffer		db	16 dup (?)


Profiler PROC NEAR
	ifdef GVE_PROFILER
	push	esi
	push	edi

	mov	esi,ds:[SVGA_Display_Width]
	shr	esi,5				;ESI = WIdth/32
	mov	edi,ds:[SVGA_Display_Height]
	shr	edi,5				;EDI = Height/32

	mov	edx,ds:[GVE_Frame_Speed]
	shr	edx,8
	call	Long2Text

	mov	eax,ds:[SVGA_Frame_Buffer]
	mov	ebx,edi
	shl	ebx,16
	mov	bx,si
	add	ebx,20010h
	mov	ecx,OFFSET Text_Buffer
	mov	edx,200
	call	GDraw_Text

@@End:  pop	edi
	pop	esi
	endif
	retn
Profiler ENDP




;
;Long2Text:
;  Input:
;	EDX	- Number to convert
;	EDI	- ptr to string
;  Output:
;	EDI	- ptr to terminating 0
;  Destroys:
;	EAX,EBBX,ECX,EDX
;
Long2Text PROC NEAR
	push	edi
	mov	edi,OFFSET Text_Buffer
	test 	edx,edx
	jnz 	@@NotZ
	mov	ax,'0'
	stosw
	pop	edi
	retn

@@NotZ:	test 	edx,edx
	jns 	short @@NoS
	mov 	byte ptr ds:[edi],'-'
	inc 	edi
	neg 	edx

@@NoS:  push	ebp
	mov	ebp,edi
	mov 	ebx,edx
	mov 	ecx,10000000
@@1:    xor 	edx,edx
	mov 	eax,ebx
	div 	ecx
	test 	al,al
	jnz 	short @@4
	cmp 	edi,ebp
	je 	short @@2
@@4:	add 	al,'0'
	stosb
@@2:	mov 	ebx,edx
	xor 	edx,edx
	mov 	eax,ecx
	mov 	ecx,10
	div 	ecx
	test 	eax,eax
	jz 	short @@3
	mov 	ecx,eax
	jmp 	short @@1

@@3:	mov 	byte ptr ds:[edi],0
	pop	ebp
	pop	edi
	retn
Long2Text ENDP

code32 ends
END
