;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P386
LOCALS
JUMPS

code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gve32.inc
include gomez.inc
include svga.inc
include keys.inc
include gvemacro.inc


;
;
;
;   GOMEZ VECTOR ENGINE                                            3D-Viewer
;
;
;

World_Ptr	dd	?
Camera_Ptr	dd	?
Palette_Ptr	dd	?
Mesh_Ptr	dd	?
Video_Ptr	dd	?
Texture_Ptr	dd	?

STXT		db	"Gomez Vector Engine                                 (C) 1996 by Marc van Shaney",10,13,'$'
ETXT0		db	"Usage: 3DVIDEO.EXE [videofile.VID] [/switches]",10,13
		db	"       With the follwing switches:",10,13
		db	"	  /NoVESA       - Lock out VESA Modes",10,13
		db	"	  /NoVGA        - Lock out VGA Modes",10,13
		db	"	  /NoTweak      - Lock out Tweak Modes",10,13
		db	"	  /NoLinBuf     - Don't use linear frame buffer",10,13
		db	"	  /NoVESAPM     - Don't use VESA proteceted mode interface",10,13
		db	"	  /NoVBE2	- Ignore VESA 2.0 extensions",10,13
		db	"	  /NoPages  	- Don't use VESA multipage support",10,13
		db	"	  /BIOSPal	- Use BIOS functions to set palette",10,13
		db	"	  /WaitRetrace  - Wait for vertical retrace before setting palette",10,13
		db	"	  /VMode=xxx	- Force to use this VESA-mode (hex)",10,13
		db	'$'
TILDE		db	"~",0
ETXT2		db	"Error: Could not initialize vector engine . . .",10,13,'$'


;
;   GOMEZ VECTOR ENGINE                                         Main routine
;
PUBLIC C main
main PROC NEAR
	mov	es,cs:[DATA32_Selector]
	mov	esi,OFFSET STXT
	call	Print32

	mov	eax,OFFSET Tilde
	call	Scan_Argument
	jc	@@NoFile
	;
	mov	ecx,1024
	call	Malloc
	jc	@@InitError
	mov	ds:[Palette_Ptr],eax
	mov	edi,eax
	xor	eax,eax
	mov	ecx,256
@@L2:	stosd
	add	eax,01010101h
	dec	ecx
	jnz	short @@L2
	;
	mov	eax,SVGA_8bit_Modes	;+SVGA_15bit_Modes+SVGA_16bit_Modes
	call	SVGA_Scan_Modes
	call	SVGA_Select_Mode
	jc	@@Ende
	mov	edi,eax			;EDI = mode-number
	;
	mov	eax,ds:[ecx]			;EAX = Display-Width
	mov	ebx,ds:[ecx+4]			;EBX = Display-Height
	mov	ecx,ds:[ecx+8]			;ECX = Display-Depth
	call	Init_GVE
	jc	@@InitError
	;
	mov	eax,OFFSET VideoBox
	call	GVE_Build_World
	jc	@@InitError
	mov	ds:[World_Ptr],eax
	mov	ebx,ds:[eax+World_Object_List]
	mov	ecx,ds:[eax+World_Camera_List]
	mov	ebx,ds:[ebx+4]
	mov	ecx,ds:[ecx+4]
	mov	ds:[Mesh_Ptr],ebx
	mov	ds:[Camera_Ptr],ecx

	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Mesh_Ptr]
	call	GVE_Init_Normals
	jc 	@@InitError
	;
	mov	eax,OFFSET Tilde
	call	Scan_Argument
	mov	ebx,eax
	mov	eax,ds:[World_Ptr]
	xor	edx,edx
	call	GVE_Import_Video
	mov	ds:[Video_Ptr],eax
	mov	ds:[Texture_Ptr],edx
	jc	@@InitError

	push	edi
	mov	edx,ds:[World_Ptr]
	mov	esi,ds:[eax+Video_Current_Palette]
	mov	edi,ds:[edx+World_Palette]
	mov	ecx,GVE_PALETTE_SIZE/4
	rep	movsd
	and	ds:[eax+Video_Flags],NOT GVE_VID_REMAP
	pop	edi

	mov	eax,ds:[World_Ptr]
	call	GVE_Init_World			;Initialize world
	jc  	@@InitError
	;
	mov	eax,edi
	call	Init_SVGA
	jc	@@NoVESA

	mov	esi,ds:[World_Ptr]              ;ESI = World ptr
	mov	eax,ds:[esi+World_Palette]	;ESI = ptr to palette
	xor	ebx,ebx
	mov	ecx,256
	call	SVGA_Set_Palette
	;
@@L1:   mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Video_Ptr]
	call	GVE_Video_Next_Frame

	mov	esi,ds:[Texture_Ptr]
	mov	edi,ds:[SVGA_Frame_Buffer]
	call	Rescale_Frame

	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Camera_Ptr]
	call	GVE_Move_Camera			;Move camera !
	call	GVE_Transform_World		;Transform world !
	mov	eax,ds:[World_Ptr]
	mov	ebx,ds:[Camera_Ptr]
	mov	ecx,ds:[SVGA_Old_Frame_Buffer]
	mov	edx,ds:[SVGA_Frame_Buffer]	;EDX = Frame buffer
	call	GVE_Draw_World			;Draw world !

	mov	ebx,ds:[Camera_Ptr]		;EBX = Viewport
	add	dword ptr ds:[ebx+Camera_RotationX],4
	sub	dword ptr ds:[ebx+Camera_RotationY],3
	add	dword ptr ds:[ebx+Camera_RotationZ],5

	call	SVGA_Switch_Frame
	;
	GETKEY32
	test	ax,ax				;No key => Loop !
	jz	@@L1
	mov	ebx,ds:[Camera_Ptr]		;EBX = ViewPort
	mov	ecx,ds:[World_Ptr]		;ECX = World_Header
	cmp	ax,F1_Key
	jne	short @@K7
		xor	ds:[ecx+World_Flags],GVE_FLAG_SOFTEN_HORIZONTAL
		jmp	@@L1
@@K7:	cmp	ax,F2_Key
	jne	short @@K8
		xor	ds:[ecx+World_Flags],GVE_FLAG_SOFTEN_VERTICAL
		jmp	@@L1
@@K8:	cmp	ax,F3_Key
	jne	short @@KEnd
		xor	ds:[ecx+World_Flags],GVE_FLAG_MOTION_BLURR
		jmp	@@L1

@@KEnd:	cmp 	ax,Escape
	je	short @@Ende
	jmp	@@L1
	;
@@Ende:	mov	eax,ds:[World_Ptr]
	call	GVE_Free_World                  ;Release memory
	call	Exit_SVGA
	call	Exit_GVE			;Bye-bye !
@@NoVESA:
	jmp	Exit_PMODE32			;Thats all folks !

@@InitError:					;An error occured
	mov	esi,OFFSET ETXT2		;Display error-text
	call	Print32
	jmp	Exit_PMODE32

@@NoFile:
	mov	esi,OFFSET ETXT0		;Display error-text
	call	Print32
	jmp	Exit_PMODE32
main ENDP

;
;
; Rescale_Frame:
;  Input:
;	ESI	- ptr to video-buffer
;	EDI	- ptr to texture-buffer
;  Output:
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Rescale_Frame PROC NEAR
	push	esi
	push	edi

	mov	ebx,ds:[SVGA_Display_Width]
	mov	ecx,ds:[SVGA_Display_Height]
	mov	ds:[@@dst_x],ebx		;EBX = dest. width
	mov	ds:[@@dst_y],ecx
	movzx	eax,ds:[esi+Bitmap_Width]      	;EAX = source width
	mov	d ds:[@@C5-4],eax		; ...save it in code
	xor	edx,edx
	shl	eax,16
	idiv	ebx				;EAX = src_width / dst_width
	xor	edx,edx
	shld	edx,eax,16                      ;EDX = integer part
	mov	d ds:[@@C2-4],edx		; ...save it
	shl	eax,16				;EAX = fractional part
	mov	d ds:[@@C1-4],eax		; ...save it

	movzx	eax,ds:[esi+Bitmap_Height]	;EAX = source height
	xor	edx,edx
	shl	eax,16
	idiv	ecx				;EAX = src_height / dst_height
	mov	edx,eax
	shl	edx,16				;EDX = fractional part
	mov	d ds:[@@C4-4],edx		; ...and save it
	shr	eax,16				;EAX = integer part
	imul	d ds:[@@C5-4]			;EAX *= source_width
	mov	d ds:[@@C3-4],eax		; ...and save it
	add	esi,GVE_BITMAP_SIZE

	;
	;
	;Note the register allocation:
	;	ESI	- src
	;	EDI	- dst
	;	EBX	- X-counter
	;	ECX	- X-fraction
	;	EDX	- Y-fraction
	;And the @@C things:
	;	@@C1-4	- Fraction_X increment
	;	@@C2-4	- StdAddX
	;	@@C3-4	- StdAddY*Source_Width
	;	@@C4-4	- Fraction_Y increment
	;	@@C5-4	- Source_Width
	;
	xor	ecx,ecx				;Clear fraction
	xor	eax,eax
@@L1:   push	esi
	mov	ebx,ds:[@@dst_x]
	xor	edx,edx				;Clear fraction
	add	edi,ebx
	neg	ebx
	@@L2:	mov	al,ds:[esi]		;Get pixel
		add	edx,12345678h  		;Add fraction
	@@C1:   adc	esi,12345678h		;Add integer with carry
	@@C2:	mov	ds:[edi+ebx],al
		inc	ebx
		jnz	short @@L2           	;Loop !
	pop	esi
	add	esi,12345678h
@@C3:	add	ecx,12345678h
@@C4:	jnc	short @@C5
		add 	esi,12345678h
@@C5:	dec	ds:[@@dst_y]
	jnz	short @@L1
	;

@@Err:	pop	edi
	pop	esi
	retn

		ALIGN	DWORD
@@dst_y		dd	?
@@dst_x		dd	?
Rescale_Frame ENDP


;
;   GOMEZ VECTOR ENGINE                                           SMall world
;

CREATE_WORLD VideoBox
 SET_SHADING 	VOBJ_FAST_TEXTURE
 SET_COLOUR     16
 SET_FLAGS	GVE_FLAG_NOSORT
 SET_TEXTURE	0

 CREATE_OBJECT "VideoBox"
  SET_FLAGS	GVE_OBJ_BACK_CULLING
  CREATE_VERTEX_LIST
   ADD_VERTEX	-30,-30,-30,0,0
   ADD_VERTEX	-30,  0,-30,8000h,0
   ADD_VERTEX	-30,+30,-30,10000h,0
   ADD_VERTEX	  0,+30,-30,10000h,8000h
   ADD_VERTEX	+30,+30,-30,10000h,10000h
   ADD_VERTEX	+30,  0,-30,8000h,10000h
   ADD_VERTEX	+30,-30,-30,0,10000h
   ADD_VERTEX	  0,-30,-30,0h,8000h
   ADD_VERTEX	  0,  0,-30,8000h,8000h

   ADD_VERTEX	-30,-30,+30,0,0
   ADD_VERTEX	-30,  0,+30,8000h,0
   ADD_VERTEX	-30,+30,+30,10000h,0
   ADD_VERTEX	  0,+30,+30,10000h,8000h
   ADD_VERTEX	+30,+30,+30,10000h,10000h
   ADD_VERTEX	+30,  0,+30,8000h,10000h
   ADD_VERTEX	+30,-30,+30,0,10000h
   ADD_VERTEX	  0,-30,+30,0h,8000h
   ADD_VERTEX	  0,  0,+30,8000h,8000h

   ADD_VERTEX	+30,-30,-30,0,0
   ADD_VERTEX	+30,-30,  0,8000h,0
   ADD_VERTEX	+30,-30,+30,10000h,0
   ADD_VERTEX	+30,  0,+30,10000h,8000h
   ADD_VERTEX	+30,+30,+30,10000h,10000h
   ADD_VERTEX	+30,+30,  0,8000h,10000h
   ADD_VERTEX	+30,+30,-30,0,10000h
   ADD_VERTEX	+30,  0,-30,0h,8000h
   ADD_VERTEX	+30,  0,  0,8000h,8000h

   ADD_VERTEX	-30,-30,-30,0,0
   ADD_VERTEX	-30,-30,  0,8000h,0
   ADD_VERTEX	-30,-30,+30,10000h,0
   ADD_VERTEX	-30,  0,+30,10000h,8000h
   ADD_VERTEX	-30,+30,+30,10000h,10000h
   ADD_VERTEX	-30,+30,  0,8000h,10000h
   ADD_VERTEX	-30,+30,-30,0,10000h
   ADD_VERTEX	-30,  0,-30,0h,8000h
   ADD_VERTEX	-30,  0,  0,8000h,8000h

   ADD_VERTEX	-30,+30,-30,0,0
   ADD_VERTEX	-30,+30,  0,8000h,0
   ADD_VERTEX	-30,+30,+30,10000h,0
   ADD_VERTEX	  0,+30,+30,10000h,8000h
   ADD_VERTEX	+30,+30,+30,10000h,10000h
   ADD_VERTEX	+30,+30,  0,8000h,10000h
   ADD_VERTEX	+30,+30,-30,0,10000h
   ADD_VERTEX	  0,+30,-30,0h,8000h
   ADD_VERTEX	  0,+30,  0,8000h,8000h

   ADD_VERTEX	-30,-30,-30,0,0
   ADD_VERTEX	-30,-30,  0,8000h,0
   ADD_VERTEX	-30,-30,+30,10000h,0
   ADD_VERTEX	  0,-30,+30,10000h,8000h
   ADD_VERTEX	+30,-30,+30,10000h,10000h
   ADD_VERTEX	+30,-30,  0,8000h,10000h
   ADD_VERTEX	+30,-30,-30,0,10000h
   ADD_VERTEX	  0,-30,-30,0h,8000h
   ADD_VERTEX	  0,-30,  0,8000h,8000h
  FINISH_VERTEX_LIST

  CREATE_FACE_LIST
   ADD_TRIANGLE	0,1,8
   ADD_TRIANGLE 0,8,7
   ADD_TRIANGLE	1,2,3
   ADD_TRIANGLE 1,3,8
   ADD_TRIANGLE 8,3,4
   ADD_TRIANGLE 8,4,5
   ADD_TRIANGLE 7,8,5
   ADD_TRIANGLE 7,5,6

   ADD_TRIANGLE	9,17,10
   ADD_TRIANGLE 9,16,17
   ADD_TRIANGLE	10,12,11
   ADD_TRIANGLE 10,17,12
   ADD_TRIANGLE 17,13,12
   ADD_TRIANGLE 17,14,13
   ADD_TRIANGLE 16,14,17
   ADD_TRIANGLE 16,15,14

   ADD_TRIANGLE	18,26,19
   ADD_TRIANGLE 18,25,26
   ADD_TRIANGLE	19,21,20
   ADD_TRIANGLE 19,26,21
   ADD_TRIANGLE 26,22,21
   ADD_TRIANGLE 26,23,22
   ADD_TRIANGLE 25,23,26
   ADD_TRIANGLE 25,24,23

   ADD_TRIANGLE	27,28,35
   ADD_TRIANGLE 27,35,34
   ADD_TRIANGLE	28,29,30
   ADD_TRIANGLE 28,30,35
   ADD_TRIANGLE 35,30,31
   ADD_TRIANGLE 35,31,32
   ADD_TRIANGLE 34,35,32
   ADD_TRIANGLE 34,32,33

   ADD_TRIANGLE	36,37,44
   ADD_TRIANGLE 36,44,43
   ADD_TRIANGLE	37,38,39
   ADD_TRIANGLE 37,39,44
   ADD_TRIANGLE 44,39,40
   ADD_TRIANGLE 44,40,41
   ADD_TRIANGLE 43,44,41
   ADD_TRIANGLE 43,41,42

   ADD_TRIANGLE	45,53,46
   ADD_TRIANGLE 45,52,53
   ADD_TRIANGLE	46,48,47
   ADD_TRIANGLE 46,53,48
   ADD_TRIANGLE 53,49,48
   ADD_TRIANGLE 53,50,49
   ADD_TRIANGLE 52,50,53
   ADD_TRIANGLE 52,51,50
  FINISH_FACE_LIST
 FINISH_OBJECT

 ADD_CAMERA	0,0,-135,0,0,0
 ADD_LIGHT	0,0,-135,0,0,0
FINISH_WORLD
code32 ends
END
