;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P386
LOCALS
JUMPS

code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gve32.inc
include gomez.inc
include svga.inc
include gdraw.inc
include keys.inc


;
;
;
;   GOMEZ VECTOR ENGINE                                            3D-Viewer
;
;
;

World_Ptr	dd	?
Camera_Ptr	dd	?
Palette_Ptr	dd	?
Local_Flags	dd	0

STXT		db	"Gomez Vector Engine                                 (C) 1996 by Marc van Shaney",10,13,'$'
ETXT0		db	"Usage: 3DVIEW.EXE [vectorfile.GVE] [/switches]",10,13
		db	"       With the follwing switches:",10,13
		db	"	  /NoVESA       - Lock out VESA Modes",10,13
		db	"	  /NoVGA        - Lock out VGA Modes",10,13
		db	"	  /NoTweak      - Lock out Tweak Modes",10,13
		db	"	  /NoLinBuf     - Don't use linear frame buffer",10,13
		db	"	  /NoVESAPM     - Don't use VESA proteceted mode interface",10,13
		db	"	  /NoVBE2	- Ignore VESA 2.0 extensions",10,13
		db	"	  /NoPages  	- Don't use VESA multipage support",10,13
		db	"	  /BIOSPal	- Use BIOS functions to set palette",10,13
		db	"	  /WaitRetrace  - Wait for vertical retrace before setting palette",10,13
		db	"	  /VMode=xxx	- Force to use this VESA-mode (hex)",10,13
		db	"	  /Cinema	- Adds a black border at top and bottom",10,13
		db	'$'
ETXT1		db	"Error: Data file not found . . .",10,13,'$'
ETXT2		db	"Error: Could not initialize vector engine . . .",10,13,'$'
TILDE		db	"~",0
CINEMA		db	"/CINEMA",0

;
;   GOMEZ VECTOR ENGINE                                         Main routine
;
PUBLIC C main
main PROC NEAR
	mov	es,cs:[DATA32_Selector]
	mov	esi,OFFSET STXT
	call	Print32

	mov	eax,OFFSET Tilde
	call	Scan_Argument
	jc	@@NoFile
	mov	esi,eax			;ESI = ptr to file-name

	mov	eax,OFFSET Cinema
	call	Scan_Argument
	jc	@@J1
	or	ds:[Local_Flags],1

@@J1:	;
	;   Init code for  SVGA/GVE/GDRAW
	;
	mov	eax,SVGA_8bit_Modes+SVGA_15bit_Modes+SVGA_16bit_Modes
	call	SVGA_Scan_Modes
	call	SVGA_Select_Mode
	jc	@@Ende
	call	Init_SVGA
	jc	@@NoVESA

	mov	eax,ds:[SVGA_Display_Width]
	mov	ebx,ds:[SVGA_Display_Height]
	mov	ecx,ds:[SVGA_Display_Depth]
	call	Init_GDraw
	jc	@@InitError
	;
	mov	eax,ds:[SVGA_Display_Width]	;EAX = Display-Width
	mov	ebx,ds:[SVGA_Display_Height]	;EBX = Display-Height
	mov	ecx,ds:[SVGA_Display_Depth]	;ECX = Display-Depth
	test	ds:[Local_Flags],1
	jz	short @@J2
	imul	ebx,3
	shr	ebx,2
@@J2:	call	Init_GVE
	jc	@@InitError
	;
	mov	ecx,1024
	call	Malloc
	jc	@@InitError
	mov	ds:[Palette_Ptr],eax
	mov	edi,eax
	xor	eax,eax
	mov	ecx,256
@@L2:	stosd
	add	eax,01010101h
	dec	ecx
	jnz	short @@L2

	mov	eax,ds:[Palette_Ptr]
	call	GDraw_Set_System_Palette
	;
	xor	edx,edx
	mov	eax,ds:[SVGA_Display_Width]	;EAX = Width
	shl	eax,16
	idiv	ds:[SVGA_Display_Height]
	mov	ecx,eax				;ECX = Aspect ratio
	mov	eax,ds:[GVE_Frame_Width]	;EAX = Width
	mov	ebx,ds:[GVE_Frame_Height]	;EBX = Height
	call	GVE_Set_Frame_Size
	jc	@@InitError

	;
	;   Loading of a world
	;
	mov	ebx,esi
	xor	edx,edx				;Start at file offset 0
	call	GVE_Load_World			;Load world
	mov	ds:[World_Ptr],eax		;Save returned ptr !
	jc	@@LoadError			;JC => Error
	call	GVE_Init_World			;Initialize world
	jc	@@LoadError

	mov	esi,ds:[World_Ptr]              ;ESI = World ptr
	mov	eax,ds:[esi+World_Palette]	;ESI = ptr to palette
	xor	ebx,ebx
	mov	ecx,256
	call	SVGA_Set_Palette

	mov	esi,ds:[World_Ptr]              ;ESI = World ptr
	mov	eax,ds:[esi+World_Palette]	;ESI = ptr to palette
	call	GDraw_Set_Frame_Palette

	mov	eax,ds:[World_Ptr]
	mov	eax,ds:[eax+World_Camera_List]
	mov	eax,ds:[eax+4]
	mov	ds:[Camera_Ptr],eax

	;
	;   Timer init code
	;
	ifndef GVE_PROFILER
	 mov	eax,0
	 mov	ebx,OFFSET Timer_Handler
	 call	Set_Flat_IRQ
	 mov	ds:[TIMER_PM_Int],ebx
	 mov	eax,0
;	 call	Link_Real_IRQ
	 mov	ds:[TIMER_RM_Int],ebx

	 cli
	 mov 	al,36h
	 out 	43h,al
	 mov	ebx,GVE_TIMER_SPEED
	 xor 	edx,edx
	 mov 	eax,123333h                    	;Calculate timer constant
	 div 	ebx
	 out 	40h,al
	 sar 	eax,8
	 out 	40h,al
	 sti
	endif

	;
	;   Main loop
	;
@@L1:   mov	eax,ds:[GVE_Timer]
	mov	ebx,ds:[Camera_Ptr]		;EBX = Viewport
	imul	ecx,eax,37
	shr	ecx,10
	mov	dword ptr ds:[ebx+Camera_RotationX],ecx
	imul	ecx,eax,31
	shr	ecx,10
	mov	dword ptr ds:[ebx+Camera_RotationY],ecx
	imul	ecx,eax,29
	shr	ecx,10
	mov	dword ptr ds:[ebx+Camera_RotationZ],ecx

	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Camera_Ptr]
	call	GVE_Move_Camera			;Move camera !
	call	GVE_Transform_World		;Transform world !

	xor	ecx,ecx
	xor	edx,edx
	test	ds:[Local_Flags],1
	jz	short @@J3
	mov	ecx,ds:[SVGA_Display_Height]
	shr	ecx,3
	imul	ecx,ds:[SVGA_Bytes_per_Line]
	mov	edx,ecx
@@J3:	mov	eax,ds:[World_Ptr]
	mov	ebx,ds:[Camera_Ptr]
	add	ecx,ds:[SVGA_Old_Frame_Buffer]
	add	edx,ds:[SVGA_Frame_Buffer]	;EDX = Frame buffer
	call	GVE_Draw_World			;Draw world !

	call	Profiler
	call	SVGA_Switch_Frame
	;
	GETKEY32
	test	ax,ax				;No key => Loop !
	jz	@@L1
	mov	ebx,ds:[Camera_Ptr]		;EBX = ViewPort
	mov	ecx,ds:[World_Ptr]		;ECX = World_Header
	cmp	ax,'+'
@@K0:	jne	short @@K1
		add 	ds:[ebx+Camera_PositionZ],10 shl GVE_MATH_SHIFT
		jmp 	@@L1
@@K1:	cmp	ax,'-'
	jne	short @@K2
		sub 	ds:[ebx+Camera_PositionZ],10 shl GVE_MATH_SHIFT
		jmp 	@@L1
@@K2:	cmp	ax,Cursor_Left
	jne	short @@K3
		sub	ds:[ebx+Camera_PositionX],10 shl GVE_MATH_SHIFT
		jmp	@@L1
@@K3:	cmp	ax,Cursor_Right
	jne	short @@K4
		add	ds:[ebx+Camera_PositionX],10 shl GVE_MATH_SHIFT
		jmp	@@L1
@@K4:	cmp	ax,Cursor_Up
	jne	short @@K5
		sub	ds:[ebx+Camera_PositionY],10 shl GVE_MATH_SHIFT
		jmp	@@L1
@@K5:	cmp	ax,Cursor_Down
	jne	short @@K6
		add	ds:[ebx+Camera_PositionY],10 shl GVE_MATH_SHIFT
		jmp	@@L1
@@K6:	cmp	ax,F9_Key
	jne	short @@K7
		xor	ds:[ecx+World_Flags],GVE_FLAG_SOFTEN_HORIZONTAL
		jmp	@@L1
@@K7:	cmp	ax,F10_Key
	jne	short @@K8
		xor	ds:[ecx+World_Flags],GVE_FLAG_SOFTEN_VERTICAL
		jmp	@@L1
@@K8:	cmp	ax,F1_Key
	jne	short @@K9
		xor	ds:[ecx+World_Flags],GVE_FLAG_MOTION_BLURR
		jmp	@@L1
@@K9:	cmp	ax,F2_Key
	jne	short @@KA
		xor	ds:[ecx+World_Flags],GVE_FLAG_MOTION_TRACE
		jmp	@@L1
@@KA:	cmp	ax,F3_Key
	jne	short @@KB
		xor	ds:[ecx+World_Flags],GVE_FLAG_FEED_BACK
		jmp	@@L1
@@KB:	cmp	ax,F4_Key
	jne	short @@KEnd
		xor	ds:[ecx+World_Flags],GVE_FLAG_CLEAR_FRAME
		jmp	@@L1

@@KEnd:	cmp 	ax,Escape
	je	short @@Ende
	jmp	@@L1
	;
	;   Exit routines
	;
@@Ende: ifndef GVE_PROFILER
	 mov 	ax,36h 	; PIT channel 0, square wave,binary, send LSB & MSB
	 out 	43h,al 	; send command
	 mov 	al,0
	 out 	40h,al 	; maximum timer count (freq. = 18.2 Hz)
	 out 	40h,al 	;

	 mov	eax,0
	 mov	ebx,ds:[TIMER_RM_Int]
;	 call	UnLink_Real_IRQ
	 mov	eax,0
	 mov	ebx,ds:[TIMER_PM_Int]
	 call	Set_Flat_IRQ

	 call 	Print_Profiler
	endif

	mov	eax,ds:[World_Ptr]
	call	GVE_Free_World                  ;Release memory
	call	Exit_GDraw
	call	Exit_SVGA
	call	Exit_GVE
@@NoVESA:
	jmp	Exit_PMODE32			;Thats all folks !

@@InitError:					;An error occured
	call	Exit_GDraw
	call	Exit_SVGA
	call	Exit_GVE
	mov	esi,OFFSET ETXT2		;Display error-text
	call	Print32
	jmp	Exit_PMODE32

@@LoadError:					;An error occured
	call	Exit_GDraw
	call	Exit_SVGA
	call	Exit_GVE
	mov	esi,OFFSET ETXT1		;Display error-text
	call	Print32
	jmp	Exit_PMODE32

@@NoFile:
	mov	esi,OFFSET ETXT0		;Display error-text
	call	Print32
	jmp	Exit_PMODE32
main ENDP


;
;   GOMEZ VECTOR ENGINE                                          Timer stuff
;
Timer_PM_INT		dd 	?
Tiemr_RM_INT		dd	?
Timer_Counter		dd	0ffffh
Timer_Handler:
	push	ds
	push	eax
	mov	ds,cs:[DATA32_Selector]
	inc	ds:[GVE_Timer]
	mov	al,20h
	sub	ds:[Timer_Counter],123333h/GVE_TIMER_SPEED
	js	short @@1
	out	20h,al		;Send EOI to PIC
	pop	eax
	pop	ds
	iretd

@@1:	add	ds:[Timer_Counter],0ffffh
	pop	eax
	pop	ds
	jmp	cs:[Timer_PM_INT]
	iretd

;
;   GOMEZ VECTOR ENGINE                                           Profiler
;
Text_Buffer		db	16 dup (?)


Profiler PROC NEAR
	ifdef GVE_PROFILER
	push	esi
	push	edi

	mov	esi,ds:[SVGA_Display_Width]
	shr	esi,5				;ESI = WIdth/32
	mov	edi,ds:[SVGA_Display_Height]
	shr	edi,5				;EDI = Height/32

	mov	eax,ds:[SVGA_Frame_Buffer]
	mov	ebx,edi
	shl	ebx,16
	mov	bx,si
	mov	ecx,100000h
	mov	cx,si
	imul	cx,30
	mov	edx,255
	call	GDraw_Border

	test	ds:[Local_Flags],1
	jz	short @@J1
	xor	ebx,ebx
	shrd	ebx,edi,16
	mov	bx,si
	add	ebx,20002h			;EBX = Upper left corner
	mov	ecx,ds:[SVGA_Display_Width]
	sub	ecx,esi
	sub	ecx,esi
	sub	ecx,4
	or 	ecx,0c0000h
	mov	eax,ds:[SVGA_Frame_Buffer]
	xor	edx,edx
	call	GDraw_Box
@@J1:	;
	mov	eax,ds:[GVE_Frame_Speed]
	xor	ebx,ebx
	shrd	ebx,edi,16
	mov	bx,si
	add	ebx,20002h			;EBX = Upper left corner
	mov	ecx,0c0000h
	imul	si				;DX:AX = 256*fps*Width/32
	shrd	ax,dx,8
	mov	cx,ax
	mov	eax,ds:[SVGA_Display_Width]
	sub	eax,esi
	sub	eax,esi
	sub	eax,4
	cmp	cx,ax
	jb	short @@1
	mov	cx,ax
@@1:	mov	eax,ds:[SVGA_Frame_Buffer]
	mov	edx,128
	call	GDraw_Box
	;
	mov	edx,ds:[GVE_Frame_Speed]
	shr	edx,8
	call	Long2Text

	mov	eax,ds:[SVGA_Frame_Buffer]
	mov	ebx,edi
	shl	ebx,16
	mov	bx,si
	add	ebx,20010h
	mov	ecx,OFFSET Text_Buffer
	mov	edx,200
	call	GDraw_Text

@@End:  pop	edi
	pop	esi
	endif
	retn
Profiler ENDP



;
;Long2Text:
;  Input:
;	EDX	- Number to convert
;	EDI	- ptr to string
;  Output:
;	EDI	- ptr to terminating 0
;  Destroys:
;	EAX,EBBX,ECX,EDX
;
Long2Text PROC NEAR
	push	edi
	mov	edi,OFFSET Text_Buffer
	test 	edx,edx
	jnz 	@@NotZ
	mov	ax,'0'
	stosw
	pop	edi
	retn

@@NotZ:	test 	edx,edx
	jns 	short @@NoS
	mov 	byte ptr ds:[edi],'-'
	inc 	edi
	neg 	edx

@@NoS:  push	ebp
	mov	ebp,edi
	mov 	ebx,edx
	mov 	ecx,10000000
@@1:    xor 	edx,edx
	mov 	eax,ebx
	div 	ecx
	test 	al,al
	jnz 	short @@4
	cmp 	edi,ebp
	je 	short @@2
@@4:	add 	al,'0'
	stosb
@@2:	mov 	ebx,edx
	xor 	edx,edx
	mov 	eax,ecx
	mov 	ecx,10
	div 	ecx
	test 	eax,eax
	jz 	short @@3
	mov 	ecx,eax
	jmp 	short @@1

@@3:	mov 	byte ptr ds:[edi],0
	pop	ebp
	pop	edi
	retn
Long2Text ENDP

code32 ends
END
