;[]------------------------------------------------------------------------[]
;|                                                                          |
;| (c) 1993,1994 by Marc van Shaney , aka Kaya Memisoglu                    |
;|                                                                          |
;| Dieser Assembler-Source-Code unterliegt dem Urheberrecht von Kaya        |
;| Memisoglu und darf auch nur mit seiner schriftlichen Genehmigung         |
;| in kommerziellen Programmen verwendet werden.                            |
;| Ich bernehme keinerlei Verantwortung fr eventuelle Schden,die dieses  |
;| Programm verursacht.                                                     |
;|                                                                          |
;|                                                                          |
;| 18.1.1994 Kaya Memisoglu                                                 |
;|                                                                          |
;[]------------------------------------------------------------------------[]



P386

LOCALS
VGA_Width         equ  320
VGA_Height        equ  200
Char_Segment      equ  0f000h
Char_Offset       equ  0fa6eh
Black             equ  240
Background        equ  0
TRUE              equ  1
FALSE             equ  -1


.MODEL USE16 LARGE

.Code
PUBLIC C UncompCLUT
UncompCLUT PROC
	ARG src:dword,dest:dword
	;uncompress color palette onto a buffer
	push bp
	mov bp,sp
	push ds
	push si
	push di
	cld

	lds si,[src]
	les di,[dest]
	lodsw
	mov bx, ax   ;get the count
	test bx,bx
	jmp short endu
u:
        xor ax,ax
	lodsb		;get colors to skip
	add di,ax
	add di,ax
	add di,ax
	add di,ax       ;MvS
	lodsb		;get colors to copy
	or  al,al	;test for zero
	jnz short u2
	mov ax,256
u2:
	mov cx,ax
 Schleife67:            ;MvS in order to use my 4-Byte Palettes
	  lodsb
	  shl al,2      ;We need 8 bits and not only 6
	  stosb
	  lodsb
	  shl al,2      ;  ""
	  stosb
	  lodsb         ;  ""
	  shl al,2
	  stosw         ;  ""
 loop Schleife67        ;  ""
	dec bx
endu:
	jnz short u

	pop di
	pop si
	pop ds
	pop bp
	retf
UncompCLUT endp







PUBLIC C UncompCLUT24
UncompCLUT24 PROC
	ARG src:dword,dest:dword
	;uncompress color palette onto a buffer
	push bp
	mov bp,sp
	push ds
	push si
	push di
	cld

	lds si,[src]
	les di,[dest]
	lodsw
	mov bx, ax   ;get the count
	test bx,bx
	jmp short endu24
u24:
        xor ax,ax
	lodsb		;get colors to skip
	add di,ax
	add di,ax
	add di,ax
	add di,ax       ;MvS
	lodsb		;get colors to copy
	or  al,al	;test for zero
	jnz short u224
	mov ax,256
u224:
	mov cx,ax
 Schleife6:            ;MvS in order to use my 4-Byte Palettes
	  lodsw
	  stosw
	  lodsb
	  stosw
 loop Schleife6        ;  ""
	dec bx
endu24:
	jnz short u24

	pop di
	pop si
	pop ds
	pop bp
	retf
UncompCLUT24 endp




;fii_unbrun.asm - low level routine to uncompress 1st frame of a FLI
FLI_Lsize		dw ?
PUBLIC C UncompRLE
UncompRLE PROC far
	ARG src:dword,dest:dword
	;save the world and set the basepage
	push bp
	mov bp,sp
	push ds

	cld	;clear direction flag in case Aztec or someone mucks with it.

	lds si,src
	les di,dest
	mov ax,es:[di]
	mov cs:[FLI_lsize],ax
	mov bp,es:[di+2]
	add di,16
	mov	dx,di	;keep pointer to start of line in dx
linelp:
	mov	di,dx
	lodsb		;get op count for this line
	mov bl,al
	test bl,bl
	jz short ulcout4
ulcloop:
	xor ah,ah
	lodsb	; load op/count
	test al,al
	js short ucopy

	mov cx,ax ;move count to cx
	lodsb	  ;value to repeat in al
	shr cx,1
	mov ah,al
	rep stosw ;store same value again and again...
	jnc short ulcout
	stosb
	dec bl
	jnz short ulcloop
	jmp short ulcout4

ucopy:
	neg al
	mov cx,ax       ;get sign  correctec copy count
	shr cx,1
	rep movsw
	jnc short ulcout
	movsb

ulcout:			;advance to next line...
	dec bl          ;Packets--
	jnz short ulcloop     ;llop
ulcout4:
	add	dx,cs:[FLI_lsize]
	dec     bp      ;Lines--
	jnz	linelp

	pop ds
	pop bp
	retf
UncompRLE ENDP





PUBLIC C CopyFLI
CopyFLI PROC
      ARG Src:dword,dest:dword
      push bp
      mov bp,sp

      cld
      les di,dest
      lfs si,src
      mov ax,es:[di]
      mul word ptr es:[di+2]
      mov cx,ax
      shr cx,2
      add di,16
      rep movs dword ptr [es:di],[fs:si]

      pop bp
      retf
CopyFLI ENDP






PUBLIC C ClearFLI
ClearFLI PROC
      ARG Dest:dword
      push bp
      mov bp,sp

      cld
      les di,Dest
      mov ax,es:[di]
      mul word ptr es:[di+2]
      mov cx,ax
      shr cx,2
      add di,16
      xor eax,eax
      rep stosd

      pop bp
      retf
ClearFLI ENDP







PUBLIC C UncompDELTA_FLI
UncompDELTA_FLI PROC
	ARG src:dword,dest:dword
	push bp
	mov bp,sp
	push ds

	cld		;clear direction flag in case Aztec or someone mucks with it.

	lds si,[src]
	les di,[dest]
	mov bx,es:[di]
	mov cs:[FLI_Lsize],bx
	add di,16

	lodsw		;get the count of # of lines to skip
	mul bx
	add di,ax
	lodsw		;get line count
	mov	bp,ax	;save it on stack
	mov	dx,di	;keep pointer to start of line in dx
	xor	ah,ah	;clear hi bit of ah cause lots of unsigned uses to follow
linelp2:
	mov	di,dx
	lodsb		;get op count for this line
	mov bl,al
	test al,al
	jz short ulcout3
ulcloop2:
	xor ah,ah
	lodsb	;load in the byte skip
	add di,ax
	lodsb			; load op/count
	test al,al
	js short ulcrun
	mov cx,ax
	shr cx,1
	rep movsw    		;MvS:movsb
	jnc short ulcout2
	movsb
	dec bl
	jnz short ulcloop2
	jmp short ulcout3
ulcrun:
	neg al
	mov cx,ax 		;get signed count
	shr cx,1
	lodsb	  		;value to repeat in al
	mov ah,al
	rep stosw 		;Do it !
	jnc short ulcout2
	stosb

ulcout2:
	dec bl
	jnz short ulcloop2
ulcout3:
	add	dx,cs:[FLI_Lsize]	;Next line
	dec     bp       		;Lines--
	jnz	short linelp2

	pop     ds
	pop	bp
	retf
UncompDELTA_FLI ENDP







PUBLIC C UncompDELTA_FLC
UncompDELTA_FLC PROC
	ARG src:dword,dest:dword
	push bp
	mov bp,sp
	push ds

	cld	;clear direction flag in case Aztec or someone mucks with it.

	lds si,[src]
	les di,[dest]
	mov bx,es:[di]
	mov cs:[FLI_Lsize],bx
	add di,16
	lodsw			;get line count
	mov	bp,ax		;save it on stack (lp_count)
	mov	dx,di		;keep pointer to start of line in dx
	xor cx,cx
	jmp short LPACK

SKIPLINES:
	mov bx,dx               ;Save line-pointer
	imul cs:[FLI_Lsize]
	mov dx,bx
	sub dx,ax
LPACK:
	lodsw			;opcount
	cmp ax,0
	jge short DO_SS2OPS
	test ax,04000h          ;Skip some lines ?
	jnz short SKIPLINES
	mov di,dx		;No,put dot at eol
	add di,cs:[FLI_Lsize]	;next line
	dec di			;eol
	stosb			;put pixel
	lodsw			;get opcount
	test ax,ax		;some opcounts left ???
	jnz short DO_SS2OPS
	add dx,cs:[FLI_Lsize]	;No opcounts left,next line
	dec bp			;lp_count--
	jnz short LPACK		;Unpack next line
	jmp short FLC_OUT	;All done

DO_SS2OPS:
	mov bx,ax		;Opcount
	mov di,dx               ;Start of line
PPACK:
	lodsb
	xor ah,ah
	add di,ax
	lodsb
	cmp al,0
	jl short DO_RLE
	mov cl,al
	rep movsw      		;Opcount--
	dec bx
	jnz short PPACK
	add dx,cs:[FLI_Lsize]
	dec bp			;L_Count--
	jg  short LPACK
	jmp short FLC_OUT
DO_RLE:
	neg al
	mov cl,al
	lodsw
	rep stosw
	dec bx
	jnz short PPACK
	add dx,cs:[FLI_Lsize]
	dec bp			;L_Count--
	jg  short LPACK

FLC_OUT:
	pop     ds
	pop	bp
	retf
UncompDELTA_FLC ENDP









;[]------------------------------------------------------------------------[]
;|                                                                          |
;|                                                                          |
;| Assembler low-level Zeigernormierungsroutinen fr das FLIC-format        |
;|                                                                          |
;| berarbeitet von Kaya Memisoglu                                         |
;|                                                                          |
;|                                                                          |
;|                                                                          |
;[]------------------------------------------------------------------------[]





PUBLIC C norm_ptr
	;i86_norm_ptr(offset, seg)
	;Add as much as possible of the offset of a pointer to the segment
norm_ptr PROC far
	mov bx,sp

	mov ax,ss:[bx+4]	;offset
	mov dx,ss:[bx+6]   ;segment
	shr ax,4
	add dx,ax
	mov	ax,ss:[bx+4]	;offset
	and ax,15

	retf
norm_ptr ENDP




PUBLIC	C enorm_ptr
	;i86_norm_ptr(offset, seg)
	;Add as much as possible of the offset of a pointer to the segment
	;and make it evenly alligned...
enorm_ptr PROC far
	push bp
	mov bp,sp

	mov ax,[bp+4+2]	;offset
	mov dx,[bp+6+2]   ;segment
	inc ax
	and ax,0FFFEh	;force even allignment
	mov [bp+4+2],ax ;and save...
	mov cl,4
	shr ax,cl
	add dx,ax
	mov	ax,[bp+4+2]	;offset
	and ax,15

	pop	bp
	retf
enorm_ptr ENDP




;[]------------------------------------------------------------------------[]
;|                                                                          |
;|                                                                          |
;| Assembler low-level Routinen zur besseren komprimierung von FLI-Dateien  |
;|                                                                          |
;| (c) 1994 by Kaya Memisoglu                                               |
;|                                                                          |
;|                                                                          |
;|                                                                          |
;[]------------------------------------------------------------------------[]




CompareCOLORS PROC NEAR
       ;Ein Zeiger auf die Palette in GS:BX
       ;Farbe 1 in al
       ;Farbe 2 in ah
       ;Ergebnis in AX
	push bx
	movzx dx,al                 ;Farbe 1
	shl dx,2
	add bx,dx                   ;Die Palette wird indiziert
	movzx dx,byte ptr [gs:bx]
	mov cs:[Red],dx
	movzx dx,byte ptr [gs:bx+1]
	mov cs:[Green],dx
	movzx dx,byte ptr [gs:bx+2]
	mov cs:[Blue],dx          ;Alle Register gespeichert
	pop bx
	push bx                     ;Alten Zeiger herstellen
	movzx dx,ah
	shl dx,2
	add bx,dx
	xor dh,dh
	movzx ax,[gs:bx]            ;Farbe von NEU in ebx
	sub ax,cs:[Red]
	jns short NoSign1
	neg ax
     NoSign1:
	 mov dl,[gs:bx+1]
	 sub dx,cs:[Green]
	 jns short NoSign2
	 neg dx
     NoSign2:
	 add ax,dx
	 mov dl,[gs:bx+2]
	 sub dx,cs:[Blue]
	 jns short NoSign3
	 neg dx
     NoSign3:
	add ax,dx
	pop bx
	retn

 Red    dw ?
 Green  dw ?
 Blue   dw ?
CompareCOLORS ENDP








PUBLIC C ReduceNEXT
ReduceNEXT PROC
	ARG Old:dword,New:dword,Pal:dword,Ratio:word
	push bp
	mov bp,sp

	les di,New
	lfs si,Old
	lgs bx,Pal

	mov dword ptr cs:[Changed],0
	mov cx,VGA_Width*(VGA_Height-1)-1
Schleife296:
	 inc di
	 inc si
	 mov al,byte ptr [fs:si]
	 mov ah,byte ptr [es:di]
	 call CompareCOLORS
	 cmp ax,[Ratio]                   ;Innerhalb der Fehlergrenze ?
	 ja short TooBig1                 ;Ja es wird NICHT von Old bernommen
	 mov dl,[fs:si]                   ;NEW bekommt den Wert von OLD
	 mov [es:di],dl                   ;          --"--
	 inc dword ptr cs:[Changed]

TooBig1:
loop Schleife296
	 jmp short EndeReduce

;TooBig1:
	 mov al,byte ptr [es:di]
	 mov ah,byte ptr [es:di-1]
	 call CompareCOLORS          ;Knnen wir wenigstens RLE tunen ?
	 cmp ax,[Ratio]
	 ja short TooBig2                  ;Rechts geht nicht
	 mov dl,[es:di-1]
	 mov [es:di],dl
	 inc dword ptr cs:[Changed]
  TooBig2:
	 mov al,byte ptr [es:di]
	 mov ah,byte ptr [es:di+320]
	 call CompareCOLORS
	 cmp ax,[Ratio]
	 ja short TooBig3                  ;Unten geht nicht
	 mov dl,[es:di]
	 mov [es:di+320],dl
  TooBig3:
loop Schleife296


EndeReduce:
	mov eax,dword ptr cs:[Changed]
	shr eax,2
	pop bp
	retf
Changed dd ?
ReduceNEXT ENDP






PUBLIC C ReduceFIRST
ReduceFIRST PROC
	ARG buf:dword,Pal:dword,Ratio:word
	push bp
	mov bp,sp

	les di,buf
	lgs bx,Pal

	mov cx,VGA_Width*VGA_Height-321
Schleife335:
	 inc di
	 mov al,byte ptr [es:di-1]
	 mov ah,byte ptr [es:di]
	 call CompareCOLORS
	 cmp ax,[Ratio]
	 ja short TooBig4
	 mov dl,[es:di-1]
	 mov [es:di],dl
  TooBig4:
	 mov al,byte ptr [es:di]
	 mov ah,byte ptr [es:di+320]
	 call CompareCOLORS
	 cmp ax,[Ratio]
	 ja short TooBig5
	 mov dl,byte ptr [es:di]
	 mov [es:di+320],dl
  TooBig5:
loop Schleife335

	pop bp
	retf
ReduceFIRST ENDP





;[]------------------------------------------------------------------------[]
;|                                                                          |
;|                                                                          |
;| Assembler low-level Komprimierungs-Routinen fr das FLIC-format          |
;| (c) by Jim Kent                                                          |
;|                                                                          |
;| berarbeitet von Kaya Memisoglu                                         |
;|                                                                          |
;|                                                                          |
;|                                                                          |
;[]------------------------------------------------------------------------[]





PUBLIC C i86_bcompare
	;i86_bcompare(s1,s2,count)
;return # of bytes of s1 and s2 that match
i86_bcompare PROC far
	push bp
	mov bp,sp
	push ds
	push si
	push di
	cld

	lds si,[bp+4+2]
	les di,[bp+8+2]
	mov cx,[bp+12+2]
	inc cx
	repe cmpsb

	mov ax,[bp+12+2]
	sub ax,cx

	pop di
	pop si
	pop ds
	pop	bp
	retf

i86_bcompare ENDP




PUBLIC C i86_bcontrast
	;i86_bcontrast(s1, s2, count)
;return how many bytes of s1 and s2 are different
i86_bcontrast PROC far
	push bp
	mov bp,sp
	push ds
	push si
	push di
	cld

	lds si,[bp+4+2]
	les di,[bp+8+2]
	mov cx,[bp+12+2]
	repne cmpsb
	inc cx
	mov ax,[bp+12+2]
	sub ax,cx

	pop di
	pop si
	pop ds
	pop	bp
	retf
i86_bcontrast ENDP





PUBLIC C i86_bsame
	;i86_bsame(d, count)
	;find out how many bytes in a row are the same value
i86_bsame PROC far
	push bp
	mov bp,sp
	push di
	cld

	les di,[bp+4+2]
	mov cx,[bp+8+2]
	mov ax,es:[di]
	inc cx
	repe scasb

	mov ax,[bp+8+2]
	sub ax,cx

	pop di
	pop	bp
	retf
i86_bsame ENDP





PUBLIC C i86_dcompare
	;i86_dcompare(s1, s2, count)
i86_dcompare PROC far
	push bp
	mov bp,sp
	push ds
	push si
	push di
	cld

	lds si,[bp+4+2]
	les di,[bp+8+2]
	mov cx,[bp+12+2]
	inc cx
	repe cmpsd

	mov ax,[bp+12+2]
	sub ax,cx

	pop di
	pop si
	pop ds
	pop	bp
	ret

i86_dcompare ENDP






PUBLIC C i86_wcontrast
	;i86_wcontrast(s1, s2, count)
i86_wcontrast PROC far
	push bp
	mov bp,sp
	push ds
	push si
	push di
	cld

	lds si,[bp+4+2]
	les di,[bp+8+2]
	mov cx,[bp+12+2]
	repne cmpsw
	inc cx

	mov ax,[bp+12+2]
	sub ax,cx

	pop di
	pop si
	pop ds
	pop	bp
	retf
i86_wcontrast ENDP





PUBLIC C i86_wsame
	;i86_wsame(d, count)
	; find out how many (16 bit) words in a row are the same
i86_wsame PROC far
	push bp
	mov bp,sp
	push di
	cld

	les di,[bp+4+2]
	mov cx,[bp+8+2]
	mov ax,es:[di]
	inc cx
	repe scasw

	mov ax,[bp+8+2]
	sub ax,cx

	pop di
	pop	bp
	ret
i86_wsame ENDP




	PUBLIC _fii_tnskip
;fii_tnskip(s1,s2,bcount,mustmatch)
s1	equ	[bp+4+2]
s1s	equ	[bp+6+2]
s2	equ	[bp+8+2]
s2s	equ	[bp+10+2]
bcount	equ	[bp+12+2]
mmatch	equ	[bp+14+2]
_fii_tnskip	proc far
difcount	equ	[bp-2]
	push bp
	mov bp,sp
	sub sp,4	;space for locals
	push bx
	push si
	push di
	push ds

	mov word ptr difcount,0	;zero out return value
	lds si,s1
	les di,s2
	mov bx,bcount
	mov dx,mmatch

tnsloop:
	;calculate number of pixels different in s1 and s2 into ax
	mov cx,bx
	inc cx
	repne cmpsb
	mov ax,bx
	sub ax,cx
	dec si	;move source pointers just past this different run
	dec di
	sub bx,ax
	add difcount,ax	;and different count to return value

	cmp bx,dx		;see if near the end...
	js endcheck

	;see if enough in a row match to break out of this
	mov cx,dx
	repe cmpsb
	jz short zfii_tnskip	;if all of them match between s1 and s2 go home
	inc cx
	mov ax,dx		;calc ones that do match into ax
	sub ax,cx
	add difcount,ax	;add it to difcount return value
	sub bx,ax		;sub it from pixels left to examine
	dec si		;update s1,s2 pointers
	dec di
	jmp short tnsloop
endcheck:
	;check last couple of pixels
	mov cx,bx
	inc cx
	repe cmpsb
	jcxz short zfii_tnskip	;if all of them match between s1 and s2 go home
	add difcount,bx	;otherwise assume no skip this time around

zfii_tnskip:
	mov ax,difcount
	pop ds
	pop di
	pop si
	pop bx
	mov sp,bp
	pop bp
	retf
_fii_tnskip	endp




	PUBLIC	_fii_tnsame
;fii_tnsame(s2x,wcount,mustmatch)
s2x	equ [bp+4+2]
wcount	equ word ptr[bp+8+2]
mumatch	equ [bp+10+2]
_fii_tnsame	PROC far
	push bp
	mov bp,sp
	push ds
	push si
	push di
	push bx


	les	di,s2x		;get starting address in es:di
	mov	dx,wcount		;dx is 'dif_count' return value
	mov	bx,dx		;bx is # of pixels left
	mov	si,0		;si is # of pixels examined
alp:
				;break out of loop if less than 4 pixels
				;left to examine
	cmp	bx,mumatch
	js short zalp

	;same_count = i86_bsame(s2x,wcount)
	mov cx,bx
	mov al,es:[di]
	rep scasb
	inc cx
	sub di,2
	mov ax,bx
	sub ax,cx

	cmp ax,mumatch			;if mustmatch or more
	jns short gotsame		;go truncate dif_count
	add	si,ax
	add	di,ax
	sub	bx,ax
	jmp	alp
gotsame:
	mov	dx,si
zalp:
	mov ax,dx		;return dif_count
	pop bx
	pop di
	pop si
	pop ds
	pop bp
	retf

_fii_tnsame	ENDP

END

