;͸
;                                                                           
; (c) 1997 by Marc van Shaney , aka Kaya Memisoglu                          
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P486
LOCALS
JUMPS

__GDRAW_SYSTEM_FILE	equ	1

code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gomez.inc
include gdraw.inc
include svga.inc



PUBLIC C GD_Frame_Width
PUBLIC C GD_Frame_Line_Size
PUBLIC C GD_Frame_Height
PUBLIC C GD_Frame_Depth
PUBLIC C GD_Frame_Palette
PUBLIC C GD_System_Palette
GD_Frame_Width		dd	?
GD_Frame_Line_Size	dd	?
GD_Frame_Height		dd	?
GD_Frame_Depth		dd	?
GD_Functions		dd	?
GD_Colour_LUT		dd	?
GD_System_Palette	dd	?
GD_Frame_Palette	dd	?



;
;
;
;   GOMEZ DRAWING ROUTINES  				         Init-Stuff
;
;
;
;
;
; Init_GDraw
;  Input:
;	EAX	- Display width
;	EBX	- Display height
;	ECX	- Display depth (8,15,16,24,32)
;  Output:
;	[CF]	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C Init_GDraw
Init_GDraw PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov	ds:[GD_Frame_Width],eax
	mov	ds:[GD_Frame_Line_Size],eax
	mov	ds:[GD_Frame_Height],ebx
	mov	ds:[GD_Frame_Depth],ecx
	;
	mov	ecx,1024
	call	Malloc
	mov	ds:[GD_Frame_Palette],eax
	jc	@@End

	mov	ecx,1024
	call	Malloc
	mov	ds:[GD_System_Palette],eax
	jc	@@End

	mov	ecx,1024
	call	Malloc
	mov	ds:[GD_Colour_LUT],eax
	jc	@@End
	;
	mov	ecx,ds:[GD_Frame_Depth]
	cmp	cl,8
	ja	short @@15
	mov	ds:[GD_Functions],OFFSET Drawing_Table8
	clc
	jmp	@@End
@@15:	;
	cmp	cl,16
	ja	short @@24
	mov	ds:[GD_Functions],OFFSET Drawing_Table16
	shl	ds:[GD_Frame_Line_Size],1
	clc
	jmp	@@End
@@24:	;
	cmp	cl,24
	ja	short @@32
	mov	ds:[GD_Functions],OFFSET Drawing_Table24
	mov	eax,ds:[GD_Frame_Width]
	lea	eax,[eax+2*eax]
	mov	ds:[GD_Frame_Line_Size],eax
	clc
	jmp	@@End
@@32:	;
	mov	ds:[GD_Functions],OFFSET Drawing_Table32
	shl	ds:[GD_Frame_Line_Size],2
	clc

@@End:	pop	ds
	retn
Init_GDraw ENDP



;
;
; Exit_GDraw
;  Input:
;	Nothing
;  Output:
;	[CF]	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C Exit_GDraw
Exit_GDraw PROC NEAR
	mov	ecx,cs:[GD_Colour_LUT]
	call	Free
	mov	ecx,cs:[GD_Frame_Palette]
	call	Free
	mov	ecx,cs:[GD_System_Palette]
	call	Free
	retn
Exit_GDraw ENDP



;
;
; GDraw_Set_Frame_Palette
;  Input:
;	EAX	- DATA32-ptr to palette
;  Output:
;	[CF]	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GDraw_Set_Frame_Palette
GDraw_Set_Frame_Palette  PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,cs:[DATA32_Selector]
	;
	mov	esi,eax
	mov	edi,ds:[GD_Frame_Palette]
	mov	ecx,256
	rep	movsd
	;
	cmp	ds:[GD_Frame_Depth],15
	jae	short @@End

	mov     esi,ds:[GD_Frame_Palette]
	mov	ebp,ds:[GD_System_Palette]
	mov	edi,ds:[GD_Colour_LUT]
	mov	ecx,256
@@L1:   push	ecx
	mov	edx,ds:[ebp]
	call	Fit_Colour
	mov	cl,ch
	mov	ds:[edi],cx
	mov	ds:[edi+2],cx
	pop	ecx
	add	ebp,4
	add	edi,4
	dec	ecx
	jnz	short @@L1
@@End:	;
	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GDraw_Set_Frame_Palette  ENDP



;
;
; GDraw_Set_System_Palette
;  Input:
;	EAX	- DATA32-ptr to palette
;  Output:
;	[CF]	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GDraw_Set_System_Palette
GDraw_Set_System_Palette PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,cs:[DATA32_Selector]
	;
	mov	esi,eax
	mov	edi,ds:[GD_System_Palette]
	mov	ecx,256
	rep	movsd
	;
	cmp	ds:[GD_Frame_Depth],15
	jae	short @@15

	mov     esi,ds:[GD_Frame_Palette]
	mov	ebp,ds:[GD_System_Palette]
	mov	edi,ds:[GD_Colour_LUT]
	mov	ecx,256
@@L1:   push	ecx
	mov	edx,ds:[ebp]
	call	Fit_Colour
	mov	cl,ch
	mov	ds:[edi],cx
	mov	ds:[edi+2],cx
	pop	ecx
	add	ebp,4
	add	edi,4
	dec	ecx
	jnz	short @@L1
	jmp	@@End
@@15:	;
	cmp	ds:[GD_Frame_Depth],24
	jae	short @@24

	mov	esi,ds:[GD_System_Palette]
	mov	edi,ds:[GD_Colour_LUT]
	mov	ecx,16
	sub	ecx,ds:[GD_Frame_Depth]
	mov	ebx,256
@@L2:   mov	edx,ds:[esi]
	bswap	edx
	shld	eax,edx,5
	shl	edx,8
	shld	eax,edx,6
	shr	eax,cl
	shl	edx,8
	shld	eax,edx,5

	stosw
	stosw
	add	esi,4
	dec	ebx
	jnz	short @@L2
	jmp	@@End
@@24:	;


@@End:	;
	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn


	pop	es
	pop	ds
	retn
GDraw_Set_System_Palette ENDP

;
;
; Now follows a LUT-Generator in order to get a shading LUT for a given 3*6
; bit palette.
;
;
; FIT_COLOUR:
;  Input:
;	EDX   	- colour to fit	(3*8 bit)
;	DS:ESI 	- DATA32 ptr to palette	(3*8 bit)
;  Output:
;	EDX     - Best difference
;	CH	- Best colour
;  Destroys:
;	EAX,EBX,ECX,EDX
;
;  All colours have the following format:
;	8bit   8bit  8bit   8bit
;	 EDH    EDL   DH     DL
;	  ?    Blue  Green  Red
;
Fit_Colour PROC NEAR
	push 	esi		;Save old colour-ptr
	push	edi
	push	ebp

	mov	ebp,edx		;EBP = Colour to fit
	mov	ebx,esi		;EBX = Ptr to palette
	movzx	esi,dl		;ESI = Red
	movzx	edi,dh		;EDI = Green
	shr	ebp,16
	and	ebp,0ffh        ;EBP = Blue
	xor	ecx,ecx		;CL  = Counter     CH = Best colour
	mov 	edx,0fffh	;EDX = Difference
	@@L1:	push	ecx
		movzx 	eax,b ds:[ebx]
		sub	eax,esi		;EAX = Red difference
		jns 	short @@1
		neg 	eax
	@@1:   	movzx	ecx,b ds:[ebx+1]
		sub	ecx,edi		;ECX = Green difference
		jns 	short @@2
		neg 	ecx
	@@2:	add 	eax,ecx
		movzx 	ecx,b ds:[ebx+2]
		sub 	ecx,ebp		;ECX = Blue difference
		jns 	short @@3
		neg 	ecx
	@@3:	add 	eax,ecx		;EAX = total difference
		pop	ecx
		cmp     eax,edx		;Compare differences
		jae	short @@No
			mov	edx,eax	;Best difference
			mov	ch,cl	;Best index
	@@No: 	add	ebx,4
		inc	cl
		jnz	short @@L1

	pop	ebp
	pop	edi
	pop	esi
	retn
Fit_Colour ENDP




;
;
;
;   GOMEZ DRAWING ROUTINES  			          Front-End-Routines
;
;
;
;
;
; GDraw_Box
; GDRaw_Border
; GDraw_VLine
; GDRaw_HLine
; GDRaw_Line
; GDraw_Text
; GDraw_Mouse
; GDraw_Bitmap
; GDraw_Scaled_Bitmap
; GDRaw_Icon
;
PUBLIC C GDraw_Box
GDraw_BOX:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[GD_Functions]
	mov	es,ds:[DATA32_Selector]
	jmp	d ds:[ebp+GD_Box_Handler]
;
PUBLIC C GDraw_Border
GDraw_Border:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[GD_Functions]
	mov	es,ds:[DATA32_Selector]
	jmp	d ds:[ebp+GD_Border_Handler]
;
PUBLIC C GDraw_Line
GDraw_Line:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[GD_Functions]
	mov	es,ds:[DATA32_Selector]
	jmp	d ds:[ebp+GD_Line_Handler]
;
PUBLIC C GDraw_VLine
GDraw_VLine:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[GD_Functions]
	mov	es,ds:[DATA32_Selector]
	jmp	d ds:[ebp+GD_VLine_Handler]
;
PUBLIC C GDraw_HLine
GDraw_HLine:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[GD_Functions]
	mov	es,ds:[DATA32_Selector]
	jmp	d ds:[ebp+GD_HLine_Handler]
;
PUBLIC C GDraw_Bitmap
GDraw_Bitmap:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[GD_Functions]
	mov	es,ds:[DATA32_Selector]
	jmp	d ds:[ebp+GD_Bitmap_Handler]
;
PUBLIC C GDraw_Scaled_Bitmap
GDraw_Scaled_Bitmap:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[GD_Functions]
	mov	es,ds:[DATA32_Selector]
	jmp	d ds:[ebp+GD_Scaled_Bitmap_Handler]
;
PUBLIC C GDraw_Mouse
GDraw_Mouse:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[GD_Functions]
	mov	es,ds:[DATA32_Selector]
	jmp	d ds:[ebp+GD_Mouse_Handler]
;
PUBLIC C GDraw_Text
GDraw_Text:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[GD_Functions]
	mov	es,ds:[DATA32_Selector]
	jmp	d ds:[ebp+GD_Text_Handler]
;
PUBLIC C GDraw_Icon
GDraw_Icon:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[GD_Functions]
	mov	es,ds:[DATA32_Selector]
	jmp	d ds:[ebp+GD_Icon_Handler]

;
;
;
;   GOMEZ DRAWING ROUTINES  			               8bpp handlers
;
;
;
Drawing_Table8	LABEL DWORD
	dd OFFSET Box8
	dd OFFSET Border8
	dd OFFSET Line8
	dd OFFSET VLine8
	dd OFFSET HLine8
	dd OFFSET Text8
	dd OFFSET Bitmap8
	dd OFFSET Scaled_Bitmap8
	dd OFFSET Icon8
	dd OFFSET Mouse8
;
Box8:
	sub	ecx,10000h
	js	short @@End
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	mov	ebx,ecx			;EBX = Height | Width
	;
@@L1:   push	edi
	movzx	ecx,bx			;ECX = Width
	shr	ecx,1
	rep	stosw
	adc	cl,0
	rep	stosb
	pop	edi
	add	edi,ds:[GD_Frame_Line_Size]
	sub	ebx,10000h
	jns	short @@L1

@@End:  pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Border8:
	sub	ecx,30000h
	js	@@End
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	mov	ebx,ecx			;EBX = Height | Width
	;
	push	edi
	movzx	ecx,bx
	shr	ecx,1
	rep	stosw
	adc	cl,0
	rep	stosb
	pop	edi
	add	edi,ds:[GD_Frame_Line_Size]
	;
	movzx	ecx,bx			;ECX = Width
@@L1:   mov	ds:[edi],al
	mov	ds:[edi+ecx-1],al
	add	edi,ds:[GD_Frame_Line_Size]
	sub	ebx,10000h
	jns	short @@L1
	;
	shr	ecx,1
	rep	stosw
	adc	cl,0
	rep	stosb

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Line8:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
VLine8:
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	;
@@L1:   mov	ds:[edi],al
	add	edi,ds:[GD_Frame_Line_Size]
	dec	ecx
	jnz	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
HLine8:
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	;
	shr	ecx,1
	rep	stosw
	adc     cl,0
	rep	stosb

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Bitmap8:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Icon8:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Scaled_Bitmap8:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Text8 PROC NEAR
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	edx,ds:[ebx+4*edx]	;DL = colour
	;
@@L1:  	movzx 	eax,byte ptr ds:[ecx] 	;EAX = character
	test 	al,al
	jz 	short @@End
	fastimul esi,eax,12
	push	edi
	add 	esi,OFFSET FONT12

	mov 	dh,12
@@L2:	lods 	byte ptr ds:[esi]   	;AL  = Font-Bits
	counter=7
	REPT	8
	  LOCAL NEXT
	  test	al,1 shl counter
	  jz	short NEXT
	  mov 	byte ptr ds:[edi+7-counter],dl
	  counter=counter-1
     NEXT:
	ENDM

	add 	edi,ds:[GD_Frame_Line_Size]
	dec 	dh
	jnz 	short @@L2

	pop	edi
	inc 	ecx
	add	edi,8
	jmp 	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
Text8 ENDP
;
Mouse8:
	and	edx,0ffh
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	ebx,ds:[ebx+4*edx]	;EBX = colour
	;
	mov 	esi,ecx	   		;ESI = DATA32 ptr to mouse mask
	mov 	dh,15                 	;DH  = Mask height
@@L1:   lods 	dword ptr ds:[esi]	;AL  = one row of mask
	mov 	dl,16			;DL  = mask width
@@L2:   rol 	eax,2
	mov 	bl,al
	and 	bl,11b			;BL  = 2 mouse bits
	jz 	short @@NoP
	cmp 	bl,10b
	ja 	short @@Invert
	je 	short @@White
		mov 	byte ptr ds:[edi],0
		jmp 	short @@Nop
@@Invert:	xor 	byte ptr ds:[edi],0ffh
		jmp 	short @@Nop
@@White:	mov 	byte ptr ds:[edi],bh
@@Nop:	inc 	edi
	dec 	dl
	jnz 	short @@L2

	add 	edi,ds:[GD_Frame_Line_Size]
	sub	edi,16
	dec 	dh
	jnz 	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

;
;
;
;   GOMEZ DRAWING ROUTINES  			               16bpp handlers
;
;
;
Drawing_Table16	LABEL DWORD
	dd OFFSET Box16
	dd OFFSET Border16
	dd OFFSET Line16
	dd OFFSET VLine16
	dd OFFSET HLine16
	dd OFFSET Text16
	dd OFFSET Bitmap16
	dd OFFSET Scaled_Bitmap16
	dd OFFSET Icon16
	dd OFFSET Mouse16
;
Box16:
	sub	ecx,10000h
	js	short @@End
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	mov	ebx,ecx			;EBX = Height | Width
	;
@@L1:   push	edi
	movzx	ecx,bx			;ECX = Width
	shr	ecx,1
	rep	stosd
	adc	cl,0
	rep	stosw
	pop	edi
	add	edi,ds:[GD_Frame_Line_Size]
	sub	ebx,10000h
	jns	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Border16:
	sub	ecx,30000h
	js	@@End
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	mov	ebx,ecx			;EBX = Height | Width
	;
	push	edi
	movzx	ecx,bx
	shr	ecx,1
	rep	stosd
	adc	cl,0
	rep	stosw
	pop	edi
	add	edi,ds:[GD_Frame_Line_Size]
	;
	movzx	ecx,bx			;ECX = Width
@@L1:  	mov	ds:[edi],ax
	mov	ds:[edi+2*ecx-2],ax
	add	edi,ds:[GD_Frame_Line_Size]
	sub	ebx,10000h
	jns	short @@L1
	;
	shr	ecx,1
	rep	stosd
	adc	cl,0
	rep	stosw

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Line16:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
VLine16:
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	;
@@L1:   mov	ds:[edi],ax
	add	edi,ds:[GD_Frame_Line_Size]
	dec	ecx
	jnz	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
HLine16:
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	;
	shr	ecx,1
	rep	stosd
	adc     cl,0
	rep	stosw

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Bitmap16:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Icon16:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Scaled_Bitmap16:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Text16 PROC NEAR
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	edx,ds:[ebx+4*edx]	;DX = colour
	;
@@L1:  	movzx 	eax,byte ptr ds:[ecx] 	;EAX = character
	test 	al,al
	jz 	short @@End
	fastimul esi,eax,12
	push	edi
	add 	esi,OFFSET FONT12

	mov 	ah,12
@@L2:	lods 	byte ptr ds:[esi]   	;AL  = Font-Bits
	counter=7
	REPT	8
	  LOCAL NEXT
	  test	al,1 shl counter
	  jz	short NEXT
	  mov 	word ptr ds:[edi+14-2*counter],dx
	  counter=counter-1
     NEXT:
	ENDM

	add 	edi,ds:[GD_Frame_Line_Size]
	dec 	ah
	jnz 	short @@L2

	pop	edi
	inc 	ecx
	add	edi,16
	jmp 	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
Text16 ENDP
;
Mouse16:
	and	edx,0ffh
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	ebp,ds:[ebx+4*edx]	;EBP = colour
	;
	mov 	esi,ecx	   		;ESI = DATA32 ptr to mouse mask
	mov 	dh,15                 	;DH  = Mask height
@@L1:   lods 	dword ptr ds:[esi]	;AL  = one row of mask
	mov 	dl,16			;DL  = mask width
@@L2:   rol 	eax,2
	mov 	bl,al
	and 	bl,11b			;BL  = 2 mouse bits
	jz 	short @@NoP
	cmp 	bl,10b
	ja 	short @@Invert
	je 	short @@White
		mov 	w ds:[edi],0
		jmp 	short @@Nop
@@Invert:	xor 	w ds:[edi],0ffffh
		jmp 	short @@Nop
@@White:	mov 	w ds:[edi],bp
@@Nop:	inc 	edi
	dec 	dl
	jnz 	short @@L2

	add 	edi,ds:[GD_Frame_Line_Size]
	sub	edi,32
	dec 	dh
	jnz 	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn


;
;
;
;   GOMEZ DRAWING ROUTINES  			               32bpp handlers
;
;
;
Drawing_Table32	LABEL DWORD
	dd OFFSET Box32
	dd OFFSET Border32
	dd OFFSET Line32
	dd OFFSET VLine32
	dd OFFSET HLine32
	dd OFFSET Text32
	dd OFFSET Bitmap32
	dd OFFSET Scaled_Bitmap32
	dd OFFSET Icon32
	dd OFFSET Mouse32
;
Box32:
	sub	ecx,10000h
	js	short @@End
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	mov	ebx,ecx			;EBX = Height | Width
	;
@@L1:   push	edi
	movzx	ecx,bx			;ECX = Width
	rep	stosd
	pop	edi
	add	edi,ds:[GD_Frame_Line_Size]
	sub	ebx,10000h
	jns	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Border32:
	sub	ecx,30000h
	js	@@End
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	mov	ebx,ecx			;EBX = Height | Width
	;
	push	edi
	movzx	ecx,bx
	rep	stosd
	pop	edi
	add	edi,ds:[GD_Frame_Line_Size]
	;
	movzx	ecx,bx			;ECX = Width
@@L1:	mov	ds:[edi],eax
	mov	ds:[edi+4*ecx-4],eax
	add	edi,ds:[GD_Frame_Line_Size]
	sub	ebx,10000h
	jns	short @@L1
	;
	rep	stosd

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Line32:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
VLine32:
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	;
@@L1:   mov	ds:[edi],ax
	add	edi,ds:[GD_Frame_Line_Size]
	dec	ecx
	jnz	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
HLine32:
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	eax,ds:[ebx+4*edx]	;EAX = colour
	;
	rep	stosd

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Bitmap32:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Icon32:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Scaled_Bitmap32:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Text32 PROC NEAR
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	edx,ds:[ebx+4*edx]	;EDX = colour
	;
@@L1:	movzx 	eax,byte ptr ds:[ecx] 	;EAX = character
	test 	al,al
	jz 	short @@End
	fastimul esi,eax,12
	push	edi
	add 	esi,OFFSET FONT12

	mov 	ah,12
@@L2:	lods 	byte ptr ds:[esi]   	;AL  = Font-Bits
	counter=7
	REPT	8
	  LOCAL NEXT
	  test	al,1 shl counter
	  jz	short NEXT
	  mov   d ds:[edi+28-4*counter],edx
	  counter=counter-1
     NEXT:
	ENDM

	add 	edi,ds:[GD_Frame_Line_Size]
	dec 	ah
	jnz 	short @@L2

	pop	edi
	inc 	ecx
	add	edi,32
	jmp 	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
Text32 ENDP
;
Mouse32:
	and	edx,0ffh
	mov	edi,eax
	movzx	eax,bx
	shr	ebx,16
	imul	ebx,ds:[GD_Frame_Line_Size]
	add	edi,ebx
	mov	ebx,ds:[GD_Colour_LUT]	;ES:EBX = ptr to colour LUT
	add	edi,eax			;ES:EDI = first pixel
	mov	ebp,ds:[ebx+4*edx]	;EBP = colour
	;
	mov 	esi,ecx	   		;ESI = DATA32 ptr to mouse mask
	mov 	dh,15                 	;DH  = Mask height
@@L1:   lods 	dword ptr ds:[esi]	;AL  = one row of mask
	mov 	dl,16			;DL  = mask width
@@L2:   rol 	eax,2
	mov 	bl,al
	and 	bl,11b			;BL  = 2 mouse bits
	jz 	short @@NoP
	cmp 	bl,10b
	ja 	short @@Invert
	je 	short @@White
		mov 	d ds:[edi],0
		jmp 	short @@Nop
@@Invert:	xor 	d ds:[edi],0ffffffffh
		jmp 	short @@Nop
@@White:	mov 	d ds:[edi],ebp
@@Nop:	inc 	edi
	dec 	dl
	jnz 	short @@L2

	add 	edi,ds:[GD_Frame_Line_Size]
	sub	edi,64
	dec 	dh
	jnz 	short @@L1

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn


;
;
;
;   GOMEZ DRAWING ROUTINES  			               24bpp handlers
;
;
;
Drawing_Table24	LABEL DWORD
	dd OFFSET Box24
	dd OFFSET Border24
	dd OFFSET Line24
	dd OFFSET VLine24
	dd OFFSET HLine24
	dd OFFSET Text24
	dd OFFSET Bitmap24
	dd OFFSET Scaled_Bitmap24
	dd OFFSET Icon24
	dd OFFSET Mouse24
;
Box24:
Border24:
Line24:
VLine24:
HLine24:
Text24:
Bitmap24:
Scaled_Bitmap24:
Icon24:
Mouse24:
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn


include font12.inc
code32 ends
END