;͸
;                                                                          
; (c) 1996 by Marc van Shaney , aka Kaya Memisoglu                         
;                                                                          
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	    
; You may use the whole code or only parts of it in your own programs      
; whether they are commercial or not. BUT you must give credits for these  
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                       
; I am not responsible for any damage or loss caused by this program, so   
; if you success in erasing your harddisk with this code, then it is your  
; own fault and you should not claim me to be responsible...               
; I would be very pleased if you also sent me a postcard or even a letter  
; if you can use this code. My address:                                    
;                                                                          
;        Kaya Memisoglu                                                    
;        Reichenberger Ring 50                                             
;        63512 Hainburg                                                    
;        Germany                                                           
;	                                                                    
;	  Internet: memisogl@stud.uni-frankfurt.de                          
;                                                                          
; You can also leave a message for Marc van Shaney on the Nirvana BBS:     
;                                                                          
;              Nirvana BBS     ++49-(0)6245-3056      Sysop:Raytrayza      
;                                                                          
;                                                                          
;;
;
;
;   GOMEZ MUSIC INTERFACE                               MAIN-HEADERS ETC...
;
GMI_MAX_CHANNELS		equ	32
GMI_BOOST_BITS			equ	13
GMI_BOOST_SIZE			equ	(1 shl GMI_BOOST_BITS)


;
;   GOMEZ MUSIC INTERFACE                               MAIN-HEADERS ETC...
;
GMI_SAMPLE STRUC			;64 bytes / Sample
	SMP_FLAGS		dd	?
	SMP_NAME		db	32 dup (?)
	SMP_SIZE		dd	?
	SMP_LOOP_START   	dd	?
	SMP_LOOP_END		dd	?
	SMP_VOLUME		db	?
	SMP_PANNING		db	?
	SMP_RESERVED		dw	?
	SMP_RESAMPLE		dd	?
	SMP_ADDRESS		dd	?
	SMP_HANDLE		dd	?
	ENDS

GMI_INSTRUMENT STRUC
	INS_FLAGS			dd	?
	INS_NAME			db	32 dup (?)
	INS_AVIB			LABEL DWORD
	INS_AVIB_SWEEP			db	?
	INS_AVIB_FORM			db	?
	INS_AVIB_SPEED			db	?
	INS_AVIB_DEPTH			db	?
	INS_FADE_OUT			dd	?
	INS_VENVELOPE			LABEL BYTE
	INS_VENVELOPE_SIZE		dw	?
	INS_VENVELOPE_SUSTAIN		dw	?
	INS_VENVELOPE_LOOP_START	dw	?
	INS_VENVELOPE_LOOP_END		dw	?
	INS_VENVELOPE_POINTS		dd	12 dup (?)
	INS_PENVELOPE			LABEL BYTE
	INS_PENVELOPE_SIZE		dw	?
	INS_PENVELOPE_SUSTAIN		dw	?
	INS_PENVELOPE_LOOP_START	dw	?
	INS_PENVELOPE_LOOP_END		dw	?
	INS_PENVELOPE_POINTS		dd	12 dup (?)
	INS_SAMPLE_NOTES		db      96 dup (?)
	INS_SAMPLES			db	16*SIZE GMI_SAMPLE dup (?)
	ENDS

GMI_SONG_HEADER STRUC
	SNG_FLAGS		dd	?
	SNG_CHANNEL_COUNT	dd	?
	SNG_CHANNEL_MAP		db	32 dup (?)
	SNG_ORDER_COUNT		dd	?
	SNG_RESTART_POSITION	dd	?
	SNG_START_SPEED		dd	?
	SNG_START_TEMPO		dd	?
	SNG_START_VOLUME	dd	?
	SNG_TICK_SPEED		dd	?
	SNG_PATTERN_PTR		dd	256 dup (?)
	SNG_INSTRUMENT_PTR	dd	256 dup (?)
	SNG_ORDER_LIST		db	256 dup (?)
	SNG_NAME		db	64 dup (?)
	ENDS

GMI_CHANNEL_INFO STRUC
	CI_FLAGS		dd	?
	CI_INSTRUMENT_NUMBER	dd	?
	CI_INSTRUMENT_ADDRESS	dd	?
	CI_SAMPLE_ADDRESS	dd	?
	CI_RESAMPLE		dd	?

	CI_COMMAND		dd	6 dup (?)

	CI_PERIOD		dd	?
	CI_DST_PERIOD		dd	?
	CI_PERIOD_SLIDE		dd	?
	CI_ARP1			dd	?
	CI_ARP2			dd	?
	CI_ARP3			dd	?
	CI_VOLUME		db	?
	CI_VOLUME_SLIDE		db	?
	CI_PANNING		db	?
	CI_ENVELOPE_VOLUME	db	?
	CI_ENVELOPE_PANNING	db	?

	CI_AVIB			LABEL DWORD
	CI_AVIB_SWEEP		db	?
	CI_AVIB_FORM		db	?
	CI_AVIB_SPEED		db	?
	CI_AVIB_DPETH		db	?
	CI_AVIB_POS		db	?

	CI_VIB_POS		db	?
	CI_VIB_DEPTH		db	?
	CI_VIB_SPEED		db	?
	CI_VIB_FORM		db	?

	CI_TRM_VOLUME		db	?
	CI_TRM_POS		db	?
	CI_TRM_ON		LABEL BYTE
	CI_TRM_DEPTH		db	?
	CI_TRM_OFF		LABEL BYTE
	CI_TRM_SPEED		db	?
	CI_TRM_FORM		db	?

	CI_ARPEGGIO_POS		LABEL BYTE
	CI_CUT_POS		LABEL BYTE
	CI_TRG_POS		db	?
	CI_TRG_SPEED		db	?
	CI_TRG_VOLUME		db	?
	CI_PAN_SPEED		db	?
	CI_NOTE_DELAY		db	?

	ALIGN DWORD
	CI_FADE_OUT		dd	?
	CI_FADE_POS		dd	?

	CI_VENVELOPE_POS	dd	?
	CI_PENVELOPE_POS	dd	?
	ENDS

GMI_MIXING_INFO STRUC				;36 bytes/entry
	MI_FLAGS		dd	?
	MI_ADDRESS		dd	?
	MI_LOOP_START		dd	?
	MI_LOOP_END		dd	?
	MI_POSITION		dd	?,?
	MI_INCREMENT		dd	?
	MI_MAX_ECX		dd	?
	MI_VOLUME_L             db	?
	MI_VOLUME_R		db	?
				dw	?
	ENDS
;
;   GOMEZ MUSIC INTERFACE                               FLAG-DEFINITIONS
;
;
;
; Now follow all flags for the instruments
;
FL_PLAY_CHANNEL			equ	1
FL_VOLUME_ENVELOPE		equ	2
FL_VOLUME_ENVELOPE_SUSTAIN	equ	4
FL_VOLUME_ENVELOPE_LOOP		equ	8
FL_PANNING_ENVELOPE		equ	10h
FL_PANNING_ENVELOPE_SUSTAIN	equ	20h
FL_PANNING_ENVELOPE_LOOP	equ	40h
FL_LOOP				equ	80h		;*
FL_PINGPONG_LOOP		equ	100h            ;*
FL_USE_PANNING			equ	200h
FL_16BIT        		equ	400h            ;*
FL_STEREO			equ	800h		;*
FL_GLISSANDO_CTRL		equ	1000h
FL_NEW_INSTRUMENT		equ	2000h
FL_FULL_INSTRUMENT		equ	1000000h
FL_UNUSED_SAMPLE		equ	2000000h	;*

;
;
; These are the flags, that can be set when calling GMI_Play_Song
;
GMI_WAVE_DRIVER		equ	100000h
GMI_SOUND_DRIVER	equ	200000h
GMI_TIMER_MODE		equ	400000h
GMI_BREAK_FLAG		equ	800000h
GMI_BUFFER_READY_FLAG	equ	1000000h
GMI_BUSY		equ	2000000h
GMI_FIRST_TICK		equ	4000000h
GMI_PLAYING_FLAG	equ	8000000h
GMI_LOW_DMA_BUFFER	equ	10000000h

GMI_FORCE_8BIT_SAMPLES	equ	4000h
GMI_SIGNED_DATA		equ	2000h
GMI_MIX_ALWAYS		equ	1000h
GMI_USE_REVERB		equ	800h
GMI_USE_POLLING		equ	400h
GMI_SUPPORT_INT8	equ	200h
GMI_USE_16BIT		equ	100h
GMI_USE_STEREO		equ	80h
GMI_QUALITY_MODE	equ	40h
GMI_AMIGA_FREQUENCY	equ	4
GMI_LINEAR_FREQUENCY	equ	2
GMI_LOOP_FLAG		equ	1


REVERB_ECHO STRUC
	FEEDBACK	DD	?
	GAIN		DD	?
REVERB_ECHO ENDS


REVERB_INFO STRUC
	RVB_COUNT	DD	?
	RVB1	REVERB_ECHO	<?,?>
	RVB2	REVERB_ECHO	<?,?>
	RVB3	REVERB_ECHO	<?,?>
	RVB4	REVERB_ECHO	<?,?>
	RVB5	REVERB_ECHO	<?,?>
	RVB6	REVERB_ECHO	<?,?>
	RVB7	REVERB_ECHO	<?,?>
	RVB8	REVERB_ECHO	<?,?>
REVERB_INFO ENDS

;
;   GOMEZ MUSIC INTERFACE                                  OPCODES
;
OC_NOTHING			equ	0
OC_PLAY_NOTE			equ	1
OC_NEW_INSTRUMENT		equ	2
OC_PLAY_PERIOD			equ	3
OC_NOTE_OFF			equ	4
OC_RESET_INSTRUMENT		equ	5
OC_SET_NOTE			equ	6
OC_SET_PERIOD			equ	7
OC_PARAMETER			equ	8
OC_ARPEGGIO			equ	9
OC_PORTA_UP			equ	10
OC_PORTA_DOWN			equ	11
OC_TONE_PORTA			equ	12
OC_VIBRATO			equ	13
OC_PORTA_AND_VOLUME_SLIDE	equ	14
OC_VIBRATO_AND_VOLUME_SLIDE     equ	15
OC_TREMOLO                      equ	16
OC_SET_PANNING                  equ	17
OC_SET_SAMPLE_OFFSET            equ	18
OC_VOLUME_SLIDE                 equ	19
OC_POSITION_JUMP                equ	20
OC_SET_VOLUME                   equ	21
OC_PATTERN_BREAK                equ	22
OC_SET_TEMPO                    equ	23
OC_SET_SPEED                    equ	24
OC_SET_GLOBAL_VOLUME            equ	25
OC_GLOBAL_VOLUME_SLIDE          equ	26
OC_KEY_OFF                      equ	OC_NOTE_OFF
OC_SET_ENVELOPE_POSITION        equ	27
OC_PANNING_SLIDE		equ	28
OC_MULTI_RETRIGGER		equ	29
OC_TREMOR			equ	30
OC_EXTRA_FINE_SLIDE_UP		equ	31
OC_EXTRA_FINE_SLIDE_DOWN	equ	32
OC_FINE_SLIDE_UP		equ	33
OC_FINE_SLIDE_DOWN		equ	34
OC_SET_GLISSANDO		equ	35
OC_SET_VIBRATO			equ	36
OC_SET_FINETUNE			equ	37
OC_PATTERN_LOOP			equ	38
OC_SET_TREMOLO			equ	39
OC_RETRIGGER			equ	40
OC_FINE_VOLUME_SLIDE_UP		equ	41
OC_FINE_VOLUME_SLIDE_DOWN	equ	42
OC_NOTE_CUT			equ	43
OC_NOTE_DELAY			equ	44
OC_PATTERN_DELAY		equ	45
OC_SET_FILTER			equ	46
OC_INVERT_LOOP			equ	47
OC_FINE_VIBRATO			equ	48
OC_NEW_NOTE_AND_INSTRUMENT	equ	49
OC_TRAELLER			equ	50
OC_REVERSE_SAMPLE		equ	51

OC_SLIDE_DOWN			equ	OC_PORTA_DOWN
OC_SLIDE_UP			equ	OC_PORTA_UP
OC_TONE_PORTAMENTO		equ	OC_TONE_PORTA



OC_SET_CHANNEL			equ	128
OC_SET_DIRECT_VOLUME		equ	160


;
;   GOMEZ MUSIC INTERFACE                                FILE-HEADERS
;
;
;
; The following structure is for XM-Songs only
;
XM_MAIN_HEADER STRUC
	XM_MAGIC		db	17 dup (?)
	XM_NAME			db	20 dup (?)
	XM_EOF			db	1ah
	XM_TRACKER		db	20 dup (?)
	XM_VERSION		dw	?
	XM_HEADER_SIZE		dd	?
	XM_ENTRY_COUNT		dw	?
	XM_RESTART_POSITION     dw	?
	XM_CHANNEL_COUNT	dw	?
	XM_PATTERN_COUNT	dw	?
	XM_INSTRUMENT_COUNT	dw	?
	XM_FLAGS		dw	?
	XM_START_SPEED		dw	?
	XM_START_TEMPO		dw	?
	ENDS
XM_INSTRUMENT_MAIN_HEADER STRUC
	XM_INST_SIZE		dd	?
	XM_INST_NAME		db	22 dup (?)
	XM_INST_TYPE		db	?
	XM_INST_SAMPLE_COUNT	dw	?
	XM_INST_SAMPLE_HEADER_SIZE	dd	?
	ENDS
XM_INSTRUMENT_SUB_HEADER STRUC
	XM_INST_SAMPLE_NOTES		db	96 dup (?)
	XM_INST_VOLUME_ENVELOPE		db	48 dup (?)
	XM_INST_PANNING_ENVELOPE        db	48 dup (?)
	XM_INST_VE_COUNT		db	?
	XM_INST_PE_COUNT		db	?
	XM_INST_VE_SUSTAIN		db	?
	XM_INST_VE_LOOP_START		db	?
	XM_INST_VE_LOOP_END		db	?
	XM_INST_PE_SUSTAIN		db	?
	XM_INST_PE_LOOP_START		db	?
	XM_INST_PE_LOOP_END		db	?
	XM_INST_VE_TYPE			db	?
	XM_INST_PE_TYPE			db	?
	XM_INST_AVIB_TYPE		db	?
	XM_INST_AVIB_SWEEP		db	?
	XM_INST_AVIB_DEPTH		db	?
	XM_INST_AVIB_SPEED		db	?
	XM_INST_FADE_OUT		dw	?
	XM_INST_RESERVED		db	22 dup (?)
	ENDS
;
;
; The following structure is for MOD-Songs only
;
MOD_INSTRUMENT_HEADER STRUC
	MOD_INST_NAME			db 22 dup (?)
	MOD_INST_SIZE			dw ?
	MOD_INST_FINETUNE		db ?
	MOD_INST_VOLUME			db ?
	MOD_INST_LOOP_START		dw ?
	MOD_INST_LOOP_SIZE		dw ?
	ENDS

MOD4_MAGIC_1		equ	2e4b2e4dh
MOD4_MAGIC_2		equ	214b264dh
MOD4_MAGIC_3		equ	34544c46h
MOD8_MAGIC_1		equ	38544c46h
MOD_MAGIC_CH		equ     4843h
MOD_MAGIC_HN		equ     4e48h


;
;
; The following structure is for S3M-Songs only
;
S3M_MAIN_HEADER STRUC
	S3M_NAME		db	1ch dup (?)
				db	?
	S3M_TYPE		db	?
				db	?,?
	S3M_ORDER_COUNT         dw	?
	S3M_INSTRUMENT_COUNT	dw	?
	S3M_PATTERN_COUNT	dw	?
	S3M_FLAGS		dw	?
	S3M_ST3_VERSION		dw	?
	S3M_SAMPLE_FORMAT	dw	?
	S3M_MAGIC		dd	?
	S3M_GLOBAL_VOLUME	db	?
	S3M_START_SPEED		db	?
	S3M_START_TEMPO		db	?
	S3M_MASTER_VOLUME	db	?
				db	?,?,?,?,?,?,?,?,?,?
				dw	?
	S3M_CHANNEL_MAP		db	32 dup (?)
	ENDS
S3M_INSTRUMENT_HEADER STRUC
	S3M_INST_TYPE		db 	?
	S3M_INST_FILE_NAME	db	12 dup (?)
	S3M_INST_ADDRESS	db	3 dup (?)
	S3M_INST_SIZE		dd	?
	S3M_INST_LOOP_START	dd	?
	S3M_INST_LOOP_END	dd	?
	S3M_INST_VOLUME		db	?
				db	?
	S3M_INST_PACKING	db	?
	S3M_INST_FLAGS		db	?
	S3M_INST_RESAMPLE	dd	?
				dd	?
				dd	?
				dd	?
	S3M_INST_NAME		db	28 dup (?)
	S3M_INST_MAGIC		dd	?
	ENDS

;
;   GOMEZ MUSIC INTERFACE                           FUNCTION-DECLARATIONS
;
ifndef GMI_SYSTEM_FILE

extrn C Init_GMI:near
extrn C Exit_GMI:near
extrn C GMI_Free_Song:near
extrn C GMI_Play_Song:near
extrn C GMI_Stop_Song:near
extrn C GMI_Init_Song:near
extrn C GMI_Set_Volume:near
extrn C GMI_Position_Jump:near
extrn C GMI_Uncompress_Pattern:near
extrn C GMI_Compress_Pattern:near
extrn C GMI_Load_Song:near
extrn C GMI_Load_XM:near
extrn C GMI_Load_MOD:near
extrn C GMI_Load_STM:near
extrn C GMI_Load_S3M:near
extrn C GMI_Load_MTM:near
extrn C GMI_Load_669:near
extrn C GMI_Load_FAR:near
extrn C GMI_Load_ULT:near



extrn C GMI_Pattern_No:dword
extrn C GMI_Beat_No:dword
extrn C GMI_Entry_No:dword
extrn C GMI_Row_Address:dword
extrn C GMI_Mixing_Buffer:dword
extrn C GMI_Mixing_Size:dword
extrn C GMI_Flags:dword
extrn C GMI_Channel_Flags:dword
extrn C GMI_Channel_Data:GMI_CHANNEL_INFO
extrn C GMI_Volume:dword
extrn C GMI_Channels:dword
extrn C GMI_Tick:dword
extrn C GMI_Speed:dword
extrn C GMI_Tempo:dword
extrn C GMI_Song:dword
extrn C GMI_Tick_Speed:dword
extrn C GMI_Play_Frequency:dword
extrn C GMI_Poll_Counter:dword
extrn C GMI_Reverb:REVERB_INFO

endif