;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P386
LOCALS
_DEVICE_SYSTEM_FILE	equ	1


;
;
;
;   GOMEZ GRAVIS ULTRASOUND DRIVER
;
;
;
CODE32	segment para public use32
	assume cs:code32, ds:code32
	largestack

include gomez.inc
include devices.inc
ALIGN 4
PUBLIC C GUS_Driver
GUS_Driver LABEL BYTE
	db	"WAVE",0,0,0,0			;8 bytes driver-type
	dd	100h				;Version
	dd	?				;Reserved
	db	"UltraSound GF1  "		;Driver name

	dd      DRV_Init
	dd	DRV_Exit
	dd	DRV_Detect
	dd	Load_Sample
	dd	Free_Sample
	dd	Set_Sample
	dd	Set_Frequency
	dd	Set_Volume
	dd	Stop_Sample
	dd	Init_Mixer
	dd	Exit_Mixer
	dd	Run_Mixer
	dd	Set_Mixer_Handler
	dd	Set_Master_Volume
;
u_Base LABEL DWORD
GF1_Base	dd ?
GF1_DMA		dd ?
GF1_IRQ		dd ?
GF1_Voices	dd ?
GF1_Memory	dd ?
Old_IRQ		dd ?
Old_Real_IRQ	dd ?
u_Voice		dd ?
u_Command	dd ?
u_DataLo	dd ?
u_DataHi	dd ?
u_Status	dd ?
u_TimerControl  dd ?
u_TimerData	dd ?
Sample_Map	dd ?

ALIGN DWORD
Bank_Info	dd 4*8 dup (?)
Channel_MapL	db 32 dup (?)
Channel_MapP	db 32 dup (?)

;
;Sample_Info:
;	dword	flags
;	dword	address
;	dword	size
;	dword 	loop-start
;
;Channel_MapL:
;	byte	physical channel  or  0ffh
;
;Channel_MapP:
;	byte	flags: 20h  -  used channel
;		       40h  -  ramping down
;		       80h  -  unused channel
;
CHN_USED		equ	20h
CHN_RAMPING		equ	40h
CHN_UNUSED		equ	80h


Period_Factor 	dd	?

mt_VolTable	dw	00E00h,0A000h,0A800h,0AC00h,0AE00h,0B000h,0B400h,0B800h,0BC00h
		dw	0C000h,0C200h,0C400h,0C600h,0C800h,0CA00h,0CC00h,0CE00h
		dw	0D000h,0D100h,0D200h,0D300h,0D400h,0D500h,0D600h,0D700h
		dw	0D800h,0D900h,0DA00h,0DB00h,0DC00h,0DD00h,0DE00h,0DF00h
		dw	0E080h,0E100h,0E180h,0E200h,0E280h,0E300h,0E380h,0E400h
		dw	0E480h,0E500h,0E580h,0E600h,0E680h,0E700h,0E780h,0E800h
		dw	0E880h,0E900h,0E980h,0EA00h,0EA80h,0EB00h,0EB80h,0EC00h
		dw      0EC80h,0ED00h,0ED80h,0EE00h,0EE80h,0EF00h,0EF80h,0EFF0h

;
SET_VARS MACRO
	mov     ds:[u_Base],edx
	add     edx,102h
	mov     ds:[u_Voice],edx
	inc     edx
	mov     ds:[u_Command],edx
	inc     edx
	mov     ds:[u_DataLo],edx
	inc     edx
	mov     ds:[u_DataHi],edx
	mov     edx,ds:[u_Base]
	add     edx,6
	mov     ds:[u_Status],edx
	add     edx,2
	mov     ds:[u_TimerControl],edx
	inc     edx
	mov     ds:[u_TimerData],edx
	 ENDM
;
;   GUS driver                                             GF1-routines
;
;
;
; U_Delay:
;   Input:
;	Nothing
;   Output:
;	Nothing
;
;
; U_Peek:
;   Input:
;      ECX	- Address to read from
;   Output:
;	EAX	- byte read from memory
;
;
; U_Poke:
;   Input:
;	ECX	- Address to write to
;	EAX	- byte to send to memory
;   Output:
;	Nothing
;
;
; U_LoadSample:
;   Input:
;   	DS:ESI  - Max 256k sample to dump to RAM.
;   	EDI     - DRAM location to dump to.
;   	ECX     - Max bytes to dump.
;   Output:
;	Nothing
;
;
; U_Slide_Away:
;    Input:
;	Nothing
;    Output:
;	[CF]	- Set: Volume already 0
;
;
; U_SlideRamp:
;   Input:
; 	EBX   -   destination
; 	EAX   -   current volume
;   Output:
;	Nothing
;
;
; DSP_Init_Frequency:
;   Input:
; 	EBX	- play frequency (in Hz)
;   Output:
;	Nothing
;
U_Delay PROC NEAR
	push    edx eax
	mov     edx,300h
	in      al,dx
	in      al,dx
	in      al,dx
	in      al,dx
	in      al,dx
	in      al,dx
	in      al,dx
	pop     eax edx
	retn
U_Delay ENDP
;
u_Peek PROC NEAR
	push 	edx
	mov     edx,ds:[u_Command]
	mov     al,43h
	out     dx,al			;Send command to GF1
	inc     edx                    ;104h
	mov     eax,ecx			;EAX = peek address
	out     dx,ax
	dec     edx                     ;103h
	mov     al,44h
	out     dx,al
	add     dl,2
	shr	eax,16			;AX = high word
	out     dx,al                   ;Set whole address
	add     dl,2
	in      al,dx			;Read in byte
	pop 	edx
	retn
u_Peek ENDP
;
u_Poke PROC NEAR
	push 	edx
	push    eax
	mov     edx,ds:[u_Command]
	mov     al,43h
	out     dx,al
	inc     edx
	mov     eax,ecx
	out     dx,ax
	dec     edx
	mov     al,44h
	out     dx,al
	add     dl,2
	shr     eax,16
	out     dx,al
	add     dl,2
	pop     eax
	out     dx,al
	in      al,dx
	pop 	edx
	retn
u_Poke ENDP
;
u_LoadSample proc near
	cli
	cld
	mov     edx,ds:[u_Command]
	mov     al,44h
	out     dx,al
	add     edx,2
	mov     eax,edi
	shr 	eax,16
	out     dx,al
	sub     edx,2
@@MainLoop:
	mov     al,43h
	out     dx,al
	inc     edx
	mov     eax,edi
	out     dx,ax
	dec     edx
@@DumpByte:
	add     edx,4
	lodsb
	out     dx,al
	sub     edx,4
	add     di,1
	jnc     short @@DoLoop
	add	edi,10000h
	mov     al,44h
	out     dx,al
	add     edx,2
	mov     eax,edi
	shr 	eax,16
	out     dx,al
	sub     edx,2
@@DoLoop:
	dec 	ecx
	jnz    	short @@MainLoop
	sti
	retn
u_LoadSample endp
;
u_slideramp PROC NEAR
	shr     eax,8
	shr     ebx,8
	cmp     ax,bx
	jb 	short @@OK
	je 	short @@End
	xchg    ebx,eax
@@Ok:   pushfd
	push    eax
	mov     edx,ds:[u_Command]
	mov     al,6
	out     dx,al
	add     dl,2
	mov     al,00111111b		;Set rate
	out     dx,al
	sub     dl,2
	mov     al,7
	out     dx,al
	add     dl,2
	pop     eax
	out     dx,al			;Set start
	sub     dl,2
	mov     al,8
	out     dx,al
	add     dl,2
	mov     eax,ebx
	out     dx,al                   ;Set end
	xor	bl,bl
	popfd
	jb      short @@OK3
	or      bl,01000000b		;Ramp backwards
@@OK3:	mov     edx,ds:[u_Command]
	mov     al,0Dh
	out     dx,al
	add     dl,2
	mov     al,bl
	out     dx,al
	call	u_delay
	out	dx,al
@@End:	retn
u_slideramp endp
;
u_slide_away PROC NEAR
	mov     edx,ds:[u_Command]

	mov     al,0dh
	out     dx,al
	add     dl,2
	mov     al,3	              	;Stop ramping !
	out     dx,al
	call	u_delay
	out	dx,al

	sub     dl,2
	mov     al,89h
	out     dx,al
	inc     dl
	in      ax,dx
	cmp     ax,0f00h		;Already zero ???
	jb      short @@Zero
	mov	ebx,eax			;EBX=end volume (Bigger than 0)

	shr     ebx,8
	dec	dl
	mov     al,6
	out     dx,al
	add     dl,2
	mov     al,00111111b		;Set rate
	out     dx,al

	sub	dl,2
	mov     al,7
	out     dx,al
	add     dl,2
	mov 	al,0Eh
	out     dx,al			;Set start

	sub	dl,2
	mov     al,8
	out     dx,al
	add     dl,2
	mov     eax,ebx
	out     dx,al                   ;Set end

	sub	dl,2
	mov     al,0Dh
	out     dx,al
	add     dl,2
	mov     al,01100000b		;Set backwards & IRQ
	out     dx,al
	call	u_delay
	out	dx,al
	clc
	retn

@@Zero:	stc
	retn
U_Slide_away ENDP
;
;
;
;   GOMEZ GRAVIS ULTRASOUND DRIVER                        NICE HELPER MACROS
;
;
;
;
;
; uStop_Ramp
;   In:
;	Nothing
;
;
; uSet_Start
;   In:
;	EBX	- start address
;
;
; uSet_LoopStart
;   In:
;	EBX	- start address
;
;
; uSet_End
;   In:
;	EBX	- end address
;
;
; uSet_Control:
;   In:
;   	CL 	4   -   16bit data
;          	8   -   loop enabled
;         	16  -   bidirectional loop
;         	64  -   play backwards
;
;
; uGet_Control:
;   Out:
;	AL	- control flags
;
;
; uSet_Panning:
;   In:
;	BL	- pan position (0-255)
;
;
; uRamp_Volume:
;   In:
;	EBX	- new volume (0-64)
;
;
; uSet_Volume:
;   In:
;	EBX	- logarithmic volume
;
;
; uSet_Frequency:
;   In:
;	EAX	- frequency (8bit fixed point)
;
;
; uStop_Voice:
;   In:
;	Nothing
;
;
; uFind_Channel:
;   Out:
;	EDX	- number of free channel
;
uStop_Ramp MACRO
	mov     edx,ds:[u_Command]
	mov 	al,0dh		;Volume control
	out	dx,al
	add	dl,2
	mov	al,3		;Stop ramping
	out     dx,al
	call	u_delay
	out	dx,al
	ENDM
;
uSet_Start MACRO
	mov     edx,ds:[u_Command]
	mov     al,0ah
	out     dx,al
	inc     edx             ; 104h
	mov     eax,ebx		;EBX = start address
	shr 	eax,7
	out     dx,ax
	call	u_delay
	out	dx,ax
	dec     edx             ; 103h
	mov     al,0bh
	out     dx,al
	inc     edx              ; 104h
	mov     eax,ebx
	shl     eax,9
	out     dx,ax
	call	u_delay
	out	dx,ax
	ENDM
;
uSet_LoopStart MACRO
	mov     edx,ds:[u_Command]
	mov     al,2
	out     dx,al
	inc     edx             ; 104h
	mov 	eax,ebx
	shr 	eax,7
	out     dx,ax
	dec     edx              ; 103h
	mov     al,3
	out     dx,al
	inc     edx             ; 104h
	mov     eax,ebx
	shl     eax,9
	out     dx,ax
	ENDM
;
uSet_End MACRO
	mov     edx,ds:[u_Command]
	mov     al,4
	out     dx,al
	inc     edx             ; 104h
	mov 	eax,ebx
	shr	eax,7
	out     dx,ax
	dec     edx             ; 103h
	mov     al,5
	out     dx,al
	inc     edx             ; 104h
	mov 	eax,ebx
	shl     eax,9
	out     dx,ax
	ENDM
;
uSet_Control MACRO
	mov     edx,ds:[u_Command]
	xor     al,al
	out     dx,al
	add     dl,2
	mov     al,cl
	out     dx,al
	call 	u_delay
	out	dx,al
	ENDM
;
uGet_Control MACRO
	mov     edx,ds:[u_Command]
	mov	al,80h
	out     dx,al
	add     dl,2
	in      al,dx
	ENDM
;
uSet_Panning MACRO
	mov     edx,ds:[u_Command]
	mov     al,0ch
	out     dx,al
	add     dl,2
	mov     al,bl
	shr 	al,4
	out     dx,al
	ENDM
;
uSet_Volume MACRO
	local   Done
	mov     edx,ds:[u_Command]

	mov     al,0dh
	out     dx,al
	add     dl,2
	mov     al,3	              	;Stop ramping !
	out     dx,al

	sub     dl,2
	mov     al,89h
	out     dx,al
	inc     dl
	in      ax,dx
	cmp     ax,bx
	je      short Done

	dec 	dl
	mov	al,9h
	out 	dx,al
	inc	dl
	mov	eax,ebx
	out	dx,ax
	call 	u_delay
	out	dx,ax
Done:	ENDM
;
uClear_Volume MACRO
	mov     edx,ds:[u_Command]

	mov	al,9h
	out 	dx,al
	inc	dl
	xor	eax,eax
	out	dx,ax
	call 	u_delay
	out	dx,ax
	ENDM
;
uRamp_Volume MACRO
	mov     edx,ds:[u_Command]

	mov 	bx,ds:[mt_VolTable+2*ebx]
	mov     al,89h
	out     dx,al
	inc     edx
	in      ax,dx
	call    u_slideramp
	ENDM
;
;
;Sets a new frequency
; fc = (unsigned int)(((speed_khz<<10L)+divisor) / divisor);
; EAX - frequency
;
uSet_Frequency MACRO
	local	done
	shl 	eax,2
	xor 	edx,edx
	add	eax,ds:[Period_Factor]
	idiv 	ds:[Period_Factor]
	and	al,NOT 1
	mov 	ebx,eax
	mov     edx,ds:[u_Command]
	mov     al,81h
	out     dx,al
	inc     edx
	in      ax,dx
	cmp     ax,bx
	je      short done
	dec     edx
	mov     al,1
	out     dx,al
	inc     edx
	mov     eax,ebx
	out     dx,ax
done:
	ENDM
;
uStop_Voice MACRO
	mov     edx,ds:[u_Command]
	xor	eax,eax
	out     dx,al
	add     dl,2
	mov     al,3
	out     dx,al
	call	u_delay
	out	dx,al
	ENDM
;
uFind_Channel MACRO
	local	L1,L2,E,E2
	mov	edx,ds:[GF1_Voices]
	dec	edx
L1:	test	ds:[Channel_MapP+edx],CHN_UNUSED	;Is channel free ???
	jnz	short E
	dec	edx
	jns	short L1
	;
	mov	edx,ds:[GF1_Voices]
	dec	edx
L2:	test	ds:[Channel_MapP+edx],CHN_RAMPING	;Is channel ramping down ???
	jnz	short E
	dec	edx
	jns	short L2
E:      ENDM

;
;
;
;   GOMEZ GRAVIS ULTRASOUND DRIVER                        DRIVER ROUTINES
;
;
;
;
;
; First some init/exit/detect routines
;
EnvString		db	"ULTRASND=~",0
DRV_Init:
	push	ds
	push	es
	push	edi
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	;
	cld
	mov	ecx,4*8				;For 8MB board
	mov 	eax,32
	mov	edi,OFFSET Bank_Info
	rep	stosd
	;
	mov	ecx,256*16
	call	Malloc
	jc	@@Err
	mov	ds:[Sample_Map],eax
	mov	edi,eax            		;EDI = ptr to sample-info

	mov	ecx,256				;ECX = Sample-counter
@@L1:	mov	ds:[edi],FL_UNUSED_SAMPLE	;Set this sample as free
	add	edi,16
	dec	ecx
	jnz	short @@L1
	;
	cli
	mov 	eax,ds:[GF1_IRQ]
	call	Get_FLat_IRQ
	mov	ds:[Old_IRQ],eax
	mov 	eax,ds:[GF1_IRQ]
	call	Link_Real_IRQ
	mov	ds:[Old_Real_IRQ],ebx	;EBX = old real-mode proc
	mov 	eax,ds:[GF1_IRQ]
	call	Unlink_Real_IRQ
	sti
	;
	clc
@@Err:  pop	edi
	pop	es
	pop	ds
	retn
;
DRV_Exit:
	push	ds
	mov	ds,cs:[DATA32_Selector]
	;
	cli
	mov     edx,ds:[u_Base]
	mov     al,00001011b
	out     dx,al

	mov     edx,ds:[u_Command]
	mov     al,4Ch
	out     dx,al
	add     dl,2
	mov     al,1			;Turn off IRQ,DAC
	out     dx,al
	;
	mov	eax,ds:[GF1_IRQ]
	call	Disable_IRQ
	mov 	eax,ds:[GF1_IRQ]
	mov 	ebx,ds:[Old_IRQ]
	call	Set_Flat_IRQ
	mov 	eax,ds:[GF1_IRQ]
	mov 	ebx,ds:[Old_Real_IRQ]
	call	Unlink_Real_IRQ
	sti
	;
	mov	ecx,ds:[Sample_Map]
	call	Free
	;
	pop	ds
	retn
;
DRV_Detect:
	push	ds
	push	es
	push 	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	eax,OFFSET EnvString
	call	Scan_Environment
	jc      @@Not_Found
	lea	esi,[eax+9]			;DS:ESI = ptr to variable-contents
	;
	xor 	edx,edx				;Clear thing
	xor 	eax,eax
	mov	ah,1				;AH = Variable-Counter
@@Scan_Loop:	lodsb
		test 	al,al			;Terminating 0 ???
		jz 	short @@Found
		cmp 	al,32
		je 	short @@Scan_Loop	;Is it a silly space ?
		cmp	al,','
		je	short @@Save_Numba
		cmp	al,'0'
		jb	short @@Scan_Loop
		cmp	al,'9'
		ja	short @@Scan_Loop
		sub	al,'0'
		shl	edx,4
		or 	dl,al
		jmp	short @@Scan_Loop
@@Save_Numba:	cmp	ah,2
		jb	short @@Save_Base
		je	short @@Save_DMA
		cmp	ah,4
		je	short @@Save_IRQ
		xor	edx,edx
		inc	ah
		jmp	short @@Scan_Loop
@@Save_Base:	mov	ds:[GF1_Base],edx
		xor	edx,edx
		inc	ah
		jmp	short @@Scan_Loop
@@Save_DMA:	mov	ds:[GF1_DMA],edx
		xor	edx,edx
		inc	ah
		jmp	short @@Scan_Loop
@@Save_IRQ:     cmp	dl,9
		jbe	short @@1
		sub	edx,16-10
@@1:            mov	ds:[GF1_IRQ],edx
		xor	edx,edx
		inc	ah
		jmp	short @@Scan_Loop
	;
@@Found:;
	;Now lets check how much memory is on board
	;
	mov	edx,ds:[GF1_Base]
	SET_VARS
	mov 	edx,ds:[u_Command]
	mov 	al,4Ch          	;Reset
	out 	dx,al
	add 	edx,2          		; 105h
	mov 	al,1
	out 	dx,al			;Turn off reset

	call 	u_delay
	call 	u_delay

	xor 	eax,eax			;Poke 00 to 0000:0000
	xor 	ecx,ecx
	call 	u_Poke

	mov 	edi,1			;Counter
@@GUSSize:	xor 	ecx,ecx
		call 	u_Peek		;Get value from 0000:0000
		test 	al,al
		jnz 	short @@Got

		mov 	ecx,edi
		shl 	ecx,10		;ECX points to test location
		mov 	eax,0aah
		call 	u_Poke
		call 	u_Peek
		cmp 	al,0aah
		jne 	short @@Got

		inc 	edi
		cmp 	edi,1024*8	;For 8MB boards
		jb 	short @@GusSize

@@Got:	mov 	ds:[GF1_Memory],edi
	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
	;
@@Not_Found:
	stc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
;
; Other driver-routines come here.
;
; Init_Mixer:
;   In:
;	ECX	- Number of voices
;   Out:
;	[CF]	- Error flag
;
;
; Exit_Mixer:
;   In:
;	Nothing
;   Out:
;	[CF]	- Error flag
;
;
; Set_Mixer_Handler:
;   In:
;	EAX	- DATA32 ptr to handler
;   Out:
;      EAX	- Old play handler
;	[CF]	- Error flag
;
;
; Load_Sample:
;   In:
;	EAX	- DATA32 ptr to sample
;	EBX	- size of sample (in samples)
;	ECX	- loop start of sample
;	EDX	- loop end of sample
;	ESI	- sample-flags
;   Out:
;	EAX	- sample-handle
;	[CF]	- error flag
;
;
; Free_Sample:
;   In:
;	EAX	- Sample-Handle
;   Out:
;	[CF]	- error flag
;
;
Init_Mixer:
	push	ds
	push	es
	push 	edi
	push	ecx			;Save voices
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	cli
	cld
	mov     ebx,ds:[u_Command]
	mov     ecx,ds:[u_DataHi]
	mov     edx,ebx			;EDX = Command
	mov     al,4Ch
	out     dx,al
	mov     edx,ecx			;EDX = DataHi
	xor     al,al			;Start GUS reset
	out     dx,al
	call    u_delay
	call    u_delay
	mov     edx,ebx			;EDX = Command
	mov     al,4Ch
	out     dx,al
	mov     edx,ecx			;EDX = DataHi
	mov     al,1			;End GUS reset
	out     dx,al
	call    u_delay
	call    u_delay

	mov     edx,ds:[u_Voice]
	add     dx,100h
	mov     al,3
	out     dx,al
	call    u_delay
	mov     edx,ds:[u_Voice]
	add     dx,100h
	xor     al,al
	out     dx,al
	;
	mov     edx,ebx			;EDX = Command
	mov     al,41h			;DMA register clear
	out     dx,al
	mov     edx,ecx
	xor     al,al
	out     dx,al

	mov     edx,ebx
	mov     al,45h			;Turn off timers
	out     dx,al
	mov     edx,ecx
	xor     al,al
	out     dx,al

	mov     edx,ebx
	mov     al,49h			;Stop sampling
	out     dx,al
	mov     edx,ecx
	xor     al,al
	out     dx,al
	;
	mov     edx,ebx
	mov     al,0Eh			;Set number of voices
	out     dx,al
	add     dx,2
	pop	eax			;EAX = Number of voices
	cmp 	al,14
	ja 	short @@1
	mov	al,14
@@1:    mov	ds:[GF1_Voices],eax
	dec	al
	or      al,0C0h
	out     dx,al

	mov     edx,ds:[u_Status]
	in      al,dx
	mov     edx,ebx
	mov     al,41h
	out     dx,al
	mov     edx,ecx
	in      al,dx
	mov     edx,ebx
	mov     al,49h
	out     dx,al
	mov     edx,ecx
	in      al,dx
	mov     edx,ebx
	mov     al,8Fh
	out     dx,al
	mov     edx,ecx
	in      al,dx
	;
	push    ebx ecx
	xor     ecx,ecx
@@VoiceClearLoop:
	mov     edx,ds:[u_Voice]
	mov     al,cl
	out     dx,al
	inc     dx
	mov     al,9
	out     dx,al
	inc     dl
	xor     eax,eax
	out     dx,ax
	dec     dl
	xor     al,al
	out     dx,al
	add     dx,2
	mov     al,3                    ; Turn voice off
	out     dx,al
	sub     dx,2
	mov     al,0Dh
	out     dx,al
	add     dx,2
	mov     al,3
	out     dx,al
	sub     dx,2
	inc     ecx
	cmp     ecx,32
	jnz     @@VoiceClearLoop
	pop     ecx ebx
	;
	mov     edx,ebx
	mov     al,41h
	out     dx,al
	mov     edx,ecx
	in      al,dx
	mov     edx,ebx
	mov     al,49h
	out     dx,al
	mov     edx,ecx
	in      al,dx
	mov     edx,ebx
	mov     al,8Fh
	out     dx,al
	mov     edx,ecx
	in      al,dx
	;
	mov     edx,ebx
	mov     al,4Ch
	out     dx,al
	mov     edx,ecx
	mov     al,7			;Turn on IRQ,DAC
	out     dx,al

	mov     edx,ds:[u_Base]
	mov	al,8
	out     dx,al
	;
	mov 	ebx,ds:[GF1_Voices]
	;dec	ebx
	xor 	edx,edx
	mov 	eax,96bb8h
	div 	ebx
	mov 	ds:[Period_Factor],eax

	mov	edi,OFFSET Channel_MapP	;Physical channel map
	mov	eax,01010101h*CHN_UNUSED
	mov	ecx,32/4
	rep	stosd
	mov	edi,OFFSET Channel_MapL	;Logical channel map
	mov	eax,0ffffffffh		;Set no channel
	mov	ecx,32/4
	rep	stosd

	mov 	eax,ds:[GF1_IRQ]	;EAX = IRQ number
	mov	ebx,OFFSET GUS_Interrupt
	call	Set_Flat_IRQ		;Set new IRQ
	mov 	eax,ds:[GF1_IRQ]	;EAX = IRQ number
	call	Link_Real_IRQ
	mov	eax,ds:[GF1_IRQ]
	call 	Enable_IRQ
	;
	sti
	clc
	pop 	edi
	pop	es
	pop	ds
	retn
;
Exit_Mixer:
	push	ds
	mov	ds,cs:[DATA32_Selector]
	;
	cli
	mov     edx,ds:[u_Base]
	mov     al,00001011b
	out     dx,al

	mov     edx,ds:[u_Command]
	mov     al,4Ch
	out     dx,al
	add     dx,2
	mov     al,1			;Turn off IRQ,DAC
	out     dx,al
	;
	mov	eax,ds:[GF1_IRQ]
	call 	Disable_IRQ
	mov 	eax,ds:[GF1_IRQ]
	mov 	ebx,ds:[Old_IRQ]
	call	Set_Flat_IRQ
	mov 	eax,ds:[GF1_IRQ]
	mov 	ebx,ds:[Old_Real_IRQ]
	call	Unlink_Real_IRQ
	sti
	;
	clc
	pop	ds
	retn
;
Run_Mixer:
	clc
	retn
;
Set_Mixer_Handler:
	clc
	retn
;
Set_Master_Volume:
	clc
	retn
;
Load_Sample:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	;
	test	ebx,ebx				;Is size>0 ???
	jz	@@Ret0
	;
	push	ecx				;Save loop start
	mov	edi,ds:[Sample_Map]		;EDI = ptr to sample-info
	mov	ecx,256
@@L1:	test	ds:[edi],FL_UNUSED_SAMPLE
	jnz	short @@found
	add	edi,16
	dec	ecx
	jnz	short @@L1
	pop	ecx				;Restore loop start
	jmp	@@Err
	;
@@found:pop	ecx				;ECX = LOOP_START
	and	esi,NOT FL_UNUSED_SAMPLE	;ESI = flags
	mov	ds:[edi],esi			;Save flags
	test	esi,FL_LOOP or FL_PINGPONG_LOOP
	jz	short @@1
	mov	ebx,edx				;EBX = SIZE = LOOP_END
@@1:    mov	ds:[edi+8],ebx			;Save size
	dec	ecx
	mov	ds:[edi+12],ecx                	;Save loop start
	test	esi,FL_16BIT
	jz	short @@2
	shl	ebx,1				;EBX = SIZE *= 2
@@2:    inc	ebx
	and	bl,0feh				;Align to word address
	;
	mov 	ebp,OFFSET Bank_Info
	mov	esi,eax				;ESI = src
	mov 	edx,256				;EDX = Required memory
	xor 	ecx,ecx				;ECX = bank address

@@L0:	cmp 	ds:[GF1_Memory],edx		;Enough memory ???
	jb 	short @@Err
	mov 	eax,40000h			;EAX = Bank size
	sub 	eax,ds:[ebp]			;EAX = Bytes left in bank
	cmp 	eax,ebx				;EBX = required bytes
	jae 	short @@Succ

	add 	edx,256				;EDX += 256 kB
	add 	ecx,40000h			;ECX += bank size
	add 	ebp,4				;Next bank
	jmp 	short @@L0
	;
@@Err:	stc
	pop	ebp
	pop 	edi
	pop 	esi
	pop	es
	pop	ds
	retn
	;
@@Succ: push 	edi				;EDI = hdr-address = handle
	mov	eax,ecx				;EAX = bank address
	add	eax,ds:[ebp]			;Add current bank pos
	add 	ds:[ebp],ebx			;Increment position
	mov	ds:[edi+4],eax			;Save address
	mov	ecx,ebx				;ECX = Size
	mov	edi,eax
	call 	u_LoadSample

	pop	eax				;EAX = Handle
	test	dword ptr ds:[eax],FL_16BIT
	jz	short @@Ret0
	mov	ebx,ds:[eax+4]			;Translate address to 16bit
	mov	ecx,ebx
	shr	ebx,1
	and	ebx,001ffffh
	and	ecx,0fffc0000h
	or	ebx,ecx
	mov	ds:[eax+4],ebx
	;
@@Ret0:	clc
	pop	ebp
	pop	edi
	pop 	esi
	pop 	es
	pop	ds
	retn
;
Free_Sample:
	push	ds
	push	es
	push	edi
	cld

	mov	ds,cs:[DATA32_Selector]
	mov	es,cs:[DATA32_Selector]
	mov	ecx,256				;ECX = Sample-counter
	mov	edi,ds:[Sample_Map]		;EDI = ptr to sample-info
@@L1:	mov	ds:[edi],FL_UNUSED_SAMPLE	;Set this sample as free
	add	edi,16
	dec	ecx
	jnz	short @@L1

	mov	ecx,4*8				;For 8MB board
	mov 	eax,32
	mov	edi,OFFSET Bank_Info
	rep	stosd


	clc
	pop	edi
	pop	es
	pop	ds
	retn
;
;
;
; Set_Sample
;   In:
;	ECX	- Channel-Number
;      EAX	- Sample-Handle
; 	EBX	- Start position
;
;
; Set_Frequency:
;   In:
;	ECX	- Channel-Number
;	EAX	- Frequency (Hz) (8bit fixed point)
;
;
; Set_Volume:
;   In:
;	ECX	- Channel-Number
;	EAX	- Volume (0-64)
;	EBX	- Panning (0-255)
;
;
; Stop_Sample:
;   In:
;	ECX	- Channel-Number
;
;
Set_Sample:
	push	esi
	test	eax,eax				;is sample = 0 ???
	jz	SS2
	;
	mov	dl,ds:[Channel_MapL+ecx]	;Get physical channel
	mov	esi,eax				;ESI = Sample-handle
	cmp	dl,0ffh
	jb	SS3
	uFind_Channel				;EDX = new channel
	mov	ds:[Channel_MapL+ecx],dl	;Save channel
	or	cl,CHN_USED
	mov	ds:[Channel_MapP+edx],cl	;Set used bit
	;
	mov	eax,edx				;AL = physical channel
	mov 	edx,ds:[u_Voice]
	out 	dx,al				;Set channel
	uStop_Ramp
	uClear_Volume

	mov	cl,32				;CL = falgs  (IRQ on)
	test	dword ptr ds:[esi],FL_16BIT
	jz	short @@1
	or	cl,4				;TUrn on 16bit data
@@1:	add     ebx,ds:[esi+4]			;EBX = Start position
	uSet_Start
	mov	ebx,ds:[esi+8]			;EBX = Size
	add	ebx,ds:[esi+4]			;EBX = End position
	dec	ebx
	uSet_End
	test	dword ptr ds:[esi],FL_LOOP or FL_PINGPONG_LOOP
	jz	short @@2
		mov	ebx,ds:[esi+12]		;EBX = Loop-start
		and	cl,NOT 32
		add	ebx,ds:[esi+4]
		or	cl,8			;Turn loop on / IRQ off
		uSet_LoopSTart
		test	dword ptr ds:[esi],FL_PINGPONG_LOOP
		jz	short @@2
		or	cl,16			;Turn on pingpong loop
@@2:    uSet_Control
	pop	esi
	retn
SS3:	;
	mov	eax,edx				;AL = physical channel
	mov 	edx,ds:[u_Voice]
	out 	dx,al				;Set channel

	add     ebx,ds:[esi+4]			;EBX = Start position
	uSet_Start
	uGet_Control
	and	al,01111100b
	mov	cl,al
	uSet_Control
	pop	esi
	retn
	;
SS2:	pop	esi
	retn
;
Stop_Sample:
	push	edi
	;
	movzx	eax,ds:[Channel_MapL+ecx]	;EAX = physical channel
	mov	edi,eax				;
	cmp	al,0ffh
	je	short @@End
	mov 	edx,ds:[u_Voice]
	out 	dx,al				;Set channel
	mov	ds:[Channel_MapL+ecx],0ffh	;Clear channel
	mov	ds:[Channel_MapP+edi],CHN_RAMPING
	;
	uStop_Voice
	call	U_Slide_Away
	jnc	short @@End			;Carry => Already zero
	mov	ds:[Channel_MapP+edi],CHN_UNUSED
	;
@@End:	pop	edi
	retn
;
Set_Frequency:
	movzx	edx,ds:[Channel_MapL+ecx]	;Get physical channel
	cmp	dl,0ffh
	je	short SF1
	push	eax				;Save freq.
	mov	al,dl				;AL = physical channel
	mov 	edx,ds:[u_Voice]
	out 	dx,al				;Set channel
	pop	eax				;EAX = freq.
	uSet_Frequency
SF1:	retn
;
Set_Volume:
	movzx	edx,ds:[Channel_MapL+ecx]	;Get physical channel
	cmp	dl,0ffh
	je	short SV1
	push	eax				;Save volume
	mov	al,dl				;AL = physical channel
	mov 	edx,ds:[u_Voice]
	out 	dx,al				;Set channel
	uSet_Panning
	pop	ebx				;EAX = volume
	ifdef	GUS_VOLUME_RAMPING
	 uRamp_Volume
	else
	 mov 	bx,ds:[mt_VolTable+2*ebx]
	 uSet_Volume
	endif
SV1:	retn
;
;
;   GOMEZ GRAVIS ULTRASOUND DRIVER                        INTERRUPT ROUTINE
;
PUBLIC C GUS_Event_Counter
PUBLIC C GUS_IRQ_Counter
PUBLIC C GUS_Ramp_Counter
PUBLIC C GUS_Wave_Counter

GUS_IRQ_Counter		dd 	0
GUS_Event_Counter       dd	0
GUS_Wave_Counter	dd	0
GUS_Ramp_Counter	dd	0

GUS_Interrupt:
	push 	ds
	pushad
	;
	mov	ds,cs:[DATA32_Selector]
	inc	ds:[GUS_IRQ_Counter]
	mov 	edx,ds:[u_Command]
	in 	al,dx			;Get Command
	shl	eax,8
	mov 	edx,ds:[u_Voice]
	in 	al,dx			;Get Voice
	push	eax
@@Main: mov	edx,ds:[u_Status]
	in      al,dx
	test 	al,al
	jz	@@End
	inc	ds:[GUS_Event_Counter]
	test 	al,1100000b		;Wavetable IRQ ???
	jz 	@@Main
	;
@@GF1_Loop:
	mov	edx,ds:[u_Command]
	mov 	al,8fh
	out	dx,al
	add     dx,2
	in      al,dx
	mov     cl,al                   ;CL = IRQ status register

	shr	al,6
	cmp	al,11b
	je 	short @@Main
	;
	mov 	al,cl
	and 	eax,1fh			;EAX = Voice Number

	mov 	edx,ds:[u_Voice]
	out 	dx,al			;Select Voice

	test 	cl,64			;Is it volume ramp ???
	jnz 	@@Wave
		inc	ds:[GUS_Ramp_Counter]
		uStop_Ramp
		test 	ds:[Channel_MapP+eax],CHN_RAMPING or CHN_UNUSED
		jz 	@@Wave
		mov	ds:[Channel_MapP+eax],CHN_UNUSED
		uStop_Voice
		jmp 	@@GF1_Loop
	;
@@Wave:	test 	cl,128			;Is it wavetable IRQ ???
	jnz 	@@GF1_Loop
		inc	ds:[GUS_Wave_Counter]
		mov	bl,ds:[Channel_MapP+eax]	;BL = Logical channel
		and	ebx,1fh                         ;AL = Physical chan.
		mov	ds:[Channel_MapP+eax],CHN_UNUSED
		cmp	al,ds:[CHannel_MapL+ebx]
		jne	short @@St
		mov	ds:[CHannel_MapL+ebx],0ffh
	@@St:	uStop_Voice
		jmp @@GF1_Loop
	;
@@End:  pop	eax
	mov 	edx,ds:[u_Voice]
	out	dx,al			;Select Voice
	shr	eax,8
	mov 	edx,ds:[u_Command]
	out	dx,al			;Select Command
	mov     al,20h
	cmp	ds:[GF1_IRQ],7
	jbe	short @@1
	out	0a0h,al
@@1:	out	020h,al


	popad
	pop 	ds
	iretd
code32 ends
END