;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
;
;
;   GOMEZ VECTOR ENGINE                                   DISPLAY-Variables
;
;
;
DISPLAY_Width		equ	640
DISPLAY_Height		equ	480
DISPLAY_Depth		equ	8



;
;
;
;   GOMEZ VECTOR ENGINE                                              Flags
;
;
;
GVE_VERSION		equ	200h
GVE_FILE_VERSION	equ	250h
GVE_CULL_AFTER		equ	1
GVE_TRIVIAL_REJECT	equ	1
GVE_SPHERICAL_CHROME	equ	1
GVE_VERTEX_TEXTURE_UV	equ	1
;GVE_MULTI_LIGHTS	equ	1
GVE_RASTER8		equ	1
GVE_RASTER16		equ	1
GVE_PROFILER		equ	1
GVE_EXACT_FRAME_SPEED	equ	1
GVE_BOUNDING_BOX	equ	1
GVE_VIDEO_TEXTURES	equ	1




;
;
;
;   GOMEZ VECTOR ENGINE                                           constants
;
;
;
GVE_DISTANCE		equ	9
GVE_MATH_SHIFT		equ	10		;Standard fixed point bits
GVE_MATRIX_SHIFT	equ	20		;used for matrix entries
GVE_NORMAL_SHIFT	equ	10		;used for vertex normals
GVE_SHAD_SHIFT		equ	(GVE_MATRIX_SHIFT+GVE_NORMAL_SHIFT-6)
GVE_3DS_SHIFT		equ     (GVE_MATH_SHIFT-3)
GVE_SCRIPT_SHIFT	equ	12

GVE_MAX_VISIBLE_POLYS	equ	9000
GVE_TIMER_SPEED		equ	4000		;4000Hz timer speed
GVE_BLURR_FACTOR	equ	(32+16)

GVE_VIDEO_WIDTH		equ	256
GVE_VIDEO_HEIGHT	equ	256
GVE_VIDEO_BUFFER_SIZE	equ	100		;100 kB for video buffer

GVE_PHONG_MAX_EXP	equ	16
GVE_MAX_TEXTURES	equ	256
GVE_COSINE_SHIFT	equ	10
GVE_COSINE_SIZE		equ	(1 shl GVE_COSINE_SHIFT)
GVE_ASINE_SHIFT		equ	10
GVE_ASINE_SIZE		equ	(1 shl GVE_ASINE_SHIFT)


ifndef GVE_PRO
  GVE_MAX_EDGES		equ	24
else
  GVE_MAX_EDGES		equ	3
endif

ifdef GVE_RASTER15
  GVE_RASTER16		equ	1
endif

;
;
; The following equates are used for GVE_Flags etc...
;
GVE_FLAG_MOTION_BLURR		equ	1
GVE_FLAG_NOSORT			equ	2
GVE_FLAG_SOFTEN_HORIZONTAL	equ	4
GVE_FLAG_SOFTEN_VERTICAL	equ	8
GVE_FLAG_MOTION_TRACE		equ	10h
GVE_FLAG_CLEAR_FRAME		equ	20h
GVE_FLAG_FEED_BACK		equ	40h

GVE_CHANGE_SHADING	equ	1
GVE_CHANGE_COLOUR	equ	2
GVE_CHANGE_PHONG	equ	4
GVE_CHANGE_TEXTURE	equ	8
GVE_CHANGE_LIGHTMAP	equ	10h
GVE_CHANGE_BUMP		equ	20h

GVE_OBJ_BACK_CULLING	equ	1
GVE_OBJ_NOSORT		equ	2
GVE_OBJ_MESH		equ	4
GVE_OBJ_VERTEX_INDEX	equ	8
GVE_OBJ_VERTEX_ADDRESS	equ	10h
GVE_OBJ_NORMALS		equ	80h
GVE_OBJ_VERTEX_SHADING	equ	100h
GVE_OBJ_HIDE		equ	200h

GVE_VID_LOOP		equ	1
GVE_VID_EXTERNAL	equ	2
GVE_VID_INTERNAL	equ	4
GVE_VID_REMAP		equ	8
GVE_VID_RESCALE		equ	16

GVE_PAL_24BIT		equ	1
GVE_PAL_REMAP		equ	2

GVE_TEXT_RESCALE	equ	1
GVE_TEXT_REMAP		equ	2
GVE_TEXT_LIGHTMAP	equ	4

COMPRESSION_NONE	equ	'ENON'
COMPRESSION_LZW		equ	'8WZL'

GVE_TYP_OBJECT		equ	'JBO'
GVE_TYP_LIGHT		equ	'HGIL'
GVE_TYP_SPOTLIGHT	equ	'TOPS'
GVE_TYP_POINTLIGHT	equ	'TNOP'
GVE_TYP_AMBIENT		equ	'BMA'
GVE_TYP_CAMERA		equ     'MAC'
GVE_TYP_VIDEO		equ	'ODIV'
GVE_TYP_BITMAP		equ	'PMB'
GVE_TYP_FRAME_BUFFER	equ	'MARF'


;
;
; The following equates are the primitive indetifiers in the type field
;
VOBJ_NOTHING		equ	0
VOBJ_WIRE_POLY		equ	4
VOBJ_FILLED_POLY	equ	8
VOBJ_LAMBERT_POLY	equ	12
VOBJ_GOURAUD_POLY	equ	16
VOBJ_PHONG_POLY		equ	20
VOBJ_GLASS_POLY		equ	24
VOBJ_LAMBERT_GLASS	equ	28
VOBJ_GOURAUD_GLASS	equ	32
VOBJ_PHONG_GLASS	equ	36
VOBJ_FAST_TEXTURE	equ	40
VOBJ_LAMBERT_TEXTURE	equ	44
VOBJ_GOURAUD_TEXTURE	equ	48
VOBJ_PHONG_TEXTURE	equ	52
VOBJ_BUMP_CHROME	equ	56
VOBJ_CHROME_POLY	equ	60
VOBJ_LAMBERT_CHROME	equ	64
VOBJ_GOURAUD_CHROME	equ	68
VOBJ_PHONG_CHROME	equ	72
VOBJ_FAST_PHONG		equ	76
VOBJ_GLASS_TEXTURE	equ	80
VOBJ_GLASS_CHROME	equ	84
VOBJ_BUMP_POLY		equ	88
VOBJ_LAMBERT_BUMP	equ	92
VOBJ_GOURAUD_BUMP	equ	96
VOBJ_PHONG_BUMP		equ	100
VOBJ_GLASS_BUMP		equ	104
VOBJ_SOFT_WIRE		equ	108
VOBJ_GLASS_WIRE		equ	112
VOBJ_LIGHTMAP_TEXTURE	equ	116
VOBJ_CHROME_TEXTURE	equ	120
VOBJ_LIGHTMAP_BUMP	equ	124
VOBJ_POINT		equ	128
VOBJ_CARVA_POLY		equ	132
VOBJ_LAMBERT_CARVA	equ	136
VOBJ_GOURAUD_CARVA	equ	140
VOBJ_PHONG_CARVA	equ	144
VOBJ_GLASS_CARVA	equ	148
VOBJ_PTEXTURE		equ	152
VOBJ_LAMBERT_PTEXTURE	equ	156
VOBJ_GOURAUD_PTEXTURE	equ	160
VOBJ_PHONG_PTEXTURE	equ	164
VOBJ_LIGHTMAP_PTEXTURE	equ	168
VOBJ_CHROME_PTEXTURE	equ	172
VOBJ_GLASS_PTEXTURE	equ	176
VOBJ_BUMP_TEXTURE	equ	180

VOBJ_MAX_METHODS	equ	180


LIGHT_POINT		equ	1
LIGHT_SPOT		equ	2

CAMERA_NORMAL		equ	1


;
;
;
;   GOMEZ VECTOR ENGINE                                standard structures
;
;
;
GVE_MATRIX STRUC
	Matrix11		dd	?	;The matrix looks like this:
	Matrix12		dd	?	;                      
	Matrix13		dd	?	; e11   e12   e13  e14 
	Matrix14		dd	?	; e21   e22   e23  e24 
	Matrix21		dd	?	; e31   e32   e33  e34 
	Matrix22		dd	?	; e41   e42   e43  e44 
	Matrix23		dd	?	;                      
	Matrix24		dd	?
	Matrix31		dd	?
	Matrix32		dd	?
	Matrix33		dd	?
	Matrix34		dd	?
	Matrix41		dd	?
	Matrix42		dd	?
	Matrix43		dd	?
	Matrix44		dd	?
GVE_MATRIX ENDS


GVE_VECTOR STRUC             			;This is a simple 3 dimensional
	VectorX			dd	?	;vector used in 3-space
	VectorY			dd	?
	VectorZ			dd	?
GVE_VECTOR ENDS


GVE_VERTEX STRUC
	VertexX			dd	?
	VertexY			dd	?
	VertexZ			dd	?
	Vertex_Normal		LABEL DWORD
	Vertex_NormalX		dd	?
	Vertex_NormalY		dd	?
	Vertex_NormalZ		dd	?
	Vertex@X		dd	?	;Transformed vertex
	Vertex@Y		dd	?
	Vertex@Z		dd	?
	Vertex_ScreenX		dd	?	;Projected X
	Vertex_ScreenY		dd	?	;Projected Y
	Vertex_Normal@		LABEL DWORD
	Vertex_Normal@X		dd	?	;Transformed normal
	Vertex_Normal@Y		dd	?
	Vertex_Normal@Z		dd	?
	Vertex_Shading		dd	?	;Dot product of Light*Normal
	Vertex_Chrome   	LABEL DWORD
	Vertex_ChromeX		dd	?	;Chrome-mapping coordinate
	Vertex_ChromeY		dd	?
	Vertex_Texture		LABEL DWORD
	Vertex_TextureU		LABEL DWORD
	Vertex_TextureX		dd	?
	Vertex_TextureV		LABEL DWORD
	Vertex_TextureY		dd	?
GVE_VERTEX ENDS


GVE_OBJECT STRUC
	Object_Name		db	32 dup (?)
	Object_Magic		dd	?
	Object_Type		dd	?
	Object_Position        	LABEL	DWORD
	Object_RotationX	dd	?
	Object_RotationY	dd	?
	Object_RotationZ	dd	?
	Object_PositionX	dd	?
	Object_PositionY	dd	?
	Object_PositionZ	dd	?
	Object_Bound            LABEL 	DWORD
	Object_Bound_MinX	dd	?
	Object_Bound_MaxX	dd	?
	Object_Bound_MinY	dd	?
	Object_Bound_MaxY	dd	?
	Object_Bound_MinZ	dd	?
	Object_Bound_MaxZ	dd	?
				dd	3 dup (?)
	Object_Mesh_Width	dd	?
	Object_Mesh_Height	dd	?
	Object_Flags		dd	?
				dd      ?,?,?,?
	Object_Brother		dd	?
	Object_Son		dd	?
	Object_Father		dd	?
	Object_Vertex_List	dd	?
	Object_Face_List	dd	?
	Object_Local_Matrix	dd	16 dup (?)
	Object_Final_Matrix	dd	16 dup (?)
GVE_OBJECT ENDS


GVE_LIGHTSOURCE STRUC
	Light_Name              db	32 dup (?)
	Light_Magic		dd	?
	Light_Type		dd      ?
	Light_Position		LABEL 	DWORD
	Light_RotationX		dd	?
	Light_RotationY		dd	?
	Light_RotationZ		dd	?
	Light_PositionX		dd	?
	Light_PositionY		dd	?
	Light_PositionZ		dd	?
	Light_Colour		LABEL 	DWORD
	Light_ColourRed		db	?
	Light_ColourGreen	db	?
	Light_ColourBlue	db	?
				db	?
				dd	?
	Light_Flags		dd	?
				dd	?,?,?,?,?
	Light_Direction		LABEL	DWORD
	Light_DirectionX	dd	?
	Light_DirectionY	dd	?
	Light_DirectionZ	dd	?
	Light_Object_Direction	dd	3 dup (?)
	Light_Object_Position	dd	3 dup (?)
GVE_LIGHTSOURCE ENDS


GVE_AMBIENT_LIGHT STRUC
	Ambient_Colour		LABEL 	DWORD
	Ambient_ColourRed	db	?
	Ambient_ColourGreen	db	?
	Ambient_ColourBlue	db	?
				db	?
	Ambient_Flags		dd	?
	Ambient_Specular	db	?
				db	?,?,?
				dd	?,?,?,?,?
GVE_AMBIENT_LIGHT ENDS


GVE_TRIANGLE STRUC
	Triangle_Size		dw	3*4+24
	Triangle_Type		db	?
	Triangle_Vertex_Count	db	3
	Triangle_Bump  		db	?
	Triangle_Phong		db	?
	Triangle_Colour		LABEL BYTE
	Triangle_Texture	dw	?
	Triangle_NormalX        dd	?
	Triangle_NormalY        dd	?
	Triangle_NormalZ        dd	?
	Triangle_Plane        	dd	?
	Triangle_Vertex1      	dd	?
	Triangle_Vertex2      	dd	?
	Triangle_Vertex3      	dd	?
GVE_TRIANGLE ENDS


GVE_CAMERA STRUC
	Camera_Name		db	32 dup (?)
	Camera_Magic		dd	?
	Camera_Type		dd	?
	Camera_Position        	LABEL	DWORD
	Camera_RotationX	dd	?
	Camera_RotationY	dd	?
	Camera_RotationZ	dd	?
	Camera_PositionX	dd	?
	Camera_PositionY	dd	?
	Camera_PositionZ	dd	?
	Camera_Distance		dd	?
	Camera_Flags		dd	?
				dd	9 dup (?)
	Camera_Matrix		dd	16 dup (?)
GVE_CAMERA ENDS


GVE_SCRIPT_TRACK STRUC
	Track_Name		db	32 dup (?)
	Track_Magic		dd	?
	Track_Type		dd	?
	Track_Frames     	dd	?
	Track_Flags	       	dd	?
	Track_Format		dd	?
				dd	11 dup (?)
	Track_Object_Address	dd	?
	Track_Data		LABEL DWORD
GVE_SCRIPT_TRACK ENDS


GVE_TRACK_ENTRY STRUC
	Frame_RotationX		dd	?
	Frame_RotationY		dd	?
	Frame_RotationZ		dd	?
	Frame_PositionX		dd	?
	Frame_PositionY		dd	?
	Frame_PositionZ		dd	?
GVE_TRACK_ENTRY ENDS


GVE_VIDEO STRUC
	Video_Name		db	32 dup (?)
	Video_Magic		dd	?
	Video_Type		dd	?
	Video_Width		dw	?
	Video_Height		dw	?
	Video_Depth		db	?,?,?,?
	Video_Flags		dd	?
	Video_File_Name		db	128 dup (?)
	Video_Texture_Number	dd	?
				dd	?,?,?,?,?,?

	Video_Compression	dd	?
	Video_Compressor	dd	?
	Video_Decompressor	dd	?
	Video_Speed		dd	?
	Video_Frames		dd	?
	Video_Handle		dd	?
	Video_Index_Start	dd	?
	Video_Film_Start	dd	?
	Video_Current_Frame	dd	?
	Video_Current_Position	dd	?
	Video_Current_Palette	dd	?
	Video_Current_LUT	dd	?
	Video_Frame_Buffer	dd	?
GVE_VIDEO ENDS


GVE_BITMAP STRUC
	Bitmap_Name		db	32 dup (?)
	Bitmap_Magic		dd	?
	Bitmap_Type		dd	?
	Bitmap_Width		dw	?
	Bitmap_Height		dw	?
	Bitmap_Depth		db	?,?,?,?
	Bitmap_Flags		dd	?
	Bitmap_Palette		dd	?
				dd	2 dup (?)
GVE_BITMAP ENDS


GVE_VERTEX_SIZE		equ	(SIZE GVE_VERTEX)
GVE_OBJECT_SIZE		equ	(SIZE GVE_OBJECT)
GVE_CAMERA_SIZE		equ	(SIZE GVE_CAMERA)
GVE_LIGHT_SIZE		equ	(SIZE GVE_LIGHTSOURCE)
GVE_TRACK_SIZE		equ	(SIZE GVE_SCRIPT_TRACK)
GVE_TRIANGLE_SIZE	equ     (SIZE GVE_TRIANGLE)
GVE_VIDEO_SIZE		equ	(SIZE GVE_VIDEO)
GVE_BITMAP_SIZE		equ	(SIZE GVE_BITMAP)
GVE_AMBIENT_SIZE	equ	(SIZE GVE_AMBIENT_LIGHT)
GVE_SHADING_LUT8_SIZE	equ     (64*256)
GVE_BUMP_LUT8_SIZE	equ     (64*256)
GVE_GLASS_LUT8_SIZE	equ	(256*256)
GVE_PALETTE_SIZE	equ	(256*4)

GVE_FILE_VERTEX_SIZE	equ	(6*4)
GVE_FILE_OBJECT_SIZE	equ	(32*4)
GVE_FILE_CAMERA_SIZE	equ	(32*4)
GVE_FILE_LIGHT_SIZE	equ	(24*4)
GVE_FILE_AMBIENT_SIZE	equ	(8*4)
GVE_FILE_TRACK_SIZE	equ	(24*4)
GVE_FILE_TRIANGLE_SIZE	equ	GVE_TRIANGLE_SIZE
GVE_FILE_VIDEO_SIZE	equ	(52*4)
GVE_FILE_BITMAP_SIZE	equ	(16*4)
GVE_FILE_PALETTE_SIZE	equ	(256*4)



;
;
;
;   GOMEZ VECTOR ENGINE                               function declarations
;
;
;
;
;
; These are just the normal function- and variable-definitions....
;
ifndef GVE_SYSTEM_FILE
extrn C GVE_Init_World:near
extrn C GVE_Draw_World:near
extrn C GVE_Move_Object:near
extrn C GVE_Move_Camera:near
extrn C GVE_Move_Light:near
extrn C GVE_Set_Distance:near
extrn C GVE_Transform_World:near
extrn C GVE_Load_World:near
extrn C GVE_Save_World:near
extrn C GVE_Free_World:near
extrn C GVE_Alloc_World:near
extrn C GVE_Set_Frame_Size:near
extrn C GVE_Set_Palette:near
extrn C Init_GVE:near
extrn C Exit_GVE:near

extrn C GVE_Alloc_Bitmap:near

extrn C GVE_Alloc_Texture:near
extrn C GVE_Free_Texture:near
extrn C GVE_Remap_Texture:near
extrn C GVE_Rescale_Texture:near
extrn C GVE_Get_Texture_Info:near

extrn C GVE_Alloc_LightMap:near
extrn C GVE_Free_LightMap:near
extrn C GVE_Get_LightMap_Info:near
extrn C GVE_Rescale_LightMap:near
extrn C GVE_Remap_LightMap:near

extrn C GVE_Alloc_BumpMap:near
extrn C GVE_Free_BumpMap:near
extrn C GVE_Get_BumpMap_Info:near
extrn C GVE_Rescale_BumpMap:near
extrn C GVE_Create_BumpMap:near

extrn C GVE_Make_Triangles:near
extrn C GVE_Change_Object:near
extrn C GVE_Texture_Object:near
extrn C GVE_Alloc_Object:near
extrn C GVE_Free_Object:near
extrn C GVE_Get_Object_Info:near
extrn C GVE_Init_Normals:near
extrn C GVE_Init_Bounding_Box:near

extrn C GVE_Alloc_Light:near
extrn C GVE_Free_Light:near
extrn C GVE_Get_Light_Info:near

extrn C GVE_Alloc_Camera:near
extrn C GVE_Free_Camera:near
extrn C GVE_Get_Camera_Info:near

extrn C GVE_Init_Shading_LUT:near
extrn C GVE_Init_Bump_LUT:near
extrn C GVE_Init_Shading_PAL:near
extrn C GVE_Init_Glass_LUT:near

extrn C GVE_Import_Texture:near
extrn C GVE_Export_Texture:near
extrn C GVE_Import_LightMap:near
extrn C GVE_Export_LightMap:near
extrn C GVE_Import_BumpMap:near
extrn C GVE_Export_BumpMap:near

extrn C GVE_Alloc_Video:near
extrn C GVE_Free_Video:near
extrn C GVE_Get_Video_Info:near
extrn C GVE_Import_Video:near
extrn C GVE_Open_Video:near
extrn C GVE_Close_Video:near
extrn C GVE_Video_Seek:near
extrn C GVE_Video_Next_Frame:near

extrn C GVE_Import_Palette:near
extrn C GVE_Export_Palette:near

extrn C GVE_Import_3DS:near

extrn C GVE_Build_World:near

extrn C GVE_Alloc_Track:near
extrn C GVE_Alloc_Script:near
extrn C GVE_Free_Track:near
extrn C GVE_Compress_Track:near
extrn C GVE_DeCompress_Track:near
extrn C GVE_Grab_Frame:near
extrn C GVE_Jump_Frame:near
extrn C GVE_Kill_Frames:near
extrn C GVE_Suggest_Frame:near

extrn C GVE_Alloc_Mesh:near
extrn C GVE_Free_Mesh:near
extrn C GVE_Init_Mesh:near

extrn GVE_PhongMap_List:DWORD
extrn GVE_Texture_List:DWORD
extrn GVE_Shading_LUT:DWORD
extrn GVE_Glass_LUT:DWORD
extrn GVE_Bump_LUT:DWORD
extrn GVE_Blurr_LUT:DWORD

extrn C GVE_Shading_List:DWORD
extrn C GVE_Palette_Buffer:BYTE
extrn C GVE_Timer:DWORD

extrn C GVE_Frame_Buffer:DWORD
extrn C GVE_Old_Frame_Buffer:DWORD
extrn C GVE_Frame_Width:DWORD
extrn C GVE_Frame_Height:DWORD
extrn C GVE_Frame_Depth:DWORD
extrn C GVE_Frame_Line_Size:DWORD
extrn C GVE_Frame_Aspect_Ratio:DWORD
extrn C GVE_Frame_Speed:DWORD

extrn C GVE_Clip_X1:DWORD
extrn C GVE_Clip_Y1:DWORD
extrn C GVE_Clip_X2:DWORD
extrn C GVE_Clip_Y2:DWORD
endif

ifndef __VOXEL_SYSTEM_FILE
extrn C VS_Init_World:PROC
extrn C VS_Translate_World:PROC
extrn C VS_Draw_World:PROC
extrn C VS_Put_Frame:PROC
endif



;
;
; In order to simplify the initialisation of the system, I want to intro-
; duce a special header that will be used.
;
GVE_World_Header STRUC
	World_Name		db	128 dup (?)
	World_Object_List	dd	?
	World_TextureMap_List	dd	?
	World_PhongMap_List	dd	?
	World_BumpMap_List	dd	?
	World_Light_List	dd      ?
	World_Camera_List	dd	?
	World_Track_List     	dd	?
	World_Video_List	dd	?
	World_Ambient_Light	dd	?
	World_Information_Text	dd	?
	World_Copyright_Text	dd	?
	World_Software_Text	dd	?
	World_Palette		dd	?
	World_Flags		dd	?
	World_Shading_LUT8	dd	?
	World_Glass_LUT8 	dd	?
	World_Bump_LUT8		dd	?
	World_Shading_LUT	dd	?
	World_Glass_LUT 	dd	?
	World_Bump_LUT		dd	?
	World_Blurr_LUT		dd	?
	World_File_Handle	dd	?
GVE_World_Header ENDS


;
;
;
;   GOMEZ VECTOR ENGINE                                 surface attributes
;
;
;
VST_FILLED		equ	1
VST_WIRE		equ	2
VST_GLASS		equ	4
VST_GOURAUD		equ	8
VST_PHONG		equ	10h
VST_LAMBERT		equ	20h
VST_TEXTURE		equ	40h
VST_POINT		equ	80h
VST_CHROME		equ	100h
VST_BUMP		equ	200h
VST_LIGHTMAP		equ	400h


;
;
;
;   GOMEZ VECTOR ENGINE                                     porfiling crap
;
;
;
;
;
; The following macros are for the profiler:
;
;	PROF_START_AREA n
;	PROF_END_AREA n
;
; Where n is the area number (0,...,15)
;
PROF_START_AREA MACRO n
	ifdef GVE_PROFILER
	 push	ds
	 push	eax
	 mov	ds,cs:[DATA32_Selector]
	 inc	ds:[PROFILING_DATA+n*16]
	 mov	eax,ds:[GVE_Timer]
	 mov	ds:[PROFILING_DATA+n*16+12],eax
	 pop	eax
	 pop	ds
	endif
	ENDM

PROF_END_AREA MACRO n
	LOCAL J1
	ifdef GVE_PROFILER
	 push	ds
	 push	eax
	 mov	ds,cs:[DATA32_Selector]
	 mov	eax,ds:[GVE_Timer]
	 sub	eax,ds:[PROFILING_DATA+n*16+12]
	 add	ds:[PROFILING_DATA+n*16+4],eax
	 cmp	ds:[PROFILING_DATA+n*16+8],eax
	 ja	short J1
	 mov	ds:[PROFILING_DATA+n*16+8],eax
J1:	 pop	eax
	 pop	ds
	endif
	ENDM

PROF_SET_COUNTER MACRO n,reg
	LOCAL J1,J2
	ifdef GVE_PROFILER
	 inc	ds:[PROFILING_DATA+n*16]
	 add	ds:[PROFILING_DATA+n*16+12],reg
	 cmp	ds:[PROFILING_DATA+n*16+4],reg
	 jb	short J1
		mov 	ds:[PROFILING_DATA+n*16+4],reg
J1:   	 cmp	ds:[PROFILING_DATA+n*16+8],reg
	 ja	short J2
		mov 	ds:[PROFILING_DATA+n*16+8],reg
J2:  	endif
	ENDM

PROF_RESET_COUNTER MACRO n
	ifdef GVE_PROFILER
	 mov	d ds:[PROFILING_DATA+n*16],0
	 mov	d ds:[PROFILING_DATA+n*16+12],0
	 mov 	d ds:[PROFILING_DATA+n*16+4],0fffffffh
	 mov    d ds:[PROFILING_DATA+n*16+8],0
	endif
	ENDM
