;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
GVE_SYSTEM_FILE		equ	1



;
;
;
;   GOMEZ VECTOR ENGINE                                     3DS-Import stuff
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gve32.inc
include gomez.inc


extrn GVE_IO_Buffer:BYTE

extrn C GVE_Alloc_Object:near
extrn C GVE_Init_Bounding_Box:near
extrn C GVE_Move_Object:near
extrn GVE_Reference_Primitives:near
extrn GVE_DeReference_Primitives:near


ALIGN 4
FileEnd		dd	?
FileHandle	dd	?
FileStart	dd	?
WorldPtr	dd	?
ObjectPtr	dd	?
ObjectName	db	64 dup (?)

;
;
;
;   GOMEZ VECTOR ENGINE                                     3DS-Import stuff
;
;
;
;
;
; GVE_Import_3DS:
;  Input:
;	EAX	-  DATA32 ptr to world-header
;      EBX	-  DATA32 ptr to file-name
;	EDX	-  Start-position  (Normally set to zero)
;  Output:
;	CF 	-  error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Import_3DS
GVE_Import_3DS PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]		;Important !
	mov	es,ds:[DATA32_Selector]
	mov	ds:[FileStart],edx		;First lets save the start pos.
	mov	ds:[WorldPtr],eax
	;
	mov	ecx,O_RDONLY
	call	Open
	jc	@@Err
	mov	ds:[FileHandle],eax

	mov	ebx,eax
	mov	al,SEEK_END
	xor	ecx,ecx
	call	Seek
	jc	@@Err
	mov	ds:[FileEnd],eax

	mov	ebx,ds:[FileHandle]
	mov	ecx,ds:[FileStart]
	mov	al,SEEK_SET
	call	Seek				;Seek to start of 3DS-file
	jc	@@Err
	;
	mov	ecx,ds:[FileEnd]
	call	Read_3DS_Chunk
	jc	@@Err
	;
	mov	esi,ds:[WorldPtr]
	mov	ebp,ds:[esi+World_Object_List]	;EBP = ptr to object-list
	mov	edi,ds:[ebp]			;EDI = Number of objects
	test	edi,edi
	jz	short @@Ok2
	@@L2:	mov	eax,ds:[ebp+4*edi]
		call	GVE_Reference_Primitives
		mov	eax,esi
		mov	edx,ds:[ebp+4*edi]
		call	GVE_Init_Bounding_Box
		mov	eax,esi
		mov	edx,ds:[ebp+4*edi]
		call	GVE_Move_Object
		dec	edi
		jnz	@@L2
@@Ok2:	;
	mov     ebx,ds:[FileHandle]
	call	Close
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Import_3DS ENDP


;
;
; Read_3DS_Chunks:
;  Input:
;      ECX	-  Chunk End
;  Output:
;	[CF]	-  Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Read_3DS_Chunk PROC NEAR
	push	ebp
	push	esi
	push	edi
	mov	ebp,ecx			;EBP = Chunk-end
@@L1:   mov	ebx,ds:[FileHandle]
	call	Tell
	mov	edi,eax			;EDI = Current position
	cmp	eax,ebp
	jae	@@End
	;
	mov	ebx,ds:[FileHandle]
	mov	ecx,6
	mov	edx,OFFSET GVE_IO_Buffer
	call	Read
	jc	@@Err

	movzx	eax,word  ptr ds:[GVE_IO_Buffer]	;EAX = Chunk-Id
	mov	esi,dword ptr ds:[GVE_IO_Buffer+2]	;ESI = Chunk-Size
	test	esi,esi
	jz	@@End                                   ;Zero-size ==> return !
	add	esi,edi					;ESI = Chunk-End

	mov	ebx,OFFSET Chunk_Types
	@@L2:	cmp	ds:[ebx],eax	;Find correct chunk-type
		je	short @@Handle
		add	ebx,8
		cmp	ebx,OFFSET Last_Chunk_Type
		jb	short @@L2
		jmp	@@Nxt
@@Handle:
	mov	eax,ds:[ebx+4]		;EAX = ptr to chunk-handler
	test	eax,eax
	jnz	short @@J1
	mov	eax,OFFSET Read_3DS_Chunk
@@J1:	mov	ecx,esi			;ECX = CHunl-End
	call	eax			;Call chunk-handler
	jc	@@Err
	;
@@Nxt:	mov	ecx,esi			;ECX = CHunk-End
	mov	al,SEEK_SET
	mov	ebx,ds:[FileHandle]
	call	Seek                   	;Seek to next chunk
	jc	@@Err
	jmp	@@L1
	;
@@End:  clc
@@Err:  pop	edi
	pop	esi
	pop	ebp
	retn
Read_3DS_Chunk ENDP
;
;
; ASCII_Reader:
;  Input:
;      EDX	-  ASCII-Buffer
;  Output:
;	[CF]	-  Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
ASCII_Reader PROC NEAR
	push	edi
	mov	edi,edx

@@L1:	mov     ebx,ds:[FileHandle]
	call	Getchar			;EAX = char read
	stosb
	jc	@@Err
	test	al,al
	jnz	short @@L1

	clc
@@Err:	pop	edi
	retn
ASCII_Reader ENDP


;
;
; 3DS-Chunk List
;	Chunk-Magic , Chunk-Function
;
Chunk_Types	LABEL DWORD
	dd	00010h,Chunk_RGB_Float
	dd	00011h,Chunk_RGB_Byte
	dd	00012h,Chunk_RGB_Byte2
	dd      0c23dh,0 ;Chunk_Project
	dd	03daah,0 ;Chunk_Material_Library
	dd	04d4dh,0 ;Chunk_Main
	dd	03d3dh,0 ;Chunk_Object_Mesh
	dd	01200h,0 ;Chunk_Background_Colour
	dd	02100h,0 ;Chunk_Ambient_Colour
	dd	04000h,Chunk_Object_Block
	dd	04100h,Chunk_Tri_Mesh
	dd	04110h,Chunk_Vertex_List
	dd	04120h,Chunk_Face_List
	dd	04130h,Chunk_Face_Materials
	dd	04140h,Chunk_Mapping_List
	dd	04150h,Chunk_Smoothing_List
	dd	04160h,Chunk_Transformation_Matrix
	dd	04600h,Chunk_Light
	dd	04610h,Chunk_Spotlight
	dd	04700h,Chunk_Camera
	dd	04f00h,0 ;Chunk_Hierarchy
	dd	07001h,0 ;Chunk_Viewport
	dd	0afffh,0 ;Chunk_Material
	dd	0a000h,Chunk_Material_name
	dd	0a010h,0 ;Chunk_Ambient_Colour
	dd	0a020h,0 ;Chunk_Diffuse_Colour
	dd	0a030h,0 ;Chunk_Specular_Colour
	dd	0a200h,0 ;Chunk_Texture_Map
	dd	0a230h,0 ;Chunk_Bump_Map
	dd	0a300h,Chunk_Map_Filename
	dd	0b000h,0 ;Chunk_Keyframer
	dd	0b001h,0 ;Chunk_Ambient_Key
	dd	0b002h,0 ;Chunk_Track_Info
	dd	0b010h,Chunk_Track_Object_Name
	dd	0b013h,Chunk_Track_Pivot_Point
	dd	0b020h,Chunk_Track_Position
	dd	0b021h,Chunk_Track_Rotation
	dd	0b022h,Chunk_Track_Scale
	dd	0b030h,Chunk_Object_Number
	dd	0b003h,0 ;Chunk_Track_Camera
	dd	0b023h,0 ;Chunk_Track_FOV
	dd	0b024h,0 ;Chunk_Track_Roll
	dd	0b004h,0 ;Chunk_Track_Camera_Target
	dd	0b005h,0 ;Chunk_Track_Light
	dd	0b006h,0 ;Chunk_Track_Target_Light
	dd	0b007h,0 ;Chunk_Track_Spotlight
	dd	0b008h,0 ;Chunk_Frames
Last_Chunk_Type	LABEL DWORD
;
Chunk_RGB_Float:
Chunk_RGB_Byte:
Chunk_RGB_Byte2:
Chunk_Project:
Chunk_Material_Library:
Chunk_Main:
Chunk_Object_Mesh:
Chunk_Background_Colour:
Chunk_Ambient_Colour:
Chunk_Face_Materials:
Chunk_Smoothing_List:
Chunk_Transformation_Matrix:
Chunk_Light:
Chunk_Spotlight:
Chunk_Camera:
Chunk_Hierarchy:
Chunk_Viewport:
Chunk_Material:
Chunk_Material_name:
Chunk_Ambient_Colour:
Chunk_Diffuse_Colour:
Chunk_Specular_Colour:
Chunk_Texture_Map:
Chunk_Bump_Map:
Chunk_Map_Filename:
Chunk_Keyframer:
Chunk_Ambient_Key:
Chunk_Track_Info:
Chunk_Track_Object_Name:
Chunk_Track_Pivot_Point:
Chunk_Track_Position:
Chunk_Track_Rotation:
Chunk_Track_Scale:
Chunk_Object_Number:
Chunk_Track_Camera:
Chunk_Track_FOV:
Chunk_Track_Roll:
Chunk_Track_Camera_Target:
Chunk_Track_Light:
Chunk_Track_Target_Light:
Chunk_Track_Spotlight:
Chunk_Frames:
	clc
	retn
;
Chunk_Object_Block:
	push	ecx
	mov	edx,OFFSET ObjectName
	call	ASCII_Reader
	pop	ecx
	jc	@@Err
	call    Read_3DS_Chunk
@@Err:	retn
;
Chunk_Tri_Mesh:
	push	ecx
	mov     eax,ds:[WorldPtr]
	call	GVE_Alloc_Object	;EAX = ptr to allocated object
	pop	ecx
	jc	@@Err
	mov	ds:[ObjectPtr],eax
	push	esi
	push	edi
	push	ecx
	mov	ecx,32/4                ;ECX = 32 characters
	mov	edi,eax			;EDI = object-name
	mov	esi,OFFSET ObjectName
	rep	movsd			;Copy name
	pop	ecx
	pop	edi
	pop	esi
	call	Read_3DS_Chunk
@@Err:	retn
;
Chunk_Vertex_List:
	push	edi
	mov	ebx,ds:[FileHandle]
	mov	ecx,2
	mov	edx,OFFSET GVE_IO_Buffer
	call	Read
	movzx	eax,word ptr ds:[GVE_IO_Buffer]
	fastimul ecx,eax,GVE_VERTEX_SIZE
	add	ecx,4
	call	Malloc
	jc	@@Err
	mov	ebx,ds:[ObjectPtr]
	mov	ds:[ebx+Object_Vertex_List],eax
	;
	mov	edi,eax			;EDI = ptr to vertex-data
	movzx	eax,word ptr ds:[GVE_IO_Buffer]
	fastimul ecx,eax,GVE_VERTEX_SIZE/4
	inc	ecx                     ;ECX = size of vertex list in dwords
	xor	eax,eax			;EAX = 0
	rep	stosd			;Clear vertex-list
	;
	mov	edi,ds:[ebx+Object_Vertex_List]
	movzx	ecx,word ptr ds:[GVE_IO_Buffer]
	mov	ds:[edi],ecx		;Save vertex-counter
	add	edi,4

	@@L1:   push	ecx
		mov	ebx,ds:[FileHandle]
		mov	ecx,3*4		;Size of three 32bit floats
		mov	edx,OFFSET GVE_IO_Buffer
		call	Read		;Read in vertex
		fwait
		fild	dword ptr ds:[@@shiftsize]
		fld	dword ptr ds:[GVE_IO_Buffer]
		fscale
		fistp	dword ptr ds:[edi+VertexX]
		fld	dword ptr ds:[GVE_IO_Buffer+4]
		fscale
		fistp	dword ptr ds:[edi+VertexY]
		fld	dword ptr ds:[GVE_IO_Buffer+8]
		fscale
		fistp	dword ptr ds:[edi+VertexZ]
		ffree	st(0)
		fwait
		pop	ecx
		jc	@@Err
		add	edi,GVE_VERTEX_SIZE
		dec	ecx
		jnz	short @@L1
	;
	clc
@@Err:  pop	edi
	retn

@@shiftsize	dd	GVE_3DS_SHIFT
;
Chunk_Face_List:
	push	edi
	mov	ebx,ds:[FileHandle]
	mov	ecx,2
	mov	edx,OFFSET GVE_IO_Buffer
	call	Read
	movzx	eax,word ptr ds:[GVE_IO_Buffer]
	fastimul ecx,eax,3*4+24
	add	ecx,4
	call	Malloc
	jc	@@Err
	mov	ebx,ds:[ObjectPtr]
	mov	ds:[ebx+Object_Face_List],eax
	;
	mov	edi,eax			;EDI = ptr to face-data
	movzx	eax,word ptr ds:[GVE_IO_Buffer]
	fastimul ecx,eax,(3*4+24)/4
	inc	ecx                     ;ECX = size of face list in dwords
	xor	eax,eax			;EAX = 0
	rep	stosd			;Clear vertex-list
	;
	mov	edi,ds:[ebx+Object_Face_List]
	movzx	ecx,word ptr ds:[GVE_IO_Buffer]
	mov	ds:[edi],ecx		;Save face-counter
	add	edi,4

	@@L1:   push	ecx
		mov	ebx,ds:[FileHandle]
		mov	ecx,8
		mov	edx,OFFSET GVE_IO_Buffer
		call	Read		;Read in triple
		jc	@@Err

		mov	d ds:[edi+Triangle_Size],03080024h
		mov	d ds:[edi+Triangle_Colour],00100800h
		movzx	eax,word ptr ds:[GVE_IO_Buffer]
		mov	d ds:[edi+Triangle_Vertex1],eax
		movzx	eax,word ptr ds:[GVE_IO_Buffer+2]
		mov	d ds:[edi+Triangle_Vertex2],eax
		movzx	eax,word ptr ds:[GVE_IO_Buffer+4]
		mov	d ds:[edi+Triangle_Vertex3],eax
		mov	ax,word ptr ds:[GVE_IO_Buffer+6]
		test	ax,08h			;Texture U-Wrap
		jz	short @@J1
		or	byte ptr ds:[edi+7],40h
	@@J1:	test	ax,10h			;Texture V-Wrap
		jz	short @@J2
		or	byte ptr ds:[edi+7],80h
	@@J2:
		add	edi,3*4+24
		pop	ecx
		dec	ecx
		jnz	short @@L1
	;
	clc
@@Err:	pop	edi
	retn
;
Chunk_Mapping_List:
	push	edi
	mov	ebx,ds:[FileHandle]
	mov	ecx,2
	mov	edx,OFFSET GVE_IO_Buffer
	call	Read
	mov	ebx,ds:[ObjectPtr]
	mov	edi,ds:[ebx+Object_Vertex_List]
	test	edi,edi
	jz	@@Err
	movzx	ecx,word ptr ds:[GVE_IO_Buffer]
	add	edi,4

	@@L1:   push	ecx
		mov	ebx,ds:[FileHandle]
		mov	ecx,2*4		;Size of two 32bit floats
		mov	edx,OFFSET GVE_IO_Buffer
		call	Read		;Read in vertex
		fwait
		fild	dword ptr ds:[@@shiftsize]
		fld	dword ptr ds:[GVE_IO_Buffer]
		fscale
		fistp	dword ptr ds:[edi+Vertex_TextureU]
		fld	dword ptr ds:[GVE_IO_Buffer+4]
		fscale
		fistp	dword ptr ds:[edi+Vertex_TextureV]
		ffree	st(0)
		fwait
		add	edi,GVE_VERTEX_SIZE
		pop	ecx
		dec	ecx
		jnz	short @@L1
	;
	pop	edi
	clc
@@Err:	retn

@@shiftsize	dd	8+8
CODE32 ends
END