;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS

CHUNK_SYSTEM_FILE	equ	1

;
;
;
;   GOMEZ VECTOR ENGINE                                      CHUNK ROUTINES
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gvechunk.inc

PUBLIC Default_Compression
PUBLIC Chunk_Type
PUBLIC Chunk_Size
PUBLIC Chunk_Compression
PUBLIC File_Magic
PUBLIC File_Version
PUBLIC File_Handle

Default_Compression	dd ?
Chunk_Type		dd ?
Chunk_Size		dd ?
Chunk_Compression	dd ?
Chunk_Position		dd 8 dup (?)
Chunk_Level		dd 0

File_Magic		dd ?,?
FIle_Version		dd ?
File_Handle		dd ?


;
;
;
;   GOMEZ VECTOR ENGINE                                      CHUNK ROUTINES
;
;
;
;
;
; Creat_File:
;  Input:
; 	EAX 	- Magic1
;	EBX	- Magic2
;	ECX	- Version
; 	EDX	- ptr to file-name
;  Output:
; 	EAX	- File handle
; 	[CF]	- Error flag
;  Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Creat_File
Creat_File PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]
	mov	ds:[File_Magic],eax
	mov	ds:[File_Magic+4],ebx
	mov	ds:[File_Version],ecx

	mov	ebx,edx
	xor	ecx,ecx
	call	Creat
	jc	@@Err
	mov	ds:[File_Handle],eax

	mov	ebx,ds:[File_Handle]
	mov	ecx,12
	mov	edx,OFFSET File_Magic
	call	Write				;Write main-header
	mov	eax,ds:[File_Handle]

@@Err:	pop	ds
	retn
Creat_File ENDP


;
;
; Open_File:
;  Input:
; 	EDX	- ptr to file-name
;  Output:
; 	EAX 	- Magic1
;	EBX	- Magic2
;	ECX	- Version
;	EDX	- File-handle
; 	[CF]	- Error flag
;  Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Open_File
Open_File PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]

	mov	ebx,edx
	mov	ecx,O_RDONLY
	call	Open
	jc	@@Err
	mov	ds:[File_Handle],eax

	mov	ebx,ds:[File_Handle]
	mov	ecx,12
	mov	edx,OFFSET File_Magic
	call	Read				;Write main-header

	mov	eax,ds:[File_Magic]
	mov	ebx,ds:[File_Magic+4]
	mov	ecx,ds:[File_Version]
	mov	edx,ds:[File_Handle]

@@Err:	pop	ds
	retn
Open_File ENDP



;
;
; Close_File:
;  Input:
; 	Nothing
;  Output:
; 	[CF]	- Error flag
;  Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Close_File
Close_File PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]
	mov	ebx,ds:[File_Handle]
	call	Close

	pop	ds
	retn
Close_File ENDP



;
;
; Creat_Chunk:
;  Input:
; 	EAX 	- Chunk-Name
; 	EBX	- Compression
;  Output:
; 	EAX	- Current position
; 	[CF]	- Error flag
;  Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Creat_Chunk
Creat_Chunk PROC NEAR
	test	ebx,ebx
	jnz	short @@Ok
		mov	ebx,ds:[Default_Compression]	;Get standard compression
@@Ok:	mov	ds:[Chunk_Type],eax
	mov	ds:[Chunk_Compression],ebx
	mov	ebx,ds:[File_Handle]
	call	Tell
	mov	ebx,ds:[Chunk_Level]
	inc	ds:[Chunk_Level]
	push	eax
	mov	ds:[Chunk_Position+4*ebx],eax
	mov	ebx,ds:[File_Handle]
	mov	ecx,12
	mov	edx,OFFSET Chunk_Type
	call	Write			;Write block-header
	pop	eax
	retn
Creat_Chunk ENDP


;
;
; Creat_Subchunk:
;  Input:
; 	EAX 	- Chunk-Name
;  Output:
; 	EAX	- Current position
; 	[CF]	- Error flag
;  Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Creat_Subchunk
Creat_Subchunk PROC NEAR
	mov	ds:[Chunk_Type],eax
	mov	ebx,ds:[File_Handle]
	call	Tell
	mov	ebx,ds:[Chunk_Level]
	inc	ds:[Chunk_Level]
	push	eax
	mov	ds:[Chunk_Position+4*ebx],eax
	mov	ebx,ds:[File_Handle]
	mov	ecx,8
	mov	edx,OFFSET Chunk_Type
	call	Write			;Write block-header
	pop	eax
	retn
Creat_Subchunk ENDP


;
;
; Close_Chunk:
;  Input:
; 	Nothing
;  Output:
; 	EAX	- Current position
; 	[CF]	- Error flag
;  Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Close_Chunk
Close_Chunk PROC NEAR
	mov	ebx,ds:[File_Handle]
	call	Tell                    ;Get current position
	push	eax

	dec	ds:[Chunk_Level]
	mov	ecx,ds:[Chunk_Level]

	mov	al,SEEK_SET
	mov	ebx,ds:[File_Handle]
	mov	ecx,ds:[Chunk_Position+4*ecx]
	push	ecx
	add	ecx,4			;
	call	Seek                    ;Seek to block-size

	pop	ecx
	mov	eax,ss:[esp]		;Get block-end position
	sub	eax,ecx
	mov	ds:[Chunk_Size],eax

	mov	ebx,ds:[File_Handle]
	mov	ecx,4
	mov	edx,OFFSET Chunk_Size
	call	Write			;Write block-header

	pop	ecx
	mov	al,SEEK_SET
	mov	ebx,ds:[File_Handle]
	call	Seek                    ;Seek to old position

	retn
Close_Chunk ENDP


;
;
; Close_Subchunk:
;  Input:
; 	Nothing
;  Output:
; 	EAX	- Current position
; 	[CF]	- Error flag
;  Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Close_Subchunk
Close_Subchunk PROC NEAR
	jmp	Close_Chunk
Close_Subchunk ENDP




;
;
; Compress_Chunk:
;  Input:
; 	EAX	- Compression
; 	ECX	- Size of data
; 	EDX	- ptr to data
;  Output:
; 	EAX	- Current position
; 	[CF]	- Error flag
;  Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Compress_Chunk
Compress_Chunk PROC NEAR
	test	eax,eax
	jnz	short @@Ok0
		mov	eax,ds:[Default_Compression]	;Get standard compression
@@Ok0:	cmp	eax,COMPRESSION_NONE
	jne	@@N1
		mov	ebx,ds:[File_Handle]
		call	Write
		jmp	@@End

@@N1:	cmp	eax,COMPRESSION_LZW
	jne	@@N2
		push	ecx			;Save source-size
		push	edx			;Save source-ptr
		mov	ds:[LZW_Uncompressed_Size],ecx
		mov	ebx,ds:[File_Handle]
		call	Tell			;Get current file-position
		mov	ds:[LZW_Block_Address],eax
		mov	ebx,ds:[File_Handle]
		mov	ecx,16			;Size of LZW-header
		mov	edx,OFFSET LZW_Info
		call	Write			;Write LZW header

		pop	edx			;Get source back again
		pop	ecx			;Get source-size
		call	LZW_Encoder		;Pack block
		add	ecx,16			;Get size of whole LZW block
		mov	ds:[LZW_Compressed_Size],ecx

		mov	al,SEEK_SET
		mov	ebx,ds:[File_Handle]
		mov	ecx,ds:[LZW_Block_Address]
		call	Seek			;Seek back to header

		mov	ebx,ds:[File_Handle]
		mov	ecx,16			;Size of LZW-header
		mov	edx,OFFSET LZW_Info
		call	Write			;Write new LZW header

		mov	al,SEEK_CUR
		mov	ebx,ds:[File_Handle]
		mov	ecx,ds:[LZW_Compressed_Size]
		sub	ecx,16
		call	Seek			;Seek back to end of block
		jmp	@@End


@@N2:

@@End:  mov	ebx,ds:[File_Handle]
	call	Tell
	retn
Compress_Chunk ENDP


;
;
; Read_Chunk:
;   Input:
; 	Nothing
;   Output:
; 	EAX	- Compression
; 	ECX	- Compressed block size (without header)
; 	EDX	- Chunk-Type
; 	[CF]	- Error flag
;   Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Read_Chunk
Read_Chunk PROC NEAR
	mov	ebx,ds:[File_Handle]
	mov	ecx,12
	mov	edx,OFFSET Chunk_Type
	call	Read				;Read in chunk header
	pushfd
	mov	eax,ds:[Chunk_Compression]
	mov	ecx,ds:[Chunk_Size]
	mov	edx,ds:[Chunk_Type]
	sub	ecx,12
	popfd
	retn
Read_Chunk ENDP


;
;
; Read_Subchunk:
;   Input:
; 	Nothing
;   Output:
; 	EAX	- Compression
; 	ECX	- Compressed block size (without header)
; 	EDX	- Chunk-Type
; 	[CF]	- Error flag
;   Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Read_Subchunk
Read_Subchunk PROC NEAR
	mov	ebx,ds:[File_Handle]
	mov	ecx,8
	mov	edx,OFFSET Chunk_Type
	call	Read				;Read in chunk header
	pushfd
	mov	eax,COMPRESSION_NONE
	mov	ecx,ds:[Chunk_Size]
	mov	edx,ds:[Chunk_Type]
	sub	ecx,8
	popfd
	retn
Read_Subchunk ENDP



;
;
; Uncompress_Chunk:
;   Input:
; 	EAX	- Compression
; 	ECX	- Compressed block size
;   Output:
; 	EAX	- Ptr to uncompressed block
; 	[CF]	- Error flag
;   Destroys:
; 	EAX,EBX,ECX,EDX
;
PUBLIC Uncompress_Chunk
Uncompress_Chunk PROC NEAR
	push	esi
	push	edi
	push	ebp
	cmp	eax,COMPRESSION_NONE
	jne	short @@Test_LZW
		push	ecx             ;Save block-size
		call	Malloc
		pop	ecx
		jc	@@Err
		push	eax		;Save block-adr
		mov	edx,eax		;Dest for read
		mov	ebx,ds:[File_Handle]
		call	Read
		pop	eax
		jmp	@@End

@@Test_LZW:
	cmp	eax,COMPRESSION_LZW
	jne	short @@Err
		mov	ebx,ds:[File_Handle]
		mov	ecx,16
		mov	edx,OFFSET LZW_Info
		call	Read			;Get size of uncompressed block
		mov	ecx,ds:[LZW_Uncompressed_Size]
		call	Malloc			;Allocate dst(uncrunched) block
		jc	@@Err
		mov	edi,eax			;EDI = ptr to dst
		mov	ecx,ds:[LZW_Compressed_Size]
		sub	ecx,16          	;Subtract header size
		call	Malloc			;Allocate src(compressd) block
		jc	@@Err
		mov	esi,eax			;ESI = ptr to LZW-src

		mov	ebx,ds:[File_Handle]
		mov	ecx,ds:[LZW_Compressed_Size]
		sub	ecx,16
		mov	edx,esi
		call	Read			;Read LZW-Stuff
		jc	@@Err
		call	LZW_Decoder

		mov	ecx,esi
		call	Free			;Free LZW-buffer
		mov	eax,edi			;Return ptr to uncompressed stuff
		jmp	@@End

@@Err:	xor	eax,eax
	stc
@@End:  pop	ebp
	pop	edi
	pop	esi
	retn
Uncompress_Chunk ENDP



;
;
;
;   GOMEZ VECTOR ENGINE                            (DE)COMPRESSION ROUTINES
;
;
;
;
;
; This is a LZW-Decoder used for data-uncompression. It is extremly
; optimized, and thus very difficult to read. Be warned !
; If yu want to understand this thing, I can advise you to read some
; original 'C' sources in one of the following books (they all deal with
; GIF decompression):
;           "The C Graphics Handbook"
;                 by Roger T. Stevens
;                 published by the Academic Press
;           "Bit-mapped Graphics 2nd edition"
;		   by Steve Rimmer  (I like his books very much !)
;		   published by Windcrest/McGraw-Hill
;           "Supercharged Bitmapped Graphics"
;                 by Steve Rimmer
;                 published by Windcrest/McGraw-Hill
;           "Super VGA Graphics Programming Secrets"
;                 by Steve Rimmer
;                 published by Windcrest/McGraw-Hill
;
LZW_Info	LABEL BYTE
LZW_Compressed_Size	dd	?
LZW_Uncompressed_Size	dd	?
LZW_Block_Address	dd	?
			dd	?

LZW_Stack_Size		equ 	4096
LZW_Table_Size		equ	5003
LZW_Largest_Code	equ     4095
LZW_Code_Size		equ 	8
LZW_Clear_Code		equ     (1 shl LZW_Code_Size)
LZW_End_Code		equ	(LZW_Clear_Code+1)
LZW_Start_Slot		equ	(LZW_End_Code+1)

LZW_Free_Code		dd 	?
LZW_OldCode_Table	dd	?
LZW_CurrentCode_Table	dd	?
LZW_NewCode_Table	dd	?
LZW_Fix_Table 		dd 	?
LZW_Max_Code		dd      ?
LZW_Stack		dd	?



;
;LZW_Get_NCode:
;  Input:
;	Nothing
;  Output:
;	EBX	-	Next code
;  Destroys:
;	EAX,EBX,ECX,EBP
;
LZW_Get_NCode PROC NEAR			;Result will be in EBX
	db	0bdh			;mov ebp,cs:[LZW_Buffer_Pointer]
	LZW_Buffer_Pointer	dd	?
	db	0b9h                    ;Mov ecx,cs:[Bits_Left]
	Bits_Left	db	?
	Code_Size	db	?	;CH=codesize CL=bits_left
			dw	?
	test cl,cl
	jnz short LZW_Bits_Left
		movzx 	ebx,byte ptr ds:[ebp]
		mov 	ds:[Last_Byte],ebx
		inc 	ebp
		jmp 	short @@G100

  LZW_Bits_Left:
	db 	0bbh                   	;mov ebx,Last_Byte
	Last_Byte	dd	?
	shl 	ebx,cl                 	;code=Last_Byte >> (8- bits_left)
	shr 	ebx,8
  NCode_Loop:   movzx 	eax,byte ptr ds:[ebp]
		mov 	ds:[Last_Byte],eax
		inc 	ebp
		shl 	eax,cl
		or 	ebx,eax
	@@G100:	add 	cl,8
		cmp 	ch,cl
		ja 	short NCode_Loop



  Ready_Get_Code:
	sub 	cl,ch
	mov 	ds:[Bits_left],cl
	mov 	ds:[LZW_Buffer_Pointer],ebp
	db	81h,0e3h
  Code_Mask	dd	?		;and ebx,1234h

	retn
LZW_Get_NCode ENDP





;
;LZW_Decoder:
;  Input:
;       ESI	- src-ptr
;	EDI	- dst-ptr
;  Output:
;	EDI	- uncompressed LZW
;  Destroys:
;	EAX,EBX,ECX,EDX
;
LZW_Decoder PROC NEAR
	cld
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ds:[LZW_Buffer_Pointer],esi
	mov	ds:[LZW_Destination],edi

	mov	ecx,4*LZW_Stack_Size+4
	call 	Malloc
	mov 	ds:[LZW_Fix_Table],eax

	mov	ecx,2*LZW_Stack_Size
	call	Malloc
	mov	ds:[LZW_Stack],eax

	mov 	ds:[LZW_Top],1 shl (LZW_Code_Size+1)
	mov	ds:[LZW_Slot],LZW_Start_Slot
	mov 	ds:[Code_Size],LZW_Code_Size+1
	mov	ds:[Code_Mask],1ffh

	mov 	ds:[Bits_left],0
	mov 	ds:[Last_Byte],0

	mov	edi,ds:[LZW_Stack]		;DS:EDI points to stack
	mov 	esi,ds:[LZW_Fix_Table]		;DS:ESI -> LZW_Last (bytes)
 LZW_Main_Loop:
	call 	LZW_Get_NCode			;Code is in EBX
	cmp 	ebx,LZW_End_Code
	je 	LZW_Decode_End
	cmp 	ebx,LZW_Clear_Code
	je 	Clear_Code

   Decode_Code:
	   mov 	ecx,ebx                        	;ECX=ch
	   db	0bdh				;mov EBP,ds:[LZW_Slot]
	   LZW_Slot 	dd 	?               ;EBP = LZW_Slot
	   cmp 	ebx,LZW_Start_Slot
	   jb 	short Decoded
	   cmp 	ebx,ebp
	   jb 	short Decode_Loop
	       mov 	ebx,edx			;EDX=Old_Code
	       db	0b0h			;MOV al,ds:[First_Colour]
	       First_Colour	db	?
	       stosb
	       cmp 	ebx,LZW_Start_Slot
	       jb 	short Decoded
   Decode_Loop:
	       mov 	al,ds:[esi+4*ebx]
	       stosb				;put code onto stack
	       movzx 	ebx,w ds:[esi+4*ebx+2]	;code=link[code]
	       cmp 	ebx,LZW_Start_Slot
	       jae 	short Decode_Loop

   Decoded:
	   mov 	eax,ebx
	   stosb
	   db 81h,0fdh				;cmp EBP,LZW_Top
	   LZW_Top	dd	?
	   jae 	short No_New_Slot
		mov 	ds:[First_Colour],al	;fc=code
		mov 	ds:[esi+4*ebp],ax
		mov 	ds:[esi+4*ebp+2],dx    	;DX=Old_Code
		mov     edx,ecx			;Old_Code=ch
		inc 	ds:[LZW_Slot]
		inc 	ebp

	   cmp  ebp,ds:[LZW_Top]
	   jb 	short No_New_Code_Size
   No_New_Slot:
	   cmp 	ds:[Code_Size],12
	   jae	short No_New_Code_Size
		shl 	ds:[LZW_Top],1
		inc 	ds:[Code_Size]
		stc				;Set carry
		rcl	ds:[Code_Mask],1

   No_New_Code_Size:
	   mov 	ebx,edi
	   mov	edi,ds:[LZW_Stack]
	   sub 	ebx,edi
	   db 0bdh				;mov ebp,cs:[LZW_Destination]
	   LZW_Destination	dd	?
       Unstack_Loop:
		mov 	al,ds:[edi+ebx-1]
		mov 	ds:[ebp],al
		inc     ebp
		dec 	ebx
       jnz short Unstack_Loop
	   mov	ds:[LZW_Destination],ebp
	   jmp 	LZW_Main_Loop



 CLear_Code:
	mov 	ds:[Code_Size],LZW_Code_Size+1
	mov 	ds:[LZW_Top],1 shl (LZW_Code_Size+1)
	mov	ds:[LZW_Slot],LZW_Start_Slot
	mov	ds:[Code_Mask],1ffh
   Get_All_Clear_Codes:
	   call LZW_Get_NCode
	   cmp 	ebx,LZW_Clear_Code
	   je 	short Get_All_Clear_Codes
	mov 	ds:[First_Colour],bl
	mov 	eax,ebx
	mov	edx,ebx
	stosb
	jmp 	No_New_Code_Size

 LZW_Decode_End:
	mov	ecx,ds:[LZW_Fix_Table]
	call 	Free
	mov	ecx,ds:[LZW_Stack]
	call	Free

	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn
LZW_Decoder ENDP



;
;
; This is the LZW-Encoder used for data-compression. It is also extremly
; optimized, and thus very difficult to read. Be warned !
;
;
;LZW_Write_Code:
; Input:
;	EAX	- code
; Output:
;	Nothing
; Destroys:
;	EAX,EBX,ECX,EDX
;
LZW_Write_Code PROC NEAR
	db	0bbh			;mov ebx,ds:[bit_offset]
	bit_offset 	dd 	0
	shr	ebx,3
	mov	edx,ds:[LZW_Stack]	;EDX = LZW_Stack
	mov	ds:[byte_offset],ebx	;EBX = byte_offset
	mov	ecx,ds:[bit_offset]
	and	cl,7
	mov	ds:[bits_left],cl	;CL = bits_left

	cmp	ebx,254
	jl	short @@NoFlush
		push	eax
		call    LZW_Flush_Buffer
		mov	ebx,ds:[byte_offset]
		mov	edx,ds:[LZW_Stack]
		mov	al,ds:[edx+ebx]
		mov	ds:[edx],al
		pop	eax
		movzx	ecx,ds:[bits_left]
		mov	ds:[bit_offset],ecx
		mov	ds:[byte_offset],0
		jmp	short @@NoFlush
@@NoFlush:
	db	0bbh			;mov ebx,ds:[byte_offset]
	byte_offset	dd 0		;EBX = byte_offset
	cmp	cl,0			;Is bits_left > 0
	jle	short @@1
		shl	eax,cl		;code << bits_left
		or	al,ds:[edx+ebx]
	@@1:	mov	d ds:[edx+ebx],eax

@@E:	movzx	ecx,ds:[code_size]
	add	ds:[bit_offset],ecx
	retn
LZW_Write_Code ENDP



;
;LZW_Flush_Buffer
; Input:
;	EBX	- size of buffer
; Output:
;	EAX	- bytes written
; Destroys:
;	EAX,EBX,ECX,EDX
;
LZW_Flush_Buffer PROC NEAR
	mov	ecx,ebx
	mov	ebx,ds:[File_Handle]
	mov	edx,ds:[LZW_Stack]
	call	Write
	add	ds:[LZW_Compressed_Size],eax
	retn
LZW_Flush_Buffer ENDP


;
;LZW_Encoder:
; Input:
;	EDX	- src ptr
;	ECX	- src size
; Output:
;  	ECX	- compressed size in bytes
; Destroys:
;	EAX,EBX,ECX,EDX
;
LZW_Encoder PROC NEAR
	push	esi
	push	edi
	push	ebp
	mov	ds:[bit_offset],0
	mov	ds:[LZW_Compressed_Size],0
	mov	esi,edx
	add	ecx,esi				;ECX holds last byte
	mov	ds:[source_end],ecx

	mov	ecx,2*LZW_Stack_Size
	call	Malloc
	mov	ds:[LZW_Stack],eax
	mov	ecx,4*LZW_Table_Size
	call	Malloc
	mov	ds:[LZW_OldCode_Table],eax
	mov	ecx,4*LZW_Table_Size
	call	Malloc
	mov	ds:[LZW_NewCode_Table],eax
	mov	ecx,4*LZW_Table_Size
	call	Malloc
	mov	ds:[LZW_CurrentCode_Table],eax
	mov	edi,eax
	mov	ecx,LZW_Table_Size
	xor	eax,eax
	rep	stosd				;Clear this table

	;
	;Initialistaion of tables etc...
	mov	ds:[code_size],LZW_Code_Size+1
	mov	ds:[LZW_Free_Code],LZW_Start_Slot
	mov	ds:[LZW_Max_Code],1 shl (LZW_Code_Size+1)

	mov	eax,LZW_Clear_Code
	call	LZW_Write_Code			;First write a clear-code
	movzx	edi,byte ptr ds:[esi]		;EDI = prefix_code
	inc	esi

	;
	;Here begins the main loop !
	;
	;Some standard register allocation:
	;	EDX	- hx
	;	ESI	- d
	;	EDI	- prefix_code
	;	EBP	- suffix_code
	;
@@L1:	db	81h,0feh			;cmp esi,source_end
	source_end	dd	?
	jae	@@End				;Are there bytes left ???
	movzx	ebp,byte ptr ds:[esi]		;EBP = suffix_char
	inc	esi
	push	esi				;Save source-ptr

	;hx=(prefix_code ^ (suffix_char << 5)) % table_size;
	mov	eax,edi				;EAX = prefix_code
	mov	edx,ebp				;EDX = suffix_char
	shl	edx,5				;EDX <<= 5
	xor	eax,edx
	xor	edx,edx
	mov	ebx,LZW_Table_Size
	div	ebx				;EDX = hx
	mov	esi,1				;ESI = d = 1

	@@L2:	mov	eax,ds:[LZW_CurrentCode_Table]
		cmp	d ds:[eax+4*edx],0	;if(currentcode[hx] == 0)
		jne	@@J1
			push	edx		;Save hx
			mov	eax,edi		;EAX = prefix_code
			call	LZW_Write_Code	;Write prefix code
			pop	edx		; and get again hx !
			mov	esi,ds:[LZW_Free_Code]

			cmp	esi,LZW_Largest_Code
			ja	short @@TooBig
				mov	eax,ds:[LZW_OldCode_Table]
				mov	ds:[eax+4*edx],edi
				mov	eax,ds:[LZW_NewCode_Table]
				mov	ds:[eax+4*edx],ebp
				mov	eax,ds:[LZW_CurrentCode_Table]
				mov	ds:[eax+4*edx],esi
				inc	ds:[LZW_Free_Code]
		@@TooBig:
			cmp	esi,ds:[LZW_Max_Code]
			jne	short @@J2
				cmp	ds:[Code_Size],12
				jae	short @@NewInit
					inc	ds:[code_size]
					shl	ds:[LZW_Max_Code],1
					jmp	short @@J2
				@@NewInit:
					mov	eax,LZW_Clear_Code
					call	LZW_Write_Code
					mov	ds:[code_size],LZW_Code_Size+1
					mov	ds:[LZW_Free_Code],LZW_Start_Slot
					mov	ds:[LZW_Max_Code],1 shl (LZW_Code_Size+1)
					mov	edi,ds:[LZW_CurrentCode_Table]
					xor	eax,eax
					mov	ecx,LZW_Table_Size
					rep	stosd
		@@J2:	mov	edi,ebp		;prefix_code = suffix_char
			jmp	@@BRK

		@@J1:	mov	eax,ds:[LZW_OldCode_Table]
			cmp	ds:[eax+4*edx],edi
			jne	short @@J4
			mov	eax,ds:[LZW_NewCode_Table]
			cmp	ds:[eax+4*edx],ebp
			jne	short @@J4
				mov	eax,ds:[LZW_CurrentCode_Table]
				mov	edi,ds:[eax+4*edx]
				jmp	@@BRK
		@@J4:	add	edx,esi		;hx += d
			add	esi,2		;d += 2
			cmp	edx,LZW_Table_Size
			jb	@@L2
				sub	edx,LZW_Table_Size
			jmp	@@L2

@@BRK:	pop	esi
	jmp	@@L1				;End of main loop

@@End:	mov	eax,edi
	call	LZW_Write_Code
	mov	eax,LZW_End_Code
	call	LZW_Write_Code
	cmp	ds:[bit_offset],0
	jle	short @@Ok
		mov     ebx,ds:[bit_offset]
		add	ebx,7
		shr	ebx,3
		call	LZW_Flush_Buffer

	;
	;Release buffer memory
@@Ok:   mov	ecx,ds:[LZW_CurrentCode_table]
	call	Free
	mov	ecx,ds:[LZW_NewCode_table]
	call	Free
	mov	ecx,ds:[LZW_OldCode_table]
	call	Free
	mov	ecx,ds:[LZW_Stack]
	call	Free
	mov	ecx,ds:[LZW_Compressed_Size]
	pop	ebp
	pop	edi
	pop	esi
	retn
LZW_Encoder ENDP
CODE32 ends
END