;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
COLOUR_SYSTEM_FILE		equ	1

;
;
;
;   GOMEZ VECTOR ENGINE                                            v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gve32.inc


;
;
;
;   GOMEZ VECTOR ENGINE                                     COLOUR ROUTINES
;
;
;
ALIGN dword
LColour	LABEL DWORD
	LColour_Red		db	?
	LColour_Green		db	?
	LColour_Blue		db	?
				db	?
SColour	LABEL DWORD
	SColour_Red		db	?
	SColour_Green		db	?
	SColour_Blue		db	?
				db	?
AColour	LABEL DWORD
	AColour_Red		db	?
	AColour_Green		db	?
	AColour_Blue		db	?
				db	?

Specular			dd	?

;
;
; Now follows a LUT-Generator in order to get a shading LUT for a given 3*6
; bit palette.
;
;
; GVE_Fir_Colour:
;  Input:
;	EAX   	- colour to fit	(3*8 bit)
;	DS:ESI 	- DATA32 ptr to palette	(3*8 bit)
;  Output:
;	EDX     - Best difference
;	CH	- Best colour
;  Destroys:
;	EAX,EBX,ECX,EDX
;
;  All colours have the following format:
;	8bit   8bit  8bit   8bit
;	 EAH    EAL   AH     AL
;	  ?    Blue  Green  Red
;
PUBLIC GVE_Fit_Colour
GVE_Fit_Colour PROC NEAR
	push 	esi		;Save old colour-ptr
	push	edi
	push	ebp

	mov	ebp,eax		;EBP = Colour to fit
	mov	ebx,esi		;EBX = Ptr to palette
	movzx	esi,dl		;ESI = Red
	movzx	edi,dh		;EDI = Green
	shr	ebp,16
	and	ebp,0ffh        ;EBP = Blue
	xor	ecx,ecx		;CL  = Counter     CH = Best colour
	mov 	edx,0fffh	;EDX = Difference
	@@L1:	push	ecx
		movzx 	eax,b ds:[ebx]
		sub	eax,esi		;EAX = Red difference
		jns 	short @@1
		neg 	eax
	@@1:   	movzx	ecx,b ds:[ebx+1]
		sub	ecx,edi		;ECX = Green difference
		jns 	short @@2
		neg 	ecx
	@@2:	add 	eax,ecx
		movzx 	ecx,b ds:[ebx+2]
		sub 	ecx,ebp		;ECX = Blue difference
		jns 	short @@3
		neg 	ecx
	@@3:	add 	eax,ecx		;EAX = total difference
		pop	ecx
		cmp     eax,edx		;Compare differences
		jae	short @@No
			mov	edx,eax	;Best difference
			mov	ch,cl	;Best index
	@@No: 	add	ebx,4
		inc	cl
		jnz	short @@L1

	pop	ebp
	pop	edi
	pop	esi
	retn
GVE_Fit_Colour ENDP

;
;
; This macro converts a 32bit colour value into a 15/16bit colour value
;
; REDUCE_COLOUR:
;  Input:
;	EDX	- 32bit colour value
;  Output:
;	AX	- 15/16bit colour value
;  Destroys:
;	EAX,ECX,EDX
;
REDUCE_COLOUR MACRO
	mov	ecx,16
	sub	ecx,ds:[GVE_Frame_Depth]
	bswap	edx
	shld	eax,edx,5
	shl	edx,8
	shld	eax,edx,6
	shr	eax,cl
	shl	edx,8
	shld	eax,edx,5
	ENDM

;
;
; Now some macros for calculating shading colours
;   DARKEN_COLOUR
;   BRIGHTEN_COLOUR
;   DIFFUSE_COLOUR
;   SPECULAR_COLOUR
;
; Notes on the calculation:
;      Darkening: (0  i  32)
;	   dr(r,i,darkness)=(r*i + (32-i)*((64-Darkness)*r + Darkness*0)/64) /32
;	Lightening: (0  i  32)
;	   lr(r,i,brightness,br)=((32-i)*r + i*((64-Brightness)*r + Brightness*br)/64) /32
;
;	Diffuse_Reflection: (0  i  32)
;         diff(red,i) = (A_red*red + (i*L_red*red)/32)/256
;	Specular_Reflection: (0  i  32)
;         spec(red,i) = (A_red*red + L_red*red + L_red*i*spec/8)/256
;
DIFFUSE_COLOUR MACRO scol,acol,lcol,i
	LOCAL J
	movzx	eax,scol
	movzx	ebx,acol
	imul	ebx,eax			;EBX = A_red*red
	movzx	edx,lcol
	imul	eax,edx			;EAX = L_red*red
	imul	eax,i			;EAX = L_red*red*i
	sar	eax,5
	add	eax,ebx			;EAX = A_red*red + L_red*red*i/32
	sar	eax,8			;EAX = (A_red*red + L_red*red*i/32
	cmp	eax,255
	jl	short J
	mov	eax,255
J:
	ENDM

SPECULAR_COLOUR MACRO scol,acol,lcol,i,spec
	LOCAL J
	movzx	eax,scol
	movzx	ebx,acol
	imul	ebx,eax			;EBX = A_red*red
	movzx	edx,lcol
	imul	eax,edx			;EAX = L_red*red
	add	eax,ebx			;EAX = A_red*red + L_red*red
	imul	edx,i			;EDX = L_red*i
	imul	edx,spec
	sar	edx,3
	add	eax,edx			;EAX = A_red*red + L_red*red + L_red*i*spec/8
	sar	eax,8
	cmp	eax,255
	jl	short J
	mov	eax,255
J:
	ENDM

DARKEN_COLOUR MACRO col_src,count
	LOCAL J
	movzx	eax,col_src		;Get original colour
	mov     ebx,64
	sub	ebx,ds:[Darkness]
	imul	ebx			;EAX holds (64-Darkness)*r
	mov	ebx,31
	sub	ebx,count		;EBX = 31-i
	imul	ebx			;EAX = (31-i)*64-Darkness*r
	shr	eax,6			;EAX = (31-i)*(64-Darkness*r/64)
	movzx	edx,col_src
	imul	edx,count		;EDX = r*i
	add	eax,edx			;Add both results
	shr	eax,5			;Divide by 32
	cmp	eax,255			;Clip colour value
	jbe	short J
		mov	eax,255
J:	ENDM

BRIGHTEN_COLOUR MACRO col_src,col_light,count
	LOCAL J
	movzx	eax,col_src		;Get original colour
	mov     ebx,64
	sub	ebx,ds:[Brightness]
	imul	ebx			;EAX holds (64-Brightness)*r
	movzx	edx,col_light
	imul	edx,ds:[Brightness]	;EDX = Brightness*light_colour
	add	eax,edx			;EAX = (64-Brightness)*r + Brightness*light_colour
	imul	count			;EAX = i * EAX
	shr	eax,6			;EAX /= 64
	movzx	edx,col_src		;Get source-colour
	mov	ebx,32
	sub	ebx,count		;EBX = (32 - i)
	imul	edx,ebx  		;EDX = (32-i) * r
	add	eax,edx			;Add both results
	shr	eax,5			;Divide by 32
	cmp	eax,255			;Clip colour value
	jbe	short J
		mov	eax,255
J:	ENDM

;
;
; GVE_Shade_Colour:
;  Input:
;	EAX	- SOurce Colour
;      BL 	- Strength      (0[Dark] to +32[Diffuse] to +64[Specular])
;      BH 	- Specular intensity (0 to 64)
;	ECX	- Ambient colour
;	EDX	- Light Colour
;  Output:
;	EAX	- Shaded colour
;
;  All colours have the following format:
;	8bit   8bit  8bit   8bit
;	 E?H    E?L   ?H     ?L
;	  ?    Blue  Green  Red
;
PUBLIC GVE_Shade_Colour
GVE_Shade_Colour PROC NEAR
	push	ebp
	xor	ebp,ebp
	mov	ds:[SColour],eax
	mov	ds:[AColour],ecx
	mov	ds:[LColour],edx
	mov	b ds:[Specular],bh
	movzx	ecx,bl
	cmp	ecx,32
	jle	@@Diff
	;
	sub	ecx,32
	SPECULAR_COLOUR ds:[SColour_Red],ds:[AColour_Red],ds:[LColour_Red],ecx,ds:[Specular]
	shrd	ebp,eax,8
	SPECULAR_COLOUR ds:[SColour_Green],ds:[AColour_Green],ds:[LColour_Green],ecx,ds:[Specular]
	shrd	ebp,eax,8
	SPECULAR_COLOUR ds:[SColour_Blue],ds:[AColour_Blue],ds:[LColour_Blue],ecx,ds:[Specular]
	shrd	ebp,eax,16
	mov	eax,ebp                 ;Put RGB-value into EAX
	jmp	@@End
	;
@@Diff:	DIFFUSE_COLOUR ds:[SColour_Red],ds:[AColour_Red],ds:[LColour_Red],ecx
	shrd	ebp,eax,8
	DIFFUSE_COLOUR ds:[SColour_Green],ds:[AColour_Green],ds:[LColour_Green],ecx
	shrd	ebp,eax,8
	DIFFUSE_COLOUR ds:[SColour_Blue],ds:[AColour_Blue],ds:[LColour_Blue],ecx
	shrd	ebp,eax,16
	mov	eax,ebp                 ;Put RGB-value into EAX
	;
@@End:	pop	ebp
	retn
GVE_Shade_COlour ENDP


;
;
; GVE_Fit_Palette:
;  Input:
;	EAX	- Active palette (dst.)
;	EBX	- Virtual palette (src.)
;	EDX	- LUT-Buffer
;  Output:
;	CF	- Error flag
;
PUBLIC GVE_Fit_Palette
GVE_Fit_Palette PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	esi,eax				;ESI = active palette
	mov	ebp,ebx				;EBP = virtual palette
	mov	edi,edx				;EDI = translation LUT
	xor	ecx,ecx                         ;CL  = counter
	@@L2:   push	ecx
		mov	eax,ds:[ebp+4*ecx]	;EAX = palette to fit
		and	eax,0ffffffh		;Get olds colour in EDX
		call	GVE_Fit_Colour		;Get best colour
		mov	ds:[edi],ch		;Save it into LUT
		pop	ecx
		inc	edi			;Next LUT-entry
		inc	cl
		jnz	@@L2                    ;Loop !

	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn
GVE_Fit_Palette ENDP
CODE32 ENDS
END