;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;

;
;
; This macro converts a 32bit colour value into a 15/16bit colour value
;
; REDUCE_COLOUR:
;  Input:
;	EDX	- 32bit colour value
;  Output:
;	AX	- 15/16bit colour value
;  Destroys:
;	EAX,ECX,EDX
;
REDUCE_COLOUR MACRO
	mov	ecx,16
	sub	ecx,ds:[GVE_Frame_Depth]
	bswap	edx
	shld	eax,edx,5
	shl	edx,8
	shld	eax,edx,6
	shr	eax,cl
	shl	edx,8
	shld	eax,edx,5
	ENDM

;
;
; Now some macros for calculating shading colours
;   DARKEN_COLOUR
;   BRIGHTEN_COLOUR
;
; Notes on the calculation:
;      Darkening: (0  i  31)
;	   dr(r,i,darkness)=(r*i + (32-i)*((64-Darkness)*r + Darkness*0)/64) /32
;	Lightening: (0  i  31)
;	   lr(r,i,brightness,br)=((32-i)*r + i*((64-Brightness)*r + Brightness*br)/64) /32
;
DARKEN_COLOUR MACRO col_src,count
	LOCAL J
	movzx	eax,col_src		;Get original colour
	mov     ebx,64
	sub	ebx,ds:[Darkness]
	imul	ebx			;EAX holds (64-Darkness)*r
	mov	ebx,31
	sub	ebx,count		;EBX = 32-i
	imul	ebx			;EAX = (32-i)*64-Darkness*r
	shr	eax,6			;EAX = (32-i)*(64-Darkness*r/64)
	movzx	edx,col_src
	imul	edx,count		;EDX = r*i
	add	eax,edx			;Add both results
	shr	eax,5			;Divide by 32
	cmp	eax,255			;Clip colour value
	jbe	short J
		mov	eax,255
J:	ENDM

BRIGHTEN_COLOUR MACRO col_src,col_light,count
	LOCAL J
	movzx	eax,col_src		;Get original colour
	mov     ebx,64
	sub	ebx,ds:[Brightness]
	imul	ebx			;EAX holds (64-Brightness)*r
	movzx	edx,col_light
	imul	edx,ds:[Brightness]	;EDX = Brightness*light_colour
	add	eax,edx			;EAX = (64-Brightness)*r + Brightness*light_colour
	imul	count			;EAX = i * EAX
	shr	eax,6			;EAX /= 64
	movzx	edx,col_src		;Get source-colour
	mov	ebx,32
	sub	ebx,count		;EBX = (32 - i)
	imul	edx,ebx  		;EDX = (32-i) * r
	add	eax,edx			;Add both results
	shr	eax,5			;Divide by 32
	cmp	eax,255			;Clip colour value
	jbe	short J
		mov	eax,255
J:	ENDM


ifndef COLOUR_SYSTEM_FILE
extrn GVE_Shade_Colour:near
extrn GVE_Fit_Colour:near
extrn GVE_Fit_Palette:near
endif