;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
GVE_SYSTEM_FILE		equ	1



;
;
;
;   GOMEZ VECTOR ENGINE                                            v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gve32.inc
include gvechunk.inc


extrn GVE_IO_Buffer:BYTE
extrn GVE_Read_Video_Body:near
extrn GVE_Alloc_Texture:near
extrn GVE_Reference_Primitives:near
extrn GVE_DeReference_Primitives:near
extrn GVE_Link_Tracks:near
extrn C GVE_Alloc_World:near
extrn C GVE_Free_World:near
extrn C GVE_Alloc_Bitmap:near
extrn C GVE_Open_Video:near



;
;
;
;   GOMEZ VECTOR ENGINE                                FILE I/O ROUTINES
;
;
;
;
;
; Now follows a GVE-file loader
;
; GVE_Load_World:
;  Input:
;      EBX	-  DATA32 ptr to file-name
;	EDX	-  Start-position  (Normally set to zero)
;  Output:
;	CF 	-  error flag
;	EAX	-  ptr to world-header
;  Destroys:
;	EAX,EBX,ECX,EDX
;
ALIGN 4
WHeader		dd	?
OldESP		dd	?

GVE_Magic_List	LABEL DWORD
		db	"NAME"
		dd	OFFSET Read_NAME
		db	"PAL",0
		dd	OFFSET Read_PAL
		db	"TLUT"
		dd	OFFSET Read_TLUT
		db	"SLUT"
		dd	OFFSET Read_SLUT
		db	"BLUT"
		dd	OFFSET Read_BLUT
		db	"LIGH"
		dd	OFFSET Read_LIGH
		db	"OBJS"
		dd	OFFSET Read_OBJS
		db	"FLAG"
		dd	OFFSET Read_FLAG
		db	"TEXT"
		dd	OFFSET Read_TMAP
		db	"TMAP"
		dd	OFFSET Read_TMAP
		db	"LMAP"
		dd	OFFSET Read_LMAP
		db	"BMAP"
		dd	OFFSET Read_BMAP
		db	"VIDO"
		dd	OFFSET Read_VIDO
		db	"VIEW"
		dd	OFFSET Read_VIEW
		db	"SCRP"
		dd	OFFSET Read_SCRP
		db	"(I)",0
		dd	OFFSET Read_Information
		db	"(S)",0
		dd	OFFSET Read_Software
		db	"(C)",0
		dd	OFFSET Read_Copyright
		dd	0


PUBLIC C GVE_Load_World
GVE_Load_World PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]		;Important !
	mov	es,ds:[DATA32_Selector]
	mov	ds:[OldESP],esp
	;
	mov	edx,ebx
	call	Open_File
	jc	@@Err

	cmp	eax,'FEVG'
	jne	@@Err
	cmp	ebx,'ELI'			;Compare file magic
	jne	@@Err
	;
	call	GVE_Alloc_World
	jc	@@Err
	mov	ds:[WHeader],eax
	mov	esi,eax				;ESI = World-header

	mov	ecx,ds:[esi+World_Palette]
	mov	ds:[esi+World_Palette],0
	call	Free
	mov	ecx,ds:[esi+World_Software_Text]
	mov	ds:[esi+World_Software_Text],0
	call	Free
	;
	;
	; First read in all chunks
	;
	clc
@@L1:   jc	@@Err				;Carry ==> Error !
	call	Read_Chunk
	jc	@@Err
	;
	mov	ebp,OFFSET GVE_Magic_List
	cmp	edx,'DNE'
	je	@@End
	@@L2:   mov	ebx,ds:[ebp]
		add	ebp,8
		test	ebx,ebx
		jz	short @@Skp
		cmp	edx,ebx
		jne	short @@L2
		call	d ds:[ebp-4]
		jmp	short @@L1
	;
@@Skp:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1

@@End:	;
	call	Close_File
	;
	mov	ebp,ds:[esi+World_Object_List]	;EBP = ptr to object-lis
	mov	edi,ds:[ebp]			;EDI = Number of objects
	test	edi,edi
	jz	@@N1
@@L3:		mov	eax,ds:[ebp+4*edi]
		call	GVE_Reference_Primitives
		dec	edi
		jnz	short @@L3
@@N1:   ;
	ifdef GVE_VIDEO_TEXTURES
	 mov	ebp,ds:[esi+World_Video_List]
	 mov	edi,ds:[ebp]
	 test	edi,edi
	 jz	@@N2
	 @@L4:  mov	edx,ds:[ebp+4*edi]	;EDX = Video-Header
		mov	eax,esi			;EAX = WOrld-header
		call	GVE_Open_Video
		dec	edi
		jnz	short @@L4
	endif
@@N2:	;
	mov	eax,esi				;EAX = world-header
	call	GVE_Link_Tracks
	mov	eax,esi
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn


Load_Error:
@@Err:  mov	esp,ds:[OldESP]
	mov	eax,ds:[WHeader]
	stc

	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Load_World ENDP
;
Read_NAME:
	call	Uncompress_Chunk
	jc	Load_Error
	push	esi
	push	edi
	mov	ecx,128/4
	lea	edi,[esi+World_Name]
	mov	esi,eax
	rep	movsd
	pop	edi
	pop	esi
	mov	ecx,eax
	call	Free
	retn
;
Read_INFORMATION:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ds:[esi+World_Information_Text],eax
	retn
;
Read_SOFTWARE:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ds:[esi+World_Software_Text],eax
	retn
;
Read_COPYRIGHT:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ds:[esi+World_Copyright_Text],eax
	retn
;
Read_PAL:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ds:[esi+World_Palette],eax
	retn
;
Read_TLUT:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ds:[esi+World_Glass_LUT8],eax
	retn
;
Read_BLUT:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ds:[esi+World_Bump_LUT8],eax
	retn
;
Read_SLUT:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ds:[esi+World_Shading_LUT8],eax
	retn
;
Read_LIGH:
@@L1:   call	Read_Chunk
	jc	Load_Error
	;
	cmp	edx,'DNE'
	je	@@End
	cmp	edx,'TNOP'
	jne	short @@N1
		call	LIGH_Read_PONT
		jmp	@@L1
@@N1:	cmp	edx,'TOPS'
	jne	short @@N2
		call	LIGH_Read_SPOT
		jmp	@@L1
@@N2:	cmp	edx,'BMA'
	jne	short @@N3
		call	LIGH_Read_AMB
		jmp	@@L1
@@N3:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1
@@End:	;
	mov	esi,ds:[WHeader]
	clc
	retn
;
LIGH_Read_PONT:
LIGH_Read_SPOT:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ebx,eax				;EBX = Loaded chunk
	mov	ecx,GVE_LIGHT_SIZE
	call	Realloc
	jc	Load_Error
	mov	edi,eax				;EDI = new light header
	;
	mov	ebx,ds:[esi+World_Light_List]	;EBX = ptr to light list
	inc	dword ptr ds:[ebx]		;Increment light-counter
	mov	ecx,ds:[ebx]			;ECX = number of allocated lights
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_Light_List],eax	;EAX = new light list
	;
	mov	ecx,ds:[eax]			;ECX = light counter
	mov	ds:[eax+4*ecx],edi		;Save new light header
	retn
;
LIGH_Read_AMB:
	call	Uncompress_Chunk
	jc	Load_Error
	push	eax
	mov	ecx,ds:[esi+World_Ambient_Light]
	call	Free
	pop	ds:[esi+World_Ambient_Light]
	jc	Load_Error
	retn
;
Read_VIEW:
@@L1:	call	Read_Chunk
	jc	Load_Error
	;
	cmp	edx,'DNE'
	je	@@End
	cmp	edx,' MAC'
	jne	short @@N1
		call	VIEW_Read_CAM
		jmp	@@L1
@@N1:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1
@@End:	;
	mov	esi,ds:[WHeader]
	clc
	retn
;
VIEW_Read_CAM:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ebx,eax
	mov	ecx,GVE_CAMERA_SIZE
	call	Realloc
	jc	Load_Error
	mov	edi,eax				;EDI = new camera
	mov	ds:[eax+Camera_Distance],1 shl GVE_DISTANCE
	;
	mov	ebx,ds:[esi+World_Camera_List]
	inc	dword ptr ds:[ebx]		;Increment camera-counter
	mov	ecx,ds:[ebx]			;ECX = number of allocated cameras
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_Camera_List],eax
	;
	mov	ecx,ds:[eax]			;ECX = camera counter
	mov	ds:[eax+4*ecx],edi		;Save new camera header
	retn
;
Read_FLAG:
	mov	edx,ds:[WHeader]
	add	edx,World_Flags
	mov     ebx,ds:[File_Handle]
	mov	ecx,4
	call	Read
	jc	Load_Error
	retn
;
Read_SCRP:
@@L1:	call	Read_Chunk			;Get sub-chunk header
	jc	Load_Error
	;
	cmp	edx,'DNE'
	je	@@End
	cmp	edx,'DAEH'
	jne	short @@N1
		call	SCRP_Read_HEAD
		jmp	@@L1
@@N1:	cmp	edx,'KART'
	jne	short @@N2
		call	SCRP_Read_TRAK
		jmp	@@L1
@@N2:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1
@@End:	;
	mov	esi,ds:[WHeader]
	clc
	retn
;
SCRP_Read_HEAD:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ebx,eax				;EBX = New track header
	mov	ecx,GVE_TRACK_SIZE
	call	Realloc				;EAX = Reallocated track
	jc	Load_Error
	mov	ebp,eax				;EBP = new track header
	;
	mov	ebx,ds:[esi+World_Track_List]	;EBX = ptr to track list
	inc	dword ptr ds:[ebx]		;Increment track-counter
	mov	ecx,ds:[ebx]			;ECX = number of allocated tracks
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_Track_List],eax
	mov	ecx,ds:[eax]			;ECX = track counter
	mov	ds:[eax+4*ecx],ebp		;Save new track
	;
	mov	ds:[ebp+Track_Object_Address],0
	retn
;
SCRP_Read_TRAK:
	call	Uncompress_Chunk
	jc	Load_Error
	;
;	mov     ds:[ebp+Track_Data],eax		;EAX = ptr to track-data
	retn
;
Read_OBJS:
	xor	ebp,ebp				;EBP = Object-header ptr
@@L1:	call	Read_Chunk			;Get sub-chunk header
	jc	Load_Error
	;
	cmp	edx,'DNE'
	je	@@End
	cmp	edx,'DAEH'
	jne	short @@N1
		call	OBJ_Read_HEAD
		jmp	@@L1
@@N1:	cmp	edx,'ECAF'
	jne	short @@N2
		call	OBJ_Read_FACE
		jmp	@@L1
@@N2:	cmp	edx,'TCEV'
	jne	short @@N3
		call	OBJ_Read_VECT
		jmp	@@L1
@@N3:	cmp	edx,'VUXT'
	jne	short @@N4
		call	OBJ_Read_TXUV
		jmp	@@L1
@@N4:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1
@@End:  ;
	mov	esi,ds:[WHeader]
	clc
	retn
;
OBJ_Read_HEAD:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ebx,eax				;EBX = ptr to uncompressed chunk
	mov	ecx,GVE_OBJECT_SIZE
	call	Realloc
	jc	Load_Error
	mov	ebp,eax				;EBP = new object address
	;
	mov	ebx,ds:[esi+World_Object_List]	;EBX = ptr to object list
	inc	dword ptr ds:[ebx]		;Increment object-counter
	mov	ecx,ds:[ebx]			;ECX = number of allocated objects
	lea	ecx,[4*ecx+4]			;ECX = new list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_Object_List],eax
	mov	ecx,ds:[eax]			;ECX = Object counter
	mov	ds:[eax+4*ecx],ebp		;Save new object header
	;
	xor	eax,eax
	mov	ds:[ebp+Object_Vertex_List],eax
	mov	ds:[ebp+Object_Face_List],eax
	or	ds:[ebp+Object_Flags],GVE_OBJ_VERTEX_INDEX
	and	ds:[ebp+Object_Flags],NOT GVE_OBJ_VERTEX_ADDRESS
	retn
;
OBJ_Read_VECT:
	call	Uncompress_Chunk
	jc	Load_Error
	test	ebp,ebp				;Is there an object header allocated ???
	jz	Load_Error
	;
	mov	esi,eax				;ESI = uncompressed vertices
	mov	eax,ds:[esi]			;EAX = number of vertices
	fastimul ecx,eax,GVE_VERTEX_SIZE
	add	ecx,4                           ;ECX = req. size of vertex-list
	push	ecx
	call	Malloc				;Allocate memory for real vertices
	mov	edi,eax				;ES:EDI = new vertex list
	pop	ecx				;ECX = size of vertex-list
	mov	ds:[ebp+Object_Vertex_List],eax
	jc	Load_Error
	;
	push	edi				;Save VERTEX-Ptr
	shr	ecx,2				;Shift for DWORD-mode
	xor	eax,eax				;Clear EAX for STOSD
	rep	stosd				;Clear vertex-list
	pop	edi				;EDI = vrtex-list ptr
	mov	ecx,esi				;ECX = ptr to file-vlist
	mov	edx,ds:[esi]			;EDX = number of vertices
	mov	ds:[edi],edx			;Save vertex counter
	test	edx,edx
	jz	short @@End
	add	edi,4				;Skip counter
	add	esi,4
	@@L1:	mov	eax,ds:[esi]		;Copy vertex & normal
		mov	ds:[edi+VertexX],eax
		mov	eax,ds:[esi+4]
		mov	ds:[edi+VertexY],eax
		mov	eax,ds:[esi+8]
		mov	ds:[edi+VertexZ],eax
		mov	eax,ds:[esi+12]
		mov	ds:[edi+Vertex_NormalX],eax
		mov	eax,ds:[esi+16]
		mov	ds:[edi+Vertex_NormalY],eax
		mov	eax,ds:[esi+20]
		mov	ds:[edi+Vertex_NormalZ],eax
		add	esi,24			;Next source-entry
		add	edi,GVE_VERTEX_SIZE	;Next destination entry
		dec	edx			;Next vertex
		jnz	short @@L1		;Loop !
	;
@@End:	mov	esi,ds:[WHeader]
	call	Free				;Free file-vertex list (ECX)
	retn
;
OBJ_Read_TXUV:
	call	Uncompress_Chunk
	jc	Load_Error
	test	ebp,ebp				;Is there an object header allocated ???
	jz	Load_Error
	;
	mov	esi,eax				;ESI = uncompressed vertices
	mov	eax,ds:[esi]			;EAX = number of vertices
	mov	edi,ds:[ebp+Object_Vertex_List]
	test	edi,edi				;EDI = Vertex-list
	jz	Load_Error
	;
	mov	ecx,esi				;ECX = ptr to file-vlist
	mov	edx,ds:[esi]			;EDX = number of vertices
	test	edx,edx
	jz	short @@End
	add	edi,4				;Skip counter
	add	esi,4
	@@L1:	mov	eax,ds:[esi]		;Copy vertex & normal
		mov	ds:[edi+Vertex_TextureU],eax
		mov	eax,ds:[esi+4]
		mov	ds:[edi+Vertex_TextureV],eax
		mov	eax,ds:[esi+8]
		add	esi,8			;Next source-entry
		add	edi,GVE_VERTEX_SIZE	;Next destination entry
		dec	edx			;Next vertex
		jnz	short @@L1		;Loop !
	;
@@End:	mov	esi,ds:[WHeader]
	call	Free				;Free file-vertex list (ECX)
	retn
;
OBJ_Read_FACE:
	call	Uncompress_Chunk
	jc	Load_Error
	test	ebp,ebp				;Is current object-header 0 ???
	jz	Load_Error
	mov	ds:[ebp+Object_Face_List],eax
	retn
;
Read_TMAP:
@@L1:	call	Read_Chunk			;Read in sub-chunk header
	jc	Load_Error
	;
	cmp	edx,'DNE'
	je	short @@End
	cmp	edx,'PIKS'			;Empty texture ???
	jne	short @@J1
		call	TMAP_Read_SKIP
		jmp	short @@L1
@@J1:	cmp	edx,'8PMB'
	jne     short @@J2
		call    TMAP_Read_BMP8
		jmp	short @@L1
@@J2:	cmp	edx,'DAEH'
	jne	short @@J3
		call	TMAP_Read_HEAD
		jmp	short @@L1
@@J3:	cmp	edx,'YDOB'
	jne	short @@J4
		call	TMAP_Read_BODY
		jmp	short @@L1
@@J4:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1
	;
@@End:  mov	esi,ds:[WHeader]
	clc
	retn
;
TMAP_Read_BMP8:
	mov	ebx,ds:[esi+World_TextureMap_List]
	inc	d ds:[ebx]			;Increment texture counter
	mov	ecx,ds:[ebx]			;ECX = number of allocated textures
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_TextureMap_List],eax
	mov	ecx,ds:[eax]			;ECX = texture counter
	lea	edi,[eax+4*ecx]			;EDI = ptr in texture-list
	;
	mov	ebx,ds:[File_Handle]
	mov	ecx,4
	mov	edx,OFFSET GVE_IO_Buffer
	call	Read				;Read in bitmap-size
	jc	Load_Error
	mov	ebp,d ds:[GVE_IO_Buffer]	;EBP = WIdth/Height

	mov	eax,ds:[Chunk_Compression]
	mov	ecx,ds:[Chunk_Size]
	sub	ecx,16
	call    Uncompress_Chunk
	jc	Load_Error
	mov	esi,eax				;ESI = loaded texture-data
	;
	mov	eax,ebp
	shr	eax,16
	movzx	ecx,bp
	imul	ecx,eax				;ECX = Size of bitmap
	add	ecx,GVE_BITMAP_SIZE
	call	Malloc				;EAX = New texture-chunk
	jc	Load_Error
	mov	ds:[edi],eax			;Save pointer in list

	mov	edi,eax				;EDI = New texture-hdr
	mov	ebx,eax				;EBX = New texture-hdr
	xor	eax,eax
	mov	ecx,GVE_BITMAP_SIZE/4
	rep	stosd				;EDI = ptr to texture-body

	mov	d ds:[ebx+Bitmap_Width],ebp
	mov	ds:[ebx+Bitmap_Depth],8
	mov	ds:[ebx+Bitmap_Magic],ebx
	mov	ds:[ebx+Bitmap_Type],GVE_TYP_BITMAP

	push	esi
	mov	eax,ebp
	shr	eax,16
	movzx	ecx,bp
	imul	ecx,eax
	shr	ecx,2
	rep	movsd				;Copy texture-body

	pop	ecx
	call	Free
	mov	esi,ds:[WHeader]
	retn
;
TMAP_Read_SKIP:
	mov	ebx,ds:[File_Handle]
	mov	ecx,4
	mov	edx,OFFSET GVE_IO_Buffer
	call	Read				;Read in SKIP-counter
	jc	Load_Error

	mov	eax,d ds:[GVE_IO_Buffer]
	mov	ebx,ds:[esi+World_TextureMap_List]
	add	ds:[ebx],eax
	mov	ecx,ds:[ebx]			;ECX = number of allocated textures
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_TextureMap_List],eax
	mov	ecx,ds:[eax]			;ECX = number of textures
	mov	d ds:[eax+4*ecx],0
	retn
;
TMAP_Read_HEAD:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ebx,eax				;EBX = ptr to uncompressed chunk
	movzx	eax,ds:[ebx+Bitmap_Width]
	movzx	ecx,ds:[ebx+Bitmap_Height]
	imul	ecx,eax				;ECX = total size of texture
	add	ecx,GVE_BITMAP_SIZE
	call	Realloc
	jc	Load_Error
	mov	ebp,eax				;EBP = new texture address
	;
	mov	ebx,ds:[esi+World_TextureMap_List]
	inc	d ds:[ebx]			;Increment texture counter
	mov	ecx,ds:[ebx]			;ECX = number of allocated textures
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_TextureMap_List],eax
	;
	mov	ecx,ds:[eax]			;ECX = Texture counter
	mov	ds:[eax+4*ecx],ebp		;Save new texture header
	retn
;
TMAP_Read_BODY:
LMAP_Read_BODY:
	call	Uncompress_Chunk
	jc	Load_Error
	test	ebp,ebp				;Is there an object header allocated ???
	jz	Load_Error
	;
	mov	esi,eax
	lea	edi,[ebp+GVE_BITMAP_SIZE]
	movzx	edx,ds:[ebp+Bitmap_Width]
	movzx	ecx,ds:[ebp+Bitmap_Height]
	imul	ecx,edx				;ECX = total size of texture
	shr	ecx,2
	rep	movsd
	mov	esi,ds:[WHeader]

	mov	ecx,eax				;ECX = ptr to old texture
	call	Free
	retn
;
Read_LMAP:
@@L1: 	call	Read_Chunk			;Read in sub-chunk header
	jc	Load_Error
	;
	cmp	edx,'DNE'
	je	short @@End
	cmp	edx,'PIKS'			;Empty lightmap ???
	jne	short @@J1
		call	LMAP_Read_SKIP
		jmp	short @@L1
@@J1:	cmp	edx,'8PMB'
	jne     short @@J2
		call    LMAP_Read_BMP8
		jmp	short @@L1
@@J2:	cmp	edx,'DAEH'
	jne	short @@J3
		call	LMAP_Read_HEAD
		jmp	short @@L1
@@J3:	cmp	edx,'YDOB'
	jne	short @@J4
		call	LMAP_Read_BODY
		jmp	short @@L1
@@J4:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1
	;
@@End:  mov	esi,ds:[WHeader]
	clc
	retn
;
LMAP_Read_BMP8:
	mov	ebx,ds:[esi+World_PhongMap_List]
	inc	d ds:[ebx]			;Increment lightmap counter
	mov	ecx,ds:[ebx]			;ECX = number of allocated lightmaps
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_PhongMap_List],eax
	mov	ecx,ds:[eax]			;ECX = lightmap counter
	lea	edi,[eax+4*ecx]			;EDI = ptr in lightmap-list
	;
	mov	ebx,ds:[File_Handle]
	mov	ecx,4
	mov	edx,OFFSET GVE_IO_Buffer
	call	Read				;Read in bitmap-size
	jc	Load_Error
	mov	ebp,d ds:[GVE_IO_Buffer]	;EBP = WIdth/Height

	mov	eax,ds:[Chunk_Compression]
	mov	ecx,ds:[Chunk_Size]
	sub	ecx,16
	call    Uncompress_Chunk
	jc	Load_Error
	mov	esi,eax				;ESI = loaded lightmap-data
	;
	mov	eax,ebp
	shr	eax,16
	movzx	ecx,bp
	imul	ecx,eax				;ECX = Size of bitmap
	add	ecx,GVE_BITMAP_SIZE
	call	Malloc				;EAX = New lightmap-chunk
	jc	Load_Error
	mov	ds:[edi],eax			;Save pointer in list

	mov	edi,eax				;EDI = New lightmap-hdr
	mov	ebx,eax
	xor	eax,eax
	mov	ecx,GVE_BITMAP_SIZE/4
	rep	stosd				;EDI = ptr to lightmap-body

	mov	d ds:[ebx+Bitmap_Width],ebp
	mov	ds:[ebx+Bitmap_Depth],8
	mov	ds:[ebx+Bitmap_Magic],ebx
	mov	ds:[ebx+Bitmap_Type],GVE_TYP_BITMAP

	push	esi
	mov	eax,ebp
	shr	eax,16
	movzx	ecx,bp
	imul	ecx,eax
	shr	ecx,2
	rep	movsd				;Copy lightmap-body

	pop	ecx
	call	Free
	mov	esi,ds:[WHeader]
	retn
;
LMAP_Read_SKIP:
	mov	ebx,ds:[File_Handle]
	mov	ecx,4
	mov	edx,OFFSET GVE_IO_Buffer
	call	Read				;Read in SKIP-counter
	jc	Load_Error

	mov	eax,d ds:[GVE_IO_Buffer]
	mov	ebx,ds:[esi+World_PhongMap_List]
	add	ds:[ebx],eax
	mov	ecx,ds:[ebx]			;ECX = number of allocated phongs
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_PhongMap_List],eax
	mov	ecx,ds:[eax]			;ECX = number of phongs
	mov	d ds:[eax+4*ecx],0
	retn
;
LMAP_Read_HEAD:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ebx,eax				;EBX = ptr to uncompressed chunk
	movzx	eax,ds:[ebx+Bitmap_Width]
	movzx	ecx,ds:[ebx+Bitmap_Height]
	imul	ecx,eax				;ECX = total size of phong
	add	ecx,GVE_BITMAP_SIZE
	call	Realloc
	jc	Load_Error
	mov	ebp,eax				;EBP = new phong address
	;
	mov	ebx,ds:[esi+World_PhongMap_List]
	inc	d ds:[ebx]			;Increment phong counter
	mov	ecx,ds:[ebx]			;ECX = number of allocated phongs
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_PhongMap_List],eax
	;
	mov	ecx,ds:[eax]			;ECX = Phong counter
	mov	ds:[eax+4*ecx],ebp		;Save new phong header
	retn
;
Read_BMAP:
@@L1: 	call	Read_Chunk			;Read in sub-chunk header
	jc	Load_Error
	;
	cmp	edx,'DNE'
	je	short @@End
	cmp	edx,'PIKS'			;Empty bump-map ???
	jne	short @@J1
		call	BMAP_Read_SKIP
		jmp	short @@L1
@@J1:	cmp	edx,'DAEH'
	jne	short @@J2
		call	BMAP_Read_HEAD
		jmp	short @@L1
@@J2:	cmp	edx,'YDOB'
	jne	short @@J3
		call	BMAP_Read_BODY
		jmp	short @@L1
@@J3:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1
	;
@@End:  mov	esi,ds:[WHeader]
	clc
	retn
;
BMAP_Read_SKIP:
	mov	ebx,ds:[File_Handle]
	mov	ecx,4
	mov	edx,OFFSET GVE_IO_Buffer
	call	Read				;Read in SKIP-counter
	jc	Load_Error

	mov	eax,d ds:[GVE_IO_Buffer]
	mov	ebx,ds:[esi+World_BumpMap_List]
	add	ds:[ebx],eax
	mov	ecx,ds:[ebx]			;ECX = number of allocated phongs
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_BumpMap_List],eax
	mov	ecx,ds:[eax]			;ECX = number of phongs
	mov	d ds:[eax+4*ecx],0
	retn
;
BMAP_Read_HEAD:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ebx,eax				;EBX = ptr to uncompressed chunk
	movzx	eax,ds:[ebx+Bitmap_Width]
	movzx	ecx,ds:[ebx+Bitmap_Height]
	imul	ecx,eax				;ECX = total size of phong
	lea	ecx,[2*ecx+GVE_BITMAP_SIZE]
	call	Realloc
	jc	Load_Error
	mov	ebp,eax				;EBP = new phong address
	;
	mov	ebx,ds:[esi+World_BumpMap_List]
	inc	d ds:[ebx]			;Increment phong counter
	mov	ecx,ds:[ebx]			;ECX = number of allocated phongs
	lea	ecx,[4*ecx+4]			;Increase list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_BumpMap_List],eax
	;
	mov	ecx,ds:[eax]			;ECX = Phong counter
	mov	ds:[eax+4*ecx],ebp		;Save new phong header
	retn
;
BMAP_Read_BODY:
	call	Uncompress_Chunk
	jc	Load_Error
	test	ebp,ebp				;Is there an object header allocated ???
	jz	Load_Error
	;
	mov	esi,eax
	lea	edi,[ebp+GVE_BITMAP_SIZE]
	movzx	edx,ds:[ebp+Bitmap_Width]
	movzx	ecx,ds:[ebp+Bitmap_Height]
	imul	ecx,edx				;ECX = total size of texture
	shr	ecx,1
	rep	movsd
	mov	esi,ds:[WHeader]

	mov	ecx,eax				;ECX = ptr to old texture
	call	Free
	retn
;
Read_VIDO:
	xor	ebp,ebp
@@L1:	call	Read_Chunk			;Read in sub-chunk header
	jc	Load_Error
	;
	cmp	edx,'DNE'
	je	short @@End
	cmp	edx,'DAEH'
	jne	short @@J3
		call	VIDO_Read_HEAD
		jmp	short @@L1
@@J3:	cmp	edx,'YDOB'
	jne	short @@J4
		call	VIDO_Read_BODY
		jmp	short @@L1
@@J4:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1
	;
@@End:  mov	esi,ds:[WHeader]
	clc
	retn
;
VIDO_Read_HEAD:
	call	Uncompress_Chunk
	jc	Load_Error
	mov	ebx,eax				;EBX = ptr to uncompressed chunk
	mov	ecx,GVE_VIDEO_SIZE
	call	Realloc
	jc	Load_Error
	mov	ebp,eax				;EBP = new video address
	;
	mov	ebx,ds:[esi+World_Video_List]	;EBX = ptr to video list
	inc	dword ptr ds:[ebx]		;Increment video-counter
	mov	ecx,ds:[ebx]			;ECX = number of allocated videos
	lea	ecx,[4*ecx+4]			;ECX = new list-size
	call	Realloc
	jc	Load_Error
	mov	ds:[esi+World_Video_List],eax
	mov	ecx,ds:[eax]			;ECX = video counter
	mov	ds:[eax+4*ecx],ebp		;Save new video header
	retn
;
VIDO_Read_BODY:
	ifdef GVE_VIDEO_TEXTURES
	 test	ebp,ebp
	 jz	Load_Error
	 and	ds:[ebp+Video_Flags],NOT GVE_VID_EXTERNAL
	 or	ds:[ebp+Video_Flags],GVE_VID_INTERNAL
	 mov	eax,esi
	 mov	ebx,ebp
	 mov	edx,ds:[File_Handle]
	 call	GVE_Read_Video_Body
	else
	 mov	al,SEEK_CUR
	 mov	ebx,ds:[File_Handle]
	 call	Seek
	endif
	retn



;
;
; Now follows a GVE-file saver
;
; GVE_Save_World:
;  Input:
;	EAX	-  DATA32 ptr to world-header
;      EBX	-  DATA32 ptr to file-name
;	ECX	-  Compression
;	EDX	-  Start-position  (Normally set to zero)
;  Output:
;	CF 	-  error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Save_World
GVE_Save_World PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ds:[Default_Compression],ecx
	mov	ds:[WHeader],eax
	mov	ds:[OldESP],esp

	mov	edx,ebx
	mov	eax,'FEVG'
	mov	ebx,'ELI'
	mov	ecx,GVE_FILE_VERSION
	call	Creat_File
	jc	Save_Error

	mov	ebp,ds:[WHeader]
;
Write_NAME:
		mov	eax,'NAME'
		xor	ebx,ebx
		call	Creat_Chunk

		xor	eax,eax
		mov	ecx,128
		lea	edx,[ebp+World_Name]
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
;
Write_COPYRIGHT:
	mov	esi,ds:[ebp+World_Copyright_Text]
	test	esi,esi
	jz	Write_INFORMATION
		mov	edi,esi
		xor	eax,eax
		mov	ecx,10000h
		repne	scasb                   ;Search terminating '0'
		sub	edi,esi			;EDI = size of string

		mov	eax,'(C)'
		xor	ebx,ebx
		call	Creat_Chunk

		xor	eax,eax
		mov	ecx,edi
		mov	edx,esi
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
;
Write_INFORMATION:
	mov	esi,ds:[ebp+World_Information_Text]
	test	esi,esi
	jz	Write_SOFTWARE
		mov	edi,esi
		xor	eax,eax
		mov	ecx,10000h
		repne	scasb                   ;Search terminating '0'
		sub	edi,esi			;EDI = size of string

		mov	eax,'(I)'
		xor	ebx,ebx
		call	Creat_Chunk

		xor	eax,eax
		mov	ecx,edi
		mov	edx,esi
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
;
Write_SOFTWARE:
	mov	esi,ds:[ebp+World_Software_Text]
	test	esi,esi
	jz	Write_OBJS
		mov	edi,esi
		xor	eax,eax
		mov	ecx,10000h
		repne	scasb                   ;Search terminating '0'
		sub	edi,esi			;EDI = size of string

		mov	eax,'(S)'
		xor	ebx,ebx
		call	Creat_Chunk

		xor	eax,eax
		mov	ecx,edi
		mov	edx,esi
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
;
Write_OBJS:
	mov	esi,ds:[ebp+World_Object_List]		;Save vertices
	mov	eax,ds:[esi]			;EAX = number of objects
	test	eax,eax
	jz	Write_PAL
		mov	eax,'SJBO'
		mov	ebx,COMPRESSION_NONE
		call	Creat_Chunk		;Objects-main-chunk
	;
		mov	eax,ds:[esi]		;EAX = number of objects
		add	esi,4			;Skip object-counter
	@@L3:   push	eax			;Save counter
		cmp	d ds:[esi],0		;Is there a header ???
		je	@@NObj
		mov	eax,'DAEH'		;EAX = Object header magic
		xor	ebx,ebx			;EBX = standard compression
		call	Creat_Chunk		;Header-chunk
		xor	eax,eax			;EAX = STandard compression
		mov	ecx,GVE_FILE_OBJECT_SIZE;ECX = Size of memory-chunk
		mov	edx,ds:[esi]		;EDX = ptr to buffer
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
	;
		mov	ebx,ds:[esi]		;EBX = ptr to object hdr
		mov	eax,ds:[ebx+Object_Vertex_List]
		test	eax,eax                 ;Is it a valid list ???
		jz	@@N2

		push	esi
		mov	esi,eax			;ESI = ptr to vertex-list
		mov	eax,ds:[esi]		;EAX = Number of vertices
		fastimul ecx,eax,GVE_FILE_VERTEX_SIZE
		add	ecx,4
		call	Malloc			;Allocate buffer
		push	eax			;Save buffer ptr
		mov	edi,eax			;EDI = ptr to buffer
		mov	edx,ds:[esi]		;EDX = NOV
		mov	ds:[edi],edx
		add	esi,4			;ESI = ptr to 1st src-vertex
		add	edi,4                   ;EDI = ptr to 1st dst-vertex
	@@L4:	mov	eax,ds:[esi+VertexX]	;Copy vertex & normal
		mov	ds:[edi],eax
		mov	eax,ds:[esi+VertexY]
		mov	ds:[edi+4],eax
		mov	eax,ds:[esi+VertexZ]
		mov	ds:[edi+8],eax
		mov	eax,ds:[esi+Vertex_NormalX]
		mov	ds:[edi+12],eax
		mov	eax,ds:[esi+Vertex_NormalY]
		mov	ds:[edi+16],eax
		mov	eax,ds:[esi+Vertex_NormalZ]
		mov	ds:[edi+20],eax
		add	edi,24			;Next dst-vertex
		add	esi,GVE_VERTEX_SIZE	;Next src-vertex
		dec	edx			;
		jnz	short @@L4              ;Loop !

		pop	esi			;ESI = buffer-ptr
		mov	eax,'TCEV'		;EAX = Vectors-Magic
		xor	ebx,ebx			;EBX = Standard compression
		call	Creat_Chunk
		xor	eax,eax			;Standard compression
		mov	ebx,ds:[esi]		;EBX = number of vertices
		fastimul ecx,ebx,GVE_FILE_VERTEX_SIZE
		add	ecx,4			;ECX = Size of memory-chunk
		mov	edx,esi			;EDX = ptr to buffer
		call	Compress_Chunk
		call	Close_Chunk
		mov	ecx,esi
		call	Free			;Release buffer

		pop	esi			;ESI = ptr to object list
	;
	@@N1:	push	esi
		mov	ebx,ds:[esi]		;EBX = ptr to obbject-header
		mov	esi,ds:[ebx+Object_Vertex_List]
		mov	eax,ds:[esi]		;EAX = Number of vertices
		fastimul ecx,eax,8
		add	ecx,4
		call	Malloc			;Allocate buffer
		push	eax			;Save buffer ptr
		mov	edi,eax			;EDI = ptr to buffer
		mov	edx,ds:[esi]		;EDX = NOV
		mov	ds:[edi],edx
		add	esi,4			;ESI = ptr to 1st src-vertex
		add	edi,4                   ;EDI = ptr to 1st dst-vertex
	@@L5:	mov	eax,ds:[esi+Vertex_TextureU]
		mov	ds:[edi],eax
		mov	eax,ds:[esi+Vertex_TextureV]
		mov	ds:[edi+4],eax
		add	edi,8			;Next dst-vertex
		add	esi,GVE_VERTEX_SIZE	;Next src-vertex
		dec	edx			;
		jnz	short @@L5              ;Loop !

		pop	esi			;ESI = buffer-ptr
		mov	eax,'VUXT'		;EAX = TextureUV-Magic
		xor	ebx,ebx			;EBX = Standard compression
		call	Creat_Chunk
		xor	eax,eax			;Standard compression
		mov	ebx,ds:[esi]		;EBX = number of vertices
		fastimul ecx,ebx,8
		add	ecx,4			;ECX = Size of memory-chunk
		mov	edx,esi			;EDX = ptr to buffer
		call	Compress_Chunk
		call	Close_Chunk
		mov	ecx,esi
		call	Free			;Release buffer

		pop	esi			;ESI = ptr to object list
	;
	@@N2:	mov	ebx,ds:[esi]		;EBX = ptr to object hdr
		mov	eax,ds:[ebx+Object_Face_List]
		test	eax,eax                 ;Is it a valid list ???
		jz	@@NObj
		mov	eax,'ECAF'		;EAX = FACE-Magic
		xor	ebx,ebx			;Standard compression
		call	Creat_Chunk
		mov	eax,ds:[esi]		;EAX = Object header
		call	GVE_Dereference_Primitives
		mov	ebx,ds:[esi]		;EBX = ptr to object hdr
		mov	edx,ds:[ebx+Object_Face_List]
		mov	ecx,eax			;ECX = size of list
		xor	eax,eax			;Standrad compression
		call	Compress_Chunk		;Write chunk !
		call	Close_Chunk
		mov	eax,ds:[esi]
		call	GVE_Reference_Primitives    ;Get again addresses
	;
	@@NObj:	add	esi,4			;Skip to next object
		pop	eax
		dec	eax
		jnz	@@L3
	;
		mov	eax,'DNE'		;Write last obj-chunk
		mov	ebx,COMPRESSION_NONE
		call	Creat_Chunk
		call	Close_Chunk             ;Close END-Chunk
		call	Close_Chunk		;Close OBJS-Chunk
;
Write_PAL:
	mov	esi,ds:[ebp+World_Palette]
	test	esi,esi
	jz	Write_SLUT
		mov	eax,'LAP'
		xor	ebx,ebx
		call	Creat_Chunk
		xor	eax,eax
		mov	ecx,GVE_FILE_PALETTE_SIZE
		mov	edx,esi
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
;
Write_SLUT:
	mov	esi,ds:[ebp+World_Shading_LUT8]
	test	esi,esi
	jz	Write_TLUT
		mov	eax,'TULS'		;Shdaing LUT
		xor	ebx,ebx			;Standard compression
		call	Creat_Chunk
		xor	eax,eax			;Standard compression
		mov	ecx,GVE_SHADING_LUT8_SIZE
		mov	edx,esi
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
;
Write_TLUT:
	mov	esi,ds:[ebp+World_Glass_LUT8]
	test	esi,esi
	jz	Write_BLUT
		mov	eax,'TULT'		;Transparency LUT
		xor	ebx,ebx			;Standard compression
		call	Creat_Chunk
		xor	eax,eax			;Standard compression
		mov	ecx,GVE_GLASS_LUT8_SIZE
		mov	edx,esi
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
;
Write_BLUT:
	mov	esi,ds:[ebp+World_Bump_LUT8]
	test	esi,esi
	jz	Write_LIGH
		mov	eax,'TULB'		;Bump LUT
		xor	ebx,ebx			;Standard compression
		call	Creat_Chunk
		xor	eax,eax			;Standard compression
		mov	ecx,GVE_BUMP_LUT8_SIZE
		mov	edx,esi
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
;
Write_LIGH:
	mov	esi,ds:[ebp+World_Light_List]
	mov	eax,'HGIL'			;Light-list
	mov	ebx,COMPRESSION_NONE		;
	call	Creat_Chunk
	;
	mov	eax,'BMA'			;EAX = Ambient light
	xor	ebx,ebx				;EBX = standard compression
	call	Creat_Chunk			;Header-chunk
	xor	eax,eax				;Standard compression
	mov	ecx,GVE_FILE_AMBIENT_SIZE
	mov	edx,ds:[ebp+World_Ambient_Light]
	call	Compress_Chunk
	jc	Save_Error
	call	Close_Chunk
	;
	mov	eax,ds:[esi]			;EAX = number of lights
	test	eax,eax
	jz	@@ELig
	;
		mov	edi,ds:[esi]		;EDI = number of lights
		add	esi,4			;Skip light-counter
	@@L6:	cmp	d ds:[esi],0		;Is there a light ???
		je	@@NLig

		mov	eax,'TNOP'		;EAX = Point light source
		xor	ebx,ebx			;EBX = standard compression
		call	Creat_Chunk		;Header-chunk
		xor	eax,eax			;Standard compression
		mov	ecx,GVE_FILE_LIGHT_SIZE
		mov	edx,ds:[esi]
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
	;
	@@NLig:	add	esi,4			;Skip to next light
		dec	edi
		jnz	short @@L6
	;
	@@ELig:	mov	eax,'DNE'		;Write last ligh-chunk
		mov	ebx,COMPRESSION_NONE
		call	Creat_Chunk
		call	Close_Chunk
		call	Close_Chunk		;Close LIGH-Chunk
;
Write_VIEW:
	mov	esi,ds:[ebp+World_Camera_List]
	mov	eax,ds:[esi]			;EAX = number of cameras
	test	eax,eax
	jz	Write_SCRP
		mov	eax,'WEIV'		;Camera-list
		mov	ebx,COMPRESSION_NONE	;
		call	Creat_Chunk
	;
		mov	edi,ds:[esi]		;EDI = number of cameras
		add	esi,4			;Skip camera-counter
	@@L7:	cmp	d ds:[esi],0		;Is there a camera ???
		je	@@NCam

		mov	eax,' MAC'		;EAX = Camera
		xor	ebx,ebx			;EBX = standard compression
		call	Creat_Chunk		;Header-chunk
		xor	eax,eax			;Standard compression
		mov	ecx,GVE_FILE_CAMERA_SIZE
		mov	edx,ds:[esi]
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
	;
	@@NCam:	add	esi,4			;Skip to next camera
		dec	edi
		jnz	short @@L7
	;
		mov	eax,'DNE'		;Write last camera-chunk
		mov	ebx,COMPRESSION_NONE
		call	Creat_Chunk
		call	Close_Chunk
		call	Close_Chunk		;Close VIEW-Chunk
;
Write_SCRP:
	mov	esi,ds:[ebp+World_Track_List]
	mov	eax,ds:[esi]			;EAX = number of tracks
	test	eax,eax
	jz	Write_VIDO
		mov	eax,'PRCS'		;Track-list
		mov	ebx,COMPRESSION_NONE	;
		call	Creat_Chunk
	;
		mov	edi,ds:[esi]		;EDI = number of tarcks
		add	esi,4			;Skip track-counter
	@@L8:	cmp	d ds:[esi],0		;Is there a track ???
		je	@@NTrk

		mov	eax,'DAEH'		;EAX = Track-header
		xor	ebx,ebx			;EBX = standard compression
		call	Creat_Chunk		;Header-chunk
		xor	eax,eax			;Standard compression
		mov	ecx,GVE_FILE_TRACK_SIZE
		mov	edx,ds:[esi]
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk

		mov	eax,'KART'
		xor	ebx,ebx
		call	Creat_Chunk
		xor	eax,eax			;EAX = Standard compression
		mov	ecx,ds:[esi+Track_Frames]
		imul	ecx,6*4
		lea	edx,ds:[esi+Track_Data]
		call	Compress_Chunk
		jc	Save_Error
		call	Close_Chunk
	;
	@@NTrk:	add	esi,4			;Skip to next track
		dec	edi
		jnz	short @@L8
	;
		mov	eax,'DNE'		;Write last track-chunk
		mov	ebx,COMPRESSION_NONE
		call	Creat_Chunk
		call	Close_Chunk
		call	Close_Chunk		;Close VIEW-Chunk
;
Write_VIDO:
	mov	esi,ds:[ebp+World_Video_List]
	mov	edi,ds:[esi]			;EDI = number of videos
	test	edi,edi
	jz	Write_TMAP
		mov	eax,'ODIV'		;Videos
		mov	ebx,COMPRESSION_NONE	;No compression
		call	Creat_Chunk
		add	esi,4			;Skip counter
	@@L9:	mov	eax,ds:[esi]		;EAX = texture-pointer
		test	eax,eax         	;Is there a texture ??
		jz	@@DoL9			;JZ: No, write SKIP-block
	;
		mov	eax,'DAEH'
		xor	ebx,ebx
		call	Creat_Chunk
		xor	eax,eax			;Standard compression
		mov	ecx,GVE_FILE_VIDEO_SIZE
		mov	edx,ds:[esi]
		call	Compress_Chunk		;Write sub-chunk header
		jc	Save_Error
		call	Close_Chunk
	;
	@@DoL9: add	esi,4			;Next video
		dec	edi
		jnz	@@L9			;Loop to next video

		mov	eax,'DNE'
		mov	ebx,COMPRESSION_NONE
		call	Creat_Chunk
		call	Close_Chunk
		call	Close_Chunk
;
Write_TMAP:
	mov	esi,ds:[ebp+World_TextureMap_List]
	mov	edi,ds:[esi]			;EDI = number of textures
	test	edi,edi
	jz	Write_LMAP
		mov	eax,'PAMT'		;Textures
		mov	ebx,COMPRESSION_NONE	;No compression
		call	Creat_Chunk
		add	esi,4			;Skip counter
	@@L1:	mov	eax,ds:[esi]		;EAX = texture-pointer
		test	eax,eax         	;Is there a texture ??
		jz	@@Empty_Texture		;JZ: No, write SKIP-block
	;
		mov	eax,'DAEH'
		xor	ebx,ebx
		call	Creat_Chunk
		xor	eax,eax			;Standard compression
		mov	ecx,GVE_FILE_BITMAP_SIZE
		mov	edx,ds:[esi]
		call	Compress_Chunk		;Write sub-chunk header
		jc	Save_Error
		call	Close_Chunk

		mov	edx,ds:[esi]
		cmp	ds:[edx+Bitmap_Type],GVE_TYP_FRAME_BUFFER
		je	@@DoL1

		mov	eax,'YDOB'
		xor	ebx,ebx
		call	Creat_Chunk
		mov	edx,ds:[esi]
		xor	eax,eax			;Standard compression
		movzx	ecx,ds:[edx+Bitmap_Width]
		movzx	ebx,ds:[edx+Bitmap_Height]
		imul	ecx,ebx			;ECX = Size of bitmap (bytes)
		add	edx,GVE_BITMAP_SIZE	;EDX = texture address
		call	Compress_Chunk		;Write texture
		jc	Save_Error
		call	Close_Chunk
		jmp	@@DoL1
	;
	@@Empty_Texture:			;Skip empty texture
		mov	eax,'PIKS'		;EAX = Magic
		mov	ebx,COMPRESSION_NONE	;No compression
		call	Creat_Chunk
		mov	d ds:[GVE_IO_Buffer],1
		mov	ebx,ds:[File_Handle]
		mov	ecx,4
		mov	edx,OFFSET GVE_IO_Buffer
		call	Write
		call	Close_Chunk
	;
	@@DoL1: add	esi,4			;Next texture
		dec	edi
		jnz	@@L1			;Loop to next texture

		mov	eax,'DNE'
		mov	ebx,COMPRESSION_NONE
		call	Creat_Chunk
		call	Close_Chunk
		call	Close_Chunk
;
Write_LMAP:
	mov	esi,ds:[ebp+World_PhongMap_List]
	mov	edi,ds:[esi]			;EDI = number of textures
	test	edi,edi
	jz	Write_BMAP
		mov	eax,'PAML'		;Light maps
		mov	ebx,COMPRESSION_NONE	;No compression
		call	Creat_Chunk
		add	esi,4			;Skip counter
	@@L2:	mov	eax,ds:[esi]		;EAX = texture-pointer
		test	eax,eax         	;Is there a texture ??
		jz	@@Empty_Light		;JZ: No, write SKIP-block
	;
		mov	eax,'DAEH'
		xor	ebx,ebx
		call	Creat_Chunk
		xor	eax,eax			;Standard compression
		mov	ecx,GVE_FILE_BITMAP_SIZE
		mov	edx,ds:[esi]
		call	Compress_Chunk		;Write sub-chunk header
		jc	Save_Error
		call	Close_Chunk

		mov	edx,ds:[esi]
		cmp	ds:[edx+Bitmap_Type],GVE_TYP_FRAME_BUFFER
		je	@@DoL2

		mov	eax,'YDOB'
		xor	ebx,ebx
		call	Creat_Chunk
		mov	edx,ds:[esi]
		xor	eax,eax			;Standard compression
		movzx	ecx,ds:[edx+Bitmap_Width]
		movzx	ebx,ds:[edx+Bitmap_Height]
		imul	ecx,ebx			;ECX = Size of bitmap (bytes)
		add	edx,GVE_BITMAP_SIZE	;EDX = texture address
		call	Compress_Chunk		;Write texture
		jc	Save_Error
		call	Close_Chunk
		jmp	@@DoL2
	;
	@@Empty_Light:				;Skip empty texture
		mov	eax,'PIKS'		;Textures
		mov	ebx,COMPRESSION_NONE	;No compression
		call	Creat_Chunk
		mov	d ds:[GVE_IO_Buffer],1
		mov	ebx,ds:[File_Handle]
		mov	ecx,4
		mov	edx,OFFSET GVE_IO_Buffer
		call	Write
		call	Close_Chunk
	;
	@@DoL2: add	esi,4			;Next texture
		dec	edi
		jnz	@@L2			;Loop to next texture

		mov	eax,'DNE'
		mov	ebx,COMPRESSION_NONE
		call	Creat_Chunk
		call	Close_Chunk
		call	Close_Chunk
;
Write_BMAP:
	mov	esi,ds:[ebp+World_BumpMap_List]
	mov	edi,ds:[esi]			;EDI = number of textures
	test	edi,edi
	jz	Write_FLAG
		mov	eax,'PAMB'		;Light maps
		mov	ebx,COMPRESSION_NONE	;No compression
		call	Creat_Chunk
		add	esi,4			;Skip counter
	@@LA:	mov	eax,ds:[esi]		;EAX = texture-pointer
		test	eax,eax         	;Is there a texture ??
		jz	@@Empty_Bump		;JZ: No, write SKIP-block
	;
		mov	eax,'DAEH'
		xor	ebx,ebx
		call	Creat_Chunk
		xor	eax,eax			;Standard compression
		mov	ecx,GVE_FILE_BITMAP_SIZE
		mov	edx,ds:[esi]
		call	Compress_Chunk		;Write sub-chunk header
		jc	Save_Error
		call	Close_Chunk

		mov	edx,ds:[esi]
		cmp	ds:[edx+Bitmap_Type],GVE_TYP_FRAME_BUFFER
		je	@@DoLA

		mov	eax,'YDOB'
		xor	ebx,ebx
		call	Creat_Chunk
		mov	edx,ds:[esi]
		xor	eax,eax			;Standard compression
		movzx	ecx,ds:[edx+Bitmap_Width]
		movzx	ebx,ds:[edx+Bitmap_Height]
		imul	ecx,ebx			;ECX = Size of bitmap (bytes)
		shl	ecx,1
		add	edx,GVE_BITMAP_SIZE	;EDX = texture address
		call	Compress_Chunk		;Write texture
		jc	Save_Error
		call	Close_Chunk
		jmp	@@DoLA
	;
	@@Empty_Bump:				;Skip empty texture
		mov	eax,'PIKS'		;Textures
		mov	ebx,COMPRESSION_NONE	;No compression
		call	Creat_Chunk
		mov	d ds:[GVE_IO_Buffer],1
		mov	ebx,ds:[File_Handle]
		mov	ecx,4
		mov	edx,OFFSET GVE_IO_Buffer
		call	Write
		call	Close_Chunk
	;
	@@DoLA: add	esi,4			;Next texture
		dec	edi
		jnz	@@LA			;Loop to next texture

		mov	eax,'DNE'
		mov	ebx,COMPRESSION_NONE
		call	Creat_Chunk
		call	Close_Chunk
		call	Close_Chunk
;
Write_FLAG:
	mov	eax,'GALF'			;Flags
	mov	ebx,COMPRESSION_NONE		;No compression
	call	Creat_Chunk
	mov	eax,COMPRESSION_NONE		;No compression
	mov	ecx,4
	lea	edx,[ebp+World_Flags]
	call	Compress_Chunk
	call	Close_Chunk

	mov	eax,'DNE'			;End-marker
	mov	ebx,COMPRESSION_NONE		;No compression
	call	Creat_Chunk
	call	Close_Chunk
	call	Close_File

	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

Save_Error:
	stc
	mov	esp,ds:[OldESP]
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Save_World ENDP
CODE32 ends
END