;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
;
;
; Shrink_List:
;  Throws out all zero-entries in ptr-lists
;  Input:
;  	EAX	- DATA32 ptr to list
;  Output:
;	EAX	- New DATA32 ptr to list
;
Shrink_List PROC NEAR
	push	esi
	push	edi
	push	ebp

	push	eax			;Save start address
	lea	esi,[eax+4]		;ESI = ptr to first entry
	mov	ecx,ds:[eax]		;ECX = src ptr-counter
	xor	edx,edx			;EDX = new entry-counter (start: 0)
	mov	edi,esi			;EDI = dst-list
	test	ecx,ecx
	jz	@@End
	;
@@L1:	mov	eax,ds:[esi]		;EAX = ptr from list
	add	esi,4			;Next entry
	test	eax,eax
	jz	@@Nxt
	inc	edx			;Increment new entry-counter
	mov	ds:[edi],eax		;Store in list
	add	edi,4
@@Nxt:	dec	ecx
	jnz	short @@L1
	;
@@End:	pop	ebx			;EBX = old start address
	sub	edi,ebx			;EDI = Size of new list
	mov	ds:[ebx],edx		;Save new entry-counter
	mov	ecx,edi			;ECX = new size
	call	Realloc

	pop	ebp
	pop	edi
	pop	esi
	retn
Shrink_List ENDP


;
;
; New_List_Entry:
;  Finds a new entry in a list or expands the list
;  Input:
;  	EAX	- DATA32 ptr to list
;  Output:
;	EAX	- DATA32 ptr to new list
;	EBX	- Entry-Number
;	EDX	- DATA32 ptr to new entry
;
New_List_Entry PROC NEAR
	mov	ebx,ds:[eax]		;EBX = Number of entries
	test	ebx,ebx
	jz	short @@Exp
@@L1:	cmp	d ds:[eax+4*ebx],0
	je	short @@Succ
	dec	ebx
	jnz	short @@L1
@@Exp:	;
	inc	d ds:[eax]		;Increment entry counter
	mov	ecx,ds:[eax]		;ECX = Number of entries
	mov	ebx,eax			;EBX = List ptr
	lea	ecx,[4*ecx+4]		;ECX = new list size
	call	Realloc
	jc	@@Err
	mov	ebx,ds:[eax]		;EBX = Number of entries
	mov	d ds:[eax+4*ebx],0	;Clear new entry
	;
@@Succ: clc
	lea	edx,[eax+4*ebx]		;EDX = DATA32 ptr to new entry
	dec	ebx			;EBX = new entry-number
@@Err:	retn
New_List_Entry ENDP



;
;
; Find_List_Entry:
;  Searches a specific entry in a list
;  Input:
;  	EAX	- DATA32 ptr to list
;	EDX	- Entry to search
;  Output:
;	EBX	- Entry-Number
;	EDX	- DATA32 ptr to entry
;
Find_List_Entry PROC NEAR
	test	edx,edx
	jz	short @@Err
	mov	ebx,ds:[eax]		;EBX = Number of entries
	test	ebx,ebx
	jz	short @@Err
@@L1:	cmp	d ds:[eax+4*ebx],edx
	je	short @@Succ
	dec	ebx
	jnz	short @@L1
@@Err:	stc
	retn
	;
@@Succ: clc
	lea	edx,[eax+4*ebx]		;EDX = DATA32 ptr to new entry
	dec	ebx   			;EBX = new entry-number
	retn
Find_List_Entry ENDP

