;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
GVE_SYSTEM_FILE		equ	1



;
;
;
;   GOMEZ VECTOR ENGINE                                            v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gve32.inc
include gomez.inc
include gvecolor.inc

extrn C GVE_Palette_Buffer:BYTE
extrn C GVE_Remap_Texture:near
extrn GVE_IO_Buffer:BYTE



FileHandle	dd	?
FileStart	dd	?
FileName	dd	?


;
;
;
;   GOMEZ VECTOR ENGINE                            WORLD EDITING FUNCTIONS
;
;
;
;
;
; GVE_Init_Shading_LUT
;  Input:
;	EAX  	- DATA32 ptr to world-header
;  Output:
;	[CF]	- Error flag
;	LUT
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Init_Shading_LUT
GVE_Init_Shading_LUT PROC NEAR
	push	ds
	push	ebp
	push	esi
	push	edi

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[eax+World_Light_List]
	mov	ebx,ds:[eax+World_Ambient_Light]
	mov	ebp,ds:[ebp+4]			;Get first light-source
	mov	esi,ds:[eax+World_Palette]	;ESI = ptr to palette
	mov	ecx,ds:[ebx+Ambient_Colour]	;ECX = Ambient colour
	mov     edx,ds:[ebp+Light_Colour]	;EDX = Light colour
	mov	bh, ds:[ebx+Ambient_Specular]	;BH  = Darkness/Brightness
	;
	push	eax
	push	ebx
	push	ecx
	push	edx
	mov	ecx,ds:[eax+World_Shading_LUT8]
	call	Free
	mov	ecx,GVE_SHADING_LUT8_SIZE
	call	Malloc
	mov	edi,eax
	pop	edx
	pop	ecx
	pop	ebx
	pop	eax
	jc	@@Err
	mov	ds:[eax+World_Shading_LUT8],edi
	;
	xor	bl,bl				;EBX = Strength
@@L1:	xor	ebp,ebp
	@@L2:  	push	ebx			;EBX = Strength
		push	ecx			;ECX = Ambient colour
		push	edx			;EDX = Light colour
		push	ebp
		mov	eax,ds:[esi+ebp]	;EAX = original colour
		call	GVE_Shade_Colour
		call	GVE_Fit_Colour		;CH  = best colour
		mov	ds:[edi],ch             ;Save translation value
		inc	edi			;Next LUT entry
		pop	ebp
		pop	edx
		pop	ecx
		pop	ebx
		add	ebp,4                   ;Next source-colour
		cmp	ebp,256*4
		jb	short @@L2		;Loop !
	inc	bl
	cmp	bl,64
	jl	short @@L1
	;
@@End:	clc
@@Err:	pop	edi
	pop	esi
	pop	ebp
	pop	ds
	retn
GVE_Init_Shading_LUT ENDP


;
;
; GVE_Init_Bump_LUT
;  Input:
;	EAX  	- DATA32 ptr to world-header
;  Output:
;	[CF]	- Error flag
;	LUT
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Init_Bump_LUT
GVE_Init_Bump_LUT PROC NEAR
	push	ds
	push	ebp
	push	esi
	push	edi

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[eax+World_Light_List]
	mov	ebx,ds:[eax+World_Ambient_Light]
	mov	ebp,ds:[ebp+4]			;Get first light-source
	mov	esi,ds:[eax+World_Palette]	;ESI = Palette ptr
	mov     edx,ds:[ebp+Light_Colour]	;EDX = Light colour
	mov	ecx,ds:[ebx+Ambient_Colour]	;ECX = Ambient colour
	mov	bh,ds:[ebx+Ambient_Specular]	;BH  = Specular value
	mov	ds:[@@lcolour],edx		;Save light colour
	mov	ds:[@@acolour],ecx		;Save light colour
	mov	ds:[@@specular],bh
	;
	mov	ecx,ds:[eax+World_Bump_LUT8]	;ECX = Bump-LUT
	push	eax
	call	Free
	mov	ecx,GVE_BUMP_LUT8_SIZE
	call	Malloc
	mov	edi,eax				;EDI = Bump-LUT
	pop	eax				;EAX = World-Header
	jc	@@Err
	mov	ds:[eax+World_Bump_LUT8],edi
	;
@@Ok:	xor	ecx,ecx				;Clear darken counter
@@L1:	xor	ebp,ebp				;EBP = Colour counter
	@@L2:   push	ebp
		push	ecx
		;
		mov     eax,ds:[esi+ebp]	;EAX = Source-colour
		movzx	ecx,al			;ECX = Red
		cmp	ah,cl
		jb	short @@Ok1
		mov	cl,ah
	@@Ok1:	shr	eax,16
		cmp	al,cl
		jb	short @@Ok2
		mov	cl,al			;ECX = max colour value
	@@Ok2:  sub	ecx,32
		push	ecx
		fwait
		fldpi
		fild	dword ptr ds:[@@neg_scale]
		fild	dword ptr ss:[esp]
		fscale
		fmul	st(0),st(2)
		fsin
		fld1
		fadd	st(0),st(1)
		fild	dword ptr ds:[@@pos_scale]
		fxch	st(1)
		fscale
		fadd	st(0),st(1)
		fistp	dword ptr ss:[esp]
		ffree	st(0)
		ffree	st(1)
		ffree	st(2)
		ffree	st(3)
		fwait
		pop	ebx			;ECX = sin(EBX) (Just for fun)

		mov	ebx,128
		sub	ebx,ecx			;EBX = 128-Colour_Intensity
		imul	ebx,ss:[esp]
		sar	ebx,7
		;
		mov     eax,ds:[esi+ebp]	;EAX = Source-colour
		mov	bh,ds:[@@Specular]
		mov	ecx,ds:[@@AColour]
		mov	edx,ds:[@@LColour]
		call	GVE_Shade_Colour
		call	GVE_Fit_Colour		;Get best colour
		mov	ds:[edi],ch             ;Save translation value
		inc	edi			;Next LUT entry
		pop	ecx
		pop	ebp			;Restore colour-counter
		add	ebp,4                   ;Next source-colour
		cmp	ebp,256*4
		jb	@@L2			;Loop !
	inc	ecx
	cmp	ecx,64
	jl	@@L1
	;
@@End:  clc
@@Err:	pop	edi
	pop	esi
	pop	ebp
	pop	ds
	retn

		ALIGN	DWORD
@@neg_scale	dd	-8
@@pos_scale	dd	8
@@lcolour	dd	?
@@acolour	dd	?
@@specular	db	?
GVE_Init_Bump_LUT ENDP



;
;
; GVE_Init_Glass_LUT
;  Input:
;	EAX  	- DATA32 ptr to world-header
;  Output:
;	[CF]	- Error flag
;	Transparency LUT
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Init_Glass_LUT
GVE_Init_Glass_LUT PROC NEAR
	push	ds
	push	ebp
	push	esi
	push	edi

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	esi,ds:[eax+World_Palette]
	mov	ecx,ds:[eax+World_Glass_LUT8]
	push	eax
	call	Free
	mov	ecx,10000h
	call	Malloc
	mov	edi,eax
	pop	eax
	jc	@@Err
	mov	ds:[eax+World_Glass_LUT8],edi
	;
@@Ok:	xor	ecx,ecx
@@L1:	xor	ebp,ebp
	@@L2:   push	ecx
		xor	edx,edx
		movzx	eax,b ds:[esi+ebp+2]
		add	al,b [esi+ecx+2]
		adc	ah,0
		shr	eax,1
		mov	dl,al				;DL = Blue

		shl	edx,16
		movzx	eax,b ds:[esi+ebp+1]
		add	al,b [esi+ecx+1]
		adc	ah,0
		shr	eax,1
		mov	dh,al				;DL = Green

		movzx	eax,b ds:[esi+ebp]
		add	al,b [esi+ecx]
		adc	ah,0
		shr	eax,1
		mov	dl,al				;DL = Red

		mov	eax,edx
		call	GVE_Fit_Colour
		mov	ds:[edi],ch
		inc	edi

	pop	ecx
	add	ebp,4
	cmp	ebp,256*4
	jb	short @@L2

	add	ecx,4
	cmp	ecx,256*4
	jb	short @@L1
	;
@@End:	clc
@@Err:	pop	edi
	pop	esi
	pop	ebp
	pop	ds
	retn
GVE_Init_Glass_LUT ENDP



;
;
; GVE_Init_Shading_Pal
;  Input:
;	EAX 	- DATA32 ptr to world-header
;	ECX	- Colour number (0 to 255)
;  Output:
;	[CF]	- Error flag
;	32 shades of colour in palette
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Init_Shading_Pal
GVE_Init_Shading_Pal PROC NEAR
	push	ds
	push	ebp
	push	esi
	push	edi
	cld
	;
	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[eax+World_Light_List]
	mov	esi,ds:[eax+World_Palette]	;ESI = ptr to palette
	mov	ebx,ds:[eax+World_Ambient_Light]
	mov	ebp,ds:[ebp+4]			;EBP = First light-source
	lea	esi,[esi+4*ecx-16*4]		;ESI = ESI+4*ECX (dst colour)
	mov     edx,ds:[ebp+Light_Colour]	;EDX = Light colour
	mov	ecx,ds:[ebx+Ambient_Colour]	;ECX = Ambient colour
	mov	bh,ds:[ebx+Ambient_Specular]	;BH  = Specular reflection
	mov	eax,ds:[esi+16*4]		;EAX = source colour
	;
	xor	bl,bl
@@L1:   push	eax				;EAX = Source-colour
	push	ebx				;EBX = Strength
	push	ecx				;ECX = Ambient colour
	push	edx				;EDX = Light colour
	call	GVE_Shade_Colour
	mov	ds:[esi],eax			;EAX = Shaded colour
	pop	edx
	pop	ecx
	pop	ebx
	pop	eax
	add	esi,4
	add	bl,2
	cmp	bl,64
	jl     	@@L1                    ;Loop !
	;
@@End:	clc
	pop	edi
	pop	esi
	pop	ebp
	pop	ds
	retn
GVE_Init_Shading_Pal ENDP



;
;
; GVE_Import_Palette
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- DATA32 ptr to file-name
;	EDX	- start position within file
;	ECX	- flags:
;		  bit 0 - 24 bit palette
;		  bit 1 - remap textures
;  Output:
;	[CF]	- Error-Flag
;	EAX	- ptr to loaded palette
;
PUBLIC C GVE_Import_Palette
GVE_Import_Palette PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]		;Important !
	mov	es,ds:[DATA32_Selector]
	mov	ds:[FileName],ebx
	mov	ds:[FileStart],edx		;First lets save the start pos.
	mov	ds:[@@Flags],ecx
	mov	esi,eax
	;
	push	esi			       	;Copy current palette
	mov	esi,ds:[esi+World_Palette]	;ESI points to current pal
	mov	edi,OFFSET GVE_Palette_Buffer
	mov	ecx,256
	rep	movsd
	pop	esi
	;
	mov	ecx,ds:[esi+World_Palette]
	call	Free
	jc	@@Err
	mov	ecx,256*4
	call	Malloc
	jc	@@Err
	mov	ds:[esi+World_Palette],eax
	mov	edi,eax

	mov	ecx,3*256
	call	Malloc
	jc	@@Err
	mov	ebp,eax				;EBP = temp palette
	;
	mov	cx,O_RDONLY
	mov	ebx,ds:[FileName]
	call	Open                            ;Open file
	jc	@@Err
	mov	ds:[FileHandle],eax

	mov	ebx,eax
	mov	ecx,ds:[FileStart]
	mov	al,SEEK_SET
	call	Seek				;Seek to desired position
	jc	@@Err

	mov	ebx,ds:[FileHandle]
	mov	ecx,256*3
	mov	edx,ebp
	call	Read				;Read in palette
	jc	@@Err

	mov     ebx,ds:[FileHandle]
	call	Close
	;
	test	ds:[@@Flags],GVE_PAL_24BIT
	jnz	short @@J1
		mov	ecx,256			;Convert 18bit to 32bit
	@@L1:	mov	eax,ds:[ebp]          	;Get old colour
		add	ebp,3
		shl	eax,2			;shift !
		and	eax,0ffffffh
		stosd
		dec	ecx
		jnz	short @@L1              ;Loop !
		sub	edi,4*256
		sub	ebp,3*256
		jmp	@@J2

	@@J1:	mov	ecx,256			;Convert 18bit to 32bit
	@@L2:	mov	eax,ds:[ebp]          	;Get old colour
		add	ebp,3
		and	eax,0ffffffh
		stosd
		dec	ecx
		jnz	short @@L2              ;Loop !
		sub	edi,4*256
		sub	ebp,3*256
	;
@@J2:   mov	ecx,ebp
	call	Free				;Release temporary memory
	jc	@@Err
	;
	test	ds:[@@Flags],GVE_PAL_REMAP
	jz	short @@J3
		mov	ebp,ds:[esi+World_TextureMap_List]
		mov	ebp,ds:[ebp]		;Get number of textures
		dec	ebp
	@@L3:	mov	eax,esi			;Get world-header
		xor	ebx,ebx			;Use buffer-palette
		mov	edx,ebp			;Texture-number
		call	GVE_Remap_Texture	;Do it !
		dec	ebp
		jns	short @@L3		;Loop !
	;
@@J3:	clc
	mov	eax,edi
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@flags	dd	?
GVE_Import_Palette ENDP




;
;
; GVE_Export_Palette
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- DATA32 ptr to file-name
;	EDX	- start position within file
;	ECX	- flags:
;		  bit 0 - 24 bit palette
;  Output:
;	[CF]	- Error-Flag
;
PUBLIC C GVE_Export_Palette
GVE_Export_Palette PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]		;Important !
	mov	es,cs:[DATA32_Selector]		;Important !
	mov	esi,eax				;ESI = ptr to world-header
	mov	ds:[@@FLags],ecx		
	mov	esi,ds:[esi+World_Palette]	;DS:ESI points to palette
	;
	push	edx				;Save srtart position
	push	ebx				;Save file-name
	mov	ecx,3*256
	call	Malloc
	mov	edi,eax				;EDI = temp buffer
	mov	ecx,256
	@@L1:	lodsd
		shr	eax,2
		and	eax,03f3f3fh
		stosd
		dec	edi
		dec	ecx
		jnz	short @@L1
	sub	esi,4*256
	sub	edi,3*256
	;
	pop	ebx				;EBX = ptr to filename
	xor	ecx,ecx
	call	Creat                           ;Open file
	pop	ecx				;ECX = Start position
	jc	@@Err
	mov	ds:[FileHandle],eax

	mov	ebx,eax				;EBX = file handle
	mov	al,SEEK_SET
	call	Seek				;Seek to desired position

	mov	ebx,ds:[FileHandle]
	mov	ecx,256*3
	mov	edx,edi
	call	Write				;Read in palette

	mov     ebx,ds:[FileHandle]
	call	Close

	mov	ecx,edi
	call	Free
	;
	clc
@@Err: 	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@flags	dd	?
GVE_Export_Palette ENDP
CODE32 ENDS
END

