;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
GVE_SYSTEM_FILE		equ	1



;
;
;
;   GOMEZ VECTOR ENGINE                                            v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gomez.inc
include gve32.inc
include gvemacro.inc

extrn C GVE_Alloc_Object:near
extrn C GVE_Alloc_World:near
extrn C GVE_Alloc_Camera:near
extrn C GVE_Alloc_Light:near
extrn GVE_Reference_Primitives:near
extrn GVE_DeReference_Primitives:near

;
;
;
;   GOMEZ VECTOR ENGINE                                        MACRO-TOOLS
;
;
;
;
;
; GVE_Build_WOrld:
;   Input:
;	EAX	- DATA32 ptr to MACRO-World
;   Output:
;	EAX	- DATA32 ptr to world-header
;	[CF]	- Error flag
;
PUBLIC C GVE_Build_World
GVE_Build_World PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	xor	ebp,ebp
	mov	esi,eax				;ESI = src-world
	cmp	d ds:[eax],GVE_MAC_WORLD
	jne	@@Err

	call	GVE_Alloc_World
	jc	@@Err
	mov	ebx,ds:[esi+8]			;EBX = Flags
	mov	ebp,eax				;EBP = World-Header
	mov	ds:[eax+World_Flags],ebx
	add	esi,12
	;
@@L1:	mov	eax,ds:[esi]			;EAX = Chunk-Type
	cmp	eax,GVE_MAC_END
	je      @@End
	cmp	eax,GVE_MAC_OBJECT
	jne	short @@1
		call	MAC_OBJECT
		jmp	short @@Nxt1
@@1:	cmp	eax,GVE_MAC_LIGHT
	jne	short @@2
		call	MAC_LIGHT
		jmp	short @@Nxt1
@@2:	cmp	eax,GVE_MAC_CAMERA
	jne	short @@Nxt1
		call	MAC_CAMERA
		jmp	short @@Nxt1
@@Nxt1:	add	esi,ds:[esi+4]
	jmp	short @@L1
	;
@@End: 	clc
@@Err:  mov	eax,ebp
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Build_World ENDP
;
MAC_OBJECT:
	mov	eax,ebp
	call	GVE_Alloc_Object
	jc	@@Err
	mov	edi,eax				;EDI = Object-Header
	mov	ecx,ds:[esi+8]			;ECX = SIze of vertex list
	call	Malloc				;EAX = New vertex list
	jc	@@Err
	mov	ecx,ds:[edi+Object_Vertex_List]	;ECX = Old vertex list
	mov	ds:[edi+Object_Vertex_List],eax
	call	Free

	mov	ecx,ds:[esi+12]			;ECX = SIze of face list
	call	Malloc				;EAX = New face list
	jc	@@Err
	mov	ecx,ds:[edi+Object_Face_List]	;ECX = Old face list
	mov	ds:[edi+Object_Face_List],eax
	call	Free

	mov	eax,ds:[esi+16]
	mov	ds:[edi+Object_Flags],eax
	;
	push	esi
	add	esi,13*4
@@L1:  	mov	eax,ds:[esi]
	cmp	eax,GVE_MAC_END
	je	short @@End
	cmp	eax,GVE_MAC_VERTEX_LIST
	jne	short @@1
		call	MAC_VERTEX_LIST
		jmp	short @@Nxt
@@1:	cmp	eax,GVE_MAC_FACE_LIST
	jne	short @@Nxt
		call	MAC_FACE_LIST
		jmp	short @@Nxt
@@Nxt:	add	esi,ds:[esi+4]
	jmp	short @@L1
	;
@@End:  or	ds:[edi+Object_Flags],GVE_OBJ_VERTEX_INDEX
	and	ds:[edi+Object_Flags],NOT GVE_OBJ_VERTEX_ADDRESS
	mov	eax,edi
	call	GVE_Reference_Primitives
@@Err:	pop	esi
	retn
;
MAC_VERTEX_LIST:
	push	esi
	push	edi
	mov	ecx,ds:[esi+8]			;ECX = Number of vertices
	mov	edi,ds:[edi+Object_Vertex_List]
	mov	ds:[edi],ecx
	add	esi,12
	add	edi,4
@@L3:	;
	mov	eax,ds:[esi]
	mov	ebx,ds:[esi+4]
	mov	edx,ds:[esi+8]
	mov	ds:[edi+VertexX],eax
	mov	ds:[edi+VertexY],ebx
	mov	ds:[edi+VertexZ],edx
	mov	ebx,ds:[esi+12]
	mov	edx,ds:[esi+16]
	mov	ds:[edi+Vertex_TextureU],ebx
	mov	ds:[edi+Vertex_TextureV],edx
	add	esi,5*4
	add	edi,GVE_VERTEX_SIZE
	dec	ecx
	jnz	short @@L3
	;
	pop	edi
	pop	esi
	retn
;
MAC_FACE_LIST:
	push	esi
	push	edi
	mov	ecx,ds:[esi+8]			;ECX = Number of faces
	mov	edi,ds:[edi+Object_Face_List]
	mov	ds:[edi],ecx
	add	esi,12
	add	edi,4
@@L4:	;
	mov	ax,ds:[esi+2]
	mov	ebx,ds:[esi+4]
	mov	w ds:[edi],GVE_TRIANGLE_SIZE
	mov	ds:[edi+2],ax
	mov	ds:[edi+4],ebx
	movzx	eax,w ds:[esi+8]
	movzx	ebx,w ds:[esi+10]
	movzx	edx,w ds:[esi+12]
	mov	ds:[edi+Triangle_Vertex1],eax
	mov	ds:[edi+Triangle_Vertex2],ebx
	mov	ds:[edi+Triangle_Vertex3],edx
	movzx	eax,w ds:[esi]
	add	esi,eax
	add	edi,GVE_TRIANGLE_SIZE
	dec	ecx
	jnz	short @@L4
	;
	pop	edi
	pop	esi
	retn
;
MAC_LIGHT:
	mov	eax,ebp
	call	GVE_Alloc_Light
	mov	ebx,ds:[esi+8]
	mov	ecx,ds:[esi+12]
	mov	edx,ds:[esi+16]
	mov	ds:[eax+Light_PositionX],ebx
	mov	ds:[eax+Light_PositionY],ecx
	mov	ds:[eax+Light_PositionZ],edx
	mov	ebx,ds:[esi+20]
	mov	ecx,ds:[esi+24]
	mov	edx,ds:[esi+28]
	mov	ds:[eax+Light_RotationX],ebx
	mov	ds:[eax+Light_RotationY],ecx
	mov	ds:[eax+Light_RotationZ],edx
	retn
;
MAC_CAMERA:
	mov	eax,ebp
	call	GVE_Alloc_Camera
	mov	ebx,ds:[esi+8]
	mov	ecx,ds:[esi+12]
	mov	edx,ds:[esi+16]
	mov	ds:[eax+Camera_PositionX],ebx
	mov	ds:[eax+Camera_PositionY],ecx
	mov	ds:[eax+Camera_PositionZ],edx
	mov	ebx,ds:[esi+20]
	mov	ecx,ds:[esi+24]
	mov	edx,ds:[esi+28]
	mov	ds:[eax+Camera_RotationX],ebx
	mov	ds:[eax+Camera_RotationY],ecx
	mov	ds:[eax+Camera_RotationZ],edx
	retn

code32 ends
end