;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
;
;
;   GOMEZ VECTOR ENGINE                                   MACRO-Stuff
;
;
;
GVE_MAC_WORLD		equ	1
GVE_MAC_OBJECT		equ	2
GVE_MAC_LIGHT		equ	3
GVE_MAC_CAMERA		equ	4
GVE_MAC_VOID		equ	5
GVE_MAC_VERTEX_LIST	equ	6
GVE_MAC_FACE_LIST	equ	7
GVE_MAC_END		equ	8

@GVE_CURRENT_MACRO	=	GVE_MAC_VOID
@GVE_CURRENT_SHADING	=       VOBJ_GOURAUD_POLY
@GVE_CURRENT_PHONG	=	8
@GVE_CURRENT_TEXTURE	=	0
@GVE_CURRENT_BUMP	=	0
@GVE_WORLD_ADDRESS 	=	0
@GVE_OBJECT_ADDRESS 	=	0
@GVE_VERTEX_ADDRESS 	=	0
@GVE_FACE_ADDRESS	=	0
@GVE_TRANSLATE_X	=       0
@GVE_TRANSLATE_Y	=       0
@GVE_TRANSLATE_Z	=       0
@GVE_SCALE_X		=       1 shl GVE_MATH_SHIFT
@GVE_SCALE_Y		=       1 shl GVE_MATH_SHIFT
@GVE_SCALE_Z		=       1 shl GVE_MATH_SHIFT
@GVE_FACE_COUNTER	=	0
@GVE_VERTEX_COUNTER	=	0
@GVE_FACE_SIZE		=	0
@GVE_VERTEX_SIZE	=	0
@GVE_FACE_LIST		=	0
@GVE_VERTEX_LIST	=	0
@GVE_WORLD_NAME		=	0
@GVE_OBJECT_FLAGS	=	0
@GVE_WORLD_FLAGS	=	0




CREATE_WORLD MACRO name
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_VOID)
		ERR	"CREATE_WORLD cannot be used within an object etc..."
	endif

	ALIGN	16
	@GVE_CURRENT_MACRO	=	GVE_MAC_WORLD
	@GVE_WORLD_ADDRESS	=	$
	@GVE_WORLD_NAME		=	name

	PUBLIC C &name
	&name LABEL DWORD

	dd	GVE_MAC_WORLD
	dd	?			;Size
	dd	?			;Flags
	ENDM

FINISH_WORLD MACRO
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_WORLD)
		ERR	"FINISH_WORLD must close CREATE_WORLD"
	endif

	dd	GVE_MAC_END
	dd	8

	??oldaddress		=	$

	ORG	@GVE_WORLD_ADDRESS+4
	dd	??oldaddress-@GVE_WORLD_ADDRESS
	dd	@GVE_WORLD_FLAGS

	ORG	??oldaddress
	@GVE_CURRENT_MACRO	=	GVE_MAC_VOID
	ENDM




CREATE_OBJECT MACRO name
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_WORLD)
		ERR	"CREATE_OBJECT cannot be used within an object etc..."
	endif

	@GVE_CURRENT_MACRO	=	GVE_MAC_OBJECT
	@GVE_OBJECT_ADDRESS	=	$
	@GVE_FACE_COUNTER	=	0
	@GVE_VERTEX_COUNTER	=	0
	@GVE_FACE_SIZE		=	0
	@GVE_VERTEX_SIZE	=	0
	@GVE_FACE_LIST		=	0
	@GVE_VERTEX_LIST	=	0

	dd      GVE_MAC_OBJECT          ;Magic
	dd	?			;Size of this block
	dd	?			;Vertex size
	dd	?			;Face size
	dd	?			;FLags
	db	32 dup (0)		;Object name

	??oldaddress		=	$
	ORG	$-32
	db	name,0
	ORG	??oldaddress
	ENDM

FINISH_OBJECT MACRO
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_OBJECT)
		ERR	"FINISH_OBJECT must close CREATE_OBJECT"
	endif

	dd	GVE_MAC_END
	dd	8

	??oldaddress		=	$

	ORG	@GVE_OBJECT_ADDRESS+4
	dd	??oldaddress-@GVE_OBJECT_ADDRESS
	dd	@GVE_VERTEX_SIZE
	dd	@GVE_FACE_SIZE
	dd	@GVE_OBJECT_FLAGS

	ORG	??oldaddress
	@GVE_CURRENT_MACRO	=	GVE_MAC_WORLD
	ENDM




CREATE_VERTEX_LIST MACRO
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_OBJECT)
		ERR	"CREATE_VERTEX_LIST must reside in CREATE_OBJECT"
	endif
	if	(@GVE_VERTEX_LIST eq 1)
		ERR	"There is already a vertex list defined for this object"
	endif

	@GVE_CURRENT_MACRO	=	GVE_MAC_VERTEX_LIST
	@GVE_VERTEX_LIST	=	1
	@GVE_VERTEX_ADDRESS	=	$
	@GVE_VERTEX_SIZE	=	4

	dd      GVE_MAC_VERTEX_LIST
	dd	?                       ;SIze
	dd	?			;Number of vertices
	ENDM

FINISH_VERTEX_LIST MACRO
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_VERTEX_LIST)
		ERR	"FINISH_VERTEX_LIST must close CREATE_VERTEX_LIST"
	endif
	??oldaddress		=	$

	ORG	@GVE_VERTEX_ADDRESS+4
	dd	??oldaddress-@GVE_VERTEX_ADDRESS
	dd	@GVE_VERTEX_COUNTER

	ORG	??oldaddress
	@GVE_CURRENT_MACRO	=	GVE_MAC_OBJECT
	ENDM




CREATE_FACE_LIST MACRO
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_OBJECT)
		ERR	"CREATE_FACE_LIST must reside in CREATE_OBJECT"
	endif
	if	(@GVE_FACE_LIST eq 1)
		ERR	"There is already a face list defined for this object"
	endif

	@GVE_CURRENT_MACRO	=	GVE_MAC_FACE_LIST
	@GVE_FACE_LIST		=	1
	@GVE_FACE_ADDRESS	=	$
	@GVE_FACE_SIZE		=	4

	dd      GVE_MAC_FACE_LIST
	dd	?                       ;SIze
	dd	?			;Number of faces
	ENDM

FINISH_FACE_LIST MACRO
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_FACE_LIST)
		ERR	"FINISH_FACE_LIST must close CREATE_FACE_LIST"
	endif
	??oldaddress		=	$

	ORG	@GVE_FACE_ADDRESS+4
	dd	??oldaddress-@GVE_FACE_ADDRESS
	dd	@GVE_FACE_COUNTER

	ORG	??oldaddress
	@GVE_CURRENT_MACRO	=	GVE_MAC_OBJECT
	ENDM




ADD_VERTEX MACRO x,y,z,u,v
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_VERTEX_LIST)
		ERR	"ADD_VERTEX may only be used in a VERTEX_LIST"
	endif

	dd	((x)*@GVE_SCALE_X)+@GVE_TRANSLATE_X
	dd	((y)*@GVE_SCALE_Y)+@GVE_TRANSLATE_Y
	dd	((z)*@GVE_SCALE_Z)+@GVE_TRANSLATE_Z
	dd	u
	dd	v

	@GVE_VERTEX_COUNTER	=	@GVE_VERTEX_COUNTER+1
	@GVE_VERTEX_SIZE	=	@GVE_VERTEX_SIZE+GVE_VERTEX_SIZE
	ENDM



ADD_TRIANGLE MACRO a,b,c
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_FACE_LIST)
		ERR	"ADD_TRIANGLE may only be used in a FACE_LIST"
	endif

	dw	4*4
	db	@GVE_CURRENT_SHADING
	db	3
	db	@GVE_CURRENT_BUMP
	db	@GVE_CURRENT_PHONG
	dw	@GVE_CURRENT_TEXTURE
	dw	a,b,c,0

	@GVE_FACE_COUNTER	=	@GVE_FACE_COUNTER+1
	@GVE_FACE_SIZE		=	@GVE_FACE_SIZE+GVE_TRIANGLE_SIZE
	ENDM




ADD_LIGHT MACRO x,y,z,rx,ry,rz
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_WORLD)
		ERR	"ADD_LIGHT cannot be used within an object etc..."
	endif

	dd	GVE_MAC_LIGHT
	dd	8*4
	dd	((x)*@GVE_SCALE_X)+@GVE_TRANSLATE_X
	dd	((y)*@GVE_SCALE_Y)+@GVE_TRANSLATE_Y
	dd	((z)*@GVE_SCALE_Z)+@GVE_TRANSLATE_Z
	dd	rx
	dd	ry
	dd	rz
	ENDM



ADD_CAMERA MACRO x,y,z,rx,ry,rz
	if	(@GVE_CURRENT_MACRO ne GVE_MAC_WORLD)
		ERR	"ADD_CAMERA cannot be used within an object etc..."
	endif

	dd	GVE_MAC_CAMERA
	dd	8*4
	dd	((x)*@GVE_SCALE_X)+@GVE_TRANSLATE_X
	dd	((y)*@GVE_SCALE_Y)+@GVE_TRANSLATE_Y
	dd	((z)*@GVE_SCALE_Z)+@GVE_TRANSLATE_Z
	dd	rx
	dd	ry
	dd	rz
	ENDM



SET_FLAGS MACRO f
	if	(@GVE_CURRENT_MACRO	eq	GVE_MAC_WORLD)
		@GVE_WORLD_FLAGS	=	f
	else
	 if	(@GVE_CURRENT_MACRO	eq	GVE_MAC_OBJECT)
		@GVE_OBJECT_FLAGS	=	f
	 else
		ERR	"SET_FLAGS may only be used in OBJECT or WORLD"
	 endif
	endif
	ENDM

SET_COLOUR MACRO col
	@GVE_CURRENT_TEXTURE	=	col
	ENDM

SET_PHONG MACRO phong
	@GVE_CURRENT_PHONG	=	phong
	ENDM

SET_TEXTURE MACRO tex
	@GVE_CURRENT_TEXTURE	=	tex
	ENDM

SET_BUMP MACRO tex
	@GVE_CURRENT_BUMP	=	tex
	ENDM

SET_SHADING MACRO shad
	@GVE_CURRENT_SHADING	=	shad
	ENDM

SET_TRANSLATION MACRO x,y,z
	@GVE_TRANSLATE_X	=	x
	@GVE_TRANSLATE_Y	=	y
	@GVE_TRANSLATE_Z	=	z
	ENDM

SET_SCALING MACRO x,y,z
	@GVE_SCALE_X		=	x
	@GVE_SCALE_Y		=	y
	@GVE_SCALE_Z		=	z
	ENDM
