;͸
;                                                                          
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                    
;                                                                          
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	    
; You may use the whole code or only parts of it in your own programs      
; whether they are commercial or not. BUT you must give credits for these  
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                       
; I am not responsible for any damage or loss caused by this program, so   
; if you success in erasing your harddisk with this code, then it is your  
; own fault and you should not claim me to be responsible...               
; I would be very pleased if you also sent me a postcard or even a letter  
; if you can use this code. My address:                                    
;                                                                          
;        Kaya Memisoglu                                                    
;        Reichenberger Ring 50                                             
;        63512 Hainburg                                                    
;        Germany                                                           
;	                                                                    
;	  Internet: memisogl@stud.uni-frankfurt.de                          
;                                                                          
; You can also leave a message for Marc van Shaney on the Nirvana BBS:     
;                                                                          
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza      
;                                                                          
;                                                                          
;;
;
;
P486
LOCALS
JUMPS

GVE_VERSION		equ	100h
GVE_SYSTEM_FILE		equ	1
GVE_PROFILER		equ	1


;
;
;
;   GOMEZ VECTOR ENGINE                                            v1.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gve32.inc
include gomez.inc

b	equ	byte ptr
w	equ	word ptr
d	equ	dword ptr


Free_and_Zero	MACRO a
	LOCAL J
	mov	ecx,a
	test	ecx,ecx
	jz	short J
	call	Free
	mov	a,0
J:
	ENDM

;
;
;
;   GOMEZ VECTOR ENGINE  pro                             ASSEMBLING-CHECK
;
;
;


IF1
 ifdef GVE_PRO
  DISPLAY "   GVE/pro Version"
 endif
 ifdef GVE_CULL_FIRST
  DISPLAY "   Culling before vertex-transformation"
 endif
 ifdef GVE_CULL_AFTER
  DISPLAY "   Culling after vertex-transformation"
 endif
 ifdef GVE_PROFILER
  DISPLAY "   Profiler enabled"
 endif
 DISPLAY "   Assembling pass 1 . . ."
endif
IF2
 DISPLAY "   Assembling pass 2 . . ."
endif


;
;
; The Gomez Vector-Engine:
; =============================
;
; There are three lists used by this program:
; 1) The point list:
;    This lists contains all 3D points defined for the polygons
;    Its structure looks like this:
;
;    word  Number of points defined (NOP)
;    NOP*14 dwords of entries:
;    	dword X          	You only need to fill these
;    	dword Y	       		three coordinates. The other items
;    	dword Z	       		will be used only internally.
;    	dword transformed X
;    	dword transformed Y
;    	dword transformed Z
;	dword projected X
;	dword projected Y
;    	dword Normal X
;	dword Normal Y
;	dword Normal Z
;	dword transformed Normal X
;	dword transformed Normal Y
;	dword transformed Normal Z
;
;
; 2) The primitive list:
;    word  Number of Primitives (NOP)
;    Then follows the primitive list:
;      word size (including header)
;      byte type		For exapmle VOBJ_POLY,VOBJ_FILLED_POLY etc.
;	byte reserved
;      data
;    The primitive list should NOT define any points but refer to the first
;    list, as only this first list will be transformed !
;
; 3) The order list:
;    This list will be calculated (meaning sorted) after each transform, so
;    that the objects wich are the farest away will be drawn first
;    word Number of Entries (NOE)
;    NOE*8 bytes:
;	dword Pointer to primitive
;      dword Average Z coordinate (will be calculated after transformation
;                                  for faster sorting)
;
; Once you have called GVE_Init_World, the whole scenario will look like
;   this:
;
;
;                            Primitive list:
;                              dword  count
;
;                              word  size
;			        byte  type
;			        byte  flags (1: already using offset)
;                              data
;
; Order_List:                  [...]
;   dword   count
;   dword  ptr   ----------->  word size
;   dword  z                   byte type                  vector list:
;                              byte flag                    dword count
;   ...                        data:                        8*dword vector
;                                  dword ptr ------------>  8*dword vector
;                                  ...                        ....
;
;                              ...
;
;
PUBLIC C GVE_Object_List
PUBLIC C GVE_Texture_List
PUBLIC C GVE_PhongMap_List
PUBLIC C GVE_Order_List
PUBLIC C GVE_Frame_Buffer
PUBLIC C GVE_Flags
PUBLIC C GVE_Camera_Matrix
PUBLIC C GVE_Light_Matrix
PUBLIC C GVE_Shading_LUT
PUBLIC C GVE_Glass_LUT
PUBLIC C GVE_Bump_LUT
PUBLIC C GVE_Palette
PUBLIC C GVE_Light_Source
PUBLIC C GVE_ViewPort
PUBLIC C GVE_Debug_Index
PUBLIC C GVE_Script_Directory

PUBLIC C GVE_IO_Buffer			;These two buffers are used
PUBLIC C GVE_LZW_Stack			; for internal use only
PUBLIC C GVE_Palette_Buffer


ALIGN 4
GVE_Object_List			dd	0
GVE_Texture_List		dd	0
GVE_Order_List			dd	0
GVE_PhongMap_List			dd	0
GVE_Frame_Buffer		dd	0
GVE_Shading_LUT			dd	0
GVE_Glass_LUT			dd	0
GVE_Bump_LUT			dd	0
GVE_Flags			dd	0
GVE_Palette			dd	0
GVE_Light_Source		dd	0
GVE_ViewPort			dd	0
GVE_Debug_Index			dd	0
GVE_Timer			dd	0
GVE_Script_Directory		dd	0
ALIGN 16
GVE_Camera_Matrix		GVE_MATRIX	<1 shl GVE_MATRIX_SHIFT,0,0,0,  \
						 0,1 shl GVE_MATRIX_SHIFT,0,0,  \
						 0,0,1 shl GVE_MATRIX_SHIFT,0,  \
						 0,0,0,1 shl GVE_MATRIX_SHIFT>
GVE_Light_Matrix		GVE_MATRIX  	<1 shl GVE_MATRIX_SHIFT,0,0,0,  \
						 0,1 shl GVE_MATRIX_SHIFT,0,0,  \
						 0,0,1 shl GVE_MATRIX_SHIFT,0,  \
						 0,0,0,1 shl GVE_MATRIX_SHIFT>
Current_Light			GVE_VECTOR  	<?>
X_Distance			dd	1 shl GVE_DISTANCE
Y_Distance			dd	1 shl GVE_DISTANCE


;
;
; The next two macros are used for matrix-vector multiplications:
;
; MULT_VECTOR (matrix,src,dst,type)
;  Input:
;    matrix	- Matrix A
;    src	- Source Vector x
;    type	- MV_MULT_4x4  or
;		  MV_MULT_3x3
;  Output:
;    dst	- Destination Vector y:=Ax
;  Destroys:
;    EAX,EBX,ECX,EDX
;
;
; TRANSPOSED_MULT_VECTOR (matrix,src,dst,type)
;  Input:
;    matrix	- Matrix A
;    src	- Source Vector x
;  Output:
;    dst	- Destination Vector y:=A'x
;                with A' the transposed matrix of A
;  Destroys:
;    EAX,EBX,ECX,EDX
;
MV_MULT_4x4	equ	1
MV_MULT_3x3	equ	2
MV_REG_INIT	equ	4

MULT_VECTOR MACRO mtx,src,dst,typ
	push	ebp
	if ((typ) AND MV_REG_INIT)
	 mov	ebp,ebx			;EBP = Y
	 mov	ebx,eax			;EBX = X
	else
	 mov	ebx,d ds:[src]		;EBX = X
	 mov	ebp,d ds:[src+4]	;EBP = Y
	 mov	ecx,d ds:[src+8]	;ECX = Z
	endif
	;
	mov 	eax,d ds:[mtx+E11]
	imul 	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst],edx
	mov 	eax,d ds:[mtx+E12]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst],edx
	mov 	eax,ds:[mtx+E13]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	if ((typ) AND MV_MULT_4x4)
	 mov	eax,d ds:[mtx+E14]
	 add 	d ds:[dst],edx
	 add 	d ds:[dst],eax
	else
	 add 	d ds:[dst],edx
	endif
	;
	mov 	eax,d ds:[mtx+E21]
	imul	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst+4],edx
	mov 	eax,d ds:[mtx+E22]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst+4],edx
	mov 	eax,d ds:[mtx+E23]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	if ((typ) AND MV_MULT_4x4)
	 mov	eax,d ds:[mtx+E24]
	 add 	d ds:[dst+4],edx
	 add 	d ds:[dst+4],eax
	else
	 add 	d ds:[dst+4],edx
	endif
	;
	mov 	eax,d ds:[mtx+E31]
	imul 	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst+8],edx
	mov 	eax,d ds:[mtx+E32]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst+8],edx
	mov 	eax,d ds:[mtx+E33]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	if ((typ) AND MV_MULT_4x4)
	 mov	eax,d ds:[mtx+E34]
	 add 	d ds:[dst+8],edx
	 add 	d ds:[dst+8],eax
	else
	 add 	d ds:[dst+8],edx
	endif
	pop	ebp
	ENDM
;
TRANSPOSED_MULT_VECTOR MACRO mtx,src,dst,typ
	push	ebp
	if ((typ) AND MV_REG_INIT)
	 mov	ebp,ebx			;EBP = Y
	 mov	ebx,eax			;EBX = X
	else
	 mov	ebx,d ds:[src]		;EBX = X
	 mov	ebp,d ds:[src+4]	;EBP = Y
	 mov	ecx,d ds:[src+8]	;ECX = Z
	endif
	;
	mov 	eax,d ds:[mtx+E11]
	imul 	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst],edx
	mov 	eax,d ds:[mtx+E21]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst],edx
	mov 	eax,d ds:[mtx+E31]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	if ((typ) AND MV_MULT_4x4)
	 mov	eax,d ds:[mtx+E41]
	 add 	d ds:[dst],edx
	 add 	d ds:[dst],eax
	else
	 add 	d ds:[dst],edx
	endif
	;
	mov 	eax,d ds:[mtx+E12]
	imul	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst+4],edx
	mov 	eax,d ds:[mtx+E22]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst+4],edx
	mov 	eax,d ds:[mtx+E32]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	if ((typ) AND MV_MULT_4x4)
	 mov	eax,d ds:[mtx+E42]
	 add 	d ds:[dst+4],edx
	 add 	d ds:[dst+4],eax
	else
	 add 	d ds:[dst+4],edx
	endif
	;
	mov 	eax,d ds:[mtx+E13]
	imul 	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst+8],edx
	mov 	eax,d ds:[mtx+E23]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst+8],edx
	mov 	eax,d ds:[mtx+E33]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	if ((typ) AND MV_MULT_4x4)
	 mov	eax,d ds:[mtx+E43]
	 add 	d ds:[dst+8],edx
	 add 	d ds:[dst+8],eax
	else
	 add 	d ds:[dst+8],edx
	endif
	pop	ebp
	ENDM


;
;
; Now follows a LUT-Generator in order to get a shading LUT for a given 3*6
; bit palette. Note the following MACRO is used to get the best colour
; within the palette
;
;
; FIT_COLOUR:
;  Input:
;	EDX   	holds colour to fit	(3*6 bit)
;	ES:ESI 	points to palette	(3*6 bit)
;  Output:
;	BL      Best difference
;	BH	Best colour
;  Destroys:
;	CL
;	AX
;
FIT_COLOUR MACRO
	LOCAL L01,NS1,NS2,NS3,NoFit
	push 	esi		;Save old colour-ptr

	xor	cl,cl
	mov 	bx,0ffh		;BL=Difference BH=Best_Colour
L01:		mov 	ax,ds:[esi]	;AL=RED AH=GREEN
		sub 	al,dl		;Red difference
		jns 	short NS1
		neg 	al
	 NS1:   sub 	ah,dh		;Green difference
		jns 	short NS2
		neg 	ah
	 NS2:	add 	al,ah
		bswap 	edx
		mov 	ah,ds:[esi+2]
		sub 	ah,dh		;Blue difference
		jns 	short NS3
		neg 	ah
	 NS3:	add 	al,ah
		bswap	edx
		cmp     al,bl		;Compare differences
		jae	short NoFit
			mov	bl,al	;Best difference
			mov	bh,cl	;Best index
 NoFit: add	esi,3
	inc	cl
	jnz	short L01

	pop	esi
	ENDM

;
;   GOMEZ VECTOR ENGINE        DATA AREA
;
ALIGN 16
GVE_IO_Buffer 		LABEL BYTE
ORG $+264
GVE_Palette_Buffer 	LABEL BYTE
GVE_LZW_Stack 		LABEL BYTE    	; !!! ATTENTION !!! The stack must have 4 kB !
ORG $-264

Poly_Edges	LABEL DWORD
	dd	GVE_MAX_EDGES*4		dup (?)
Line_Table	LABEL DWORD
	dd	8*DISPLAY_Height	dup (?)
Phong_Table	LABEL BYTE
	db	256*GVE_PHONG_MAX_EXP	dup (?)
Phong_Texture_Table LABEL BYTE
	db	256*GVE_PHONG_MAX_EXP	dup (?)
Blurr_Table	LABEL BYTE
	db	256			dup (?)
SinTab	dd	GVE_COSINE_SIZE/4	dup (?)
CosTab	dd	GVE_COSINE_SIZE		dup (?)

ALIGN 16
DeltaX	   LABEL DWORD
Clip_Bits		dd		?
Clip_Old_X		dd              ?
Clip_Old_Y		dd              ?
Clip_Old_Data		LABEL DWORD
Clip_Old_Data1		dd		?
Clip_Old_Data2		dd		?
Line_Table_Start	dd		?
Line_Table_End		dd		?
Object_Counter		dd		?
Vertex_Counter		dd		?
Face_Counter		dd		?



;
;
; The following macro is a powerful clipper for polys (CLIP_POLY)
; Input:
;   ES:ESI  -  Ptr to object-header
;   ES:EBP  -  Ptr to special data
;   ECX     -  Number of vertices
; Output:
;   EBP     -  16*number of edges (not including the repetition of last edge)
;   Poly_Edges
;   Line_Table_Start
;   Line_Table_End
; Destroys:
;   EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
;
; There is another small macro here: SET_CLIP_BITS
; Input:
;   EAX     -  X Coordinate
;   EBX     -  Y Coordinate
; Output:
;   EDX     -  Clip-Bytes
; Destroys:
;   Nothing
;
;
; Another fine macro: OUT_VERTEX
; Input:
;   EAX     -  X Coordinate
;   EBX     -  Y Coordinate
;   EDI     -  Data value (not needed)
;   EBP     -  Current ptr+16 to Poly_Edge_List
; Output:
;   Poly_Edges
;   Line_Table_End
;   Line_Table_Start
;   EBP     -  Next index
;
;
; Plus two clipping macros: CLIP_HLINE, CLIP_VLINE
; Input:
;   EAX     - X Coordinate
;   EBX     - Y Coordinate
;   EDI     - Data value
;   ds:[Clip_Old_X], ds:[Clip_Old_Y]
; Output:
;   New edge via OUT_VERTEX
; Destroys:
;   Nothing
;
;
; Note the structure of the Clip-Bits:
;              a b c d
;                 
;                 Vertice is below window
;                Vertice is above window
;               Vertice is right from window
;              Vertice is left from window
;
;
SIMPLE_POLY		equ	1	;No special values
SPECIAL_POLY		equ	2
GOURAUD_POLY		equ	3
FAST_PHONG_POLY		equ	5
TEXTURE_POLY		equ	20	;Use 20 or higher, if 2 data words
CHROME_POLY		equ	21	;  are used
TEXTURE_GOURAUD_POLY	equ	40	;Use 40 or higher, if 2 data words
TEXTURE_PHONG_POLY	equ	41	;  plus 1 data dword are used
CHROME_GOURAUD_POLY	equ	42
CHROME_PHONG_POLY	equ	43


SET_CLIP_BITS MACRO
	cmp 	eax,DISPLAY_WIDTH
	setge	dl			;Vertex is right from window
	test	eax,eax
	sets	dh			;Vertex is left from window
	bswap	edx
	cmp	ebx,DISPLAY_HEIGHT
	setge	dl			;Vertex is below window
	test	ebx,ebx
	sets	dh			;Vertex is above window
ENDM
;
OUT_VERTEX MACRO poly_type
	LOCAL N1,N2
	mov	ds:[Poly_Edges+ebp+16],eax
	mov	ds:[Poly_Edges+ebp+20],ebx
	if poly_type ge 2
	  mov	ds:[Poly_Edges+ebp+24],edi
	endif
	if poly_type ge 40
	  mov	ds:[Poly_Edges+ebp+28],esi
	endif
	add	ebp,16			;Next edge

	cmp	ds:[Line_Table_Start],ebx
	jl	short N1
		mov	ds:[Line_Table_Start],ebx
N1:	cmp	ds:[Line_Table_End],ebx
	jg	short N2
		mov	ds:[Line_Table_End],ebx
N2:
ENDM
;
CLIP_VLINE MACRO ymax,poly_type,direction
	LOCAL NOUT, CC1
	;Now lets clip
	;
	;  x:=x0 + (x1 - x0) * (ymax - y0) / (y1 - y0)
	;  y:=ymax
	;  d:=d0 + (d1 - d0) * (ymax - y0) / (y1 - y0)
	;
	;or:
	;  x:=x1 + (x1 - x0) * (ymax - y1) / (y1 - y0)
	;  y:=ymax
	;  d:=d0 + (d1 - d0) * (ymax - y0) / (y1 - y0)
	;
	push	eax			;EAX = X1
	push	ebx			;EBX = Y1
	push	edx
	if poly_type ge 2
	  push 	edi			;EDI = D1
	endif
	if poly_type ge 40
	  push	esi
	endif
	;
	if direction eq 1
	 sub	eax,ds:[Clip_Old_X]	;EAX = x1 - x0
	 sub	ebx,ds:[Clip_Old_Y]	;EBX = y1 - y0
	 mov	edx,ymax
	 sub	edx,ds:[Clip_Old_Y]	;EDX = ymax - y0
	 imul	edx
	 idiv	ebx
	 add	eax,ds:[Clip_Old_X]	;EAX = Clipped X
	else
	 mov	d ds:[CC1-4],eax	;Save x1
	 mov	edx,ymax
	 sub	edx,ebx			;EDX = ymax - y1
	 sub	eax,ds:[Clip_Old_X]	;EAX = x1 - x0
	 sub	ebx,ds:[Clip_Old_Y]	;EBX = y1 - y0
	 imul	edx
	 idiv	ebx
	 add	eax,12345678h		;EAX = Clipped X
    CC1:
	endif
	;
	cmp	eax,DISPLAY_WIDTH	;Is clipped point in window ?
	if (poly_type lt 40)
	 jae	short NOUT
	else
	 jae	NOUT
	endif
	;
	if (poly_type ge 2) and (poly_type lt 20)
	 push	eax
	 sub	edi,ds:[Clip_Old_Data]	;EDI = d1 - d0
	 mov	eax,ymax
	 sub	eax,ds:[Clip_Old_Y]	;EAX = ymax - y0
	 imul	edi
	 idiv	ebx
	 add	eax,ds:[Clip_Old_Data]	;EAX = Clipped D
	 mov	edi,eax
	 pop	eax
	endif
	if (poly_type ge 20)		;This is for textures
	 push	eax
	 sub	edi,ds:[Clip_Old_Data]	;EDI = d1 - d0
	 mov	eax,ymax
	 sub	eax,ds:[Clip_Old_Y]	;EAX = ymax - y0
	 imul	di
	 idiv	bx                      ;EBX = y1 - y0
	 mov	di,ax

	 rol	edi,16
	 mov	eax,ymax
	 sub	eax,ds:[Clip_Old_Y]	;EAX = ymax - y0
	 imul	di
	 idiv	bx                     	;EBX = y1 - y0
	 mov	di,ax
	 rol	edi,16
	 add	edi,ds:[Clip_Old_Data]	;EDI = Clipped D
	 if (poly_type lt 40)
	  pop	eax
	 endif
	endif
	if (poly_type ge 40)
	 sub	esi,ds:[Clip_Old_Data2]	;EDI = d1 - d0
	 mov	eax,ymax
	 sub	eax,ds:[Clip_Old_Y]	;EAX = ymax - y0
	 imul	esi
	 idiv	ebx
	 add	eax,ds:[Clip_Old_Data2]	;EAX = Clipped D
	 mov	esi,eax
	 pop	eax
	endif
	;
	mov	ebx,ymax      		;EBX = Clipped Y
	OUT_VERTEX poly_type		;Put out new vertex
NOUT:   if poly_type ge 40
	  pop	esi
	endif
	if poly_type ge 2
	  pop	edi
	endif
	pop	edx
	pop	ebx
	pop	eax
ENDM
;
CLIP_HLINE MACRO xmax,poly_type,direction
	LOCAL NOUT,CC1
	;Now lets clip
	;
	;  y:=y0 + (y1 - y0) * (xmax - x0) / (x1 - x0)
	;  x:=xmax
	;  d:=d0 + (d1 - d0) * (xmax - x0) / (x1 - x0)
	;
	;or:
	;  y:=y1 + (y1 - y0) * (xmax - x1) / (x1 - x0)
	;  x:=xmax
	;  d:=d0 + (d1 - d0) * (xmax - x0) / (x1 - x0)
	;
	push	eax		;EAX = X1
	push	ebx		;EBX = Y1
	push	edx
	if poly_type ge 2
	  push	edi			;EDI = D1
	endif
	if poly_type ge 40
	  push	esi
	endif
	;
	if direction eq 1
	 sub	eax,ds:[Clip_Old_X]	;EAX = x1 - x0
	 sub	ebx,ds:[Clip_Old_Y]	;EBX = y1 - y0
	 xchg	ebx,eax
	 mov	edx,xmax
	 sub	edx,ds:[Clip_Old_X]	;EDX = xmax - x0
	 imul	edx
	 idiv	ebx
	 add	eax,ds:[Clip_Old_Y]	;EAX = Clipped Y
	else
	 mov	d ds:[CC1-4],ebx	;Save y1
	 mov	edx,xmax
	 sub	edx,eax			;EDX = xmax - x1
	 sub	eax,ds:[Clip_Old_X]	;EAX = x1 - x0
	 sub	ebx,ds:[Clip_Old_Y]	;EBX = y1 - y0
	 xchg	ebx,eax
	 imul	edx
	 idiv	ebx
	 add	eax,12345678h		;EAX = Clipped Y
    CC1:
	endif
	;
	cmp	eax,DISPLAY_HEIGHT	;Is clipped point in window ?
	if (poly_type lt 40)
	 jae	short NOUT
	else
	 jae	NOUT
	endif
	;
	if (poly_type ge 2) and (poly_type lt 20)
	 push	eax
	 sub	edi,ds:[Clip_Old_Data]	;EDI = d1 - d0
	 mov	eax,xmax
	 sub	eax,ds:[Clip_Old_X]	;EAX = xmax - x0
	 imul	edi
	 idiv	ebx                     ;EBX = x1 - x0
	 add	eax,ds:[Clip_Old_Data]	;EAX = Clipped D
	 mov	edi,eax
	 pop	eax
	endif
	if (poly_type ge 20)
	 push	eax
	 sub	edi,ds:[Clip_Old_Data]	;EDI = d1 - d0
	 mov	eax,xmax
	 sub	eax,ds:[Clip_Old_X]	;EAX = xmax - x0
	 imul	di
	 idiv	bx                      ;EBX = x1 - x0
	 mov	di,ax

	 rol	edi,16
	 mov	eax,xmax
	 sub	eax,ds:[Clip_Old_X]	;EAX = xmax - x0
	 imul	di
	 idiv	bx                     	;EBX = x1 - x0
	 mov	di,ax
	 rol	edi,16
	 add	edi,ds:[Clip_Old_Data]	;EDI = Clipped D
	 if (poly_type lt 40)
	  pop	eax
	 endif
	endif
	if (poly_type ge 40)
	 sub	esi,ds:[Clip_Old_Data2]	;EDI = d1 - d0
	 mov	eax,xmax
	 sub	eax,ds:[Clip_Old_X]	;EAX = xmax - x0
	 imul	esi
	 idiv	ebx
	 add	eax,ds:[Clip_Old_Data2]	;EAX = Clipped D
	 mov	esi,eax
	 pop	eax
	endif
	;
	mov	ebx,eax			;EBX = CLipped Y
	mov	eax,xmax      		;EAX = Clipped X
	OUT_VERTEX poly_type		;Put out new vertex
NOUT:   if poly_type ge 40
	  pop	esi
	endif
	if poly_type ge 2
	  pop	edi
	endif
	pop	edx
	pop	ebx
	pop	eax
ENDM
;
CLIP_POLY MACRO poly_type
	LOCAL L1,CC2,CC1,OUT,NOUT
	;
	;First lets get all 2D coordinates
	;
	add	esi,20			;Jump over header minus one vertex
	mov	edi,ds:[esi+4]		;EDI : Get first vertex-ptr
	mov	dword ptr ds:[CC2-4],esi
	lea	esi,[4*ecx]		;ESI is new counter of edges

	;
	;
	; Get special-data needed for clipping
	; Input:
	;	EBP	- passed value from MACRO-caller
	;      ES:EDI	- First vertex ptr
	; Output:
	;	DS:[Clip_Old_Data]
	; May get destroyed:
	;	EAX,EBX,ECX,EDX,EBP
	;
	if (poly_type eq TEXTURE_POLY) or (poly_type eq TEXTURE_GOURAUD_POLY) or (poly_type eq TEXTURE_PHONG_POLY)
	  sub	ebp,4			;Adjust address of special data
	  mov	dword ptr ds:[CC1-4],ebp
	  mov  	eax,ds:[esi+ebp]		;Save first special entry
	  mov	ds:[Clip_Old_Data],eax
	endif
	;
	if (poly_type eq GOURAUD_POLY)
	  mov 	dword ptr ds:[CC1-4],ebp	;Save colour (already shifted)
	  mov	ebx,ds:[edi+N21]		;Get Normal_X
	  mov   eax,ds:[edi+N22]			;Get Normal_Y
	  imul	ebx,d ds:[Current_Light.E1]
	  imul	d ds:[Current_Light.E2]
	  add	ebx,eax

	  mov   eax,ds:[edi+N23]
	  imul	d ds:[Current_Light.E3]
	  add	ebx,eax
	  add	ebx,ebp				;Add colour
	  mov	ds:[Clip_Old_Data],ebx
	endif
	;
	if (poly_type eq FAST_PHONG_POLY)
	  mov	ebx,ds:[edi+N21]		;Get Normal_X
	  mov   eax,ds:[edi+N22]		;Get Normal_Y
	  imul	ebx,d ds:[Current_Light.E1]
	  imul	d ds:[Current_Light.E2]
	  add	ebx,eax

	  mov   eax,ds:[edi+N23]
	  imul	d ds:[Current_Light.E3]
	  lea	ebx,[ebx+eax+1 shl (2*GVE_MATH_SHIFT)]
	  sar	ebx,5
	  mov	ds:[Clip_Old_Data],ebx
	endif
	;
	if (poly_type eq CHROME_GOURAUD_POLY) or (poly_type eq TEXTURE_GOURAUD_POLY) \
	   or (poly_type eq TEXTURE_PHONG_POLY) or (poly_type eq CHROME_PHONG_POLY)
	  mov	ebx,ds:[edi+N21]		;Get Normal_X
	  mov   eax,ds:[edi+N22]		;Get Normal_Y
	  imul	ebx,d ds:[Current_Light.E1]
	  imul	eax,d ds:[Current_Light.E2]
	  add	ebx,eax
	  mov   eax,ds:[edi+N23]
	  imul	eax,d ds:[Current_Light.E3]
	  lea	ebx,[ebx+eax+1 shl (2*GVE_MATH_SHIFT)]
	  if (poly_type eq TEXTURE_PHONG_POLY) or (poly_type eq CHROME_PHONG_POLY)
	    sar	ebx,5
	  endif
	  mov	ds:[Clip_Old_Data2],ebx
	endif
	;
	if (poly_type eq CHROME_POLY) or (poly_type eq CHROME_GOURAUD_POLY) or (poly_type eq CHROME_PHONG_POLY)
	  mov	edx,ds:[edi+N22]		;Get Normal_Y
	  mov	eax,ds:[edi+N21]		;Get Normal_X
	  add	edx,1 shl GVE_MATH_SHIFT
	  add	eax,1 shl GVE_MATH_SHIFT
	  shl	edx,32-GVE_MATH_SHIFT-5		;Texture u  (4 bit FP)
	  shl	eax,12-GVE_MATH_SHIFT-1		;Texture v  (4 bit FP)
	  shld	eax,edx,16			;EAX = texture-address
	  mov	ds:[Clip_Old_Data1],eax
	endif

	;
	;
	;Setup line-table things
	;
	xor	ebp,ebp				;EBP = ptr to poly-edge table
	mov	ds:[Line_table_Start],DISPLAY_Height
	mov	ds:[Line_Table_End],ebp


	;Get first point and set bytes in EDX
	mov	eax,ds:[edi+PX]			;
	mov	ebx,ds:[edi+PY]			;Get projected X,Y
	SET_CLIP_BITS
	mov	ds:[Clip_Bits],edx		;And save them here !
	mov	ds:[Clip_Old_X],eax
	mov	ds:[Clip_Old_Y],ebx

	;
	;Now the main-clip loop starts here
	;
L1:     if (poly_type ge 40)
	 push	esi				;Save edge-counter
	endif
	mov	edi,ds:[esi+12345678h]		;Get vector-ptr
CC2:	mov	eax,ds:[edi+PX]			;EAX= projected X
	mov	ebx,ds:[edi+PY]			;EBX= projected Y

	;
	;
	; Now get special data. The special data is calculated in one of the
	; if-clauses.
	; Input:
	;	ES:EDI 	- ptr to vertex
	;	ES:ESI	- Vector ptr
	; Output:
	;	EDI 	- special data
	;	(ESI 	- second special data)
	; May get destroyed:
	;	ECX,EDX,(ESI)
	;
	if (poly_type eq TEXTURE_POLY)
	  mov	edi,ds:[esi+12345678h]		;EDI= special data...
CC1:	endif
	;
	if (poly_type eq GOURAUD_POLY)
	  mov	ecx,ds:[edi+N21]		;Get Normal_X
	  mov   edx,ds:[edi+N22]		;Get Normal_Y
	  imul	ecx,d ds:[Current_Light.E1]
	  imul	edx,d ds:[Current_Light.E2]
	  add	ecx,edx

	  mov   edx,ds:[edi+N23]
	  imul	edx,d ds:[Current_Light.E3]
	  add	ecx,edx

	  lea	edi,[ecx+12345678h]
CC1:	endif
	;
	if (poly_type eq FAST_PHONG_POLY)
	  mov	ecx,ds:[edi+N21]		;Get Normal_X
	  mov   edx,ds:[edi+N22]		;Get Normal_Y
	  imul	ecx,d ds:[Current_Light.E1]
	  imul	edx,d ds:[Current_Light.E2]
	  add	ecx,edx

	  mov   edx,ds:[edi+N23]
	  imul	edx,d ds:[Current_Light.E3]
	  lea	edi,[ecx+edx+1 shl (2* GVE_MATH_SHIFT)]
	  sar	edi,5
	endif
	;
	if (poly_type eq CHROME_GOURAUD_POLY) or (poly_type eq TEXTURE_GOURAUD_POLY) \
	   or (poly_type eq CHROME_PHONG_POLY) or (poly_type eq TEXTURE_PHONG_POLY)
	  mov	ecx,ds:[edi+N21]		;Get Normal_X
	  mov   edx,ds:[edi+N22]		;Get Normal_Y
	  imul	ecx,d ds:[Current_Light.E1]
	  imul	edx,d ds:[Current_Light.E2]
	  add	ecx,edx

	  mov   edx,ds:[edi+N23]
	  imul	edx,d ds:[Current_Light.E3]
	  if (poly_type eq TEXTURE_GOURAUD_POLY) or (poly_type eq TEXTURE_PHONG_POLY)
	    mov	edi,ds:[esi+12345678h]		;EDI=texture coordinates
CC1:	  endif
	  lea	esi,[ecx+edx+1 shl (2* GVE_MATH_SHIFT)]
	  if (poly_type eq TEXTURE_PHONG_POLY) or (poly_type eq CHROME_PHONG_POLY)
	    sar	esi,5
	  endif
	endif
	;
	if (poly_type eq CHROME_POLY) or (poly_type eq CHROME_GOURAUD_POLY) or (poly_type eq CHROME_PHONG_POLY)
	  mov	edx,ds:[edi+N22]		;Get Normal_Y
	  mov	edi,ds:[edi+N21]		;Get Normal_X
	  add	edx,1 shl GVE_MATH_SHIFT
	  add	edi,1 shl GVE_MATH_SHIFT
	  shl	edx,32-GVE_MATH_SHIFT-5		;Texture u  (4 bit FP)
	  shl	edi,12-GVE_MATH_SHIFT-1		;Texture v  (4 bit FP)
	  shld	edi,edx,16			;EDI = texture-address
	endif


	;
	;
	; Now the main clipping routine starts here.
	;
	SET_CLIP_BITS			;EDX= clip bytes
	push	eax			;Save X
	push	ebx			;Save Y
	if poly_type ge 2
	 push	edi			;Save special data
	endif
	if poly_type ge 40
	 push 	esi
	endif
	mov	ecx,ds:[Clip_Bits]	;Get old clip-bits
	test	edx,ecx
	jnz	NOut			;Nothing to do !
	cmp	edx,ecx			;Are they the same ???
	je	Out			;JE ==> EDX=ECX=0 No clipping needed !

	;
	;Ok, now we have to do some clipping:
	;Note that here only the old point will be clipped !
		cmp	cx,1		;Was old point below ?
		jb	@@Old_LR	;JB: Check for other cases
		ja	@@COU    	;JA: Clip upper part

		CLIP_VLINE 	(DISPLAY_HEIGHT-1),poly_type,0
		jmp	@@Old_LR
	@@COU:	CLIP_VLINE 	0,poly_type,0


	@@Old_LR:
		bswap	ecx
		cmp	cx,1		;Was old point right ?
		jb	@@New		;JB: Check for other cases
		ja	@@COL		;JA: Clip left part

		CLIP_HLINE 	(DISPLAY_WIDTH-1),poly_type,0
		jmp	@@New
	@@COL:	CLIP_HLINE	0,poly_type,0


	@@New:  test	edx,edx		;EDX=zero ???
		jz	Out		;JZ: Put vertex out !
		cmp	dx,1h		;Is new point below ?
		jb	@@new_LR	;JB: Check for other cases
		ja	@@CNU    	;JA: Clip upper part

		CLIP_VLINE 	(DISPLAY_HEIGHT-1),poly_type,1
		jmp	@@New_LR
	@@CNU:	CLIP_VLINE 	0,poly_type,1


	@@New_LR:
		bswap	edx		;Set DX=Highword of EDX
		cmp	dx,1		;Is new point right ?
		bswap	edx
		jb	NOut		;JB: Check for other cases
		ja	@@CNL		;JA: Clip left part

		CLIP_HLINE 	(DISPLAY_WIDTH-1),poly_type,1
		jmp	NOut
	@@CNL:	CLIP_HLINE	0,poly_type,1
		jmp	NOut


Out:	OUT_VERTEX poly_type

	;
	;This is the end of the outer clipping-loop
NOut:	mov	ds:[Clip_Bits],edx	;Save clipped points here
	if poly_type ge 40
	 pop 	ds:[Clip_Old_Data2]
	endif
	if poly_type ge 2
	 pop	ds:[Clip_Old_Data1]
	endif
	pop	ds:[Clip_Old_Y]
	pop	ds:[Clip_Old_X]
	if (poly_type ge 40)
	 pop	esi			;Restore edge-counter
	endif
	sub	esi,4
	jnz	L1

	;
	;
	; End of clipping loop. Now we check if there were any points and
	; we copy the last point to the first one
	;
	test	ebp,ebp			;EBP=0  =>  Nothing to do
	jz	@@Exit

	;Make last_point=first point
	mov	eax,ds:[Poly_Edges+ebp]
	mov	ebx,ds:[Poly_Edges+ebp+4]
	mov	ds:[Poly_Edges],eax
	mov	ds:[Poly_Edges+4],ebx
	if poly_type ge 2
	  mov	eax,ds:[Poly_Edges+ebp+8]
	  mov	ds:[Poly_Edges+8],eax
	endif
	if poly_type ge 40
	  mov	eax,ds:[Poly_Edges+ebp+12]
	  mov	ds:[Poly_Edges+12],eax
	endif

ENDM



;
;
; This macro scan-converts the edges of a simple poly. The results will be
; saved in the Line_Table
;
; Input:
;   ES:ESI - Ptr to object-header
;   ECX    - Number of vertices...
; Ouput:
;   Line_Start_Table
;   Line_End_Table
;   Line_Table
; Destroys:
;   EAX,EBX,ECX,EDX
;   ESI
;   EDI
;
;
CONVERT_SIMPLE_POLY MACRO
	LOCAL L1,L2,L3,J1,J2,J3,NEXT
	CLIP_POLY SIMPLE_POLY

	;
	;Now lets set the linestarts to zero
	;
	mov	eax,7fffffffh
	xor	ebx,ebx
	mov	edx,ds:[Line_Table_End]		;EDX=counter
	mov	edi,ds:[Line_Table_Start]
	sub	edx,edi
	jz	@@Exit
	shl	edx,4				;*16 bytes / entry
	shl	edi,4				;*16 bytes / entry
L1:	mov	ds:[edx+edi+Line_Table],eax	;Set start to high value
	mov	ds:[edx+edi+Line_Table+8],ebx	;Set end to zero
	sub	edx,16
	jnz	short L1

	;
	;Now lets setup the line-table...
	;
L2:   	mov	ebx,ds:[Poly_Edges+ebp-16]	;EBX=X1
	mov	edi,ds:[Poly_Edges+ebp-12]	;EDI=Y1
	mov	eax,ds:[Poly_Edges+ebp]		;EAX=X0
	mov	esi,ds:[Poly_Edges+ebp+4]     	;ESI=Y0

	cmp	edi,esi				;Is Y2>Y1 ?
	jg	short J1
	je	short NEXT
		xchg	eax,ebx			;Swap end points....
		xchg	edi,esi
J1:	sub	edi,esi			;EDI=Y1-Y0

	sub 	eax,ebx			;EAX=X0-X1
	shl	eax,16             	;Fudge it for extra precision
	shl	ebx,16

	cdq
	idiv	edi			;EAX contains X-Increment

	;
	;This is the inner line-loop
	;
	shl	edi,4
	shl	esi,4
L3:     cmp	ds:[Line_Table+edi+esi],ebx
	jb	short J2
		mov	ds:[Line_Table+edi+esi],ebx
J2:	cmp	ds:[Line_Table+edi+esi+8],ebx
	ja	short J3
		mov	ds:[Line_Table+edi+esi+8],ebx
J3:	add	ebx,eax
	sub	edi,16
	jns	short L3

NEXT:	sub	ebp,16
	jnz	L2
	ENDM



;
;
; This macro scan-converts the edges of a complex poly. The results will be
; saved in the Line_Table
;
;
; CONVERT_DATA_POLY / CONVERT_TEXTURE_POLY:
; Input:
;   ES:ESI - Ptr to object-header
;   ES:EAX - Start of special data (consitsing out of dwords...)
;   ECX    - Number of vertices...
; Ouput:
;   Line_Start_Table
;   Line_End_Table
;   Line_Table
; Destroys:
;   EAX,EBX,ECX,EDX
;   ESI
;   EDI
;   EBP
;
;
CONVERT_DATA_POLY MACRO poly_type
	LOCAL L1,L2,L3,J1,J2,J3,J4,C1,C2,C3,NEXT
	CLIP_POLY poly_type

	;
	;Now lets set the linestarts to zero
	;
	mov	eax,7fffffffh
	xor	ebx,ebx
	mov	edx,ds:[Line_Table_End]		;EDX=counter
	mov	edi,ds:[Line_Table_Start]
	sub	edx,edi
	jz	@@Exit

	shl	edx,4
	shl	edi,4				;*16 bytes /entry
L1:	mov	ds:[edx+edi+Line_Table],eax	;Set start to high value
	mov	ds:[edx+edi+Line_Table+8],ebx	;Set end to zero
	sub	edx,16
	jnz	short L1


	;
	;Now lets setup the line-table...
	;
L2:     mov	edi,ds:[Poly_Edges+ebp+4]		;EDI=Y1
	mov	esi,ds:[Poly_Edges+ebp-12]	     	;ESI=Y0

	cmp	edi,esi					;Is Y2>Y1 ?
	jl	short J1
	je	NEXT
		sub	edi,esi
		mov	ebx,ds:[Poly_Edges+ebp]		;EBX=X1
		mov	eax,ds:[Poly_Edges+ebp-16]	;EAX=X0
		sub 	eax,ebx				;EAX=X0-X1
		shl	eax,16                 		;Fudge it for extra precision
		shl	ebx,16
		cdq
		idiv	edi				;EAX contains X-Increment
		mov	d ds:[C1-4],eax

		mov	ecx,ds:[Poly_Edges+ebp+8]	;ECX=D1
		mov	eax,ds:[Poly_Edges+ebp-8]	;EAX=D0
		jmp	short J2

	J1:     xchg	edi,esi
		sub	edi,esi
		mov	ebx,ds:[Poly_Edges+ebp-16]	;EBX=X0
		mov	eax,ds:[Poly_Edges+ebp]		;EAX=X1
		sub 	eax,ebx				;EAX=X1-X0
		shl	eax,16                 		;Fudge it for extra precision
		shl	ebx,16
		cdq
		idiv	edi				;EAX contains X-Increment
		mov	d ds:[C1-4],eax

		mov	ecx,ds:[Poly_Edges+ebp-8]	;ECX=D0
		mov	eax,ds:[Poly_Edges+ebp+8]	;EAX=D1
J2:     if	(poly_type eq GOURAUD_POLY) or \
		(poly_type eq SPECIAL_POLY) or \
		(poly_type eq FAST_PHONG_POLY)
	  sub	eax,ecx			;EAX=D0-D1
	  cdq
	  idiv	edi
	  mov	d ds:[C2-4],eax
	endif

	;
	;This is the inner line-loop
	;
	shl	edi,4				;16 bytes / entry
	shl	esi,4
L3:	cmp	ds:[Line_Table+edi+esi],ebx
	jb	short J3
		mov	ds:[Line_Table+edi+esi],ebx
		mov	ds:[Line_Table+edi+esi+4],ecx
		if poly_type ge 20
		  mov	ds:[Line_Table+edi+esi+8],edx
		endif
J3:	cmp	ds:[Line_Table+edi+esi+8],ebx
	ja	short J4
		mov	ds:[Line_Table+edi+esi+8],ebx
		mov	ds:[Line_Table+edi+esi+8+4],ecx
		if poly_type ge 20
		  mov	ds:[Line_Table+edi+esi+8+8],edx
		endif
J4:	add	ebx,12345678h
C1:   	add	ecx,12345678h
C2:   	if poly_type ge 20
	  add	edx,12345678h
C3:	endif
	sub	edi,16
	jns	short L3

NEXT:	sub	ebp,16
	jnz	L2
	ENDM
;
CONVERT_TEXTURE_POLY MACRO poly_type
	LOCAL L1,L2,L3,J1,J2,J3,J4,C1,C2,C3,C4,NEXT
	CLIP_POLY poly_type

	;
	;Now lets set the linestarts to zero
	;
	mov	eax,7fffffffh
	xor	ebx,ebx
	mov	edx,ds:[Line_Table_End]		;EDX=counter
	mov	edi,ds:[Line_Table_Start]
	sub	edx,edi
	jz	@@Exit

	shl	edx,5
	shl	edi,5				;*32 bytes /entry
L1:	mov	ds:[edx+edi+Line_Table],eax	;Set start to high value
	mov	ds:[edx+edi+Line_Table+16],ebx	;Set end to zero
	sub	edx,32
	jnz	short L1


	;
	;Now lets setup the line-table...
	;
L2:     mov	edi,ds:[Poly_Edges+ebp+4]		;EDI=Y1
	mov	esi,ds:[Poly_Edges+ebp-12]	     	;ESI=Y0

	cmp	edi,esi					;Is Y2>Y1 ?
	if (poly_type lt 40)
	 jl	short J1
	 je	NEXT
	else
	 jl	J1
	 je	NEXT
	endif
		sub	edi,esi
		mov	ebx,ds:[Poly_Edges+ebp]		;EBX=X1
		mov	eax,ds:[Poly_Edges+ebp-16]	;EAX=X0
		sub 	eax,ebx				;EAX=X0-X1
		shl	eax,16                 		;Fudge it for extra precision
		shl	ebx,16
		cdq
		idiv	edi				;EAX contains X-Increment
		mov	d ds:[C1-4],eax

		movsx	eax,w ds:[Poly_Edges+ebp-8]	;Texture u
		movsx	ecx,w ds:[Poly_Edges+ebp+8]
		shl	eax,12
		shl	ecx,12
		sub	eax,ecx
		cdq
		idiv	edi
		mov	d ds:[C2-4],eax

		mov	ax,w ds:[Poly_Edges+ebp-6]	;Texture v
		sub	ax,w ds:[Poly_Edges+ebp+10]
		movsx	eax,ax
		shl	eax,12
		cdq
		idiv	edi
		mov	d ds:[C3-4],eax

		if (poly_type ge 40)
		 mov	eax,ds:[Poly_Edges+ebp-4]	;Gouraud value
		 sub	eax,ds:[Poly_Edges+ebp+12]
		 cdq
		 idiv	edi
		 mov	d ds:[C4-4],eax
		 mov	eax,ds:[Poly_Edges+ebp+12]
		endif

		movsx	edx,w ds:[Poly_Edges+ebp+10]
		shl	edx,12
		if (poly_type lt 40)
		 jmp	short J2
		else
		 jmp	J2
		endif

	J1:     xchg	edi,esi
		sub	edi,esi
		mov	ebx,ds:[Poly_Edges+ebp-16]	;EBX=X0
		mov	eax,ds:[Poly_Edges+ebp]		;EAX=X1
		sub 	eax,ebx				;EAX=X1-X0
		shl	eax,16                 		;Fudge it for extra precision
		shl	ebx,16
		cdq
		idiv	edi				;EAX contains X-Increment
		mov	d ds:[C1-4],eax

		movsx	eax,w ds:[Poly_Edges+ebp+8]	;Texture u
		movsx	ecx,w ds:[Poly_Edges+ebp-8]
		shl	eax,12
		shl	ecx,12
		sub	eax,ecx
		cdq
		idiv	edi
		mov	d ds:[C2-4],eax

		mov	ax,w ds:[Poly_Edges+ebp+10]	;Texture v
		sub	ax,w ds:[Poly_Edges+ebp-6]
		movsx	eax,ax
		shl	eax,12
		cdq
		idiv	edi
		mov	d ds:[C3-4],eax

		if (poly_type ge 40)
		 mov	eax,ds:[Poly_Edges+ebp+12]	;Gouraud value
		 sub	eax,ds:[Poly_Edges+ebp-4]
		 cdq
		 idiv	edi
		 mov	d ds:[C4-4],eax
		 mov	eax,ds:[Poly_Edges+ebp-4]
		endif

		movsx	edx,w ds:[Poly_Edges+ebp-6]
		shl	edx,12


J2:     ;
	;This is the inner line-loop
	;
	shl	edi,5
	shl	esi,5
L3:	cmp	ds:[Line_Table+edi+esi],ebx
	jb	short J3
		mov	ds:[Line_Table+edi+esi],ebx
		mov	ds:[Line_Table+edi+esi+4],ecx
		mov	ds:[Line_Table+edi+esi+8],edx
		if (poly_type ge 40)
		  mov	ds:[Line_Table+edi+esi+12],eax
		endif
J3:	cmp	ds:[Line_Table+edi+esi+16],ebx
	ja	short J4
		mov	ds:[Line_Table+edi+esi+16],ebx
		mov	ds:[Line_Table+edi+esi+16+4],ecx
		mov	ds:[Line_Table+edi+esi+16+8],edx
		if (poly_type ge 40)
		  mov	ds:[Line_Table+edi+esi+16+12],eax
		endif
J4:	add	ebx,12345678h
C1:   	add	ecx,12345678h
C2:   	add	edx,12345678h
C3:     if (poly_type ge 40)
	 add	eax,12345678h
C4:	endif
	sub	edi,32
	jns	short L3

NEXT:	sub	ebp,16
	jnz	L2
	ENDM


;
;   GOMEZ VECTOR ENGINE DRAWING FUNCTIONS
;
;
;
; These are the lowest-end drawing functions for the various objects.
; Like in the CDMI, I use a quick and nice table for indexing all functions
;
; O.k. Here are some things you must keep in mind when coding new methods:
; 1.) ES is set to linear address space
;     DS is set to data segment
; 2.) ES:ESI points to the primitive header
; 3.) ES:EDI points to upper left corner of the frame buffer
; 4.) ES:EBP points to the current entry in the order table
;     (But I think you won't need that one...)
; 5.) The following registers MUST be saved: ES, DS, EDI and EBP
;
GVE_Method_Table LABEL DWORD
	dd Draw_Nothing			;0
	dd Draw_Wire_Poly               ;4
	dd Draw_Filled_Poly             ;8
	dd Draw_Lambert_Poly            ;12
	dd Draw_Gouraud_Poly            ;16
	dd Draw_Phong_Poly              ;20
	dd Draw_Glass_Poly              ;24
	dd Draw_Lambert_Glass_Poly      ;28
	dd Draw_Gouraud_Glass_Poly      ;32
	dd Draw_Phong_Glass_Poly        ;36
	dd Draw_Fast_Texture            ;40
	dd Draw_Lambert_Texture         ;44
	dd Draw_Gouraud_Texture         ;48
	dd Draw_Phong_Texture           ;52
	dd Draw_Slow_Texture            ;56
	dd Draw_Chrome_Poly             ;60
	dd Draw_Lambert_Chrome_Poly     ;64
	dd Draw_Gouraud_Chrome_Poly     ;68
	dd Draw_Phong_Chrome_Poly       ;72
	dd Draw_Fast_Phong_Poly         ;76
	dd Draw_Glass_Texture           ;80
	dd Draw_Glass_Chrome_Poly       ;84
	dd Draw_Nothing                 ;88	Bumps come here
	dd Draw_Nothing                 ;92
	dd Draw_Nothing                 ;96
	dd Draw_Nothing                 ;100
	dd Draw_Nothing                 ;104
	dd Draw_Soft_Wire_Poly          ;108
	dd Draw_Glass_Wire_Poly         ;112
	dd Draw_Nothing                 ;116
	dd Draw_Nothing                 ;120
	dd Draw_Nothing                 ;124
	dd Draw_Vertex                  ;128
	dd 64-(VOBJ_MAX_METHODS/4) dup (Draw_Nothing)

;
Draw_Nothing PROC NEAR
	retn
Draw_Nothing ENDP
;
Draw_Wire_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	mov	al,byte ptr ds:[esi+4]	;Get colour
	mov	b ds:[@@C1-1],al	;Save colour
	CLIP_POLY SIMPLE_POLY

	;
	;Now lets darw all lines...
@@L1:	mov     ebx,4340h         		;Code for INC EBX / INC EAX

	mov	eax,ds:[Poly_Edges+ebp]		;EAX = X1
	mov	ecx,ds:[Poly_Edges+ebp-16]	;ECX = X2
	sub     ecx,eax            		;DeltaX=X2-X1 bilden
	jge     short @@J1        		;Is X2>X1?
		mov     bl,48h           	;No, code for DEC EAX
		neg     ecx               	; and invert DELTAX
@@J1:  	mov     edx,ds:[Poly_Edges+ebp-12]    	;EDX = Y2
	sub     edx,ds:[Poly_Edges+ebp+4]	;DeltaY=Y2-Y1
	jge     short @@J2        		;Y2 > Y1 ?
		mov     bh,4bh           	;No, code for DEC EBX
		neg     edx               	; and invert DELTAY
@@J2:  	mov     word ptr ds:[@@C3],bx      	;Save code
	cmp     ecx,edx            		;DeltaX > DeltaY ?
	jge     short @@J3
		  mov     bl,90h           	;NOP
		  xchg    ecx,edx            	;Swap DeltaX and DeltaY
		  jmp     short @@J4
@@J3:  	mov     bh,90h

@@J4:	mov     word ptr ds:[@@C2],bx
	shl     edx,1             		;Calc IncB
	mov	d ds:[@@C4-4],edx              	;and save it in code !
	sub     edx,ecx            		;DAB bestimmen
	sub     edx,ecx
	mov	d ds:[@@C6-4],edx		;  and save it in code !
	add	edx,ecx				;EDX = dab
	mov	ebx,ds:[Poly_Edges+ebp+4]       ;EBX = Y1
	mov	eax,ds:[Poly_Edges+ebp]		;EAX = X1
@@L2:   mov	edi,ebx
	imul	edi,DISPLAY_Width
	add	edi,ds:[GVE_Frame_Buffer]
	mov	byte ptr ds:[edi+eax],12h      	;Set pixel !
@@C1:   cmp     edx,0             		;DAB>0?
	jge     short @@C3        		;ja, verzweige
	@@C2:  	inc     eax            		;hier wird der
		inc     ebx            		;Code modifiziert
		add     edx,12345678h  		;DAB+=IncB
	@@C4:	dec	ecx
		jg 	short @@L2
		jmp     short @@Next    	;und weiter
	@@C3:   inc     eax               	;hier wird der
		inc     ebx		   	;Code modifiziert
		add     edx,12345678h      	;DAB+=IncA
	@@C6:	dec	ecx
		jg 	short @@L2

@@Next:	sub	ebp,16
	jnz	@@L1

@@Exit: mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Wire_Poly ENDP
;
Draw_Soft_Wire_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	mov	al,byte ptr ds:[esi+4]	;Get colour
	or	al,1
	shl	al,4
	mov	ah,al
	add	al,16
	mov	d ds:[@@C1-4],eax	;Save colour
	CLIP_POLY SIMPLE_POLY

	;
	;Now lets darw all lines...
@@L1:	mov     ebx,4340h         		;Code for INC EBX / INC EAX

	mov	eax,ds:[Poly_Edges+ebp]		;EAX = X1
	mov	ecx,ds:[Poly_Edges+ebp-16]	;ECX = X2
	sub     ecx,eax            		;DeltaX=X2-X1 bilden
	jge     short @@J1        		;Is X2>X1?
		mov     bl,48h           	;No, code for DEC EAX
		neg     ecx               	; and invert DELTAX
@@J1:  	mov     esi,ds:[Poly_Edges+ebp-12]    	;ESI = Y2
	sub     esi,ds:[Poly_Edges+ebp+4]	;DeltaY=Y2-Y1
	jge     short @@J2        		;Y2 > Y1 ?
		mov     bh,4bh           	;No, code for DEC EBX
		neg     esi               	; and invert DELTAY
@@J2:  	mov     word ptr ds:[@@C3],bx      	;Save code
	cmp     ecx,esi            		;DeltaX > DeltaY ?
	jge     short @@J3
		  mov     bl,90h           	;NOP
		  xchg    ecx,esi            	;Swap DeltaX and DeltaY
		  jmp     short @@J4
@@J3:  	mov     bh,90h

@@J4:	mov     word ptr ds:[@@C2],bx
	inc	ecx
	mov	ds:[DeltaX],ecx
	dec	ecx
	shl     esi,1             		;Calc IncB
	mov	d ds:[@@C4-4],esi              	;and save it in code !
	sub     esi,ecx            		;DAB bestimmen
	sub     esi,ecx
	mov	d ds:[@@C6-4],esi		;  and save it in code !
	add	esi,ecx				;ESI = dab
	mov	ebx,ds:[Poly_Edges+ebp+4]       ;EBX = Y1
	mov	eax,ds:[Poly_Edges+ebp]		;EAX = X1
@@L2:   push	eax
	mov	eax,esi
	shl	eax,4
	cdq
	idiv	ds:[DeltaX]
	mov	edx,12345678h
@@C1:	add	dl,al
	sub	dh,al
	mov	eax,ebx
	fastimul edi,eax,DISPLAY_Width
	add	edi,ds:[GVE_Frame_Buffer]
	pop	eax
	mov	byte ptr ds:[edi+eax],dh       	;Set pixel !
	mov	byte ptr ds:[edi+eax+DISPLAY_Width],dl
	test    esi,esi           		;DAB>0?
	jge     short @@C3        		;ja, verzweige
	@@C2:  	inc     eax            		;hier wird der
		inc     ebx            		;Code modifiziert
		add     esi,12345678h  		;DAB+=IncB
	@@C4:	dec	ecx
		jg 	short @@L2
		jmp     short @@Next    	;und weiter
	@@C3:   inc     eax               	;hier wird der
		inc     ebx		   	;Code modifiziert
		add     esi,12345678h      	;DAB+=IncA
	@@C6:	dec	ecx
		jg 	short @@L2

@@Next:	sub	ebp,16
	jnz	@@L1

@@Exit: mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Soft_Wire_Poly ENDP
;
Draw_Glass_Wire_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,byte ptr ds:[esi+4]	;Get colour
	shl	eax,8
	add	eax,ds:[GVE_Glass_LUT]
	mov	d ds:[@@C1-4],eax	;save it there
	CLIP_POLY SIMPLE_POLY

	;
	;Now lets darw all lines...
@@L1:	mov     ebx,4340h         		;Code for INC EBX / INC EAX

	mov	eax,ds:[Poly_Edges+ebp]		;EAX = X1
	mov	ecx,ds:[Poly_Edges+ebp-16]	;ECX = X2
	sub     ecx,eax            		;DeltaX=X2-X1 bilden
	jge     short @@J1        		;Is X2>X1?
		mov     bl,48h           	;No, code for DEC EAX
		neg     ecx               	; and invert DELTAX
@@J1:  	mov     esi,ds:[Poly_Edges+ebp-12]    	;ESI = Y2
	sub     esi,ds:[Poly_Edges+ebp+4]	;DeltaY=Y2-Y1
	jge     short @@J2        		;Y2 > Y1 ?
		mov     bh,4bh           	;No, code for DEC EBX
		neg     esi               	; and invert DELTAY
@@J2:  	mov     word ptr ds:[@@C3],bx      	;Save code
	cmp     ecx,esi            		;DeltaX > DeltaY ?
	jge     short @@J3
		  mov     bl,90h           	;NOP
		  xchg    ecx,esi            	;Swap DeltaX and DeltaY
		  jmp     short @@J4
@@J3:  	mov     bh,90h

@@J4:	mov     word ptr ds:[@@C2],bx
	inc	ecx
	mov	ds:[DeltaX],ecx
	dec	ecx
	shl     esi,1             		;Calc IncB
	mov	d ds:[@@C4-4],esi              	;and save it in code !
	sub     esi,ecx            		;DAB bestimmen
	sub     esi,ecx
	mov	d ds:[@@C6-4],esi		;  and save it in code !
	add	esi,ecx				;ESI = dab
	mov	ebx,ds:[Poly_Edges+ebp+4]       ;EBX = Y1
	mov	eax,ds:[Poly_Edges+ebp]		;EAX = X1
	xor	edx,edx
@@L2:	mov	edi,ebx
	imul 	edi,DISPLAY_Width
	add	edi,ds:[GVE_Frame_Buffer]
	mov	dl,ds:[edi+eax]			;Get old colour
	mov	dl,ds:[edx+12345678h]		;Mix via LUT
@@C1:	mov	byte ptr ds:[edi+eax],dl       	;Set pixel !
	test    esi,esi           		;DAB>0?
	jge     short @@C3        		;ja, verzweige
	@@C2:  	inc     eax            		;hier wird der
		inc     ebx            		;Code modifiziert
		add     esi,12345678h  		;DAB+=IncB
	@@C4:	dec	ecx
		jg 	short @@L2
		jmp     short @@Next    	;und weiter
	@@C3:   inc     eax               	;hier wird der
		inc     ebx		   	;Code modifiziert
		add     esi,12345678h      	;DAB+=IncA
	@@C6:	dec	ecx
		jg 	short @@L2

@@Next:	sub	ebp,16
	jnz	@@L1

@@Exit: mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Glass_Wire_Poly ENDP
;
;
;
; Now comes a class of filled polygons like constant shading, lambert
; shading, gouraud shading etc...
;
Draw_Filled_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	mov	al,ds:[esi+4]		;Get colour
	mov	ah,al
;       shld	eax,eax,16		;Get colour in high word
	mov	d ds:[FCOL-4],eax	;save it there

__Draw_Filled:
	CONVERT_SIMPLE_POLY

	;
	;Finally let us draw da poly
	;
	mov	edx,ds:[Line_Table_End]		;EDX=counter
	mov	ebx,ds:[Line_Table_Start]
	mov	eax,edx
	sub	edx,ebx
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	ebx,4				;*16 bytes /entry
	shl	edx,4
	mov	eax,12345678h			;Colour...
FCOL:
@@L6:	push	edi
	movzx	ecx,w ds:[edx+ebx+Line_Table+2] ;Get start to zero
	add	edi,ecx
	sub	cx,w ds:[edx+ebx+Line_Table+10]
	neg	cx
	shr	ecx,1
	rep	stosw
	adc	cl,0
	rep	stosb
	pop	edi
	sub	edi,DISPLAY_Width
	sub	edx,16
	jnz	short @@L6

@@Exit: mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Filled_Poly ENDP
;
Draw_Lambert_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	ebx,byte ptr ds:[esi+4]	;Get colour
	shl	ebx,2*GVE_MATH_SHIFT-4

	mov	ebp,ds:[esi+24]		;Get first vector
	mov	eax,ds:[ebp+N21]	;Get Normal X
	imul	ds:[Current_Light.E1]
	add	ebx,eax
	mov	eax,ds:[ebp+N22]	;Get Normal Y
	imul	ds:[Current_Light.E2]
	add	ebx,eax
	mov	eax,ds:[ebp+N23]	;Get Normal Z
	imul	ds:[Current_Light.E3]
	add	eax,ebx			;EAX=Normal * Light
	sar	eax,2*GVE_MATH_SHIFT-4
	mov	ah,al			;Set both bytes to new colour !
	mov	d ds:[FCOL-4],eax	;save it there

	jmp	__Draw_Filled
Draw_Lambert_Poly ENDP
;
Draw_Gouraud_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	ebp,byte ptr ds:[esi+4]	;Get colour
	shl	ebp,2*GVE_MATH_SHIFT-4 	;Shift for interpolation

	CONVERT_DATA_POLY GOURAUD_POLY


	;
	;Finally let us draw da poly
	;
	mov	ebp,ds:[Line_Table_End]		;EBP=counter
	mov	ebx,ds:[Line_Table_Start]
	mov	eax,ebp
	sub	ebp,ebx
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	ebx,4				;*16 bytes /entry
	shl	ebp,4
@@L6:   push	edi
	movzx	ecx,w ds:[ebp+ebx+Line_Table+2] ;Get start to zero
	add	edi,ecx
	sub	cx,w ds:[ebp+ebx+Line_Table+10]	;ECX=Negative Width
	jns	@@Next
	movsx	ecx,cx

	lea	eax,[2*ecx+ecx+3*DISPLAY_WIDTH]	;*3 bytes/pixel
	mov	ds:[@@DST],eax			;Save in jump instruction

	mov	esi,ds:[ebp+ebx+Line_Table+4]	;Colour 1
	mov 	eax,ds:[ebp+ebx+Line_Table+12]	;Colour 2
	sub 	eax,esi
	cdq
	idiv 	ecx
	xchg	eax,esi				;EAX=Start colour
	rol	eax,16				;ESI=Decrement
	rol	esi,16

	db	0e9h
@@DST 	dd     	?                 		;JMP rel32

	REPT	DISPLAY_WIDTH
	  stosb					;;...SET IT !
	  sbb	eax,esi				;;Add colour increment
	ENDM

@@Next:	pop	edi
	sub	edi,DISPLAY_Width
	sub	ebp,16
	jnz	@@L6


	;
	;Restore EDI and EBP
	;
@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Gouraud_Poly ENDP
;
;
; This is the fast phong-shading method. It simply interpolates the cosinus
; values between the vertices of the poly.
;
; Note that the actual shading formula looks like this:
;
;	light()=2*cos(/2)^n - 1
;
Draw_Fast_Phong_Poly PROC NEAR
	push	ebp

	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,w ds:[esi+4]	;Get corner-colour/phong exponent
	mov	b ds:[@@CC5-1],al	;Save colour
	xor	al,al			;Clear colour/shift highlight value
	add	eax,OFFSET Phong_Table-256
	mov	d ds:[@@CC4-4],eax


	CONVERT_DATA_POLY FAST_PHONG_POLY


	;
	;Finally let us draw da poly
	;
	mov	ebp,ds:[Line_Table_End]		;EBP=counter
	mov	ecx,ds:[Line_Table_Start]	;ECX=Table-start
	mov	eax,ebp
	sub	ebp,ecx
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	ecx,4				;*16 bytes /entry
	shl	ebp,4
@@L6:	push	edi
	movzx	ebx,w ds:[ebp+ecx+Line_Table+2] ;EBX = start to zero
	add	edi,ebx				;EDI = buffer start address
	sub	bx,w ds:[ebp+ecx+Line_Table+10]	;EBX=Negative Width
	jns	@@Next
	movsx	ebx,bx

	lea	eax,[8*ebx+8*DISPLAY_WIDTH]	;*8 bytes/pixel
	mov	ds:[@@DST],eax			;Save in jump instruction

	mov	esi,ds:[ebp+ecx+Line_Table+4]	;ESI=STart-value
	mov 	eax,ds:[ebp+ecx+Line_Table+12]	;EAX=End value
	sub 	eax,esi
	cdq
	idiv 	ebx
	mov	edx,esi				;EDX=Start
	mov	esi,eax				;ESI=Decrement

	mov	ebx,12345678h                   ;Highlight-table address
@@CC4:  mov	ah,12h				;Colour
@@CC5:

	db	0e9h
@@DST 	dd     	?                 		;JMP rel32

	REPT	DISPLAY_WIDTH
	  mov	al,dh				;;Get current interpolated cos
	  xlatb					;;Look it up in Phong-table
	  add	al,ah				;;Add colour
	  stosb					;;...SET IT !
	  sub	edx,esi				;;Add cosine-increment
	ENDM

@@Next:	pop	edi
	sub	edi,DISPLAY_Width
	sub	ebp,16
	jnz	@@L6


	;
	;Restore EDI and EBP
	;
@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Fast_Phong_Poly ENDP



Draw_Phong_Poly PROC NEAR
	retn
Draw_Phong_Poly ENDP
;
;
;
; Now come all transparent polygons. The transparency effect is done by
; looking the two colours to mix up in a LUT - this is very flexible
; and still fast; you only need a 64kBytes big table.
; Another fine solution would be ORing the new pixels with the old ones,
; if you have a special palette. But I do not use such special palettes
; cause they are a bit clumsy and very unflexible, especially if you want
; to do some shading.
;
; The routines are very similar to the ones above, except for the mixng
; statements.
;
Draw_Glass_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,byte ptr ds:[esi+4]	;Get colour
	shl	eax,8
	add	eax,ds:[GVE_Glass_LUT]
	mov	d ds:[GCOL-4],eax	;save it there

__Draw_Glass:
	CONVERT_SIMPLE_POLY

	;
	;Finally let us draw da poly
	;
	mov	edx,ds:[Line_Table_End]		;EDX=counter
	mov	esi,ds:[Line_Table_Start]
	mov	eax,edx
	sub	edx,esi
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	esi,4				;*16 bytes /entry
	shl	edx,4
	mov	ebx,12345678h			;GlassLUT
GCOL:	xor	eax,eax

@@L6:	push	edi
	movzx	ecx,w ds:[edx+esi+Line_Table+2] ;Get start to zero
	add	edi,ecx
	sub	cx,w ds:[edx+esi+Line_Table+10]
	jns	@@Next
	movsx	ecx,cx

	lea	ecx,[8*ecx+8*DISPLAY_WIDTH]	;*8 bytes/pixel
	mov	ds:[@@DST],ecx			;Save in jump instruction

	jmp	short @@CJ1
@@CJ1:	db	0e9h
@@DST 	dd     	?                 		;JMP rel32


	REPT	DISPLAY_WIDTH
	 mov	al,es:[edi]			;;Get old colour
	 mov	al,es:[ebx+eax]			;;Look mixed colour up
	 stosb					;;Set pixel
	ENDM

@@Next:	pop	edi
	sub	edi,DISPLAY_Width
	sub	edx,16
	jnz	@@L6

@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Glass_Poly ENDP
;
Draw_Lambert_Glass_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	ebx,byte ptr ds:[esi+4]	;Get colour
	shl	ebx,2*GVE_MATH_SHIFT-4

	mov	ebp,ds:[esi+24]		;Get first vector
	mov	eax,ds:[ebp+N21]	;Get Normal X
	imul	ds:[Current_Light.E1]
	add	ebx,eax
	mov	eax,ds:[ebp+N22]	;Get Normal Y
	imul	ds:[Current_Light.E2]
	add	ebx,eax
	mov	eax,ds:[ebp+N23]	;Get Normal Z
	imul	ds:[Current_Light.E3]
	add	eax,ebx			;EAX=Normal * Light
	sar	eax,2*GVE_MATH_SHIFT-4
	mov	ah,al			;Set both bytes to new colour !
	and	eax,0ff00h
	add	eax,ds:[GVE_Glass_LUT]
	mov	d ds:[GCOL-4],eax	;save it there

	jmp	__Draw_Glass
Draw_Lambert_Glass_Poly ENDP
;
Draw_Gouraud_Glass_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	ebp,byte ptr ds:[esi+4]	;Get colour
	shl	ebp,2*GVE_MATH_SHIFT-4 	;Shift for interpolation

	CONVERT_DATA_POLY GOURAUD_POLY


	;
	;Finally let us draw da poly
	;
	mov	ebp,ds:[Line_Table_End]		;EBP=counter
	mov	esi,ds:[Line_Table_Start]
	mov	eax,ebp
	sub	ebp,esi
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	esi,4				;*16 bytes /entry
	shl	ebp,4
@@L6:	push	edi
	movzx	ecx,w ds:[ebp+esi+Line_Table+2] ;Get start to zero
	add	edi,ecx
	sub	cx,w ds:[ebp+esi+Line_Table+10]	;ECX=Negative Width
	jns	@@Next
	movsx	ecx,cx

	lea	eax,[2*ecx+ecx]			;*3 bytes/pixel
	lea	eax,[4*eax+12*DISPLAY_WIDTH]	;12 bytes/pixel
	mov	ds:[@@DST],eax			;Save in jump instruction

	mov	ebx,ds:[ebp+esi+Line_Table+4]	;Colour 1
	mov 	eax,ds:[ebp+esi+Line_Table+12]	;Colour 2
	sub 	eax,ebx
	cdq
	idiv 	ecx				;EAX=Decrement, EBX=Startcolour
	mov	ecx,eax				;ECX=Decrement

	mov	edx,ds:[GVE_Glass_LUT]
	xor	eax,eax
	rol	ebx,16
	rol	ecx,16				;Carry should be ok now

	db	0e9h
@@DST 	dd     	?                 		;JMP rel32

	REPT	DISPLAY_WIDTH
	  mov	al,es:[edi]			;;Get old colour
	  mov	ah,bl				;;...and new colour
	  mov	al,es:[eax+edx]			;;mix colours via LUT
	  stosb					;;...SET IT !
	  sbb	ebx,ecx                         ;;add increment to colour
	ENDM

@@Next:	pop	edi
	sub	edi,DISPLAY_Width
	sub	ebp,16
	jnz	@@L6


	;
	;Restore EDI and EBP
	;
@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Gouraud_Glass_Poly ENDP
;
Draw_Phong_Glass_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,w ds:[esi+4]	;Get corner-colour/phong exponent
	mov	b ds:[@@CC5-1],al	;Save colour
	xor	al,al			;Clear colour/shift highlight value
	add	eax,OFFSET Phong_Table-256
	mov	d ds:[@@CC4-4],eax


	CONVERT_DATA_POLY FAST_PHONG_POLY

	;
	;Finally let us draw da poly
	;
	mov	ebp,ds:[Line_Table_End]		;EBP=counter
	mov	esi,ds:[Line_Table_Start]
	mov	eax,ebp
	sub	ebp,esi
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	esi,4				;*16 bytes /entry
	shl	ebp,4
@@L6:	push	edi
	movzx	ecx,w ds:[ebp+esi+Line_Table+2] ;Get start to zero
	add	edi,ecx
	sub	cx,w ds:[ebp+esi+Line_Table+10]	;ECX=Negative Width
	jns	@@Next
	movsx	ecx,cx
	push	esi				;Save index...
	push	ebp

	lea	eax,[8*ecx]			;*8 bytes/pixel
	lea	eax,[2*eax+15*DISPLAY_WIDTH]	;*16 bytes/pixel
	sub	eax,ecx				;=15 bytes/pixel
	mov	ds:[@@DST],eax			;Save in jump instruction

	mov	ebx,ds:[ebp+esi+Line_Table+4]	;Colour 1
	mov 	eax,ds:[ebp+esi+Line_Table+12]	;Colour 2
	sub 	eax,ebx
	cdq
	idiv 	ecx				;EAX=Decrement, EBX=Startcolour
	mov	ebp,eax				;EBP=Decrement
	mov	edx,ebx				;EDX=Start-colour

	xor	eax,eax				;Clear for indexing
	mov	esi,ds:[GVE_Glass_LUT]
	mov	ebx,12345678h                   ;Highlight-table address
@@CC4:  mov	cl,12h				;Colour
@@CC5:
	db	0e9h
@@DST 	dd     	?                 		;JMP rel32

	REPT	DISPLAY_WIDTH
	  mov	al,dh				;;Get current cos-value
	  xlatb					;;Look it up in Phong table
	  add	al,cl				;;Add colour
	  mov	ah,es:[edi]			;;Get old colour
	  mov	al,es:[esi+eax]			;;Get mixed colour
	  stosb					;;...SET IT !
	  sub	edx,ebp
	ENDM

	pop	ebp
	pop	esi
@@Next: pop	edi
	sub	edi,DISPLAY_Width
	sub	ebp,16
	jnz	@@L6


	;
	;Restore EDI and EBP
	;
@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Phong_Glass_Poly ENDP
;
;
;
; Now follow some texture-mapping routines also used by the chrome mappings
;
Draw_Fast_Texture PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,word ptr ds:[esi+6]	;Get texture-number
	lea	eax,[8*eax+4]		;*8 bytes/entry
	add	eax,ds:[GVE_Texture_List]
	mov	eax,ds:[eax+4]		;Get texture address
	mov	d ds:[TADR-4],eax
	lea	ebp,[esi+4*ecx+24]	;EBP points to texture coordinates

	CONVERT_TEXTURE_POLY TEXTURE_POLY

__Draw_Texture:
	;
	;Finally let us draw da poly
	;
	mov	ebp,ds:[Line_Table_End]		;EBP=counter
	mov	esi,ds:[Line_Table_Start]
	mov	eax,ebp
	sub	ebp,esi
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	esi,5				;*32 bytes /entry
	shl	ebp,5
@@L6:	push	edi
	movzx	ebx,w ds:[ebp+esi+Line_Table+2] ;Get start to zero
	add	edi,ebx
	sub	bx,w ds:[ebp+esi+Line_Table+18]	;EBX=Negative Width
	jns	@@Next
	movsx	ebx,bx

	lea	eax,[8*ebx]
	sub	eax,ebx				;7*ebx
	lea	eax,[2*eax+14*DISPLAY_WIDTH]	;*14 bytes/pixel
	mov	ds:[@@DST],eax			;Save in jump instruction

	mov 	eax,ds:[ebp+esi+Line_Table+24]	;Texture y2
	sub 	eax,ds:[ebp+esi+Line_Table+8]	;Texture y1
	cdq
	idiv 	ebx
	shrd	ecx,eax,24

	mov 	eax,ds:[ebp+esi+Line_Table+20]	;Texture x2
	sub 	eax,ds:[ebp+esi+Line_Table+4]	;Texture x1
	cdq
	idiv 	ebx
	sar	eax,8
	mov 	cx,ax               		;ECX holds texture increment

	mov 	edx,ds:[ebp+esi+Line_Table+7]
	mov	dx,w ds:[ebp+esi+Line_Table+5]	;EDX holds start address

	mov    	ebx,12345678h			;Texture address
TADR	db	0e9h
@@DST 	dd     	?                 		;JMP rel32

	REPT	DISPLAY_WIDTH
	  movzx	eax,dh
	  shld	eax,edx,8
	  mov	al,es:[ebx+eax]
	  stosb					;;...SET IT !
	  sub	edx,ecx
	ENDM

@@Next:	pop	edi
	sub	edi,DISPLAY_Width
	sub	ebp,32
	jnz	@@L6

	;
	;Restore EDI and EBP
	;
@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Fast_Texture ENDP
;
Draw_Lambert_Texture PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,word ptr ds:[esi+6]	;Get texture-number
	lea	eax,[8*eax+4]		;*8 bytes/entry +4 bytes header
	add	eax,ds:[GVE_Texture_List]
	mov	eax,ds:[eax+4]		;Get texture address
	mov	d ds:[TLADR-4],eax

	mov	ebp,ds:[esi+24]		;Get first vector
	mov	ebx,ds:[ebp+N21]	;Get Normal X
	imul	ebx,ds:[Current_Light.E1]
	mov	eax,ds:[ebp+N22]	;Get Normal Y
	imul	ds:[Current_Light.E2]
	add	ebx,eax
	mov	eax,ds:[ebp+N23]	;Get Normal Z
	imul	ds:[Current_Light.E3]
	add	eax,ebx			;EAX=Normal * Light
	sar	eax,2*GVE_MATH_SHIFT-5
	add	eax,32
	shl	eax,8			;*256 bytes/LUT table
	add	eax,ds:[GVE_Shading_LUT]
	mov	d ds:[TLLUT-4],eax	;save it there
	lea	ebp,[esi+4*ecx+24]	;EBP points to texture coordinates

	CONVERT_TEXTURE_POLY TEXTURE_POLY

__Draw_Lambert_Texture:
	mov	ebp,ds:[Line_Table_End]		;EBP=counter
	mov	esi,ds:[Line_Table_Start]
	mov	eax,ebp
	sub	ebp,esi
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	esi,5				;*32 bytes /entry
	shl	ebp,5
@@L6:	push	edi
	movzx	ebx,w ds:[ebp+esi+Line_Table+2] ;Get start to zero
	add	edi,ebx
	sub	bx,w ds:[ebp+esi+Line_Table+18]	;EBX=Negative Width
	jns	@@Next
	movsx	ebx,bx
	push	esi

	lea	eax,[8*ebx]
	lea	eax,[2*eax+16*DISPLAY_WIDTH]	;*16 bytes/pixel
	mov	ds:[@@DST],eax			;Save in jump instruction

	mov 	eax,ds:[ebp+esi+Line_Table+24]	;Texture y2
	sub 	eax,ds:[ebp+esi+Line_Table+8]	;Texture y1
	cdq
	idiv 	ebx
	shrd	ecx,eax,24			;The high-word of ECX now contains

	mov 	eax,ds:[ebp+esi+Line_Table+20]	;Texture x2
	sub 	eax,ds:[ebp+esi+Line_Table+4]	;Texture x1
	cdq
	idiv 	ebx
	sar	eax,8
	mov 	cx,ax               		;ECX holds texture increment

	mov 	edx,ds:[ebp+esi+Line_Table+7]
	mov	dx,w ds:[ebp+esi+Line_Table+5]	;EDX holds start address

	mov    	esi,12345678h			;Texture address
TLADR:  mov	ebx,12345678h
TLLUT:	db	0e9h
@@DST 	dd     	?                 		;JMP rel32

	REPT	DISPLAY_WIDTH
	  movzx	eax,dh
	  shld	eax,edx,8
	  mov	al,es:[esi+eax]
	  xlatb	es:[ebx]			;;Look up in shading-table
	  stosb					;;...SET IT !
	  sub	edx,ecx
	ENDM

	pop	esi
@@Next:	pop	edi
	sub	edi,DISPLAY_Width
	sub	ebp,32
	jnz	@@L6

	;
	;Restore EDI and EBP
	;
@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Lambert_Texture ENDP
;
Draw_Gouraud_Texture PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,word ptr ds:[esi+6]	;Get texture-number
	lea	eax,[8*eax+4]		;*8 bytes/entry +4 bytes header
	add	eax,ds:[GVE_Texture_List]
	mov	eax,ds:[eax+4]		;Get texture address
	mov	d ds:[TGADR-4],eax
	lea	ebp,[esi+4*ecx+24]	;EBP points to texture coordinates

	CONVERT_TEXTURE_POLY TEXTURE_GOURAUD_POLY

__Draw_Gouraud_Texture:
	mov	eax,ds:[GVE_Shading_LUT]
	mov	d ds:[@@C3-4],eax

	mov	ebp,ds:[Line_Table_End]		;EBP=counter
	mov	esi,ds:[Line_Table_Start]
	mov	eax,ebp
	sub	ebp,esi
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	esi,5				;*32 bytes /entry
	shl	ebp,5
@@L6:	push	edi
	movzx	ecx,w ds:[ebp+esi+Line_Table+2] ;Get start to zero
	add	edi,ecx
	sub	cx,w ds:[ebp+esi+Line_Table+18]	;ECX=Negative Width
	jns	@@Next
	movsx	ecx,cx

	mov 	eax,ds:[ebp+esi+Line_Table+24]	;Texture y2
	sub 	eax,ds:[ebp+esi+Line_Table+8]	;Texture y1
	cdq
	idiv 	ecx
	sar	eax,8				;EAX holds texture y increment
	mov	w ds:[@@C1-2],ax

	mov 	eax,ds:[ebp+esi+Line_Table+20]	;Texture x2
	sub 	eax,ds:[ebp+esi+Line_Table+4]	;Texture x1
	cdq
	idiv 	ecx
	sar	eax,8				;EAX holds texture x increment
	mov	w ds:[@@C1-4],ax

	mov 	eax,ds:[ebp+esi+Line_Table+28]	;Gouraud d2
	mov 	ebx,ds:[ebp+esi+Line_Table+12]	;Gouraud d1
	sub	eax,ebx
	cdq
	idiv 	ecx
	sar	eax,2*GVE_MATH_SHIFT-5-8
	mov	d ds:[@@C2-4],eax
	sar	ebx,2*GVE_MATH_SHIFT-5-8	;Gouraud start

	mov 	edx,ds:[ebp+esi+Line_Table+7]
	mov	dx,w ds:[ebp+esi+Line_Table+5]	;EDX holds start address

@@L1:	  movzx	eax,dh
	  shld	eax,edx,8
	  mov	al,b es:[eax+12345678h]		;Get texture texel
TGADR:	  mov	ah,bh				;Get gouraud-value
	  mov	al,ds:[eax+12345678h]		;Look up in shading-table
@@C3:	  stosb					;...SET IT !
	  sub	edx,12345678h			;Inc texture-address
@@C1:	  sub	ebx,12345678h			;Inc gouraud value
@@C2:	  inc	ecx
	  jnz	short @@L1


@@Next:	pop	edi
	sub	edi,DISPLAY_Width
	sub	ebp,32
	jnz	@@L6

	;
	;Restore EDI and EBP
	;
@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Gouraud_Texture ENDP
;
Draw_Phong_Texture PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,b ds:[esi+5]	;Get phong exponent
	shl	eax,8			;Clear colour/shift highlight value
	add	eax,OFFSET Phong_Texture_Table-256
	mov	d ds:[TPTBL-4],eax	;Save into code !
	movzx	eax,word ptr ds:[esi+6]	;Get texture-number
	lea	eax,[8*eax+4]		;*8 bytes/entry +4 bytes header
	add	eax,ds:[GVE_Texture_List]
	mov	eax,ds:[eax+4]		;Get texture address
	mov	d ds:[TPADR-4],eax
	lea	ebp,[esi+4*ecx+24]	;EBP points to texture coordinates

	CONVERT_TEXTURE_POLY TEXTURE_PHONG_POLY

__Draw_Phong_Texture:
	mov	eax,ds:[GVE_Shading_LUT]
	mov	d ds:[@@C3-4],eax

	mov	ebp,ds:[Line_Table_End]		;EBP=counter
	mov	esi,ds:[Line_Table_Start]
	mov	eax,ebp
	sub	ebp,esi
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	esi,5				;*32 bytes /entry
	shl	ebp,5
@@L6:	push	edi
	movzx	ecx,w ds:[ebp+esi+Line_Table+2] ;Get start to zero
	add	edi,ecx
	sub	cx,w ds:[ebp+esi+Line_Table+18]	;ECX=Negative Width
	jns	@@Next
	movsx	ecx,cx
	push	ebp

	mov 	eax,ds:[ebp+esi+Line_Table+24]	;Texture y2
	sub 	eax,ds:[ebp+esi+Line_Table+8]	;Texture y1
	cdq
	idiv 	ecx
	sar	eax,8				;EAX holds texture y increment
	mov	w ds:[@@C1-2],ax

	mov 	eax,ds:[ebp+esi+Line_Table+20]	;Texture x2
	sub 	eax,ds:[ebp+esi+Line_Table+4]	;Texture x1
	cdq
	idiv 	ecx
	sar	eax,8				;EAX holds texture x increment
	mov	w ds:[@@C1-4],ax

	mov 	eax,ds:[ebp+esi+Line_Table+28]	;Phong d2
	mov 	ebx,ds:[ebp+esi+Line_Table+12]	;Phong d1
	sub	eax,ebx
	cdq
	idiv 	ecx
	mov	d ds:[@@C2-4],eax

	mov 	edx,ds:[ebp+esi+Line_Table+7]
	mov	dx,w ds:[ebp+esi+Line_Table+5]	;EDX holds start address
	mov	ebp,ecx				;EBP holds counter
	xor	ecx,ecx

@@L1:	  movzx	eax,dh
	  shld	eax,edx,8
	  mov	al,b ds:[eax+12345678h]		;Get texture texel
TPADR:	  mov	cl,bh
	  mov	ah,ds:[ecx+12345678h]		;Get phong-value
TPTBL:	  mov	al,ds:[eax+12345678h]		;Look up in shading-table
@@C3:	  stosb					;...SET IT !
	  sub	edx,12345678h			;Inc texture-address
@@C1:	  sub	ebx,12345678h			;Inc cosine value
@@C2:	  inc	ebp
	  jnz	short @@L1

	pop	ebp
@@Next:	pop	edi
	sub	edi,DISPLAY_Width
	sub	ebp,32
	jnz	@@L6

	;
	;Restore EDI and EBP
	;
@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Phong_Texture ENDP
;
Draw_Glass_Texture PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,word ptr ds:[esi+6]	;Get texture-number
	lea	eax,[8*eax+4]		;*8 bytes/entry +4 bytes header
	add	eax,ds:[GVE_Texture_List]
	mov	eax,ds:[eax+4]		;Get texture address
	mov	d ds:[GTADR-4],eax
	lea	ebp,[esi+4*ecx+8]	;EBP points to texture coordinates

	CONVERT_TEXTURE_POLY TEXTURE_POLY

__Draw_Glass_Texture:
	mov	ebp,ds:[Line_Table_End]		;EBP=counter
	mov	esi,ds:[Line_Table_Start]
	mov	eax,ebp
	sub	ebp,esi
	fastimul edi,eax,DISPLAY_WIdth
	add	edi,ds:[GVE_Frame_Buffer]	;EDI points to first line
	shl	esi,5				;*32 bytes /entry
	shl	ebp,5
@@L6:	push	edi
	movzx	ebx,w ds:[ebp+esi+Line_Table+2] ;Get start to zero
	add	edi,ebx
	sub	bx,w ds:[ebp+esi+Line_Table+18]	;EBX=Negative Width
	jns	@@Next
	movsx	ebx,bx
	push	esi

	lea	eax,[8*ebx]
	sub	eax,ebx				;7*ebx
	lea	eax,[2*eax+eax+21*DISPLAY_WIDTH];*21 bytes/pixel
	mov	ds:[@@DST],eax			;Save in jump instruction

	mov 	eax,ds:[ebp+esi+Line_Table+24]	;Texture y2
	sub 	eax,ds:[ebp+esi+Line_Table+8]	;Texture y1
	cdq
	idiv 	ebx
	shrd	ecx,eax,24			;The high-word of ECX now contains

	mov 	eax,ds:[ebp+esi+Line_Table+20]	;Texture x2
	sub 	eax,ds:[ebp+esi+Line_Table+4]	;Texture x1
	cdq
	idiv 	ebx
	sar	eax,8
	mov 	cx,ax               		;ECX holds texture increment

	mov 	edx,ds:[ebp+esi+Line_Table+7]
	mov	dx,w ds:[ebp+esi+Line_Table+5]	;EDX holds start address

	mov	esi,ds:[GVE_Glass_LUT]
	mov    	ebx,12345678h			;Texture address
GTADR   db	0e9h
@@DST 	dd     	?                 		;JMP rel32

	REPT	DISPLAY_WIDTH
	  movzx	eax,dh
	  shld	eax,edx,8
	  mov	al,es:[ebx+eax]
	  mov	ah,es:[edi]			;;Get old colour
	  mov	al,es:[esi+eax]			;;Look up in glass-LUT
	  stosb					;;...SET IT !
	  sub	edx,ecx
	ENDM

	pop	esi
@@Next:	pop	edi
	sub	edi,DISPLAY_Width
	sub	ebp,32
	jnz	@@L6

	;
	;Restore EDI and EBP
	;
@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Glass_Texture ENDP
;
Draw_Slow_Texture PROC NEAR
	retn
Draw_Slow_Texture ENDP
;
;
;
; This is a chrome mapper. The mapper is some sort of a texture mapper,
; but the texture (u,v) coordinates will be calculated via the eye-vector
;
Draw_Chrome_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,word ptr ds:[esi+6]	;Get texture-number
	lea	eax,[8*eax+4]		;*8 bytes/entry +4 bytes header
	add	eax,ds:[GVE_Texture_List]
	mov	eax,ds:[eax+4]		;Get texture address
	mov	d ds:[TADR-4],eax

	CONVERT_TEXTURE_POLY CHROME_POLY
	jmp	__Draw_Texture

@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Chrome_Poly ENDP
;
Draw_Lambert_Chrome_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,word ptr ds:[esi+6]	;Get texture-number
	lea	eax,[8*eax+4]		;*8 bytes/entry +4 bytes header
	add	eax,ds:[GVE_Texture_List]
	mov	eax,ds:[eax+4]		;Get texture address
	mov	d ds:[TLADR-4],eax

	mov	ebp,ds:[esi+24]		;Get first vector
	mov	ebx,ds:[ebp+N21]	;Get Normal X
	imul	ebx,ds:[Current_Light.E1]
	mov	eax,ds:[ebp+N22]	;Get Normal Y
	imul	ds:[Current_Light.E2]
	add	ebx,eax
	mov	eax,ds:[ebp+N23]	;Get Normal Z
	imul	ds:[Current_Light.E3]
	add	eax,ebx			;EAX=Normal * Light
	sar	eax,2*GVE_MATH_SHIFT-5
	add	eax,32
	shl	eax,8			;*256 bytes/LUT table
	add	eax,ds:[GVE_Shading_LUT]
	mov	d ds:[TLLUT-4],eax	;save it there

	CONVERT_TEXTURE_POLY CHROME_POLY
	jmp	__Draw_Lambert_Texture

@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Lambert_Chrome_Poly ENDP
;
Draw_Gouraud_Chrome_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,word ptr ds:[esi+6]	;Get texture-number
	lea	eax,[8*eax+4]		;*8 bytes/entry +4 bytes header
	add	eax,ds:[GVE_Texture_List]
	mov	eax,ds:[eax+4]		;Get texture address
	mov	d ds:[TGADR-4],eax

	CONVERT_TEXTURE_POLY CHROME_GOURAUD_POLY
	jmp	__Draw_Gouraud_Texture

@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Gouraud_Chrome_Poly ENDP
;
Draw_Glass_Chrome_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,word ptr ds:[esi+6]	;Get texture-number
	lea	eax,[8*eax+4]		;*8 bytes/entry +4 bytes header
	add	eax,ds:[GVE_Texture_List]
	mov	eax,ds:[eax+4]		;Get texture address
	mov	d ds:[GTADR-4],eax

	CONVERT_TEXTURE_POLY CHROME_POLY
	jmp	__Draw_Glass_Texture

@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Glass_Chrome_Poly ENDP
;
Draw_Phong_Chrome_Poly PROC NEAR
	push	ebp
	movzx	ecx,byte ptr ds:[esi+3]	;Get Poly-Counter
	movzx	eax,b ds:[esi+5]	;Get phong exponent
	shl	eax,8			;Clear colour/shift highlight value
	add	eax,OFFSET Phong_Texture_Table-256
	mov	d ds:[TPTBL-4],eax	;Save into code !
	movzx	eax,word ptr ds:[esi+6]	;Get texture-number
	lea	eax,[8*eax+4]		;*8 bytes/entry +4 bytes header
	add	eax,ds:[GVE_Texture_List]
	mov	eax,ds:[eax+4]		;Get texture address
	mov	d ds:[TPADR-4],eax

	CONVERT_TEXTURE_POLY CHROME_PHONG_POLY

	jmp	__Draw_Phong_Texture

@@Exit:	mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw_Phong_Chrome_Poly ENDP
;
;
;
; This routine will simply draw all vertices of a poly
;
Draw_Vertex PROC NEAR
	movzx	ecx,byte ptr ds:[esi+3]	;Number of vertices

@@L1:	mov	edx,ds:[esi+20+4*ecx]	;Get vertex
	mov	ebx,ds:[edx+PX]         ;Get projected X
	cmp	ebx,DISPLAY_Width
	jae	short @@N
	mov	eax,ds:[edx+PY]		;Get projected Y
	cmp	eax,DISPLAY_Height
	jae	short @@N

	fastimul edx,eax,DISPLAY_Width
	add	edx,ebx
	mov	al,ds:[esi+4]		;Get colour
	mov	ds:[edi+edx],al

@@N:    dec	ecx
	jnz	short @@L1

	retn
Draw_Vertex ENDP




;
;   GOMEZ VECTOR ENGINE                           MATHEMATICAL FUNCTIONS
;
;
;
; Now follow two maacros for the SINE and COSINE functions including a
; (Co)Sine-table. There is also another table used for phong-shading,
; which contains 256 values for cos(acos(x)/2).
;
;   Sine and Cosine table (GVE_MATRIX_SHIFT bit fixed point arithmetic (FPA) )
;   Phong-Table with 8 bit FPA
;
include gvetable.inc
;
;Cosinus und Sinus:
;    In : bx      -> Angel (from 0 to 1024 for 2PI or 360 degerees)
;         eax     -> Value to multpiply sine with
;    Out: ebx     -> Sinus or Cosinus
;         edx:eax -> Multiplied result
;
Sinus MACRO
	and 	ebx,GVE_COSINE_SIZE-1
	mov 	ebx,ds:[OFFSET SinTab+4*ebx]
	imul 	ebx
	shrd 	eax,edx,GVE_MATRIX_SHIFT
	sar 	edx,GVE_MATRIX_SHIFT
      ENDM
Cosinus MACRO
	and 	ebx,GVE_COSINE_SIZE-1
	mov 	ebx,ds:[OFFSET CosTab+4*ebx]
	imul 	ebx
	shrd 	eax,edx,GVE_MATRIX_SHIFT
	sar 	edx,GVE_MATRIX_SHIFT
      ENDM

;
;MSinusCosinus:
;  Input:
;	???   	- Angel
;  Output:
;	EAX	- Sinus
;	EBX	- Cosinus
;
MSinusCosinus MACRO angel
	and	angel,GVE_COSINE_SIZE-1
	mov 	eax,ds:[OFFSET SinTab+4*angel]
	mov 	ebx,ds:[OFFSET CosTab+4*angel]
      ENDM


;
;
; Build_Matrix:
;   This function builds the transformation matrix as follows:
;   The order of the rotations are as follows:
;         X , Y , Z
; Input:
;   EAX    -  X translation
;   EBX    -  Y translation
;   ECX    -  Z translation
;   EDX    -  X Rotation  ()
;   ESI    -  Y Rotation  ()
;   EDI    -  Z Rotation  ()
;   DS:EBP -  ptr to destination matrix
; Output:
;   DS:EBP -  Transformation matrix
; Destryos:
;   Everything
;
;
; This routine calculates a matrix as a combination of the following
; matrices (plus the translation that will be performed last):
;
;                                                                  
; cos   -sin   0   0    1   0        0   0    cos   0   sin   0
; sin   cos    0   0    0  cos  -sin   0    0      1     0    0
;  0      0      1   0 *  0  sin  cos    0 *  -sin  0   cos   0
;  0      0      0   1    0   0        0   1    0      0     0    1
;                                                                  
;       Z rotation              X Rotation               Y Rotation
;
;
; The resulting matrix looks like this: (Calculated with CC4 !)
;                                                                              
;  cos*cos - sin*sin*sin    -sin*cos    cos*sin + sin*sin*cos   Tx 
;  sin*cos + cos*sin*sin     cos*cos    sin*sin - cos*sin*cos   Ty 
;          -cos*sin               sin              cos*cos             Tz 
;              0                     0                    0                 1  
;                                                                              
;
;
Build_Matrix PROC NEAR
	mov	ds:[ebp+E14],eax	;Set all translation thingys
	mov	ds:[ebp+E24],ebx
	mov	ds:[ebp+E34],ecx
	xor	eax,eax
	mov	d ds:[ebp+E44],1 shl GVE_MATRIX_SHIFT
	mov	ds:[ebp+E41],eax
	mov	ds:[ebp+E42],eax
	mov	ds:[ebp+E43],eax

	mov	ebx,edx			;Set EBX to 
	and	ebx,GVE_COSINE_SIZE-1
	and	esi,GVE_COSINE_SIZE-1
	and	edi,GVE_COSINE_SIZE-1	;Normalize angles

	mov	eax,ds:[SinTab+4*ebx]	;Get sin
	mov	ds:[ebp+E32],eax	;-=> E32 is ready ! <=-
	imul	ds:[SinTab+4*edi]	;sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	imul	ds:[SinTab+4*esi]	;sin*sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ecx,eax			;ECX=sin*sin*sin

	mov	eax,ds:[CosTab+4*edi]	;cos
	imul	ds:[CosTab+4*esi]	;cos*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	sub	eax,ecx			;EAX=cos*cos - sin*sin*sin
	mov	ds:[ebp+E11],eax	;-=> E11 is ready ! <=-


	mov	eax,ds:[SinTab+4*edi]	;sin
	imul	ds:[CosTab+4*ebx]	;sin*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	neg	eax
	mov	ds:[ebp+E12],eax	;-=> E12 is ready ! <=-


	mov	eax,ds:[CosTab+4*edi]	;cos
	imul	ds:[SinTab+4*esi]	;cos*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ecx,eax			;ECX=cos*sin

	mov	eax,ds:[SinTab+4*edi]	;sin
	imul	ds:[SinTab+4*ebx]	;sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	imul	ds:[CosTab+4*esi]	;sin*sin*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	add	eax,ecx
	mov	ds:[ebp+E13],eax	;-=> E13 is ready ! <=-


	mov	eax,ds:[SinTab+4*ebx]	;Get sin
	imul	ds:[CosTab+4*edi]	;cos*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	imul	ds:[SinTab+4*esi]	;cos*sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ecx,eax			;ECX=cos*sin*sin

	mov	eax,ds:[SinTab+4*edi]	;sin
	imul	ds:[CosTab+4*esi]	;sin*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	add	eax,ecx			;EAX=sin*cos + cos*sin*sin
	mov	ds:[ebp+E21],eax	;-=> E21 is ready ! <=-


	mov	eax,ds:[CosTab+4*edi]	;cos
	imul	ds:[CosTab+4*ebx]	;cos*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ds:[ebp+E22],eax	;-=> E22 is ready ! <=-


	mov	eax,ds:[SinTab+4*edi]	;sin
	imul	ds:[SinTab+4*esi]	;sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ecx,eax			;ECX=cos*sin

	mov	eax,ds:[CosTab+4*edi]	;cos
	imul	ds:[SinTab+4*ebx]	;cos*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	imul	ds:[CosTab+4*esi]	;cos*sin*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	sub	ecx,eax
	mov	ds:[ebp+E23],ecx	;-=> E23 is ready ! <=-


	mov	eax,ds:[CosTab+4*ebx]	;cos
	imul	ds:[SinTab+4*esi]	;cos*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	neg	eax
	mov	ds:[ebp+E31],eax	;-=> E31 is ready ! <=-


	mov	eax,ds:[CosTab+4*ebx]	;cos
	imul	ds:[CosTab+4*esi]	;cos*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ds:[ebp+E33],eax	;-=> E33 is ready ! <=-


	retn
Build_Matrix ENDP


;
;
; Mult_Matrix:
;	This function is used to multiply two 4x4 matrices
;
; Input:
;	ES	-	Selector for matrices
;	ESI	-	Matrix A
;	EBP	-	Matrix B
;	EDI	-	Resulting matrix A*B
;	CH	-	Number of rows to calculate
; Output:
;	resulting matrix
; Destroys:
;	EAX,EBX,ECX,EDX
;
;
; Note: CH is used as a row-counter, because when calculating the final
;       transformation matrix, 3 rows suffice, but normally you would like
;	 to get 4 rows. So for speed, I made it this way
;
Mult_Matrix PROC NEAR
	push	edi
	push	esi
;	mov	ch,4
@@L1:	mov	cl,4
@@L2:		mov	eax,ds:[esi]
		imul	d ds:[ebp]
		shrd	eax,edx,GVE_MATRIX_SHIFT
		mov	ebx,eax

		mov	eax,ds:[esi+4]
		imul	d ds:[ebp+4*4]
		shrd	eax,edx,GVE_MATRIX_SHIFT
		add	ebx,eax

		mov	eax,ds:[esi+8]
		imul	d ds:[ebp+8*4]
		shrd	eax,edx,GVE_MATRIX_SHIFT
		add	ebx,eax

		mov	eax,ds:[esi+12]
		imul	d ds:[ebp+12*4]
		shrd	eax,edx,GVE_MATRIX_SHIFT
		add	eax,ebx		;EAX holds result

		stosd			;Save it in matrix
		add	ebp,4
		dec	cl		;Next coloumn in B
		jnz	short @@L2
	sub	ebp,4*4
	add	esi,4*4			;Next row in A
	dec	ch
	jnz	short @@L1

	pop	esi
	pop	edi
	retn
Mult_Matrix ENDP
;
;
; Get_Root:
; Input:
;   ESI   -  Number to process
; Output:
;   ECX   -  Root of ESI
; Destroys:
;   EAX,EBX,EDX
;
;
; Get_Root64:
; Input:
;   EDI:ESI   -  Number to process
; Output:
;   ECX       -  Root of ESI
; Destroys:
;   EAX,EBX,EDX
;
PUBLIC C Get_Root64
Get_ROOT64 PROC NEAR
	mov	ecx,esi
	or	ecx,edi
	jz	short @@E
	mov	ecx,0f0000000h		;ECX is start-value

@@L1:	mov	eax,esi                 ;EAX=ESI
	mov	edx,edi			;EDX:EAX = EDI:ESI
	div	ecx                     ;EAX=ESI / EAX
	add	eax,ecx                 ;ECX=(ECX + ESI/ECX)
	rcr	eax,1			;EAX=(ECX + ESI/ECX)/2

	cmp	ecx,eax                 ;Is it same ???
	mov	ecx,eax			;Set result ECX = EAX
	ja	short @@L1		;Not same ==> L1

@@E:	retn
Get_ROOT64 ENDP
;
PUBLIC C Get_Root
Get_ROOT PROC NEAR
	mov	ecx,esi			;ECX is start-value
	jecxz	@@E

@@L1:	mov	eax,esi                 ;EAX=ESI
	cdq
	div	ecx                     ;EAX=ESI / EAX
	add	eax,ecx                 ;ECX=(ECX + ESI/ECX)
	rcr	eax,1			;EAX=(ECX + ESI/ECX)/2

	cmp	ecx,eax                 ;Is it same ???
	mov	ecx,eax			;Set result ECX = EAX
	ja	short @@L1		;Not same ==> L1

@@E:	retn
Get_ROOT ENDP

;
;
; This macro tests if a surface is visible
; Input:
;	ES:ESI 	- primitive header
; Output:
;      SIGN	- 1 - not visible
;		  0 - visible
; Destroys:
;	EAX,EBX,ECX,EDX,EBP
;
;
; The calculation is based on the following formular:
;  v[x]:=p1.x - p2.x;
;  v[y]:=p1.y - p2.y;
;  w[x]:=p3.x - p2.x;
;  w[y]:=p3.y - p2.y;
;  m1  :=v[x] * w[y];
;  m2  :=v[y] * w[x];
;  visible:=m1 - m2>0;
;
TEST_BACK_CULLING MACRO
	mov	ebx,ds:[esi+24]		;ES:EBX points to p1
	mov	ecx,ds:[esi+28]		;ES:ECX points to p2
	mov     ebp,ds:[esi+32]		;ES:EBP points to p3

	mov	eax,ds:[ebx+PX]
	sub	eax,ds:[ecx+PX]  	;EAX = p1x-p2x

	mov	edx,ds:[ebp+PY]
	sub	edx,ds:[ecx+PY]		;EDX = p3y-p2y
	imul	edx                     ;EAX = v[x] * w[y]

	mov	edx,ds:[ebp+PX]
	sub	edx,ds:[ecx+PX]		;EDX = p3x-p2x
	mov	ebp,eax			;EBP = v[x] * w[y]

	mov	eax,ds:[ebx+PY]
	sub	eax,ds:[ecx+PY]  	;EAX = p1y-p2y
	imul	edx			;EAX = v[y] * w[x]

	cmp	ebp,eax
	ENDM



;
;   GOMEZ VECTOR ENGINE                                SORTING ROUTINES
;
;
;
; o.k. Here comes the byte-sort routine for sorting the primitives in de-
; scending order.
;
; Imput:
;	ESI = Start of source list
;	EDI = Start of destination list
;      EDX = Number of elements to sort
;	ECX = Shift_Size  (MUST  BE  BYTE_SORT_SIZE  !!!)
;      ES  = Zero segment
; Output:
;	Nothing
; Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
BYTE_SORT_SIZE	equ	4
Byte_Sort PROC NEAR
	sub	esp,(1 shl BYTE_SORT_SIZE)*8
	mov	ebp,esp


	;
	;First, lets clear all counters...
	;
	xor	eax,eax
	a=0
	REPT	(1 shl BYTE_SORT_SIZE)
	 mov	ss:[ebp+a*8],eax
	 a=(a+1)
	ENDM


	;
	;O.k. now comes the first pass:
	;  Count all entries of the order list
	;
	push	edx				;Save NOP-Counter
@@L1: 	mov	ebx,ds:[esi+8*edx-4]		;Get average Z-coordinate
	rol	ebx,cl                          ;Fuddle out important bits
	and	ebx,(1 shl BYTE_SORT_SIZE)-1
	inc	dword ptr ss:[ebp+8*ebx]	;Increment app. counter
	dec	edx
	jnz	short @@L1


	;
	;Now we calculate all start-indices...
	; (in descending order !)
	;
	xor	eax,eax
	a=(1 shl BYTE_SORT_SIZE)-1
	REPT    (1 shl BYTE_SORT_SIZE)
	 mov	ss:[ebp+8*a+4],eax		;Save index...
	 add	eax,ss:[ebp+8*a]		;Get size of this sub-list
	 a=(a-1)
	ENDM

	;
	;Now we can fill in all lists
	;
	pop	edx				;Restore counter
@@L2:	mov	eax,ds:[esi+8*edx-4]		;Get average Z-coordiante
	shld	ebx,eax,cl			;Get list-number in EBX
	and	ebx,(1 shl BYTE_SORT_SIZE)-1
	inc	dword ptr ss:[ebp+8*ebx+4]    	;Inc index...
	mov	ebx,ss:[ebp+8*ebx+4]		;EBX-8 = New index
	mov	ds:[edi+8*ebx-4],eax		;Save Z-Coordinate
	mov	eax,ds:[esi+8*edx-8]	        ;Get primitive ptr
	mov	ds:[edi+8*ebx-8],eax		;Save it !

	dec	edx
	jnz	short @@L2


	add	cl,BYTE_SORT_SIZE
	cmp	cl,32
	jae	@@End

	xchg	edi,esi				;Change source/dst


	a=(1 shl BYTE_SORT_SIZE)-1
	REPT  (1 shl BYTE_SORT_SIZE)
	LOCAL J1,J2
	 mov	edx,ss:[ebp+8*a]		;Get size of sub-list
	 cmp	edx,1				;Is it zero ???
	 je	short J2                        ;JE: Only 1 element
	 jb	short J1			;JB: Empty sub-list !
	 push	edi
	 push	esi
	 push	ebp
	 call	Byte_Sort
	 pop	ebp
	 pop	esi
	 pop	edi
	 mov	edx,ss:[ebp+8*a]
	 lea	edi,[edi+8*edx]			;Address of next lists
	 lea	esi,[esi+8*edx]
	 jmp	short J1
J2:      movsd					;Just copy one entry !
	 movsd
J1:	 a=(a-1)
	ENDM


@@End:	add	esp,(1 shl BYTE_SORT_SIZE)*8
	retn
Byte_Sort ENDP


;
;
; Hugh again... The byte-sort algorithm is still too complex. Now I decided
; clever as I am, to rip some quick-sort code from the Borland C++ library.
; It was some work to get it work (C to ASM conversion can be tricky !), but
; now quick_sort is _VERY_ fast compared with bubble sort.
;
; Quicker_Sort:
;  Input:
;	ES  - DATA32 Selector
;	ESI - ptr to first element to sort
;	EDX - number of elements to sort
;  Output:
;	Sorted list
;  Destroys:
;	EAX,EBX,ECX,EDX,EDI,ESI,EBP
;
Quicker_Sort PROC NEAR
@@Tail:	cmp	edx,2			;Is number <= 2 ???
	jb	short @@End		;JB: Only 1 element !
	ja	short @@DoIt		;JA: More than 2 elements
		;
		;Need only to sort 2 elements !
		mov	eax,ds:[esi+4]
		cmp	eax,ds:[esi+12]
		jge	short @@End

		mov	ebx,ds:[esi]
		xchg	eax,ds:[esi+12]
		xchg	ebx,ds:[esi+8]
		mov	ds:[esi+4],eax
		mov	ds:[esi],ebx
	@@End:	retn

@@DoIt: ;
	;Need to sort more than 2 elements !
	;
	lea	edi,[esi+8*edx-8]	;EDI is rightP (last entry)
	mov	ebp,edx
	shr	ebp,1
	lea	ebp,[esi+8*ebp]		;EBP is leftP (middle entry)

	;
	;First something like "Median of three"
	;Registers are:
	;  	ESI	- 	pivotP
	;	EBP	-       leftP
	;	EDI	-	rightP
	;	EDX	-	Counter
	;
	mov	eax,ds:[ebp+4]		;EAX is left pleft-element
	cmp	eax,ds:[edi+4]		;Is *leftP > *rightP ???
	jge	short @@N1
		mov	ebx,ds:[ebp]
		xchg	eax,ds:[edi+4]	;Exchange *leftP and *rightP...
		xchg	ebx,ds:[edi]
		mov	ds:[ebp+4],eax
		mov	ds:[ebp],ebx
@@N1:	cmp	eax,ds:[esi+4]		;EAX still contains leftP
	jg 	short @@N2
		cmp	edx,3		;Only 3 elements to process ???
		je	short @@End	;JE ==> Ready !
		mov	ebx,ds:[ebp]
		xchg	eax,ds:[esi+4]	;Exchange leftP and pivotP
		xchg	ebx,ds:[esi]
		mov	ds:[ebp+4],eax
		mov	ds:[ebp],ebx
		jmp	short @@Hoare
@@N2:   mov	eax,ds:[esi+4]		;EAX = pivot
	cmp	eax,ds:[edi+4]		;Is *pivotP > *rightP ???
	jge	short @@N3
		mov	ebx,ds:[esi]
		xchg	eax,ds:[edi+4]	;Exchange pivot and pright
		xchg	ebx,ds:[edi]
		mov	ds:[esi+4],eax
		mov	ds:[esi],ebx
@@N3:	cmp	edx,3
	ja	short @@Hoare		;Are there only 3 elements ???
		mov	ebx,ds:[esi]
		xchg	eax,ds:[ebp+4]	;Exchange *leftP and *pivotP
		xchg	ebx,ds:[ebp]
		mov	ds:[esi+4],eax
		mov	ds:[esi],ebx
		retn

@@Hoare:
	;
	;Now lets start the classic Hoare-algorithm
	;
	;Registers are:
	;	ESI	-	pivotP
	;	EDI	-	rightP
	;	EBP	-       leftP
	;	EBX	-	pivotEnd
	;	EDX	-	Counter
	;
	;The order is:
	;       *leftP > *pivotP > *rightP
	;
	;The pointer order is:
	;	pivotP < leftP < rightP
	;
	lea	ebx,[esi+8]		;Initialize LeftP and pivotEnd
	mov	ebp,ebx
	;
	;Now the pointer order is:
	;	pivotP < leftP=pivotEnd=pivotP+1 < rightP
	;
	;The item order is:
	;	*pivotP > *rightP
	;but we cannot assume anything about *leftP
	;

	;
	;In the following loop, we look for the first item between
	;pivotP(first entry) and rightP(last entry) that is smaller than
	;*pivotP
	;
@@L1:   mov	eax,ds:[ebp+4]		;EAX=*leftP
	cmp	eax,ds:[esi+4]		;Is *leftP < *pivotP ?
	jl	short @@L2
	jne	short @@NEq
		;
		;The following thing happens when *leftP = *pivotP
		;Then we exchange the current thing with the entry just
		;behind the pivot-element (pivotEnd).
		mov	ecx,ds:[ebp]
		xchg	eax,ds:[ebx+4]	;Exchange *leftP and *pivotEnd
		xchg	ecx,ds:[ebx]
		mov	ds:[ebp+4],eax
		mov	ds:[ebp],ecx
		add	ebx,8		;pivotEnd += 8
@@NEq:  add     ebp,8			;leftP += 8
	cmp	ebp,edi			;Is leftP < rightP ???
	jbe	short @@L1
	sub	ebp,8                   ;Oha, there is no item between pivotP
	jmp	@@qBreak		;  and rightP that is smaller than
					;  pivotP

	;
	;Ok, we have just found an entry *leftP between pivotP and rightP
	;for which is true:
	;		*pivotP > *leftP
	;		pivotEnd< leftP < rightP
	;
	;Out goal is that all entries bigger/equal to *pivotP get to the left
	;end of the list and all entries smaller get to the right end of the
	;list.
	;
@@L2:	cmp	ebp,edi			;Is leftP < rightP ???
	jae	short @@EndL2		;JAE: No ==> Quit loop !
	mov	eax,ds:[esi+4]		;EAX=*pivotP
	cmp	eax,ds:[edi+4]		;Is *pivotP < *rightP ?
	jle	short @@J1
		sub	edi,8		;rightP-=8
		jmp	short @@L2
	@@J1:	mov	eax,ds:[edi+4]	;Exchange *leftP and *rightP
		mov	ecx,ds:[edi]
		xchg	eax,ds:[ebp+4]
		xchg	ecx,ds:[ebp]
		mov	ds:[edi+4],eax
		mov	ds:[edi],ecx

		je	short @@EndL2	;Jump if *pivotP = *rightP
		add     ebp,8           ;leftP += 8
		sub	edi,8		;rightP -= 8
@@EndL2:
	cmp	ebp,edi			;Is leftP < rightP ???
	jb	short @@L1


@@qBreak:
	mov	eax,ds:[ebp+4]		;EAX = *leftP
	cmp	eax,ds:[esi+4]		;Is *leftP < *pivotP ??
	jl	short @@J2
		add	ebp,8		;leftP += 8
@@J2:   ;
	;Now Regsiters will set to:
	;	ESI	- 	pivotP / pivotTemp
	;	EDI	-	leftTemp
	;	EBX	-	pivotEnd
	;	EBP	-	leftP
	;	EDX	-	Counter
	;
	lea	edi,[ebp-8]		;EDI = leftTemp
	push	esi			;Save pivotP

@@L3:	cmp	esi,ebx			;Is pivotTemp < pivotEnd ?
	jae	short @@EndL3
	cmp     edi,ebx
	jb	short @@EndL3
		mov	eax,ds:[edi+4]	;Exchange *pivotTemp and *leftTemp
		mov	ecx,ds:[edi]
		xchg	eax,ds:[esi+4]
		xchg	ecx,ds:[esi]
		mov	ds:[edi+4],eax
		mov	ds:[edi],ecx
		add	esi,8		;pivotTemp += 8
		sub	edi,8		;leftTemp -= 8
		jmp	short @@L3
@@EndL3:
	pop	esi			;ESI = pivotP
	mov	eax,ebp
	sub	eax,ebx
	shr	eax,3			;EAX = lnum = (leftP - pivotEnd) / 8
	lea	edx,[8*edx+esi]
	sub	edx,ebp
	shr	edx,3			;EDX = nElem = (nElem * 8 + pivotP - leftP) / 8

	push	eax			;Save lnum
	push	esi			;Save pivotP
	mov	esi,ebp			;ESI = leftP
	call	Quicker_Sort
	pop	esi
	pop	edx			;Restore nElem=lnum

	jmp	@@Tail
Quicker_Sort ENDP



;
;   GOMEZ VECTOR ENGINE                                 SPECIAL EFFECTS
;
;
;
; Here come some special F/X algorithms such like motion blurr, feed back
; etc....
;
;
; FX_Motion_Blurr:
;   Input:
;	EDI 	- src frame
;   Output:
;	Blurred frame
;   Destroys:
;	EAX,EBX,ECX,EDI
;
FX_Motion_Blurr PROC NEAR
	mov	ebx,OFFSET Blurr_Table
	mov 	ecx,DISPLAY_WIDTH*DISPLAY_HEIGHT/4

@@L6:	 	mov	eax,ds:[edi]
		xlatb
		rol	eax,8
		xlatb
		rol	eax,8
		xlatb
		rol	eax,8
		xlatb
		rol	eax,8
		stosd
		dec	ecx
		jnz	short @@L6
	retn
FX_Motion_Blurr ENDP
;
;
; Here come some special F/X algorithms such like motion blurr, feed back
; etc....
;
;
; FX_Feed_Back:
;   Input:
;	EDI 	- src frame
;   Output:
;	new frame
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
FX_Feed_Back PROC NEAR
	lea	esi,[edi+DISPLAY_WIDTH/8+DISPLAY_HEIGHT/8*DISPLAY_WIDTH]
	xor	ebx,ebx
	xor	ebp,ebp

	mov	edx,DISPLAY_HEIGHT/2
	@@L1:	push	esi

		mov	ecx,DISPLAY_WIDTH/4
	@@L2:	mov	bl,ds:[esi]
		mov	al,ds:[Blurr_Table+ebx]
		inc	esi

		mov	bl,ds:[esi]
		mov	ah,ds:[Blurr_Table+ebx]
		inc	esi
		rol	eax,16

		mov	bl,ds:[esi]
		mov	al,ds:[Blurr_Table+ebx]
		mov	ah,al
		inc	esi
		ror	eax,16
		stosd

		dec	ecx
		jnz	short @@L2

		pop	esi
		add	bp,0c000h	;Zoom factoor 3:4
		jnc	short @@1
		add	esi,DISPLAY_WIDTH
	@@1:	dec	edx
		jnz	short @@L1

	xor	ebp,ebp
	lea	edi,[edi+(DISPLAY_HEIGHT/2-1)*DISPLAY_WIDTH]
	lea	esi,[edi+DISPLAY_WIDTH/8-DISPLAY_HEIGHT/8*DISPLAY_WIDTH]
	mov	edx,DISPLAY_HEIGHT/2
	@@L9:	push	esi

		mov	ecx,DISPLAY_WIDTH/4
	@@LA:	mov	bl,ds:[esi]
		mov	al,ds:[Blurr_Table+ebx]
		inc	esi

		mov	bl,ds:[esi]
		mov	ah,ds:[Blurr_Table+ebx]
		inc	esi
		rol	eax,16

		mov	bl,ds:[esi]
		mov	al,ds:[Blurr_Table+ebx]
		mov	ah,al
		inc	esi
		ror	eax,16
		stosd

		dec	ecx
		jnz	short @@LA

		pop	esi
		add	bp,0c000h	;Zoom factoor 3:4
		jnc	short @@2
		sub	esi,DISPLAY_WIDTH
	@@2:    sub	edi,2*DISPLAY_WIDTH
		dec	edx
		jnz	short @@L9
	retn
FX_Feed_Back ENDP




;
;
;
;   GOMEZ VECTOR ENGINE                               USER FUNCTIONS
;
;
;
;
;
; Now follow the front-end routines (GVE_Transform_World,GVE_Draw_World)
; Only these needs to be called by the user.
; And first of all you must use GVE_Init_World to tell the engine where to
; find all datas needed. But you only need to call this once.
;
; The prefix GVE is derived from Gomez Vector Engine.
;
;
; The following profiling areas are defined:
;	0	-	Transformation
;	1	-	Sorting
;	2	-	Drawing
;	3	-	Postprocessing
;	4	- 	Culling / Visible Surface Determination
;	5	-	User #1
;	6	-	User #2
;	7	-	Vertex-Counter
;	8	-	Face-Counter
;
;
;   GOMEZ VECTOR ENGINE                      INITIIALISATION FUNCTIONS
;
PUBLIC C Init_GVE
Init_GVE PROC NEAR
	cld
	push	ds
	push	es
	push	edi
	push	esi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	;
	test	ds:[GOMEZ_System],7 shl 11	;Test for FPU
	stc					;Carry for error
	jz	@@Err				;No FPU ==> Error
	;
	finit
	xor	ecx,ecx
	mov	edi,OFFSET SinTab
	fild	ds:[@cossize]			;ST(2) = Cossize
	fild	ds:[@shiftsize]			;ST(1) = 16
@@L1:	push	ecx
	fldpi					;ST(0) = pi
	fimul	dword ptr ss:[esp]		;ST(0) = ECX*pi
	fdiv	st(0),st(2)			;ST(0) = ECX*pi / Table_Size
	fsin                            	;ST(0) = sin
	fscale					;ST(0) <<= ST(1)
	fistp	dword ptr ss:[esp]
	pop	eax
	stosd
	inc	ecx
	cmp	ecx,(GVE_COSINE_SIZE*5)/4
	jb	short @@L1
	ffree	st(1)
	ffree	st(0)
	;
	mov	ecx,64000
	call	Malloc
	mov	ds:[GVE_Order_List],eax
	;
	xor	edi,edi
	mov	ebx,1
@@L3:	xor	ebp,ebp
@@L2:   movsx	ecx,ds:[Phong_Translation_Table+2*ebp]
	shl	ecx,10				;Make 20 bit FPA

	mov	eax,100000h			;EAX = base
	mov	bh,bl				;BH = Exponent
	@@EXP:  imul	ecx			;EAX *= ECX (Phong_Table)
		shrd	eax,edx,20
		dec	bh
		jnz	short @@EXP
	sar	eax,14
	mov	ds:[Phong_Texture_Table+edi],al
	sar	eax,1
	sub	al,16
	mov	ds:[Phong_Table+edi],al
	inc	edi

	inc	ebp
	cmp	ebp,256
	jl	short @@L2			;Next base

	inc	bl				;Next exponent
	cmp	bl,GVE_PHONG_MAX_EXP
	jbe	short @@L3
	;
	ifdef GVE_PROFILER
	 mov	eax,0
	 mov	ebx,OFFSET Timer_Handler
	 call	Set_Flat_IRQ
	 mov	eax,0
;	 call	Link_Real_IRQ
	 mov	ds:[TIMER_Int],ebx
	 mov 	al,36h
	 out 	43h,al
	 mov 	al,02ah
	 out 	40h,al
	 mov 	al,1
	 out 	40h,al                      	;Set timer speed (4000 Hz)

	 ;
	 ;Set minimal counts of #vertices and #faces
	 mov	eax,0fffffffh
	 mov	ds:[PROFILING_DATA+7*16+4],eax
	 mov	ds:[PROFILING_DATA+8*16+4],eax
	endif
	;
	clc
@@Err:	pop	ebp
	pop	esi
	pop	edi
	pop	es
	pop	ds
	retn

@cossize	dd	GVE_COSINE_SIZE/2
@shiftsize	dd	GVE_MATRIX_SHIFT
Init_GVE ENDP




PUBLIC C Exit_GVE
Exit_GVE PROC NEAR
	push	ds
	push	es
	mov	ds,cs:[DATA32_Selector]

	Free_and_Zero	ds:[GVE_Order_List]
	ifdef GVE_PROFILER
	 mov 	ax,36h 	; PIT channel 0, square wave,binary, send LSB & MSB
	 out 	43h,al 	; send command
	 mov 	al,0
	 out 	40h,al 	; maximum timer count (freq. = 18.2 Hz)
	 out 	40h,al 	;

	 call 	Print_Profiler
	endif

	clc
	pop	es
	pop	ds
	retn
Exit_GVE ENDP



;
;   GOMEZ VECTOR ENGINE               DRAWING/TRANSFORMATION FUNCTIONS
;
;
;
; GVE_Move_Camera
;  Input:
;	Nothing
;  Output:
;	GVE_Camera_Matrix
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Move_Camera
GVE_Move_Camera PROC NEAR
	cld
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ebp,ds:[GVE_Viewport]
	mov	eax,ds:[ebp+12]
	mov	ebx,ds:[ebp+16]
	mov	ecx,ds:[ebp+20]
	mov	edx,ds:[ebp]
	mov	esi,ds:[ebp+4]
	mov	edi,ds:[ebp+8]
	neg	eax
	neg	ebx
	neg	ecx
	neg	edx
	neg	esi
	neg	edi

	mov	ebp,OFFSET GVE_Camera_Matrix
	call	Build_Matrix

	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Move_Camera ENDP



;
;
; GVE_Move_Object
;  Input:
;	EDX	- Object number
;  Output:
;      Matrix within object
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Move_Object
GVE_Move_Object PROC NEAR
	cld
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ebp,ds:[GVE_Object_List]
	mov	ebp,ds:[ebp+4*edx+4]		;EBP = ptr to object header
	mov	eax,ds:[ebp+Object_Position+12]
	mov	ebx,ds:[ebp+Object_Position+16]
	mov	ecx,ds:[ebp+Object_Position+20]
	mov	edx,ds:[ebp+Object_Position]
	mov	esi,ds:[ebp+Object_Position+4]
	mov	edi,ds:[ebp+Object_Position+8]
	lea	ebp,[ebp+Object_Local_Matrix]
	call	Build_Matrix

	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Move_Object ENDP



;
;
; GVE_Move_Light
;  Input:
;	Nothing
;  Output:
;	GVE_Light_Matrix
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Move_Light
GVE_Move_Light PROC NEAR
	cld
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ebp,ds:[GVE_Light_Source]
	mov	eax,ds:[ebp+12]
	mov	ebx,ds:[ebp+16]
	mov	ecx,ds:[ebp+20]
	mov	edx,ds:[ebp]
	mov	esi,ds:[ebp+4]
	mov	edi,ds:[ebp+8]
	mov	ebp,OFFSET GVE_Light_Matrix
	call	Build_Matrix

	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Move_Light ENDP




;
;
; GVE_Set_Camera
;  Input:
;	EAX	- Distance
;  Output:
;	GVE_Camera
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Set_Camera
GVE_Set_Camera PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov	ds:[Y_Distance],eax
	shl	eax,16
	mov	ds:[X_Distance],eax

	clc
	pop	ds
	retn
GVE_Set_Camera ENDP




;
;
; GVE_Transform_World
;  Input:
;	GVE_???_List
;  Output:
;	Transformed vectors
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Transform_World
GVE_Transform_World PROC NEAR
	clc
	retn
GVE_Transform_World ENDP





;
;
; GVE_Draw_World:
;   Input:
;	EDX   	- ptr to frame-buffer
;   Output:
;	refreshed frame-buffer
;   Destroys:
;	EAX,EBX,ECX,EDX,ES
;
PUBLIC C GVE_Draw_World
GVE_Draw_World PROC NEAR
	push 	ds
	push	es
	push	esi
	push	edi
	push	ebp


	cld
	mov 	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebx,ds:[GVE_ORder_List]
	xor	eax,eax
	mov	ds:[GVE_Frame_Buffer],edx
	mov	ds:[ebx],eax			;Clear order list
	mov	ds:[@@VCount],eax

	;
	;
	; First lets preprocess the old screen with blurring etc... if
	; desired, or lets simply clear the buffer
	;
	;
	test	ds:[GVE_Flags],GVE_CLEAR_FRAME
	jz	short @@J2
	mov 	edi,ds:[GVE_Frame_Buffer]
	mov 	ecx,DISPLAY_WIDTH*DISPLAY_HEIGHT/4
	xor 	eax,eax
	rep     stosd
	jmp	@@DoGVE

@@J2:	test	ds:[GVE_Flags],GVE_MOTION_BLURR
	jz	@@J3
	mov 	edi,ds:[GVE_Frame_Buffer]
	call	FX_Motion_Blurr
	jmp	@@DoGVE

@@J3:	test	ds:[GVE_Flags],GVE_FEED_BACK
	jz	@@DoGVE
	mov 	edi,ds:[GVE_Frame_Buffer]
	call	FX_Feed_Back



@@DoGVE:;
	;
	; Now lets get the global light vector from GVE_Light_Matrix
	;
	mov	eax,ds:[GVE_Light_Matrix.E11]
	mov	ebx,ds:[GVE_Light_Matrix.E21]
	mov	ecx,ds:[GVE_Light_Matrix.E31]
	sar	eax,GVE_MATRIX_SHIFT-GVE_MATH_SHIFT
	sar	ebx,GVE_MATRIX_SHIFT-GVE_MATH_SHIFT
	sar	ecx,GVE_MATRIX_SHIFT-GVE_MATH_SHIFT
	mov	ds:[Current_Light.E1],eax
	mov	ds:[Current_Light.E2],ebx
	mov	ds:[Current_Light.E3],ecx


	;
	;
	; Main object loop starts here. We do four things with all objects:
	;	1.  Build final object transformation matrix
	;	    calc local viewer position
	;	    calc local viewer direction
	;	2.  Generate local light vector
	;	3.  Perform backface culling,
	;	    write face-ptr into sort-list
	;	4.  Transform vertices, if needed
	;
	mov	esi,ds:[GVE_Object_List]
	mov	eax,ds:[esi]			;EAX = object-counter
	add	esi,4				;Skip header
	test	eax,eax
	jz      @@NoDraw
	mov	ds:[Object_Counter],eax		;Save it here
@@L1:	push	esi				;ESI = index in object-list
	mov	esi,ds:[esi]			;ESI = ptr to object header
	mov	ch,3				;CH = Row counter for matmul
	push	esi				;Save this ptr, too
	lea	ebp,[esi+Object_Local_Matrix]
	lea	edi,[esi+Object_Final_Matrix]
	mov	esi,OFFSET GVE_Camera_Matrix
	call	Mult_Matrix       	      	;DS:EDI = A*B

	;
	;
	; Transformation of vertices
	;
@@Form:	PROF_START_AREA 0
	mov	esi,ss:[esp]			;ESI = ptr to object header
	lea	edi,[esi+Object_FInal_Matrix]	;EDI = ptr to transformation matrix
	mov	esi,ds:[esi+Object_Vertex_List]	;ESI = ptr to vertex list
	test	esi,esi
	jz	@@NObj
	mov	eax,ds:[esi]			;EAX = vertex counter
	add	esi,4
	test	eax,eax
	jz	@@NObj
	add	ds:[@@VCount],0			;Increment vertex counter
	mov	ds:[Vertex_Counter],eax


	@@L5:   ;
		;
		; The main transformation loop starts here:
		;
		;   1.  Transformation of vertex
		;   2.  Transformation of normal   (optional)
		;   3.  Vertex shading   (optional)
		;   4.  Projection
		;
		MULT_VECTOR edi,esi+VertexX,esi+V21,MV_MULT_4x4

		test	ds:[GVE_FLAGS],GVE_TRANSFORM_NORMALS
		jz	@@J8
		MULT_VECTOR edi,esi+NormalX,esi+N21,MV_MULT_3x3


		;
		;
		; Project of the 3D view-space coordinates to 2D screen space.
		; Note the following thing:
		;
		;	PX is stored as a 32.0 bit integer with the
		;         lowest bit used as a flag whether transformation
		;         is necessary for this vertex
		;      PY is stored as an 32.0 integer
		;
	@@J8:	mov     ebx,ds:[esi+V23]	;EBX = Z
		mov 	eax,ds:[esi+V21]	;EAX = X
		cmp	ebx,1 shl (GVE_DISTANCE-1)	;Compare if negativ etc...
		jl	short @@Next
		imul	ds:[X_Distance]		;EAX = X*Distance
		idiv 	ebx			;EAX = (X * Distance) / (Z+Distance)
		add	eax,(DISPLAY_Width/2)
		mov	ds:[esi+PX],eax		;Save projected X

		mov 	eax,ds:[esi+V22]
		imul	ds:[Y_Distance]
		idiv 	ebx
		add	eax,DISPLAY_Height/2
		mov	ds:[esi+PY],eax		;Save projected Y
		inc	ds:[@@VCount]

	@@Next: add 	esi,GVE_VERTEX_SIZE	;Go to the next vector...
		dec 	ds:[Vertex_Counter]
		jnz 	@@L5
	PROF_END_AREA 0


	;
	;
	; Here we perform a second visible surface determination
	;
	PROF_START_AREA 4
	mov	esi,ss:[esp]			;ESI = ptr to object-header
	mov	al,72h				;JB opcode
	test	ds:[GVE_Flags],GVE_BACK_CULLING
	jnz	short @@J7
	mov	al,0ebh				;JMP opcode
@@J7:   mov	byte ptr ds:[@@C7-2],al		;Save opcode
	;
	mov	esi,ds:[esi+Object_Face_List]	;ESI = ptr to primitives
	mov	edi,ds:[GVE_Order_List]		;EDI = ptr to draw-list
	test	esi,esi
	jz	@@NObj
	mov	eax,ds:[esi]			;EAX = number of primitives
	mov	ebx,ds:[edi]			;EBX = current size of order-list
	test	eax,eax
	jz	@@NObj
	mov	ds:[Face_Counter],eax
	add	esi,4				;Skip primitive counter
	lea	edi,[edi+4+8*ebx]		;EDI = ptr to first new entry
	@@L3:   ;                              
		cmp 	byte ptr ds:[esi+3],3	;Get number of vertices
		jb	short @@NRm
	@@C7:	TEST_BACK_CULLING		;Test for back-culling
		js	@@NAd			;JS: Face is not visible
	@@Nrm:	movzx 	ebx,byte ptr ds:[esi+3]	;EBX = number of vectors
		xor	eax,eax			;EAX=Z-coordinate
		mov	edx,ebx			;EDX = Number of vertices
		@@L4:	mov	ebp,ds:[esi+24+4*edx-4]
			add	eax,ds:[ebp+V23]
			dec	edx
			jnz	short @@L4

		cdq
		idiv	ebx			;Average Z-coordinates
		cmp	eax,(1 shl (GVE_DISTANCE-1))-(1 shl (GVE_MATH_SHIFT+GVE_DISTANCE))
		jng	short @@NAd
		mov	ds:[edi],esi		;Save Object address
		mov	ds:[edi+4],eax		;Save average z-Coordinate
		add	edi,8			;Next object...
		;                              
	@@NAd:	movzx	eax,word ptr ds:[esi]	;Get size of primitive
		add	esi,eax			;Add to source-address
		dec	ds:[Face_Counter]
		jnz	@@L3
	;
	mov	ebp,ds:[GVE_Order_List]
	sub	edi,ebp				;EDI = size of order list
	sub	edi,4
	shr	edi,3                   	;EDI = Number of entries in sort-list
	mov	ds:[ebp],edi			;Save number of saved objects...
	PROF_END_AREA 4
	;
@@NObj: pop	eax				;EAX = ptr to object-header (trash)
	pop	esi				;ESI = object-list index
	add	esi,4
	dec	ds:[Object_Counter]
	jnz	@@L1



@@DoSort:
	;
	;
	; Sorting all triangles for painters algorithm
	;
	;
	mov	ebp,ds:[GVE_Order_List]	;EBP = ptr to order-list
	mov	ecx,ds:[@@VCount]	;ECX = number of transformed vertices
	mov	edx,ds:[ebp]		;EDX = number of faces
	PROF_SET_COUNTER 7,ecx
	PROF_SET_COUNTER 8,edx
	test	edx,edx			;Nothing to do ?
	jz	@@NoDraw
	test	ds:[GVE_Flags],GVE_SUPPRESS_SORTING
	jnz	short @@NoSort
	PROF_START_AREA	1
	lea	esi,[ebp+4]		;ESI points to first entry
;	lea	edi,[ebp+32000]		;EDI points to destination
;	mov	ecx,BYTE_SORT_SIZE
	call	Quicker_Sort            ;Sort list !
	PROF_END_AREA 1



@@NoSort:
	;
	;
	; The main drawing loop which draws simply the odrered list.
	; Method used is to draw from back to front.
	;
	;
	PROF_START_AREA 2
	mov 	ebp,ds:[GVE_Order_List]
	mov	eax,ds:[ebp]		;Get number of primitives
	mov 	ds:[Face_Counter],eax
	add	ebp,4			;Skip counter
@@L6:   mov 	esi,ds:[ebp]		;ESI = primitive pointer
	xor	eax,eax			;EAX = Zero
	add	ebp,8			;EBP = ptr to next entry
	mov 	al,byte ptr ds:[esi+2]	;EAX = primitive type
	call	dword ptr ds:[GVE_Method_Table+eax]
	dec 	ds:[Face_Counter]
	jnz	short @@L6
	PROF_END_AREA 2



@@NoDraw:
	;
	;
	; Last but not least, zthe GVE supports some sort of postprocessing
	; like softening etc. This is done here:
	;
	;
	PROF_START_AREA 3
	cld
	test	ds:[GVE_Flags],GVE_SOFTEN_HORIZONTAL
	jz	@@SoftV
		mov	edi,ds:[GVE_Frame_Buffer]
		mov	esi,ds:[GVE_Glass_LUT]
		mov	ebp,DISPLAY_HEIGHT
		xor	eax,eax
	@@L7:   REPT DISPLAY_WIDTH
		  mov	ah,[edi]	;;Get next pixel
		  mov	al,[esi+eax]	;;AL=Soften
		  stosb
		ENDM
		dec	ebp
		jnz	@@L7

@@SoftV:test	ds:[GVE_Flags],GVE_SOFTEN_VERTICAL
	jz	@@NoSoften
		mov	edi,ds:[GVE_Frame_Buffer]
		add	edi,DISPLAY_WIDTH
		mov	ebx,ds:[GVE_Glass_LUT]
		mov	ebp,DISPLAY_HEIGHT-1
		xor	eax,eax
	@@L8:	REPT DISPLAY_WIDTH
		 mov	al,[edi-DISPLAY_WIDTH]
		 mov	ah,[edi]	;;Get next pixel
		 mov	al,[ebx+eax]	;;AL=Soften
		 stosb
		ENDM
		dec	ebp
		jnz	@@L8
@@NoSoften:
	PROF_END_AREA 3

	;
	;
	; Finally, the end !
	;
@@End:  clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop 	ds
	retn
	;
@@VCount	dd	?
GVE_Draw_World ENDP



;
;
; GVE_Init_World:
;   This routine is designed to initialise lots of things in a just loaded
;   vector world.
;
; Input:
;   EAX	- ptr to header
; Output:
;   GVE_???
; Destroys:
;   EAX,EBX,ECX,EDX,FS,GS
;
PUBLIC C GVE_Init_World
GVE_Init_World PROC NEAR
	push	ds
	push	es
	push 	ebp
	push 	esi
	push 	edi

	cld

	;
	;
	; First lets grab all variables...
	;
	mov	es,cs:[DATA32_Selector]
	mov	ds,cs:[DATA32_Selector]
	mov	edx,ds:[eax+ObjectList]
	mov	ds:[GVE_Object_List],edx
	mov	edx,ds:[eax+PhongList]
	mov	ds:[GVE_PhongMap_List],edx
	mov	edx,ds:[eax+TextureList]
	mov	ds:[GVE_Texture_List],edx
	mov	edx,ds:[eax+Palette]
	mov	ds:[GVE_Palette],edx
	mov	edx,ds:[eax+ShadingLUT]
	mov	ds:[GVE_Shading_LUT],edx
	mov	edx,ds:[eax+BumpLUT]
	mov	ds:[GVE_Bump_LUT],edx
	mov	edx,ds:[eax+Flags]
	mov	ds:[GVE_Flags],edx
	mov	edx,ds:[eax+LightSource]
	mov	ds:[GVE_Light_Source],edx
	mov	edx,ds:[eax+ViewPort]
	mov	ds:[GVE_ViewPort],edx
	mov	edx,ds:[eax+GlassLUT]
	mov	ds:[GVE_Glass_LUT],edx
	mov	edx,ds:[eax+ScriptDirectory]
	mov	ds:[GVE_Script_Directory],edx

	call	GVE_Move_Light                  ;Init light matrix
	call	GVE_Move_Camera			;Init camera matrix
	mov	eax,ds:[GVE_Object_List]	;EAX = ptr to obj-list
	test	eax,eax
	jz	short @@1
	mov	ebp,ds:[eax]			;EBP = number of objects
	dec	ebp
	js	short @@1
	@@L1:	mov	edx,ebp			;EDX = object number
		call	GVE_Move_Object		;Init object matrices
		dec	ebp
		jns	short @@L1		;Loop !

	;
	;
	; Initialisation of blurr-table. This table is VERY similar to
	; the shdaing table, but there are some (little) differences
	;
@@1:	mov	esi,ds:[GVE_Palette]
	test	esi,esi
	jz	@@2
	mov	edi,esi
	xor	ebp,ebp
	xor	ebx,ebx
	mov	ch,GVE_BLURR_FACTOR
	@@L7:	mov	al,ds:[edi]
		imul	ch
		shr	ax,6
		mov	dl,al

		mov	al,ds:[edi+1]
		imul	ch
		shr	ax,6
		mov	dh,al

		ror	edx,8
		mov	al,ds:[edi+2]
		imul	ch
		shr	ax,6
		mov	dh,al
		rol	edx,8

		FIT_COLOUR
		shr	ebx,8
		cmp	ebp,ebx
		jne	short @@J4
		xor	bl,bl
	@@J4:   mov	ds:[Blurr_Table+ebp],bl

		add	edi,3
		inc	ebp
		cmp	ebp,256
		jb	@@L7

@@2:	clc
	pop 	edi
	pop 	esi
	pop 	ebp
	pop	es
	pop	ds
	retn
GVE_Init_World ENDP


;
;
;
;   GOMEZ VECTOR ENGINE                              PROFILING SYSTEM
;
;
;
;
;
; This is a simple timer-counter used for the profiling option
;
; The profiling data is structured like this:
;	dword	-	Number of calls
;	dword	-	Total time called
;	dword	-	Longest call
;	dword	-	Current start-time
;
ifdef GVE_PROFILER
 PROFILING_DATA	dd 9*4 dup (0)
 Timer_INT	dd ?


 Timer_Handler PROC NEAR
	push	ds
	push	eax
	cli
	mov	ds,cs:[DATA32_Selector]
	inc	ds:[GVE_Timer]
	mov	al,20h
	out	20h,al		;Send EOI to PIC
	pop	eax
	pop	ds
	iretd
 Timer_Handler ENDP


 Print_Profiler PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[LIN_Selector]

	cld
	mov	edi,0b8000h	 	;ES:EDI points to video RAM
	mov	esi,OFFSET PROFILER_LOGO
	mov	ecx,80*22/2
	rep	movsd

	mov	edi,9*160+44
	mov	esi,OFFSET PROFILING_DATA
	mov	ecx,7
 @@L1:	push	ecx
	push	edi
	mov	edx,ds:[esi]		;Get number of calls
	test	edx,edx
	jz	@@No
	call	PrintHex32
	mov	edx,ds:[esi+4]
	shl	edx,4
	add	edi,13*2
	call	PrintHex32
	mov	edx,ds:[esi+8]
	shl	edx,4
	add	edi,14*2
	call	PrintHex32
	mov	eax,ds:[esi+4]
	xor	edx,edx
	shld	edx,eax,4
	shl	eax,4
	div	dword ptr ds:[esi]
	mov	edx,eax
	add	edi,15*2
	call	PrintHex32

 @@No:	pop	edi
	pop	ecx
	add	edi,160
	add	esi,16
	dec	ecx
	jnz	short @@L1


	mov	edi,18*160+44
	mov	edx,ds:[PROFILING_DATA+16*7+4]	;Min
	call	PrintHex32
	mov	edx,ds:[PROFILING_DATA+16*7+8]	;Max
	add	edi,12*2
	call	PrintHex32
	mov	eax,ds:[PROFILING_DATA+16*7+12]	;Total
	xor	edx,edx
	div	dword ptr ds:[PROFILING_DATA+16*7]
	mov	edx,eax
	add	edi,13*2
	call	PrintHex32
	mov	edi,19*160+44
	mov	edx,ds:[PROFILING_DATA+16*8+4]	;Min
	call	PrintHex32
	mov	edx,ds:[PROFILING_DATA+16*8+8]	;Max
	add	edi,12*2
	call	PrintHex32
	mov	eax,ds:[PROFILING_DATA+16*8+12]	;Total
	xor	edx,edx
	div	dword ptr ds:[PROFILING_DATA+16*8]
	mov	edx,eax
	add	edi,13*2
	call	PrintHex32

	mov 	ds:[v86_ah],2
	mov	ds:[v86_bh],0
	mov	ds:[v86_dx],1701h
	mov	eax,10h
	call	Invoke_Real_Int		;Set cursor

	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
 Print_Profiler ENDP


 PrintHex32 PROC NEAR
	push	edi
	push	esi

	cld
	add	edi,0b8000h
	mov	ah,30

	mov	cl,8		;Display 8 digits
 @@L1:  rol	edx,4
	mov	al,dl
	and	al,0fh
	add	al,'0'
	cmp	al,'9'
	jbe	short @@1
	add	al,'A'-'9'-1

 @@1:	stosw
	dec	cl
	jnz	short @@L1

	mov	al,'h'
	stosw

 @@E:	pop	esi
	pop	edi
	retn
 PrintHex32 ENDP
endif

CODE32 ends
END