;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
GVE_SYSTEM_FILE		equ	1



;
;
;
;   GOMEZ VECTOR ENGINE                                            v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gve32.inc
include gomez.inc
include gvelist.inc


extrn C GVE_Alloc_Object:near
extrn C GVE_Free_Object:near



;
;
;
;   GOMEZ VECTOR ENGINE                                       MESH-ROUTINES
;
;
;
;
;
; GVE_Alloc_Mesh
;  Alloctaes a mesh
;  Input:
;  	EAX	- DATA32 ptr to world-header
;	EBX	- Width of mesh (in vertices)
;	ECX	- Height of mesh (in vertices)
;	EDX	- Grid-size (in space units)
;  Output:
;	EAX	- DATA32 ptr to Allocted object-header
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Alloc_Mesh
GVE_Alloc_Mesh PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,cs:[DATA32_Selector]
	mov	ebp,eax			;EBP = World-header
	mov	ds:[@@wid],ebx
	mov	ds:[@@hei],ecx
	mov	ds:[@@siz],edx
	call	GVE_Alloc_Object
	jc	@@Err
	mov	ebp,eax			;EBP = Object-header
	;
	mov	eax,ds:[@@wid]
	mov	ebx,ds:[@@hei]
	mov	ds:[ebp+Object_Flags],GVE_OBJ_MESH or GVE_OBJ_VERTEX_ADDRESS or GVE_OBJ_VERTEX_SHADING
	mov	ds:[ebp+Object_Mesh_Width],eax
	mov	ds:[ebp+Object_Mesh_Height],ebx

	lea	edi,[ebp+Object_Name]
	mov	esi,OFFSET @@txt
	mov	ecx,32/4
	rep	movsd
	;
	mov	ecx,ds:[@@wid]
	imul	ecx,ds:[@@hei]
	imul	ecx,GVE_VERTEX_SIZE
	add	ecx,4
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+Object_Vertex_List],eax

	mov	eax,ds:[@@hei]
	mov	ecx,ds:[@@wid]
	dec	ecx
	dec	eax
	imul	ecx,eax
	imul	ecx,2*GVE_TRIANGLE_SIZE
	add	ecx,4
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+Object_Face_List],eax
	;
	mov	eax,10000h
	xor	edx,edx
	idiv	ds:[@@hei]
	mov	ds:[@@vadd],eax

	mov	eax,10000h
	xor	edx,edx
	idiv	ds:[@@wid]
	mov	ds:[@@uadd],eax
	;
	mov	edi,ds:[ebp+Object_Vertex_List]
	mov	eax,ds:[@@wid]
	imul	eax,ds:[@@hei]		;EAX = Number of vertices
	mov	ds:[edi],eax
	add	edi,4

	mov	ebx,ds:[@@hei]
	mov	ds:[@@vcnt],ebx
	imul	ebx,ds:[@@siz]
	sar	ebx,1			;EBX = vertical start coordinate
	neg	ebx
	xor	ecx,ecx
	xor	edx,edx			;ECX:EDX = texture-coordinate

@@L1: 	mov	eax,ds:[@@wid]		;EAX = horizontal counter
	xor	ecx,ecx
	mov	ds:[@@hcnt],eax
	imul	eax,ds:[@@siz]
	sar	eax,1			;EAX = horizontal start coordinate
	neg	eax
	@@L2:	mov	ds:[edi+VertexX],eax
		mov	ds:[edi+VertexY],ebx
		mov	ds:[edi+VertexZ],0
		mov	ds:[edi+Vertex_TextureU],ecx
		mov	ds:[edi+Vertex_TextureV],edx

		add	eax,ds:[@@siz]
		add	ecx,ds:[@@uadd]
		add	edi,GVE_VERTEX_SIZE
		dec	ds:[@@hcnt]
		jnz	short @@L2
	add	ebx,ds:[@@siz]
	add	edx,ds:[@@vadd]
	dec	ds:[@@vcnt]
	jnz	short @@L1
	;
	mov	edi,ds:[ebp+Object_Face_List]
	mov	esi,ds:[ebp+Object_Vertex_List]
	mov	eax,ds:[@@wid]
	mov	ebx,ds:[@@hei]
	mov	edx,eax			;EDX = Width
	dec	eax
	dec	ebx			;EBX = Height-1
	mov	ecx,eax			;ECX = Width-1
	imul	eax,ebx			;EAX = Number of triangles
	shl	eax,1
	mov	ds:[edi],eax
	imul	edx,GVE_VERTEX_SIZE	;EDX = Size of one line
	add	edi,4			;EDI = Ptr to first triangle
	add	esi,4			;ESI = First vertex

@@L3:   push	ecx
	@@L4:   mov	d ds:[edi+Triangle_Size],03080024h
		mov	d ds:[edi+Triangle_Bump],00100800h
		mov	d ds:[edi+Triangle_Vertex1],esi
		lea	eax,[esi+edx+GVE_VERTEX_SIZE]
		mov	d ds:[edi+Triangle_Vertex2],eax
		lea	eax,[esi+GVE_VERTEX_SIZE]
		mov	d ds:[edi+Triangle_Vertex3],eax
		add	edi,GVE_TRIANGLE_SIZE

		mov	d ds:[edi+Triangle_Size],03080024h
		mov	d ds:[edi+Triangle_Colour],00100800h
		mov	d ds:[edi+Triangle_Vertex1],esi
		lea	eax,[esi+edx]
		mov	d ds:[edi+Triangle_Vertex2],eax
		lea	eax,[esi+edx+GVE_VERTEX_SIZE]
		mov	d ds:[edi+Triangle_Vertex3],eax
		add	edi,GVE_TRIANGLE_SIZE

		add	esi,GVE_VERTEX_SIZE
		dec	ecx
		jnz	short @@L4

	pop	ecx
	add	esi,GVE_VERTEX_SIZE
	dec	ebx
	jnz	short @@L3
	mov	eax,ebp			;EAX = DATA32 ptr to allocated object
	;
	clc
@@Err:  pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

ALIGN	dword
@@wid	dd	?
@@hei	dd	?
@@siz	dd	?
@@txt	db	"Polygon-Mesh",0
@@hcnt	dd	?
@@vcnt	dd	?
@@uadd	dd	?
@@vadd	dd	?
GVE_Alloc_Mesh ENDP



;
;
; GVE_Free_Mesh
;  Input:
;	EAX	- DATA32 ptr to world-header
;      EDX	- DATA32 ptr to object header
;  Output:
;	CF	- Error-Flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Free_Mesh
GVE_Free_Mesh PROC NEAR
	jmp	GVE_Free_Object
GVE_Free_Mesh ENDP



;
;
; GVE_Init_Mesh
;   Initialises the normals and related stuff of a mesh. The result is
;   slightly different from GVE_INit_Normals, but a lot faster.
;  Input:
;	EAX	- DATA32 ptr to world-header
;      EDX	- DATA32 ptr to object header
;  Output:
;	CF	- Error-Flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Init_Mesh
GVE_Init_Mesh PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	eax,ds:[eax+World_Object_List]
	call	Find_List_Entry
	jc	@@End
	mov	edi,ds:[edx]			;EDI = ptr to object-header
	mov	esi,ds:[edi+Object_Face_List]	;ESI = ptr to face-list
	mov	ebp,ds:[edi+Object_Vertex_List]	;EBP = ptr to vertex-list
	;
	push	ebp				;Save vertex-list ptr
	mov	ebp,ds:[esi]			;EBP = Number of primitives
	add	esi,4				;Skip counter
@@L5:   movzx 	ecx,byte ptr ds:[esi+3]		;Get number of vectors
	;
	push	ebp
	mov 	ebx,ds:[esi+Triangle_Vertex1] 	;Get vector address of vector 1
	mov	ecx,ds:[esi+Triangle_Vertex2]	;Get vector address #2
	mov	ebp,ds:[esi+Triangle_Vertex3]	;Get vector address #3
	;
	;
	;First we have to get the differences between the vectors:
	;The differences will be saved in vectors #1 and #2 !
	;This is difference #1-#2
	mov	eax,ds:[ebx+VertexX]
	sub	eax,ds:[ecx+VertexX]
	mov	ds:[ebx+Vertex@X],eax		;Save new X1
	mov	eax,ds:[ebx+VertexY]
	sub	eax,ds:[ecx+VertexY]
	mov	ds:[ebx+Vertex@Y],eax		;Save new Y1
	mov	eax,ds:[ebx+VertexZ]
	sub	eax,ds:[ecx+VertexZ]
	mov	ds:[ebx+Vertex@Z],eax		;Save new Z1

	;This is difference #3-#2
	mov	eax,ds:[ebp+VertexX]
	sub	eax,ds:[ecx+VertexX]
	mov	ds:[ecx+Vertex@X],eax		;Save new X2
	mov	eax,ds:[ebp+VertexY]
	sub	eax,ds:[ecx+VertexY]
	mov	ds:[ecx+Vertex@Y],eax		;Save new Y2
	mov	eax,ds:[ebp+VertexZ]
	sub	eax,ds:[ecx+VertexZ]
	mov	ds:[ecx+Vertex@Z],eax		;Save new Z2

	;
	;
	;Now lets calculate the normal vector via cross-product
	;                     
	;       a2*b3 - a3*b2 
	; AxB:= a3*b1 - a1*b3 
	;       a1*b2 - a2*b1 
	;                     
	fwait
	fild	dword ptr ds:[ebx+Vertex@Z]	;ST(0) = a3
	fimul	dword ptr ds:[ecx+Vertex@Y]	;ST(0) = a3*b2
	fild	dword ptr ds:[ebx+Vertex@Y]	;ST(0) = a2     ST(1) = a3*b2
	fimul	dword ptr ds:[ecx+Vertex@Z]	;ST(0) = a2*b3  ST(1) = a3*b2
	fsub	st(0),st(1)			;ST(0) = a2*b3 - a3*b2
	ffree	st(1)

	fild	dword ptr ds:[ebx+Vertex@X]
	fimul	dword ptr ds:[ecx+Vertex@Z]	;ST(0) = a1*b3
	fild	dword ptr ds:[ebx+Vertex@Z]
	fimul	dword ptr ds:[ecx+Vertex@X]	;ST(0) = a3*b1  ST(1) = a1*b3
	fsub	st(0),st(1)			;ST(0) = a3*b1 - a1*b3
	fstp	st(1)				;  ST(0) = Normal_Y
						;  ST(1) = Normal_X
	fild	dword ptr ds:[ebx+Vertex@Y]
	fimul	dword ptr ds:[ecx+Vertex@X]	;ST(0) = a2*b1
	fild	dword ptr ds:[ebx+Vertex@X]
	fimul	dword ptr ds:[ecx+Vertex@Y]	;ST(0) = a1*b2  ST(1) = a2*b1
	fsub	st(0),st(1)			;ST(0) = a1*b2 - a2*b1
	fstp	st(1)                   	;  ST(0) = Normal_Z
						;  ST(1) = Normal_Y
						;  ST(2) = Normal_X
	;
	fld	st(2)
	fmul	st(0),st(0)			;ST(0) = Normal_X
	fld	st(2)
	fmul	st(0),st(0)			;ST(0) = Normal_Y
	fadd	st(0),st(1)			;ST(0) = Normal_X + Normal_Y
	fstp	st(1)
	fld	st(1)
	fmul	st(0),st(0)			;ST(0) = Normal_Z
	fadd	st(0),st(1)			;ST(0) = Normal_X + Normal_Y +Normal_Z
	fstp	st(1)
	;
	;
	;Now the floating point stack looks like this:
	;	ST(0) =  Normal 
	;	ST(1) = Normal_Z
	;	ST(2) = Normal_Y
	;	ST(3) = Normal_X
	;
	fsqrt					;ST(0) = SQRT (ST(0))
	fdiv	st(1),st
	fdiv	st(2),st
	fdiv	st(3),st
	fstp	st(0)				;Throw away root

	fild	ds:[@@shiftsize]		;ST(0) = GVE_MATH_SHIFT
	fld	st(3)				;ST(0) = Normal_X
	fscale
	fistp   ds:[esi+Triangle_NormalX]	;Save normalized Normal_X
	fwait
	fld	st(2)				;ST(0) = Normal_Y
	fscale
	fistp   ds:[esi+Triangle_NormalY]	;Save normalized Normal_Y
	fwait
	fld	st(1)				;ST(0) = Normal_Z
	fscale
	fistp   ds:[esi+Triangle_NormalZ]	;Save normalized Normal_Z
	fwait
	ffree	st(0)
	ffree	st(1)
	ffree	st(2)
	ffree	st(3)
	;
	;
	;Now lets build the plane-equation for this polygon.
	;Remember that the equation
	;
	;  	Ax + By + Cz + D = 0
	;
	;must be true for all points that lie within the plane.
	;A,B and C are simply the surface normal-values. D has to
	;be evaluated by plugging in a vertex.
	mov	edi,ds:[esi+Triangle_Vertex1]	;EDI = ptr to vertex
	mov	eax,ds:[esi+Triangle_NormalX]	;EAX = A
	imul	d ds:[edi+VertexX]		;EDX:EAX = Vertex-X * A
	mov	ebx,eax
	mov	ebp,edx				;EBP:EBX = A*x
	mov	eax,ds:[esi+Triangle_NormalY]	;EAX = B
	imul	ds:[edi+VertexY]		;EDX:EAX = Vertex_Y * B
	add	ebx,eax
	adc	ebp,edx				;EBP:EBX = A*x + B*y
	mov	eax,ds:[esi+Triangle_NormalZ]	;EAX = C
	imul	ds:[edi+VertexZ]		;EDX:EAX = Vertex_Z * C
	add	eax,ebx
	adc	edx,ebp				;EDX:EAX = A*x + B*y + C*z
	shrd	eax,edx,GVE_NORMAL_SHIFT
	neg	eax				;EAX = D
	mov	ds:[esi+Triangle_Plane],eax	;Save D in polygon

	mov	eax,ds:[esi+Triangle_NormalX]
	mov	ebx,ds:[esi+Triangle_NormalY]
	mov	edx,ds:[esi+Triangle_NormalZ]	;Get back surface-normal
	pop	ebp				;Restore primitive counter
	;
	mov	ecx,3
	@@L4:	mov	edi,ds:[esi+20+4*ecx]	;EDI = vertex
		mov	ds:[edi+Vertex_NormalX],eax
		mov	ds:[edi+Vertex_NormalY],ebx
		mov	ds:[edi+Vertex_NormalZ],edx
		dec 	ecx
		jnz	short @@L4
	;
@@Next:	movzx	eax,word ptr ds:[esi]	;Get size
	add	esi,eax			;Skip to next primitive
	dec	ebp
	jnz	@@L5
	;
	pop	ebp			;EBP = ptr to vertex-list
	mov	ecx,ds:[ebp]		;ECX = number of vertices
	add	ebp,4
	;
@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn

	@@shiftsize	dd	GVE_MATH_SHIFT
GVE_Init_Mesh ENDP
CODE32 ENDS
END