;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS

GVE_SYSTEM_FILE		equ	1



;
;
;
;   GOMEZ VECTOR ENGINE                                            v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gomez.inc
include gve32.inc
include gvelist.inc

extrn GVE_Build_Matrix:near
extrn GVE_Build_Direction:near
extrn GVE_Mult_Matrix:near

;
;   GOMEZ VECTOR ENGINE                                  helper functions
;
;
;
; Find_Track
;   Input:
;	EAX	- DATA32 ptr to track-list
;	EDX	- DATA32 ptr to object-header
;   Output:
;	EAX	- DATA32 ptr to track-header
;	EDX	- DATA32 ptr to entry in track-list
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
Find_Track PROC NEAR
	mov	ebx,edx				;EBX = magic to search
	mov	ecx,ds:[eax]			;ECX = number of tracks
	lea	edx,[eax+4]			;EDX = ptr to tracklist
	test	ecx,ecx
	jz	short @@Err
	;
@@L1:	mov	eax,ds:[edx]			;EAX = ptr to track-header
	cmp	ds:[eax+Track_Object_Address],ebx
	je	short @@Succ
	add	edx,4				;Next entry
	dec	ecx
	jnz	short @@L1
	;
@@Err:	xor	eax,eax
	stc
	retn

@@Succ:	clc
	retn
FInd_Track ENDP



;
;
; Alloc_Frames
;   Input:
;	EBX	- DATA32 ptr to track-header
;	ECX	- Number of frames requested
;   Output:
;	EBX	- DATA32 ptr to track-header
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
Alloc_Frames PROC NEAR
	push	edi
	cmp	ds:[ebx+Track_Frames],ecx
	jg	short @@Succ
	;
	add	ecx,63
	and	ecx,NOT 63
	push	ecx				;ECX = new number of frames
	imul	ecx,6*4
	add	ecx,6*4+GVE_TRACK_SIZE		;ECX = requested track-size
	call	Realloc
	pop	ecx
	jc	short @@Err
	mov	edx,ds:[eax+Track_Frames]	;EDX = old number of frames
	mov	ds:[eax+Track_Frames],ecx	;ECX = number of frames
	mov	ebx,eax				;EBX = track ptr
	;
	sub	ecx,edx				;ECX = number of new frames
	imul	edi,edx,6*4
	lea	edi,[edi+ebx+GVE_TRACK_SIZE]	;EDI = ptr to 1st new entry
	imul	ecx,6
	xor	eax,eax
	rep	stosd				;Clear new track data
	;
@@Succ:	clc
@@Er:	pop	edi
	retn

@@Err:	jmp	Exit_PMODE32
Alloc_Frames ENDP


;
;   GOMEZ VECTOR ENGINE                            transformation functions
;
;
;
; Move_????:
;    Input:
;	EBP	- DATA32 ptr to object/light/camera/...
;    Output:
;	Nothing
;    Destroys:
;	Everything
;
ALIGN 16
Transformation_List:
	dd	GVE_TYP_OBJECT,OFFSET Move_Object
	dd	GVE_TYP_LIGHT,Move_Light
	dd	GVE_TYP_SPOTLIGHT,Move_Light
	dd	GVE_TYP_POINTLIGHT,Move_Light
	dd	GVE_TYP_CAMERA,Move_Camera
	dd	0,0
;
Move_Light:
	mov	edx,ds:[ebp+Light_Position]
	mov	esi,ds:[ebp+Light_Position+4]
	mov	edi,ds:[ebp+Light_Position+8]
	lea	ebp,[ebp+Light_Direction]
	call	GVE_Build_Direction
	retn
;
Move_Camera:
	mov	eax,ds:[ebp+Camera_Position+12]
	mov	ebx,ds:[ebp+Camera_Position+16]
	mov	ecx,ds:[ebp+Camera_Position+20]
	mov	edx,ds:[ebp+Camera_Position]
	mov	esi,ds:[ebp+Camera_Position+4]
	mov	edi,ds:[ebp+Camera_Position+8]
	neg	eax
	neg	ebx
	neg	ecx
	neg	edx
	neg	esi
	neg	edi
	lea	ebp,[ebp+Camera_Matrix]
	call	GVE_Build_Matrix
	retn
;
Move_Object:
	mov	eax,ds:[ebp+Object_Position+12]
	mov	ebx,ds:[ebp+Object_Position+16]
	mov	ecx,ds:[ebp+Object_Position+20]
	mov	edx,ds:[ebp+Object_Position]
	mov	esi,ds:[ebp+Object_Position+4]
	mov	edi,ds:[ebp+Object_Position+8]
	lea	ebp,[ebp+Object_Local_Matrix]
	call	GVE_Build_Matrix
	retn


;
;
;
;   GOMEZ VECTOR ENGINE                            SCRIPT PLAYING FUNCTIONS
;
;
;
;
;
; GVE_Alloc_Track
;   Input:
;	EAX	- DATA32 ptr to world-header
;	EDX	- DATA32 ptr to object-header
;   Output:
;	EAX	- DATA32 ptr to new track-header
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Alloc_Track
GVE_Alloc_Track PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	test	edx,edx
	jz	short @@Succ
	mov	ebp,eax				;EBP = Ptr to world-header
	mov	esi,edx				;ESI = Ptr to obejct-header
	mov	eax,ds:[eax+World_Track_List]	;EAX = Ptr to track-List
	call    Find_Track			;EAX = Ptr to track-header
	jnc	short @@End
	;
	mov	eax,ds:[ebp+World_Track_List]
	call	New_List_Entry
	jc	@@End
	mov	ds:[ebp+World_Track_List],eax
	;
	push	edx				;EDX = DATA32 ptr to new entry
	mov	ecx,GVE_TRACK_SIZE
	call	Malloc                  	;EAX = allocated track-hdr
	pop	edx
	jc	@@End
	mov	ds:[edx],eax			;Save hdr-address
	;
	push	eax
	mov	edi,eax
	mov	ecx,GVE_TRACK_SIZE/4
	xor	eax,eax
	rep	stosd				;Clear object !
	pop	eax				;EAX = ptr to header

	mov	ecx,ds:[esi+Object_Magic]
	mov	ebx,ds:[esi+Object_Type]
	mov	ds:[eax+Track_Object_Address],esi
	mov	ds:[eax+Track_Magic],ecx
	mov	ds:[eax+Track_Type],ebx
	;
@@Succ:	clc
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Alloc_Track ENDP


;
;
; GVE_Alloc_Script
;   Input:
;	EAX	- DATA32 ptr to world-header
;   Output:
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Alloc_Script
GVE_Alloc_Script PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,eax				;EBP = Ptr to world-header
	;
	mov	esi,ds:[ebp+World_Object_List]	;ESI = Ptr to obejct-header
	mov	edi,ds:[esi]			;EDI = Number of objects
	test	edi,edi
	jz	short @@Nxt1
@@L1:	mov	eax,ebp				;EAX = WOrld header
	mov	edx,ds:[esi+4*edi]		;EDX = Object address
	call	GVE_Alloc_Track
	jc	@@End
	dec	edi
	jnz	short @@L1
@@Nxt1:	;
	mov	esi,ds:[ebp+World_Camera_List]	;ESI = Ptr to obejct-header
	mov	edi,ds:[esi]			;EDI = Number of objects
	test	edi,edi
	jz	short @@Nxt2
@@L2:	mov	eax,ebp				;EAX = WOrld header
	mov	edx,ds:[esi+4*edi]		;EDX = Object address
	call	GVE_Alloc_Track
	jc	@@End
	dec	edi
	jnz	short @@L2
@@Nxt2:	;
	mov	esi,ds:[ebp+World_Light_List]	;ESI = Ptr to obejct-header
	mov	edi,ds:[esi]			;EDI = Number of objects
	test	edi,edi
	jz	short @@Nxt3
@@L3:	mov	eax,ebp				;EAX = WOrld header
	mov	edx,ds:[esi+4*edi]		;EDX = Object address
	call	GVE_Alloc_Track
	jc	@@End
	dec	edi
	jnz	short @@L3
@@Nxt3:	;

	clc
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Alloc_Script ENDP



;
;
; GVE_Free_Track
;   Input:
;	EAX	- DATA32 ptr to world-header
;	EDX	- DATA32 ptr to object-header
;   Output:
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Free_Track
GVE_Free_Track PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,eax				;EBP = World-Header
	mov	eax,ds:[eax+World_Track_List]
	call	Find_List_Entry
	jc	short @@End
	;
	mov	ecx,ds:[edx]			;ECX = ptr to track-header
	mov	d ds:[edx],0
	call	Free

	mov	eax,ds:[ebp+World_Track_List]
	call	Shrink_List			;Tidy up tarck-list !
	mov	ds:[ebp+World_Track_List],eax
	;
	clc
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn
GVE_Free_Track ENDP




;
;
; GVE_Compress_Track
;   Input:
;	EAX	- DATA32 ptr to world-header
;	EDX	- DATA32 ptr to object-header
;   Output:
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Compress_Track
GVE_Compress_Track PROC NEAR
	retn
GVE_Compress_Track ENDP




;
;
; GVE_DeCompress_Track
;   Input:
;	EAX	- DATA32 ptr to world-header
;	EDX	- DATA32 ptr to object-header
;   Output:
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_DeCompress_Track
GVE_DeCompress_Track PROC NEAR
	retn
GVE_DeCompress_Track ENDP




;
;
; GVE_Grab_Frame
;   Input:
;	EAX	- DATA32 ptr to world-header
;	ECX	- frame number
;	EDX	- DATA32 ptr to object or zero for all
;   Output:
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Grab_Frame
GVE_Grab_Frame PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,ecx				;EBP = Frame-Number
	mov	esi,ds:[eax+World_Track_List]	;ESI = Track-list
	shr	ebp,GVE_SCRIPT_SHIFT
	test	edx,edx
	jz	short @@All
	;
	mov	eax,ds:[eax+World_Track_List]	;EAX = Ptr to track-List
	call    Find_Track
	mov	esi,edx				;ESI = Entry in list
	jc	short @@End
	mov	ecx,1
	jmp	@@L1
@@All:	;
	mov	ecx,ds:[esi]			;ECX = Number of tracks
	add	esi,4
	test	ecx,ecx
	jz	@@End

@@L1:   push	ecx
	mov	ebx,ds:[esi]			;EBX = ptr to track-header
	lea	ecx,[ebp+1]
	call	Alloc_Frames
	pop	ecx				;ECX = Track counter
	jc	@@Err
	mov	ds:[esi],ebx
	;
	push	esi
	mov	esi,ds:[ebx+Track_Object_Address]
	test	esi,esi
	jz	short @@Nxt
	imul	edi,ebp,6*4
	lea	edi,[edi+ebx+GVE_TRACK_SIZE]	;EDI = ptr to req. entry

	mov	eax,ds:[esi+Object_RotationX]
	mov	ebx,ds:[esi+Object_RotationY]
	mov	edx,ds:[esi+Object_RotationZ]
	mov	ds:[edi+Frame_RotationX],eax
	mov	ds:[edi+Frame_RotationY],ebx
	mov	ds:[edi+Frame_RotationZ],edx
	mov	eax,ds:[esi+Object_PositionX]
	mov	ebx,ds:[esi+Object_PositionY]
	mov	edx,ds:[esi+Object_PositionZ]
	mov	ds:[edi+Frame_PositionX],eax
	mov	ds:[edi+Frame_PositionY],ebx
	mov	ds:[edi+Frame_PositionZ],edx

@@Nxt:  pop	esi
	add	esi,4
	dec	ecx
	jnz	short @@L1
	;
@@End:	clc
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Grab_Frame ENDP



;
;
; GVE_Jump_Frame
;   Input:
;	EAX	- DATA32 ptr to world-header
;	ECX	- frame number (shifted value)
;	EDX	- DATA32 ptr to object-header
;   Output:
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
;
; This functions uses a cubic interpolation scheme:
;
;	f(x) = a*x^3 + b*x^2 + c*x + d
;
; with the following values given:
;
;	f(0) = p0
;	f(1) = p1
;	f(2) = p2
;	f(3) = p3
;
; Thus we get for a,b,c,d:
;
;	a =  -1/6*p0 + 1/2*p1 - 1/2*p2 + 1/6*p3
;  	b =       p0 - 5/2*p1 +   2*p2 - 1/2*p3
;	c = -11/6*p0 +   3*p1 - 3/2*p2 + 1/3*p3
;	d =       p0
;
;

PUBLIC C GVE_Jump_Frame
GVE_Jump_Frame PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ecx				;EBP = Frame-Number
	push	eax
	push	edx
	;

	;
	pop	edx
	pop	eax
	mov	esi,ds:[eax+World_Track_List]	;ESI = Track-list
	test	edx,edx
	jz	short @@All
	;
	mov	eax,ds:[eax+World_Track_List]	;EAX = Ptr to track-List
	call    Find_Track
	mov	esi,edx				;ESI = Entry in list
	jc	@@End
	mov	ecx,1
	jmp	@@L1
@@All:	;
	mov	ecx,ds:[esi]			;ECX = Number of tracks
	add	esi,4
	test	ecx,ecx
	jz	@@Succ

@@L1:   mov	eax,ds:[@@FRAME]		;EAX = Frame-number
	mov	ebx,ds:[esi]			;EBX = ptr to track-header
	push	ecx
	push	esi
	cmp	ds:[ebx+Track_Frames],eax
	jle	short @@Nxt
	;
	mov	ebp,ds:[ebx+Track_Object_Address]
	test	ebp,ebp
	jz	short @@Nxt
	imul	edi,eax,6*4
	lea	edi,[edi+ebx+GVE_TRACK_SIZE]	;EDI = ptr to req. entry

	mov	eax,ds:[edi+Frame_RotationX]
	mov	ebx,ds:[edi+Frame_RotationY]
	mov	edx,ds:[edi+Frame_RotationZ]
	mov	ds:[ebp+Object_RotationX],eax
	mov	ds:[ebp+Object_RotationY],ebx
	mov	ds:[ebp+Object_RotationZ],edx
	mov	eax,ds:[edi+Frame_PositionX]
	mov	ebx,ds:[edi+Frame_PositionY]
	mov	edx,ds:[edi+Frame_PositionZ]
	mov	ds:[ebp+Object_PositionX],eax
	mov	ds:[ebp+Object_PositionY],ebx
	mov	ds:[ebp+Object_PositionZ],edx
	;
	mov	eax,ds:[ebp+Object_Type]
	mov	ebx,OFFSET Transformation_List
@@L2:	mov	ecx,ds:[ebx]
	add	ebx,8
	test	ecx,ecx
	jz	short @@Nxt
	cmp	ecx,eax
	jne	short @@L2
	call	d ds:[ebx-4]
	;
@@Nxt: 	pop	esi
	pop	ecx
	add	esi,4
	dec	ecx
	jnz	short @@L1
	;

@@Succ:	clc
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn

		ALIGN 	16
@@A		dd	?
@@B		dd	?
@@C		dd	?
@@D		dd	?
@@X3		dd	?
@@X2		dd	?
@@X1		dd	?
@@FRAME		dd	?
GVE_Jump_Frame ENDP



;
;
; GVE_Kill_Frames
;   Input:
;	EAX	- DATA32 ptr to world-header
;	EBX	- first frame
;	ECX	- last frame
;   Output:
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Kill_Frames
GVE_Kill_Frames PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Kill_Frames ENDP


;
;
; GVE_Suggest_Frame
;   Input:
;	EAX	- DATA32 ptr to world-header
;	ECX	- frame number
;	EDX	- DATA32 ptr to object or zero for all
;   Output:
;	CF	- Error flag
;   Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Suggest_Frame
GVE_Suggest_Frame PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	shr	ecx,GVE_SCRIPT_SHIFT
	jz	@@End				;Predict 1st frame ???
	mov	ebp,ecx				;EBP = Frame-Number
	mov	esi,ds:[eax+World_Track_List]	;ESI = Track-list
	test	edx,edx
	jz	short @@All
	;
	mov	eax,ds:[eax+World_Track_List]	;EAX = Ptr to track-List
	call    Find_Track
	mov	esi,edx				;ESI = Entry in list
	jc	@@End
	mov	ecx,1
	jmp	@@L1
@@All:	;
	mov	ecx,ds:[esi]			;ECX = Number of tracks
	add	esi,4
	test	ecx,ecx
	jz	@@End

@@L1:   push	ecx
	mov	ebx,ds:[esi]			;EBX = ptr to track-header
	lea	ecx,[ebp+1]
	call	Alloc_Frames
	pop	ecx				;ECX = Track counter
	jc	@@Err
	mov	ds:[esi],ebx
	;
	push	esi
	imul	edi,ebp,6*4
	lea	edi,[edi+ebx+GVE_TRACK_SIZE]	;EDI = ptr to req. entry
	cmp	ebp,3
	jb	short @@Cpy			;We need 3 frames for prediction !
	;
	;
	; Here we use an quadratic approximation for the last three values
	; let's say y0,y1 and y2. Now we want:
	;
	;		f(x) = ax + bx + c
	;
	; with the following known euqations:
	;
	;               f(0) = c	    = y0
	;		f(1) = a  + b  + c  = y1
	;		f(2) = 4a + 2b + c  = y2
	;
	; Solving this system, we get for a,b and c:
	;
	;		a = (y0 -  2y1 + y2) / 2
	;		b = (4y1 - 3y0 - y2) / 2
	;		c = y0
	;
	; The predicten value will then be f(3). And this is:
	;
	;		f(3) = y0 - 3y1 + 3y2
	;
	mov	eax,ds:[edi-1*(SIZE GVE_TRACK_ENTRY)+Frame_RotationX]
	mov	ebx,ds:[edi-1*(SIZE GVE_TRACK_ENTRY)+Frame_RotationY]
	mov	edx,ds:[edi-1*(SIZE GVE_TRACK_ENTRY)+Frame_RotationZ]
	sub	eax,ds:[edi-2*(SIZE GVE_TRACK_ENTRY)+Frame_RotationX]
	sub	ebx,ds:[edi-2*(SIZE GVE_TRACK_ENTRY)+Frame_RotationY]
	sub	edx,ds:[edi-2*(SIZE GVE_TRACK_ENTRY)+Frame_RotationZ]
	imul	eax,3
	imul	ebx,3
	imul	edx,3
	add	eax,ds:[edi-3*(SIZE GVE_TRACK_ENTRY)+Frame_RotationX]
	add	ebx,ds:[edi-3*(SIZE GVE_TRACK_ENTRY)+Frame_RotationY]
	add	edx,ds:[edi-3*(SIZE GVE_TRACK_ENTRY)+Frame_RotationZ]
	mov	ds:[edi+Frame_RotationX],eax
	mov	ds:[edi+Frame_RotationY],ebx
	mov	ds:[edi+Frame_RotationZ],edx

	mov	eax,ds:[edi-1*(SIZE GVE_TRACK_ENTRY)+Frame_PositionX]
	mov	ebx,ds:[edi-1*(SIZE GVE_TRACK_ENTRY)+Frame_PositionY]
	mov	edx,ds:[edi-1*(SIZE GVE_TRACK_ENTRY)+Frame_PositionZ]
	sub	eax,ds:[edi-2*(SIZE GVE_TRACK_ENTRY)+Frame_PositionX]
	sub	ebx,ds:[edi-2*(SIZE GVE_TRACK_ENTRY)+Frame_PositionY]
	sub	edx,ds:[edi-2*(SIZE GVE_TRACK_ENTRY)+Frame_PositionZ]
	imul	eax,3
	imul	ebx,3
	imul	edx,3
	add	eax,ds:[edi-3*(SIZE GVE_TRACK_ENTRY)+Frame_PositionX]
	add	ebx,ds:[edi-3*(SIZE GVE_TRACK_ENTRY)+Frame_PositionY]
	add	edx,ds:[edi-3*(SIZE GVE_TRACK_ENTRY)+Frame_PositionZ]
	mov	ds:[edi+Frame_PositionX],eax
	mov	ds:[edi+Frame_PositionY],ebx
	mov	ds:[edi+Frame_PositionZ],edx

	jmp	@@Nxt
	;
@@Cpy:  push	ecx
	lea	esi,[edi-SIZE GVE_TRACK_ENTRY]
	mov	ecx,(SIZE GVE_TRACK_ENTRY)/4
	rep	movsd
	pop	ecx
	;
@@Nxt:  pop	esi
	add	esi,4
	dec	ecx
	jnz	@@L1
	;
@@End:	clc
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Suggest_Frame ENDP
CODE32 ends
END