;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
;
;
;
;   GOMEZ VECTOR ENGINE  pro                                 raster macros
;
;
;

	b		equ	byte ptr
	w		equ	word ptr
	d		equ	dword ptr
;
	VShading	equ	Vertex_Shading
	VTexture	equ	Vertex_Texture
	VTextureU	equ	Vertex_TextureU
	VTextureV	equ	Vertex_TextureV
	VTextureX	equ	Vertex_TextureX
	VTextureY	equ	Vertex_TextureY
	VChrome		equ	Vertex_Chrome
	VChromeX	equ	Vertex_ChromeX
	VChromeY	equ	Vertex_ChromeY
;
	SIMPLE_POLY		equ	0	;No special values
	GOURAUD_POLY		equ	1
	FAST_PHONG_POLY		equ	2
	TEXTURE_POLY		equ	8
	BUMP_POLY		equ	TEXTURE_POLY
	CHROME_POLY		equ	10h
	TEXTURE_GOURAUD_POLY	equ	(TEXTURE_POLY+GOURAUD_POLY)
	TEXTURE_PHONG_POLY	equ	(TEXTURE_POLY+FAST_PHONG_POLY)
	TEXTURE_CHROME_POLY	equ	(TEXTURE_POLY+CHROME_POLY)
	CHROME_GOURAUD_POLY	equ	(CHROME_POLY+GOURAUD_POLY)
	CHROME_PHONG_POLY	equ	(CHROME_POLY+FAST_PHONG_POLY)
;
;
; GRAB_VERTICES:
;  Input:
;  	ESI	- DATA32 ptr triple
;  Output:
;	EAX	- Y0
;	EBX	- Y2
;	ESI	- DATA32 ptr to first vertex
;      EDI	- DATA32 ptr to second vertex
;      EBP	- DATA32 ptr to third vertex
;	 with Y0 < Y1 < Y2 , if Y0=Y1 then X0<X1
;  Destroys:
;	ECX,EDX
;
GRAB_VERTICES MACRO poly_type
	LOCAL J1,J2,J3,E
	ifndef GVE_VERTEX_TEXTURE_UV
	 if (poly_type and TEXTURE_POLY)
	  mov	eax,ds:[esi+36]		;EAX = 1st texture-coordinate (12:4)
	  mov	ebx,ds:[esi+40]		;EBX = 2nd texture-coordinate (12:4)
	  mov	ecx,ds:[esi+44]		;ECX = 3rd texture-coordinate (12:4)
	  mov	ebp,ds:[esi+24]		;EBP = first vertex
	  mov	edi,ds:[esi+28]		;EDI = 2nd vertex
	  mov	esi,ds:[esi+32]		;ESI = 3rd vertex
	  movsx	edx,ax			;EDX = low coordinate
	  sar	eax,16-4                ;EAX = 24.8 u coordinate
	  shl	edx,4
	  mov	ds:[ebp+VTextureY],eax
	  mov	ds:[ebp+VTextureX],edx
	  movsx	edx,bx			;EDX = low coordinate
	  sar	ebx,16-4
	  shl	edx,4
	  mov	ds:[edi+VTextureY],ebx
	  mov	ds:[edi+VTextureX],edx
	  movsx	edx,cx			;EDX = low coordinate
	  sar	ecx,16-4
	  shl	edx,4
	  mov	ds:[esi+VTextureY],ecx
	  mov	ds:[esi+VTextureX],edx
	 else
	  mov	ebp,ds:[esi+24]		;Get first vertex
	  mov	edi,ds:[esi+28]		;Get 2nd vertex
	  mov	esi,ds:[esi+32]		;Get 3rd vertex
	 endif
	else
	 mov	ebp,ds:[esi+24]		;Get first vertex
	 mov	edi,ds:[esi+28]		;Get 2nd vertex
	 mov	esi,ds:[esi+32]		;Get 3rd vertex
	endif
	;
	mov	ecx,ds:[edi+Vertex_ScreenY];ECX = Y1
	mov	eax,ds:[esi+Vertex_ScreenY];EAX = Y0
	mov	ebx,ds:[ebp+Vertex_ScreenY];EBX = Y2
	cmp	eax,ecx			;Is Y0 < Y1 ???
	jle	short J1
		;xchg	esi,edi		;Swap V0 and V1
		;xchg	eax,ecx		;Swap Y0 and Y1
		mov	edx,esi         ; tmp = V0
		mov	esi,edi		;*ESI = V1
		mov	edi,eax		; EDI = Y0
		mov	eax,ecx		;*EAX = Y1
		mov	ecx,edi		;*ECX = Y0
		mov	edi,edx		;*EDI = tmp = V0
	;	jmp	short J1
	;
J1:	cmp	eax,ebx			;Is Y0 < Y2 ???
	jle	short J2
		;xchg	edi,ebp		;Swap V1 and V2
		;xchg	ecx,ebx		;Swap Y1 and Y2
		;xchg	esi,edi		;Swap V0 and V1
		;xchg	eax,ecx		;Swap Y0 and Y1
		mov	edx,edi		; tmp = V1
		mov	edi,esi		;*EDI = V0
		mov	esi,ebp		;*ESI = V2
		mov	ebp,edx		;*EBP = tmp = V1
		mov	edx,ecx		; tmp = Y1
		mov	ecx,eax		;*ECX = V0
		mov	eax,ebx         ;*EAX = Y2
		mov	ebx,edx		;*EBX = tmp = Y1
		jmp	short J3
	;
J2:    	cmp	ebx,ecx			;Is Y2 > Y1 ???
	jge	short J3
		;xchg	edi,ebp		;Swap V1 and V2
		;xchg	ecx,ebx		;Swap Y1 and Y2
		mov	edx,edi		; tmp = V1
		mov	edi,ebp		;*EDI = V2
		mov	ebp,ecx		; EBP = Y1
		mov	ecx,ebx		;*ECX = Y2
		mov	ebx,ebp		;*EBX = Y1
		mov	ebp,edx		;*EBP = tmp = V1
	;
J3:     cmp	eax,ecx			;Is Y0 = Y1 ???
	jne	short E
	mov	edx,ds:[esi+Vertex_ScreenX];EDX = X0
	cmp	edx,ds:[edi+Vertex_ScreenX];Is X0 < X1 ???
	jle	short E
		mov	edx,esi
		mov	esi,edi
		mov	edi,edx		;Swap V0 and V1
		mov	eax,ecx        	;EAX = Y0
	;
	;
	;Lets perform a quick range-checking !
E:      ifndef GVE_TRIVIAL_REJECT
	cmp	eax,ds:[GVE_Frame_Height]	;Is Y0 > Display ???
	jge	@@End
	test	ebx,ebx			;Is Y2 < 0 ???
	js	@@End
	endif
	ENDM
;
;
; GRAB_SLOPES:
;  Input:
;	EAX	- Y0
;	EBX	- Y2
;	ESI	- DATA32 ptr to first vertex
;      EDI	- DATA32 ptr to second vertex
;      EBP	- DATA32 ptr to third vertex
;	 with Y0 < Y1 < Y2
;  Output:
;	@@S1-4	- Slope of V0->V2
;	@@S2-4	- Slope of V0->V1
;	@@S3-4	- Slope of V1->V2
;	@@S4-4	- X of V1
;	@@C1	- [xchg] ebx,ecx  /  [xchg] edx,edx
;	EBP	- 1st vertical counter
;	ESI	- 2nd vertical counter
;	EBX	- X0
;	EDI	- Y0
;  Additional output:
;	@@G0-4  - Gouraud start value
;	@@G1-4	- Vertical gouraud slope from V0->V2 or V0->V1
;	@@G2-4  - Horizontal gouraud slope
;	@@G3-4  - Vertical gouraud slope from V0->V2 or V1->V2
;	@@T0-4	- Texture start value
;	@@T1-4	- Vertical texture slope from V0->V2 or V0->V1
;	@@T2-4  - Horizontal texture slope
;	@@T3-4  - Vertical texture slope from V0->V2 or V1->V2
;	@@P0-4	- Phong/Chrome start value
;	@@P1-4	- Vertical phong/chrome slope from V0->V2 or V0->V1
;	@@P2-4  - Horizontal phong/chrome slope
;	@@P3-4  - Vertical phong/chrome slope from V0->V2 or V1->V2
;      Counter_V02
;	Counter_V01
;	Counter_V12
;  Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
;
;  Note this nice way of calculating the horizontal texture/gouraud
;  increments:
;
;	      (At-Ct)*(By-Cy) - (Bt-Ct)*(Ay-Cy)
;    dt/dx = 
;	      (Ax-Cx)*(By-Cy) - (Bx-Cx)*(Ay-Cy)
;
GRAB_SLOPES MACRO poly_type
	LOCAL N1,N2,N3,J1,J2
	LOCAL GJ1,GJ2,GN1,GN2,GN3
	LOCAL CJ1,CJ2,CN1,CN2,CN3
	LOCAL TJ1,TJ2,TN1,TN2,TN3

	sub	ebx,eax				;EBX = Cy - Ay
	jz	@@End				;EBX = 0 ==> No triple !
	mov	ds:[Counter_V02],ebx
	;
	mov	eax,ds:[ebp+Vertex_ScreenX]
	mov	ecx,ds:[edi+Vertex_ScreenX]
	sub	eax,ds:[esi+Vertex_ScreenX]	;EAX = X2 - X0
	push	d ds:[esi+Vertex_ScreenY]	;Save Y0
	mov	edx,eax
	mov	d ds:[@@S4-4],ecx
	sar	edx,31
	idiv	ebx				;EAX = Slope_1   (V0 -> V2)
	mov	d ds:[@@S1-4],eax
	;
	mov	ecx,ds:[edi+Vertex_ScreenY]	;ECX = Y1
	mov	eax,ds:[edi+Vertex_ScreenX]	;EAX = X1
	sub	ecx,ds:[esi+Vertex_ScreenY]	;ECX = By - Ay
	jz	short J1			;Prevent division fault
	sub	eax,ds:[esi+Vertex_ScreenX]	;EAX = X1 - X0
	cdq
	idiv	ecx				;EAX = Slope_2   (V0 -> V1)
	mov	d ds:[@@S2-4],eax
J1:	;
	mov	ds:[Counter_V01],ecx
	sub	ebx,ecx				;EBX = (Cy - Ay) - (By - Ay)
	mov	b ds:[@@C1],0d2h		;[xchg] eax,eax
	mov	ds:[Counter_V12],ebx
	cmp	eax,d ds:[@@S1-4]
	jge	short J2
	mov	b ds:[@@C1],0cbh		;[xchg] ebx,ecx
J2:     ;
	if ((poly_type and GOURAUD_POLY) or (poly_type and FAST_PHONG_POLY))
	  cmp	b ds:[@@C1],0cbh
	  je	short GJ1
	  mov	edx,ds:[esi+VShading]	;EDX = At
	  mov   eax,ds:[ebp+VShading]	;EAX = Ct
	  mov	d ds:[@@G0-4],edx	;Save gouraud start value
	  sub	eax,edx			;EAX = Ct - At
	  cdq
	  idiv	ds:[Counter_V02]	;EAX = vertical gouraud slope
	  mov	d ds:[@@G1-4],eax	;Save vertical gouraud slope
	  mov	d ds:[@@G3-4],eax
	  jmp	short GN2
	  ;
GJ1:      mov	edx,ds:[esi+VShading]	;EDX = At
	  mov   eax,ds:[edi+VShading]	;EAX = Bt
	  mov	d ds:[@@G0-4],edx	;Save gouraud start value
	  test	ecx,ecx			;ECX = By - Ay
	  jz    short GN1
	  sub	eax,edx			;EAX = Bt - At
	  cdq
	  idiv	ecx			;EAX = vertical gouraud slope
	  mov	d ds:[@@G1-4],eax	;Save vertical gouraud slope

GN1:      mov	edx,ds:[edi+VShading]	;EDX = Bt
	  test	ebx,ebx			;EBX = Cy - By
	  jz	short GN2
	  mov   eax,ds:[ebp+VShading]	;EAX = Ct
	  sub	eax,edx			;EAX = Ct - Bt
	  cdq
	  idiv	ebx			;EAX = vertical gouraud slope
	  mov	d ds:[@@G3-4],eax	;Save vertical gouraud slope
GN2:	endif
	;
	if (poly_type and CHROME_POLY)
	  cmp	b ds:[@@C1],0cbh
	  je	short CJ1
	  mov	edx,ds:[esi+VChromeX]	;ECX = Chrome u coordinates at V0
	  mov	eax,ds:[ebp+VChromeX]	;EAX = Chrome u coordinates at V2
	  mov	w ds:[@@P0-4],dx	;Save texture start value
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ds:[Counter_V02]	;EAX = vertical u texture slope
	  mov	w ds:[@@P1-4],ax	;Save vertical u texture slope
	  mov	w ds:[@@P3-4],ax	;Save vertical u texture slope

	  mov	edx,ds:[esi+VChromeY]	;ECX = Chrome v coordinates at V0
	  mov	eax,ds:[ebp+VChromeY]	;EAX = Chrome v coordinates at V2
	  mov	w ds:[@@P0-2],dx	;Save texture start value
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ds:[Counter_V02]	;EAX = vertical v texture slope
	  mov	w ds:[@@P1-2],ax	;Save vertical v texture slope
	  mov	w ds:[@@P3-2],ax	;Save vertical v texture slope
	  jmp	short CN2
	  ;
CJ1:      mov	eax,ds:[esi+VChromeY]	;EAX = Chrome v coordinates at V0
	  mov	edx,ds:[esi+VChromeX]	;EDX = Chrome u coordinates at V0
	  mov	w ds:[@@P0-2],ax	;Save texture start value
	  mov	eax,ds:[edi+VChromeX]	;EAX = Chrome u coordinates at V2
	  mov	w ds:[@@P0-4],dx	;Save texture start value
	  test	ecx,ecx			;ECX = By - Ay
	  jz    short CN1
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ecx			;EAX = vertical u texture slope
	  mov	w ds:[@@P1-4],ax	;Save vertical u texture slope

	  mov	edx,ds:[esi+VChromeY]	;EDX = Chrome v coordinates at V0
	  mov	eax,ds:[edi+VChromeY]	;EAX = Chrome v coordinates at V2
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ecx			;EAX = vertical v texture slope
	  mov	w ds:[@@P1-2],ax	;Save vertical v texture slope

CN1:	  mov	edx,ds:[edi+VChromeX]	;EDX = Chrome u coordinates at V0
	  test	ebx,ebx			;EBX = Cy - By
	  jz	short CN2
	  mov	eax,ds:[ebp+VChromeX]	;EAX = Chrome u coordinates at V2
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ebx			;EAX = vertical u texture slope
	  mov	w ds:[@@P3-4],ax	;Save vertical u texture slope

	  mov	edx,ds:[edi+VChromeY]	;EDX = Chrome v coordinates at V0
	  mov	eax,ds:[ebp+VChromeY]	;EAX = Chrome v coordinates at V2
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ebx			;EAX = vertical v texture slope
	  mov	w ds:[@@P3-2],ax	;Save vertical v texture slope
CN2:	endif
	;
	if (poly_type and TEXTURE_POLY)
	  cmp	b ds:[@@C1],0cbh
	  je	short TJ1
	  mov	edx,ds:[esi+VTextureU]	;ECX = Chrome u coordinates at V0
	  mov	eax,ds:[ebp+VTextureU]	;EAX = Chrome u coordinates at V2
	  mov	w ds:[@@T0-4],dx	;Save texture start value
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ds:[Counter_V02]	;EAX = vertical u texture slope
	  mov	w ds:[@@T1-4],ax	;Save vertical u texture slope
	  mov	w ds:[@@T3-4],ax	;Save vertical u texture slope

	  mov	edx,ds:[esi+VTextureV]	;ECX = Chrome v coordinates at V0
	  mov	eax,ds:[ebp+VTextureV]	;EAX = Chrome v coordinates at V2
	  mov	w ds:[@@T0-2],dx	;Save texture start value
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ds:[Counter_V02]	;EAX = vertical v texture slope
	  mov	w ds:[@@T1-2],ax	;Save vertical v texture slope
	  mov	w ds:[@@T3-2],ax	;Save vertical v texture slope
	  jmp	short TN2
	  ;
TJ1:      mov	eax,ds:[esi+VTextureV]	;EAX = Chrome v coordinates at V0
	  mov	edx,ds:[esi+VTextureU]	;EDX = Chrome u coordinates at V0
	  mov	w ds:[@@T0-2],ax    	;Save texture start value
	  mov	eax,ds:[edi+VTextureU]	;EAX = Chrome u coordinates at V2
	  mov	w ds:[@@T0-4],dx	;Save texture start value
	  test	ecx,ecx			;ECX = By - Ay
	  jz    short TN1
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ecx			;EAX = vertical u texture slope
	  mov	w ds:[@@T1-4],ax	;Save vertical u texture slope

	  mov	edx,ds:[esi+VTextureV]	;EDX = Chrome v coordinates at V0
	  mov	eax,ds:[edi+VTextureV]	;EAX = Chrome v coordinates at V2
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ecx			;EAX = vertical v texture slope
	  mov	w ds:[@@T1-2],ax	;Save vertical v texture slope

TN1:	  mov	edx,ds:[edi+VTextureU]	;EDX = Chrome u coordinates at V0
	  test	ebx,ebx			;EBX = Cy - By
	  jz	short TN2
	  mov	eax,ds:[ebp+VTextureU]	;EAX = Chrome u coordinates at V2
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ebx			;EAX = vertical u texture slope
	  mov	w ds:[@@T3-4],ax	;Save vertical u texture slope

	  mov	edx,ds:[edi+VTextureV]	;EDX = Chrome v coordinates at V0
	  mov	eax,ds:[ebp+VTextureV]	;EAX = Chrome v coordinates at V2
	  sub	eax,edx			;Subtract 2nd texture value
	  cdq
	  idiv	ebx			;EAX = vertical v texture slope
	  mov	w ds:[@@T3-2],ax	;Save vertical v texture slope
TN2:	endif
	;
	if (poly_type ne 0)			;Get Denominator
	  mov	eax,d ds:[ebp+Vertex_ScreenX]
	  sub	eax,d ds:[edi+Vertex_ScreenX]	;EAX     = Cx - Ax
	  imul	ds:[Counter_V02]		;EDX:EAX = (Ax-Cx)*(By-Cy)
	  mov	ebx,eax
	  mov	eax,d ds:[ebp+Vertex_ScreenX]
	  mov	ecx,edx				;ECX:EBX = (Ax-Cx)*(By-Cy)
	  sub	eax,d ds:[esi+Vertex_ScreenX]	;EAX     = Cx - Bx
	  imul	ds:[Counter_V12]		;EDX:EAX = (Bx-Cx)*(Ay-Cy)
	  sub	ebx,eax
	  sbb	ecx,edx				;ECX:EBX = (Ax-Cx)*(By-Cy) - (Bx-Cx)*(Ay-Cy)
	  shrd	ebx,ecx,16			;EBX     = Denominator
	  if (poly_type ne TEXTURE_CHROME_POLY)
	   jz	short N3
	  else
	   jz	N3
	  endif
	endif
	;
	if ((poly_type and GOURAUD_POLY) or (poly_type and FAST_PHONG_POLY))
	  mov	eax,d ds:[edi+VSHading]	;EAX = Bt
	  push	ebx
	  sub	eax,d ds:[ebp+VSHading]	;EAX = Bt-Ct
	  imul	ds:[Counter_V02]	;EDX:EAX = (Bt-Ct)*(Ay-Cy)
	  mov	ebx,eax
	  mov	eax,d ds:[esi+VShading]	;EAX	 = At
	  mov	ecx,edx			;ECX:EBX = (Bt-Ct)*(Ay-Cy)
	  sub	eax,d ds:[ebp+VSHading]	;EAX     = At-Ct
	  imul	ds:[Counter_V12]	;EDX:EAX = (At-Ct)*(By-Cy)
	  sub	eax,ebx
	  sbb	edx,ecx			;EDX:EAX = (At-Ct)*(By-Cy) - (Bt-Ct)*(Ay-Cy)
	  pop	ebx
	  idiv	ebx			;EAX = Horizontal Gouraud increment
	  mov	d ds:[@@G2-4],eax
	endif
	;
	if (poly_type and CHROME_POLY)
	  mov	eax,d ds:[esi+VChromeX]	;
	  mov	ecx,d ds:[edi+VChromeX]	;
	  sub	eax,d ds:[ebp+VChromeX]	;EAX = At-Ct
	  sub	ecx,d ds:[ebp+VChromeX]	;ECX = Bt-Ct
	  imul	ds:[Counter_V12]	;EAX = (At-Ct)*(By-Cy)
	  imul	ecx,ds:[Counter_V02]	;ECX = (Bt-Ct)*(Ay-Cy)
	  sub	eax,ecx			;EAX = (At-Ct)*(By-Cy) - (Bt-Ct)*(Ay-Cy)
	  cdq
	  idiv	ebx
	  mov	w ds:[@@P2-4],ax

	  mov	eax,d ds:[esi+VChromeY]	;
	  mov	ecx,d ds:[edi+VChromeY]	;
	  sub	eax,d ds:[ebp+VChromeY]	;EAX = At-Ct
	  sub	ecx,d ds:[ebp+VChromeY]	;ECX = Bt-Ct
	  imul	ds:[Counter_V12]	;EAX = (At-Ct)*(By-Cy)
	  imul	ecx,ds:[Counter_V02]	;ECX = (Bt-Ct)*(Ay-Cy)
	  sub	eax,ecx			;EAX = (At-Ct)*(By-Cy) - (Bt-Ct)*(Ay-Cy)
	  cdq
	  idiv	ebx
	  mov	w ds:[@@P2-2],ax
	endif
	;
	if (poly_type and TEXTURE_POLY)
	  mov	eax,d ds:[esi+VTextureU]	;
	  mov	ecx,d ds:[edi+VTextureU]	;
	  sub	eax,d ds:[ebp+VTextureU]	;EAX = At-Ct
	  sub	ecx,d ds:[ebp+VTextureU]	;ECX = Bt-Ct
	  imul	ds:[Counter_V12]		;EAX = (At-Ct)*(By-Cy)
	  imul	ecx,ds:[Counter_V02]		;ECX = (Bt-Ct)*(Ay-Cy)
	  sub	eax,ecx				;EAX = (At-Ct)*(By-Cy) - (Bt-Ct)*(Ay-Cy)
	  cdq
	  idiv	ebx
	  mov	w ds:[@@T2-4],ax

	  mov	eax,d ds:[esi+VTextureV]	;
	  mov	ecx,d ds:[edi+VTextureV]	;
	  sub	eax,d ds:[ebp+VTextureV]	;EAX = At-Ct
	  sub	ecx,d ds:[ebp+VTextureV]	;ECX = Bt-Ct
	  imul	ds:[Counter_V12]		;EAX = (At-Ct)*(By-Cy)
	  imul	ecx,ds:[Counter_V02]		;ECX = (Bt-Ct)*(Ay-Cy)
	  sub	eax,ecx				;EAX = (At-Ct)*(By-Cy) - (Bt-Ct)*(Ay-Cy)
	  cdq
	  idiv	ebx
	  mov	w ds:[@@T2-2],ax
	endif
N3:	;
	mov	eax,ds:[ebp+Vertex_ScreenX]	;EAX = X2
	mov	ebx,ds:[esi+Vertex_ScreenX]	;EBX = X0
	sub	eax,ds:[edi+Vertex_ScreenX]	;EAX = Cx - Bx
	mov	esi,ds:[Counter_V12]		;ESI = Cy - By
	mov	edx,eax
	test	esi,esi
	jz	short N2			;Prevent division fault
	sar	edx,31
	idiv	esi				;EAX = Slope_3   (V1 -> V2)
	mov	d ds:[@@S3-4],eax
N2:    	;
	mov	ebp,ds:[Counter_V01]
	pop	edi				;EDI = Y0
	ENDM

;
;
; CLIP_VERTICAL:
;  Input:
;	EBP	- 1st vertical count
;	ESI	- 2nd vertical count
;	EBX	- X0
;	EDI	- Y0
;  Output:
;	EBX	- X0
;	ECX	- X1
;	EDI	- Y0
;	EBP	- 1st counter
;	ESI	- 2nd counter
;  Destroys:
;	EAX,EDX
;
CLIP_VERTICAL MACRO poly_type
	LOCAL N1,N2,N3,C1
	mov	ecx,ebx			;EBX = X0 , ECX = X1
	;
	test	edi,edi                 ;Need upper clipping ???
	jns	N1
		mov	eax,d ds:[@@S1-4]
		imul	eax,edi		;EDI = negative number of lines to cut
		sub	ebx,eax		;EBX = X0 + Slope*Clip
		mov	eax,ebp		;EAX = 1st counter
		add    	ebp,edi 	;EBP = New 1st counter
		js	short C1	;  Is lines_to_cut > 1st count ???
		if ((poly_type and GOURAUD_POLY) or (poly_type and FAST_PHONG_POLY))
		 mov	eax,d ds:[@@G1-4]
		 imul	eax,edi		;EAX = Gouraud-cut value
		 sub	d ds:[@@G0-4],eax
		endif
		if (poly_type and CHROME_POLY)
		 mov	eax,d ds:[@@P1-4]
		 imul	eax,edi		;EAX = Gouraud-cut value
		 sub	d ds:[@@P0-4],eax
		endif
		if (poly_type and TEXTURE_POLY)
		 mov	eax,d ds:[@@T1-4]
		 imul	eax,edi		;EAX = Gouraud-cut value
		 sub	d ds:[@@T0-4],eax
		endif
		imul	edi,d ds:[@@S2-4]
		sub	ecx,edi		;ECX = X1 + Slope*Clip
		xor	edi,edi		;EDI = Y0
		jmp	short N1

	C1:     add	esi,ebp		;ESI = New 2nd counter after cut
		if ((poly_type eq CHROME_GOURAUD_POLY) or (poly_type eq CHROME_PHONG_POLY))
		 push	eax
		 imul	eax,d ds:[@@G1-4]
		 mov	edx,d ds:[@@G3-4]
		 imul	edx,ebp
		 sub	eax,edx
		 add	d ds:[@@G0-4],eax
		 pop	eax
		 imul	eax,d ds:[@@P1-4]
		 mov	edx,d ds:[@@P3-4]
		 imul	edx,ebp
		 sub	eax,edx
		 add	d ds:[@@P0-4],eax
		else
		if ((poly_type eq TEXTURE_GOURAUD_POLY) or (poly_type eq TEXTURE_PHONG_POLY))
		 push	eax
		 imul	eax,d ds:[@@G1-4]
		 mov	edx,d ds:[@@G3-4]
		 imul	edx,ebp
		 sub	eax,edx
		 add	d ds:[@@G0-4],eax
		 pop	eax
		 imul	eax,d ds:[@@T1-4]
		 mov	edx,d ds:[@@T3-4]
		 imul	edx,ebp
		 sub	eax,edx
		 add	d ds:[@@T0-4],eax
		else
		if (poly_type eq TEXTURE_CHROME_POLY)
		 push	eax
		 imul	eax,d ds:[@@P1-4]
		 mov	edx,d ds:[@@P3-4]
		 imul	edx,ebp
		 sub	eax,edx
		 add	d ds:[@@P0-4],eax
		 pop	eax
		 imul	eax,d ds:[@@T1-4]
		 mov	edx,d ds:[@@T3-4]
		 imul	edx,ebp
		 sub	eax,edx
		 add	d ds:[@@T0-4],eax
		else
		 if ((poly_type and GOURAUD_POLY) or (poly_type and FAST_PHONG_POLY))
		  imul	eax,d ds:[@@G1-4]
		  mov	edx,d ds:[@@G3-4]
		  imul	edx,ebp
		  sub	eax,edx
		  add	d ds:[@@G0-4],eax
		  endif
		 if (poly_type and CHROME_POLY)
		  imul	eax,d ds:[@@P1-4]
		  mov	edx,d ds:[@@P3-4]
		  imul	edx,ebp
		  sub	eax,edx
		  add	d ds:[@@P0-4],eax
		 endif
		 if (poly_type and TEXTURE_POLY)
		  imul	eax,d ds:[@@T1-4]
		  mov	edx,d ds:[@@T3-4]
		  imul	edx,ebp
		  sub	eax,edx
		  add	d ds:[@@T0-4],eax
		 endif
		endif
		endif
		endif
		mov	ecx,d ds:[@@S4-4]
		imul	ebp,d ds:[@@S3-4]
		sub	ecx,ebp		;ECX = X1
		xor	edi,edi		;EDI = Y0
		xor	ebp,ebp		;EBP = 0 = 1st counter
		mov	d ds:[@@S4-4],ecx
	;
N1:	lea	eax,[edi+ebp]		;EAX = Y0 + 1st counter
	cmp	eax,ds:[GVE_Frame_Height]	;Need lower clipping ???
	jl	short N2
		sub	eax,ds:[GVE_Frame_Height]
		xor	esi,esi		;Clear 2nd counter
		sub	ebp,eax		;EBP -= Lines to cut
		jmp	short N3
N2:	add	eax,esi			;EAX += 2nd counter
	cmp	eax,ds:[GVE_Frame_Height]
	jl	short N3
		sub	eax,ds:[GVE_Frame_Height]
		sub	esi,eax		;ESI -= lines to cut

N3:    	ENDM
;
;
; CLIP_HORIZONTAL:
;  Input:
;	EBX	- X0 (16:16 fixed point)
;	ECX	- X1 (16:16 fixed point)
;	EAX	- Gouraud-Value
;	EDX	- Gouraud-Increment
;  Output:
;	EBX	- X0 (integer)
;	ECX	- X1 (integer)
;	EAX	- Gouraud-value
;  Destroys:
;	Nothing except flags
;
CLIP_HORIZONTAL MACRO poly_type
	LOCAL 	N1,N2
	sar	ebx,16
	sar	ecx,16
	jle	@@N			;No line to draw !
	cmp	ebx,ds:[GVE_Frame_Width]
	jge	@@N			;No line to draw !
	;
	if ((poly_type eq CHROME_GOURAUD_POLY) or (poly_type eq TEXTURE_GOURAUD_POLY))
	 mov	esi,12345678h		;ESI = Gouraud-start value
@@G0:	 sar	esi,GVE_SHAD_SHIFT-13
	endif
	if ((poly_type eq CHROME_PHONG_POLY) or (poly_type eq TEXTURE_PHONG_POLY))
	 mov	esi,12345678h		;ESI = Gouraud-start value
@@G0:	 sar	esi,GVE_SHAD_SHIFT-15
	endif
	if (poly_type eq TEXTURE_CHROME_POLY)
	 mov	edx,12345678h		;EDX = PhongMap coordinates
@@P0:	endif
	;
	test	ebx,ebx
	jns	short N1
		if ((poly_type eq CHROME_GOURAUD_POLY) or (poly_type eq CHROME_PHONG_POLY) or\
		    (poly_type eq TEXTURE_GOURAUD_POLY) or (poly_type eq TEXTURE_PHONG_POLY))
		 push	ebx
		 imul	ebx,d ds:[@@G2-4]
		 sub	esi,ebx
		 pop	ebx
		 imul 	ebx,edx		;EDX = Texture_Increment*Lines_to_Skip
		 sub	eax,ebx		;EAX = Texture-Value
		else
		if (poly_type eq TEXTURE_CHROME_POLY)
		 push	ebx
		 imul	ebx,d ds:[@@P2-4]
		 sub	edx,ebx   	;EDX = PhongMap-Value
		 pop	ebx
		 imul 	ebx,d ds:[@@T2-4]
		 sub	eax,ebx		;EAX = Texture-Value
		else
		 if ((poly_type and GOURAUD_POLY) or (poly_type and FAST_PHONG_POLY))
		   imul ebx,edx		;EDX = Gouraud_Increment*Lines_to_Skip
		   sub	eax,ebx		;EAX = Gouraud-Value
		 endif
		 if ((poly_type and CHROME_POLY) or (poly_type and TEXTURE_POLY))
		   imul	ebx,edx		;EDX = Texture_Increment*Lines_to_Skip
		   sub	eax,ebx		;EAX = Texture-Value
		 endif
		endif
		endif
		xor	ebx,ebx		;Start at zero !
	;
N1:	cmp	ecx,ds:[GVE_Frame_Width]
	jl	short N2
		mov	ecx,ds:[GVE_Frame_Width]
N2:	ENDM
