;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
SMART
WARN ICG


GVE_SYSTEM_FILE		equ	1
GVE_PRO			equ	1


;
;
;
;   GOMEZ VECTOR ENGINE  pro                        16bit raster algorithms
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gve32.inc
include gomez.inc
include gpp.inc
include gverst.inc



;
;   GOMEZ VECTOR ENGINE   pro     			DATA AREA
;
extrn C GVE_Frame_Width:DWORD
extrn C GVE_Frame_Height:DWORD
extrn C GVE_Frame_Depth:DWORD
extrn C GVE_Frame_Line_Size:DWORD
extrn C GVE_Frame_Buffer:DWORD
extrn GVE_Glass_LUT:DWORD
extrn GVE_Shading_LUT:DWORD
extrn GVE_Bump_LUT:DWORD
extrn GVE_Blurr_LUT:DWORD
extrn GVE_PhongMap_List:DWORD
extrn GVE_Texture_List:DWORD
extrn GVE_BumpMap_List:DWORD
extrn GVE_Soften_Mask:DWORD

extrn Phong_Texture_Table:BYTE
extrn Phong_Table:BYTE
extrn Carva_Table:BYTE

Counter_V01		dd		?
Counter_V12		dd		?
Counter_V02		dd		?



;
;
;
;   GOMEZ VECTOR ENGINE  pro                             RASTER ALGORITHMS
;
;
;
;
;
; These are the lowest-end drawing functions for the various objects.
; Like in the GMI, I use a quick and nice table for indexing all functions
;
; O.k. Here are some things you must keep in mind when coding new methods:
; 1.) ES is set to data/code segment
;     DS is set to data/code segment
; 2.) DS:ESI points to the primitive header
; 3.) DS:EBP points to the current entry in the order table
;     (But I think you won't need that one...)
; 4.) The following registers MUST be saved: ES, DS and EBP
;
PUBLIC GVE_Method_Table16
GVE_Method_Table16 LABEL DWORD
	dd Draw16_Nothing			;0
	dd Draw16_Wire_Triple            	;4
	dd Draw16_Filled_Triple          	;8
	dd Draw16_Lambert_Triple         	;12
	dd Draw16_Gouraud_Triple         	;16
	dd Draw16_Phong_Triple           	;20
	dd Draw16_Glass_Triple           	;24
	dd Draw16_Lambert_Glass_Triple   	;28
	dd Draw16_Gouraud_Glass_Triple   	;32
	dd Draw16_Phong_Glass_Triple     	;36
	dd Draw16_Texture_Triple         	;40
	dd Draw16_Lambert_Texture_Triple 	;44
	dd Draw16_Gouraud_Texture_Triple 	;48
	dd Draw16_Phong_Texture_Triple   	;52
	dd Draw16_Bump_Chrome_Triple 		;56
	dd Draw16_Chrome_Triple          	;60
	dd Draw16_Lambert_Chrome_Triple  	;64
	dd Draw16_Gouraud_Chrome_Triple  	;68
	dd Draw16_Phong_Chrome_Triple    	;72
	dd Draw16_Fast_Phong_Triple      	;76
	dd Draw16_Glass_Texture_Triple   	;80
	dd Draw16_Glass_Chrome_Triple    	;84
	dd Draw16_Bump_Triple         		;88
	dd Draw16_Lambert_Bump_Triple 		;92
	dd Draw16_Gouraud_Bump_Triple 		;96
	dd Draw16_Phong_Bump_Triple   		;100
	dd Draw16_Glass_Bump_Triple       	;104
	dd Draw16_Soft_Wire_Triple        	;108
	dd Draw16_Glass_Wire_Triple       	;112
	dd Draw16_Lightmap_Texture_Triple   	;116
	dd Draw16_Chrome_Texture_Triple   	;120
	dd Draw16_Lightmap_Bump_Triple    	;124
	dd Draw16_Vertices               	;128
	dd Draw16_Carva_Triple			;132
	dd Draw16_Lambert_Carva_Triple		;136
	dd Draw16_Gouraud_Carva_Triple		;140
	dd Draw16_Phong_Carva_Triple		;144
	dd Draw16_Glass_Carva_Triple		;148
	dd Draw16_PTexture_Triple		;152
	dd Draw16_Lambert_PTexture_Triple	;156
	dd Draw16_Gouraud_PTexture_Triple	;160
	dd Draw16_Phong_PTexture_Triple		;164
	dd Draw16_LightMap_PTexture_Triple	;168
	dd Draw16_Chrome_PTexture_Triple	;172
	dd Draw16_Glass_PTexture_Triple		;176
	dd Draw16_Bump_Texture_Triple		;180
	dd 64-(($-GVE_METHOD_TABLE16)/4) DUP (OFFSET Draw16_Nothing)
;
Draw16_Nothing:
Draw16_Soft_Wire_Triple:
Draw16_Phong_Triple:
	retn
;
;
;
; First some easy things: wire-frame models
;
Draw16_Wire_Triple PROC NEAR
	xor	eax,eax
	mov	ebx,ds:[GVE_Shading_LUT]
	xor	ecx,ecx
	mov	al,ds:[esi+Triangle_Colour]	;AL  = colour
	mov	cl,ds:[esi+Triangle_Vertex_Count]	;ECX = Poly-Counter
	mov	eax,ds:[ebx+2*eax+32*512]
	push	ebp
	mov	w ds:[@@COL-2],ax	;Save colour


	mov	ebp,ds:[esi+24]			;EBP = first vertex
	mov	ecx,ds:[ebp+Vertex_ScreenX]	;ECX = X2
	mov	edx,ds:[ebp+Vertex_ScreenY]	;EDX = Y2
	sar	ecx,16				;Unshift X-value
	;
	movzx	ebp,byte ptr ds:[esi+3]		;EBP = number of vertices
@@L1:   push	ebp				;Save counter
	mov	ebp,ds:[esi+20+4*ebp]		;EBP = n-th vertex
	mov	eax,ds:[ebp+Vertex_ScreenX]	;EAX = X1
	mov	ebx,ds:[ebp+Vertex_ScreenY]	;EBX = Y1
	sar	eax,16
	push	ebx				;Save Y1
	push	eax				;Save X1
	;
	mov     ebx,4340h         		;EBX = Code for INC EBX / INC EAX
	sub	ecx,eax				;ECX = DeltaX = X2-X1
	jge     short @@J1        		;Is X2>X1?
		mov     bl,48h           	;No, code for DEC EAX
		neg     ecx               	; and invert DELTAX
@@J1:   sub     edx,ds:[ebp+Vertex_ScreenY]	;EDX = DeltaY = Y2-Y1
	jge     short @@J2        		;Y2 > Y1 ?
		mov     bh,4bh           	;No, code for DEC EBX
		neg     edx               	; and invert DELTAY
@@J2:  	mov     word ptr ds:[@@C3],bx      	;Save code
	cmp     ecx,edx            		;DeltaX > DeltaY ?
	jge     short @@J3
		mov     bl,90h           	;NOP
		xchg    ecx,edx            	;Swap DeltaX and DeltaY
		jmp     short @@J4
@@J3:  	mov     bh,90h

@@J4:   mov     word ptr ds:[@@C2],bx
	shl     edx,1             		;Calc IncB
	mov	d ds:[@@C4-4],edx              	;and save it in code !
	sub     edx,ecx            		;EDX = DAB
	sub     edx,ecx
	mov	d ds:[@@C6-4],edx		;  and save it in code !
	add	edx,ecx				;EDX = dab
	mov	eax,ds:[ebp+Vertex_ScreenX]	;EAX = X1
	mov	ebx,ds:[ebp+Vertex_ScreenY]	;EBX = Y1
	sar	eax,16				;Unshift X-value
	;
@@L2:   mov	edi,ebx
	cmp	ebx,ds:[GVE_Frame_Height]
	jae	short @@COL
	cmp	eax,ds:[GVE_Frame_Width]
	jae	short @@COL
	imul	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	mov	word ptr ds:[edi+2*eax],1234h   ;Set pixel !
@@COL:  test    edx,edx             		;DAB>0?
	jge     short @@C3        		;ja, verzweige
	@@C2:  	inc     eax            		;hier wird der
		inc     ebx            		;Code modifiziert
		add     edx,12345678h  		;DAB+=IncB
	@@C4:	dec	ecx
		jg 	short @@L2
		jmp     short @@Next    	;und weiter
	@@C3:   inc     eax               	;hier wird der
		inc     ebx		   	;Code modifiziert
		add     edx,12345678h      	;DAB+=IncA
	@@C6:	dec	ecx
		jg 	short @@L2
	;
@@Next: pop     ecx                     	;EDX = X2
	pop	edx				;ECX = Y2
	pop	ebp				;EBP = counter
	dec	ebp
	jnz	@@L1
	;
@@Exit: mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw16_Wire_Triple ENDP
;
Draw16_Glass_Wire_Triple PROC NEAR
	xor	eax,eax
	mov	ebx,ds:[GVE_Shading_LUT]
	xor	ecx,ecx
	mov	al,ds:[esi+Triangle_Colour]	;AL  = colour
	mov	cl,ds:[esi+Triangle_Vertex_Count];ECX = Poly-Counter
	mov	eax,ds:[ebx+2*eax+32*512]
	push	ebp
	and	eax,ds:[GVE_Soften_Mask]
	mov	d ds:[@@COL-4],eax	;Save colour

	mov	ebp,ds:[esi+24]			;EBP = first vertex
	mov	ecx,ds:[ebp+Vertex_ScreenX]	;EAX = X2
	mov	edx,ds:[ebp+Vertex_ScreenY]	;EDX = Y2
	sar	ecx,16				;Unshift X-value
	;
	movzx	ebp,byte ptr ds:[esi+3]		;EBP = number of vertices
@@L1:   push	ebp				;Save counter
	push	esi

	mov	ebp,ds:[esi+20+4*ebp]		;EBP = n-th vertex
	mov     ebx,4340h         		;EBX = Code for INC EBX / INC EAX
	mov	eax,ds:[ebp+Vertex_ScreenX]	;EAX = X1
	sar	eax,16				;Unshift X-value
	sub     ecx,eax            		;ECX = DeltaX = X2-X1
	push	eax				;Save X1 for next loop
	jge     short @@J1        		;Is X2>X1?
		mov     bl,48h           	;No, code for DEC EAX
		neg     ecx               	; and invert DELTAX
@@J1:  	push	d ds:[ebp+Vertex_ScreenY]    	;Save Y1 for next loop
	sub     edx,ds:[ebp+Vertex_ScreenY]	;EDX = DeltaY = Y2-Y1
	jge     short @@J2        		;Y2 > Y1 ?
		mov     bh,4bh           	;No, code for DEC EBX
		neg     edx               	; and invert DELTAY
@@J2:  	mov     word ptr ds:[@@C3],bx      	;Save code
	cmp     ecx,edx            		;DeltaX > DeltaY ?
	jge     short @@J3
		mov     bl,90h           	;NOP
		xchg    ecx,edx            	;Swap DeltaX and DeltaY
		jmp     short @@J4
@@J3:  	mov     bh,90h

@@J4:   mov	esi,edx				;ESI = Y2
	mov     word ptr ds:[@@C2],bx
	shl     esi,1             		;Calc IncB
	mov	d ds:[@@C4-4],esi              	;and save it in code !
	sub     esi,ecx            		;ESI = DAB
	sub     esi,ecx
	mov	d ds:[@@C6-4],esi		;  and save it in code !
	add	esi,ecx				;ESI = dab
	mov	eax,ds:[ebp+Vertex_ScreenX]	;EAX = X1
	mov	ebx,ds:[ebp+Vertex_ScreenY]	;EBX = Y1
	sar	eax,16				;Unshift X-value
	xor	edx,edx
	;
@@L2:   mov	edi,ebx
	cmp	ebx,ds:[GVE_Frame_Height]
	jae	short @@J5
	cmp	eax,ds:[GVE_Frame_Width]
	jae	short @@J5
	imul	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	mov	dx,ds:[edi+2*eax]		;Get old colour
	and	edx,ds:[GVE_Soften_Mask]
	add	edx,12345678h
@@COL:  shr	edx,1
	mov	w ds:[edi+2*eax],dx       	;Set pixel !
@@J5:	test    esi,esi           		;DAB>0?
	jge     short @@C3        		;ja, verzweige
	@@C2:  	inc     eax            		;hier wird der
		inc     ebx            		;Code modifiziert
		add     esi,12345678h  		;DAB+=IncB
	@@C4:	dec	ecx
		jg 	short @@L2
		jmp     short @@Next    	;und weiter
	@@C3:   inc     eax               	;hier wird der
		inc     ebx		   	;Code modifiziert
		add     esi,12345678h      	;DAB+=IncA
	@@C6:	dec	ecx
		jg 	short @@L2
	;
@@Next: pop     edx                     	;EDX = Y2
	pop	ecx				;ECX = X2
	pop	esi				;ESI = ptr to polygon
	pop	ebp				;EBP = counter
	dec	ebp
	jnz	@@L1
	;
@@Exit: mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw16_Glass_Wire_Triple ENDP
;
;
;
; Now comes a class of filled polygons like constant shading, lambert
; shading, gouraud shading etc...
;
Draw16_Filled_Triple PROC NEAR
	xor	eax,eax
	mov	ebx,ds:[GVE_Shading_LUT]
	mov	al,ds:[esi+Triangle_Colour]	;Get colour
	push	ebp
	mov	ax,ds:[ebx+2*eax+32*512]

__Draw16_Filled:
	mov	word ptr ds:[FCOL-2],ax
	mov	word ptr ds:[FCOL-4],ax
	GRAB_VERTICES SIMPLE_POLY
	GRAB_SLOPES SIMPLE_POLY
	CLIP_VERTICAL SIMPLE_POLY

	;
	;Vertical drawing loop starts here !
	mov	edx,edi
	mov	eax,12345678h		;Get colour
FCOL:   imul 	edx,ds:[GVE_Frame_Line_Size]
	add	edx,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
@@L1:   push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL SIMPLE_POLY
	sub	ecx,ebx			;ECX = width of span
	lea	edi,[2*ebx+edx]		;EDI = EDX + X0
	jle	short @@N		;ECX >= 0 ==> Nothing to draw !
	shr	ecx,1			;Word mode !
	rep	stosd
	adc	cl,0
	rep	stosw			;Draw span !
@@N:   	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:	add	edx,ds:[GVE_Frame_Line_Size]
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		mov	dword ptr ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = New vertical count
		mov	ecx,12345678h
	@@S4:	xor 	esi,esi		;ESI = New 2nd vertical count (0)
		jmp	short @@L1	;Do loop again !

@@End: 	pop	ebp
	retn
Draw16_Filled_Triple ENDP
;
Draw16_Lambert_Triple PROC NEAR
	mov	ebx,ds:[esi+Triangle_Vertex1]
	push	ebp
	mov	eax,ds:[ebx+VShading]		;Get light-thingy
	mov	ebx,ds:[GVE_Shading_LUT]
	sar	eax,GVE_SHAD_SHIFT-5
	shl	eax,8				;EAX = Shading-table
	mov	al,ds:[esi+Triangle_Colour]	;EBX = colour
	mov	ax,ds:[2*eax+ebx+(32 shl 9)]

	jmp	__Draw16_Filled
Draw16_Lambert_Triple ENDP
;
Draw16_Gouraud_Triple PROC NEAR
	xor	eax,eax
	push	ebp
	mov	al,ds:[esi+Triangle_Colour]	;Get colour
	mov	ebx,ds:[GVE_SHading_LUT]
	lea	eax,[ebx+2*eax]
	mov	d ds:[@@COL-4],eax


	GRAB_VERTICES GOURAUD_POLY
	GRAB_SLOPES GOURAUD_POLY
	CLIP_VERTICAL GOURAUD_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get gouraud start value
@@G0:   mov	edx,12345678h		;Get horizontal gouraud slope
@@G2:   add	eax,1 shl GVE_SHAD_SHIFT
	imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start colour
	push	ebx			;Save X0
	push	ecx			;Save X1
	push	edx
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL GOURAUD_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;ECX <= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[2*ecx+edi]		;EDI = last pixel to draw
	shr	eax,GVE_SHAD_SHIFT-13
	xor	ecx,ecx
	sar	edx,GVE_SHAD_SHIFT-13
	mov	ch,ah

	@@L2:	add	eax,edx
		mov	si,ds:[2*ecx+12345678h]
	@@COL:	mov	ecx,eax
		mov	ds:[edi+2*ebx],si
		xor	cl,cl
		inc	ebx
		jnz	short @@L2

	pop	edi
@@N:	pop	edx
	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:   add	edi,ds:[GVE_Frame_Line_Size]
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@G1-4],12345678h
	@@G3:   jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Gouraud_Triple ENDP
;
;
; This is the fast phong-shading method. It simply interpolates the cosinus
; values between the vertices of the poly.
;
; Note that the actual shading formula looks like this:
;
;	light()=2*cos(/2)^n - 1
;
Draw16_Fast_Phong_Triple PROC NEAR
	xor	ecx,ecx
	xor	eax,eax
	mov	ch,ds:[esi+Triangle_Phong]
	mov	ebx,ds:[GVE_SHading_LUT]
	add	ecx,OFFSET Phong_Texture_Table-256
	mov	al,ds:[esi+Triangle_Colour]
	mov	d ds:[@@EXP-4],ecx	;ECX = address of phong-table
	lea	eax,[ebx+2*eax]
	push	ebp
	mov	d ds:[@@COL-4],eax


	GRAB_VERTICES FAST_PHONG_POLY
	GRAB_SLOPES FAST_PHONG_POLY
	CLIP_VERTICAL FAST_PHONG_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;EAX = cosine start value
@@G0:   mov	edx,12345678h		;EDX = horizontal cosine slope
@@G2:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	eax,1 shl GVE_SHAD_SHIFT
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start cosine value
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL FAST_PHONG_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	push	edx
	sar	eax,GVE_SHAD_SHIFT-15	;EAX = cosine value
	lea	edi,[edi+2*ecx]		;ESI = start pixel
	sar	edx,GVE_SHAD_SHIFT-15	;EDX = cosine increment
	xor	ecx,ecx

	@@L2:	movzx	esi,ah		;ESI = Gouraud value
		mov	ch,ds:[esi+12345678h]
	@@EXP:  add	eax,edx		;EAX += Gouraud-increment
		mov	si,ds:[2*ecx+12345678h]
	@@COL:  mov	ds:[edi+2*ebx],si
		inc	ebx		;EBX += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

@@E:	pop	edx
	pop	edi
@@N:   	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:   add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@G1-4],12345678h
	@@G3:   jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Fast_Phong_Triple ENDP
;
;
;
; Now comes a class of filled transparent polygons like constant shading,
; lambert shading, gouraud shading etc...
;
Draw16_Glass_Triple PROC NEAR
	xor	eax,eax
	mov	ebx,ds:[GVE_Shading_LUT]
	mov	al,ds:[esi+Triangle_Colour]
	push	ebp
	mov	ax,ds:[ebx+2*eax+32*512]

__Draw16_Glass:
	and	eax,ds:[GVE_Soften_Mask]
	mov	dword ptr ds:[@@COL-4],eax
	GRAB_VERTICES SIMPLE_POLY
	GRAB_SLOPES SIMPLE_POLY
	CLIP_VERTICAL SIMPLE_POLY

	;
	;Vertical drawing loop starts here !
	mov	edx,edi
	mov	eax,12345678h		;Get colour
@@COL:  imul 	edx,ds:[GVE_Frame_Line_Size]
	add	edx,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
@@L1:   push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL SIMPLE_POLY
	sub	ecx,ebx			;ECX = width of span
	lea	edi,[2*ebx+edx-2]	;EDI = EDX + X0
	jle	short @@N		;ECX >= 0 ==> Nothing to draw !
	@@L2:	mov	bx,ds:[edi+2*ecx]
		and	ebx,ds:[GVE_Soften_Mask]
		add	ebx,eax
		shr	ebx,1
		mov	ds:[edi+2*ecx],bx
		dec	ecx
		jnz	short @@L2

@@N:   	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:	add	edx,ds:[GVE_Frame_Line_Size]
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		mov	dword ptr ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = New vertical count
		mov	ecx,12345678h
	@@S4:	xor 	esi,esi		;ESI = New 2nd vertical count (0)
		jmp	short @@L1	;Do loop again !

@@End: 	pop	ebp
	retn
Draw16_Glass_Triple ENDP
;
Draw16_Lambert_Glass_Triple PROC NEAR
	mov	ebx,ds:[esi+Triangle_Vertex1]
	push	ebp
	mov	eax,ds:[ebx+VShading]	;Get light-thingy
	mov	ebx,ds:[GVE_Shading_LUT]
	sar	eax,GVE_SHAD_SHIFT-5
	shl	eax,8			;EAX = Shading-table
	mov	al,ds:[esi+Triangle_Colour]
	mov	ax,ds:[2*eax+ebx+(32 shl 9)]

	jmp	__Draw16_Glass
Draw16_Lambert_Glass_Triple ENDP
;
Draw16_Gouraud_Glass_Triple PROC NEAR
	xor	eax,eax
	push	ebp
	mov	ebx,ds:[GVE_SHading_LUT]
	mov	al,ds:[esi+Triangle_Colour]
	lea	eax,[ebx+2*eax]
	mov	d ds:[@@COL-4],eax


	GRAB_VERTICES GOURAUD_POLY
	GRAB_SLOPES GOURAUD_POLY
	CLIP_VERTICAL GOURAUD_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get gouraud start value
@@G0:   mov	edx,12345678h		;Get horizontal gouraud slope
@@G2:   add	eax,1 shl GVE_SHAD_SHIFT
	imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start colour
	push	ebx			;Save X0
	push	ecx			;Save X1
	push	edx
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL GOURAUD_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;ECX <= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+2*ecx]		;EDI = Last pixel in row
	shr	eax,GVE_SHAD_SHIFT-13
	xor	ecx,ecx
	sar	edx,GVE_SHAD_SHIFT-13
	mov	ch,ah

	@@L2:   mov	cx,ds:[2*ecx+12345678h]	;CX  = New colour
	@@COL:  mov	si,ds:[edi+2*ebx]	;SI  = Background colour
		and	ecx,ds:[GVE_Soften_Mask]
		and	esi,ds:[GVE_Soften_Mask]
		add	eax,edx			;EAX += Gouraud increment
		add	esi,ecx			;ESI = Sum of both colours
		mov	ecx,eax			;ECX = Gouraud value
		shr	esi,1			;ESI = AVerage colour
		xor	cl,cl
		mov	ds:[edi+2*ebx],si	;Set pixel
		inc	ebx
		jnz	short @@L2

	pop	edi
@@N:    pop	edx
	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:   add	edi,ds:[GVE_Frame_Line_Size]
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@G1-4],12345678h
	@@G3:   jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Gouraud_Glass_Triple ENDP
;
Draw16_Phong_Glass_Triple PROC NEAR
	xor	ecx,ecx
	xor	eax,eax
	mov	ch,ds:[esi+Triangle_Phong]
	mov	ebx,ds:[GVE_SHading_LUT]
	add	ecx,OFFSET Phong_Texture_Table-256
	mov	al,ds:[esi+Triangle_Colour]
	mov	d ds:[@@EXP-4],ecx	;ECX = address of phong-table
	lea	eax,[ebx+2*eax]
	push	ebp
	mov	d ds:[@@COL-4],eax


	GRAB_VERTICES FAST_PHONG_POLY
	GRAB_SLOPES FAST_PHONG_POLY
	CLIP_VERTICAL FAST_PHONG_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;EAX = cosine start value
@@G0:   mov	edx,12345678h		;EDX = horizontal cosine slope
@@G2:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	eax,1 shl GVE_SHAD_SHIFT
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start cosine value
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL FAST_PHONG_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	push	edx
	sar	eax,GVE_SHAD_SHIFT-15	;EAX = cosine value
	lea	edi,[edi+2*ecx]		;ESI = start pixel
	sar	edx,GVE_SHAD_SHIFT-15	;EDX = cosine increment
	xor	ecx,ecx

	@@L2:	movzx	esi,ah		;ESI = Gouraud value
		mov	ch,ds:[esi+12345678h]
	@@EXP:  add	eax,edx		;EAX += Gouraud-increment
		mov	si,ds:[2*ecx+12345678h]
	@@COL:	mov	cx,ds:[edi+2*ebx]
		and	esi,ds:[GVE_Soften_Mask]
		and	ecx,ds:[GVE_Soften_Mask]
		add	esi,ecx
		xor	ecx,ecx
		shr	esi,1
		mov	ds:[edi+2*ebx],si
		inc	ebx		;EBX += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	pop	edx
	pop	edi
@@N:   	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:   add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@G1-4],12345678h
	@@G3:   jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Phong_Glass_Triple ENDP
;
;
;
; Now comes a class of carva shaded polygons like constant shading, lambert
; shading, gouraud shading etc...
;
Draw16_Carva_Triple PROC NEAR
	xor	eax,eax
	mov	ebx,ds:[GVE_SHading_LUT]
	mov	al,ds:[esi+Triangle_Colour]
	push	ebp
	lea	eax,[ebx+2*eax+16*512]
	mov	d ds:[CALUT-4],eax

__Draw16_Carva:
	GRAB_VERTICES SIMPLE_POLY
	GRAB_SLOPES SIMPLE_POLY
	CLIP_VERTICAL SIMPLE_POLY

	;
	;Vertical drawing loop starts here !
	imul 	edi,ds:[GVE_Frame_Line_Size]
	and	edx,0ffh
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL SIMPLE_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+2*ecx]		;ESI += X0
	xor	ecx,ecx
	mov	ch,ds:[Carva_Table+edx]
	@@L2:	inc	dl
		mov	ax,ds:[12345678h+2*ecx]
	CALUT:  mov	ch,ds:[Carva_Table+edx]
		mov	ds:[esi+2*ebx],ax
		inc	ebx
		jnz	short @@L2

@@N:   	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	dword ptr ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = New vertical count
		mov	ecx,12345678h
	@@S4:	jmp	short @@L1	;Do loop again !

@@End: 	pop	ebp
	retn
Draw16_Carva_Triple ENDP
;
Draw16_Lambert_Carva_Triple PROC NEAR
	mov	ebx,ds:[esi+Triangle_Vertex1]		;EBX = first vector
	push	ebp
	mov	eax,1 shl GVE_SHAD_SHIFT
	add	eax,ds:[ebx+VShading]	;Get light-thingy
	sar	eax,GVE_SHAD_SHIFT-4-8
	mov	al,ds:[esi+Triangle_Colour]
	add	eax,eax
	add	eax,ds:[GVE_SHading_LUT]
	mov	d ds:[CALUT-4],eax

	jmp	__Draw16_Carva
Draw16_Lambert_Carva_Triple ENDP
;
Draw16_Gouraud_Carva_Triple PROC NEAR
	xor	eax,eax
	push	ebp
	mov	al,ds:[esi+Triangle_Colour]	;EAX = colour
	add	eax,eax
	add	eax,ds:[GVE_SHading_LUT]
	mov	d ds:[@@LUT-4],eax

	GRAB_VERTICES GOURAUD_POLY
	GRAB_SLOPES GOURAUD_POLY
	CLIP_VERTICAL GOURAUD_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get gouraud start value
@@G0:   imul 	edi,ds:[GVE_Frame_Line_Size]
	and	edx,0ffh
	add	edi,ds:[GVE_Frame_Buffer]
	mov	d ds:[@@C2-4],edx
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   mov	edx,12345678h           ;EDX = Gouraud increment
@@G2:	push	eax			;Save start colour
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	mov	esi,edx
	CLIP_HORIZONTAL GOURAUD_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	add	eax,1 shl GVE_SHAD_SHIFT
	lea	edi,[edi+2*ecx]		;EDI = start pixel
	sar	eax,GVE_SHAD_SHIFT-4-8	;EAX = gouraud colour
	mov	edx,12345678h
@@C2:	xor	ecx,ecx
	mov	ch,ah
	sar	esi,GVE_SHAD_SHIFT-4-8	;ESI = gouraud increment / get sign in carry
	add	ch,ds:[Carva_Table+edx]
	@@L2:   inc	dl			;EDX = Carva-Index
		mov	cx,ds:[12345678h+2*ecx] ;CH  = Colour
	@@LUT: 	add	eax,esi			;EAX = Gouraud value
		mov	ds:[edi+2*ebx],cx		;Set pixel
		mov	ch,ah			;ECX = Gouraud-Value
		add	ch,ds:[Carva_Table+edx] ;CH  = Carve value
		inc	ebx
		mov	cl,0
		jnz	short @@L2

	mov	d ds:[@@C2-4],edx
	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Gouraud_Carva_Triple ENDP
;
Draw16_Phong_Carva_Triple PROC NEAR
	jmp	Draw16_Gouraud_Carva_Triple
Draw16_Phong_Carva_Triple ENDP
;
Draw16_Glass_Carva_Triple PROC NEAR
	xor	eax,eax
	mov	ebx,ds:[GVE_SHading_LUT]
	mov	al,ds:[esi+Triangle_Colour]	;EAX = colour
	push	ebp
	lea	eax,[ebx+2*eax+16*512]
	mov	d ds:[@@LUT-4],eax

	GRAB_VERTICES SIMPLE_POLY
	GRAB_SLOPES SIMPLE_POLY
	CLIP_VERTICAL SIMPLE_POLY

	;
	;Vertical drawing loop starts here !
	imul 	edi,ds:[GVE_Frame_Line_Size]
	and	edx,0ffh
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL SIMPLE_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+2*ecx]		;ESI += X0
	xor	ecx,ecx
	mov	esi,ebx			;ESI = Counter
	mov	ch,ds:[Carva_Table+edx]
	@@L2:	inc	dl
		mov	ax,ds:[12345678h+2*ecx]
	@@LUT:  mov	bx,ds:[edi+2*esi]
		and	eax,ds:[GVE_Soften_Mask]
		and	ebx,ds:[GVE_Soften_Mask]
		mov	ch,ds:[Carva_Table+edx]
		add	eax,ebx
		shr	eax,1
		mov	ds:[edi+2*esi],ax
		inc	esi
		jnz	short @@L2

	pop	edi
@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	dword ptr ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = New vertical count
		mov	ecx,12345678h
	@@S4:	jmp	@@L1		;Do loop again !

@@End: 	pop	ebp
	retn
Draw16_Glass_Carva_Triple ENDP

;
;
;
; Now come some texture-routines
;
Draw16_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Shading_LUT]
	push	ebp
	add	ebx,32*512
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	mov	d ds:[TLLUT-4],ebx
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TLADR-4],eax


__Draw16_Texture:
	GRAB_VERTICES TEXTURE_POLY
	GRAB_SLOPES TEXTURE_POLY
	CLIP_VERTICAL TEXTURE_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   mov	edx,12345678h		;Get horizontal texture slope
@@T2:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+2*ecx]		;ESI = start pixel
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16			;AH  = Texture u-coordinate
	@@L2:	mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,edx		;ECX += Texture-increment
		movzx	eax,b ds:[eax+12345678h]
	TLADR: 	mov	ax,ds:[2*eax+12345678h]
	TLLUT:	mov	ds:[esi+2*ebx],ax
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	ebx		;EBX += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@T1-4],12345678h
	@@T3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Texture_Triple ENDP
;
Draw16_Lambert_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	edx,ds:[esi+Triangle_Vertex1]
	and	eax,3fffh
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[edx+VShading]	;EBX = light-thingy
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	sar	ebx,GVE_SHAD_SHIFT-5
	push	ebp
	add	ebx,32			;EBX = LUT-Number
	add	eax,GVE_BITMAP_SIZE
	shl	ebx,9
	mov	d ds:[TLADR-4],eax
	add	ebx,ds:[GVE_Shading_LUT]
	mov	d ds:[TLLUT-4],ebx

	jmp	__Draw16_Texture
Draw16_Lambert_Texture_Triple ENDP
;
Draw16_Gouraud_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Shading_LUT]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]
	mov	d ds:[TGLUT-4],ebx
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TGADR-4],eax

__Draw16_Gouraud_Texture:
	GRAB_VERTICES TEXTURE_GOURAUD_POLY
	GRAB_SLOPES TEXTURE_GOURAUD_POLY
	CLIP_VERTICAL TEXTURE_GOURAUD_POLY
	add	d ds:[@@G0-4],1 shl GVE_SHAD_SHIFT
	sar	d ds:[@@G2-4],GVE_SHAD_SHIFT-13

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   mov	edx,12345678h		;Get horizontal texture slope
@@T2:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_GOURAUD_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+2*ecx]		;EDI = start pixel
	mov	ecx,ebx
	mov	ebx,esi			;EBX = Gouraud-value
	mov	esi,ecx			;ESI = Vertical counter
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16			;AH  = Texture u-coordinate
	@@L2:	mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,edx		;ECX += Texture-increment
		mov	al,b ds:[eax+12345678h]
	TGADR:  mov	ah,bh		;AH  = gouraud value
		mov	ax,ds:[2*eax+12345678h]
	TGLUT:  add	ebx,12345678h	;EBX += Gouraud-increment
	@@G2:	mov	ds:[edi+2*esi],ax
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	esi		;ESI += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@G0-4],12345678h	;Increment vertical gouraud value
@@G1:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Gouraud_Texture_Triple ENDP
;
Draw16_Phong_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	xor	edx,edx
	and	eax,3fffh
	mov	dh,ds:[esi+Triangle_Phong]	;EDX = phong-exponent
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_Shading_LUT]
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	add	edx,OFFSET Phong_Texture_Table-256
	push	ebp
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TPTBL-4],edx
	mov	d ds:[TPLUT-4],ebx
	mov	d ds:[TPADR-4],eax


__Draw16_Phong_Texture:
	GRAB_VERTICES TEXTURE_PHONG_POLY
	GRAB_SLOPES TEXTURE_PHONG_POLY
	CLIP_VERTICAL TEXTURE_PHONG_POLY
	add	d ds:[@@G0-4],1 shl GVE_SHAD_SHIFT
	sar	d ds:[@@G2-4],GVE_SHAD_SHIFT-15

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   mov	edx,12345678h		;Get horizontal texture slope
@@T2:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	push	edx
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_PHONG_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	push	ebp
	lea	edi,[edi+2*ecx]		;EDI = start pixel
	mov	ebp,ebx			;EBP = counter
	mov	ebx,esi			;EBX = Gouraud-value
	mov	ecx,eax			;ECX = Texture (u,v) start
	mov	esi,edx			;ESI = texture-increment
	xor	edx,edx
	shr	eax,16			;AH  = Texture u-coordinate

	@@L2:	mov	dl,bh		;EDX = Gouraud value
		mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,esi		;ECX += Texture-increment
		mov	al,b ds:[eax+12345678h]
	TPADR:  mov	ah,ds:[edx+12345678h]
	TPTBL:	mov	ax,ds:[2*eax+12345678h]
	TPLUT:  add	ebx,12345678h	;EBX += Gouraud-increment
	@@G2:	mov	ds:[edi+2*ebp],ax
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	ebp		;ESI += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	pop	ebp
	pop	edi
@@N:	pop	edx
	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@G0-4],12345678h	;Increment vertical gouraud value
@@G1:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Phong_Texture_Triple ENDP
;
Draw16_Glass_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Shading_LUT]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	add	ebx,32*512
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TTLUT-4],ebx
	mov	d ds:[TTADR-4],eax


__Draw16_Glass_Texture:
	GRAB_VERTICES TEXTURE_POLY
	GRAB_SLOPES TEXTURE_POLY
	CLIP_VERTICAL TEXTURE_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   mov	edx,12345678h		;Get horizontal texture slope
@@T2:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+2*ecx]		;ESI = start pixel
	mov	esi,edx
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16			;AH  = Texture u-coordinate
	@@L2:	mov    	al,ch		;EAX = texture (u,v)-coordinate
		xor	edx,edx
		add	ecx,esi		;ECX += Texture-increment
		mov	dl,b ds:[eax+12345678h]
	TTADR: 	mov	ax,ds:[2*edx+12345678h]
	TTLUT:	mov	dx,ds:[edi+2*ebx]
		and	eax,ds:[GVE_Soften_Mask]
		and	edx,ds:[GVE_Soften_Mask]
		add	edx,eax
		mov	eax,ecx
		shr	edx,1
		shr	eax,16		;AH   = texture u-coordinate
		mov	ds:[edi+2*ebx],dx
		inc	ebx		;EBX += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	mov	edx,esi			;EDX = texture-increment
	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@T1-4],12345678h
	@@T3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Glass_Texture_Triple ENDP
;
Draw16_Lightmap_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	xor	edx,edx
	and	eax,3fffh
	mov	dl,ds:[esi+Triangle_Phong]	;EDX = lightmap-number
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_PhongMap_List]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]	;EAX = texture-address
	mov	edx,ds:[4*edx+4+ebx]	;EDX = lightmap-address
	mov	ebx,ds:[GVE_Shading_LUT]
	add	eax,GVE_BITMAP_SIZE
	add	edx,GVE_BITMAP_SIZE
	mov	d ds:[TMTXT-4],eax
	mov	d ds:[TMLUT-4],ebx
	mov	d ds:[TMMAP-4],edx


__Draw16_Lightmap_Texture:
	GRAB_VERTICES TEXTURE_CHROME_POLY
	GRAB_SLOPES TEXTURE_CHROME_POLY
	CLIP_VERTICAL TEXTURE_CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+2*ecx-2]	;EDI = start pixel
	mov	esi,ebx			;ESI = horizontal counter
	@@L2:   mov	ecx,eax
		mov	ebx,edx
		shr	ecx,16
		shr	ebx,16
		mov    	cl,ah		;ECX = texture (u,v)-coordinate
		mov	bl,dh		;EBX = chrome (u,v)-coordinate
		add	eax,12345678h	;ECX += Texture-increment
	@@T2:	mov	cl,b ds:[ecx+12345678h]
	TMTXT:  mov	ch,b ds:[ebx+12345678h]
	TMMAP:  add	edx,12345678h	;EDX += chrome-increment
	@@P2:   mov	cx,ds:[2*ecx+12345678h]
	TMLUT:  inc	esi		;ESI += 1  (horizontal counter)
		mov	ds:[edi+2*esi],cx
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@P0-4],12345678h	;Increment vertical gouraud value
@@P1:	add	edi,ds:[GVE_Frame_Line_Size]
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Lightmap_Texture_Triple ENDP
;
Draw16_Chrome_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	xor	edx,edx
	and	eax,3fffh
	mov	dl,ds:[esi+Triangle_Phong]	;EDX = lightmap-number
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_PhongMap_List]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]	;EAX = texture-address
	mov	edx,ds:[4*edx+4+ebx]	;EDX = lightmap-address
	mov	ebx,ds:[GVE_Glass_LUT]
	add	eax,GVE_BITMAP_SIZE
	add	edx,GVE_BITMAP_SIZE
	mov	d ds:[TCTXT-4],eax
	mov	d ds:[TCLUT-4],ebx
	mov	d ds:[TCMAP-4],edx


__Draw16_Chrome_Texture:
	GRAB_VERTICES TEXTURE_CHROME_POLY
	GRAB_SLOPES TEXTURE_CHROME_POLY
	CLIP_VERTICAL TEXTURE_CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+2*ecx-2]	;EDI = start pixel
	mov	esi,ebx			;ESI = horizontal counter
	@@L2:   mov	ecx,eax
		mov	ebx,edx
		shr	ecx,16
		shr	ebx,16
		mov    	cl,ah		;ECX = texture (u,v)-coordinate
		mov	bl,dh		;EBX = chrome (u,v)-coordinate
		add	eax,12345678h	;ECX += Texture-increment
	@@T2:	mov	cl,b ds:[ecx+12345678h]
	TCTXT:  mov	ch,b ds:[ebx+12345678h]
	TCMAP:  add	edx,12345678h	;EDX += chrome-increment
	@@P2:   mov	cx,ds:[2*ecx+12345678h]
	TCLUT:  inc	esi		;ESI += 1  (horizontal counter)
		mov	ds:[edi+2*esi],cx
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@P0-4],12345678h	;Increment vertical gouraud value
@@P1:	add	edi,ds:[GVE_Frame_Line_Size]
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Chrome_Texture_Triple ENDP
;
;
;
; Now come some bump-mapping-routines. They simply use another shading-LUT.
;
Draw16_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Bump_LUT]
	push	ebp
	add	ebx,32*512
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	mov	d ds:[TLLUT-4],ebx
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TLADR-4],eax

	jmp	__Draw16_Texture
Draw16_Bump_Triple ENDP
;
Draw16_Lambert_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	edx,ds:[esi+24]		;EDX = first vector
	and	eax,3fffh
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[edx+VShading]	;EBX = light-thingy
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	sar	ebx,GVE_SHAD_SHIFT-5
	push	ebp
	add	ebx,32			;EBX = LUT-Number
	add	eax,GVE_BITMAP_SIZE
	shl	ebx,9
	mov	d ds:[TLADR-4],eax
	add	ebx,ds:[GVE_Bump_LUT]
	mov	d ds:[TLLUT-4],ebx

	jmp	__Draw16_Texture
Draw16_Lambert_Bump_Triple ENDP
;
Draw16_Gouraud_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Bump_LUT]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]
	mov	d ds:[TGLUT-4],ebx
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TGADR-4],eax

	jmp	__Draw16_Gouraud_Texture
Draw16_Gouraud_Bump_Triple ENDP
;
Draw16_Phong_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	xor	edx,edx
	and	eax,3fffh
	mov	dh,ds:[esi+Triangle_Phong]	;EDX = phong-exponent
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_Shading_LUT]
	mov	eax,ds:[4*eax+4+ecx]		;*8 bytes/entry
	add	edx,OFFSET Phong_Texture_Table-256
	push	ebp
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TPTBL-4],edx
	mov	d ds:[TPLUT-4],ebx
	mov	d ds:[TPADR-4],eax

	jmp	__Draw16_Phong_Texture
Draw16_Phong_Bump_Triple ENDP
;
Draw16_Glass_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Bump_LUT]
	push	ebp
	add	ebx,32*512
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	mov	d ds:[TTLUT-4],ebx
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TTADR-4],eax

	jmp	__Draw16_Glass_Texture
Draw16_Glass_Bump_Triple ENDP
;
Draw16_Lightmap_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	xor	edx,edx
	and	eax,3fffh
	mov	dl,ds:[esi+Triangle_Phong]	;EDX = lightmap-number
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_PhongMap_List]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]	;EAX = texture-address
	mov	edx,ds:[4*edx+4+ebx]	;EDX = lightmap-address
	mov	ebx,ds:[GVE_Bump_LUT]
	add	eax,GVE_BITMAP_SIZE
	add	edx,GVE_BITMAP_SIZE
	mov	d ds:[TMTXT-4],eax
	mov	d ds:[TMLUT-4],ebx
	mov	d ds:[TMMAP-4],edx

	jmp	__Draw16_Lightmap_Texture
Draw16_Lightmap_Bump_Triple ENDP

;
;
;
; Now come some chrome-mapping-routines that may also be used to simulate
; a better phong-shding
;
Draw16_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Shading_LUT]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	add	ebx,32*512
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[CLLUT-4],ebx
	mov	d ds:[CLADR-4],eax


__Draw16_Chrome:
	GRAB_VERTICES CHROME_POLY
	GRAB_SLOPES CHROME_POLY
	CLIP_VERTICAL CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@P0:   mov	edx,12345678h		;Get horizontal texture slope
@@P2:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+2*ecx]		;EDI = start pixel
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16			;AH  = Texture u-coordinate
	@@L2:   mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,edx		;ECX += Texture-increment
		movzx	eax,b ds:[eax+12345678h]
	CLADR:  mov	ax,ds:[2*eax+12345678h]
	CLLUT:	mov	ds:[esi+2*ebx],ax
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	ebx		;EBX += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@P1:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Chrome_Triple ENDP
;
Draw16_Lambert_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	edx,ds:[esi+24]		;EDX = first vector
	and	eax,3fffh
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[edx+VShading]	;EBX = light-thingy
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	sar	ebx,GVE_SHAD_SHIFT-5
	push	ebp
	add	ebx,32			;EBX = LUT-Number
	add	eax,GVE_BITMAP_SIZE
	shl	ebx,9
	mov	d ds:[CLADR-4],eax
	add	ebx,ds:[GVE_Shading_LUT]
	mov	d ds:[CLLUT-4],ebx

	jmp	__Draw16_Chrome
Draw16_Lambert_Chrome_Triple ENDP
;
Draw16_Gouraud_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Shading_LUT]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]
	mov	d ds:[CGLUT-4],ebx
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[CGADR-4],eax

	GRAB_VERTICES CHROME_GOURAUD_POLY
	GRAB_SLOPES CHROME_GOURAUD_POLY
	CLIP_VERTICAL CHROME_GOURAUD_POLY
	add	d ds:[@@G0-4],1 shl GVE_SHAD_SHIFT
	sar	d ds:[@@G2-4],GVE_SHAD_SHIFT-13

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@P0:   mov	edx,12345678h		;Get horizontal texture slope
@@P2:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL CHROME_GOURAUD_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw
	push	edi
	lea	edi,[edi+2*ecx]		;EDI = start pixel
	mov	ecx,ebx
	mov	ebx,esi			;EBX = Gouraud-value
	mov	esi,ecx			;ESI = Vertical counter
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16			;AH  = Texture u-coordinate
	@@L2:	mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,edx		;ECX += Texture-increment
		mov	al,b ds:[eax+12345678h]
	CGADR:  mov	ah,bh		;AH  = gouraud value
		mov	ax,ds:[2*eax+12345678h]
	CGLUT:  add	ebx,12345678h	;EBX += Gouraud-increment
	@@G2:	mov	ds:[edi+2*esi],ax
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	esi		;ESI += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@P1:   add     d ds:[@@G0-4],12345678h	;Increment vertical gouraud value
@@G1:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@P1-4],12345678h
	@@P3:	mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Gouraud_Chrome_Triple ENDP
;
Draw16_Phong_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	xor	edx,edx
	and	eax,3fffh
	mov	dh,ds:[esi+Triangle_Phong]	;EDX = phong-exponent
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_Shading_LUT]
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	add	edx,OFFSET Phong_Texture_Table-256
	add	eax,GVE_BITMAP_SIZE
	push	ebp
	mov	d ds:[CPTBL-4],edx
	mov	d ds:[CPLUT-4],ebx
	mov	d ds:[CPADR-4],eax

	GRAB_VERTICES CHROME_PHONG_POLY
	GRAB_SLOPES CHROME_PHONG_POLY
	CLIP_VERTICAL CHROME_PHONG_POLY
	add	d ds:[@@G0-4],1 shl GVE_SHAD_SHIFT
	sar	d ds:[@@G2-4],GVE_SHAD_SHIFT-15

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@P0:   mov	edx,12345678h		;Get horizontal texture slope
@@P2:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	push	edx
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL CHROME_PHONG_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	push	ebp
	lea	edi,[edi+2*ecx]		;EDI = start pixel
	mov	ebp,ebx			;EBP = counter
	mov	ebx,esi			;EBX = Gouraud-value
	mov	ecx,eax			;ECX = Texture (u,v) start
	mov	esi,edx			;ESI = texture-increment
	xor	edx,edx
	shr	eax,16			;AH  = Texture u-coordinate

	@@L2:	mov	dl,bh		;EDX = Gouraud value
		mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,esi		;ECX += Texture-increment
		mov	al,b ds:[eax+12345678h]
	CPADR:  mov	ah,ds:[edx+12345678h]
	CPTBL:	mov	ax,ds:[2*eax+12345678h]
	CPLUT:  add	ebx,12345678h	;EBX += Gouraud-increment
	@@G2:	mov	ds:[edi+2*ebp],ax
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	ebp		;ESI += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	pop	ebp
	pop	edi
@@N:	pop	edx
	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@P1:   add     d ds:[@@G0-4],12345678h	;Increment vertical gouraud value
@@G1:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@P1-4],12345678h
	@@P3:	mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Phong_Chrome_Triple ENDP
;
Draw16_Glass_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Shading_LUT]
	push	ebp
	add	ebx,32*512
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	mov	d ds:[@@LUT-4],ebx
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[@@ADR-4],eax


	GRAB_VERTICES CHROME_POLY
	GRAB_SLOPES CHROME_POLY
	CLIP_VERTICAL CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@P0:   mov	edx,12345678h		;Get horizontal texture slope
@@P2:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+2*ecx]		;ESI = start pixel
	mov	esi,edx
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16			;AH  = Texture u-coordinate
	@@L2:	mov    	al,ch		;EAX = texture (u,v)-coordinate
		xor	edx,edx
		add	ecx,esi		;ECX += Texture-increment
		mov	dl,b ds:[eax+12345678h]
	@@ADR: 	mov	ax,ds:[2*edx+12345678h]
	@@LUT:	mov	dx,ds:[edi+2*ebx]
		and	eax,ds:[GVE_Soften_Mask]
		and	edx,ds:[GVE_Soften_Mask]
		add	edx,eax
		mov	eax,ecx
		shr	edx,1
		shr	eax,16		;AH   = texture u-coordinate
		mov	ds:[edi+2*ebx],dx
		inc	ebx		;EBX += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	mov	edx,esi			;EDX = texture-increment
	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@P1:	add	edi,ds:[GVE_Frame_Line_Size]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Glass_Chrome_Triple ENDP
;
;
;
; Now a new texture-plasma mapper
;
Draw16_Bump_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]
	xor	edx,edx
	and	eax,3fffh
	mov	dl,ds:[esi+Triangle_Bump]	;EDX = bumpmap-number
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_BumpMap_List]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]	;EAX = texture-address
	mov	ebx,ds:[4*edx+4+ebx]	;EBX = bumpmap-address
	mov	edx,ds:[GVE_Shading_LUT]
	add	eax,GVE_BITMAP_SIZE
	add	ebx,GVE_BITMAP_SIZE
	add	edx,32*512
	mov	d ds:[BCTXT-4],eax
	mov	d ds:[BCMAP-4],ebx
	mov	d ds:[BCLUT-4],edx


	GRAB_VERTICES TEXTURE_CHROME_POLY
	GRAB_SLOPES TEXTURE_CHROME_POLY
	CLIP_VERTICAL TEXTURE_CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+2*ecx-2]	;EDI = start pixel
	mov	esi,ebx			;ESI = horizontal counter
	@@L2:   mov	ecx,eax
		mov	ebx,edx
		shr	ecx,16
		shr	ebx,16
		mov    	cl,ah		;ECX = texture (u,v)-coordinate
		mov	bl,dh		;EBX = chrome (u,v)-coordinate
		add	eax,12345678h	;ECX += Texture-increment
	@@T2:  	add	bx,ds:[2*ecx+12345678h]
	BCMAP:  movzx	ecx,b ds:[ebx+12345678h]
	BCTXT:  add	edx,12345678h	;EDX += chrome-increment
	@@P2:   mov	cx,ds:[2*ecx+12345678h]
	BCLUT:  inc	esi		;ESI += 1  (horizontal counter)
		mov	ds:[edi+2*esi],cx
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@P0-4],12345678h	;Increment vertical gouraud value
@@P1:	add	edi,ds:[GVE_Frame_Line_Size]
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Bump_Chrome_Triple ENDP
;
Draw16_Bump_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	xor	edx,edx
	and	eax,3fffh
	mov	dl,ds:[esi+Triangle_Phong]	;EDX = lightmap-number
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_PhongMap_List]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]		;EAX = texture-address
	movzx	ecx,ds:[esi+Triangle_Bump]
	mov	ebx,ds:[4*edx+4+ebx]		;EBX = lightmap-address
	mov	edx,ds:[GVE_BumpMap_List]
	mov	ecx,ds:[4*ecx+4+edx]		;ECX = Bumpmap-address
	mov	edx,ds:[GVE_Shading_LUT]
	add	eax,GVE_BITMAP_SIZE
	add	ebx,GVE_BITMAP_SIZE
	add	ecx,GVE_BITMAP_SIZE
	mov	d ds:[BTTXT-4],eax
	mov	d ds:[BTMAP-4],ebx
	mov	d ds:[BTBMP-4],ecx
	mov	d ds:[BTLUT-4],edx


	GRAB_VERTICES TEXTURE_CHROME_POLY
	GRAB_SLOPES TEXTURE_CHROME_POLY
	CLIP_VERTICAL TEXTURE_CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   imul 	edi,ds:[GVE_Frame_Line_Size]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+2*ecx-2]	;EDI = start pixel
	mov	esi,ebx			;ESI = horizontal counter
	@@L2:   mov	ecx,eax
		mov	ebx,edx
		shr	ecx,16
		shr	ebx,16
		mov    	cl,ah		;ECX = texture (u,v)-coordinate
		mov	bl,dh		;EBX = chrome (u,v)-coordinate
		add	eax,12345678h	;ECX += Texture-increment
	@@T2:   add	bx,ds:[2*ecx+12345678h]
	BTBMP:	mov	cl,ds:[ecx+12345678h]
	BTTXT:  mov	ch,ds:[ebx+12345678h]
	BTMAP:  add	edx,12345678h	;EDX += chrome-increment
	@@P2:   mov	cx,ds:[2*ecx+12345678h]
	BTLUT:  inc	esi		;ESI += 1  (horizontal counter)
		mov	ds:[edi+2*esi],cx
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@P0-4],12345678h	;Increment vertical gouraud value
@@P1:	add	edi,ds:[GVE_Frame_Line_Size]
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw16_Bump_Texture_Triple ENDP
;
;
;
; The following texture-mappers have perspective correction
;
Draw16_PTexture_Triple PROC NEAR
	retn
Draw16_PTexture_Triple ENDP
;
Draw16_Lambert_PTexture_Triple:
Draw16_Gouraud_PTexture_Triple:
Draw16_Phong_PTexture_Triple:
Draw16_Lightmap_PTexture_Triple:
Draw16_Chrome_PTexture_Triple:
Draw16_Glass_PTexture_Triple:
	retn
;
;
;
; This routine will simply draw all vertices of a poly
;
Draw16_Vertices PROC NEAR
	retn
Draw16_Vertices ENDP

;
;   GOMEZ VECTOR ENGINE                                 SPECIAL EFFECTS
;
;
;
; Here come some special F/X algorithms such like motion blurr, feed back
; etc....
;
;
; FX16_Motion_Trace:
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	Blurred frame
;   Destroys:
;	EAX,EBX,ECX,EDI
;
PUBLIC FX16_Motion_Trace
FX16_Motion_Trace PROC NEAR
	retn
FX16_Motion_Trace ENDP
;
;
; Here come some special F/X algorithms such like motion blurr, feed back
; etc....
;
;
; FX16_Motion_Blurr:
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	Blurred frame
;   Destroys:
;	EAX,EBX,ECX,EDI
;
PUBLIC FX16_Motion_Blurr
FX16_Motion_Blurr PROC NEAR
	mov	ebp,ds:[GVE_Soften_Mask]
	mov 	ecx,ds:[GVE_Frame_Width]
	imul	ecx,ds:[GVE_Frame_Height]
	shr	ecx,1
	dec	ecx
@@L1:	mov	eax,ds:[esi+4*ecx]
	mov	ebx,ds:[edi+4*ecx]
	and	eax,ebp
	and	ebx,ebp
	add	eax,ebx
	rcr	eax,1
	mov	ds:[edi+4*ecx],eax
	dec	ecx
	jns	short @@L1
	retn
FX16_Motion_Blurr ENDP
;
;
; FX16_Feed_Back:
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	new frame
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
PUBLIC FX16_Feed_Back
FX16_Feed_Back PROC NEAR
	mov	eax,ds:[GVE_Frame_Width]
	mov	ebx,ds:[GVE_Frame_Height]
	shr	eax,3
	imul	ebx,eax
	add	eax,ebx
	lea	esi,[esi+2*eax]
	xor	ebx,ebx
	xor	edx,edx
	xor	ebp,ebp

	mov	edx,ds:[GVE_Frame_Height]
	@@L1:	push	esi
		push	edx
		push	ebp

		mov	ebp,ds:[GVE_Blurr_LUT]
		mov	ecx,ds:[GVE_Frame_Width]
		shr	ecx,2
	@@L2:	mov	bx,ds:[esi]
		mov	ax,ds:[ebp+2*ebx]
		rol	eax,16

		mov	bx,ds:[esi+2]
		mov	ax,ds:[ebp+2*ebx]
		rol	eax,16
		stosd

		mov	bx,ds:[esi+4]
		add	esi,6
		mov	ax,ds:[ebp+2*ebx]
		rol	eax,16
		stosd

		dec	ecx
		jnz	short @@L2

		pop	ebp
		pop	edx
		pop	esi
		add	bp,0c000h	;Zoom factor 3:4
		jnc	short @@1
		add	esi,ds:[GVE_Frame_Width]
		add	esi,ds:[GVE_Frame_Width]
	@@1:	dec	edx
		jnz	short @@L1
	retn
FX16_Feed_Back ENDP
;
;
; FX16_Soften_Horizontal
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	new frame
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
PUBLIC FX16_Soften_Horizontal
FX16_Soften_Horizontal PROC NEAR
	mov	ebp,ds:[GVE_Soften_Mask]
	mov 	ecx,ds:[GVE_Frame_Width]
	imul	ecx,ds:[GVE_Frame_Height]
	xor	eax,eax
	xor	ebx,ebx
@@L1:   mov	ax,ds:[edi+2]
	mov	bx,ds:[edi]
	and	eax,ebp
	and	ebx,ebp
	add	eax,ebx
	rcr	eax,1
	mov	ds:[edi],ax
	add	edi,2
	dec	ecx
	jnz	short @@L1
	retn
FX16_Soften_Horizontal ENDP
;
;
; FX16_Soften_Vertical
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	new frame
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
PUBLIC FX16_Soften_Vertical
FX16_Soften_Vertical PROC NEAR
	mov 	ecx,ds:[GVE_Frame_Height]
	mov	ebp,ds:[GVE_Soften_Mask]
	dec	ecx
	mov	edx,ds:[GVE_Frame_Line_Size]
	imul	ecx,ds:[GVE_Frame_Width]
	xor	eax,eax
	xor	ebx,ebx
@@L1:   mov	ax,ds:[edi+edx]
	mov	bx,ds:[edi]
	and	eax,ebp
	and	ebx,ebp
	add	eax,ebx
	rcr	eax,1
	mov	ds:[edi],ax
	add	edi,2
	dec	ecx
	jnz	short @@L1
	retn
FX16_Soften_Vertical ENDP

CODE32 ends
END