;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
SMART
WARN ICG


GVE_SYSTEM_FILE		equ	1
GVE_PRO			equ	1


;
;
;
;   GOMEZ VECTOR ENGINE  pro                        16bit raster algorithms
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gve32.inc
include gomez.inc
include gpp.inc
include gverst.inc



;
;   GOMEZ VECTOR ENGINE   pro     			DATA AREA
;
extrn C GVE_Frame_Width:DWORD
extrn C GVE_Frame_Height:DWORD
extrn C GVE_Frame_Depth:DWORD
extrn C GVE_Frame_Line_Size:DWORD
extrn C GVE_Frame_Buffer:DWORD
extrn GVE_Glass_LUT:DWORD
extrn GVE_Shading_LUT:DWORD
extrn GVE_Bump_LUT:DWORD
extrn GVE_Blurr_LUT:DWORD
extrn GVE_PhongMap_List:DWORD
extrn GVE_Texture_List:DWORD

extrn Phong_Table:BYTE
extrn Phong_Texture_Table:BYTE
extrn Carva_Table:BYTE
extrn Soften_Mask:DWORD

ALIGN 16
Counter_V01		dd		?
Counter_V12		dd		?
Counter_V02		dd		?



;
;
;
;   GOMEZ VECTOR ENGINE  pro                             RASTER ALGORITHMS
;
;
;
;
;
; These are the lowest-end drawing functions for the various objects.
; Like in the GMI, I use a quick and nice table for indexing all functions
;
; O.k. Here are some things you must keep in mind when coding new methods:
; 1.) ES is set to data/code segment
;     DS is set to data/code segment
; 2.) DS:ESI points to the primitive header
; 3.) DS:EBP points to the current entry in the order table
;     (But I think you won't need that one...)
; 4.) The following registers MUST be saved: ES, DS and EBP
;
PUBLIC GVE_Method_Table32
GVE_Method_Table32 LABEL DWORD
	dd Draw32_Nothing			;0
	dd Draw32_Wire_Triple            	;4
	dd Draw32_Filled_Triple          	;8
	dd Draw32_Lambert_Triple         	;12
	dd Draw32_Gouraud_Triple         	;16
	dd Draw32_Phong_Triple           	;20
	dd Draw32_Glass_Triple           	;24
	dd Draw32_Lambert_Glass_Triple   	;28
	dd Draw32_Gouraud_Glass_Triple   	;32
	dd Draw32_Phong_Glass_Triple     	;36
	dd Draw32_Texture_Triple         	;40
	dd Draw32_Lambert_Texture_Triple 	;44
	dd Draw32_Gouraud_Texture_Triple 	;48
	dd Draw32_Phong_Texture_Triple   	;52
	dd Draw32_Plasma_Chrome_Triple 		;56
	dd Draw32_Chrome_Triple          	;60
	dd Draw32_Lambert_Chrome_Triple  	;64
	dd Draw32_Gouraud_Chrome_Triple  	;68
	dd Draw32_Phong_Chrome_Triple    	;72
	dd Draw32_Fast_Phong_Triple      	;76
	dd Draw32_Glass_Texture_Triple   	;80
	dd Draw32_Glass_Chrome_Triple    	;84
	dd Draw32_Bump_Triple         		;88
	dd Draw32_Lambert_Bump_Triple 		;92
	dd Draw32_Gouraud_Bump_Triple 		;96
	dd Draw32_Phong_Bump_Triple   		;100
	dd Draw32_Glass_Bump_Triple       	;104
	dd Draw32_Soft_Wire_Triple        	;108
	dd Draw32_Glass_Wire_Triple       	;112
	dd Draw32_Lightmap_Texture_Triple   	;116
	dd Draw32_Chrome_Texture_Triple   	;120
	dd Draw32_Lightmap_Bump_Triple     	;124
	dd Draw32_Vertices               	;128
	dd Draw32_Carva_Triple			;132
	dd Draw32_Lambert_Carva_Triple		;136
	dd Draw32_Gouraud_Carva_Triple		;140
	dd Draw32_Phong_Carva_Triple		;144
	dd Draw32_Glass_Carva_Triple		;148
	dd 64-(($-GVE_METHOD_TABLE32)/4) DUP (OFFSET Draw32_Nothing)

;
Draw32_Nothing:
Draw32_Soft_Wire_Triple:
Draw32_Phong_Triple:
Draw32_Chrome_Texture_Triple:
Draw32_Lightmap_Texture_Triple:
Draw32_Lightmap_Bump_Triple:
	retn
;
;
;
; First some easy things: wire-frame models
;
Draw32_Wire_Triple PROC NEAR
	retn
Draw32_Wire_Triple ENDP
;
Draw32_Glass_Wire_Triple PROC NEAR
	retn
Draw32_Glass_Wire_Triple ENDP
;
;
;
; Now comes a class of filled polygons like constant shading, lambert
; shading, gouraud shading etc...
;
Draw32_Filled_Triple PROC NEAR
	retn
Draw32_Filled_Triple ENDP
;
Draw32_Lambert_Triple PROC NEAR
	retn
Draw32_Lambert_Triple ENDP
;
Draw32_Gouraud_Triple PROC NEAR
	retn
Draw32_Gouraud_Triple ENDP
;
;
; This is the fast phong-shading method. It simply interpolates the cosinus
; values between the vertices of the poly.
;
; Note that the actual shading formula looks like this:
;
;	light()=2*cos(/2)^n - 1
;
Draw32_Fast_Phong_Triple PROC NEAR
	retn
Draw32_Fast_Phong_Triple ENDP
;
;
;
; Now comes a class of filled transparent polygons like constant shading,
; lambert shading, gouraud shading etc...
;
Draw32_Glass_Triple PROC NEAR
	retn
Draw32_Glass_Triple ENDP
;
Draw32_Lambert_Glass_Triple PROC NEAR
	retn
Draw32_Lambert_Glass_Triple ENDP
;
Draw32_Gouraud_Glass_Triple PROC NEAR
	retn
Draw32_Gouraud_Glass_Triple ENDP
;
Draw32_Phong_Glass_Triple PROC NEAR
	retn
Draw32_Phong_Glass_Triple ENDP
;
;
;
; Now comes a class of carva shaded polygons like constant shading, lambert
; shading, gouraud shading etc...
;
Draw32_Carva_Triple PROC NEAR
	retn
Draw32_Carva_Triple ENDP
;
Draw32_Lambert_Carva_Triple PROC NEAR
	retn
Draw32_Lambert_Carva_Triple ENDP
;
Draw32_Gouraud_Carva_Triple PROC NEAR
	retn
Draw32_Gouraud_Carva_Triple ENDP
;
Draw32_Phong_Carva_Triple PROC NEAR
	retn
Draw32_Phong_Carva_Triple ENDP
;
Draw32_Glass_Carva_Triple PROC NEAR
	retn
Draw32_Glass_Carva_Triple ENDP

;
;
;
; Now come some texture-routines
;
Draw32_Texture_Triple PROC NEAR
	retn
Draw32_Texture_Triple ENDP
;
Draw32_Lambert_Texture_Triple PROC NEAR
	retn
Draw32_Lambert_Texture_Triple ENDP
;
Draw32_Gouraud_Texture_Triple PROC NEAR
	retn
Draw32_Gouraud_Texture_Triple ENDP
;
Draw32_Phong_Texture_Triple PROC NEAR
	retn
Draw32_Phong_Texture_Triple ENDP
;
Draw32_Glass_Texture_Triple PROC NEAR
	retn
Draw32_Glass_Texture_Triple ENDP
;
;
;
; Now come some bump-mapping-routines. They simply use another shading-LUT.
;
Draw32_Bump_Triple PROC NEAR
	retn
Draw32_Bump_Triple ENDP
;
Draw32_Lambert_Bump_Triple PROC NEAR
	retn
Draw32_Lambert_Bump_Triple ENDP
;
Draw32_Gouraud_Bump_Triple PROC NEAR
	retn
Draw32_Gouraud_Bump_Triple ENDP
;
Draw32_Phong_Bump_Triple PROC NEAR
	retn
Draw32_Phong_Bump_Triple ENDP
;
Draw32_Glass_Bump_Triple PROC NEAR
	retn
Draw32_Glass_Bump_Triple ENDP

;
;
;
; Now come some chrome-mapping-routines that may also be used to simulate
; a better phong-shding
;
Draw32_Chrome_Triple PROC NEAR
	retn
Draw32_Chrome_Triple ENDP
;
Draw32_Lambert_Chrome_Triple PROC NEAR
	retn
Draw32_Lambert_Chrome_Triple ENDP
;
Draw32_Gouraud_Chrome_Triple PROC NEAR
	retn
Draw32_Gouraud_Chrome_Triple ENDP
;
Draw32_Phong_Chrome_Triple PROC NEAR
	retn
Draw32_Phong_Chrome_Triple ENDP
;
Draw32_Glass_Chrome_Triple PROC NEAR
	retn
Draw32_Glass_Chrome_Triple ENDP
;
;
;
; Now a new texture-plasma mapper
;
Draw32_Plasma_Chrome_Triple PROC NEAR
	retn
Draw32_Plasma_Chrome_Triple ENDP
;
;
;
; This routine will simply draw all vertices of a poly
;
Draw32_Vertices PROC NEAR
	retn
Draw32_Vertices ENDP

;
;   GOMEZ VECTOR ENGINE                                 SPECIAL EFFECTS
;
;
;
; Here come some special F/X algorithms such like motion blurr, feed back
; etc....
;
;
; FX32_Motion_Trace:
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	Blurred frame
;   Destroys:
;	EAX,EBX,ECX,EDI
;
PUBLIC FX32_Motion_Trace
FX32_Motion_Trace PROC NEAR
	retn
FX32_Motion_Trace ENDP
;
;
; Here come some special F/X algorithms such like motion blurr, feed back
; etc....
;
;
; FX32_Motion_Blurr:
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	Blurred frame
;   Destroys:
;	EAX,EBX,ECX,EDI
;
PUBLIC FX32_Motion_Blurr
FX32_Motion_Blurr PROC NEAR
	retn
FX32_Motion_Blurr ENDP
;
;
; FX32_Feed_Back:
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	new frame
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
PUBLIC FX32_Feed_Back
FX32_Feed_Back PROC NEAR
	retn
FX32_Feed_Back ENDP
;
;
; FX32_Soften_Horizontal
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	new frame
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
PUBLIC FX32_Soften_Horizontal
FX32_Soften_Horizontal PROC NEAR
	retn
FX32_Soften_Horizontal ENDP
;
;
; FX32_Soften_Vertical
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	new frame
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
PUBLIC FX32_Soften_Vertical
FX32_Soften_Vertical PROC NEAR
	retn
FX32_Soften_Vertical ENDP

CODE32 ends
END