;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
SMART
WARN ICG


GVE_SYSTEM_FILE		equ	1
GVE_PRO			equ	1


;
;
;
;   GOMEZ VECTOR ENGINE  pro                        8bit raster algorithms
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gve32.inc
include gomez.inc
include gpp.inc
include gverst.inc



;
;   GOMEZ VECTOR ENGINE   pro     			DATA AREA
;
extrn C GVE_Frame_Width:DWORD
extrn C GVE_Frame_Height:DWORD
extrn C GVE_Frame_Depth:DWORD
extrn C GVE_Frame_Line_Size:DWORD
extrn C GVE_Frame_Buffer:DWORD
extrn GVE_Glass_LUT:DWORD
extrn GVE_Shading_LUT:DWORD
extrn GVE_Bump_LUT:DWORD
extrn GVE_Blurr_LUT:DWORD
extrn GVE_PhongMap_List:DWORD
extrn GVE_Texture_List:DWORD
extrn GVE_BumpMap_List:DWORD


extrn Phong_Table:BYTE
extrn Phong_Texture_Table:BYTE
extrn Carva_Table:BYTE

ALIGN 16
Counter_V01		dd		?
Counter_V12		dd		?
Counter_V02		dd		?



;
;
;
;   GOMEZ VECTOR ENGINE  pro                             RASTER ALGORITHMS
;
;
;
;
;
; These are the lowest-end drawing functions for the various objects.
; Like in the GMI, I use a quick and nice table for indexing all functions
;
; O.k. Here are some things you must keep in mind when coding new methods:
; 1.) ES is set to data/code segment
;     DS is set to data/code segment
; 2.) DS:ESI points to the primitive header
; 3.) DS:EBP points to the current entry in the order table
;     (But I think you won't need that one...)
; 4.) The following registers MUST be saved: ES, DS and EBP
;
PUBLIC GVE_Method_Table8
GVE_Method_Table8 LABEL DWORD
	dd Draw8_Nothing			;0
	dd Draw8_Wire_Triple            	;4
	dd Draw8_Filled_Triple          	;8
	dd Draw8_Lambert_Triple         	;12
	dd Draw8_Gouraud_Triple         	;16
	dd Draw8_Phong_Triple           	;20
	dd Draw8_Glass_Triple           	;24
	dd Draw8_Lambert_Glass_Triple   	;28
	dd Draw8_Gouraud_Glass_Triple   	;32
	dd Draw8_Phong_Glass_Triple     	;36
	dd Draw8_Texture_Triple         	;40
	dd Draw8_Lambert_Texture_Triple 	;44
	dd Draw8_Gouraud_Texture_Triple 	;48
	dd Draw8_Phong_Texture_Triple   	;52
	dd Draw8_Bump_Chrome_Triple  		;56
	dd Draw8_Chrome_Triple          	;60
	dd Draw8_Lambert_Chrome_Triple  	;64
	dd Draw8_Gouraud_Chrome_Triple  	;68
	dd Draw8_Phong_Chrome_Triple    	;72
	dd Draw8_Fast_Phong_Triple      	;76
	dd Draw8_Glass_Texture_Triple   	;80
	dd Draw8_Glass_Chrome_Triple    	;84
	dd Draw8_Bump_Triple         		;88
	dd Draw8_Lambert_Bump_Triple 		;92
	dd Draw8_Gouraud_Bump_Triple 		;96
	dd Draw8_Phong_Bump_Triple   		;100
	dd Draw8_Glass_Bump_Triple       	;104
	dd Draw8_Soft_Wire_Triple        	;108
	dd Draw8_Glass_Wire_Triple       	;112
	dd Draw8_Lightmap_Texture_Triple   	;116
	dd Draw8_Chrome_Texture_Triple   	;120
	dd Draw8_Lightmap_Bump_Triple     	;124
	dd Draw8_Vertices               	;128
	dd Draw8_Carva_Triple			;132
	dd Draw8_Lambert_Carva_Triple		;136
	dd Draw8_Gouraud_Carva_Triple		;140
	dd Draw8_Phong_Carva_Triple		;144
	dd Draw8_Glass_Carva_Triple		;148
	dd Draw8_PTexture_Triple		;152
	dd Draw8_Lambert_PTexture_Triple	;156
	dd Draw8_Gouraud_PTexture_Triple	;160
	dd Draw8_Phong_PTexture_Triple		;164
	dd Draw8_LightMap_PTexture_Triple	;168
	dd Draw8_Chrome_PTexture_Triple		;172
	dd Draw8_Glass_PTexture_Triple		;176
	dd Draw8_Bump_Texture_Triple		;180

	dd 64-(($-GVE_METHOD_TABLE8)/4) DUP (OFFSET Draw8_Nothing)

;
Draw8_Nothing:
Draw8_Soft_Wire_Triple:
Draw8_Phong_Triple:
	retn
;
;
;
; First some easy things: wire-frame models
;
Draw8_Wire_Triple PROC NEAR
	push	ebp
	movzx	ecx,ds:[esi+Triangle_Vertex_Count]	;Get Poly-Counter
	mov	al,ds:[esi+Triangle_Colour]	;Get colour
	mov	b ds:[@@C1-1],al		;Save colour


	mov	ebp,ds:[esi+24]			;EBP = first vertex
	mov	ecx,ds:[ebp+Vertex_ScreenX]	;ECX = X2
	mov	edx,ds:[ebp+Vertex_ScreenY]	;EDX = Y2
	sar	ecx,16				;Unshift X-value
	;
	movzx	ebp,byte ptr ds:[esi+3]		;EBP = number of vertices
@@L1:   push	ebp				;Save counter
	mov	ebp,ds:[esi+20+4*ebp]		;EBP = n-th vertex
	mov	eax,ds:[ebp+Vertex_ScreenX]	;EAX = X1
	mov	ebx,ds:[ebp+Vertex_ScreenY]	;EBX = Y1
	sar	eax,16
	push	ebx				;Save Y1
	push	eax				;Save X1
	;
	mov     ebx,4340h         		;EBX = Code for INC EBX / INC EAX
	sub	ecx,eax				;ECX = DeltaX = X2-X1
	jge     short @@J1        		;Is X2>X1?
		mov     bl,48h           	;No, code for DEC EAX
		neg     ecx               	; and invert DELTAX
@@J1:   sub     edx,ds:[ebp+Vertex_ScreenY]	;EDX = DeltaY = Y2-Y1
	jge     short @@J2        		;Y2 > Y1 ?
		mov     bh,4bh           	;No, code for DEC EBX
		neg     edx               	; and invert DELTAY
@@J2:  	mov     word ptr ds:[@@C3],bx      	;Save code
	cmp     ecx,edx            		;DeltaX > DeltaY ?
	jge     short @@J3
		mov     bl,90h           	;NOP
		xchg    ecx,edx            	;Swap DeltaX and DeltaY
		jmp     short @@J4
@@J3:  	mov     bh,90h

@@J4:   mov     word ptr ds:[@@C2],bx
	shl     edx,1             		;Calc IncB
	mov	d ds:[@@C4-4],edx              	;and save it in code !
	sub     edx,ecx            		;EDX = DAB
	sub     edx,ecx
	mov	d ds:[@@C6-4],edx		;  and save it in code !
	add	edx,ecx				;EDX = dab
	mov	eax,ds:[ebp+Vertex_ScreenX]	;EAX = X1
	mov	ebx,ds:[ebp+Vertex_ScreenY]	;EBX = Y1
	sar	eax,16				;Unshift X-value
	;
@@L2:   mov	edi,ebx
	cmp	ebx,ds:[GVE_Frame_Height]
	jae	short @@C1
	cmp	eax,ds:[GVE_Frame_Width]
	jae	short @@C1
	imul	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	mov	byte ptr ds:[edi+eax],12h      	;Set pixel !
@@C1:   test    edx,edx             		;DAB>0?
	jge     short @@C3        		;ja, verzweige
	@@C2:  	inc     eax            		;hier wird der
		inc     ebx            		;Code modifiziert
		add     edx,12345678h  		;DAB+=IncB
	@@C4:	dec	ecx
		jg 	short @@L2
		jmp     short @@Next    	;und weiter
	@@C3:   inc     eax               	;hier wird der
		inc     ebx		   	;Code modifiziert
		add     edx,12345678h      	;DAB+=IncA
	@@C6:	dec	ecx
		jg 	short @@L2
	;
@@Next: pop     ecx                     	;EDX = X2
	pop	edx				;ECX = Y2
	pop	ebp				;EBP = counter
	dec	ebp
	jnz	@@L1
	;
@@Exit: mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw8_Wire_Triple ENDP
;
Draw8_Glass_Wire_Triple PROC NEAR
	push	ebp
	movzx	ecx,ds:[esi+Triangle_Vertex_Count]
	movzx	eax,ds:[esi+Triangle_Colour]
	shl	eax,8
	add	eax,ds:[GVE_Glass_LUT]
	mov	d ds:[@@C1-4],eax	;save it there

	mov	ebp,ds:[esi+24]			;EBP = first vertex
	mov	ecx,ds:[ebp+Vertex_ScreenX]	;EAX = X2
	mov	edx,ds:[ebp+Vertex_ScreenY]	;EDX = Y2
	sar	ecx,16				;Unshift X-value
	;
	movzx	ebp,byte ptr ds:[esi+3]		;EBP = number of vertices
@@L1:   push	ebp				;Save counter
	push	esi

	mov	ebp,ds:[esi+20+4*ebp]		;EBP = n-th vertex
	mov     ebx,4340h         		;EBX = Code for INC EBX / INC EAX
	mov	eax,ds:[ebp+Vertex_ScreenX]	;EAX = X1
	sar	eax,16				;Unshift X-value
	sub     ecx,eax            		;ECX = DeltaX = X2-X1
	push	eax				;Save X1 for next loop
	jge     short @@J1        		;Is X2>X1?
		mov     bl,48h           	;No, code for DEC EAX
		neg     ecx               	; and invert DELTAX
@@J1:  	push    d ds:[ebp+Vertex_ScreenY]    	;Save Y1 for next loop
	sub     edx,ds:[ebp+Vertex_ScreenY]	;EDX = DeltaY = Y2-Y1
	jge     short @@J2        		;Y2 > Y1 ?
		mov     bh,4bh           	;No, code for DEC EBX
		neg     edx               	; and invert DELTAY
@@J2:  	mov     word ptr ds:[@@C3],bx      	;Save code
	cmp     ecx,edx            		;DeltaX > DeltaY ?
	jge     short @@J3
		mov     bl,90h           	;NOP
		xchg    ecx,edx            	;Swap DeltaX and DeltaY
		jmp     short @@J4
@@J3:  	mov     bh,90h

@@J4:   mov	esi,edx				;ESI = Y2
	mov     word ptr ds:[@@C2],bx
	shl     esi,1             		;Calc IncB
	mov	d ds:[@@C4-4],esi              	;and save it in code !
	sub     esi,ecx            		;ESI = DAB
	sub     esi,ecx
	mov	d ds:[@@C6-4],esi		;  and save it in code !
	add	esi,ecx				;ESI = dab
	mov	eax,ds:[ebp+Vertex_ScreenX]	;EAX = X1
	mov	ebx,ds:[ebp+Vertex_ScreenY]	;EBX = Y1
	sar	eax,16				;Unshift X-value
	xor	edx,edx
	;
@@L2:   mov	edi,ebx
	cmp	ebx,ds:[GVE_Frame_Height]
	jae	short @@J5
	cmp	eax,ds:[GVE_Frame_Width]
	jae	short @@J5
	imul	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	mov	dl,ds:[edi+eax]			;Get old colour
	mov	dl,ds:[edx+12345678h]		;Mix via LUT
@@C1:	mov	byte ptr ds:[edi+eax],dl       	;Set pixel !
@@J5:	test    esi,esi           		;DAB>0?
	jge     short @@C3        		;ja, verzweige
	@@C2:  	inc     eax            		;hier wird der
		inc     ebx            		;Code modifiziert
		add     esi,12345678h  		;DAB+=IncB
	@@C4:	dec	ecx
		jg 	short @@L2
		jmp     short @@Next    	;und weiter
	@@C3:   inc     eax               	;hier wird der
		inc     ebx		   	;Code modifiziert
		add     esi,12345678h      	;DAB+=IncA
	@@C6:	dec	ecx
		jg 	short @@L2
	;
@@Next: pop     edx                     	;EDX = Y2
	pop	ecx				;ECX = X2
	pop	esi				;ESI = ptr to polygon
	pop	ebp				;EBP = counter
	dec	ebp
	jnz	@@L1
	;
@@Exit: mov	edi,ds:[GVE_Frame_Buffer]
	pop	ebp
	retn
Draw8_Glass_Wire_Triple ENDP
;
;
;
; Now comes a class of filled polygons like constant shading, lambert
; shading, gouraud shading etc...
;
Draw8_Filled_Triple PROC NEAR
	mov	al,ds:[esi+Triangle_Colour]
	push	ebp
	mov	ah,al
	mov	dword ptr ds:[FCOL-4],eax

__Draw8_Filled:
	GRAB_VERTICES SIMPLE_POLY
	GRAB_SLOPES SIMPLE_POLY
	CLIP_VERTICAL SIMPLE_POLY

	;
	;Vertical drawing loop starts here !
	mov	edx,edi
	mov	eax,12345678h		;Get colour
FCOL:   imul 	edx,ds:[GVE_Frame_Width]
	add	edx,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
@@L1:   push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL SIMPLE_POLY
	sub	ecx,ebx			;ECX = width of span
	lea	edi,[ebx+edx]		;EDI = EDX + X0
	jle	short @@N		;ECX >= 0 ==> Nothing to draw !
	shr	ecx,1			;Word mode !
	rep	stosw
	adc	cl,0
	rep	stosb			;Draw span !
@@N:   	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:	add	edx,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		mov	dword ptr ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = New vertical count
		mov	ecx,12345678h
	@@S4:	xor 	esi,esi		;ESI = New 2nd vertical count (0)
		jmp	short @@L1	;Do loop again !

@@End: 	pop	ebp
	retn
Draw8_Filled_Triple ENDP
;
Draw8_Lambert_Triple PROC NEAR
	push	ebp
	mov	ebx,ds:[esi+Triangle_Vertex1]
	mov	eax,ds:[ebx+VShading]	;Get light-thingy
	sar	eax,GVE_SHAD_SHIFT-4
	add	al,ds:[esi+Triangle_Colour]
	mov	ah,al			;Set both bytes to new colour !
	mov	d ds:[FCOL-4],eax	;save it there

	jmp	__Draw8_Filled
Draw8_Lambert_Triple ENDP
;
Draw8_Gouraud_Triple PROC NEAR
	movzx	eax,ds:[esi+Triangle_Colour]
	push	ebp
	shl	eax,GVE_SHAD_SHIFT-4 	;Shift for interpolation
	mov	d ds:[@@COL-4],eax

	GRAB_VERTICES GOURAUD_POLY
	GRAB_SLOPES GOURAUD_POLY
	CLIP_VERTICAL GOURAUD_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get gouraud start value
@@G0:   mov	edx,12345678h		;Get horizontal gouraud slope
@@G2:   add	eax,12345678h		;Add colour to start value
@@COL:  imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start colour
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL GOURAUD_POLY
	ror	eax,GVE_SHAD_SHIFT-4	;EAX = gouraud colour
	lea	esi,[ebx+edi]		;ESI = start pixel
	sub	ecx,ebx			;ECX = negative width of span
	jle	short @@N		;ECX <= 0 ==> Nothing to draw !
	ror	edx,GVE_SHAD_SHIFT-4	;EDX = gouraud increment / get sign in carry

	@@L2:	mov	ds:[esi],al
		inc	esi
		adc	eax,edx
		dec	ecx
		jnz	short @@L2

	rol	edx,GVE_SHAD_SHIFT-4	;Unshift gouraud increment

@@N:   	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:   add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@G1-4],12345678h
	@@G3:   jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Gouraud_Triple ENDP
;
;
; This is the fast phong-shading method. It simply interpolates the cosinus
; values between the vertices of the poly.
;
; Note that the actual shading formula looks like this:
;
;	light()=2*cos(/2)^n - 1
;
Draw8_Fast_Phong_Triple PROC NEAR
	xor	ebx,ebx
	mov	al,ds:[esi+Triangle_Colour]
	mov	bh,ds:[esi+Triangle_Phong]
	push	ebp
	add	ebx,OFFSET Phong_Table-256
	mov	b ds:[@@COL-1],al	;Save colour
	mov	d ds:[@@EXP-4],ebx	;EAX = address of phong-table

	GRAB_VERTICES FAST_PHONG_POLY
	GRAB_SLOPES FAST_PHONG_POLY
	CLIP_VERTICAL FAST_PHONG_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;EAX = cosine start value
@@G0:   imul 	edi,ds:[GVE_Frame_Width]
	add	eax,1 shl GVE_SHAD_SHIFT
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start cosine value
	push	ebx			;Save X0
	push	ecx			;Save X1
	mov	edx,12345678h		;EDX = horizontal cosine slope
@@G2:   db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL FAST_PHONG_POLY
	sar	eax,GVE_SHAD_SHIFT-15	;EAX = cosine value
	lea	esi,[edi+ecx]		;ESI = start pixel
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	mov	ecx,eax			;ECX =  cosine value
	movzx	eax,ah
	sar	edx,GVE_SHAD_SHIFT-15	;EDX =  cosine increment

	@@L2:	mov	al,ds:[eax+12345678h]
	@@EXP:	add	ecx,edx
		add	al,12h
	@@COL:	mov	ds:[esi+ebx],al
		inc	ebx
		mov	al,ch
		jnz	short @@L2

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:   add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@G1-4],12345678h
	@@G3:   jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Fast_Phong_Triple ENDP
;
;
;
; Now comes a class of filled transparent polygons like constant shading,
; lambert shading, gouraud shading etc...
;
Draw8_Glass_Triple PROC NEAR
	xor	eax,eax
	push	ebp
	mov	ah,ds:[esi+Triangle_Colour]
	add	eax,ds:[GVE_Glass_LUT]
	mov	d ds:[GCOL-4],eax	;save it there

__Draw8_Glass:
	GRAB_VERTICES SIMPLE_POLY
	GRAB_SLOPES SIMPLE_POLY
	CLIP_VERTICAL SIMPLE_POLY

	;
	;Vertical drawing loop starts here !
	imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	mov	edx,12345678h		;EDX = ptr to glass LUT
GCOL:   xor	eax,eax			;EAX = 0 for hloop !
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL SIMPLE_POLY
	lea	esi,[edi+ecx]		;ESI += X0
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !

	@@L2: 	mov	al,ds:[esi+ebx]	;AL = old colour
		mov	al,ds:[edx+eax]	;AL = Look mixed colour up
		mov	ds:[esi+ebx],al	;Set pixel
		inc	ebx
		jnz	short @@L2

@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	dword ptr ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = New vertical count
		mov	ecx,12345678h
	@@S4:   jmp	short @@L1	;Do loop again !

@@End: 	pop	ebp
	retn
Draw8_Glass_Triple ENDP
;
Draw8_Lambert_Glass_Triple PROC NEAR
	mov	ebx,ds:[esi+Triangle_Vertex1]
	push	ebp
	mov	eax,ds:[ebx+VShading]	;Get light-thingy
	sar	eax,GVE_SHAD_SHIFT-4
	add	al,ds:[esi+Triangle_Colour]
	mov	ah,al			;Set both bytes to new colour !
	and	eax,0ff00h
	add	eax,ds:[GVE_Glass_LUT]
	mov	d ds:[GCOL-4],eax	;save it there

	jmp	__Draw8_Glass
Draw8_Lambert_Glass_Triple ENDP
;
Draw8_Gouraud_Glass_Triple PROC NEAR
	xor	eax,eax
	mov	ebx,ds:[GVE_Glass_LUT]
	mov	al,ds:[esi+Triangle_Colour]
	mov	d ds:[@@LUT-4],ebx
	shl	eax,GVE_SHAD_SHIFT-4 	;Shift for interpolation
	push	ebp
	mov	d ds:[@@COL-4],eax

	GRAB_VERTICES GOURAUD_POLY
	GRAB_SLOPES GOURAUD_POLY
	CLIP_VERTICAL GOURAUD_POLY


	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get gouraud start value
@@G0:   mov	edx,12345678h		;Get horizontal gouraud slope
@@G2:   add	eax,12345678h		;Add colour to start value
@@COL:  imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start colour
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL GOURAUD_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	ror	eax,GVE_SHAD_SHIFT-4	;EAX = gouraud colour
	lea	esi,[edi+ecx]		;ESI = start pixel
	mov	ecx,eax			;ECX = Gouraud start value
	xor  	eax,eax			;AL  = Old colour
	rol	edx,36-GVE_SHAD_SHIFT	;EDX = gouraud increment / get sign in carry
	mov	ah,cl

	@@L2:   mov	al,ds:[esi+ebx]		;AL  = Old colour
		adc	ecx,edx              	;ECX = Gouraud value
		mov	al,ds:[eax+12345678h]	;AL  = mixed colours via LUT
	@@LUT:	mov	ds:[esi+ebx],al
		mov	ah,cl			;AH = new colour
		inc	ebx
		jnz	short @@L2
	ror	edx,36-GVE_SHAD_SHIFT	;Unshift gouraud increment

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = New vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Gouraud_Glass_Triple ENDP
;
Draw8_Phong_Glass_Triple PROC NEAR
	xor	eax,eax
	xor	ebx,ebx
	push	ebp
	mov	bl,ds:[esi+Triangle_Phong]	;EBX = highlight value
	mov	al,ds:[esi+Triangle_Colour]	;EAX = corner-colour
	shl	ebx,8
	add	eax,ds:[GVE_Glass_LUT]
	add	ebx,OFFSET Phong_Table-256
	mov	d ds:[@@LUT-4],eax	;EAX = Colour LUT
	mov	d ds:[@@EXP-4],ebx	;EBX = address of phong-table

	GRAB_VERTICES FAST_PHONG_POLY
	GRAB_SLOPES FAST_PHONG_POLY
	CLIP_VERTICAL FAST_PHONG_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;EAX = cosine start value
@@G0:   imul 	edi,ds:[GVE_Frame_Width]
	add	eax,1 shl GVE_SHAD_SHIFT
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   mov	edx,12345678h		;EDX = horizontal cosine slope
@@G2:   push	eax			;Save start cosine value
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL FAST_PHONG_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+ecx]		;ESI = start pixel
	mov	ecx,eax			;ECX =  cosine value
	sar	eax,GVE_SHAD_SHIFT-7
	@@L2:	mov	al,ds:[eax+12345678h]
	@@EXP:  mov	ah,ds:[esi+ebx]
		add	ecx,edx
		mov	al,ds:[eax+12345678h]
	@@LUT:	mov	ds:[esi+ebx],al
		mov	eax,ecx
		sar	eax,GVE_SHAD_SHIFT-7
		inc	ebx
		jnz	short @@L2

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = New vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Phong_Glass_Triple ENDP
;
;
;
; Now comes a class of carva shaded polygons like constant shading, lambert
; shading, gouraud shading etc...
;
Draw8_Carva_Triple PROC NEAR
	xor	eax,eax
	push	ebp
	mov	al,ds:[esi+Triangle_Colour]
	add	eax,ds:[GVE_SHading_LUT]
	add	eax,16*256
	mov	d ds:[CALUT-4],eax

__Draw8_Carva:
	GRAB_VERTICES SIMPLE_POLY
	GRAB_SLOPES SIMPLE_POLY
	CLIP_VERTICAL SIMPLE_POLY

	;
	;Vertical drawing loop starts here !
	imul 	edi,ds:[GVE_Frame_Width]
	and	edx,0ffh
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL SIMPLE_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+ecx]		;ESI += X0
	xor	ecx,ecx
	mov	ch,ds:[Carva_Table+edx]
	@@L2:	inc	dl
		mov	al,ds:[12345678h+ecx]
	CALUT:  mov	ch,ds:[Carva_Table+edx]
		mov	ds:[esi+ebx],al
		inc	ebx
		jnz	short @@L2

@@N:   	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	dword ptr ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = New vertical count
		mov	ecx,12345678h
	@@S4:	jmp	short @@L1	;Do loop again !

@@End: 	pop	ebp
	retn
Draw8_Carva_Triple ENDP
;
Draw8_Lambert_Carva_Triple PROC NEAR
	mov	ebx,ds:[esi+Triangle_Vertex1]
	push	ebp
	mov	eax,1 shl GVE_SHAD_SHIFT
	add	eax,ds:[ebx+VShading]	;Get light-thingy
	sar	eax,GVE_SHAD_SHIFT-4-8
	mov	al,ds:[esi+Triangle_Colour]
	add	eax,ds:[GVE_SHading_LUT]
	mov	d ds:[CALUT-4],eax

	jmp	__Draw8_Carva
Draw8_Lambert_Carva_Triple ENDP
;
Draw8_Gouraud_Carva_Triple PROC NEAR
	xor	eax,eax
	push	ebp
	mov	al,ds:[esi+Triangle_Colour]
	add	eax,ds:[GVE_SHading_LUT]
	mov	d ds:[@@LUT-4],eax

	GRAB_VERTICES GOURAUD_POLY
	GRAB_SLOPES GOURAUD_POLY
	CLIP_VERTICAL GOURAUD_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get gouraud start value
@@G0:   imul 	edi,ds:[GVE_Frame_Width]
	and	edx,0ffh
	add	edi,ds:[GVE_Frame_Buffer]
	mov	d ds:[@@C2-4],edx
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   mov	edx,12345678h           ;EDX = Gouraud increment
@@G2:	push	eax			;Save start colour
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	mov	esi,edx
	CLIP_HORIZONTAL GOURAUD_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	add	eax,1 shl GVE_SHAD_SHIFT
	add	edi,ecx			;EDI = start pixel
	sar	eax,GVE_SHAD_SHIFT-4-8	;EAX = gouraud colour
	mov	edx,12345678h
@@C2:	xor	ecx,ecx
	mov	ch,ah
	sar	esi,GVE_SHAD_SHIFT-4-8	;ESI = gouraud increment / get sign in carry
	add	ch,ds:[Carva_Table+edx]
	@@L2:   inc	dl			;EDX = Carva-Index
		mov	ch,ds:[12345678h+ecx]   ;CH  = Colour
	@@LUT: 	add	eax,esi			;EAX = Gouraud value
		mov	ds:[edi+ebx],ch		;Set pixel
		mov	ch,ah			;ECX = Gouraud-Value
		add	ch,ds:[Carva_Table+edx] ;CH  = Carve value
		inc	ebx
		jnz	short @@L2

	mov	d ds:[@@C2-4],edx
	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Gouraud_Carva_Triple ENDP
;
Draw8_Phong_Carva_Triple PROC NEAR
	xor	eax,eax
	push	ebp
	mov	al,ds:[esi+Triangle_Colour]
	add	eax,ds:[GVE_SHading_LUT]
	mov	d ds:[@@LUT-4],eax

	GRAB_VERTICES GOURAUD_POLY
	GRAB_SLOPES GOURAUD_POLY
	CLIP_VERTICAL GOURAUD_POLY

	;
	;Vertical drawing loop starts here !
	and	edx,0ffh
	mov	eax,12345678h		;Get gouraud start value
@@G0:   imul 	edi,ds:[GVE_Frame_Width]
	mov	d ds:[@@C2-4],edx
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   mov	edx,12345678h           ;EDX = Gouraud increment
@@G2:	push	eax			;Save start colour
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	mov	esi,edx
	CLIP_HORIZONTAL GOURAUD_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	add	eax,1 shl GVE_SHAD_SHIFT
	add	edi,ecx			;EDI = start pixel
	sar	eax,GVE_SHAD_SHIFT-4-8	;EAX = gouraud colour
	mov	edx,12345678h
@@C2:	xor	ecx,ecx
	mov	ch,ah
	sar	esi,GVE_SHAD_SHIFT-4-8	;ESI = gouraud increment / get sign in carry
	add	ch,ds:[Carva_Table+edx]
	@@L2:	inc	dl			;EDX = Carva-Index
		mov	ch,ds:[12345678h+ecx]   ;CH  = Colour
	@@LUT: 	add	eax,esi			;EAX = Gouraud value
		mov	ds:[edi+ebx],ch		;Set pixel
		mov	ch,ah			;ECX = Gouraud-Value
		add	ch,ds:[Carva_Table+edx] ;CH  = Carve value
		inc	ebx
		jnz	short @@L2

	mov	d ds:[@@C2-4],edx
	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore colour
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical gouraud
@@G1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Phong_Carva_Triple ENDP
;
Draw8_Glass_Carva_Triple PROC NEAR
	xor	eax,eax
	push	ebp
	mov	al,ds:[esi+Triangle_Colour]
	mov	ebx,ds:[GVE_Glass_LUT]
	add	eax,ds:[GVE_SHading_LUT]
	mov	d ds:[@@GLUT-4],ebx
	add	eax,16*256
	mov	d ds:[@@LUT-4],eax

	GRAB_VERTICES SIMPLE_POLY
	GRAB_SLOPES SIMPLE_POLY
	CLIP_VERTICAL SIMPLE_POLY

	;
	;Vertical drawing loop starts here !
	imul 	edi,ds:[GVE_Frame_Width]
	and	edx,0ffh
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL SIMPLE_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns	short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+ecx]		;ESI += X1
	xor	ecx,ecx
	mov	ch,ds:[Carva_Table+edx]
	@@L2:   mov	ah,ds:[esi+ebx]
		inc	dl
		mov	al,ds:[12345678h+ecx]
	@@LUT:  mov	ch,ds:[Carva_Table+edx]
		mov	al,ds:[eax+12345678h]
	@@GLUT:	mov	ds:[esi+ebx],al
		inc	ebx
		jnz	short @@L2

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	dword ptr ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = New vertical count
		mov	ecx,12345678h
	@@S4:	jmp	@@L1		;Do loop again !

@@End: 	pop	ebp
	retn
Draw8_Glass_Carva_Triple ENDP

;
;
;
; Now come some texture-routines
;
Draw8_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;Get texture-number
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TNADR-4],eax

__Draw8_Texture:
	GRAB_VERTICES TEXTURE_POLY
	GRAB_SLOPES TEXTURE_POLY
	CLIP_VERTICAL TEXTURE_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   mov	edx,12345678h		;Get horizontal texture slope
@@T2:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+ecx]		;ESI = start pixel
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr  	eax,16
	mov	al,ch
	@@L2:	mov	al,ds:[eax+12345678h]
	TNADR:  add	ecx,edx		;ECX += Texture-increment
		mov	ds:[esi+ebx],al	;Set texel
		mov	eax,ecx		;EAX  = texture (u,v)-coordinate
		shr	eax,16		;AH   = texture u coordinate
		inc	ebx		;EBX += 1  (horizontal counter)
		mov	al,ch		;AL   = texture v coordinate
		jnz	short @@L2	;Loop !

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@T1-4],12345678h
	@@T3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Texture_Triple ENDP
;
Draw8_Lambert_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	push	ebp
	and	eax,3fffh
	mov	edx,ds:[esi+Triangle_Vertex1]	;EDX = first vector
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[edx+VShading]		;EBX = light-thingy
	mov	eax,ds:[4*eax+4+ecx]		;*8 bytes/entry
	sar	ebx,GVE_SHAD_SHIFT-5
	add	eax,GVE_BITMAP_SIZE
	add	ebx,32				;EBX = LUT-Number
	shl	ebx,8
	mov	d ds:[TLADR-4],eax
	add	ebx,ds:[GVE_Shading_LUT]
	mov	d ds:[TLLUT-4],ebx


__Draw8_Lambert_Texture:
	GRAB_VERTICES TEXTURE_POLY
	GRAB_SLOPES TEXTURE_POLY
	CLIP_VERTICAL TEXTURE_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   mov	edx,12345678h		;Get horizontal texture slope
@@T2:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+ecx]		;ESI = start pixel
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16			;AH  = Texture u-coordinate
	@@L2:	mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,edx		;ECX += Texture-increment
		movzx	eax,b ds:[eax+12345678h]
	TLADR: 	mov	al,ds:[eax+12345678h]
	TLLUT:	mov	ds:[esi+ebx],al	;Set texel
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	ebx		;EBX += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@T1-4],12345678h
	@@T3:  	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Lambert_Texture_Triple ENDP
;
Draw8_Gouraud_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Shading_LUT]
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	push	ebp
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TGLUT-4],ebx
	mov	d ds:[TGADR-4],eax


__Draw8_Gouraud_Texture:
	GRAB_VERTICES TEXTURE_GOURAUD_POLY
	GRAB_SLOPES TEXTURE_GOURAUD_POLY
	CLIP_VERTICAL TEXTURE_GOURAUD_POLY
	add	d ds:[@@G0-4],1 shl GVE_SHAD_SHIFT
	sar	d ds:[@@G2-4],GVE_SHAD_SHIFT-13

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   mov	edx,12345678h		;Get horizontal texture slope
@@T2:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_GOURAUD_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+ecx]		;EDI = start pixel
	mov	ecx,ebx
	mov	ebx,esi			;EBX = Gouraud-value
	mov	esi,ecx			;ESI = Vertical counter
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16			;AH  = Texture u-coordinate
	@@L2:	mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,edx		;ECX += Texture-increment
		mov	al,b ds:[eax+12345678h]
	TGADR:  mov	ah,bh		;AH  = gouraud value
		mov	al,ds:[eax+12345678h]
	TGLUT:  add	ebx,12345678h	;EBX += Gouraud-increment
	@@G2:	mov	ds:[edi+esi],al	;Set texel
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	esi		;ESI += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@G0-4],12345678h	;Increment vertical gouraud value
@@G1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Gouraud_Texture_Triple ENDP
;
Draw8_Phong_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	xor	edx,edx
	and	eax,3fffh
	mov	dh,ds:[esi+Triangle_Phong]	;EDX = phong-exponent
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_Shading_LUT]
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	add	edx,OFFSET Phong_Texture_Table-256
	add	eax,GVE_BITMAP_SIZE
	push	ebp
	mov	d ds:[TPTBL-4],edx
	mov	d ds:[TPLUT-4],ebx
	mov	d ds:[TPADR-4],eax

__Draw8_Phong_Texture:
	GRAB_VERTICES TEXTURE_PHONG_POLY
	GRAB_SLOPES TEXTURE_PHONG_POLY
	CLIP_VERTICAL TEXTURE_PHONG_POLY
	add	d ds:[@@G0-4],1 shl GVE_SHAD_SHIFT
	sar	d ds:[@@G2-4],GVE_SHAD_SHIFT-15

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   mov	edx,12345678h		;Get horizontal texture slope
@@T2:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	push	edx
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_PHONG_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	push	ebp
	lea	edi,[edi+ecx]
	mov	ebp,ebx			;EBP = counter
	mov	ebx,esi			;EBX = Gouraud-value
	mov	ecx,eax			;ECX = Texture (u,v) start
	mov	esi,edx			;ESI = texture-increment
	xor	edx,edx
	shr	eax,16			;AH  = Texture u-coordinate

	@@L2:	mov	dl,bh		;EDX = Gouraud value
		mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,esi		;ECX += Texture-increment
		mov	al,b ds:[eax+12345678h]
	TPADR:  mov	ah,ds:[edx+12345678h]
	TPTBL:	mov	al,ds:[eax+12345678h]
	TPLUT:  add	ebx,12345678h	;EBX += Gouraud-increment
	@@G2:	mov	ds:[edi+ebp],al	;Set texel
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	ebp		;EBP += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	pop	ebp
	pop	edi
@@N:	pop	edx
	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@G0-4],12345678h	;Increment vertical gouraud value
@@G1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Phong_Texture_Triple ENDP
;
Draw8_Glass_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	mov	ebx,ds:[GVE_Glass_LUT]
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TTGLS-4],ebx
	mov	d ds:[TTADR-4],eax


__Draw8_Glass_Texture:
	GRAB_VERTICES TEXTURE_POLY
	GRAB_SLOPES TEXTURE_POLY
	CLIP_VERTICAL TEXTURE_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   mov	edx,12345678h		;Get horizontal texture slope
@@T2:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+ecx]		;ESI = start pixel
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16
	@@L2:	mov 	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,edx		;ECX += Texture-increment
		mov	al,b ds:[eax+12345678h]
	TTADR:  mov	ah,ds:[esi+ebx]
		mov	al,ds:[eax+12345678h]
	TTGLS:	mov	ds:[esi+ebx],al	;Set texel
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	ebx		;EBX += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@T1-4],12345678h
	@@T3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Glass_Texture_Triple ENDP
;
Draw8_Lightmap_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	xor	edx,edx
	and	eax,3fffh
	mov	dl,ds:[esi+Triangle_Phong]	;EDX = lightmap-number
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_PhongMap_List]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]		;EAX = texture-address
	mov	edx,ds:[4*edx+4+ebx]		;EDX = lightmap-address
	mov	ebx,ds:[GVE_Shading_LUT]
	add	eax,GVE_BITMAP_SIZE
	add	edx,GVE_BITMAP_SIZE
	mov	d ds:[TMTXT-4],eax
	mov	d ds:[TMLUT-4],ebx
	mov	d ds:[TMMAP-4],edx


__Draw8_Lightmap_Texture:
	GRAB_VERTICES TEXTURE_CHROME_POLY
	GRAB_SLOPES TEXTURE_CHROME_POLY
	CLIP_VERTICAL TEXTURE_CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+ecx-1]		;EDI = start pixel
	mov	esi,ebx			;ESI = horizontal counter
	@@L2:   mov	ecx,eax
		mov	ebx,edx
		shr	ecx,16
		shr	ebx,16
		mov    	cl,ah		;ECX = texture (u,v)-coordinate
		mov	bl,dh		;EBX = chrome (u,v)-coordinate
		add	eax,12345678h	;ECX += Texture-increment
	@@T2:	mov	cl,b ds:[ecx+12345678h]
	TMTXT:  mov	ch,b ds:[ebx+12345678h]
	TMMAP:  add	edx,12345678h	;EDX += chrome-increment
	@@P2:   mov	cl,ds:[ecx+12345678h]
	TMLUT:  inc	esi		;ESI += 1  (horizontal counter)
		mov	ds:[edi+esi],cl
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@P0-4],12345678h	;Increment vertical gouraud value
@@P1:	add	edi,ds:[GVE_Frame_Width]
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Lightmap_Texture_Triple ENDP
;
Draw8_Chrome_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	xor	edx,edx
	and	eax,3fffh
	mov	dl,ds:[esi+Triangle_Phong]	;EDX = lightmap-number
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_PhongMap_List]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]		;EAX = texture-address
	mov	edx,ds:[4*edx+4+ebx]		;EDX = lightmap-address
	mov	ebx,ds:[GVE_Glass_LUT]
	add	eax,GVE_BITMAP_SIZE
	add	edx,GVE_BITMAP_SIZE
	mov	d ds:[TCTXT-4],eax
	mov	d ds:[TCLUT-4],ebx
	mov	d ds:[TCMAP-4],edx


__Draw8_Chrome_Texture:
	GRAB_VERTICES TEXTURE_CHROME_POLY
	GRAB_SLOPES TEXTURE_CHROME_POLY
	CLIP_VERTICAL TEXTURE_CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+ecx-1]		;EDI = start pixel
	mov	esi,ebx			;ESI = horizontal counter
	@@L2:   mov	ecx,eax
		mov	ebx,edx
		shr	ecx,16
		shr	ebx,16
		mov    	cl,ah		;ECX = texture (u,v)-coordinate
		mov	bl,dh		;EBX = chrome (u,v)-coordinate
		add	eax,12345678h	;ECX += Texture-increment
	@@T2:	mov	cl,b ds:[ecx+12345678h]
	TCTXT:  mov	ch,b ds:[ebx+12345678h]
	TCMAP:  add	edx,12345678h	;EDX += chrome-increment
	@@P2:   mov	cl,ds:[ecx+12345678h]
	TCLUT:  inc	esi		;ESI += 1  (horizontal counter)
		mov	ds:[edi+esi],cl
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@P0-4],12345678h	;Increment vertical gouraud value
@@P1:	add	edi,ds:[GVE_Frame_Width]
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Chrome_Texture_Triple ENDP
;
;
;
; Now come some bump-mapping-routines. They simply use another shading-LUT.
;
Draw8_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	push	ebp
	and	eax,3fffh
	mov	ecx,ds:[GVE_Texture_List]
	mov	eax,ds:[4*eax+4+ecx]		;*8 bytes/entry
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TNADR-4],eax

	jmp	__Draw8_Texture
Draw8_Bump_Triple ENDP
;
Draw8_Lambert_Bump_Triple PROC NEAR
	push	ebp
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	mov	edx,ds:[esi+Triangle_Vertex1]
	and	eax,3fffh
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[edx+VShading]		;EBX = light-thingy
	mov	eax,ds:[4*eax+4+ecx]		;*8 bytes/entry
	sar	ebx,GVE_SHAD_SHIFT-5
	add	eax,GVE_BITMAP_SIZE
	add	ebx,32				;EBX = LUT-Number
	shl	ebx,8
	mov	d ds:[TLADR-4],eax
	add	ebx,ds:[GVE_Bump_LUT]
	mov	d ds:[TLLUT-4],ebx

	jmp 	__Draw8_Lambert_Texture
Draw8_Lambert_Bump_Triple ENDP
;
Draw8_Gouraud_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Bump_LUT]
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	push	ebp
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TGLUT-4],ebx
	mov	d ds:[TGADR-4],eax

	jmp	__Draw8_Gouraud_Texture
Draw8_Gouraud_Bump_Triple ENDP
;
Draw8_Phong_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	xor	edx,edx
	and	eax,3fffh
	mov	dh,ds:[esi+Triangle_Phong]	;EDX = phong-exponent
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_Bump_LUT]
	mov	eax,ds:[4*eax+4+ecx]		;*8 bytes/entry
	add	edx,OFFSET Phong_Texture_Table-256
	add	eax,GVE_BITMAP_SIZE
	push	ebp
	mov	d ds:[TPTBL-4],edx
	mov	d ds:[TPLUT-4],ebx
	mov	d ds:[TPADR-4],eax

	jmp	__Draw8_Phong_Texture
Draw8_Phong_Bump_Triple ENDP
;
Draw8_Glass_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]
	mov	ebx,ds:[GVE_Glass_LUT]
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[TTGLS-4],ebx
	mov	d ds:[TTADR-4],eax

	jmp	__Draw8_Glass_Texture
Draw8_Glass_Bump_Triple ENDP
;
Draw8_Lightmap_Bump_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	xor	edx,edx
	and	eax,3fffh
	mov	dl,ds:[esi+Triangle_Phong]	;EDX = lightmap-number
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_PhongMap_List]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]		;EAX = texture-address
	mov	edx,ds:[4*edx+4+ebx]		;EDX = lightmap-address
	mov	ebx,ds:[GVE_Bump_LUT]
	add	eax,GVE_BITMAP_SIZE
	add	edx,GVE_BITMAP_SIZE
	mov	d ds:[TMTXT-4],eax
	mov	d ds:[TMLUT-4],ebx
	mov	d ds:[TMMAP-4],edx

	jmp	__Draw8_Lightmap_Texture
Draw8_Lightmap_Bump_Triple ENDP

;
;
;
; Now come some chrome-mapping-routines that may also be used to simulate
; a better phong-shding
;
Draw8_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[CNADR-4],eax

	GRAB_VERTICES CHROME_POLY
	GRAB_SLOPES CHROME_POLY
	CLIP_VERTICAL CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@P0:   mov	edx,12345678h		;Get horizontal texture slope
@@P2:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+ecx]		;ESI = start pixel
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr  	eax,16
	mov	al,ch
	@@L2:	mov	al,ds:[eax+12345678h]
	CNADR:	add	ecx,edx		;ECX += Texture-increment
		mov	ds:[esi+ebx],al	;Set texel
		mov	eax,ecx		;EAX  = texture (u,v)-coordinate
		shr	eax,16		;AH   = texture u coordinate
		inc	ebx		;EBX += 1  (horizontal counter)
		mov	al,ch		;AL   = texture v coordinate
		jnz	short @@L2	;Loop !
@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@P1:   add	edi,ds:[GVE_Frame_Width]
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !

@@End:  pop	ebp
	retn
Draw8_Chrome_Triple ENDP
;
Draw8_Lambert_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	mov	edx,ds:[esi+Triangle_Vertex1]	;EDX = first vector
	and	eax,3fffh
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[edx+VShading]	;EBX = light-thingy
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	sar	ebx,GVE_SHAD_SHIFT-5
	push	ebp
	add	ebx,32			;EBX = LUT-Number
	add	eax,GVE_BITMAP_SIZE
	shl	ebx,8
	mov	d ds:[CLADR-4],eax
	add	ebx,ds:[GVE_Shading_LUT]
	mov	d ds:[CLLUT-4],ebx

	GRAB_VERTICES CHROME_POLY
	GRAB_SLOPES CHROME_POLY
	CLIP_VERTICAL CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@P0:   mov	edx,12345678h		;Get horizontal texture slope
@@P2:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+ecx]		;ESI = start pixel
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16			;AH  = Texture u-coordinate
	@@L2:	mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,edx		;ECX += Texture-increment
		movzx	eax,b ds:[eax+12345678h]
	CLADR: 	mov	al,ds:[eax+12345678h]
	CLLUT:	mov	ds:[esi+ebx],al	;Set texel
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	ebx		;EBX += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@P1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Lambert_Chrome_Triple ENDP
;
Draw8_Gouraud_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	mov	ebx,ds:[GVE_Shading_LUT]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[CGLUT-4],ebx
	mov	d ds:[CGADR-4],eax

	GRAB_VERTICES CHROME_GOURAUD_POLY
	GRAB_SLOPES CHROME_GOURAUD_POLY
	CLIP_VERTICAL CHROME_GOURAUD_POLY
	add	d ds:[@@G0-4],1 shl GVE_SHAD_SHIFT
	sar	d ds:[@@G2-4],GVE_SHAD_SHIFT-13

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@P0:   mov	edx,12345678h		;Get horizontal texture slope
@@P2:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL CHROME_GOURAUD_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+ecx]
	mov	ecx,ebx
	mov	ebx,esi			;EBX = Gouraud-value
	mov	esi,ecx			;ESI = Vertical counter
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16			;AH  = Texture u-coordinate
	@@L2:	mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,edx		;ECX += Texture-increment
		mov	al,b ds:[eax+12345678h]
	CGADR:  mov	ah,bh		;AH  = gouraud value
		mov	al,ds:[eax+12345678h]
	CGLUT:  add	ebx,12345678h	;EBX += Gouraud-increment
	@@G2:	mov	ds:[edi+esi],al	;Set texel
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	esi		;ESI += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@P1:   add     d ds:[@@G0-4],12345678h	;Increment vertical gouraud value
@@G1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@P1-4],12345678h
	@@P3:	mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Gouraud_Chrome_Triple ENDP
;
Draw8_Phong_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	xor	edx,edx
	and	eax,3fffh
	mov	dh,ds:[esi+Triangle_Phong]	;EDX = phong-exponent
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_Shading_LUT]
	mov	eax,ds:[4*eax+4+ecx]		;*8 bytes/entry
	add	edx,OFFSET Phong_Texture_Table-256
	add	eax,GVE_BITMAP_SIZE
	push	ebp
	mov	d ds:[CPTBL-4],edx
	mov	d ds:[CPLUT-4],ebx
	mov	d ds:[CPADR-4],eax

	GRAB_VERTICES CHROME_PHONG_POLY
	GRAB_SLOPES CHROME_PHONG_POLY
	CLIP_VERTICAL CHROME_PHONG_POLY
	add	d ds:[@@G0-4],1 shl GVE_SHAD_SHIFT
	sar	d ds:[@@G2-4],GVE_SHAD_SHIFT-15

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@P0:   mov	edx,12345678h		;Get horizontal texture slope
@@P2:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	push	edx
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL CHROME_PHONG_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	push	ebp
	lea	edi,[edi+ecx]
	mov	ebp,ebx			;EBP = counter
	mov	ebx,esi			;EBX = Gouraud-value
	mov	ecx,eax			;ECX = Texture (u,v) start
	mov	esi,edx			;ESI = texture-increment
	xor	edx,edx
	shr	eax,16			;AH  = Texture u-coordinate

	@@L2:	mov	dl,bh		;EDX = Gouraud value
		mov    	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,esi		;ECX += Texture-increment
		mov	al,b ds:[eax+12345678h]
	CPADR:  mov	ah,ds:[edx+12345678h]
	CPTBL:	mov	al,ds:[eax+12345678h]
	CPLUT:  add	ebx,12345678h	;EBX += Gouraud-increment
	@@G2:	mov	ds:[edi+ebp],al	;Set texel
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	ebp		;ESI += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

	pop	ebp
	pop	edi
@@N:	pop	edx
	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@P1:   add     d ds:[@@G0-4],12345678h	;Increment vertical gouraud value
@@G1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@P1-4],12345678h
	@@P3:	mov	d ds:[@@G1-4],12345678h
	@@G3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Phong_Chrome_Triple ENDP
;
Draw8_Glass_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	mov	ecx,ds:[GVE_Texture_List]
	and	eax,3fffh
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]	;*8 bytes/entry
	mov	ebx,ds:[GVE_Glass_LUT]
	add	eax,GVE_BITMAP_SIZE
	mov	d ds:[CTGLS-4],ebx
	mov	d ds:[CTADR-4],eax


	GRAB_VERTICES CHROME_POLY
	GRAB_SLOPES CHROME_POLY
	CLIP_VERTICAL CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@P0:   mov	edx,12345678h		;Get horizontal texture slope
@@P2:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	short @@J1		;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	lea	esi,[edi+ecx]		;ESI = start pixel
	mov	ecx,eax			;ECX = Texture (u,v) start
	shr	eax,16
	@@L2:	mov 	al,ch		;EAX = texture (u,v)-coordinate
		add	ecx,edx		;ECX += Texture-increment
		mov	al,b ds:[eax+12345678h]
	CTADR:  mov	ah,ds:[esi+ebx]
		mov	al,ds:[eax+12345678h]
	CTGLS:	mov	ds:[esi+ebx],al	;Set texel
		mov	eax,ecx
		shr	eax,16		;AH   = texture u-coordinate
		inc	ebx		;EBX += 1  (horizontal counter)
		jnz	short @@L2	;Loop !

@@N:    pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@P1:	add	edi,ds:[GVE_Frame_Width]	;Advance one row
	dec	ebp			;EBP holds vertical line counter
	jnz	short @@L1		;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ebp,esi		;EBP = new vertical count
		mov	ecx,12345678h
	@@S4:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Glass_Chrome_Triple ENDP
;
;
;
; Now a new texture-plasma mapper
;
Draw8_Bump_Chrome_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	xor	edx,edx
	and	eax,3fffh
	mov	dl,ds:[esi+Triangle_Bump]	;EDX = bump-number
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_BumpMap_List]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]		;EAX = texture-address
	mov	edx,ds:[4*edx+4+ebx]		;EDX = bumpmap-address
	add	eax,GVE_BITMAP_SIZE
	add	edx,GVE_BITMAP_SIZE
	mov	d ds:[BCTXT-4],eax
	mov	d ds:[BCMAP-4],edx

	GRAB_VERTICES TEXTURE_CHROME_POLY
	GRAB_SLOPES TEXTURE_CHROME_POLY
	CLIP_VERTICAL TEXTURE_CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+ecx-1]		;EDI = start pixel
	mov	esi,ebx			;ESI = horizontal counter
	@@L2:   mov	ecx,eax
		mov	ebx,edx
		shr	ecx,16
		shr	ebx,16
		mov    	cl,ah		;ECX = texture (u,v)-coordinate
		mov	bl,dh		;EBX = chrome (u,v)-coordinate
		add	eax,12345678h	;EAX += Texture-increment
	@@T2:	add	bx,w ds:[2*ecx+12345678h]
	BCMAP:  mov	cl,b ds:[ebx+12345678h]
	BCTXT:  add	edx,12345678h	;EDX += chrome-increment
	@@P2:   inc	esi		;ESI += 1  (horizontal counter)
		mov	ds:[edi+esi],cl
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@P0-4],12345678h	;Increment vertical gouraud value
@@P1:	add	edi,ds:[GVE_Frame_Width]
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Bump_Chrome_Triple ENDP
;
Draw8_Bump_Texture_Triple PROC NEAR
	mov	ax,ds:[esi+Triangle_Texture]	;EAX = texture-number
	xor	edx,edx
	and	eax,3fffh
	mov	dl,ds:[esi+Triangle_Phong]	;EDX = lightmap-number
	mov	ecx,ds:[GVE_Texture_List]
	mov	ebx,ds:[GVE_PhongMap_List]
	push	ebp
	mov	eax,ds:[4*eax+4+ecx]		;EAX = texture-address
	movzx	ecx,ds:[esi+Triangle_Bump]
	mov	ebx,ds:[4*edx+4+ebx]		;EBX = lightmap-address
	mov	edx,ds:[GVE_BumpMap_List]
	mov	ecx,ds:[4*ecx+4+edx]		;ECX = Bumpmap-address
	mov	edx,ds:[GVE_Shading_LUT]
	add	eax,GVE_BITMAP_SIZE
	add	ebx,GVE_BITMAP_SIZE
	add	ecx,GVE_BITMAP_SIZE
	mov	d ds:[BTTXT-4],eax
	mov	d ds:[BTMAP-4],ebx
	mov	d ds:[BTBMP-4],ecx
	mov	d ds:[BTLUT-4],edx


	GRAB_VERTICES TEXTURE_CHROME_POLY
	GRAB_SLOPES TEXTURE_CHROME_POLY
	CLIP_VERTICAL TEXTURE_CHROME_POLY

	;
	;Vertical drawing loop starts here !
	mov	eax,12345678h		;Get texture start value
@@T0:   imul 	edi,ds:[GVE_Frame_Width]
	add	edi,ds:[GVE_Frame_Buffer]
	test	ebp,ebp			;EBP = int.part of 1st counter
	jz	@@J1			;JZ => Next counter !
	;
	push	esi
@@L1:   push	eax			;Save start (u,v)-coordinate
	push	ebx			;Save X0
	push	ecx			;Save X1
	db	87h			;xchg dword
@@C1	db	?			;xchg edx,edx / xchg ebx,ecx
	CLIP_HORIZONTAL TEXTURE_CHROME_POLY
	sub	ebx,ecx			;EBX = negative width of span
	jns     short @@N		;EBX >= 0 ==> Nothing to draw !
	push	edi
	lea	edi,[edi+ecx-1]		;EDI = start pixel
	mov	esi,ebx			;ESI = horizontal counter
	@@L2:   mov	ecx,eax
		mov	ebx,edx
		shr	ecx,16
		shr	ebx,16
		mov    	cl,ah		;ECX = texture (u,v)-coordinate
		mov	bl,dh		;EBX = chrome (u,v)-coordinate
		add	eax,12345678h	;ECX += Texture-increment
	@@T2:   add	bx,ds:[2*ecx+12345678h]
	BTBMP:	mov	cl,ds:[ecx+12345678h]
	BTTXT:  mov	ch,ds:[ebx+12345678h]
	BTMAP:  add	edx,12345678h	;EDX += chrome-increment
	@@P2:   mov	cl,ds:[ecx+12345678h]
	BTLUT:  inc	esi		;ESI += 1  (horizontal counter)
		mov	ds:[edi+esi],cl
		jnz	short @@L2	;Loop !

	pop	edi
@@N:	pop	ecx			;Restore X1
	pop	ebx			;Restore X0
	pop	eax			;Restore texture-start value
	;
	add	ebx,12345678h		;Increment X0
@@S1:	add	ecx,12345678h		;Increment X1
@@S2:   add	eax,12345678h		;Increment vertical texture (u,v)
@@T1:   add     d ds:[@@P0-4],12345678h	;Increment vertical gouraud value
@@P1:	add	edi,ds:[GVE_Frame_Width]
	dec	ebp			;EBP holds vertical line counter
	jnz	@@L1			;Loop !

	pop	esi
@@J1:	test	esi,esi
	jz	short @@End		;Is there s.th left to draw ???
		push	ebp
		mov	d ds:[@@S2-4],12345678h
	@@S3:   mov	ecx,12345678h	;ECX = new X1
	@@S4:	mov	ebp,esi		;EBP = new vertical count
		mov	d ds:[@@T1-4],12345678h
	@@T3:	mov	d ds:[@@P1-4],12345678h
	@@P3:	jmp	@@L1		;Do loop again !
@@End:  pop	ebp
	retn
Draw8_Bump_Texture_Triple ENDP
;
;
;
; The following texture-mappers have perspective correction
;
Draw8_PTexture_Triple PROC NEAR
	retn
Draw8_PTexture_Triple ENDP
;
Draw8_Lambert_PTexture_Triple:
Draw8_Gouraud_PTexture_Triple:
Draw8_Phong_PTexture_Triple:
Draw8_Lightmap_PTexture_Triple:
Draw8_Chrome_PTexture_Triple:
Draw8_Glass_PTexture_Triple:
	retn

;
;
;
; This routine will simply draw all vertices of a poly
;
Draw8_Vertices PROC NEAR
	mov	edi,ds:[GVE_Frame_Buffer]
	movzx	ecx,ds:[esi+Triangle_Vertex_Count]		;ECX = Number of vertices

@@L1:	mov	edx,ds:[esi+20+4*ecx]		;Get vertex
	mov	ebx,ds:[edx+Vertex_ScreenX]    	;Get projected X
	sar	ebx,16
	cmp	ebx,ds:[GVE_Frame_Width]
	jae	short @@N
	mov	eax,ds:[edx+Vertex_ScreenY]	;Get projected Y
	cmp	eax,ds:[GVE_Frame_Height]
	jae	short @@N

	imul 	eax,ds:[GVE_Frame_Width]
	add	eax,ebx
	mov	dl,ds:[esi+Triangle_Colour]	;Get colour
	mov	ds:[edi+eax],dl

@@N:    dec	ecx
	jnz	short @@L1

	retn
Draw8_Vertices ENDP

;
;   GOMEZ VECTOR ENGINE                                 SPECIAL EFFECTS
;
;
;
; Here come some special F/X algorithms such like motion blurr, feed back
; etc....
;
;
; FX8_Motion_Trace:
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	Blurred frame
;   Destroys:
;	EAX,EBX,ECX,EDI
;
PUBLIC FX8_Motion_Trace
FX8_Motion_Trace PROC NEAR
	mov	ebx,ds:[GVE_Blurr_LUT]
	mov 	ecx,ds:[GVE_Frame_Width]
	imul	ecx,ds:[GVE_Frame_Height]
	shr	ecx,2

	@@L6:  	mov	eax,ds:[esi]
		xlatb
		add	esi,4
		rol	eax,8
		xlatb
		rol	eax,8
		xlatb
		rol	eax,8
		xlatb
		rol	eax,8
		mov	ds:[edi],eax
		add	edi,4
		dec	ecx
		jnz	short @@L6
	retn
FX8_Motion_Trace ENDP
;
;
; Here come some special F/X algorithms such like motion blurr, feed back
; etc....
;
;
; FX8_Motion_Blurr:
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	Blurred frame
;   Destroys:
;	EAX,EBX,ECX,EDI
;
PUBLIC FX8_Motion_Blurr
FX8_Motion_Blurr PROC NEAR
	push	ebp
	mov	ebp,ds:[GVE_Glass_LUT]
	mov 	ecx,ds:[GVE_Frame_Width]
	imul	ecx,ds:[GVE_Frame_Height]
	shr	ecx,2
	xor	eax,eax
	xor	ebx,ebx
	xor	edx,edx

	@@L6:  	mov	al,ds:[esi]
		mov	ah,ds:[edi]
		mov	bl,ds:[esi+1]
		mov	bh,ds:[edi+1]
		mov	dl,ds:[esi+2]
		mov	dh,ds:[edi+2]
		mov	al,ds:[ebp+eax]
		mov	ah,ds:[ebp+ebx]
		mov	bl,ds:[esi+3]
		mov	bh,ds:[edi+3]
		shl	eax,16
		mov	al,ds:[ebp+edx]
		mov	ah,ds:[ebp+ebx]
		ror	eax,16
		mov	ds:[edi],eax
		add	esi,4
		add	edi,4
		xor	eax,eax
		dec	ecx
		jnz	short @@L6
	pop	ebp
	retn
FX8_Motion_Blurr ENDP
;
;
; FX8_Feed_Back:
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	new frame
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
PUBLIC FX8_Feed_Back
FX8_Feed_Back PROC NEAR
	mov	eax,ds:[GVE_Frame_Width]
	mov	ebx,ds:[GVE_Frame_Height]
	shr	eax,3
	imul	ebx,eax
	add	eax,ebx
	lea	esi,[esi+eax]
	xor	ebx,ebx
	xor	edx,edx
	xor	ebp,ebp

	mov	edx,ds:[GVE_Frame_Height]
	@@L1:	push	esi
		push	edx
		push	ebp

		mov	ebp,ds:[GVE_Blurr_LUT]
		mov	ecx,ds:[GVE_Frame_Width]
		shr	ecx,2
	@@L2:	mov	bl,ds:[esi]
		mov	al,ds:[ebp+ebx]

		mov	bl,ds:[esi+1]
		mov	ah,ds:[ebp+ebx]
		rol	eax,16

		mov	bl,ds:[esi+2]
		add	esi,3
		mov	al,ds:[ebp+ebx]
		mov	ah,al
		ror	eax,16
		stosd

		dec	ecx
		jnz	short @@L2

		pop	ebp
		pop	edx
		pop	esi
		add	bp,0c000h	;Zoom factor 3:4
		jnc	short @@1
		add	esi,ds:[GVE_Frame_Width]
	@@1:	dec	edx
		jnz	short @@L1

	retn
FX8_Feed_Back ENDP
;
;
; FX8_Soften_Horizontal
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	new frame
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
PUBLIC FX8_Soften_Horizontal
FX8_Soften_Horizontal PROC NEAR
	mov	esi,ds:[GVE_Glass_LUT]
	mov 	ecx,ds:[GVE_Frame_Width]
	imul	ecx,ds:[GVE_Frame_Height]
	shr	ecx,2
	xor	eax,eax
	xor	ebx,ebx
	@@L7:   mov	al,[edi]	;AL = 1st pixel
		mov	bl,[edi+2]	;BL = 3rd pixel
		mov	al,[esi+eax]	;AL = Softened 0&1 pixel
		mov	ah,[edi+1]	;AH = 2nd pixel
		mov	ah,[esi+eax]	;AH = Softened 1&2 pixel
		mov	bh,ah		;BH = new 2nd pixel
		shl	eax,16
		mov	bl,[esi+ebx]	;BL = Softened 2&3 pixel
		mov	bh,[edi+3]	;BH = 4th pixel
		mov	bh,[esi+ebx]	;BH = Softened 3&4 pixel
		mov	ax,bx
		rol	eax,16
		mov	ds:[edi],eax	;Set pixel (AL = [edi] / AH = [edi+1])
		add	edi,4
		mov	eax,ebx		;AH = last pixel set
		dec	ecx
		jnz	@@L7
	retn
FX8_Soften_Horizontal ENDP
;
;
; FX8_Soften_Vertical
;   Input:
;	ESI	- src frame
;	EDI 	- dst frame
;   Output:
;	new frame
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
PUBLIC FX8_Soften_Vertical
FX8_Soften_Vertical PROC NEAR
	mov	esi,ds:[GVE_Glass_LUT]
	mov	ebp,ds:[GVE_Frame_Height]
	dec	ebp
	imul	ebp,ds:[GVE_Frame_Width]
	shr	ebp,2
	xor	ebx,ebx
	xor	ecx,ecx
	mov	edx,ds:[GVE_Frame_Width]
	mov	bl,ds:[edi]
	mov	cl,ds:[edi+1]
	mov	bh,ds:[edi+edx]
	mov	ch,ds:[edi+edx+1]
	@@L8:	mov	al,[esi+ebx]
		mov	bl,ds:[edi+2]
		mov	ah,[esi+ecx]
		mov	bh,ds:[edi+edx+2]
		mov	cl,ds:[edi+3]
		shl	eax,16
		mov	ch,ds:[edi+edx+3]
		mov	al,[esi+ebx]
		mov	bl,ds:[edi+4]
		mov	ah,[esi+ecx]
		mov	bh,ds:[edi+edx+4]
		mov	cl,ds:[edi+5]
		rol	eax,16
		mov	ch,ds:[edi+edx+5]
		mov	ds:[edi+edx],eax
		add	edi,4
		dec	ebp
		jnz	short @@L8
	retn
FX8_Soften_Vertical ENDP

CODE32 ends
END