;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;

ALIGN dword
LColour	LABEL DWORD
	LColour_Red		db	?
	LColour_Green		db	?
	LColour_Blue		db	?
				db	?
SColour	LABEL DWORD
	SColour_Red		db	?
	SColour_Green		db	?
	SColour_Blue		db	?
				db	?
Darkness			dd	?
Brightness			dd	?

;
;
; Now follows a LUT-Generator in order to get a shading LUT for a given 3*6
; bit palette.
;
;
; FIT_COLOUR:
;  Input:
;	EDX   	- colour to fit	(3*8 bit)
;	DS:ESI 	- DATA32 ptr to palette	(3*8 bit)
;  Output:
;	EDX     - Best difference
;	CH	- Best colour
;  Destroys:
;	EAX,EBX,ECX,EDX
;
;  All colours have the following format:
;	8bit   8bit  8bit   8bit
;	 EDH    EDL   DH     DL
;	  ?    Blue  Green  Red
;
Fit_Colour PROC NEAR
	push 	esi		;Save old colour-ptr
	push	edi
	push	ebp

	mov	ebp,edx		;EBP = Colour to fit
	mov	ebx,esi		;EBX = Ptr to palette
	movzx	esi,dl		;ESI = Red
	movzx	edi,dh		;EDI = Green
	shr	ebp,16
	and	ebp,0ffh        ;EBP = Blue
	xor	ecx,ecx		;CL  = Counter     CH = Best colour
	mov 	edx,0fffh	;EDX = Difference
	@@L1:	push	ecx
		movzx 	eax,b ds:[ebx]
		sub	eax,esi		;EAX = Red difference
		jns 	short @@1
		neg 	eax
	@@1:   	movzx	ecx,b ds:[ebx+1]
		sub	ecx,edi		;ECX = Green difference
		jns 	short @@2
		neg 	ecx
	@@2:	add 	eax,ecx
		movzx 	ecx,b ds:[ebx+2]
		sub 	ecx,ebp		;ECX = Blue difference
		jns 	short @@3
		neg 	ecx
	@@3:	add 	eax,ecx		;EAX = total difference
		pop	ecx
		cmp     eax,edx		;Compare differences
		jae	short @@No
			mov	edx,eax	;Best difference
			mov	ch,cl	;Best index
	@@No: 	add	ebx,4
		inc	cl
		jnz	short @@L1

	pop	ebp
	pop	edi
	pop	esi
	retn
Fit_Colour ENDP

;
;
; This macro converts a 32bit colour value into a 15/16bit colour value
;
; REDUCE_COLOUR:
;  Input:
;	EDX	- 32bit colour value
;  Output:
;	AX	- 15/16bit colour value
;  Destroys:
;	EAX,ECX,EDX
;
REDUCE_COLOUR MACRO
	mov	ecx,16
	sub	ecx,ds:[GVE_Frame_Depth]
	bswap	edx
	shld	eax,edx,5
	shl	edx,8
	shld	eax,edx,6
	shr	eax,cl
	shl	edx,8
	shld	eax,edx,5
	ENDM

;
;
; Now some macros for calculating shading colours
;   DARKEN_COLOUR
;   BRIGHTEN_COLOUR
;
; Notes on the calculation:
;      Darkening: (0  i  31)
;	   dr(r,i,darkness)=(r*i + (32-i)*((64-Darkness)*r + Darkness*0)/64) /32
;	Lightening: (0  i  31)
;	   lr(r,i,brightness,br)=((32-i)*r + i*((64-Brightness)*r + Brightness*br)/64) /32
;
DARKEN_COLOUR MACRO col_src,count
	LOCAL J
	movzx	eax,col_src		;Get original colour
	mov     ebx,64
	sub	ebx,ds:[Darkness]
	imul	ebx			;EAX holds (64-Darkness)*r
	mov	ebx,31
	sub	ebx,count		;EBX = 32-i
	imul	ebx			;EAX = (32-i)*64-Darkness*r
	shr	eax,6			;EAX = (32-i)*(64-Darkness*r/64)
	movzx	edx,col_src
	imul	edx,count		;EDX = r*i
	add	eax,edx			;Add both results
	shr	eax,5			;Divide by 32
	cmp	eax,255			;Clip colour value
	jbe	short J
		mov	eax,255
J:	ENDM

BRIGHTEN_COLOUR MACRO col_src,col_light,count
	LOCAL J
	movzx	eax,col_src		;Get original colour
	mov     ebx,64
	sub	ebx,ds:[Brightness]
	imul	ebx			;EAX holds (64-Brightness)*r
	movzx	edx,col_light
	imul	edx,ds:[Brightness]	;EDX = Brightness*light_colour
	add	eax,edx			;EAX = (64-Brightness)*r + Brightness*light_colour
	imul	count			;EAX = i * EAX
	shr	eax,6			;EAX /= 64
	movzx	edx,col_src		;Get source-colour
	mov	ebx,32
	sub	ebx,count		;EBX = (32 - i)
	imul	edx,ebx  		;EDX = (32-i) * r
	add	eax,edx			;Add both results
	shr	eax,5			;Divide by 32
	cmp	eax,255			;Clip colour value
	jbe	short J
		mov	eax,255
J:	ENDM

;
;
; Shade_Colour:
;  Input:
;	EAX	- SOurce-Colour
;      EBX	- Strength      (-32[Dark] to +32[Bright])
;      CL	- Darkness	(0 to 64)
;	CH	- Brightness	(0 to 64)
;	EDX	- Light-Colour
;  Output:
;	EDX	- Shaded colour
;
;  All colours have the following format:
;	8bit   8bit  8bit   8bit
;	 E?H    E?L   ?H     ?L
;	  ?    Blue  Green  Red
;
Shade_Colour PROC NEAR
	push	ebp
	xor	ebp,ebp
	mov	ds:[SColour],eax
	mov	ds:[LColour],edx
	mov	b ds:[Darkness],CL
	mov	b ds:[Brightness],CH
	mov	ecx,ebx
	test	bl,bl
	js	@@Drk
	;
	BRIGHTEN_COLOUR ds:[SColour_Red],ds:[LColour_Red],ecx
	shrd	ebp,eax,8		;Save into EBP !
	BRIGHTEN_COLOUR ds:[SColour_Green],ds:[LColour_Green],ecx
	shrd	ebp,eax,8		;Save into EBP !
	BRIGHTEN_COLOUR ds:[SColour_Blue],ds:[LColour_Blue],ecx
	shrd	ebp,eax,16		;Save into EBP !
	mov	edx,ebp                 ;Put RGB-value into EDX
	jmp	@@End
	;
@@Drk:  add	ecx,32
	DARKEN_COLOUR ds:[SColour_Red],ecx
	shrd	ebp,eax,8		;Save into EBP !
	DARKEN_COLOUR ds:[SColour_Green],ecx
	shrd	ebp,eax,8		;Save into EBP !
	DARKEN_COLOUR ds:[SColour_Blue],ecx
	shrd	ebp,eax,16		;Save into EBP !
	mov	edx,ebp                 ;Put RGB-value into EDX
	;
@@End:	pop	ebp
	retn
Shade_COlour ENDP
