;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
GVE_SYSTEM_FILE		equ	1



;
;
;
;   GOMEZ VECTOR ENGINE                                            v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gve32.inc
include gomez.inc
include gvecolor.inc

extrn C GVE_Palette_Buffer:BYTE
extrn GVE_IO_Buffer:BYTE


;
;
;
;   GOMEZ VECTOR ENGINE                                   TEXTURE FUNCTIONS
;
;
;
;
;
; Expand_List:
;  Input:
;	EAX 	- DATA32 ptr to list
;	ECX	- Requested number of entries
;  Output:
;	EAX	- DATA32 ptr to new list
;	CF	- Error flag
;
Expand_List PROC NEAR
	push	es
	push	esi
	push	edi

	mov	es,ds:[DATA32_Selector]
	cmp	ecx,GVE_MAX_TEXTURES
	ja	short @@Err
	cmp	ecx,ds:[eax]
	jbe	short @@Succ
	;
	push	ecx			;ECX = req. number of entries
	mov	ebx,eax			;EBX = ptr to list
	lea	ecx,[4*ecx+4]
	call	Realloc
	mov	edi,eax			;EDI = ptr to texture-list
	mov	ebx,eax			;EBX = ptr to texture-list
	pop	ecx			;ECX = Number of entries
	jc	@@Err
	mov	eax,ds:[ebx]		;EAX = old number of textures
	mov	ds:[ebx],ecx		;Save new list-size
	sub	ecx,eax           	;ECX = number of new entries
	lea	edi,[edi+4*eax+4]	;EDI = ptr to first new entry
	xor	eax,eax
	rep	stosd			;Clear all entries
	mov	eax,ebx			;EAX = New list
	;
@@Succ:	clc
@@Err:	pop	edi
	pop	esi
	pop	es
	retn
Expand_List ENDP


;
;
; GVE_Alloc_Bitmap
;  Input:
;	EBX	- Width
;	ECX	- Height
;	EDX	- Depth
;  Output:
;	EAX	- DATA32 ptr to allocated texture header
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Alloc_Bitmap
GVE_Alloc_Bitmap PROC NEAR
	push	ds
	push	es
	push	edi

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ds:[@@width],ebx
	mov	ds:[@@height],ecx
	mov	ds:[@@depth],edx
	;
	add	edx,7
	shr	edx,3
	imul	ecx,ebx				;ECX = width*height
	imul	ecx,edx
	add	ecx,GVE_BITMAP_SIZE
	call	Malloc
	jc	@@Err
	mov	edi,eax
	mov	ecx,GVE_BITMAP_SIZE/4
	xor	eax,eax
	rep	stosd
	sub	edi,GVE_BITMAP_SIZE
	;
	mov	ebx,ds:[@@width]
	mov	ecx,ds:[@@height]
	mov	edx,ds:[@@depth]
	mov	ds:[edi+Bitmap_Width],bx
	mov	ds:[edi+Bitmap_Height],cx
	mov	ds:[edi+Bitmap_Depth],dl
	mov	ds:[edi+Bitmap_Magic],edi
	mov	ds:[edi+Bitmap_Type],GVE_TYP_BITMAP
	mov	eax,edi				;EAX = return address
	clc
	;
@@Err:	pop	edi
	pop	es
	pop	ds
	retn

		ALIGN	DWORD
@@width		dd	?
@@height	dd	?
@@depth		dd	?
GVE_Alloc_Bitmap ENDP



;
;   GOMEZ VECTOR ENGINE                                   TEXTURE FUNCTIONS
;
;
;
; GVE_Get_Texture_Info
;  Input:
;	EAX	- DATA32 ptr to world-header
;     	EDX	- Texture-Number
;  Output:
;	CF	- error-flag
; 	EAX	- Texture header address or zero
;	EBX	- Texture width
;	ECX	- Texture height
;	EDX	- Texture depth
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Get_Texture_Info
GVE_Get_Texture_Info PROC NEAR
	push	ds
	push	esi

	mov	ds,cs:[DATA32_Selector]
	mov	esi,ds:[eax+World_TextureMap_List]
Info_Map:
	cmp	edx,ds:[esi]
	jae	short @@Err
	mov	eax,ds:[esi+4*edx+4]
	test	eax,eax
	jz	short @@Err
	movzx	ebx,ds:[eax+Bitmap_Width]
	movzx	ecx,ds:[eax+Bitmap_Height]
	movzx	edx,ds:[eax+Bitmap_Depth]

	clc
	pop	esi
	pop	ds
	retn

@@Err:  stc
	xor	eax,eax
	xor	ebx,ebx
	xor	ecx,ecx
	pop	esi
	pop	ds
	retn
GVE_Get_Texture_Info ENDP



;
;
; GVE_Alloc_Texture
;  Input:
;	EAX	- DATA32 ptr to world-header
;	EBX	- Width
;	ECX	- Height
;	EDX	- Texture number
;  Output:
;	EAX	- DATA32 ptr to allocated texture header
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Alloc_Texture
GVE_Alloc_Texture PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	esi,eax				;ESI = WOrld-header
	;
	mov	ds:[@@width],ebx
	mov	ds:[@@height],ecx
	mov	edi,edx				;EDI = entry-number
	lea	ecx,[edx+1]			;ECX = Number of needed entries
	mov	eax,ds:[esi+World_TextureMap_List]
	call    Expand_List
	jc	@@Err
	mov	ds:[esi+World_TextureMap_List],eax
	;
	lea	edi,[4*edi+eax+4]		;EDI = ptr to entry in texture-list
	mov	ecx,ds:[edi]			;EAX = old texture pointer
	call	Free				;Free old texture
	;
	mov	ebx,ds:[@@width]
	mov	ecx,ds:[@@height]
	mov	edx,8
	call	GVE_Alloc_Bitmap
	mov	ds:[edi],eax			;EAX = ptr to allocated memory

@@Err: 	pop     edi
	pop	esi
	pop	es
	pop	ds
	retn

		ALIGN	DWORD
@@width		dd	?
@@height	dd	?
GVE_Alloc_Texture ENDP



;
;
; GVE_Free_Texture
;  Input:
;	EAX	- DATA32 ptr to world-header
;	EDX	- Texture number
;  Output:
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Free_Texture
GVE_Free_Texture PROC NEAR
	push	ds
	push	edi

	mov	ds,cs:[DATA32_Selector]
	mov	edi,ds:[eax+World_TextureMap_List]	;EDI = texture list
Free_Map:
	;
	cmp	edx,ds:[edi]			;Is texture number too big ?
	jae 	short @@End
	lea	edi,[4*edx+edi+4]		;EDI = ptr to entry in texture-list
	mov	ecx,ds:[edi]			;EAX = old texture pointer
	test	ecx,ecx				;Is there a texture
	jz	short @@End
	call	Free				;Free texture
	mov	d ds:[edi],0
	;
@@End:  clc
	pop     edi
	pop	ds
	retn
GVE_Free_Texture ENDP



;
;
; GVE_Import_Texture
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- DATA32 ptr to file-name (PCX-file)
;	EDX	- texture number to load
;	ECX	- flags:
;		  bit 0 - rescale texture to 256x256
;		  bit 1 - remap texture
;  Output:
;	CF	- Error-Flag
;	EAX	- ptr to loaded texture header
;	EBX	- width of new texture
;	ECX	- height of new texture
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Import_Texture
GVE_Import_Texture PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	esi,eax				;ESI = world-header
	mov	edi,edx				;EDI = texture-number
	mov	ebp,ecx				;EBP = flags

	call	Read_PCX			;EAX = new texture
	jc	@@Err
	;
	push	eax
	mov	eax,ds:[esi+World_TextureMap_List]
	lea	ecx,[edi+1]			;ECX = Number of needed textures
	call	Expand_List
	mov	ds:[esi+World_TextureMap_List],eax
	mov	ecx,ds:[eax+4*edi+4]		;ECX = Old texture
	pop	d ds:[eax+4*edi+4]		;Load new texture-address
	jc	@@Err
	call	Free
	;
	test	ebp,GVE_TEXT_RESCALE
	jz	short @@J1
		mov	eax,esi
		mov	ebx,256
		mov	ecx,256
		mov	edx,edi
		call	GVE_Rescale_Texture

@@J1:	test	ebp,GVE_TEXT_REMAP
	jz	short @@J2
		mov	eax,esi
		mov	edx,edi
		xor	ebx,ebx
		call	GVE_Remap_Texture
@@J2:   ;
	mov	eax,ds:[esi+World_TextureMap_List]
	mov	eax,ds:[eax+4*edi+4]		;EAX = ptr to texture
	movzx	ebx,ds:[eax+Bitmap_Width]
	movzx	ecx,ds:[eax+Bitmap_Height]

@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn
GVE_Import_Texture ENDP



;
;
; GVE_Export_Texture
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- DATA32 ptr to file-name (PCX-file)
;	EDX	- texture number to save
;  Output:
;	CF	- Error-Flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Export_Texture
GVE_Export_Texture PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]		;Important !
	mov	ecx,ds:[eax+World_TextureMap_List]	;ECX = Ptr to texture-list
Export_Map:
	cmp	edx,ds:[ecx]                    ;EDX = texture to save
	jae	@@Err
	mov	eax,ds:[ecx+4*edx+4]		;EAX = address of texture
	mov	edx,ebx                         ;EDX = file-name
	mov	ebx,ds:[eax+World_Palette]	;EBX = address of palette
	test	eax,eax				;Is there a texture ???
	jz	@@Err

	call	Write_PCX

@@Err:	pop	ds
	retn
GVE_Export_Texture ENDP



;
;
; GVE_Remap_Texture
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- Ptr to old palette  or  zero for GVE_Palette_Buffer
;	EDX	- texture number to remap
;  Output:
;	CF	- Error-Flag
;	EAX	- ptr to remapped texture header
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Remap_Texture
GVE_Remap_Texture PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]		;Important !
	mov	es,ds:[DATA32_Selector]

	mov	esi,ds:[eax+World_TextureMap_List]	;ESI = ptr to texture-list
Remap_Map:
	cmp	edx,ds:[esi]			;Is texture number valid ?
	jae	@@End

	mov	edi,ds:[4*edx+esi+4]		;EDI = texture address
	test	edi,edi
	jz	@@End
	cmp	ds:[edi+Bitmap_Type],GVE_TYP_BITMAP
	jne	@@End

	movzx	edx,ds:[edi+Bitmap_Width]	;EDX = Width
	movzx	ecx,ds:[edi+Bitmap_Height]	;ECX = Height
	imul	ecx,edx				;ECX = size of texture
	push	edi				;Save return-value
	push	ecx				;Save size
	;
	mov	eax,ds:[eax+World_Palette]	;EAX = world palette
	mov	edx,OFFSET GVE_IO_Buffer	;EDX = translation LUT
	test	ebx,ebx				;EBX = old palette
	jnz	short @@Ok
	mov	ebx,OFFSET GVE_Palette_Buffer
@@Ok:	call	GVE_Fit_Palette
	;
	pop	ecx				;ECX = Texture size
	mov	edi,ss:[esp]			;EDI = texture address
	add	edi,GVE_BITMAP_SIZE
	mov	ebx,OFFSET GVE_IO_Buffer	;EBX = translation LUT
	@@L1:   mov	al,byte ptr ds:[edi]	;AL = old colour
		xlatb				;look it up
		stosb				;Save new colour
		dec	ecx
		jnz	short @@L1		;Loop !

	pop	eax				;EAX = texture address
@@End:	clc					;Clear carry => Success !
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Remap_Texture ENDP



;
;
; GVE_Rescale_Texture
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- New width
;	ECX	- New height
;	EDX	- texture number to rescale
;  Output:
;	CF	- Error-Flag
;	EAX	- ptr to rescaled texture
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Rescale_Texture
GVE_Rescale_Texture PROC NEAR
	push	ds
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[eax+World_TextureMap_List]	;EBP = ptr to texture-list
Rescale_Map:
	cmp	edx,ds:[ebp]			;Is texture number valid
	jae	@@Err
	lea	ebp,[4*edx+ebp+4]		;EBP = ptr to entry in texture-list
	mov	eax,ds:[ebp]			;EAX = ptr to old texture
	test	eax,eax
	jz	@@Err
	cmp	ds:[eax+Bitmap_Type],GVE_TYP_BITMAP
	jne	@@Err

	call	Rescale_Bitmap
	mov	ds:[ebp],eax

@@Err:	pop	ebp
	pop	ds
	retn
GVE_Rescale_Texture ENDP



;
;   GOMEZ VECTOR ENGINE                                 PHONG MAP FUNCTIONS
;
;
;
; GVE_Rescale_LightMap
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- New width
;	ECX	- New height
;	EDX	- texture number to rescale
;  Output:
;	CF	- Error-Flag
;	EAX	- ptr to rescaled texture-header
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Rescale_LightMap
GVE_Rescale_LightMap PROC NEAR
	push	ds
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,ds:[eax+World_PhongMap_List]
	jmp	Rescale_Map
GVE_Rescale_LightMap ENDP



;
;
; GVE_Export_LightMap
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- DATA32 ptr to file-name (PCX-file)
;	EDX	- lightmap number to save
;  Output:
;	CF	- Error-Flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Export_LightMap
GVE_Export_LightMap PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]		;Important !
	mov	ecx,ds:[eax+World_PhongMap_List]	;ECX = Ptr to texture-list
	jmp	Export_Map
GVE_Export_LightMap ENDP



;
;
; GVE_Import_LightMap
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- DATA32 ptr to file-name (PCX-file)
;	EDX	- texture number to load
;  Output:
;	[CF]	- Error-Flag
;	EAX	- ptr to loaded texture-header
;	EBX	- width of new texture
;	ECX	- height of new texture
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Import_LightMap
GVE_Import_LightMap PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	esi,eax				;ESI = world-header
	mov	edi,edx				;EDI = texture-number
	mov	ebp,ecx				;EBP = flags

	call	Read_PCX			;EAX = new texture
	jc	@@Err
	;
	push	eax
	mov	eax,ds:[esi+World_PhongMap_List]
	lea	ecx,[edi+1]			;ECX = Number of needed textures
	call	Expand_List
	mov	ds:[esi+World_PhongMap_List],eax
	mov	ecx,ds:[eax+4*edi+4]		;ECX = Old texture
	call	Free
	pop	eax				;EAX = Bitmap-address
	;
	mov	ebx,256
	mov	ecx,256
	call	Rescale_Bitmap
	;
	mov	edx,ds:[esi+World_PhongMap_List]
	mov	ds:[edx+4*edi+4],eax		;EAX = ptr to texture
	movzx	ebx,ds:[eax+Bitmap_Width]
	movzx	ecx,ds:[eax+Bitmap_Height]

@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn
GVE_Import_LightMap ENDP



;
;
; GVE_Alloc_LightMap
;  Input:
;	EAX	- DATA32 ptr to world-header
;	EBX	- Width
;	ECX	- Height
;	EDX	- Lightmap number
;  Output:
;	EAX	- DATA32 ptr to allocated lightmap memory
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Alloc_LightMap
GVE_Alloc_LightMap PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	esi,eax				;ESI = WOrld-header
	;
	mov	ds:[@@width],ebx
	mov	ds:[@@height],ecx
	mov	edi,edx				;EDI = entry-number
	lea	ecx,[edx+1]			;EDX = Number of nedded entries
	mov	eax,ds:[esi+World_PhongMap_List]
	call    Expand_List
	jc	@@Err
	mov	ds:[esi+World_PhongMap_List],eax
	;
	lea	edi,[4*edi+eax+4]		;EDI = ptr to entry in texture-list
	mov	ecx,ds:[edi]			;EAX = old texture pointer
	call	Free				;Free old texture
	;
	mov	ebx,ds:[@@width]
	mov	ecx,ds:[@@height]
	mov	edx,8
	call	GVE_Alloc_Bitmap
	mov	ds:[edi],eax			;EAX = ptr to allocated memory

@@Err: 	pop     edi
	pop	esi
	pop	es
	pop	ds
	retn

		ALIGN	DWORD
@@width		dd	?
@@height	dd	?
GVE_Alloc_LightMap ENDP



;
;
; GVE_Free_LightMap
;  Input:
;	EAX	- DATA32 ptr to world-header
;	EDX	- Texture number
;  Output:
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Free_LightMap
GVE_Free_LightMap PROC NEAR
	push	ds
	push	edi

	mov	ds,cs:[DATA32_Selector]
	mov	edi,ds:[eax+World_PhongMap_List]	
	jmp	Free_Map
GVE_Free_LightMap ENDP



;
;
; GVE_Get_LightMap_Info
;  Input:
;	EAX	- DATA32 ptr to world-header
;     	EDX	- LightMap-Number
;  Output:
;	[CF]	- error-flag
; 	EAX	- LightMap header address or zero
;	EBX	- LightMap width
;	ECX	- LightMap height
;	EDX	- LightMap depth
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Get_LightMap_Info
GVE_Get_LightMap_Info PROC NEAR
	push	ds
	push	esi

	mov	ds,cs:[DATA32_Selector]
	mov	esi,ds:[eax+World_PhongMap_List]
	jmp	Info_Map
GVE_Get_LightMap_Info ENDP



;
;
; GVE_Remap_LightMap
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- Ptr to old palette  or  zero for GVE_Palette_Buffer
;	EDX	- lightmap number to remap
;  Output:
;	[CF]	- Error-Flag
;	EAX	- ptr to remapped texture header
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Remap_LightMap
GVE_Remap_LightMap PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]		;Important !
	mov	es,ds:[DATA32_Selector]

	mov	esi,ds:[eax+World_PhongMap_List]
	jmp	Remap_Map
GVE_Remap_LightMap ENDP



;
;   GOMEZ VECTOR ENGINE                                 BUMP MAP FUNCTIONS
;
;
;
; GVE_Alloc_BumpMap
;  Input:
;	EAX	- DATA32 ptr to world-header
;	EBX	- Width
;	ECX	- Height
;	EDX	- BumpMap number
;  Output:
;	EAX	- DATA32 ptr to allocated lightmap memory
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Alloc_BumpMap
GVE_Alloc_BumpMap PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	esi,eax				;ESI = WOrld-header
	;
	mov	ds:[@@width],ebx
	mov	ds:[@@height],ecx
	mov	edi,edx				;EDI = entry-number
	lea	ecx,[edx+1]
	mov	eax,ds:[esi+World_BumpMap_List]
	call    Expand_List
	jc	@@Err
	mov	ds:[esi+World_BumpMap_List],eax
	;
	lea	edi,[4*edi+eax+4]		;EDI = ptr to entry in texture-list
	mov	ecx,ds:[edi]			;EAX = old texture pointer
	call	Free				;Free old texture
	;
	mov	ebx,ds:[@@width]
	mov	ecx,ds:[@@height]
	mov	edx,16
	call	GVE_Alloc_Bitmap
	mov	ds:[edi],eax			;EAX = ptr to allocated memory

@@Err: 	pop     edi
	pop	esi
	pop	es
	pop	ds
	retn

		ALIGN	DWORD
@@width		dd	?
@@height	dd	?
GVE_Alloc_BumpMap ENDP



;
;
; GVE_Free_BumpMap
;  Input:
;	EAX	- DATA32 ptr to world-header
;	EDX	- Bump number
;  Output:
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Free_BumpMap
GVE_Free_BumpMap PROC NEAR
	push	ds
	push	edi

	mov	ds,cs:[DATA32_Selector]
	mov	edi,ds:[eax+World_BumpMap_List]	;EDI = bump list
	jmp	Free_Map
GVE_Free_BumpMap ENDP



;
;
; GVE_Get_BumpMap_Info
;  Input:
;	EAX	- DATA32 ptr to world-header
;     	EDX	- BumpMap-Number
;  Output:
;	CF	- error-flag
; 	EAX	- BumpMap header address or zero
;	EBX	- BumpMap width
;	ECX	- BumpMap height
;	EDX	- BumpMap depth
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Get_BumpMap_Info
GVE_Get_BumpMap_Info PROC NEAR
	push	ds
	push	esi

	mov	ds,cs:[DATA32_Selector]
	mov	esi,ds:[eax+World_BumpMap_List]
	jmp	Info_Map
GVE_Get_BumpMap_Info ENDP



;
;
; GVE_Create_BumpMap
;  Input:
;	EAX	- DATA32 ptr to world-header
;	ECX	- Texture-Number (src)
;     	EDX	- BumpMap-Number (dst)
;  Output:
;	CF	- error-flag
; 	EAX	- BumpMap header address or zero
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Create_BumpMap
GVE_Create_BumpMap PROC NEAR
	retn
GVE_Create_BumpMap ENDP



;
;
; GVE_Import_BumpMap
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- DATA32 ptr to file-name (PCX-file)
;	EDX	- bumpmap number to load
;	ECX	- flags:
;		  bit 0 - rescale texture to 256x256
;  Output:
;	[CF]	- Error-Flag
;	EAX	- ptr to loaded bumpmap-header
;	EBX	- width of new bumpmap
;	ECX	- height of new bumpmap
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Import_BumpMap
GVE_Import_BumpMap PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	esi,eax				;ESI = world-header
	mov	edi,edx				;EDI = texture-number
	mov	ebp,ecx				;EBP = flags

	call	Read_PCX			;EAX = new texture
	jc	@@Err
	;
	push	eax
	mov	eax,ds:[esi+World_BumpMap_List]
	lea	ecx,[edi+1]			;ECX = Number of needed textures
	call	Expand_List
	mov	ds:[esi+World_BumpMap_List],eax
	mov	ecx,ds:[eax+4*edi+4]		;ECX = Old texture
	call	Free
	pop	eax				;EAX = New texture address
	mov	ebx,ds:[esi+World_BumpMap_List]
	mov	ds:[ebx+4*edi+4],eax		;Load new texture-address
	;
	mov	ebx,256
	mov	ecx,256
	call	Rescale_Bitmap			;EAX = Rescaled texture
	jc	@@Err
	push	eax

	mov	ebx,OFFSET GVE_Palette_Buffer
	call	Make_Bumpmap			;EAX = Bump map
	pop	ecx				;ECX = Old rescaled texture
	jc	@@Err

	push	eax
	call	Free
	pop	eax				;EAX = New bump-map
	;
	mov	edx,ds:[esi+World_BumpMap_List]
	mov	ds:[edx+4*edi+4],eax		;EAX = ptr to texture
	movzx	ebx,ds:[eax+Bitmap_Width]
	movzx	ecx,ds:[eax+Bitmap_Height]

@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn
GVE_Import_BumpMap ENDP



;
;
; GVE_Export_BumpMap
;  Input:
;      EAX	- DATA32 ptr to World-Header
;	EBX	- DATA32 ptr to file-name (PCX-file)
;	EDX	- BumpMap number to save
;  Output:
;	CF	- Error-Flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Export_BumpMap
GVE_Export_BumpMap PROC NEAR
	stc
	retn
GVE_Export_BumpMap ENDP





;
;
;
;   GOMEZ VECTOR ENGINE                              Low-Level PCX routines
;
;
;
;
;
; Write_PCX:
;  Input:
;	EAX	- DATA32 ptr to bitmap-header
;	EBX	- DATA32 ptr to palette
;	EDX	- DATA32 ptr to file-name
;  Output:
;	[CF]	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Write_PCX PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]		;Important !
	mov	es,ds:[DATA32_Selector]
	mov	esi,eax				;ESI = address of bitmap
	mov	ds:[@@pal],ebx

	movzx	ebx,ds:[esi+Bitmap_Width]
	movzx	ecx,ds:[esi+Bitmap_Height]
	mov	ebp,ebx
	imul	ebp,ecx				;EBP = unpacked size
	lea	esi,[esi+GVE_BITMAP_SIZE]	;ESI = source body
	;
	mov	edi,OFFSET GVE_IO_Buffer
	xor	eax,eax				;EAX = Fill dword value
	push	ecx
	mov	ecx,128/4
	rep	stosd				;CLear header
	pop	ecx
	mov	d ds:[GVE_IO_Buffer],0801050ah	;PCX-Header
	mov	d ds:[GVE_IO_Buffer+4],10001h	;XMin/YMin
	mov	w ds:[GVE_IO_Buffer+8],bx       ;XMax
	mov	w ds:[GVE_IO_Buffer+10],cx	;YMax
	mov	b ds:[GVE_IO_Buffer+41h],1	;Number of bitplanes
	mov	w ds:[GVE_IO_Buffer+42h],bx	;Bytes per scanline
	mov	w ds:[GVE_IO_Buffer+44h],1	;Colour file


	;
	;
	; Now lets write the PCX-file
	;
	pop	ebx				;EBX = ptr to file-name
	xor	ecx,ecx
	call	Creat				;EDX = ptr to file-name
	jc	@@Err
	mov	ds:[@@handle],eax

	mov	ebx,ds:[@@handle]
	mov	ecx,128				;Size of PCX-Header
	mov	edx,OFFSET GVE_IO_Buffer
	call	Write				;Write header
	jc	@@Err
	;
	xor	edi,edi				;EDI = ptr to write-buffer
	xor	ebx,ebx				;EBX = counter of last byte
@@L1:	lods	byte ptr ds:[esi]		;AL = source-byte
	cmp	al,bh				;Is AL = RLE_Byte ???
	jne	short @@New
		cmp	bl,63			;Still in range ???
		jb	short @@Wrt		;JB: Ok !
@@WriteRLE:	or	bl,11000000b		;Mask high bits for RLE
		mov	w ds:[edi+GVE_IO_Buffer],bx
		add	edi,2			;EDI = Next dst-pointer
		xor	bl,bl                   ;BL  = RLE-counter
		jmp	@@Wrt			;Write buffer

@@New:	cmp	bl,1				;Any RLE-Data left ???
	jb	@@Wrt
	ja	@@WriteRLE
		xor	bl,bl			;BL = RLE-Counter
		mov	b ds:[edi+GVE_IO_Buffer],bh
		inc	edi
		cmp	bh,63h
		jb	short @@Wrt
		mov	b ds:[edi+GVE_IO_Buffer-1],11000001b
		mov	b ds:[edi+GVE_IO_Buffer],bh
		inc	edi

@@Wrt:  mov	bh,al				;BH = New RLE-colour
	inc	bl				;BL = RLE-Count
	cmp	edi,1024			;Buffer full ???
	jb	short @@N
		push	ebx
		mov	ebx,ds:[@@handle]
		mov	ecx,edi			;Size of chunk
		mov	edx,OFFSET GVE_IO_Buffer
		xor	edi,edi			;EDI = Start of buffer
		call	Write			;Write last block
		pop	ebx			;EBX = RLE-Counter
		jc	@@Err

@@N:	dec	ebp
	cmp	ebp,0
	jg	short @@L1
	je	@@New				;Write last pixel !

	mov	ebx,ds:[@@handle]
	mov	ecx,edi				;Size of chunk
	mov	edx,OFFSET GVE_IO_Buffer
	call	Write				;Write last block
	jc	@@Err
	;
	;
	;Write palette
	mov	b ds:[GVE_IO_Buffer],0ch
	xor	ecx,ecx				;Convert pal 32bit -> 24 bit
	mov	esi,ds:[@@pal]			;ESI = ptr to 32bit pal
@@L2:	mov	eax,d ds:[esi+4*ecx-4]
	mov	d ds:[GVE_IO_Buffer+2*ecx+ecx-3+1],eax
	inc	cl
	jnz	short @@L2
	;
	mov	ebx,ds:[@@handle]
	mov	ecx,769
	mov	edx,OFFSET GVE_IO_Buffer
	call	Write				;Write palette
	jc	short @@Err

	mov     ebx,ds:[@@handle]
	call	Close

@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

	ALIGN		DWORD
	@@pal		dd	?
	@@handle	dd	?
Write_PCX ENDP


;
;
; Read_PCX:
;  Input:
;	EDX	- DATA32 ptr to file-name
;  Output:
;	EAX	- DATA32 ptr to texture
;	[CF]	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Read_PCX PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	esi,edx				;ESI = File-name

	;
	;
	; Now lets read in the PCX-file
	;
	mov	cx,O_RDONLY
	call	Open
	jc	@@Err
	mov	ds:[@@handle],eax

	mov	ebx,ds:[@@handle]
	mov	ecx,128				;Size of PCX-Header
	mov	edx,OFFSET GVE_IO_Buffer
	call	Read				;Read in header
	jc	@@Err

	cmp	b ds:[GVE_IO_Buffer],0ah        ;Is magic correct ???
	jne	@@Err

	movzx   ebx,w ds:[GVE_IO_Buffer+8]
	sub	bx,w ds:[GVE_IO_Buffer+4]
	inc	ebx				;EBX = width
	mov	ds:[@@Width],ebx
	movzx   ecx,w ds:[GVE_IO_Buffer+10]
	sub	cx,w ds:[GVE_IO_Buffer+6]
	inc	ecx				;ECX = height
	mov	ds:[@@Height],ecx
	;
	mov	edx,8				;EDX = colour depth
	call	GVE_Alloc_Bitmap
	mov	ds:[@@Bitmap],eax
	jc	@@Err

	mov	ecx,32/4
	mov	edi,eax
	rep	movsd				;Copy file-name
	lea	edi,[eax+GVE_BITMAP_SIZE]
	;
	mov	ebx,ds:[@@handle]
	xor	ecx,ecx
	mov	al,SEEK_END
	call	Seek				;Seek to end of file
	sub	eax,128+768			;EAX = size of packed data
	push	eax				;Save size of packed data
	mov	ebx,ds:[@@handle]
	mov	ecx,128                         ;End of PCX-header
	mov	al,SEEK_SET
	call	Seek				;Seek to start of datas
	mov	ecx,ss:[esp]			;ECX = size of data-block
	call	Malloc				;Allocate data-block
	pop	ecx				;ECX = size of packed data
	jc	@@Err
	;
	push	eax				;Save allocated memory
	mov	ebp,ds:[@@Width]
	imul	ebp,ds:[@@Height]		;EBP = Unpacked size

	mov	esi,eax				;ESI = read-buffer
	mov	ebx,ds:[@@handle]
	mov	edx,eax
	call	Read                            ;Read in packed datas
	;
	mov	ebx,ds:[@@handle]
	mov	ecx,768
	mov	edx,OFFSET GVE_Palette_Buffer	;Skip some crap
	call	Read				;Get palette
	mov	ecx,256				;Convert pal 24bit -> 32bit
@@L2:	mov	eax,d ds:[GVE_Palette_Buffer+2*ecx+ecx-3]
	and	eax,0ffffffh
	mov	d ds:[GVE_Palette_Buffer+4*ecx-4],eax
	dec	ecx
	jnz	short @@L2
	;
	;
	;Uncrunch RLE data
@@L1:	cmp	ebp,0				;Is there work left to do ?
	jle	short @@Succ
		lods	byte ptr ds:[esi]       ;Get byte from source
		cmp	al,192			;>=192 means RLE
		jae	short @@RLE
			stosb                   ;No RLE => Set byte
			dec	ebp		;Decrement work to do
			jmp	short @@L1	;and loop !
		@@RLE:	and	al,63		;Get 6 lower bits
			movzx	ecx,al		; ...and use as counter
			sub	ebp,ecx		;Decrement work
			lods	byte ptr ds:[esi]
			rep	stosb		;Expand RLE-stuff
			jmp	short @@L1	;Loop !

@@Succ: pop	ecx
	call	Free				;Free IO-Buffer
	mov     ebx,ds:[@@handle]
	call	Close

	mov	eax,ds:[@@Bitmap]
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

		ALIGN 	DWORD
@@Width		dd	?
@@Height	dd	?
@@Handle	dd	?
@@Bitmap	dd	?
Read_PCX ENDP

;
;
; Rescale_Bitmap
;  Input:
;      EAX	- DATA32 ptr to bitmap
;	EBX	- New width
;	ECX	- New height
;  Output:
;	[CF]	- Error-Flag
;	EAX	- ptr to rescaled texture (old bitmap will be discarded)
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Rescale_Bitmap PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]		;Important !
	mov	es,ds:[DATA32_Selector]
	mov	esi,eax				;ESI = src-ptr

	movzx	edx,ds:[eax+Bitmap_Depth]	;EDX = depth (8bit)
	call	GVE_Alloc_Bitmap		;EAX = ptr to allocated bmp
	jc	@@Err
	push	eax                             ;Save dst.
	push	esi				;SAve src.
	mov	edi,eax				;EDI = destination
	;
	;
	;Begin with code initialisation
	movzx	ebx,ds:[edi+Bitmap_Width]
	movzx	ecx,ds:[edi+Bitmap_Height]
	mov	d ds:[@@C6-4],ebx		;EBX = dest. width
	movzx	eax,ds:[esi+Bitmap_Width]      	;EAX = source width
	mov	d ds:[@@C5-4],eax		; ...save it in code
	xor	edx,edx
	shl	eax,16
	idiv	ebx				;EAX = src_width / dst_width
	xor	edx,edx
	shld	edx,eax,16                      ;EDX = integer part
	mov	d ds:[@@C2-4],edx		; ...save it
	shl	eax,16				;EAX = fractional part
	mov	d ds:[@@C1-4],eax		; ...save it

	movzx	eax,ds:[esi+Bitmap_Height]	;EAX = source height
	xor	edx,edx
	shl	eax,16
	idiv	ecx				;EAX = src_height / dst_height
	mov	edx,eax
	shl	edx,16				;EDX = fractional part
	mov	d ds:[@@C4-4],edx		; ...and save it
	shr	eax,16				;EAX = integer part
	imul	d ds:[@@C5-4]			;EAX *= source_width
	mov	d ds:[@@C3-4],eax		; ...and save it
	add	edi,GVE_BITMAP_SIZE
	add	esi,GVE_BITMAP_SIZE

	;
	;Note the register allocation:
	;	ESI	- src
	;	EDI	- dst
	;	ECX	- Y-counter
	;	EBX	- X-counter
	;	EBP	- X-fraction
	;	EDX	- Y-fraction
	;And the @@C things:
	;	@@C1-4	- Fraction_X increment
	;	@@C2-4	- StdAddX
	;	@@C3-4	- StdAddY*Source_Width
	;	@@C4-4	- Fraction_Y increment
	;	@@C5-4	- Source_Width
	;	@@C6-4	- Destination width
	;
	xor	ebp,ebp				;Clear fraction
@@L1:   push	esi
	mov	ebx,12345678h
@@C6:	xor	edx,edx				;Clear fraction
	@@L2:	mov	al,ds:[esi]		;Get pixel
		stosb				;Save it here
		add	edx,12345678h  		;Add fraction
	@@C1:	adc	esi,12345678h		;Add integer with carry
	@@C2:	dec	ebx
		jnz	short @@L2           	;Loop !
	pop	esi
	add	esi,12345678h
@@C3:	add	ebp,12345678h
@@C4:	jnc	short @@C5
		add 	esi,12345678h
@@C5:	dec	ecx
	jnz	short @@L1
	;
	pop	ecx                             ;ECX = old texture address
	call	Free
	pop	eax				;EAX = new texture address

@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
Rescale_Bitmap ENDP


;
;
; Make_BumpMap
;  Input:
;      EAX	- DATA32 ptr to bitmap
;	EBX	- DATA32 ptr to palette
;  Output:
;	[CF]	- Error-Flag
;	EAX	- ptr to 16bit bump-map
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Make_BumpMap PROC NEAR
	push	esi
	push	edi
	push	ebp

	mov	esi,eax 			;ESI = src-bitmap
	mov	ebp,ebx				;EBP = palette
	;
	movzx	ebx,ds:[eax+Bitmap_Width]
	movzx	ecx,ds:[eax+Bitmap_Height]
	mov	edx,16
	call	GVE_Alloc_Bitmap		;EAX = new bitmap
	jc	@@Err
	push	eax

	movzx	ebx,ds:[esi+Bitmap_Width]
	movzx	ecx,ds:[esi+Bitmap_Height]
	imul	ecx,ebx				;ECX = number of pixels
	lea	esi,[esi+GVE_BITMAP_SIZE]	;ESI = src-bitmap
	lea	edi,[eax+GVE_BITMAP_SIZE]	;EDI = dst-bitmap
@@L1:	movzx	eax,b ds:[esi]			;EAX = Colour index
	inc	esi
	movzx	ebx,b ds:[ebp+4*eax]		;EBX = Colour value (R)
	movzx	edx,b ds:[ebp+4*eax+1]		;EDX = Colour value (G)
	add	ebx,edx
	movzx	edx,b ds:[ebp+4*eax+2]		;EDX = Colour value (B)
	add	ebx,edx				;EBX = Total colour intensity
	mov	ds:[edi],bx
	add	edi,2
	dec	ecx
	jnz	short @@L1
	;
	mov	esi,ss:[esp]			;ESI = bump-map
	movzx	edx,ds:[esi+Bitmap_Width]
	movzx	ecx,ds:[esi+Bitmap_Height]
	imul	ecx,edx				;ECX = number of pixels
	lea	esi,[esi+GVE_BITMAP_SIZE]	;ESI = bitmap
@@L2:   mov	ax,w ds:[esi]
	mov	bx,w ds:[esi]
	sub	ax,w ds:[esi+2]
	sub	bx,w ds:[esi+2*edx]
	sar	ax,2
	sar	bx,2
	mov	ds:[esi],al
	mov	ds:[esi+1],bl
	add	esi,2
	dec	ecx
	jnz	short @@L2

	pop	eax				;EAX = New bump-map
	;
	clc
@@Err:	pop	ebp
	pop	edi
	pop	esi
	retn
Make_BumpMap ENDP
CODE32 ENDS
END