;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
GVE_SYSTEM_FILE		equ	1

;
;
;
;   GOMEZ VECTOR ENGINE                                            v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gve32.inc
include gvelist.inc
include gvi32.inc
include gvechunk.inc
include gvecolor.inc


extrn GVE_IO_Buffer:BYTE
extrn GVE_Video_Buffer:DWORD
extrn C GVE_Alloc_Texture:near
extrn C GVE_Alloc_Bitmap:near
extrn C GVE_Free_Texture:near

;
;
;
;   GOMEZ VECTOR ENGINE                                       VIDEO ROUTINES
;
;
;
;
;
; GVE_Alloc_Video:
;  Input:
;	EAX   	- ptr to world-header
;	EBX	- Width
;	ECX	- Height
;	EDX	- texture-Number
;  Output:
;	EAX	- ptr to allocated video-header
;	EBX	- ptr to allocated texture
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Alloc_Video
GVE_Alloc_Video PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,eax				;EBP = Ptr to world-header
	shrd	esi,ebx,16
	shrd	esi,ecx,16			;ESI = Height/Width
	mov	edi,edx				;EDI = Texture-Number
	;
	mov	eax,ds:[ebp+World_Video_List]
	call	New_List_Entry
	jc	@@End
	mov	ds:[ebp+World_Video_List],eax
	;
	push	edx				;EDX = DATA32 ptr to new entry
	mov	ecx,GVE_VIDEO_SIZE
	call	Malloc                  	;EAX = allocated video-hdr
	pop	edx
	jc	@@End
	mov	ds:[edx],eax			;Save hdr-address
	;
	push	eax				;EAX = header address
	push	edi				;EDI = texture-number
	mov	edi,eax
	mov	ebx,eax
	mov	ecx,GVE_VIDEO_SIZE/4
	xor	eax,eax
	rep	stosd				;Clear object !
	pop	edx				;EDX = texture-number

	mov	ds:[ebx+Video_Texture_Number],edx
	mov	d ds:[ebx+Video_Width],esi
	mov	ds:[ebx+Video_Type],GVE_TYP_VIDEO
	mov	ds:[ebx+Video_Magic],ebx
	;
	mov	eax,ebp				;EAX = world header
	movzx	ebx,si				;EBX = WIdth
	mov	ecx,esi
	shr	ecx,16				;ECX = Height
	call	GVE_Alloc_Texture
	pop	ebp				;EBP = ptr to header
	jc	@@End
	mov	ds:[eax+Bitmap_Type],GVE_TYP_FRAME_BUFFER
	mov	esi,eax				;ESI = ptr to texture
	mov	ds:[ebp+Video_Frame_Buffer],eax

	mov	ecx,GVE_PALETTE_SIZE
	call	Malloc
	mov	ds:[ebp+Video_Current_Palette],eax

	mov	ecx,GVE_PALETTE_SIZE
	call	Malloc
	mov	ds:[ebp+Video_Current_LUT],eax

	mov	eax,ebp				;EAX = return address
	mov	ebx,esi				;EBX = ptr to texture
	;
	clc
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Alloc_Video ENDP



;
;
; GVE_Free_Video:
;  Input:
;	EAX   	- ptr to world-header
;	EDX	- video-handle
;  Output:
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Free_Video
GVE_Free_Video PROC NEAR
	push	ds
	push	esi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,eax				;EBP = World-Header
	mov	esi,edx				;ESI = video-handle
	mov	eax,ds:[eax+World_Video_List]	;EAX = light-list
	call	Find_List_Entry
	jc	short @@End
	mov	d ds:[edx],0
	;
	test	ds:[esi+Video_Flags],GVE_VID_EXTERNAL
	jz	short @@1
	mov	ebx,ds:[esi+Video_Handle]
	call	Close				;Close video-file
	mov	ecx,ds:[esi+Video_Frame_Buffer]
	call	Free

@@1:	mov	eax,ebp				;EAX = World header
	mov	ecx,ds:[esi+Video_Current_Palette]
	call	Free
	mov	ecx,ds:[esi+Video_Current_LUT]
	call	Free
	mov	eax,ebp				;EAX = World header
	mov	edx,ds:[esi+Video_Texture_Number]
	call	GVE_Free_Texture
	mov	ecx,esi
	call	Free

	mov	eax,ds:[ebp+World_Video_List]	;EAX = DATA32 ptr to video-list
	call	Shrink_List			;Tidy up video list !
	mov	ds:[ebp+World_Video_List],eax
	clc
	;
@@End:	pop	ebp
	pop	esi
	pop	ds
	retn
GVE_Free_Video ENDP



;
;
; GVE_Close_Video:
;  Input:
;	EAX   	- ptr to world-header
;	EDX	- video-handle
;  Output:
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Close_Video
GVE_Close_Video PROC NEAR
	push	ds
	push	esi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,eax				;EBP = World-Header
	mov	esi,edx				;ESI = DATA32 ptr to video-header
	mov	eax,ds:[eax+World_Video_List]	;EAX = light-list
	call	Find_List_Entry
	jc	short @@End
	;
	test	ds:[esi+Video_Flags],GVE_VID_EXTERNAL
	jz	short @@1
	mov	ebx,ds:[esi+Video_Handle]
	call	Close				;Close video-file
	mov	ecx,ds:[esi+Video_Frame_Buffer]
	mov	ds:[esi+Video_Frame_Buffer],0
	call	Free

@@1:	mov	eax,ebp				;EAX = World header
	mov	ecx,ds:[esi+Video_Current_Palette]
	mov	ds:[esi+Video_Current_Palette],0
	call	Free
	mov	ecx,ds:[esi+Video_Current_LUT]
	mov	ds:[esi+Video_Current_LUT],0
	call	Free
	;
@@End:	pop	ebp
	pop	esi
	pop	ds
	retn
GVE_Close_Video ENDP



;
;
; GVE_Import_Video:
;  Input:
;	EAX   	- ptr to world-header
;	EBX	- ptr to file-name
;	EDX	- texture-number
;  Output:
;	EAX	- ptr to video-header
;	EBX	- video width
;	ECX	- video height
;	EDX	- ptr to video-frame
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Import_Video
GVE_Import_Video PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,eax				;EBP = World-header
	mov	esi,ebx				;ESI = FIle-Name
	;
	mov	ebx,GVE_VIDEO_WIDTH
	mov	ecx,GVE_VIDEO_HEIGHT
	call	GVE_Alloc_Video
	jc	@@Err

	and	ds:[eax+Video_Flags],NOT GVE_VID_INTERNAL
	or	ds:[eax+Video_Flags],GVE_VID_EXTERNAL or GVE_VID_RESCALE or GVE_VID_REMAP

	lea	edi,[eax+Video_File_Name]
	mov	ecx,128/4
	rep	movsd				;Copy file-name

	mov	edx,eax				;EDX = Video-header
	mov	eax,ebp
	call	GVE_Open_Video
	;
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Import_Video ENDP



;
;
; GVE_Open_Video:
;  Input:
;	EAX   	- ptr to world-header
;	EDX	- ptr to video-header
;  Output:
;	EAX	- ptr to video-header
;	EBX	- video width
;	ECX	- video height
;	EDX	- ptr to video-frame
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Open_Video
GVE_Open_Video PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,eax				;EBP = World-header
	mov	edi,edx				;EDI = Video-Header
	;
	test	ds:[edx+Video_Flags],GVE_VID_EXTERNAL
	jz	@@Err

	lea	ebx,[edx+Video_File_Name]
	mov	ecx,O_RDONLY
	call	Open
	jc	@@Err
	mov	ds:[edi+Video_Handle],eax	;EAX = File-Handle

	mov	ebx,eax
	mov	ecx,3*4
	mov	edx,OFFSET @@typ
	call	Read
	cmp	ds:[@@typ],'ODIV'
	jne	@@Err
	cmp	ds:[@@typ+4],'ELIF'
	jne	@@Err
	;
	mov	eax,ebp				;EAX = world header
	mov     ebx,edi				;EBX = video header
	mov	edx,ds:[edi+Video_Handle]
	call	GVE_Read_Video_Body
	jc	@@Err

	mov	ebx,ebp
	mov	ecx,ds:[edi+Video_Current_Position]
	mov	al,SEEK_SET
	call	Seek
	;
	movzx	ebx,ds:[edi+Video_Width]
	movzx	ecx,ds:[edi+Video_Height]
	movzx	edx,ds:[edi+Video_Depth]
	call	GVE_Alloc_Bitmap
	mov	ds:[edi+Video_Frame_Buffer],eax
	jc	@@Err

	mov	eax,ds:[ebp+WOrld_Palette]
	mov	ebx,ds:[edi+Video_Current_Palette]
	mov	edx,ds:[edi+Video_Current_LUT]
	call	GVE_Fit_Palette

	mov	eax,edi
	movzx	ebx,ds:[edi+Video_Width]
	movzx	ecx,ds:[edi+Video_Height]
	mov	edx,ds:[edi+Video_Frame_Buffer]
	;
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn

		Align	DWORD
@@typ		dd	?,?
@@ver		dd	?
GVE_Open_Video ENDP



;
;
; GVE_Read_Video_Body:
;  Input:
;	EAX   	- ptr to world-header
;	EBX	- ptr to video-header
;	EDX	- file-handle
;  Output:
;	EAX	- ptr to video-header
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC GVE_Read_Video_Body
GVE_Read_Video_Body PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	push	ds:[File_Handle]
	mov	ebp,eax				;EBP = World-header
	mov	edi,ebx				;EDI = Video-Header
	mov	ds:[File_Handle],edx
	;
	clc
@@L1:   jc	@@Err				;Carry ==> Error !
	call	Read_Chunk
	jc	@@Err

	cmp	edx,'DNE'
	je	@@End
	cmp	edx,'LAP'
	jne	short @@N1
		call    Read_PAL
		jmp	@@L1
@@N1:	cmp	edx,'DAEH'
	jne	short @@N2
		call	Read_HEAD
		jmp	@@L1
@@N2:	cmp	edx,'ODIV'
	jne	short @@N3
		call	Read_VIDO
		jmp	@@L1
@@N3:	cmp	edx,'XDI'
	jne	short @@N4
		call	Read_IDX
		jmp	@@L1
@@N4:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1
@@End:	;
	mov	eax,edi
	clc

@@Err:  pop	ds:[File_Handle]
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
Read_HEAD:
	call	Uncompress_Chunk
	push	edi
	mov	esi,eax
	mov	ecx,32/4
	rep	movsd				;Copy film-name
	pop	edi				;EDI = ptr to video-header
	mov	esi,eax				;ESI = ptr to loaded header
	mov	eax,d ds:[esi+Movie_Width]
	mov	ebx,d ds:[esi+Movie_Depth]
	mov	ecx,ds:[esi+Movie_Compression]
	mov	edx,ds:[esi+Movie_FLags]
	mov	d ds:[edi+Video_Width],eax
	mov	d ds:[edi+Video_Depth],ebx
	mov	ds:[edi+Video_Compression],ecx
	or	ds:[edi+Video_Flags],edx
	mov	eax,ds:[esi+Movie_Speed]
	mov	ebx,ds:[esi+Movie_Frames]
	mov	ds:[edi+Video_Speed],eax
	mov	ds:[edi+Video_Frames],eax

	mov	ecx,esi
	call	Free				;Free movie-header

	mov	eax,ds:[edi+Video_Compression]
	call    GVI_Get_Compressor
	mov	ds:[edi+Video_Compressor],eax
	mov	ds:[edi+Video_DeCompressor],ebx
	retn
;
Read_PAL:
	call	Uncompress_Chunk
	mov	ecx,ds:[edi+Video_Current_Palette]
	mov	ds:[edi+Video_Current_Palette],eax
	call	Free
	retn
;
Read_VIDO:
	push	ecx
	mov	ebx,ds:[File_Handle]
	call	Tell
	mov	ds:[edi+Video_Film_Start],eax
	mov	ds:[edi+Video_Current_Position],eax
	pop	ecx
	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek
	retn
;
Read_IDX:
	push	ecx
	mov	ebx,ds:[File_Handle]
	call	Tell
	mov	ds:[edi+Video_Index_Start],eax
	pop	ecx
	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek
	retn
GVE_Read_Video_Body ENDP



;
;
; GVE_Video_Seek:
;  Input:
;	EAX	- WOrld-Header
;	ECX	- Destination frame number
;	EDX	- Video-Handle
;  Output:
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Video_Seek
GVE_Video_Seek PROC NEAR
	retn
GVE_Video_Seek ENDP



;
;
; GVE_Video_Next_Frame:
;  Input:
;	EAX	- WOrld-Header
;	EDX	- Video-Handle
;  Output:
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Video_Next_Frame
GVE_Video_Next_Frame PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	;
	push	ds:[eax+World_TextureMap_List]
	mov	ebp,edx				;EBP = Video-handle
	mov	edi,ds:[edx+Video_Frame_Buffer]
	mov	esi,ds:[edx+Video_Current_Palette]
	mov	al,SEEK_SET
	mov	ebx,ds:[edx+Video_handle]
	mov	ecx,ds:[edx+Video_Current_Position]
	call	Seek
	call    Read_Frame

	pop	eax				;EAX = texture-list
	test	ds:[ebp+Video_Flags],GVE_VID_RESCALE or GVE_VID_REMAP or GVE_VID_EXTERNAL
	jz	short @@End
	;
	mov	ebx,ds:[ebp+Video_Texture_Number]
	mov	esi,ds:[ebp+Video_Frame_Buffer]
	cmp	ebx,ds:[eax]
	jae	short @@End
	mov	edi,ds:[eax+4*ebx+4]
	test	edi,edi
	jz	short @@End
	test	ds:[ebp+Video_Flags],GVE_VID_REMAP
	jnz	short @@1
	call	Rescale_Frame
	jmp	@@End

@@1:	mov	ebp,ds:[ebp+Video_Current_LUT]
	call	Convert_Frame
	;
@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Video_Next_Frame ENDP


;
;   Internal helper routines for video decoding
;
;
;
; Read_Frame:
;  Input:
;	EBP	- Video-Header
;	EDI	- Video-frame-buffer
;	ESI	- Video-palette-buffer
;  Output:
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Read_Frame PROC NEAR
@@Re:	mov	ebx,ds:[ebp+Video_Handle]
	mov	ecx,12
	mov	edx,OFFSET @@Ch_Type
	call	Read
	jc	@@Err
	mov	ecx,ds:[@@Ch_Size]		;ECX = Chunk-Size
	mov	edx,ds:[@@Ch_Type]		;EDX = Chunk-Type
	add	ds:[ebp+Video_Current_Position],ecx
	inc	ds:[ebp+Video_Current_Frame]
	;
	cmp     edx,"MARF"
	je	short @@DoIt
	cmp	edx,"ATLD"
	je	short @@DoIt
	cmp	edx,"DNE"
	je	short @@End
	jmp	short @@Skp
	;
@@DoIt: cmp     ecx,GVE_VIDEO_BUFFER_SIZE*1024
	jae	short @@Skp

	mov	ebx,ds:[ebp+Video_Handle]
	sub	ecx,12
	mov	edx,ds:[GVE_VIdeo_Buffer]
	call	Read
	jc	@@err

	mov	eax,ds:[GVE_Video_Buffer]
	mov	ebx,edi
	mov	ecx,esi
	call	d ds:[ebp+Video_Decompressor]
	jmp	short @@Err
	;
@@End:	mov	al,SEEK_SET
	mov	ecx,ds:[ebp+Video_Film_Start]
	mov	ebx,ds:[ebp+Video_Handle]
	mov	ds:[ebp+Video_Current_Position],ecx
	mov	ds:[ebp+Video_Current_Frame],0
	call	Seek
	jc	short @@Err
	jmp	@@Re
	;
@@Skp:  mov	al,SEEK_CUR
	mov	ebx,ds:[ebp+Video_handle]
	sub	ecx,12
	call	Seek
@@err:  ;
	retn

		ALIGN	DWORD
@@Ch_Type	dd	?
@@Ch_Size	dd	?
@@Ch_Comp	dd	?
Read_Frame ENDP



;
;
; Convert_Frame:
;  Input:
;	ESI	- ptr to video-buffer
;	EDI	- ptr to texture-buffer
;	EBP	- ptr to colour LUT
;  Output:
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Convert_Frame PROC NEAR
	push	esi
	push	edi

	movzx	ebx,ds:[edi+Bitmap_Width]
	movzx	ecx,ds:[edi+Bitmap_Height]
	mov	ds:[@@dst_x],ebx		;EBX = dest. width
	mov	ds:[@@dst_y],ecx
	movzx	eax,ds:[esi+Bitmap_Width]      	;EAX = source width
	mov	d ds:[@@C5-4],eax		; ...save it in code
	xor	edx,edx
	shl	eax,16
	idiv	ebx				;EAX = src_width / dst_width
	xor	edx,edx
	shld	edx,eax,16                      ;EDX = integer part
	mov	d ds:[@@C2-4],edx		; ...save it
	shl	eax,16				;EAX = fractional part
	mov	d ds:[@@C1-4],eax		; ...save it

	movzx	eax,ds:[esi+Bitmap_Height]	;EAX = source height
	xor	edx,edx
	shl	eax,16
	idiv	ecx				;EAX = src_height / dst_height
	mov	edx,eax
	shl	edx,16				;EDX = fractional part
	mov	d ds:[@@C4-4],edx		; ...and save it
	shr	eax,16				;EAX = integer part
	imul	d ds:[@@C5-4]			;EAX *= source_width
	mov	d ds:[@@C3-4],eax		; ...and save it
	add	edi,GVE_BITMAP_SIZE
	add	esi,GVE_BITMAP_SIZE

	;
	;
	;Note the register allocation:
	;	ESI	- src
	;	EDI	- dst
	;	EBP	- LUT
	;	EBX	- X-counter
	;	ECX	- X-fraction
	;	EDX	- Y-fraction
	;And the @@C things:
	;	@@C1-4	- Fraction_X increment
	;	@@C2-4	- StdAddX
	;	@@C3-4	- StdAddY*Source_Width
	;	@@C4-4	- Fraction_Y increment
	;	@@C5-4	- Source_Width
	;
	xor	ecx,ecx				;Clear fraction
	xor	eax,eax
@@L1:   push	esi
	mov	ebx,ds:[@@dst_x]
	xor	edx,edx				;Clear fraction
	add	edi,ebx
        neg	ebx
	@@L2:	mov	al,ds:[esi]		;Get pixel
		add	edx,12345678h  		;Add fraction
	@@C1:   adc	esi,12345678h		;Add integer with carry
	@@C2:   mov	al,ds:[ebp+eax]		;Translate colour
		mov	ds:[edi+ebx],al
		inc	ebx
		jnz	short @@L2           	;Loop !
	pop	esi
	add	esi,12345678h
@@C3:	add	ecx,12345678h
@@C4:	jnc	short @@C5
		add 	esi,12345678h
@@C5:	dec	ds:[@@dst_y]
	jnz	short @@L1
	;

@@Err:	pop	edi
	pop	esi
	retn

		ALIGN	DWORD
@@dst_y		dd	?
@@dst_x		dd	?
COnvert_Frame ENDP


;
;
; Rescale_Frame:
;  Input:
;	ESI	- ptr to video-buffer
;	EDI	- ptr to texture-buffer
;  Output:
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Rescale_Frame PROC NEAR
	push	esi
	push	edi

	movzx	ebx,ds:[edi+Bitmap_Width]
	movzx	ecx,ds:[edi+Bitmap_Height]
	mov	ds:[@@dst_x],ebx		;EBX = dest. width
	mov	ds:[@@dst_y],ecx
	movzx	eax,ds:[esi+Bitmap_Width]      	;EAX = source width
	mov	d ds:[@@C5-4],eax		; ...save it in code
	xor	edx,edx
	shl	eax,16
	idiv	ebx				;EAX = src_width / dst_width
	xor	edx,edx
	shld	edx,eax,16                      ;EDX = integer part
	mov	d ds:[@@C2-4],edx		; ...save it
	shl	eax,16				;EAX = fractional part
	mov	d ds:[@@C1-4],eax		; ...save it

	movzx	eax,ds:[esi+Bitmap_Height]	;EAX = source height
	xor	edx,edx
	shl	eax,16
	idiv	ecx				;EAX = src_height / dst_height
	mov	edx,eax
	shl	edx,16				;EDX = fractional part
	mov	d ds:[@@C4-4],edx		; ...and save it
	shr	eax,16				;EAX = integer part
	imul	d ds:[@@C5-4]			;EAX *= source_width
	mov	d ds:[@@C3-4],eax		; ...and save it
	add	edi,GVE_BITMAP_SIZE
	add	esi,GVE_BITMAP_SIZE

	;
	;
	;Note the register allocation:
	;	ESI	- src
	;	EDI	- dst
	;	EBP	- LUT
	;	EBX	- X-counter
	;	ECX	- X-fraction
	;	EDX	- Y-fraction
	;And the @@C things:
	;	@@C1-4	- Fraction_X increment
	;	@@C2-4	- StdAddX
	;	@@C3-4	- StdAddY*Source_Width
	;	@@C4-4	- Fraction_Y increment
	;	@@C5-4	- Source_Width
	;
	xor	ecx,ecx				;Clear fraction
	xor	eax,eax
@@L1:   push	esi
	mov	ebx,ds:[@@dst_x]
	xor	edx,edx				;Clear fraction
	add	edi,ebx
        neg	ebx
	@@L2:	mov	al,ds:[esi]		;Get pixel
		add	edx,12345678h  		;Add fraction
	@@C1:   adc	esi,12345678h		;Add integer with carry
	@@C2:	mov	ds:[edi+ebx],al
		inc	ebx
		jnz	short @@L2           	;Loop !
	pop	esi
	add	esi,12345678h
@@C3:	add	ecx,12345678h
@@C4:	jnc	short @@C5
		add 	esi,12345678h
@@C5:	dec	ds:[@@dst_y]
	jnz	short @@L1
	;

@@Err:	pop	edi
	pop	esi
	retn

		ALIGN	DWORD
@@dst_y		dd	?
@@dst_x		dd	?
Rescale_Frame ENDP
CODE32 ENDS
END
