;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
GVE_SYSTEM_FILE		equ	1



;
;
;
;   GOMEZ VECTOR ENGINE                                            v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gve32.inc
include gvepal.inc



;
;   GOMEZ VECTOR ENGINE                              PRIMITIVE FUNCTIONS
;
;
;
; GVE_Reference_Primitives:
;  Input:
;	EAX	- DATA32 ptr to Object-Header
;  Output:
;	EAX	- Size of face-list (in bytes)
;	Primitive-list with all vertice-numbers substitued by addresses
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC GVE_Reference_Primitives
GVE_Reference_Primitives PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	test	eax,eax
	jz	@@End
	test	ds:[eax+Object_Flags],GVE_OBJ_VERTEX_ADDRESS
	jnz	@@End
	or	ds:[eax+Object_Flags],GVE_OBJ_VERTEX_ADDRESS
	and	ds:[eax+Object_Flags],NOT GVE_OBJ_VERTEX_INDEX
	;
	mov 	esi,ds:[eax+Object_Face_List]
	mov	edi,ds:[eax+Object_Vertex_List]
	xor	eax,eax				;EAX = return value
	test	esi,esi
	jz	@@End
	test	edi,edi
	jz	@@End
	mov 	edx,ds:[esi]			;EDX = number of primitives
	test	edx,edx
	jz	@@End
	;
	push	esi				;Save start-address
	add	esi,4
	add	edi,4				;Skip all counters...
@@L3:		movzx 	ecx,byte ptr ds:[esi+3]	;ECX = number of vertices
@@L2:		mov 	eax,ds:[esi+4*ecx+20]  	;EAX = vertex number
		fastimul ebx,eax,GVE_VERTEX_SIZE
		add   	ebx,edi			;EBX = Vertex address
		mov 	ds:[esi+4*ecx+20],ebx	;Save index
		dec	ecx
		jnz	short @@L2              ;Loop !

@@Next: movzx	eax,word ptr ds:[esi]		;EAX = size of this primitive
	add 	esi,eax     			;jump to next primitive
	dec 	edx
	jnz 	@@L3				;Loop !
	;
	pop	eax				;EAX = start of liist
	sub	eax,esi
	neg	eax				;Size of list

@@End:	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Reference_Primitives ENDP



;
;
; GVE_DeReference_Primitives:
;  Input:
;	EAX	- DATA32 ptr to Object-Header
;  Output:
;	EAX	- Size of face-list (in bytes)
;	Primitive-list with all addresses substitued by numbers
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC GVE_DeReference_Primitives
GVE_DeReference_Primitives PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	test	eax,eax
	jz	@@End
	test	ds:[eax+Object_Flags],GVE_OBJ_VERTEX_INDEX
	jnz	@@End
	or	ds:[eax+Object_Flags],GVE_OBJ_VERTEX_INDEX
	and	ds:[eax+Object_Flags],NOT GVE_OBJ_VERTEX_ADDRESS
	;
	mov 	esi,ds:[eax+Object_Face_List]
	mov	edi,ds:[eax+Object_Vertex_List]
	test	esi,esi
	jz	@@End
	test	edi,edi
	jz	@@End
	mov 	ebp,ds:[esi]			;Get number of primitives
	test	ebp,ebp
	jz	@@End
	;
	push	esi
	mov	ebx,GVE_VERTEX_SIZE		;Needed for divisions
	add	esi,4
	add	edi,4				;Skip all counters...
@@L3:          	movzx 	ecx,byte ptr ds:[esi+3]	;ECX = number of vertices
@@L2:		mov 	eax,ds:[esi+4*ecx+20]  	;EAX = Vertex address
		sub	eax,edi			;EAX = Vertex offset within list
		xor	edx,edx			;Prepare for division
		div	ebx
		mov 	ds:[esi+4*ecx+20],eax	;Save index
		dec	ecx
		jnz	short @@L2              ;Loop !

@@Next: movzx	eax,word ptr ds:[esi]		;get size of this primitive
	add 	esi,eax     			;jump to next primitive
	dec 	ebp
	jnz 	@@L3				;Loop !
	;
	pop	eax
	sub	eax,esi
	neg	eax				;Size of list

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_DeReference_Primitives ENDP



;
;
; GVE_Link_Tracks:
;  Input:
;	EAX   	- ptr to world-header
;  Output:
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC GVE_Link_Tracks
GVE_Link_Tracks PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,eax				;EBP = World-Header
	mov	edi,ds:[ebp+World_Track_List]	;EDI = ptr to track-list
	cmp	d ds:[edi],0			;No tracks ??
	je	short @@End

	mov	esi,ds:[ebp+World_Object_List]
	call	Link_Tracks
	call    Set_New_Object_Magic

	mov	esi,ds:[ebp+World_Camera_List]
	call	Link_Tracks
	call	Set_New_Object_Magic

	mov	esi,ds:[ebp+World_Light_List]
	call	Link_Tracks
	call	Set_New_Object_Magic

	mov	esi,ds:[ebp+World_TextureMap_List]
	;call	Link_Tracks
	call	Set_New_Object_Magic

	mov	esi,ds:[ebp+World_PhongMap_List]
	;call	Link_Tracks
	call	Set_New_Object_Magic

	mov	esi,ds:[ebp+World_BumpMap_List]
	;call	Link_Tracks
	call	Set_New_Object_Magic

	mov	esi,ds:[ebp+World_Video_List]
	;call	Link_Tracks
	call	Set_New_Object_Magic

	call 	Set_New_Track_Magic
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn
GVE_Link_Tracks ENDP

;
;Link_Tracks:   (Helper function)
;  Input:
;	EDI	- DATA32 ptr to track-list
;	ESI	- DATA32 ptr to object/camera/light-list
;
Link_Tracks PROC NEAR
	push	esi
	mov	ecx,ds:[esi]			;ECX = Number of objects
	add	esi,4
	test	ecx,ecx
	jz	short @@End
	;
@@L1:   push	edi
	mov	eax,ds:[esi]			;EAX = ptr to object header
	test	eax,eax
	jz	short @@Nxt
	mov	eax,ds:[eax+Object_Magic]	;EAX = old object magic
	mov	edx,ds:[edi]			;EDX = Number of tracks
	add	edi,4
	@@L2:	mov	ebx,ds:[edi]		;EBX = ptr to track-header
		cmp	ds:[ebx+Track_Magic],eax
		je	short @@Fnd
		add	edi,4
		dec	edx
		jnz	short @@L2
		jmp	@@Nxt
@@Fnd:	mov	eax,ds:[esi]			;EAX = ptr to object
	mov	ds:[ebx+Track_Object_Address],eax
@@Nxt:	pop	edi
	add	esi,4				;ESI = ptr to next object
	dec	ecx
	jnz	short @@L1
	;
@@End:  pop	esi
	retn
Link_Tracks ENDP


;
;Set_New_Object_Magic:   (Helper function)
;  Input:
;	ESI	- DATA32 ptr to object/camera/light-list
;
Set_New_Object_Magic PROC NEAR
	push	esi
	mov	ecx,ds:[esi]			;ECX = Number of objects
	add	esi,4
	test	ecx,ecx
	jz	short @@End
	;
@@L1:	mov	eax,ds:[esi]			;EAX = ptr to object-header
	test	eax,eax
	jz	short @@Nxt
	mov	ds:[eax+Object_Magic],eax	;Save magic
@@Nxt:	add	esi,4
	dec	ecx
	jnz	short @@L1
	;
@@End:	pop	esi
	retn
Set_New_Object_Magic ENDP


;
;Set_New_Track_Magic:   (Helper function)
;  Input:
;	EDI	- DATA32 ptr to track-list
;
Set_New_Track_Magic PROC NEAR
	push	edi
	mov	ecx,ds:[edi]			;ECX = NUmber of tracks
	add	edi,4
	test	ecx,ecx
	jz	short @@End
	;
@@L1:   mov	eax,ds:[edi]			;EAX = ptr to track header
	test	eax,eax
	jz	short @@Nxt
	mov	ebx,ds:[eax+Track_Object_Address]
	mov	ds:[eax+Track_Magic],ebx
@@Nxt:	add	edi,4
	dec	ecx
	jnz	short @@L1
	;
@@End:	pop	edi
	retn
Set_New_Track_Magic ENDP


;
;
;
;   GOMEZ VECTOR ENGINE                               WORLD (DE)ALLOCATION
;
;
;
;
;
; GVE_Free_World:
;  Input:
;	EAX   	- ptr to world-header
;  Output:
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Free_World
GVE_Free_World PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	esi,eax
	test	esi,esi
	jz	@@End

	;
	mov	edi,ds:[esi+World_TextureMap_List]
	mov	ebp,ds:[edi]			;EBP = number of textures
	test	ebp,ebp
	jz	short @@N1
	add	edi,4				;Skip counter
	@@L1:	mov	ecx,ds:[edi]		;Texture address
		call	Free
		add	edi,4
		dec	ebp
		jnz	short @@L1
	;
@@N1:	mov	edi,ds:[esi+World_PhongMap_List]
	mov	ebp,ds:[edi]			;EBP = number of textures
	test	ebp,ebp
	jz	short @@N2
	add	edi,4				;Skip counter
	@@L2:	mov	ecx,ds:[edi]		;Texture address
		call	Free
		add	edi,4
		dec	ebp
		jnz	short @@L2
	;
@@N2:	mov	edi,ds:[esi+World_Object_List]
	mov	ecx,ds:[edi]			;ECX = number of objects
	test	ecx,ecx
	jz	short @@N3
	add	edi,4				;Skip counter
	@@L3:   push	ecx
		mov	ebp,ds:[edi]		;Object header address
		test	ebp,ebp
		jz	short @@J4
		mov	ecx,ds:[ebp+Object_Vertex_List]
		call	Free
		mov	ecx,ds:[ebp+Object_Face_List]
		call	Free
		mov	ecx,ebp
		call	Free
	@@J4:   add	edi,4
		pop	ecx
		dec	ecx
		jnz	short @@L3
@@N3:	;
	mov	edi,ds:[esi+World_Light_List]
	mov	ebp,ds:[edi]			;EBP = number of light
	test	ebp,ebp
	jz	short @@N4
	add	edi,4				;Skip counter
	@@L4:	mov	ecx,ds:[edi]		;Lightsource address
		call	Free
		add	edi,4
		dec	ebp
		jnz	short @@L4
@@N4:	;
	mov	edi,ds:[esi+World_Camera_List]
	mov	ebp,ds:[edi]			;EBP = number of cameras
	test	ebp,ebp
	jz	short @@N5
	add	edi,4				;Skip counter
	@@L5:	mov	ecx,ds:[edi]		;camera address
		call	Free
		add	edi,4
		dec	ebp
		jnz	short @@L5
@@N5:	;
	mov	edi,ds:[esi+World_Track_List]
	mov	ebp,ds:[edi]			;EBP = number of tracks
	test	ebp,ebp
	jz	short @@N6
	add	edi,4				;Skip counter
	@@L6:	mov	ecx,ds:[edi]		;Track address
		call	Free
		add	edi,4
		dec	ebp
		jnz	short @@L6
@@N6:	;
	mov	edi,ds:[esi+World_BumpMap_List]
	mov	ebp,ds:[edi]			;EBP = number of bumps
	test	ebp,ebp
	jz	short @@N7
	add	edi,4				;Skip counter
	@@L7:	mov	ecx,ds:[edi]		;Track address
		call	Free
		add	edi,4
		dec	ebp
		jnz	short @@L7
@@N7:	;
	mov	edi,ds:[esi+World_Video_List]
	mov	ecx,ds:[edi]			;ECX = number of videos
	test	ecx,ecx
	jz	short @@N8
	add	edi,4				;Skip counter
	@@L8:   push	ecx
		mov	ebp,ds:[edi]
		test	ebp,ebp
		jz	short @@J2

		test	ds:[ebp+Video_Flags],GVE_VID_EXTERNAL
		jz	short @@J3
		mov	ebx,ds:[ebp+Video_Handle]
		call	Close
		mov	ecx,ds:[ebp+Video_Frame_Buffer]
		call	Free

	@@J3:	mov	ecx,ds:[ebp+Video_Current_Palette]
		call	Free
		mov	ecx,ds:[ebp+Video_Current_LUT]
		call	Free
		mov	ecx,ebp
		call	Free

	@@J2:	add	edi,4
		pop	ecx
		dec	ecx
		jnz	short @@L8
	;
@@N8:   mov 	ecx,ds:[esi+World_TextureMap_List]
	call	Free
	mov 	ecx,ds:[esi+World_Object_List]
	call	Free
	mov 	ecx,ds:[esi+World_PhongMap_List]
	call	Free
	mov 	ecx,ds:[esi+World_Light_List]
	call	Free
	mov 	ecx,ds:[esi+World_Camera_List]
	call	Free
	mov 	ecx,ds:[esi+World_Track_List]
	call	Free
	mov 	ecx,ds:[esi+World_BumpMap_List]
	call	Free
	mov 	ecx,ds:[esi+World_Video_List]
	call	Free
	mov 	ecx,ds:[esi+World_Information_Text]
	call	Free
	mov 	ecx,ds:[esi+World_Copyright_Text]
	call	Free
	mov 	ecx,ds:[esi+World_Software_Text]
	call	Free
	mov 	ecx,ds:[esi+World_Palette]
	call	Free
	mov 	ecx,ds:[esi+World_Blurr_LUT]
	call	Free
	mov 	ecx,ds:[esi+World_Shading_LUT8]
	call	Free
	mov 	ecx,ds:[esi+World_Bump_LUT8]
	call	Free
	mov 	ecx,ds:[esi+World_Glass_LUT8]
	call	Free
	mov 	ecx,ds:[esi+World_Shading_LUT]
	cmp	ecx,ds:[esi+World_Shading_LUT8]
	je	short @@J7
	call	Free
@@J7:	mov 	ecx,ds:[esi+World_Bump_LUT]
	cmp 	ecx,ds:[esi+World_Bump_LUT8]
	je	short @@J8
	call	Free
@@J8:	mov 	ecx,ds:[esi+World_Glass_LUT]
	cmp 	ecx,ds:[esi+World_Glass_LUT8]
	je	short @@J9
	call	Free
@@J9:	mov 	ecx,esi
	call	Free

@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Free_World ENDP



;
;
; GVE_Alloc_World:
;  Input:
;	Nothing
;  Output:
;	EAX	- DATA32 ptr to new allocated world-header
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Alloc_World
GVE_Alloc_World PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ecx,SIZE GVE_World_Header
	call	Malloc
	jc	@@Err

	mov	edi,eax				;EDI = World-header
	mov	ebp,eax				;EBP = World-header
	xor	eax,eax
	mov	ecx,SIZE GVE_World_Header /4
	rep	stosd				;Clear world-header

	mov	ds:[ebp+World_Flags],GVE_FLAG_CLEAR_FRAME

	;
	;
	; Now lets allocate some lists
	;
	mov	ecx,4				;Allocate 4 bytes for counter
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_Object_List],eax
	mov	dword ptr ds:[eax],0		;Set 0 objects in list...

	mov	ecx,4				;Allocate 4 bytes for counter
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_TextureMap_List],eax
	mov	dword ptr ds:[eax],0		;Set 0 objects in list...

	mov	ecx,4				;Allocate 4 bytes for counter
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_PhongMap_List],eax
	mov	dword ptr ds:[eax],0		;Set 0 objects in list...

	mov	ecx,4				;Allocate 4 bytes for counter
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_BumpMap_List],eax
	mov	dword ptr ds:[eax],0		;Set 0 objects in list...

	mov	ecx,4				;Allocate 4 bytes for counter
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_Track_List],eax
	mov	dword ptr ds:[eax],0		;Set 0 objects in list...

	mov	ecx,4
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_Light_List],eax
	mov	dword ptr ds:[eax],0

	mov	ecx,4
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_Camera_List],eax
	mov	dword ptr ds:[eax],0

	mov	ecx,4
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_Video_List],eax
	mov	dword ptr ds:[eax],0

	mov	ecx,@@stxtsize
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_Software_Text],eax
	mov	esi,OFFSET @@stxt
	mov	edi,eax
	mov	ecx,@@stxtsize
	rep	movsb

	mov	ecx,GVE_AMBIENT_SIZE
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_Ambient_Light],eax
	mov	edi,eax
	xor	eax,eax
	mov	ecx,GVE_AMBIENT_SIZE/4
	rep	stosd
	lea	eax,[edi-GVE_AMBIENT_SIZE]
	mov	ds:[eax+Ambient_Colour],080808h
	mov	ds:[eax+Ambient_Specular],63

	mov	ecx,GVE_PALETTE_SIZE
	call	Malloc
	jc	@@Err
	mov	ds:[ebp+World_Palette],eax
	mov	edi,eax
	mov	esi,OFFSET GVE_Standard_Pal
	mov	ecx,256
	@@L1:	mov	eax,ds:[esi]
		and	eax,3f3f3fh
		shl	eax,2
		stosd
		add	esi,3
		dec	ecx
		jnz	short @@L1
	;
@@End:  mov	eax,ebp				;EAX = World-header
	clc
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@stxt	db	"This vector-world has been created using the "
	db	"Gomez Vector Engine (C) 1997 by Marc van Shaney",0
@@stxtsize	equ	($-OFFSET @@stxt)
GVE_Alloc_World ENDP
CODE32 ENDS
END


