;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
SMART
WARN ICG


GVI_SYSTEM_FILE		equ	1


;
;
;
;   GOMEZ VIDEO INTERFACE                                          v1.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gomez.inc
include gvi32.inc
include gvichunk.inc

extrn C GVI_Get_Compressor:near



GVI_Movie_Buffer	dd	?


;
;
;
;   GOMEZ VIDEO INTERFACE                                   User functions
;
;
;
;
;
; Init_GVI:
;  Input:
;	Nothing
;  Output:
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C Init_GVI
Init_GVI PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]
	ifdef	GVI_DOS_BUFFER
	 mov	ecx,GVI_BUFFER_SIZE*1024
	 call	DOS_Malloc
	 mov	ds:[GVI_Movie_Buffer],eax
	else
	 mov	ecx,GVI_BUFFER_SIZE*1024
	 call	Malloc
	 mov	ds:[GVI_Movie_Buffer],eax
	endif

	pop	ds
	retn
Init_GVI ENDP


;
;
; Exit_GVI:
;  Input:
;	Nothing
;  Output:
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C Exit_GVI
Exit_GVI PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]
	ifdef	GVI_DOS_BUFFER
	 mov	ecx,ds:[GVI_Movie_Buffer]
	 call	DOS_Free
	else
	 mov	ecx,ds:[GVI_Movie_Buffer]
	 call	Free
	endif

	pop	ds
	retn
Exit_GVI ENDP


;
;
; GVI_Alloc_Bitmap
;  Input:
;	EBX	- Width
;	ECX	- Height
;	EDX	- Depth
;  Output:
;	EAX	- DATA32 ptr to allocated texture header
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVI_Alloc_Bitmap
GVI_Alloc_Bitmap PROC NEAR
	push	ds
	push	es
	push	edi

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ds:[@@width],ebx
	mov	ds:[@@height],ecx
	mov	ds:[@@depth],edx
	;
	add	edx,7
	shr	edx,3
	imul	ecx,ebx				;ECX = width*height
	imul	ecx,edx
	add	ecx,GVI_BITMAP_SIZE
	call	Malloc
	jc	@@Err
	mov	edi,eax
	mov	ecx,GVI_BITMAP_SIZE/4
	xor	eax,eax
	rep	stosd
	sub	edi,GVI_BITMAP_SIZE
	;
	mov	ebx,ds:[@@width]
	mov	ecx,ds:[@@height]
	mov	edx,ds:[@@depth]
	mov	ds:[edi+Bitmap_Width],bx
	mov	ds:[edi+Bitmap_Height],cx
	mov	ds:[edi+Bitmap_Depth],dl
	mov	ds:[edi+Bitmap_Magic],edi
	mov	ds:[edi+Bitmap_Type],GVI_TYP_BITMAP
	mov	eax,edi				;EAX = return address
	clc
	;
@@Err:	pop	edi
	pop	es
	pop	ds
	retn

		ALIGN	DWORD
@@width		dd	?
@@height	dd	?
@@depth		dd	?
GVI_Alloc_Bitmap ENDP



;
;
; GVI_Close_Video:
;  Input:
;	EAX	- video-handle
;  Output:
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVI_Close_Video
GVI_Close_Video PROC NEAR
	push	ds
	push	esi

	mov	ds,cs:[DATA32_Selector]
	mov	esi,eax				;ESI = DATA32 ptr to video-header
	;
	mov	ebx,ds:[esi+Movie_Handle]
	call	Close				;Close video-file
	mov	ecx,ds:[esi+Movie_Frame_Buffer]
	call	Free
	mov	ecx,ds:[esi+Movie_Palette]
	call	Free
	mov	ecx,esi
	call	Free
	;
	pop	esi
	pop	ds
	retn
GVI_Close_Video ENDP



;
;
; GVI_Open_Video:
;  Input:
;	EBX	- ptr to file-name
;  Output:
;	EAX	- ptr to video-header
;	EBX	- video width
;	ECX	- video height
;	EDX	- ptr to video-frame
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVI_Open_Video
GVI_Open_Video PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	esi,ebx				;ESI = FIle-Name
	;
	mov	ecx,O_RDONLY
	call	Open
	jc	@@Err
	mov	ebp,eax				;EBP = File-Handle

	mov	ebx,eax
	mov	ecx,3*4
	mov	edx,OFFSET @@typ
	call	Read
	cmp	ds:[@@typ],'ODIV'
	jne	@@Err
	cmp	ds:[@@typ+4],'ELIF'
	jne	@@Err
	;
	mov	eax,ebp
	call	Read_Movie_Body
	jc	@@Err
	mov	edi,eax
	mov	ds:[edi+Movie_Handle],ebp

	mov	ebx,ebp
	mov	ecx,ds:[edi+Movie_Current_Position]
	mov	al,SEEK_SET
	call	Seek
	;
	movzx	ebx,ds:[edi+Movie_Width]
	movzx	ecx,ds:[edi+Movie_Height]
	movzx	edx,ds:[edi+Movie_Depth]
	call	GVI_Alloc_Bitmap
	mov	ds:[edi+Movie_Frame_Buffer],eax

	mov	eax,edi
	movzx	ebx,ds:[edi+Movie_Width]
	movzx	ecx,ds:[edi+Movie_Height]
	mov	edx,ds:[edi+Movie_Frame_Buffer]
	;
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

		Align	DWORD
@@typ		dd	?,?
@@ver		dd	?
GVI_Open_Video ENDP



;
;
; Read_Movie_Body:
;  Input:
;	EAX	- file-handle
;  Output:
;	EAX	- ptr to video-header
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Read_Movie_Body PROC NEAR
	push	esi
	push	edi
	push	ebp

	push	ds:[File_Handle]
	mov	ds:[File_Handle],eax
	;
	clc
@@L1:   jc	@@Err				;Carry ==> Error !
	call	Read_Chunk
	jc	@@Err

	cmp	edx,'DNE'
	je	@@End
	cmp	edx,'LAP'
	jne	short @@N1
		call    Read_PAL
		jmp	@@L1
@@N1:	cmp	edx,'DAEH'
	jne	short @@N2
		call	Read_HEAD
		jmp	@@L1
@@N2:	cmp	edx,'ODIV'
	jne	short @@N3
		call	Read_VIDO
		jmp	@@L1
@@N3:	cmp	edx,'XDI'
	jne	short @@N4
		call	Read_IDX
		jmp	@@L1
@@N4:	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek				;Skip this strange block
	jmp	@@L1
@@End:	;
	mov	eax,edi
	clc

@@Err:  pop	ds:[File_Handle]
	pop	ebp
	pop	edi
	pop	esi
	retn
;
Read_HEAD:
	call	Uncompress_Chunk
	mov	ebx,eax
	mov	ecx,GVI_MOVIE_SIZE
	call	Realloc
	mov     edi,eax

	mov	eax,ds:[edi+Movie_Compression]
	call    GVI_Get_Compressor
	mov	ds:[edi+Movie_Compressor],eax
	mov	ds:[edi+Movie_DeCompressor],ebx
	retn
;
Read_PAL:
	call	Uncompress_Chunk
	mov	ds:[edi+Movie_Palette],eax
	retn
;
Read_VIDO:
	push	ecx
	mov	ebx,ds:[File_Handle]
	call	Tell
	mov	ds:[edi+Movie_Film_Start],eax
	mov	ds:[edi+Movie_Current_Position],eax
	pop	ecx
	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek
	retn
;
Read_IDX:
	push	ecx
	mov	ebx,ds:[File_Handle]
	call	Tell
	mov	ds:[edi+Movie_Index_Start],eax
	pop	ecx
	mov	ebx,ds:[File_Handle]
	mov	al,SEEK_CUR
	call	Seek
	retn
Read_Movie_Body ENDP



;
;
; GVI_Seek:
;  Input:
;	EAX	- Video-Handle
;	ECX	- Destination frame number
;  Output:
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVI_Seek
GVI_Seek PROC NEAR
	retn
GVI_Seek ENDP



;
;
; GVI_Next_Frame:
;  Input:
;	EAX	- Video-Handle
;  Output:
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVI_Next_Frame
GVI_Next_Frame PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ebp,eax				;EBP = Video-handle
	call    Read_Frame

	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVI_Next_Frame ENDP


;
;   Internal helper routines for video decoding
;
;
;
; Read_Frame:
;  Input:
;	EBP	- Video-Header
;  Output:
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Read_Frame PROC NEAR
@@Re:	mov	ebx,ds:[ebp+Movie_Handle]
	mov	ecx,12
	mov	edx,OFFSET @@Ch_Type
	call	Read
	jc	@@Err
	mov	ecx,ds:[@@Ch_Size]		;ECX = Chunk-Size
	mov	edx,ds:[@@Ch_Type]		;EDX = Chunk-Type
	add	ds:[ebp+Movie_Current_Position],ecx
	inc	ds:[ebp+Movie_Current_Frame]
	;
	cmp     edx,'MARF'
	je	short @@DoIt
	cmp	edx,'ATLD'
	je	short @@DoIt
	cmp	edx,'DNE'
	je	short @@End
	jmp	short @@Skp
	;
@@DoIt: cmp     ecx,GVI_BUFFER_SIZE*1024
	jae	short @@Skp

	mov	ebx,ds:[ebp+Movie_Handle]
	sub	ecx,12
	mov	edx,ds:[GVI_Movie_Buffer]
	call	Read
	jc	@@err

	mov	eax,ds:[GVI_Movie_Buffer]
	mov	ebx,ds:[ebp+Movie_Frame_Buffer]
	mov	ecx,ds:[ebp+Movie_Palette]
	call	d ds:[ebp+Movie_Decompressor]
	jmp	short @@Err
	;
@@End:	mov	al,SEEK_SET
	mov	ecx,ds:[ebp+Movie_Film_Start]
	mov	ebx,ds:[ebp+Movie_Handle]
	mov	ds:[ebp+Movie_Current_Position],ecx
	mov	ds:[ebp+Movie_Current_Frame],0
	call	Seek
	jc	short @@Err
	jmp	@@Re
	;
@@Skp:  mov	al,SEEK_CUR
	mov	ebx,ds:[ebp+Movie_handle]
	sub	ecx,12
	call	Seek
@@err:  ;
	retn

		ALIGN	DWORD
@@Ch_Type	dd	?
@@Ch_Size	dd	?
@@Ch_Comp	dd	?
Read_Frame ENDP
CODE32 ENDS
END