;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS

GVI_SYSTEM_FILE		equ	1

;
;
;
;   GOMEZ VIDEO INTERFACE                                          v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gvi32.inc


;
;
;
;   GOMEZ VIDEO INTERFACE                                  (De)Compressors
;
;
;
;
;
; GVI_Get_Compressor:
;  Input:
;	EAX	- Compression
;  Output:
;	EAX	- DATA32 ptr to Compressor
;	EBX	- DATA32 ptr to Decompressor
;	CF	- Error flag
;
; DeCompressor:
;  Input:
;	EAX	- DATA32 ptr to compressed frame
;	EBX	- DATA32 ptr to frame buffer
;	ECX	- DATA32 ptr to audio buffer
;  Output:
;      EAX	- Size of decompressed audio data
;	CF	- Error flag
;
; Compressor:
;  Input:
;	EAX	- DATA32 ptr to old frame buffer
;	EBX	- DATA32 ptr to new frame buffer
;	ECX	- DATA32 ptr to audio-data
;  Output:
;	EAX	- DATA32 ptr to compressed frame
;	CF	- Error flag
;
PUBLIC C GVI_Get_Compressor
GVI_Get_Compressor PROC NEAR
	mov	eax,OFFSET FLC_Compressor
	mov	ebx,OFFSET FLC_Decompressor
	clc
	retn
GVI_Get_Compressor ENDP



;
;
;
;   GOMEZ VIDEO INTERFACE                        FLI/FLC-Lowlevel routines
;
;
;
FLC_Frame_Width		dd	?
FLC_Frame_Height	dd	?

FLC_Magic_List          db	"FLC",0
			dd	OFFSET FLC_Decompress_DELTA2
			db	"FLI",0
			dd	OFFSET FLC_Decompress_DELTA
			db	"RLE8"
			dd	OFFSET FLC_Decompress_RLE8
			db	"BMP8"
			dd	OFFSET FLC_Decompress_BMP8
			db	"BLCK"
			dd	OFFSET FLC_Decompress_Black
			db	"PAL8"
			dd	OFFSET FLC_Decompress_PAL24
			db	"PAL6"
			dd	OFFSET FLC_Decompress_PAL18
			dd	0

;
;
; FLC_DeCompressor:
;  Input:
;	EAX	- DATA32 ptr to compressed frame
;	EBX	- DATA32 ptr to frame buffer
;	ECX	- DATA32 ptr to palette buffer
;	EDX	- DATA32 ptr to audio buffer
;  Output:
;      EAX	- Size of decompressed audio data
;	CF	- Error flag
;
FLC_Decompressor PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	;
	mov	esi,eax				;ESI = src
	lea	edi,[ebx+GVI_BITMAP_SIZE]	;EDI = dst
	mov	ebp,ecx				;EBP = palette

	movzx	eax,ds:[ebx+Bitmap_Width]
	movzx	ebx,ds:[ebx+Bitmap_Height]
	mov	ds:[FLC_Frame_Width],eax
	mov	ds:[FLC_Frame_Height],ebx
	jmp	short @@S
	;
@@L1:   sub	esi,8
	add	esi,ds:[esi+4]
@@S:    mov	ebx,OFFSET FLC_Magic_List
	mov	eax,ds:[esi]			;EAX = Chunk-Type
	add	esi,8				;ESI = ptr to crunched data
	cmp	eax,'DNE'
	je	short @@End
	@@L2:   mov	ecx,ds:[ebx]
		add	ebx,8
		test	ecx,ecx
		jz	short @@L1
		cmp	eax,ecx
		jne	short @@L2
		call	d ds:[ebx-4]
		jmp	short @@L1
	;
@@End:  xor	eax,eax
	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
FLC_Decompressor ENDP


;
;
; FLC_Compressor:
;  Input:
;	EAX	- DATA32 ptr to old frame buffer
;	EBX	- DATA32 ptr to new frame buffer
;	ECX	- DATA32 ptr to old palette
;	EDX	- DATA32 ptr to new palette
;  Output:
;	EAX	- DATA32 ptr to compressed frame
;	CF	- Error flag
;
FLC_Compressor PROC NEAR
	stc
	retn
FLC_Compressor ENDP



;
;
; FLC_Decompress_PAL18:
;  Input:
; 	ESI	- DATA32 ptr to source
;	EBP	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_PAL18 PROC NEAR
	push 	esi
	push 	ebp

	xor	eax,eax				;EAX = 0
	xor	ecx,ecx				;ECX = 0
	movzx	ebx,w ds:[esi]			;EBX = Number of blocks
	add	esi,2
	test	ebx,ebx
	jz 	short @@end
	;
@@L1:	mov	al,ds:[esi]			;EAX = colours to skip
	lea	ebp,[ebp+4*eax]			;Skip colours
	mov	cl,ds:[esi+1]			;ECX = colours to copy
	add	esi,2
	or  	cl,cl				;test for zero
	jnz 	short @@L2
	mov 	ecx,256
	;
@@L2:	mov	eax,ds:[esi]			;EAX = Colour triple
	add	esi,3
	shl	eax,2
	and	eax,0ffffffh
	mov	ds:[ebp],eax
	add	ebp,4
	dec 	ecx
	jnz 	short @@L2
	;
	dec	ebx
	jnz	short @@L1

@@end:  clc
	pop ebp
	pop esi
	retn
FLC_Decompress_PAL18 ENDP


;
;
; FLC_Decompress_PAL24:
;  Input:
; 	ESI	- DATA32 ptr to source
;	EBP	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_PAL24 PROC NEAR
	push 	esi
	push 	ebp

	xor	eax,eax				;EAX = 0
	xor	ecx,ecx				;ECX = 0
	movzx	ebx,w ds:[esi]			;EBX = Number of blocks
	add	esi,2
	test	ebx,ebx
	jz 	short @@end
	;
@@L1:	mov	al,ds:[esi]			;EAX = colours to skip
	lea	ebp,[ebp+4*eax]			;Skip colours
	mov	cl,ds:[esi+1]			;ECX = colours to copy
	add	esi,2
	or  	cl,cl				;test for zero
	jnz 	short @@L2
	mov 	ecx,256
	;
@@L2:	mov	eax,ds:[esi]			;EAX = Colour triple
	add	esi,3
	and	eax,0ffffffh
	mov	ds:[ebp],eax
	add	ebp,4
	dec 	ecx
	jnz 	short @@L2
	;
	dec	ebx
	jnz	short @@L1

@@end:  clc
	pop ebp
	pop esi
	retn
FLC_Decompress_PAL24 ENDP



;
;
; FLC_Decompress_RLE8:
;  Input:
; 	ESI	- DATA32 ptr to source
;	EDI	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_RLE8 PROC NEAR
	push	esi
	push	edi
	push	ebp

	mov	ebp,ds:[FLC_Frame_Height]
	mov	edx,edi				;EDX = start of line
	xor	ecx,ecx
	;
@@L1:	mov	edi,edx
	mov	bl,ds:[esi]			;BL = op count for this line
	inc	esi
	test 	bl,bl
	jz 	short @@nxtl
	;
@@L2:	mov	cl,ds:[esi]			;ECX = op/count
	inc	esi
	test	cl,cl
	js	short @@cpy
	;
	mov	al,ds:[esi]                     ;AL  = Colour to set
	inc	esi
	mov	ah,al
	shr	ecx,1
	rep	stosw
	adc	cl,0
	rep	stosb
	dec	bl
	jnz	short @@L2
	jmp	short @@nxtl
	;
@@cpy:	neg 	cl
	shr 	ecx,1
	rep 	movsw
	adc	cl,0
	rep	movsb
	dec 	bl          			;BL = Packets--
	jnz 	short @@L2
	;
@@nxtl:	add	edx,ds:[FLC_Frame_Width]
	dec     ebp
	jnz	@@L1

	clc
	pop	ebp
	pop	edi
	pop	esi
	retn
FLC_Decompress_RLE8 ENDP



;
;
; FLC_Decompress_DELTA:  (FLI-Style)
;  Input:
; 	ESI	- DATA32 ptr to source
;	EDI	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_DELTA PROC NEAR
	push	esi
	push	edi
	push	ebp

	mov	ecx,ds:[FLC_Frame_WIdth]
	mov	edx,edi				;EDX = start of line
	;
	movzx	eax,w ds:[esi]			;EAX = lines to skip
	imul	eax,ecx
	add	edi,eax
	movzx	ebp,w ds:[esi+2]		;EBP = line count
	add	esi,4
	mov	edx,edi				;EDX = start of line in dx
	xor	ecx,ecx
	;
@@L1:	mov	edi,edx
	mov	bl,ds:[esi]                     ;BL = opcount
	inc	esi
	test	bl,bl
	jz 	short @@nxtl
	;
@@L2:	mov	cl,ds:[esi]			;ECX = bytes to skip
	inc	esi
	add	edi,ecx
	mov	cl,ds:[esi]			;ECX = op/count
	inc	esi
	test 	cl,cl
	js 	short @@run
	;
	shr 	ecx,1
	rep 	movsw
	adc	cl,0
	rep	movsb
	dec 	bl
	jnz 	@@L2
	jmp 	@@nxtl
	;
@@run:	neg 	cl
	mov	al,ds:[esi]
	shr 	ecx,1
	mov	ah,al
	inc	esi
	rep 	stosw
	adc	cl,0
	rep	stosb
	dec	bl
	jnz 	short @@L2
	;
@@nxtl:	add	edx,ds:[FLC_Frame_Width]	;Next line
	dec     ebp       			;Lines--
	jnz	short @@L1

	clc
	pop	ebp
	pop	edi
	pop	esi
	retn
FLC_Decompress_DELTA ENDP


;
;
; FLC_Decompress_DELTA2:  (FLC-Style)
;  Input:
; 	ESI	- DATA32 ptr to source
;	EDI	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_DELTA2 PROC NEAR
	push	esi
	push	edi
	push	ebp

	mov	edx,edi				;EDX = start of line
	xor	ecx,ecx
        xor	eax,eax
	movzx	ebp,w ds:[esi]			;EBP = line-count
	add	esi,2
	jmp	@@lpck
	;
@@Skp:  imul	eax,ds:[FLC_Frame_Width]
	sub	edx,eax
	xor	eax,eax
	;
@@lpck: movsx	eax,w ds:[esi]			;EAX = opcount
	add	esi,2
	test	eax,eax
	jge 	short @@SS2
	test 	eax,04000h          		;Skip some lines ?
	jnz 	short @@Skp
	mov 	edi,edx				;No,put dot at eol
	add 	edi,ds:[FLC_Frame_Width]	;next line
	mov	ds:[edi],al			;put pixel
	lodsw					;get opcount
	test 	ax,ax				;some opcounts left ???
	jnz 	short @@SS2
	add 	edx,ds:[FLC_Frame_Width]	;No opcounts left,next line
	dec 	ebp				;EBP = lp_count--
	jnz 	short @@lpck			;Unpack next line
	jmp 	short @@end			;All done
	;
@@SS2:	mov 	ebx,eax				;EBX = Opcount
	mov 	edi,edx               		;EDI = Start of line
	;
@@ppck:	movzx	eax,b ds:[esi]
	add 	edi,eax
	mov	al,ds:[esi+1]
	add	esi,2
	test	al,al
	js 	short @@RLE
	mov 	ecx,eax
	rep 	movsw      			;Opcount--
	dec 	ebx
	jnz 	short @@ppck
	add 	edx,ds:[FLC_Frame_Width]
	dec 	ebp				;L_Count--
	jg  	short @@lpck
	jmp 	short @@end
	;
@@RLE:	neg 	al
	mov	ecx,eax
	lodsw
	rep 	stosw
	dec 	ebx
	jnz 	short @@PPCK
	add 	edx,ds:[FLC_Frame_Width]
	dec 	ebp				;L_Count--
	jg  	short @@LPCK

@@end:  clc
	pop	ebp
	pop	edi
	pop	esi
	retn
FLC_Decompress_DELTA2 ENDP



;
;
; FLC_Decompress_BMP8:
;  Input:
; 	ESI	- DATA32 ptr to source
;	EDI	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_BMP8 PROC NEAR
	push	esi
	push	edi

	mov	ecx,ds:[FLC_Frame_WIdth]
	imul	ecx,ds:[FLC_Frame_Height]
	shr	ecx,2
	rep	movsd

	clc
	pop	edi
	pop	esi
	retn
FLC_Decompress_BMP8 ENDP



;
;
; FLC_Decompress_Black:
;  Input:
; 	ESI	- DATA32 ptr to source
;	EDI	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_Black PROC NEAR
	push	edi

	mov	eax,ds:[esi]			;EAX = Colour to clear
	mov	ecx,ds:[FLC_Frame_WIdth]
	imul	ecx,ds:[FLC_Frame_Height]
	shr	ecx,2
	rep	stosd

	clc
	pop	edi
	retn
FLC_Decompress_Black ENDP
CODE32 ENDS
END

