;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS

;
;
;
;   GOMEZ VIDEO INTERFACE                                          v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gvi32.inc


;
;
;
;   GOMEZ VIDEO INTERFACE                        	Main routines
;
;
;
;
;
; Open_GVI


;
;
;
;   GOMEZ VIDEO INTERFACE                        FLI/FLC-Lowlevel routines
;
;
;
;
;
; FLC_Decompress_LUT:
;  Input:
; 	EAX	- DATA32 ptr to source
;	EBX	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_LUT PROC NEAR
	push 	esi
	push 	edi

	mov	esi,eax				;ESI = source
	mov	edi,ebx				;EDI = destination
	xor	eax,eax				;EAX = 0
	xor	ecx,ecx				;ECX = 0
	movzx	ebx,w ds:[esi]			;EBX = Number of blocks
	add	esi,2
	test	ebx,ebx
	jz 	short @@end
	;
@@L1:	mov	al,ds:[esi]			;EAX = colours to skip
	lea	edi,[edi+4*eax]			;Skip colours
	mov	cl,ds:[esi+1]			;ECX = colours to copy
	add	esi,2
	or  	cl,cl				;test for zero
	jnz 	short @@L2
	mov 	ecx,256
	;
@@L2:	mov	eax,ds:[esi]			;EAX = Colour triple
	add	esi,3
	shl	eax,2
	and	eax,0ffffffh
	mov	ds:[edi],eax
	add	edi,4
	dec 	ecx
	jnz 	short @@L2
	;
	dec	ebx
	jnz	short @@L1

@@end:  clc
	pop edi
	pop esi
	retn
FLC_Decompress_LUT ENDP


;
;
; FLC_Decompress_LUT24:
;  Input:
; 	EAX	- DATA32 ptr to source
;	EBX	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_LUT24 PROC NEAR
	push 	esi
	push 	edi

	mov	esi,eax				;ESI = source
	mov	edi,ebx				;EDI = destination
	xor	eax,eax				;EAX = 0
	xor	ecx,ecx				;ECX = 0
	movzx	ebx,w ds:[esi]			;EBX = Number of blocks
	add	esi,2
	test	ebx,ebx
	jz 	short @@end
	;
@@L1:	mov	al,ds:[esi]			;EAX = colours to skip
	lea	edi,[edi+4*eax]			;Skip colours
	mov	cl,ds:[esi+1]			;ECX = colours to copy
	add	esi,2
	or  	cl,cl				;test for zero
	jnz 	short @@L2
	mov 	ecx,256
	;
@@L2:	mov	eax,ds:[esi]			;EAX = Colour triple
	add	esi,3
	and	eax,0ffffffh
	mov	ds:[edi],eax
	add	edi,4
	dec 	ecx
	jnz 	short @@L2
	;
	dec	ebx
	jnz	short @@L1

@@end:  clc
	pop edi
	pop esi
	retn
FLC_Decompress_LUT24 ENDP



;
;
; FLC_Decompress_RLE:
;  Input:
; 	EAX	- DATA32 ptr to source
;	EBX	- DATA32 ptr to destination
;	ECX	- Line size
;	EDX 	- Number of lines
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_RLE PROC NEAR
	push	esi
	push	edi
	push	ebp

	mov	esi,eax
	mov	edi,ebx
	mov	ebp,edx
	mov	ds:[@@LSize],ecx
	mov	edx,edi				;EDX = start of line
	xor	ecx,ecx
	;
@@L1:	mov	edi,edx
	mov	bl,ds:[esi]			;BL = op count for this line
	inc	esi
	test 	bl,bl
	jz 	short @@nxtl
	;
@@L2:	mov	cl,ds:[esi]			;ECX = op/count
	inc	esi
	test	cl,cl
	js	short @@cpy
	;
	mov	al,ds:[esi]                     ;AL  = Colour to set
	inc	esi
	mov	ah,al
	shr	ecx,1
	rep	stosw
	adc	cl,0
	rep	stosb
	dec	bl
	jnz	short @@L2
	jmp	short @@nxtl
	;
@@cpy:	neg 	cl
	shr 	ecx,1
	rep 	movsw
	adc	cl,0
	rep	movsb
	dec 	bl          			;BL = Packets--
	jnz 	short @@L2
	;
@@nxtl:	add	edx,ds:[@@lsize]
	dec     ebp
	jnz	@@L1

	clc
	pop	ebp
	pop	edi
	pop	esi
	retn

ALIGN 4
@@lsize		dd	?
FLC_Decompress_RLE ENDP



;
;
; FLC_Decompress_DELTA:  (FLI-Style)
;  Input:
; 	EAX	- DATA32 ptr to source
;	EBX	- DATA32 ptr to destination
;	ECX	- Line size
;	EDX 	- Number of lines
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_DELTA PROC NEAR
	push	esi
	push	edi
	push	ebp

	mov	esi,eax
	mov	edi,ebx
	mov	ds:[@@LSize],ecx
	mov	edx,edi				;EDX = start of line
	;
	movzx	eax,w ds:[esi]			;EAX = lines to skip
	imul	eax,ecx
	add	edi,eax
	movzx	ebp,w ds:[esi+2]		;EBP = line count
	add	esi,4
	mov	edx,edi				;EDX = start of line in dx
	xor	ecx,ecx
	;
@@L1:	mov	edi,edx
	mov	bl,ds:[esi]                     ;BL = opcount
	inc	esi
	test	bl,bl
	jz 	short @@nxtl
	;
@@L2:	mov	cl,ds:[esi]			;ECX = bytes to skip
	inc	esi
	add	edi,ecx
	mov	cl,ds:[esi]			;ECX = op/count
	inc	esi
	test 	cl,cl
	js 	short @@run
	;
	shr 	ecx,1
	rep 	movsw
	adc	cl,0
	rep	movsb
	dec 	bl
	jnz 	@@L2
	jmp 	@@nxtl
	;
@@run:	neg 	cl
	mov	al,ds:[esi]
	shr 	ecx,1
	mov	ah,al
	inc	esi
	rep 	stosw
	adc	cl,0
	rep	stosb
	dec	bl
	jnz 	short @@L2
	;
@@nxtl:	add	edx,ds:[@@lsize]		;Next line
	dec     ebp       			;Lines--
	jnz	short @@L1

	clc
	pop	ebp
	pop	edi
	pop	esi
	retn

ALIGN 4
@@lsize		dd	?
FLC_Decompress_DELTA ENDP


;
;
; FLC_Decompress_DELTA2:  (FLC-Style)
;  Input:
; 	EAX	- DATA32 ptr to source
;	EBX	- DATA32 ptr to destination
;	ECX	- Line size
;	EDX 	- Number of lines
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_DELTA2 PROC NEAR
	push	esi
	push	edi
	push	ebp

	mov	esi,eax
	mov	edi,ebx
	mov	ds:[@@LSize],ecx
	mov	edx,edi				;EDX = start of line
	xor	ecx,ecx
	jmp	@@lpck
	;
@@Skp:  cwde
	imul	eax,ds:[@@lsize]
	sub	edx,eax
	;
@@lpck: lodsw					;EAX = opcount
	test	ax,ax
	jge 	short @@SS2
	test 	eax,04000h          		;Skip some lines ?
	jnz 	short @@Skp
	mov 	edi,edx				;No,put dot at eol
	add 	edi,ds:[@@lsize]		;next line
	dec 	edi				;eol
	stosb					;put pixel
	lodsw					;get opcount
	test 	ax,ax				;some opcounts left ???
	jnz 	short @@SS2
	add 	edx,ds:[@@Lsize]		;No opcounts left,next line
	dec 	ebp				;EBP = lp_count--
	jnz 	short @@lpck			;Unpack next line
	jmp 	short @@end			;All done
	;
@@SS2:	mov 	ebx,eax				;EBX = Opcount
	mov 	edi,edx               		;EDI = Start of line
	;
@@ppck:	lodsb
	and	eax,0ffh
	add 	edi,eax
	lodsb
	test	al,al
	js 	short @@RLE
	mov 	ecx,eax
	rep 	movsw      			;Opcount--
	dec 	ebx
	jnz 	short @@ppck
	add 	edx,ds:[@@Lsize]
	dec 	ebp				;L_Count--
	jg  	short @@lpck
	jmp 	short @@end
	;
@@RLE:	neg 	al
	mov	ecx,eax
	lodsw
	rep 	stosw
	dec 	ebx
	jnz 	short @@PPCK
	add 	edx,ds:[@@Lsize]
	dec 	ebp				;L_Count--
	jg  	short @@LPCK

@@end:  clc
	pop	ebp
	pop	edi
	pop	esi
	retn

ALIGN 4
@@lsize		dd	?
FLC_Decompress_DELTA2 ENDP
CODE32 ENDS
END

