;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P486
LOCALS
JUMPS

__GWM_SYSTEM_FILE	equ	1

code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gomez.inc
include keys.inc
include gwm32.inc
include svga.inc

PUBLIC C Init_GWM
PUBLIC C Exit_GWM
PUBLIC C GWM_Refresh_Desktop
PUBLIC C GWM_Open_Window
PUBLIC C GWM_Close_Window
PUBLIC C GWM_Flip_Window
PUBLIC C GWM_Init_Palette
PUBLIC C GWM_Wait_Mouse
PUBLIC C GWM_Read_Directory

FAST_FILL MACRO
	shr	ecx,1
	rep	stosw
	adc	ecx,0
	rep	stosb
	ENDM

b	equ	byte ptr
w	equ	word ptr
d	equ	dword ptr



;
;   GOMEZ WINDOW MANAGER   VARIABLES
;
ALIGN 16
GWM_Darken_LUT	db	256 dup (?)
GWM_Window_List	dd	16 	dup (0)

Mouse_X		dd	0
Mouse_Y		dd	0
Mouse_Buttons	dd	0
Win_Position	dd	0

Text_Colour	dd	255
Mouse_Colour	dd	255
Border_Colour	dd	255
Button_Colour1	dd	0	;Black button border
Button_Colour2	dd	255	;White
Button_Colour3	dd	20	;Shadow colour
Button_Colour4	dd	50	;Fill colour


MouseMask LABEL BYTE
dd 50000000h
dd 65000000h
dd 6a500000h
dd 6aa50000h
dd 6aaa5000h
dd 6aaaa500h
dd 6aaaaa40h
dd 6aaaaa90h
dd 6aaa5540h
dd 6aaa4000h
dd 6a969000h
dd 6a41a400h
dd 69006900h
dd 64001a40h
dd 10000690h


GUI_Colours	db      224,224,224,0 	;Text colour
		db      255,255,255,0	;Mouse colour
		db	200,200,200,0	;Border colour
		db      0  ,0  ,0  ,0	;Button black colour
		db      200,200,200,0	;Button white colour
		db	80 ,80 ,80 ,0	;Button shadow colour
		db	128,128,128,0	;Button fill colour

ASCII_Text	label BYTE
merror_text	db "Sorry, you need a MOUSE driver loaded !",10,13,'$'
empty_text	db "Empty",0
global_mask	db "*.*",0


;
;   GOMEZ WINDOW MANAGER   WINDOW ELEMENT FUNCTIONS
;
;
;
; These are all window functions
;
WinDrawingTable	dd OFFSET WinDrawNothing
		dd OFFSET WinDrawText
		dd OFFSET WinDrawButton
		dd OFFSET WinDrawSwitch
		dd OFFSET WinDrawListBox
		dd OFFSET WinDrawSelectBox
		dd OFFSET WinDrawTexture
		dd OFFSET WinDrawInteger
		dd OFFSET WinDrawStrInput
		dd OFFSET WinDrawIntInput
;
WinDrawNothing PROC NEAR
	retn
WinDrawNothing ENDP
;
WinDrawText PROC NEAR
	movzx	eax,word ptr ds:[esi+6]	;Get Y
	fastimul ebx,eax,DISPLAY_WIDTH
	movzx	eax,word ptr ds:[esi+4]	;Get X
	add	eax,ebx
	lea	ebx,[esi+8]
	call	Draw_Text
	retn
WinDrawText ENDP
;
WinDrawInteger PROC NEAR
	mov	edx,ds:[esi+8]
	call	Long2Text
	movzx	eax,word ptr ds:[esi+6]	;Get Y
	fastimul ebx,eax,DISPLAY_WIDTH
	movzx	eax,word ptr ds:[esi+4]	;Get X
	add	eax,ebx
	mov	ebx,OFFSET ASCII_Text
	call	Draw_Text
	retn
WinDrawInteger ENDP
;
WinDrawButton PROC NEAR
	push	edi
	lea	edi,[esi+12]
	xor	al,al
	mov	ecx,256
	repne	scasb
	pop	edi
	sub	ecx,255
	neg	ecx			;ECX has string-len

	movzx	eax,word ptr ds:[esi+6]	;Get Y
	fastimul ebx,eax,DISPLAY_WIDTH
	movzx	eax,word ptr ds:[esi+4]	;Get X
	add	eax,ebx
	lea	edx,[8*ecx+16]
	mov	ebx,18
	call	Draw_Button

	movzx	eax,word ptr ds:[esi+6]	;Get Y
	fastimul ebx,eax,DISPLAY_WIDTH
	movzx	eax,word ptr ds:[esi+4]	;Get X
	lea	eax,[eax+ebx+4*DISPLAY_WIDTH+8]
	lea	ebx,[esi+12]
	call	Draw_Text

	retn
WinDrawButton ENDP
;
WinDrawSwitch PROC NEAR
	movzx	eax,word ptr ds:[esi+6]	;Get Y
	fastimul ebx,eax,DISPLAY_WIDTH
	movzx	eax,word ptr ds:[esi+4]	;Get X
	add	eax,ebx
	push	eax
	movzx	ecx,b ds:[esi+12]	;Get switch state bit
	mov	ebx,ds:[esi+8]		;Get state-address
	bt	ds:[ebx],ecx
	call	Draw_Switch
	pop	eax
	add	eax,12
	lea	ebx,[esi+13]
	call	Draw_Text
	retn
WinDrawSwitch ENDP
;
WinDrawListBox PROC NEAR
	movzx	eax,word ptr ds:[esi+6]	;Get Y
	fastimul ebx,eax,DISPLAY_WIDTH
	movzx	eax,word ptr ds:[esi+4]	;Get X
	add	eax,ebx
	push	eax
	mov	edx,14*8		;Width
	mov	ebx,14*12+4		;Height
	call	Draw_Box

	mov	eax,ss:[esp]		;Get old EAX
	add	eax,14*8
	mov	edx,16
	mov	ebx,14*12+4
	call	Draw_Box

	mov	eax,ss:[esp]
	add	eax,14*8+DISPLAY_WIDTH
	mov	edx,15
	mov	ebx,18
	call	Draw_Button

	mov	eax,ss:[esp]
	add	eax,14*8+(12*12+9)*DISPLAY_Width
	mov	edx,15
	mov	ebx,18
	call	Draw_Button

	mov	ebx,ds:[esi+12]		;Get list-ptr
	mov	edx,ds:[ebx+8]		;Get selected entry
	sub	edx,ds:[ebx+4]		;Get first entry
	cmp	edx,14
	jae	short @@J1
	push	edi
	add	edi,ss:[esp+4]
	fastimul eax,edx,12*DISPLAY_WIDTH
	lea	edi,[edi+eax+2*DISPLAY_WIDTH+2]
	mov	dl,12
	mov	eax,ds:[Button_Colour3]
@@L2:	mov	ecx,(13*8+4)/4
	rep	stosd
	add	edi,DISPLAY_WIDTH-(13*8+4)
	dec	dl
	jnz	short @@L2
	pop	edi

@@J1:	pop	eax
	add	eax,2*DISPLAY_WIDTH+4
	mov	edx,ds:[ebx+4]		;Get first entry
	mov	ecx,ds:[ebx]
	sub	ecx,edx			;ECX holds number of entries
	shl	edx,4			;* entry-size (16 bytes)
	lea	ebx,[ebx+edx+16]	;Skip header etc...
	test	ecx,ecx
	jz	@@End
	cmp	ecx,14
	jbe	short @@L1
	mov	cl,14
@@L1:	push	eax
	push	ebx
	push	ecx
	call	Draw_Text
	pop	ecx
	pop	ebx
	pop	eax
	add	eax,DISPLAY_WIDTH*12
	add	ebx,16
	dec	cl
	jnz	short @@L1

@@End:	retn
WinDrawListBox ENDP
;
WinDrawSelectBox PROC NEAR
	movzx	eax,word ptr ds:[esi+6]	;Get Y
	fastimul ebx,eax,DISPLAY_WIDTH
	movzx	eax,word ptr ds:[esi+4]	;Get X
	add	eax,ebx
	push	eax

	mov	ebx,ds:[esi+12]		;Get list-ptr
	mov	edx,ds:[ebx+8]		;Get selected entry
	push	edi
	add	edi,ss:[esp+4]
	fastimul eax,edx,12*DISPLAY_WIDTH
	lea	edi,[edi+eax]
	mov	dl,12
	mov	eax,ds:[Button_Colour3]
@@L2:	mov	ecx,(13*8+4)/4
	rep	stosd
	add	edi,DISPLAY_WIDTH-(13*8+4)
	dec	dl
	jnz	short @@L2
	pop	edi

@@J1:	pop	eax
	add	eax,2
	mov	ecx,ds:[ebx]		;ECX holds number of entries
	add	ebx,16			;Skip header etc...
@@L1:	push	eax
	push	ebx
	push	ecx
	call	Draw_Text
	pop	ecx
	pop	ebx
	pop	eax
	add	eax,DISPLAY_WIDTH*12
	add	ebx,16
	dec	cl
	jnz	short @@L1
	retn
WinDrawSelectBox ENDP
;
WinDrawTexture PROC NEAR
	movzx	eax,word ptr ds:[esi+6]	;Get Y
	fastimul ebx,eax,DISPLAY_WIDTH
	movzx	eax,word ptr ds:[esi+4]	;Get X
	add	eax,ebx
	mov	ebx,ds:[esi+12]		;Bitmap address
	test	ebx,ebx			;Is address zero ?
	jz	short @@J1
	mov	ecx,d ds:[ebx+Bitmap_Width]
	mov	edx,128*10000h+128	;dst size
	add	ebx,SIZE GWM_BITMAP
	call    Scale_Bitmap
	retn
@@J1:   add	eax,58*DISPLAY_WIDTH+40
	mov	ebx,OFFSET EMPTY_TEXT
	jmp	Draw_Text
WinDrawTexture ENDP
;
WinDrawStrInput PROC NEAR
	movzx	eax,word ptr ds:[esi+6]	;Get Y
	fastimul ebx,eax,DISPLAY_WIDTH
	movzx	eax,word ptr ds:[esi+4]	;Get X
	add	eax,ebx
	push	eax
	mov	edx,16*8		;Width
	mov	ebx,16			;Height
	call	Draw_Box
	pop	eax
	mov	ebx,ds:[esi+12]		;Text address
	add	eax,2*DISPLAY_WIDTH+4
	jmp	Draw_Text
WinDrawStrInput ENDP
;
WinDrawIntInput PROC NEAR
	movzx	eax,word ptr ds:[esi+6]	;Get Y
	fastimul ebx,eax,DISPLAY_WIDTH
	movzx	eax,word ptr ds:[esi+4]	;Get X
	add	eax,ebx
	push	eax
	mov	edx,12
	mov	ebx,16
	call	Draw_Button

	mov	eax,ss:[esp]
	add	eax,13
	mov	edx,4*8+4		;Width
	mov	ebx,16			;Height
	call	Draw_Box

	mov	eax,ss:[esp]
	add	eax,16+4*8
	mov	edx,12
	mov	ebx,16
	call	Draw_Button

	mov	edx,ds:[esi+12]		;Get number
	call	Long2Text
	pop	eax
	add	eax,15+2*DISPLAY_WIDTH
	mov	ebx,OFFSET ASCII_Text	;Text address
	jmp	Draw_Text
WinDrawIntInput ENDP
;
Window_Mouse_Handler PROC NEAR
	mov	ebp,15
@@L1:   mov	esi,ds:[GWM_Window_List+4*ebp]
	test	esi,esi
	jz	@@Nxt

	;
	;First lets check if mouse is in current window
	movzx	eax,word ptr ds:[esi+4]		;Get x0
	movzx	ebx,word ptr ds:[esi+6]		;Get y0
	cmp	eax,ds:[Mouse_X]
	jge	@@Nxt
	cmp	ebx,ds:[Mouse_Y]
	jge	@@Nxt

	mov	ecx,ebx
	cmp	byte ptr ds:[esi+12],0
	je	short @@J1
	add	ecx,13
@@J1:	fastimul edx,ecx,DISPLAY_Width
	add	edx,eax
	mov	ds:[Win_Position],edx

	add	ax,word ptr ds:[esi+8]		;Get width
	add	bx,word ptr ds:[esi+10]		;Get height
	cmp	eax,ds:[Mouse_X]
	jle	@@Nxt
	cmp	ebx,ds:[Mouse_Y]
	jle	@@Nxt

	mov	edx,ds:[Mouse_X]
	mov	ecx,ds:[Mouse_Y]
	sub	dx,word ptr ds:[esi+4]
	sub	cx,word ptr ds:[esi+6]
	cmp	byte ptr ds:[esi+12],0
	je	short @@L2
		sub	ecx,13			;ECX:EDX holds relative mouse

@@L2:	movzx	eax,word ptr ds:[esi]		;Get object size
	add	esi,eax
	movsx	eax,word ptr ds:[esi+2]		;Get object type
	cmp	eax,-1
	je	@@Nxt				;End of window
;
	cmp	eax,GWM_WIN_BUTTON		;Button
	jne	@@N1
		movzx	eax,w ds:[esi+6]
		cmp	ecx,eax			;Compare y
		jle	@@L2
		add	eax,18
		cmp	ecx,eax
		jge	@@L2

		movzx	ebx,w ds:[esi+4]
		cmp	edx,ebx                	;Compare x
		jle	@@L2

		lea	edi,[esi+12]
		xor	al,al
		push	ecx
		mov	ecx,256
		repne	scasb
		sub	ecx,255
		neg	ecx			;ECX has string-len
		lea	eax,[8*ecx+16+ebx]
		pop	ecx
		cmp	edx,eax
		jge	@@L2

		mov     eax,ds:[Mouse_Buttons]
		call	dword ptr ds:[esi+8]	;Do function
		retn
;
@@N1:   cmp	eax,GWM_WIN_SWITCH
	jne	@@N2
		movzx	eax,w ds:[esi+6]
		cmp	ecx,eax			;Compare y
		jle	@@L2
		add	eax,12
		cmp	ecx,eax
		jge	@@L2

		movzx	eax,w ds:[esi+4]
		cmp	edx,eax                	;Compare x
		jle	@@L2
		add	eax,8
		cmp	edx,eax
		jge	@@L2

		movzx	ecx,b ds:[esi+12]
		mov   	ebx,d ds:[esi+8]
		btc	ds:[ebx],ecx		;Flip bit
		call	GWM_Wait_Mouse
		retn
;
@@N2:	cmp	eax,GWM_WIN_LIST_BOX
	jne	@@N3
		movzx	eax,w ds:[esi+6]
		cmp	ecx,eax			;Compare y
		jle	@@L2
		add	eax,14*12+4
		cmp	ecx,eax
		jge	@@L2

		movzx	eax,w ds:[esi+4]
		cmp	edx,eax                	;Compare x
		jle	@@L2
		add	eax,14*8+16
		cmp	edx,eax
		jge	@@L2

		sub	eax,16
		cmp	edx,eax
		jge	short @@LBScroll

		sub	cx,w ds:[esi+6]
		sub	ecx,2
		mov	eax,ecx
		xor	edx,edx
		mov	ecx,12
		idiv	ecx			;Get relative selected thing
		mov	ebx,ds:[esi+12]
		add	eax,ds:[ebx+4]		;Get start position
		cmp	eax,ds:[ebx]		;Is it in range ???
		jae	@@End
		mov	ds:[ebx+8],eax

		call	dword ptr ds:[esi+8]	;EAX contains selected item
		retn

	@@LBScroll:
		sub	cx,w ds:[esi+6]
		cmp	cx,18
		jae	short @@LB1
			mov	ebx,ds:[esi+12] ;Scroll up
			mov	eax,ds:[ebx+4]
			dec	eax
			js	@@End
			mov	ds:[ebx+4],eax
			retn
	@@LB1:	cmp	cx,12*12+9
		jbe	@@End
			mov	ebx,ds:[esi+12]	;Scroll down
			mov	eax,ds:[ebx+4]
			inc	eax
			cmp	eax,es:[ebx]
			jae	@@End
			mov	ds:[ebx+4],eax
			retn
;
@@N3:	cmp	eax,GWM_WIN_SELECT_BOX
	jne	@@N4
		movzx	eax,w ds:[esi+4]
		cmp	edx,eax                	;Compare x
		jle	@@L2
		add	eax,14*8
		cmp	edx,eax
		jge	@@L2

		movzx	eax,w ds:[esi+6]
		cmp	ecx,eax			;Compare y
		jle	@@L2

		sub	ecx,eax
		sub	ecx,2
		mov	eax,ecx
		xor	edx,edx
		mov	ecx,12
		idiv	ecx			;Get relative selected thing
		mov	ebx,ds:[esi+12]
		add	eax,ds:[ebx+4]		;Get start position
		cmp	eax,ds:[ebx]		;Is it in range ???
		jae	@@L2
		mov	es:[ebx+8],eax

		call	dword ptr ds:[esi+8]	;EAX contains selected item
		retn
;
@@N4:	cmp	eax,GWM_WIN_TEXTURE
	jne	@@N5
		movzx	eax,w ds:[esi+4]
		cmp	edx,eax                	;Compare x
		jle	@@L2
		add	eax,128
		cmp	edx,eax
		jge	@@L2

		movzx	eax,w ds:[esi+6]
		cmp	ecx,eax			;Compare y
		jle	@@L2
		add	eax,128
		cmp	ecx,eax
		jge	@@L2

		call	dword ptr ds:[esi+8]
		retn
;
@@N5:	cmp	eax,GWM_WIN_STRINPUT
	jne	@@N6
		movzx	eax,w ds:[esi+4]
		cmp	edx,eax                	;Compare x
		jle	@@L2
		add	eax,15*8
		cmp	edx,eax
		jge	@@L2

		movzx	eax,w ds:[esi+6]
		cmp	ecx,eax			;Compare y
		jle	@@L2
		add	eax,14
		cmp	ecx,eax
		jge	@@L2

		mov     ebp,ds:[esi+12]		;Get text address
		push	edi
		mov	edi,ebp
		xor	al,al
		mov	ecx,64
		repne	scasb
		sub	ecx,63
		neg	ecx
		pop	edi
		@@IN_L: push	edi
			push	esi
			push	ecx
			add	edi,ds:[Win_Position]
			call	WinDrawStrInput
			call	SVGA_Put_Frame
			GETKEY32
			pop	ecx
			pop	esi
			pop	edi

			test	eax,eax
			jz	@@IN_L
			cmp	ax,Return
			je	@@IN_E
			cmp	ax,Escape
			je	@@IN_E
			cmp	ax,BackSpace
			je	@@IN_Back
			cmp	ecx,14
			jae	@@IN_L
			xor	ah,ah
			mov	ds:[ebp+ecx],ax
			inc	ecx
			jmp	@@IN_L

	@@IN_BACK:
		test	ecx,ecx
		jz	@@IN_L
		dec	ecx
		xor	al,al
		mov	ds:[ebp+ecx],al
		jmp	@@IN_L

	@@IN_E:	call	dword ptr ds:[esi+8]
		retn
;
@@N6:	cmp	eax,GWM_WIN_INTINPUT
	jne	@@N7
		movzx	eax,w ds:[esi+4]
		cmp	edx,eax                	;Compare x
		jle	@@L2
		add	eax,28+4*8
		cmp	edx,eax
		jge	@@L2

		movzx	eax,w ds:[esi+6]
		cmp	ecx,eax			;Compare y
		jle	@@L2
		add	eax,14
		cmp	ecx,eax
		jge	@@L2

		sub	dx,w ds:[esi+4]
		cmp	dx,12
		jg	@@INT2
			mov	eax,ds:[esi+12]
			sub	eax,ds:[Mouse_Buttons]
			cmp	eax,ds:[esi+16]
			jl	@@End
			mov	ds:[esi+12],eax
			call	dword ptr ds:[esi+8]
			retn
	@@INT2:	cmp	dx,16+4*8
		jl	@@End
			mov	eax,ds:[esi+12]
			add	eax,ds:[Mouse_Buttons]
			cmp	eax,ds:[esi+20]
			jg	@@End
			mov	ds:[esi+12],eax
			call	dword ptr ds:[esi+8]
			retn
;
@@N7:   jmp	@@L2

@@Nxt:  dec	ebp
	jns	@@L1
@@End:	retn
Window_Mouse_Handler ENDP
;
Window_Keyboard_Handler PROC NEAR
	retn
Window_Keyboard_Handler ENDP

;
;   GOMEZ WINDOW MANAGER   FRONT END ROUTINES
;
;
;
; The functions below are the front-end functions called by the user:
;
;
;GWM_Refresh_Desktop
;  Input:
;	Nothing
;  Output:
;	Nothing
;  Destroys:
;	EAX,EBX,ECX,EDX
;
GWM_Refresh_Desktop PROC NEAR
	cld
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	edi,ds:[SVGA_Frame_Buffer]
	mov	ebp,15
@@L1:   push	edi
	mov	esi,ds:[GWM_Window_List+4*ebp]
	test	esi,esi
	jz	short @@J1

	;
	;Now lets draw a window
	movzx	ebx,word ptr ds:[esi+6]		;Get y0
	fastimul eax,ebx,DISPLAY_WIDTH
	movzx	ebx,word ptr ds:[esi+4]		;Get x0
	add	eax,ebx				;EAX = start address
	add	edi,eax				;EDI = new start address

	xor	eax,eax
	movzx	ebx,word ptr ds:[esi+8]		;Get width
	movzx	edx,word ptr ds:[esi+10]	;Get height
	call	Draw_Window

	;
	;Lets draw the titel into window
	mov	eax,2*DISPLAY_WIDTH+16
	cmp	byte ptr ds:[esi+12],0
	je	short @@J2
	lea	ebx,[esi+12]
	call	Draw_Text			;print header

	lea	ebx,[edi+13*DISPLAY_WIDTH]
	mov	edi,ebx
	mov	eax,ds:[Border_Colour]		;Border colour
	movzx	ecx,word ptr ds:[esi+8]		;Get width
	shr	ecx,2
	rep	stosd
	mov	edi,ebx

@@J2:   ;
	;Lets draw all elements in the window
@@L2:	movzx	eax,word ptr ds:[esi]		;Get object size
	add	esi,eax
	movsx	eax,word ptr ds:[esi+2]		;Get object type
	cmp	eax,-1
	je	short @@J1			;End of window
	call	ds:[WinDrawingTable+4*eax]
	jmp	@@L2

@@J1:   pop	edi
	dec	ebp
	jns	short @@L1


	;
	;
	; Test mouse buttons / keys
	;
	push	edi                     ;Save frame buffer
	call	Get_Mouse
	push	eax             	;Save mouse X & Y
	push	ebx
	test	ecx,ecx
	jz	short @@J3
		mov	eax,ecx
		call	Window_Mouse_Handler
@@J3:	GETKEY32
	test	eax,eax
	jz	short @@J4
		call	Window_Keyboard_Handler

@@J4:   pop	ebx
	pop	eax
	pop	edi
	call	Draw_Mouse_Cursor
	call	SVGA_Switch_Frame

	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GWM_Refresh_Desktop ENDP



;
;GWM_Open_Window
;  Input:
;	EAX	- Window-address
;  Output:
;	EAX	- TRUE/FALSE
;  Destroys:
;	EAX,ECX
;
GWM_Open_Window PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	xor	ecx,ecx
@@L1:   inc	ecx
	cmp	ecx,16
	jae	short @@New
	cmp	ds:[GWM_Window_List+4*ecx-4],eax
	jne	short @@L1
	jmp   	@@End			;Window is already opened

@@New:	xor	ecx,ecx
@@L2:   inc	ecx
	cmp	ds:[GWM_Window_List+4*ecx-4],0
	jne	short @@L2

	mov	ds:[GWM_Window_List+4*ecx-4],eax
@@End:	mov	eax,TRUE
	pop	ds
	retn
GWM_Open_WIndow ENDP



;
;GWM_Flip_Window
;  Input:
;	EAX	- Window-address
;  Output:
;	EAX	- TRUE/FALSE
;  Destroys:
;	EAX,ECX
;
GWM_Flip_Window PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	xor	ecx,ecx
@@L1:   inc	ecx
	cmp	ecx,16
	jae	short @@New
	cmp	ds:[GWM_Window_List+4*ecx-4],eax
	jne	short @@L1
	mov	ds:[GWM_Window_List+4*ecx-4],0
	jmp   	@@End

@@New:	xor	ecx,ecx
@@L2:   inc	ecx
	cmp	ds:[GWM_Window_List+4*ecx-4],0
	jne	short @@L2

	mov	ds:[GWM_Window_List+4*ecx-4],eax
@@End:	mov	eax,TRUE
	pop	ds
	retn
GWM_Flip_WIndow ENDP



;
;GWM_Open_Window
;  Input:
;	EAX	- Window-address
;  Output:
;	EAX	- TRUE/FALSE
;  Destroys:
;	EAX,EBX,ECX,EDX
;
GWM_Close_Window PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	xor	ecx,ecx
@@L1:   inc	ecx
	cmp	ecx,16
	jae	short @@E
	cmp	ds:[GWM_Window_List+4*ecx-4],eax
	jne	short @@L1

	mov	ds:[GWM_Window_List+4*ecx-4],0
	mov	eax,TRUE
	pop	ds
	retn

@@E:    mov	eax,FALSE
	pop	ds
	retn
GWM_Close_Window ENDP



;
;Init_GWM
;  Input:
;	Nothing
;  Output:
;	EAX	- TRUE/FALSE
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Init_GWM PROC NEAR
	push	ds
	push	es
	mov	ds,cs:[DATA32_Selector]
	mov     es,ds:[LIN_Selector]

	cmp 	dword ptr es:[33*4],0
	je 	short @@Err2

	mov	ds:[v86_EAX],0
	mov	eax,51
	call	Invoke_Real_Int		; do it
	cmp 	ds:[v86_ax],-1
	jne 	short @@Err2

	clc
	pop	es
	pop	ds
	retn

@@Err2: push	esi
	mov	esi,OFFSET merror_text
	call	Print32
@@Err1:	stc
	pop	esi
	pop	es
	pop	ds
	retn
Init_GWM ENDP




;
;Exit_GWM
;  Input:
;	Nothing
;  Output:
;	EAX	- TRUE/FALSE
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Exit_GWM PROC NEAR
	clc
	retn
Exit_GWM ENDP


;
;GWM_Wait_Mouse
; Input:
;	Nothing
; Output:
;	Nothing
; Destroys:
;	EAX,EBX,ECX,EDX
;
GWM_Wait_Mouse PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

@@L1:	mov 	ds:[v86_eax],3
	mov	eax,51
	call	Invoke_Real_Int		; do it
	mov	ebx,ds:[v86_ebx]
	and 	ebx,00000111b
	jnz	short @@L1

	pop	ds
	retn
GWM_Wait_Mouse ENDP



;
;GWM_Read_Directory
; Input:
;	EBX	- linear ptr to directory-mask
;	EDX	- linear ptr to directory-list
; Output:
;	[EDX]	- filled out directory
; List-format:
;	1 dword - Number of entries
;	3 dwords- Reserved
; 	14 bytes- File-name
;	1 word  - flags (directory etc...)
;
GWM_Read_Directory PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	lea	edi,[edx+16]		;EDI points to first entry
	xor	ebp,ebp			;EBP will be counter
	push	edx			;Save list start address
	;
	;
	;Read in all directories
	push	ebx			;Save directory mask
	mov	al,FINDFIRST
	mov	ebx,OFFSET GLOBAL_MASK
	mov	ecx,16			;Get all directories
	mov	edx,edi
	call	FindFile
	jc	short @@Files		;No directory
@@L6:   cmp	cx,16
	jne	short @@J
	mov	ds:[edi+14],cx		;Save attributes
	inc	ebp
	add	edi,16
@@J:	mov	al,FINDNEXT		;Get next dirs
	mov	ebx,OFFSET GLOBAL_MASK
	mov	ecx,16			;Directory attributes
	mov	edx,edi
	call	FindFile
	jnc	@@L6
	;
	;
	;Read in files specified by mask
@@Files:mov	ebx,ss:[esp]		;Restore directory mask
	mov	al,FINDFIRST
	xor	ecx,ecx			;Get all files
	mov	edx,edi
	call	FindFile
	jc	@@Sort			;No files
@@L7:   mov	ds:[edi+14],cx		;Save attributes
	inc	ebp
	add	edi,16			;Next entry
	mov	al,FINDNEXT		;Get next dirs
	mov	ebx,ss:[esp]		;Get file mask
	mov	ecx,16			;Directory attributes
	mov	edx,edi
	call	FindFile
	jnc	@@L7
	;
	;
	;End of search
@@Sort:	pop	ebx			;Throw away mask
	pop	esi			;Get list-start
	xor	eax,eax
	mov	ds:[esi],ebp		;Save number of entries
	mov	ds:[esi+4],eax
	mov	ds:[esi+8],eax		;Clear other stuff
	;
	;
	;Sort directory
	cmp	ebp,1
	jbe	@@End
	mov	ecx,ebp			;ECX = Number of files
	lea	ebp,[esi+16]		;EBP = first entry
@@L3:	push	ecx
	mov	edi,ebp                 ;EDI = smallest element
	mov	esi,ebp			;ESI = next entry
	;
@@L1:   xor 	ebx,ebx
@@L2:   mov 	al,ds:[edi+ebx]		;Get top entry
	cmp 	ds:[esi+ebx],al		;Compare with current entry
	je 	short @@G1
	ja 	short @@G2
	mov 	edi,esi			;Set EDI to new top
	jmp 	short @@G2
@@G1:	inc 	ebx
	cmp 	ebx,13
	jb 	short @@L2

@@G2:	add 	esi,16			;Goto next entry
	dec	ecx
	jnz 	short @@L1
	;
	pop 	ecx
	cmp 	ebp,edi			;Is new-file=old-file ?
	je 	short @@3		;JE: we do not need to exchange

	push 	dword ptr ds:[edi]
	push 	dword ptr ds:[edi+4]
	push 	dword ptr ds:[edi+8]
	push 	dword ptr ds:[edi+12]
	mov 	eax,ds:[ebp]
	mov 	ds:[edi],eax
	mov 	eax,ds:[ebp+4]
	mov 	ds:[edi+4],eax
	mov 	eax,ds:[ebp+8]
	mov 	ds:[edi+8],eax
	mov 	eax,ds:[ebp+12]
	mov 	ds:[edi+12],eax
	pop 	dword ptr ds:[ebp+12]
	pop 	dword ptr ds:[ebp+8]
	pop 	dword ptr ds:[ebp+4]
	pop 	dword ptr ds:[ebp]

@@3:	add 	ebp,16                  ;point to next file
	dec 	ecx			;decrement counter
	jnz 	@@L3
	;
@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GWM_Read_Directory ENDP




;
;GWM_Init_Palette
;  Input:
;	ESI	-  24 bit palette
;  Output:
;	Nothing
;  Destroys:
;	EAX,EBX,ECX,EDX
;
GWM_Init_Palette PROC NEAR
	push	ds
	push	es
	push	ebp
	push	esi
	push	edi

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[LIN_Selector]

	mov	edi,OFFSET GWM_Darken_LUT

	xor	ebp,ebp
@@L2:	mov	edx,ds:[esi+ebp]	;Get colour
	shr	edx,1
	and	edx,7f7f7fh
	call	Fit_Colour
	mov	ds:[edi],ch
	inc	edi

	add	ebp,4
	cmp	ebp,256*4
	jb	@@L2


	;
	;Now fit some GUI-colours
	;
	mov	edi,OFFSET TEXT_Colour
	xor	ebp,ebp
@@L3:	mov	edx,d ds:[GUI_Colours+ebp]	;Get red
	call	Fit_Colour
	movzx	eax,ch
	imul	eax,01010101h
	mov	ds:[edi],eax
	add	edi,4

	add	ebp,4
	cmp	ebp,7*4
	jb	@@L3


	pop	edi
	pop	esi
	pop	ebp
	pop	es
	pop	ds
	retn
GWM_Init_Palette ENDP






;
;   GOMEZ WINDOW MANAGER     INTERNAL FUNCTIONS
;
;
;
; Now come the internal functions
;
;
;Draw_Window
;  Input:
;	EDI	- Frame-Buffer
;       EAX	- Position
;	EBX	- Width
;	EDX	- Height
;	ES	- LIN_Selector
;  Output:
;	Nothing
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Draw_Window PROC NEAR
	push	edi

	add	edi,eax
	mov	eax,ds:[Border_Colour]		;Border colour
	mov	ecx,ebx
	shr	ecx,2
	rep	stosd


	lea	edi,[edi+DISPLAY_WIDTH]		;Next row
	sub	edx,2
	sub	edi,ebx
@@L1:   push	ebx
	stosb
	mov	ecx,ebx
	mov	ebx,OFFSET GWM_Darken_LUT
	sub	ecx,2
	movzx	eax,byte ptr ds:[edi]
	@@L2:	mov	al,ds:[ebx+eax]
		mov	ds:[edi],al
		inc	edi
		dec	ecx
		mov	al,byte ptr ds:[edi]
		jnz	short @@L2

	mov	eax,ds:[Border_Colour]
	stosb

	pop	ebx
	lea	edi,[edi+DISPLAY_WIDTH]		;Next row
	sub	edi,ebx
	dec	edx
	jnz	@@L1

	mov	ecx,ebx
	shr	ecx,2
	rep	stosd

	pop	edi
	retn
Draw_Window ENDP
;
;
;Draw_Text
;  Input:
;	EDI	- Ptr to frame-buffer
;       EAX	- Position
;	EBX	- Ptr to text in DS
;	ES	- LIN-Selector
;  Output:
;	Nothing
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Draw_Text PROC NEAR
	push	esi
	push	edi
	add	edi,eax
	mov	dl,b ds:[Text_Colour]
@@L1:	movzx 	eax,byte ptr ds:[ebx] 	;AX=Zeichen
	or 	al,al
	jz 	short @@End
	fastimul esi,eax,12
	add 	esi,OFFSET FONT12

	mov 	dh,12
	@@L2:	lods 	byte ptr ds:[esi]   	;Bitmuster in AL geladen
		counter=7
		REPT	8
		  LOCAL NEXT
		  test	al,1 shl counter
		  jz	short NEXT
		  mov 	byte ptr ds:[edi+7-counter],dl
		  counter=counter-1
	     NEXT:
		ENDM

		add 	edi,DISPLAY_WIDTH
		dec 	dh
		jnz 	short @@L2

	sub 	edi,12*DISPLAY_WIDTH-8
	inc 	ebx
	jmp 	short @@L1

@@End:  pop	edi
	pop	esi
	retn
Draw_Text ENDP
;
;
;Draw_Button
;  Input:
;	EDI	- Ptr to frame-buffer
;	EAX	- Position
;	EBX	- Button height
;	EDX	- Button width
;	ES	- LIN-Selector
;  Output:
;	Nothing
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Draw_Button PROC NEAR
	push	edi

	lea	edi,[edi+eax+1]
	mov	eax,ds:[Button_Colour1]	;Border colour
	lea	ecx,[edx-2]
	FAST_FILL
	add	edi,DISPLAY_Width+1
	sub	edi,edx			;Next row

	stosb
	mov	eax,ds:[Button_Colour2]
	lea	ecx,[edx-3]
	FAST_FILL
	mov	eax,ds:[Button_Colour4]
	stosb
	mov	eax,ds:[Button_Colour1]
	stosb
	add	edi,DISPLAY_WIDTH
	sub	edi,edx			;Next row

	stosb
	mov	eax,ds:[Button_Colour2]
	stosb
	mov	eax,ds:[Button_Colour4]
	lea	ecx,[edx-3]
	FAST_FILL
	mov	eax,ds:[Button_Colour1]
	stosb
	add	edi,DISPLAY_WIDTH
	sub	edi,edx			;Next row

	sub	ebx,5
@@L1:	stosb
	mov	eax,ds:[Button_Colour2]
	stosb
	mov	eax,ds:[Button_Colour4]
	lea	ecx,[edx-4]
	FAST_FILL
	mov	eax,ds:[Button_Colour3]
	stosb
	mov	eax,ds:[Button_Colour1]
	stosb
	add	edi,DISPLAY_WIDTH
	sub	edi,edx			;Next row
	dec	ebx
	jnz	short @@L1

	stosb
	mov	eax,ds:[Button_Colour4]
	stosb
	stosb
	stosb
	mov	eax,ds:[Button_Colour3]
	lea	ecx,[edx-5]
	FAST_FILL
	mov	eax,ds:[Button_Colour1]
	stosb
	add	edi,DISPLAY_Width+1
	sub	edi,edx

	mov	eax,ds:[Button_Colour1]	;Border colour
	lea	ecx,[edx-2]
	FAST_FILL

	pop	edi
	retn
Draw_Button ENDP
;
;
;Draw_Box
;  Input:
;	EDI	- Ptr to frame-buffer
;	EAX	- Position
;	EBX	- Box height
;	EDX	- Box width
;	ES	- LIN-Selector
;  Output:
;	Nothing
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Draw_Box PROC NEAR
	push	edi
	lea	edi,[edi+eax]
	lea	ebx,[ebx-2]

	mov	eax,ds:[Button_Colour3]
	mov	ecx,edx
	shr	ecx,2
	rep	stosd
	add	edi,DISPLAY_WIDTH
	sub	edi,edx
@@L1:	mov	eax,ds:[Button_Colour3]
	stosb
	lea	ecx,[edx-2]
	mov	eax,ds:[Button_Colour1]
	FAST_FILL
	mov	eax,ds:[Button_Colour2]
	stosb
	add	edi,DISPLAY_Width
	sub	edi,edx
	dec	ebx
	jnz	short @@L1

	mov	eax,ds:[Button_Colour2]
	mov	ecx,edx
	shr	ecx,2
	rep	stosd

	pop	edi
	retn
Draw_Box ENDP
;
;
;Draw_Switch
;  Input:
;	EDI	- Ptr to frame-buffer
;	EAX	- Position
;	BL	- Switch-state
;	ES	- LIN-Selector
;  Output:
;	Nothing
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Draw_Switch PROC NEAR
	push	edi
	lea	edi,[edi+eax]

	jc	short @@On
	mov	eax,ds:[Button_Colour2]	;Border colour
	stosd
	stosd
	add	edi,DISPLAY_Width-8
	stosd
	stosw
	stosb
	mov	eax,ds:[Button_Colour3]
	stosb
	add	edi,DISPLAY_Width-8

	mov	bl,8
@@L1:   mov	eax,ds:[Button_Colour2]
	stosw
	mov	eax,ds:[Button_Colour4]
	stosd
	mov	eax,ds:[Button_Colour3]
	stosw
	add	edi,DISPLAY_Width-8
	dec	bl
	jnz	short @@L1

	mov	eax,ds:[Button_Colour2]
	stosb
	mov	eax,ds:[Button_Colour3]	;Border colour
	stosb
	stosw
	stosd
	add	edi,DISPLAY_Width-8
	stosd
	stosd
	pop	edi
	retn

@@On:	mov	eax,ds:[Button_Colour3]	;Border colour
	stosd
	stosd
	add	edi,DISPLAY_Width-8
	stosd
	stosw
	stosb
	mov	eax,ds:[Button_Colour2]
	stosb
	add	edi,DISPLAY_Width-8

	mov	bl,8
@@L2:   mov	eax,ds:[Button_Colour3]
	stosw
	mov	eax,ds:[Button_Colour1]
	stosd
	mov	eax,ds:[Button_Colour2]
	stosw
	add	edi,DISPLAY_Width-8
	dec	bl
	jnz	short @@L2

	mov	eax,ds:[Button_Colour3]
	stosb
	mov	eax,ds:[Button_Colour2]	;Border colour
	stosb
	stosw
	stosd
	add	edi,DISPLAY_Width-8
	stosd
	stosd
	pop	edi
	retn
Draw_Switch ENDP
;
;
;Scale_Bitmap:
;  Input:
;	EDI	- ptr to frame buffer
;	EAX	- position
;	EBX	- ptr to bitmap
;	ECX	- size of bitmap in words (low:width, high:height)
;	EDX	- size of dst-bitmap (same)
;  Output:
;	Nothing
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Scale_Bitmap PROC NEAR
	push	esi
	push	edi
	push	ebp
	mov	esi,ebx			;ESI points to source bitmap
	add	edi,eax                 ;EDI points to frame-buffer
	mov	ebp,edx			;EBP is dst-size

	;
	;Begin with code initialisation
	movzx	ebx,bp				;Get dst width
	mov	d ds:[@@C6-4],ebx		; ...save it in code
	mov	eax,DISPLAY_Width
	sub	eax,ebx
	mov	d ds:[@@C7-4],eax		; ...save it in code
	movzx	eax,cx	                	;Get source width
	mov	d ds:[@@C5-4],eax		; ...save it in code
	xor	edx,edx				;
	shld	edx,eax,16			;fudge for 16bit fixed point
	shl	eax,16				; --""--
	div	ebx				;src_width / dst_width
	xor	edx,edx
	shld	edx,eax,16                      ;get integer part
	mov	d ds:[@@C2-4],edx		; ...save it
	shl	eax,16				;get fractional part
	mov	d ds:[@@C1-4],eax		; ...save it

	mov	eax,ecx				;Get source height
	xor	ax,ax				;For 16bit shifting
	mov	ecx,ebp                         ;Get dst height
	shr	ecx,16				;Get dst height
	xor	edx,edx
	div	ecx				;src_height / dst_height
	mov	edx,eax
	shl	edx,16				;get fractional part
	mov	d ds:[@@C4-4],edx		; ...and save it
	shr	eax,16				;get integer part
	mul	d ds:[@@C5-4]			;mul with source_width
	mov	d ds:[@@C3-4],eax		; ...and save it

	;
	;Note the register allocation:
	;	ESI	- src
	;	EDI	- dst
	;	ECX	- Y-counter
	;	EBX	- X-counter
	;	EBP	- X-fraction
	;	EDX	- Y-fraction
	;And the @@C things:
	;	@@C1-4	- Fraction_X increment
	;	@@C2-4	- StdAddX
	;	@@C3-4	- StdAddY*Source_Width
	;	@@C4-4	- Fraction_Y increment
	;	@@C5-4	- Source_Width
	;	@@C6-4	- Destination width
	;	@@C7-4  - DISPLAY_Width-Destination width
	;
	xor	ebp,ebp
@@L1:   push	esi
	mov	ebx,12345678h
@@C6:	xor	edx,edx				;Clear fraction
	@@L2:	mov	al,ds:[esi]		;Get pixel
		stosb				;Save it here
		add	edx,12345678h  		;Add fraction
	@@C1:	adc	esi,12345678h		;Add integer with carry
	@@C2:	dec	ebx
		jnz	short @@L2           	;Loop !
	pop	esi
	add	esi,12345678h
@@C3:	add	ebp,12345678h
@@C4:	jnc	short @@C5
		add 	esi,12345678h
@@C5:   add	edi,12345678h
@@C7:	dec	ecx
	jnz	short @@L1

	pop	ebp
	pop	edi
	pop	esi
	retn
Scale_Bitmap ENDP
;
;
;Draw_Mouse_Cursor
;  Input:
;	EAX	- Mouse X
;	EBX	- Mouse Y
;	EDI 	- Ptr to frame-buffer
;  Output:
;	Nothing
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Draw_Mouse_Cursor PROC NEAR
	push 	edi
	push 	esi
	push	ebp
	lea	ebp,[edi+DISPLAY_WIDTH*DISPLAY_HEIGHT]

	fastimul ecx,ebx,DISPLAY_Width
	add 	edi,ecx
	add	edi,eax

	;
	;Now the real routine starts here....
	;
	mov 	esi,OFFSET MouseMask   	;Zeiger auf Maske in FS:SI
	mov 	dh,15                 	;Cursor-Hhe
	mov	bh,b ds:[Mouse_Colour]
@@L1:   lods 	dword ptr ds:[esi]	;Get one row
	mov 	dl,16
@@L2:   rol 	eax,2
	mov 	bl,al
	and 	bl,11b
	jz 	short @@NoP
	cmp 	bl,10b
	ja 	short @@Invert
	je 	short @@White
		mov 	byte ptr ds:[edi],0
		jmp 	short @@Nop
@@Invert:	xor 	byte ptr ds:[edi],0ffh
		jmp 	short @@Nop
@@White:	mov 	byte ptr ds:[edi],bh
@@Nop:	inc 	edi
	dec 	dl
	jnz 	short @@L2

	add 	edi,DISPLAY_Width-16
	dec 	dh
	jnz 	short @@L1

@@E:    pop	ebp
	pop 	esi
	pop 	edi
	retn
Draw_Mouse_Cursor ENDP
;
;
;Long2Text:
;  Input:
;	EDX	- Number to convert
;  Output:
;	ASCII_Text
;  Destroys:
;	EAX,EBBX,ECX,EDX
;
Long2Text PROC NEAR
	test 	edx,edx
	jnz 	@@NotZ
	mov 	word ptr ds:[OFFSET ASCII_Text],'0'
	retn

@@NotZ: push	es
	push 	edi
	push	ds
	pop	es
	mov 	edi,OFFSET ASCII_Text
	test 	edx,edx
	jns 	short @@NoS
	mov 	byte ptr ds:[edi],'-'
	inc 	edi
	neg 	edx

@@NoS:	mov 	ebx,edx
	mov 	ecx,10000000
@@1:    xor 	edx,edx
	mov 	eax,ebx
	div 	ecx
	test 	al,al
	jnz 	short @@4
	cmp 	edi,OFFSET ASCII_Text
	je 	short @@2
	cmp 	byte ptr ds:[edi-1],'-'
	je 	short @@2
@@4:	add 	al,'0'
	stosb
@@2:	mov 	ebx,edx
	xor 	edx,edx
	mov 	eax,ecx
	mov 	ecx,10
	div 	ecx
	test 	eax,eax
	jz 	short @@3
	mov 	ecx,eax
	jmp 	short @@1

@@3:	mov 	byte ptr ds:[edi],0

	pop 	edi
	pop	es
	retn
Long2Text ENDP
;
;
; Now follows a LUT-Generator in order to get a shading LUT for a given 3*6
; bit palette.
;
;
; FIT_COLOUR:
;  Input:
;	EDX   	holds colour to fit	(3*8 bit)
;	ES:ESI 	points to palette	(3*8 bit)
;  Output:
;	EDX     Best difference
;	CH	Best colour
;  Destroys:
;	EAX,EBX,ECX,EDX
;
;  All colours have the following format:
;	8bit   8bit  8bit   8bit
;	 EDH    EDL   DH     DL
;	  ?    Blue  Green  Red
;
Fit_Colour PROC NEAR
	push 	esi		;Save old colour-ptr
	push	edi
	push	ebp

	mov	ebp,edx		;EBP = Colour to fit
	mov	ebx,esi		;EBX = Ptr to palette
	movzx	esi,dl		;ESI = Red
	movzx	edi,dh		;EDI = Green
	shr	ebp,16
	and	ebp,0ffh        ;EBP = Blue
	xor	ecx,ecx		;CL  = Counter     CH = Best colour
	mov 	edx,0fffh	;EDX = Difference
	@@L1:	push	ecx
		movzx 	eax,b ds:[ebx]
		sub	eax,esi		;EAX = Red difference
		jns 	short @@1
		neg 	eax
	@@1:   	movzx	ecx,b ds:[ebx+1]
		sub	ecx,edi		;ECX = Green difference
		jns 	short @@2
		neg 	ecx
	@@2:	add 	eax,ecx
		movzx 	ecx,b ds:[ebx+2]
		sub 	ecx,ebp		;ECX = Blue difference
		jns 	short @@3
		neg 	ecx
	@@3:	add 	eax,ecx		;EAX = total difference
		pop	ecx
		cmp     eax,edx		;Compare differences
		jae	short @@No
			mov	edx,eax	;Best difference
			mov	ch,cl	;Best index
	@@No: 	add	ebx,4
		inc	cl
		jnz	short @@L1

	pop	ebp
	pop	edi
	pop	esi
	retn
Fit_Colour ENDP



;
;   GOMEZ WINDOW MANAGER     MOUSE ROUTINES
;
;
;Get_Mouse
;  Input:
;	Nothing
;  Output:
;	EAX	- Mouse-X
;	EBX	- Mouse-Y
;	ECX	- Mouse-Buttons
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Get_Mouse PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov 	ds:[v86_eax],3
	mov	eax,51
	call	Invoke_Real_Int		; do it
	mov	ebx,ds:[v86_ebx]
	and 	ebx,00000111b
	push 	ebx			;Save buttons

	mov 	ds:[v86_eax],11
	mov	eax,51
	call	Invoke_Real_Int		; do it

	movsx	eax,ds:[v86_cx]
	movsx	ebx,ds:[v86_dx]

	add 	eax,ds:[Mouse_X]
	add 	ebx,ds:[Mouse_Y]

	cmp 	eax,DISPLAY_WIDTH-16
	jle 	short @@I1
	mov 	eax,DISPLAY_WIDTH-16
@@I1: 	cmp 	ebx,DISPLAY_HEIGHT-16
	jle 	short @@I2
	mov 	ebx,DISPLAY_HEIGHT-16
@@I2: 	cmp 	ebx,0
	jge 	short @@I3
	mov 	ebx,0
@@I3:  	cmp 	eax,0
	jge 	short @@I4
	mov 	eax,0
@@I4:
	mov	ds:[Mouse_X],eax
	mov	ds:[Mouse_Y],ebx
	pop 	ecx			;Restore buttons
	mov	ds:[Mouse_Buttons],ecx
	pop	ds
	retn
Get_Mouse ENDP


include font12.inc
code32 ends
END