;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P386
LOCALS
JUMPS

code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gomez.inc
include svga.inc
include keys.inc
include gvi32.inc


;
;
;
;   GOMEZ VECTOR ENGINE                                            3D-Viewer
;
;
;

Video_Ptr	dd	?
Frame_Ptr	dd	0

STXT		db	"Gomez Video Interface                               (C) 1996 by Marc van Shaney",10,13,'$'
ETXT0		db	"Usage: PLAYVID.EXE [videofile.VID] [/switches]",10,13
		db	"       With the follwing switches:",10,13
		db	"	  /NoVESA       - Lock out VESA Modes",10,13
		db	"	  /NoVGA        - Lock out VGA Modes",10,13
		db	"	  /NoTweak      - Lock out Tweak Modes",10,13
		db	"	  /NoLinBuf     - Don't use linear frame buffer",10,13
		db	"	  /NoVESAPM     - Don't use VESA proteceted mode interface",10,13
		db	"	  /NoVBE2	- Ignore VESA 2.0 extensions",10,13
		db	"	  /NoPages  	- Don't use VESA multipage support",10,13
		db	"	  /BIOSPal	- Use BIOS functions to set palette",10,13
		db	"	  /WaitRetrace  - Wait for vertical retrace before setting palette",10,13
		db	"	  /VMode=xxx	- Force to use this VESA-mode (hex)",10,13
		db	'$'
ETXT1		db	"Error: Data file not found . . .",10,13,'$'
TILDE		db	"~",0

;
;   GOMEZ VIDEO INTERFACE                                       Main routine
;
PUBLIC C main
main PROC NEAR
	mov	es,cs:[DATA32_Selector]
	mov	esi,OFFSET STXT
	call	Print32

	mov	eax,OFFSET Tilde
	call	Scan_Argument
	jc	@@NoFile
	mov	esi,eax			;ESI = ptr to file-name

	;
	;   Init code for  SVGA
	;
	mov	eax,SVGA_8bit_Modes
	call	SVGA_Scan_Modes
	call	SVGA_Select_Mode
	jc	@@NoVESA
	call	Init_SVGA
	jc	@@NoVESA
	call	Init_GVI
	jc	@@NoVESA

	;
	;   Loading of a video
	;
	mov	ebx,esi
	xor	edx,edx				;Start at file offset 0
	call	GVI_Open_Video			;Load world
	mov	ds:[Video_Ptr],eax		;Save returned ptr !
	jc	@@LoadError			;JC => Error

	mov	esi,eax		             	;ESI = Video ptr
	mov	eax,ds:[esi+Movie_Palette]	;EAX = ptr to palette
	xor	ebx,ebx
	mov	ecx,256
	call	SVGA_Set_Palette

	call	SVGA_Get_Video_Address
	jc	@@L1
	sub	eax,ds:[DATA32_Address]
	mov	ds:[Frame_Ptr],eax
	;
	;   Main loop
	;
@@L1:   mov	eax,ds:[Video_Ptr]
	call	GVI_Next_Frame

	cmp	ds:[Frame_Ptr],0
	je	short @@2
	mov	eax,ds:[Video_Ptr]
	mov	esi,ds:[eax+Movie_Frame_Buffer]
	mov	edi,ds:[Frame_Ptr]
	call	Rescale_Frame
	jmp	short @@1

@@2:	mov	eax,ds:[Video_Ptr]
	mov	esi,ds:[eax+Movie_Frame_Buffer]
	mov	edi,ds:[SVGA_Frame_Buffer]
	call	Rescale_Frame

	call	SVGA_Switch_Frame
	;
@@1:	GETKEY32
	test	ax,ax				;No key => Loop !
	jz	@@L1
	;
	;   Exit routines
	;
	mov	eax,ds:[Video_Ptr]
	call	GVI_Close_Video
@@End:	call	Exit_SVGA
	call	Exit_GVI
@@NoVESA:
	jmp	Exit_PMODE32			;Thats all folks !

@@LoadError:					;An error occured
	call	Exit_SVGA
	call	Exit_GVI
	mov	esi,OFFSET ETXT1		;Display error-text
	call	Print32
	jmp	Exit_PMODE32

@@NoFile:
	mov	esi,OFFSET ETXT0		;Display error-text
	call	Print32
	jmp	Exit_PMODE32
main ENDP


;
;
; Rescale_Frame:
;  Input:
;	ESI	- ptr to video-buffer
;	EDI	- ptr to texture-buffer
;  Output:
;	CF	- Error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
Rescale_Frame PROC NEAR
	push	esi
	push	edi

	mov	ebx,ds:[SVGA_Display_Width]
	mov	ecx,ds:[SVGA_Display_Height]
	mov	ds:[@@dst_x],ebx		;EBX = dest. width
	mov	ds:[@@dst_y],ecx
	movzx	eax,ds:[esi+Bitmap_Width]      	;EAX = source width
	mov	d ds:[@@C5-4],eax		; ...save it in code
	xor	edx,edx
	shl	eax,16
	idiv	ebx				;EAX = src_width / dst_width
	xor	edx,edx
	shld	edx,eax,16                      ;EDX = integer part
	mov	d ds:[@@C2-4],edx		; ...save it
	shl	eax,16				;EAX = fractional part
	mov	d ds:[@@C1-4],eax		; ...save it

	movzx	eax,ds:[esi+Bitmap_Height]	;EAX = source height
	xor	edx,edx
	shl	eax,16
	idiv	ecx				;EAX = src_height / dst_height
	mov	edx,eax
	shl	edx,16				;EDX = fractional part
	mov	d ds:[@@C4-4],edx		; ...and save it
	shr	eax,16				;EAX = integer part
	imul	d ds:[@@C5-4]			;EAX *= source_width
	mov	d ds:[@@C3-4],eax		; ...and save it
	add	esi,GVI_BITMAP_SIZE

	;
	;
	;Note the register allocation:
	;	ESI	- src
	;	EDI	- dst
	;	EBX	- X-counter
	;	ECX	- X-fraction
	;	EDX	- Y-fraction
	;And the @@C things:
	;	@@C1-4	- Fraction_X increment
	;	@@C2-4	- StdAddX
	;	@@C3-4	- StdAddY*Source_Width
	;	@@C4-4	- Fraction_Y increment
	;	@@C5-4	- Source_Width
	;
	xor	ecx,ecx				;Clear fraction
	xor	eax,eax
@@L1:   push	esi
	mov	ebx,ds:[@@dst_x]
	xor	edx,edx				;Clear fraction
	add	edi,ebx
	neg	ebx
	@@L2:	mov	al,ds:[esi]		;Get pixel
		add	edx,12345678h  		;Add fraction
	@@C1:   adc	esi,12345678h		;Add integer with carry
	@@C2:	mov	ds:[edi+ebx],al
		inc	ebx
		jnz	short @@L2           	;Loop !
	pop	esi
	add	esi,12345678h
@@C3:	add	ecx,12345678h
@@C4:	jnc	short @@C5
		add 	esi,12345678h
@@C5:	dec	ds:[@@dst_y]
	jnz	short @@L1
	;

@@Err:	pop	edi
	pop	esi
	retn

		ALIGN	DWORD
@@dst_y		dd	?
@@dst_x		dd	?
Rescale_Frame ENDP
code32 ends
END
