;[]------------------------------------------------------------------------[]
;|                                                                          |
;| (c) 1993,1994,1995 by Marc van Shaney , aka Kaya Memisoglu               |
;|                                                                          |
;| This Source-Code was written by and is copyrighted by Kaya Memisoglu	    |
;| You may use the whole code or only parts of it in your own programs      |
;| whether they are commercial or not. BUT you must give credits for these  |
;| parts to me (Kaya Memisoglu  or  Marc van Shaney).                       |
;| I am not responsible for any damage or loss caused by this program, so   |
;| if you success in erasing your harddisk with this code, then it is your  |
;| own fault and you should not claim me to be responsible...               |
;| I would be very pleased if you also sent me a postcard or even a letter  |
;| if you can use this code. My address:                                    |
;|                                                                          |
;|        Kaya Memisoglu                                                    |
;|        Reichenberger Ring 50                                             |
;|        63512 Hainburg                                                    |
;|        Germany                                                           |
;|	                                                                    |
;|	  Internet: memisogl@stud.uni-frankfurt.de                          |
;|                                                                          |
;| You can also leave a message for Marc van Shaney on the Nirvana BBS:     |
;|                                                                          |
;|              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza      |
;|                                                                          |
;|                                                                          |
;[]------------------------------------------------------------------------[]


P386
JUMPS

LOCALS
VGA_Width         equ  320
VGA_Height        equ  200
TRUE              equ  1
FALSE             equ  -1


.MODEL USE16 LARGE
.Code

Delta_AB_X	dw	?
Delta_AB_Y	dw	?
Delta_CD_X	dw	?
Delta_CD_Y	dw	?
Line_Count	dw	?
Texture_LPos	dw	?	;Low word
Texture_HPos	dw	?	;High word
Texture_Width	dw	?
Texture_Height	dw	?
Pos_AB_X	dd	?
Pos_AB_Y        dd	?
Pos_CD_X	dd	?
Pos_CD_Y	dd	?

GET_MAX MACRO a,b
	LOCAL J1,J2
	mov ax,a
	test ax,ax
	jns short J1
	neg ax
J1:	cmp ax,b
	jb short J2
	mov b,ax
J2:
	ENDM
GET_MAXL MACRO a,b
	LOCAL J1,J2
	mov eax,a
	test eax,eax
	jns short J1
	neg eax
J1:	cmp eax,b
	jb short J2
	mov b,eax
J2:
	ENDM


;[]------------------------------------------------------------------------[]
;|
;| This is the first texture-mapper. It simply draws two lines (from A to B
;| and from C to D) and fills the space between these two lines with texture-
;| lines.
;| Have a look at this little drawing:
;|
;|                 /----
;|           /----/     \
;|     -----/            \
;|    /                   \
;|   /                     \
;|  /                       \
;| /                         \
;|/--------------\            \
;|                \------------\
;|            Such a line will be drawn
;| Note that this approach is NOT a scan-line conversion but a slow algorithm
;| that draws texture-lines between two corners of the polygon (must have
;| EXACTLY for vertices !). If you pass "impossible" parameters, then you
;| will get nice effects ! (Bended bitmaps in space !). These funny effects
;| are NOT possible with the MUCH faster scan line conversion later in this
;| code.
;| Also note, that NO CLIPPING IS DONE !!!! (This would slow down the engine
;| really too much...)
;|
;|This line will be drawn by the macro DRAW_TEXTURE_LINE
;|
SET_PIXEL MACRO
	mov byte ptr es:[di],255
	mov cx,di
	pop di
	push di

	add di,word ptr cs:[Pos_CD_X+2]
	mov ax,word ptr cs:[Pos_CD_Y+2]
	fastimul bx,ax,VGA_Width
	add di,bx
	mov byte ptr es:[di],255

	mov di,cx
	ENDM

DRAW_TEXTURE_LINE MACRO
	LOCAL L1,J1,J2,J3,J4,J5,C1,C2,C3,C4
	push di

	add di,word ptr cs:[Pos_AB_X+2]
	mov ax,word ptr cs:[Pos_AB_Y+2]
	fastimul bx,ax,VGA_Width
	add di,bx                               ;ES:DI points to first pixel of
						;The line...
	mov bx,word ptr cs:[Pos_CD_X+2]
	sub bx,word ptr cs:[Pos_AB_X+2]
	mov dx,word ptr cs:[Pos_CD_Y+2]
	sub dx,word ptr cs:[Pos_AB_Y+2]
	xor cx,cx
	GET_MAX bx,cx
	GET_MAX dx,cx

	jcxz J5

	mov byte ptr cs:[C4+2],0c5h
	push dx
	mov ax,dx
	shl eax,16
	cdq
	idiv ecx
	test eax,eax
	jns short J1
	mov byte ptr cs:[C4+2],0edh
	neg ax
J1:	mov word ptr cs:[C3-2],ax
	pop ax
	cdq
	idiv cx
	cwde
	fastimul edx,eax,VGA_Width*10000h
	mov dword ptr cs:[C2-4],edx

	mov ax,bx
	shl eax,16
	cdq
	idiv ecx
	add dword ptr cs:[C2-4],eax

J3:	mov ax,cs:[Texture_Width]
	shl eax,16
	cdq
	idiv ecx
	mov dword ptr cs:[C1-4],eax

	xor bx,bx		;BX is overflow
	mov dx,si		;EDX is texture pointer
	mov bp,di
	shl edx,16
	shl ebp,16

L1:   	shld edi,edx,16
	mov al,ds:[di]
	shld edi,ebp,16
	mov ah,al
	mov es:[di],ax		;I draw a double-pixel, because of rounding errors....
	add edx,12345678h	;Next texel
C1: 	add ebp,12345678h	;Rows and lines
C2:     add bx,1234h
C3:	jnc short J2
C4:	add ebp,VGA_Width*10000h
J2:	dec cx
	jnz short L1

J5:	pop di
	ENDM



PUBLIC C VDraw_Texture
VDraw_Texture PROC FAR
	ARG frame:dword,x1:word,y1:word,x2:word,y2:word,x3:word,y3:word,x4:word,y4:word,texture:dword
	push bp
	mov bp,sp
	push ds
	push esi
	push edi

	les di,[frame]
	lds si,[texture]

	mov ax,[x2]
	mov dx,[x1]
	sub ax,dx
	mov cs:[Delta_AB_X],ax		;Difference
	shl edx,16
	mov cs:[Pos_AB_X],edx           ;16-bit position

	mov ax,[y2]
	mov dx,[y1]
	sub ax,dx
	mov cs:[Delta_AB_Y],ax
	shl edx,16
	mov cs:[Pos_AB_Y],edx

	mov ax,[x4]
	mov dx,[x3]
	sub ax,dx
	mov cs:[Delta_CD_X],ax
	shl edx,16
	mov cs:[Pos_CD_X],edx

	mov ax,[y4]
	mov dx,[y3]
	sub ax,dx
	mov cs:[Delta_CD_Y],ax
	shl edx,16
	mov cs:[Pos_CD_Y],edx

	xor ecx,ecx
	GET_MAX cs:[Delta_AB_X],cx	;Get biggest difference (In lines or rows)
	GET_MAX cs:[Delta_AB_Y],cx
	GET_MAX cs:[Delta_CD_X],cx
	GET_MAX cs:[Delta_CD_Y],cx

	jcxz @@End			;CX now holds maximal difference
	mov cs:[Line_Count],cx

	mov ax,cs:[Delta_AB_X]		;OK. Now we compute the increments...
	shl eax,16
	cdq
	idiv ecx
	mov dword ptr cs:[@@C1-4],eax	;Line1 X-increment

	mov ax,cs:[Delta_AB_Y]
	shl eax,16
	cdq
	idiv ecx
	mov dword ptr cs:[@@C2-4],eax	;Line1 Y-Increment

	mov ax,cs:[Delta_CD_X]
	shl eax,16
	cdq
	idiv ecx
	mov dword ptr cs:[@@C3-4],eax	;Line2 X-Increment

	mov ax,cs:[Delta_CD_Y]
	shl eax,16
	cdq
	idiv ecx
	mov dword ptr cs:[@@C4-4],eax   ;Line2 Y-Increment

	mov ax,ds:[si]			;Texture width
	mov cs:[Texture_Width],ax
	mov ax,ds:[si+2]		;Texture height
	mov cs:[Texture_Height],ax
	dec ax
	shl eax,16
	cdq
	idiv ecx
	mov word ptr cs:[@@C5-2],ax	;Save fractional part
	sar eax,16
	mul cs:[Texture_Width]
	mov word ptr cs:[@@C6-2],ax	;Save integer part

	add si,16

@@L1:	add cs:[Pos_AB_X],12345678h	;Add various increments to positions
 @@C1: 	add cs:[Pos_AB_Y],12345678h	; of the two lines...
 @@C2: 	add cs:[Pos_CD_X],12345678h	; --""--
 @@C3: 	add cs:[Pos_CD_Y],12345678h	; --""--
 @@C4:  add cs:[Texture_LPos],1234h	;Add Texture-line overflow...
 @@C5:	jnc short @@C7
	add si,cs:[Texture_Width]	;Add texture-width because of carry
 @@C7:	add si,1234h			;Add normal standard texture-increment
 @@C6:  DRAW_TEXTURE_LINE               ;Draw a line
	dec cs:[Line_Count]
	jnz @@L1

@@End:	pop edi
	pop esi
	pop ds
	pop bp
	retf
VDraw_Texture ENDP








;[]------------------------------------------------------------------------[]
;|
;| This second apporach is a scan-line algorithm. It does only work with
;| 256x256 pixel bitmaps at this moment for speed reasons. The structure
;| poly is constructed like the following:
;|
;| word number of points
;| list of points
;|   -> word x
;|      word y
;|      word texture-x
;|      word texture-y
;|
;| The corners arry is the following structure:
;| dword x1                  0
;| dword Texture x1          4
;| dword Texture y1          8
;| dword x2                  12
;| dword Texture x2          16
;| dword Texture y2          20
;|
Corners dd VGA_Height*6 dup (0)




DRAW_CORNER_LINE MACRO a,b
	LOCAL ENDE,J1,J2,J3,J4,J5,L1,C1,C2,C3
	mov byte ptr cs:[C3+1],0c3h	;ADD
	mov bx,word ptr ds:[a+2]	;Start y-coordinate
	movzx ecx,word ptr ds:[b+2]	;End y-coordinate
	sub cx,bx
	jz ENDE				;Nothing to do ???
	jns short J1
	neg cx				;Negate counter
	mov byte ptr cs:[C3+1],0ebh	;SUB

J1:     inc cx				;ECX holds y-counter
	mov ax,ds:[b]
	sub ax,ds:[a]			;AX holds x-difference
	shl eax,16			;16 bit Fixed point
	cdq
	idiv ecx			;EAX holds step-value
	mov dword ptr cs:[C1-4],eax

	mov ax,ds:[b+4]
	sub ax,ds:[a+4]         	;texture x-difference
	shl eax,16
	cdq
	idiv ecx
	mov dword ptr cs:[C2-4],eax

	mov ax,ds:[b+6]
	sub ax,ds:[a+6]         	;texture y-difference
	shl eax,16
	cdq
	idiv ecx
	mov dword ptr cs:[C3-4],eax

	mov ax,bx
	shl ax,3		;   *8
	shl bx,4		;+  *16
	add bx,ax		;=  *24 bytes/entry

	mov dx,ds:[a]
	shl edx,16		;EDX/BX holds x/y position
	mov bp,ds:[a+4]		;EBP holds texture x-pos
	shl ebp,16
	mov ax,ds:[a+6]		;EAX holds texture y-pos
	shl eax,16

	push edi

L1:     cmp bx,VGA_Height*6*4
	jae short J5				;Upper/Lower clipping
	cmp word ptr cs:[OFFSET Corners+bx+2],0f000h
	jne short J2
	mov cs:[OFFSET Corners+bx],edx          ;Set the FIRST corner point
	mov cs:[OFFSET Corners+bx+4],ebp
	mov cs:[OFFSET Corners+bx+8],eax
	jmp short J5
J2:     cmp cs:[OFFSET Corners+bx],edx		;Is FIRST corner-point bigger than this
	jg short J3
	cmp cs:[OFFSET Corners+bx+12],edx	;Is SECOND corner-point bigger than this
	jg short J5
	mov cs:[OFFSET Corners+bx+12],edx	;Set the second corner-point
	mov cs:[OFFSET Corners+bx+16],ebp
	mov cs:[OFFSET Corners+bx+20],eax
	jmp short J5
J3:     mov edi,cs:[OFFSET Corners+bx]
	cmp cs:[OFFSET Corners+bx+12],edi	;Is left point bigger than right
	jge short J4
	mov cs:[OFFSET Corners+bx+12],edi
	mov edi,cs:[OFFSET Corners+bx+4]
	mov cs:[OFFSET Corners+bx+16],edi
	mov edi,cs:[OFFSET Corners+bx+8]
	mov cs:[OFFSET Corners+bx+20],edi
J4:	mov cs:[OFFSET Corners+bx],edx
	mov cs:[OFFSET Corners+bx+4],ebp
	mov cs:[OFFSET Corners+bx+8],eax

J5:     add edx,12345678h	;EDX is x-position
C1:	add ebp,12345678h	;EBP is texture x-position
C2:	add eax,12345678h	;EAX is texture y-position
C3:     add bx,6*4
	dec cx
	jnz L1

	pop edi

ENDE:
	ENDM



DRAW_TEXTURE_HLINE MACRO
	LOCAL L1,J1,J2,J3,C1,ENDE,NC1,NC2
	mov ax,cs:[bp+2]		;Start x-psotion
	cmp ax,0f000h
	je ENDE

	movzx ecx,word ptr cs:[bp+14]	;End x-position
	sub cx,ax
	inc cx
	push di                         ;Save for later...
	add di,ax			;Add start position to DI
	mov eax,cs:[bp+20]		;Texture y2
	sub eax,cs:[bp+8]		;Texture y1
	cdq
	idiv ecx
	shl eax,8			;The high-word of ESI now contains
	mov esi,eax                     ; the vertical texture-increment

	mov eax,cs:[bp+16]		;Texture x2
	sub eax,cs:[bp+4]		;Texture x1
	cdq
	idiv ecx
	sar eax,8			;This is the 8-bit FPA horizontal increment
	mov si,ax               	;ESI holds texture increment

	mov edx,cs:[bp+7]		;the high-word holds 8.8 ty-address
	mov dx,cs:[bp+5]		;the low-word holds 8.8 tx-address

	movsx eax,word ptr cs:[bp+2]
	test ax,ax			;Do we need left clipping ?
	jns short NC1
		add cx,ax		;Adjust line-counter
		sub di,ax		;Adjust left-edge
		imul eax,esi
		sub edx,eax		;Adjust texture-position


NC1:	mov ax,cs:[bp+14]		;Do we need to clip right ?
	cmp ax,VGA_Width
	jb short NC2
		sub ax,VGA_Width-1
		sub cx,ax

NC2:	shr cx,1			;Ok Check for odd/even
	jnc short J2
	shld ebx,edx,16			;Get ty in BH
	mov bl,dh			;get tx in BL => BX indexes texture !
	mov al,ds:[bx]			;Get colour...
	add edx,esi			;Add texture increment
	stosb				;...SET IT !

J2:	shr cx,1
	jnc short J3
	shld ebx,edx,16			;Set in word mode
	mov bl,dh
	mov al,ds:[bx]
	add edx,esi

	shld ebx,edx,16
	mov bl,dh
	mov ah,ds:[bx]
	add edx,esi
	stosw


J3:     jcxz J1                         ;Is it already zero ?
L1:	shld ebx,edx,16			;And now: 32-bit DWORD-MODE !!!
	mov bl,dh
	mov al,ds:[bx]
	add edx,esi

	shld ebx,edx,16
	mov bl,dh
	mov ah,ds:[bx]
	add edx,esi

	shl eax,16
	shld ebx,edx,16
	mov bl,dh
	mov al,ds:[bx]
	add edx,esi

	shld ebx,edx,16
	mov bl,dh
	mov ah,ds:[bx]
	add edx,esi
	ror eax,16

	stosd
	dec cx				;Is there something left ?
	jnz short L1

J1:	pop di
ENDE:
	ENDM





PUBLIC C VDraw_Texture_Poly
VDraw_Texture_Poly PROC FAR
	ARG frame:dword,poly:dword,texture:dword
	push bp
	mov bp,sp
	push ds
	push esi
	push edi
	push ebp

	mov di,OFFSET Corners
	mov eax,0f0000000h
	xor ebx,ebx
	mov cx,VGA_Height
@@L2:	mov cs:[di],eax			;Clear corner-list
	mov cs:[di+3*4],ebx             ;Second x-coordinate must be 0
	add di,6*4
	dec cx
	jnz short @@L2

	lds si,[poly]			;DS:SI points to polygon list
	mov bp,ds:[si]			;Poly-Count
	add si,2
	mov di,si
	dec bp


	mov cs:[Line_Count],bp
@@L1:	DRAW_CORNER_LINE si,si+8	;Draw corners of polygon
	add si,8
	dec cs:[Line_Count]
	jnz @@L1

	DRAW_CORNER_LINE si,di		;Close Polygon

	pop ebp                         ;Get old argument-pointer
	push ebp
	les di,[frame]			;ES:DI holds frame-ptr
	lds si,[texture]                ;DS holds 265*256 texture
	mov bp,OFFSET Corners
	mov cs:[Line_Count],200
@@L3:	DRAW_TEXTURE_HLINE		;Fill polygon with texture
	add di,VGA_Width
	add bp,6*4
	dec cs:[Line_Count]
	jnz @@L3


	pop ebp
	pop edi
	pop esi
	pop ds
	pop bp
	retf
VDraw_Texture_Poly ENDP




;[]------------------------------------------------------------------------[]
;|
;| Now comes a routine for drawing _FAST_ grounds like for 3D-games etc...
;|
PUBLIC C SinTab
PUBLIC C CosTab
SinTab	dw 00000h,00324h,00647h,0096ah,00c8bh,00fabh,012c7h,015e1h,018f8h,01c0bh,01f19h,02223h,02527h,02826h,02b1eh,02e10h
	dw 030fbh,033deh,036b9h,0398ch,03c56h,03f16h,041cdh,0447ah,0471ch,049b3h,04c3fh,04ebfh,05133h,0539ah,055f4h,05842h
	dw 05a81h,05cb3h,05ed6h,060ebh,062f1h,064e7h,066ceh,068a5h,06a6ch,06c23h,06dc9h,06f5eh,070e1h,07254h,073b5h,07503h
	dw 07640h,0776bh,07883h,07989h,07a7ch,07b5ch,07c29h,07ce2h,07d89h,07e1ch,07e9ch,07f08h,07f61h,07fa6h,07fd7h,07ff5h
CosTab	dw 07fffh,07ff5h,07fd7h,07fa6h,07f61h,07f08h,07e9ch,07e1ch,07d89h,07ce2h,07c29h,07b5ch,07a7ch,07989h,07883h,0776bh
	dw 07640h,07503h,073b5h,07254h,070e1h,06f5eh,06dc9h,06c23h,06a6ch,068a5h,066ceh,064e7h,062f1h,060ebh,05ed6h,05cb3h
	dw 05a81h,05842h,055f4h,0539ah,05133h,04ebfh,04c3fh,049b3h,0471ch,0447ah,041cdh,03f16h,03c56h,0398ch,036b9h,033deh
	dw 030fbh,02e10h,02b1eh,02826h,02527h,02223h,01f19h,01c0bh,018f8h,015e1h,012c7h,00fabh,00c8bh,0096ah,00647h,00324h
	dw 00000h,0fcdch,0f9b9h,0f696h,0f375h,0f055h,0ed39h,0ea1fh,0e708h,0e3f5h,0e0e7h,0ddddh,0dad9h,0d7dah,0d4e2h,0d1f0h
	dw 0cf05h,0cc22h,0c947h,0c674h,0c3aah,0c0eah,0be33h,0bb86h,0b8e4h,0b64dh,0b3c1h,0b141h,0aecdh,0ac66h,0aa0ch,0a7beh
	dw 0a57fh,0a34dh,0a12ah,09f15h,09d0fh,09b19h,09932h,0975bh,09594h,093ddh,09237h,090a2h,08f1fh,08dach,08c4bh,08afdh
	dw 089c0h,08895h,0877dh,08677h,08584h,084a4h,083d7h,0831eh,08277h,081e4h,08164h,080f8h,0809fh,0805ah,08029h,0800bh
	dw 08001h,0800bh,08029h,0805ah,0809fh,080f8h,08164h,081e4h,08277h,0831eh,083d7h,084a4h,08584h,08677h,0877dh,08895h
	dw 089c0h,08afdh,08c4bh,08dach,08f1fh,090a2h,09237h,093ddh,09594h,0975bh,09932h,09b19h,09d0fh,09f15h,0a12ah,0a34dh
	dw 0a57fh,0a7beh,0aa0ch,0ac66h,0aecdh,0b141h,0b3c1h,0b64dh,0b8e4h,0bb86h,0be33h,0c0eah,0c3aah,0c674h,0c947h,0cc22h
	dw 0cf05h,0d1f0h,0d4e2h,0d7dah,0dad9h,0ddddh,0e0e7h,0e3f5h,0e708h,0ea1fh,0ed39h,0f055h,0f375h,0f696h,0f9b9h,0fcdch
	dw 00000h,00324h,00647h,0096ah,00c8bh,00fabh,012c7h,015e1h,018f8h,01c0bh,01f19h,02223h,02527h,02826h,02b1eh,02e10h
	dw 030fbh,033deh,036b9h,0398ch,03c56h,03f16h,041cdh,0447ah,0471ch,049b3h,04c3fh,04ebfh,05133h,0539ah,055f4h,05842h
	dw 05a81h,05cb3h,05ed6h,060ebh,062f1h,064e7h,066ceh,068a5h,06a6ch,06c23h,06dc9h,06f5eh,070e1h,07254h,073b5h,07503h
	dw 07640h,0776bh,07883h,07989h,07a7ch,07b5ch,07c29h,07ce2h,07d89h,07e1ch,07e9ch,07f08h,07f61h,07fa6h,07fd7h,07ff5h


PUBLIC C VDraw_Ground
VDraw_Ground PROC FAR
	ARG frame:dword,addx:word,addy:word,rot:word,scale:word,texture:word
	push bp
	mov bp,sp
	push ebp
	push edi
	push esi

	mov eax,800000h
	xor edx,edx
	movzx ebx,[scale]
	div ebx
	neg eax
	mov dword ptr cs:[@@SC1-4],eax

	mov eax,5a0000h
	xor edx,edx
	div ebx
	mov word ptr cs:[@@SC2-2],ax

	mov ax,[addx]
	mov word ptr cs:[@@C2-2],ax
	mov ax,[addy]
	mov word ptr cs:[@@C1-2],ax
	mov ax,[rot]
	and ax,0ffh
	shl ax,1
	mov word ptr cs:[@@C3-2],ax

	mov fs,[texture]
	les di,[frame]
	add di,60*320

	mov ebp,140
@@L1:   ;
	;First we caclulate the source y-position in the texture
	;Formula used:
	;       scrny * distance
	;srcy= ------------------
	;      scrnheight - scrny
	;
	push ebp
	mov eax,ebp
	mov edx,12345678h
@@SC1:	imul edx
	mov ebx,160
	sub bx,bp
	idiv ebx
	push eax		;Save y-start coordinate (you'll see...)

	;
	;Now we calculate the horizontal increment. This should be rather
	;easy:
	;           256
	;IncX=---------------
	;     scrny*distance
	mov ax,01234h		;6800h
@@SC2:	xor dx,dx
	mov si,160
	sub si,bp
	div si
	push ax
	mov bx,1234h		;Get angel
@@C3:   imul word ptr cs:[OFFSET CosTab+bx]
	shrd ax,dx,15
	shrd esi,eax,16		;IncX
	pop ax
	push ax
	imul word ptr cs:[OFFSET SinTab+bx]
	shrd ax,dx,15
	mov si,ax		;IncY

	;
	;Now we calculate the x-strart address in the texture using:
	;       320 * incx
	;srcx= --------------
	;         256*2
	pop ax
	cwde
	fastimul ecx,eax,-160
	pop ebp			;EBP=Y-Start
	push esi
	push edi

	movsx eax,word ptr cs:[OFFSET CosTab+bx]
	imul ecx
	shrd eax,edx,15
	mov esi,eax
	movsx eax,word ptr cs:[OFFSET SinTab+bx]
	imul ebp
	shrd eax,edx,15
	sub esi,eax		;ESI holds new X-Start

	movsx eax,word ptr cs:[OFFSET SinTab+bx]
	imul ecx
	shrd eax,edx,15
	mov edi,eax
	movsx eax,word ptr cs:[OFFSET CosTab+bx]
	imul ebp
	shrd eax,edx,15
	add edi,eax		;EDI holds new Y-Start

	add si,1234h
@@C2:	shrd edx,esi,16
	mov dx,di
	add dx,1234h
@@C1:	pop edi
	pop esi

@@T:
	;
	;Now the main loop starts here
	;
	mov cl,320/4
@@L2:   mov bl,dh
	shld ebx,edx,8
	mov al,fs:[bx]
	add edx,esi

	mov bl,dh
	shld ebx,edx,8
	mov ah,fs:[bx]
	add edx,esi

	shl eax,16

	mov bl,dh
	shld ebx,edx,8
	mov al,fs:[bx]
	add edx,esi

	mov bl,dh
	shld ebx,edx,8
	mov ah,fs:[bx]
	add edx,esi

	rol eax,16

	stosd
	dec cl
	jnz short @@L2

	pop ebp
	dec bp
	jnz @@L1


	pop esi
	pop edi
	pop ebp
	pop bp

	retf
VDraw_Ground ENDP
END