/***************************************************************************
 **
 ** (c) 1993,1994,1995 by Marc van Shaney , aka Kaya Memisoglu
 **
 ** This Source-Code was written by and is copyrighted by Kaya Memisoglu
 ** You may use the whole code or only parts of it in your own programs
 ** whether they are commercial or not. BUT you must give credits for these
 ** parts to me (Kaya Memisoglu  or  Marc van Shaney).
 ** I am not responsible for any damage or loss caused by this program, so
 ** if you success in erasing your harddisk with this code, then it is your
 ** own fault and you should not claim me to be responsible...
 ** I would be very pleased if you also sent me a postcard or even a letter
 ** if you can use this code. My address:
 **
 **        Kaya Memisoglu
 **        Reichenberger Ring 50
 **        63512 Hainburg
 **        Germany
 **
 **	   memisogl@stud.uni-frankfurt.de
 **
 ** You can also leave a message for Marc van Shaney on the Nirvana BBS:
 **
 **              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza
 **
 **
 **/

#include <math.h>
#include <alloc.h>
#include <mem.h>
#include <bios.h>
#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include "keys.h"


#pragma inline

extern unsigned _stklen=32000U;

int getkey(void)
{
 int key, lo, hi;

 key = bioskey(0);
 lo = key & 0X00FF;
 hi = (key & 0XFF00) >> 8;
 return((lo == 0) ? hi + 256 : lo);
}





void Draw_Voxel(char far *dst,char far *src,long start_u,long start_v,long h,long angle,long distance)
{
 int	Old_Y[320],newy,col;
 long	incu,incv,muly,u,v,base_y,x,i;

 for	(i=0;i<320;i++)
	Old_Y[i]=200;


 // The vertical projection equation is:
 //
 //	  v+d      h
 // 	  = 
 //   	   v      h-y
 //
 // With v = texture y coordinate
 //      y = screen y coordinate
 //      h = height above voxel
 //      d = distance screen->eye
 //      w = screen-width
 //
 // If we solve this equation for y, we get:
 //
 //               h*v
 // 	 y = h - 
 //               v+d
 //
 //
 // The horizontal texture increment can be calculated like this:
 //
 //             src_width
 //     incu = 
 //             dst_width
 //
 // with src_width being:
 //
 //                  w * (v+d)
 //     src_width = 
 //                      d
 //
 //

 for (i=0;i<80;i++)
	{
	 base_y=h - ((h*i) / (i+distance));
	 base_y+=80;

	 incu=((i+distance)<<11L)*sin(angle*0.01)/distance;
	 incv=((i+distance)<<11L)*cos(angle*0.01)/distance;
	 muly=(int)((distance<<16L)/(i+distance));

	 u=(160*incu+(i<<16L))*cos(angle*0.01)+start_u;
	 v=-(i<<16L)*sin(angle*0.01)+start_v;

	 for (x=0;x<320;x++)
		{
		 col=src[((v>>8) & 0x0ff00L) + (u>>16)];
		 newy=base_y-(int)((col * muly) >>12L);
		 while ((Old_Y[x]-newy) > 0)
			{
			 Old_Y[x]--;
			 if ((Old_Y[x]<200) && (Old_Y[x]>=0))
				 dst[Old_Y[x]*320+x]=col;
			}
		 u+=incu;
		 v+=incv;
		}
	}
}






#define R rand()&63
#define V (R&31)+1

void p(char far *dst,int N,int O,int x,int y,int A,int B,int C,int D,int f)
{
  int c, i, P, Q, S, T, E, J, K, L, M, j;

  if(O)
    {
      P=N/2;
      S=N-P;
      Q=O/2;
      T=Q ? O-Q:0;
      J=V;
      K=V;
      L=V;
      M=V;
      E=(J*A+K*B+L*C+M*D)/(J+K+L+M)+(rand()%(f+1)-f/2);
      p(dst,P,Q,x,y,A,K=(A+B)>>1,E,J=(A+D)>>1,f/=2);
      p(dst,S,T,x,y+Q,J,E,M=(C+D)>>1,D,f);
      p(dst,S,Q,x+=P,y,K,B,L=(B+C)>>1,E,f);
      p(dst,S,T,x,y+Q,E,L,C,M,f);
    }
  else
      for(i=x;i<N+x; dst[(y<<8)+(i++)]=((c=((j=R&3)==0) ? A:(j==1)?B:(j==2)?C:D)?c:1) );
}



void main(void)
{
	long distance=10,height=800,angle=0,u=0,v=0;
	int key=0;
	char far *frame,*voxel;

	frame=malloc(64000U);
	voxel=farmalloc(0x010000L);

	srand(768);
	p(voxel,256,256,0,0,R,R,R,R,127);

	// Init graphic mode (320x200x256)
	asm	mov 	ax,0x013
	asm	int 	0x010

	asm	xor	al,al
	asm	mov	dx,03c8h
	asm	out	dx,al
	asm	inc	dx
	asm	xor	cx,cx
L1:	asm	mov	al,cl
	asm	out	dx,al
	asm	out	dx,al
	asm	out	dx,al
	asm	inc	cx
	asm	cmp	cx,63
	asm	jbe	L1


	while(key!=Escape)
		{
		 asm	push	es
		 asm	push	di
		 asm	les	di,frame
		 asm	mov	cx,320*200/4
		 asm	xor	eax,eax
		 asm	rep	stosd
		 asm	pop	di
		 asm	pop	es

		 Draw_Voxel(frame,voxel,u,v,height,angle,distance);
		 asm	push	ds
		 asm	push	es
		 asm	push	si
		 asm	push	di
		 asm	lds	si,frame
		 asm	mov	ax,0x0a000
		 asm	mov	es,ax
		 asm	xor	di,di
		 asm	mov	cx,320*200/4
		 asm	rep	movsd
		 asm	pop	si
		 asm	pop	di
		 asm	pop	es
		 asm	pop	ds

		 if (kbhit())
			{
			 while(kbhit())
				 key=getkey();
			 switch (key)
				{
				 case Cursor_Pgup:
					height+=2;
					break;
				 case Cursor_Pgdwn:
					height-=2;
					break;
				 case Cursor_Up:
					v+=2<<14L;
					break;
				 case Cursor_Down:
					v-=2<<14L;
					break;
				 case Cursor_Left:
					u-=2<<14L;
					break;
				 case Cursor_Right:
					u+=2<<14L;
					break;
				 case '+':
					distance+=2;
					break;
				 case '-':
					distance-=2;
					break;
				 case '*':
					angle+=2;
					break;
				 case '/':
					angle-=2;
					break;
				}
			}
		}


	// Go back into text again
	asm	mov	ax,03
	asm	int	0x010

	free(frame);
}